#include "unicode.h"

static const char *names[] = {
	"AC CURRENT",
	"ACCOUNT OF",
	"ACTIVATE ARABIC FORM SHAPING",
	"ACTIVATE SYMMETRIC SWAPPING",
	"ACUTE ACCENT",
	"ACUTE ANGLE",
	"ADDRESSED TO THE SUBJECT",
	"ADI SHAKTI",
	"AEGEAN CHECK MARK",
	"AEGEAN DRY MEASURE FIRST SUBUNIT",
	"AEGEAN LIQUID MEASURE FIRST SUBUNIT",
	"AEGEAN MEASURE SECOND SUBUNIT",
	"AEGEAN MEASURE THIRD SUBUNIT",
	"AEGEAN NUMBER EIGHT",
	"AEGEAN NUMBER EIGHT HUNDRED",
	"AEGEAN NUMBER EIGHT THOUSAND",
	"AEGEAN NUMBER EIGHTY",
	"AEGEAN NUMBER EIGHTY THOUSAND",
	"AEGEAN NUMBER FIFTY",
	"AEGEAN NUMBER FIFTY THOUSAND",
	"AEGEAN NUMBER FIVE",
	"AEGEAN NUMBER FIVE HUNDRED",
	"AEGEAN NUMBER FIVE THOUSAND",
	"AEGEAN NUMBER FORTY",
	"AEGEAN NUMBER FORTY THOUSAND",
	"AEGEAN NUMBER FOUR",
	"AEGEAN NUMBER FOUR HUNDRED",
	"AEGEAN NUMBER FOUR THOUSAND",
	"AEGEAN NUMBER NINE",
	"AEGEAN NUMBER NINE HUNDRED",
	"AEGEAN NUMBER NINE THOUSAND",
	"AEGEAN NUMBER NINETY",
	"AEGEAN NUMBER NINETY THOUSAND",
	"AEGEAN NUMBER ONE",
	"AEGEAN NUMBER ONE HUNDRED",
	"AEGEAN NUMBER ONE THOUSAND",
	"AEGEAN NUMBER SEVEN",
	"AEGEAN NUMBER SEVEN HUNDRED",
	"AEGEAN NUMBER SEVEN THOUSAND",
	"AEGEAN NUMBER SEVENTY",
	"AEGEAN NUMBER SEVENTY THOUSAND",
	"AEGEAN NUMBER SIX",
	"AEGEAN NUMBER SIX HUNDRED",
	"AEGEAN NUMBER SIX THOUSAND",
	"AEGEAN NUMBER SIXTY",
	"AEGEAN NUMBER SIXTY THOUSAND",
	"AEGEAN NUMBER TEN",
	"AEGEAN NUMBER TEN THOUSAND",
	"AEGEAN NUMBER THIRTY",
	"AEGEAN NUMBER THIRTY THOUSAND",
	"AEGEAN NUMBER THREE",
	"AEGEAN NUMBER THREE HUNDRED",
	"AEGEAN NUMBER THREE THOUSAND",
	"AEGEAN NUMBER TWENTY",
	"AEGEAN NUMBER TWENTY THOUSAND",
	"AEGEAN NUMBER TWO",
	"AEGEAN NUMBER TWO HUNDRED",
	"AEGEAN NUMBER TWO THOUSAND",
	"AEGEAN WEIGHT BASE UNIT",
	"AEGEAN WEIGHT FIRST SUBUNIT",
	"AEGEAN WEIGHT FOURTH SUBUNIT",
	"AEGEAN WEIGHT SECOND SUBUNIT",
	"AEGEAN WEIGHT THIRD SUBUNIT",
	"AEGEAN WORD SEPARATOR DOT",
	"AEGEAN WORD SEPARATOR LINE",
	"AERIAL TRAMWAY",
	"AFGHANI SIGN",
	"AIRPLANE",
	"AKTIESELSKAB",
	"ALARM CLOCK",
	"ALCHEMICAL SYMBOL FOR AIR",
	"ALCHEMICAL SYMBOL FOR ALEMBIC",
	"ALCHEMICAL SYMBOL FOR ALKALI",
	"ALCHEMICAL SYMBOL FOR ALUM",
	"ALCHEMICAL SYMBOL FOR AMALGAM",
	"ALCHEMICAL SYMBOL FOR ANTIMONY ORE",
	"ALCHEMICAL SYMBOL FOR AQUA REGIA",
	"ALCHEMICAL SYMBOL FOR AQUA VITAE",
	"ALCHEMICAL SYMBOL FOR AQUAFORTIS",
	"ALCHEMICAL SYMBOL FOR ARSENIC",
	"ALCHEMICAL SYMBOL FOR ASHES",
	"ALCHEMICAL SYMBOL FOR AURIPIGMENT",
	"ALCHEMICAL SYMBOL FOR BATH OF MARY",
	"ALCHEMICAL SYMBOL FOR BATH OF VAPOURS",
	"ALCHEMICAL SYMBOL FOR BISMUTH ORE",
	"ALCHEMICAL SYMBOL FOR BLACK SULFUR",
	"ALCHEMICAL SYMBOL FOR BORAX",
	"ALCHEMICAL SYMBOL FOR BRICK",
	"ALCHEMICAL SYMBOL FOR CADUCEUS",
	"ALCHEMICAL SYMBOL FOR CALX",
	"ALCHEMICAL SYMBOL FOR CAPUT MORTUUM",
	"ALCHEMICAL SYMBOL FOR CINNABAR",
	"ALCHEMICAL SYMBOL FOR COPPER ANTIMONIATE",
	"ALCHEMICAL SYMBOL FOR COPPER ORE",
	"ALCHEMICAL SYMBOL FOR CROCUS OF COPPER",
	"ALCHEMICAL SYMBOL FOR CROCUS OF IRON",
	"ALCHEMICAL SYMBOL FOR CRUCIBLE",
	"ALCHEMICAL SYMBOL FOR DAY-NIGHT",
	"ALCHEMICAL SYMBOL FOR DISSOLVE",
	"ALCHEMICAL SYMBOL FOR DISTILL",
	"ALCHEMICAL SYMBOL FOR EARTH",
	"ALCHEMICAL SYMBOL FOR FIRE",
	"ALCHEMICAL SYMBOL FOR GOLD",
	"ALCHEMICAL SYMBOL FOR GUM",
	"ALCHEMICAL SYMBOL FOR HALF DRAM",
	"ALCHEMICAL SYMBOL FOR HALF OUNCE",
	"ALCHEMICAL SYMBOL FOR HORSE DUNG",
	"ALCHEMICAL SYMBOL FOR HOUR",
	"ALCHEMICAL SYMBOL FOR IRON ORE",
	"ALCHEMICAL SYMBOL FOR IRON-COPPER ORE",
	"ALCHEMICAL SYMBOL FOR LEAD ORE",
	"ALCHEMICAL SYMBOL FOR LODESTONE",
	"ALCHEMICAL SYMBOL FOR MARCASITE",
	"ALCHEMICAL SYMBOL FOR MERCURY SUBLIMATE",
	"ALCHEMICAL SYMBOL FOR MONTH",
	"ALCHEMICAL SYMBOL FOR NIGHT",
	"ALCHEMICAL SYMBOL FOR NITRE",
	"ALCHEMICAL SYMBOL FOR OIL",
	"ALCHEMICAL SYMBOL FOR PHILOSOPHERS SULFUR",
	"ALCHEMICAL SYMBOL FOR POT ASHES",
	"ALCHEMICAL SYMBOL FOR POWDER",
	"ALCHEMICAL SYMBOL FOR POWDERED BRICK",
	"ALCHEMICAL SYMBOL FOR PRECIPITATE",
	"ALCHEMICAL SYMBOL FOR PURIFY",
	"ALCHEMICAL SYMBOL FOR PUTREFACTION",
	"ALCHEMICAL SYMBOL FOR QUICK LIME",
	"ALCHEMICAL SYMBOL FOR QUINTESSENCE",
	"ALCHEMICAL SYMBOL FOR REALGAR",
	"ALCHEMICAL SYMBOL FOR REGULUS",
	"ALCHEMICAL SYMBOL FOR REGULUS OF ANTIMONY",
	"ALCHEMICAL SYMBOL FOR REGULUS OF IRON",
	"ALCHEMICAL SYMBOL FOR RETORT",
	"ALCHEMICAL SYMBOL FOR ROCK SALT",
	"ALCHEMICAL SYMBOL FOR SAL-AMMONIAC",
	"ALCHEMICAL SYMBOL FOR SALT",
	"ALCHEMICAL SYMBOL FOR SALT OF ANTIMONY",
	"ALCHEMICAL SYMBOL FOR SALT OF COPPER ANTIMONIATE",
	"ALCHEMICAL SYMBOL FOR SCEPTER OF JOVE",
	"ALCHEMICAL SYMBOL FOR SILVER",
	"ALCHEMICAL SYMBOL FOR SOAP",
	"ALCHEMICAL SYMBOL FOR SPIRIT",
	"ALCHEMICAL SYMBOL FOR STARRED TRIDENT",
	"ALCHEMICAL SYMBOL FOR STRATUM SUPER STRATUM",
	"ALCHEMICAL SYMBOL FOR SUBLIMATE OF ANTIMONY",
	"ALCHEMICAL SYMBOL FOR SUBLIMATE OF COPPER",
	"ALCHEMICAL SYMBOL FOR SUBLIMATE OF SALT OF ANTIMONY",
	"ALCHEMICAL SYMBOL FOR SUBLIMATE OF SALT OF COPPER",
	"ALCHEMICAL SYMBOL FOR SUBLIMATION",
	"ALCHEMICAL SYMBOL FOR SULFUR",
	"ALCHEMICAL SYMBOL FOR TARTAR",
	"ALCHEMICAL SYMBOL FOR TIN ORE",
	"ALCHEMICAL SYMBOL FOR TINCTURE",
	"ALCHEMICAL SYMBOL FOR TRIDENT",
	"ALCHEMICAL SYMBOL FOR TUTTY",
	"ALCHEMICAL SYMBOL FOR URINE",
	"ALCHEMICAL SYMBOL FOR VERDIGRIS",
	"ALCHEMICAL SYMBOL FOR VINEGAR",
	"ALCHEMICAL SYMBOL FOR VINEGAR OF ANTIMONY",
	"ALCHEMICAL SYMBOL FOR VITRIOL",
	"ALCHEMICAL SYMBOL FOR WATER",
	"ALCHEMICAL SYMBOL FOR WAX",
	"ALEF SYMBOL",
	"ALEMBIC",
	"ALIEN MONSTER",
	"ALL AROUND-PROFILE",
	"ALL EQUAL TO",
	"ALMOST EQUAL OR EQUAL TO",
	"ALMOST EQUAL TO",
	"ALMOST EQUAL TO WITH CIRCUMFLEX ACCENT",
	"ALTERNATE ONE-WAY LEFT WAY TRAFFIC",
	"ALTERNATIVE KEY SYMBOL",
	"AMALGAMATION OR COPRODUCT",
	"AMBULANCE",
	"AMERICAN FOOTBALL",
	"AMPERSAND",
	"ANCHOR",
	"AND WITH DOT",
	"ANGER SYMBOL",
	"ANGLE",
	"ANGLE WITH S INSIDE",
	"ANGLE WITH UNDERBAR",
	"ANGRY FACE",
	"ANGSTROM SIGN",
	"ANGUISHED FACE",
	"ANKH",
	"ANT",
	"ANTENNA WITH BARS",
	"ANTICLOCKWISE CLOSED CIRCLE ARROW",
	"ANTICLOCKWISE CONTOUR INTEGRAL",
	"ANTICLOCKWISE DOWNWARDS AND UPWARDS OPEN CIRCLE ARROWS",
	"ANTICLOCKWISE GAPPED CIRCLE ARROW",
	"ANTICLOCKWISE INTEGRATION",
	"ANTICLOCKWISE OPEN CIRCLE ARROW",
	"ANTICLOCKWISE TOP SEMICIRCLE ARROW",
	"APL FUNCTIONAL SYMBOL ALPHA",
	"APL FUNCTIONAL SYMBOL ALPHA UNDERBAR",
	"APL FUNCTIONAL SYMBOL BACKSLASH BAR",
	"APL FUNCTIONAL SYMBOL CIRCLE BACKSLASH",
	"APL FUNCTIONAL SYMBOL CIRCLE DIAERESIS",
	"APL FUNCTIONAL SYMBOL CIRCLE JOT",
	"APL FUNCTIONAL SYMBOL CIRCLE STAR",
	"APL FUNCTIONAL SYMBOL CIRCLE STILE",
	"APL FUNCTIONAL SYMBOL CIRCLE UNDERBAR",
	"APL FUNCTIONAL SYMBOL COMMA BAR",
	"APL FUNCTIONAL SYMBOL DEL DIAERESIS",
	"APL FUNCTIONAL SYMBOL DEL STILE",
	"APL FUNCTIONAL SYMBOL DEL TILDE",
	"APL FUNCTIONAL SYMBOL DELTA STILE",
	"APL FUNCTIONAL SYMBOL DELTA UNDERBAR",
	"APL FUNCTIONAL SYMBOL DIAMOND UNDERBAR",
	"APL FUNCTIONAL SYMBOL DOWN CARET TILDE",
	"APL FUNCTIONAL SYMBOL DOWN SHOE STILE",
	"APL FUNCTIONAL SYMBOL DOWN TACK JOT",
	"APL FUNCTIONAL SYMBOL DOWN TACK UNDERBAR",
	"APL FUNCTIONAL SYMBOL DOWNWARDS VANE",
	"APL FUNCTIONAL SYMBOL EPSILON UNDERBAR",
	"APL FUNCTIONAL SYMBOL GREATER-THAN DIAERESIS",
	"APL FUNCTIONAL SYMBOL I-BEAM",
	"APL FUNCTIONAL SYMBOL IOTA",
	"APL FUNCTIONAL SYMBOL IOTA UNDERBAR",
	"APL FUNCTIONAL SYMBOL JOT DIAERESIS",
	"APL FUNCTIONAL SYMBOL JOT UNDERBAR",
	"APL FUNCTIONAL SYMBOL LEFT SHOE STILE",
	"APL FUNCTIONAL SYMBOL LEFTWARDS VANE",
	"APL FUNCTIONAL SYMBOL OMEGA",
	"APL FUNCTIONAL SYMBOL OMEGA UNDERBAR",
	"APL FUNCTIONAL SYMBOL QUAD",
	"APL FUNCTIONAL SYMBOL QUAD BACKSLASH",
	"APL FUNCTIONAL SYMBOL QUAD CIRCLE",
	"APL FUNCTIONAL SYMBOL QUAD COLON",
	"APL FUNCTIONAL SYMBOL QUAD DEL",
	"APL FUNCTIONAL SYMBOL QUAD DELTA",
	"APL FUNCTIONAL SYMBOL QUAD DIAMOND",
	"APL FUNCTIONAL SYMBOL QUAD DIVIDE",
	"APL FUNCTIONAL SYMBOL QUAD DOWN CARET",
	"APL FUNCTIONAL SYMBOL QUAD DOWNWARDS ARROW",
	"APL FUNCTIONAL SYMBOL QUAD EQUAL",
	"APL FUNCTIONAL SYMBOL QUAD GREATER-THAN",
	"APL FUNCTIONAL SYMBOL QUAD JOT",
	"APL FUNCTIONAL SYMBOL QUAD LEFTWARDS ARROW",
	"APL FUNCTIONAL SYMBOL QUAD LESS-THAN",
	"APL FUNCTIONAL SYMBOL QUAD NOT EQUAL",
	"APL FUNCTIONAL SYMBOL QUAD QUESTION",
	"APL FUNCTIONAL SYMBOL QUAD RIGHTWARDS ARROW",
	"APL FUNCTIONAL SYMBOL QUAD SLASH",
	"APL FUNCTIONAL SYMBOL QUAD UP CARET",
	"APL FUNCTIONAL SYMBOL QUAD UPWARDS ARROW",
	"APL FUNCTIONAL SYMBOL QUOTE QUAD",
	"APL FUNCTIONAL SYMBOL QUOTE UNDERBAR",
	"APL FUNCTIONAL SYMBOL RHO",
	"APL FUNCTIONAL SYMBOL RIGHTWARDS VANE",
	"APL FUNCTIONAL SYMBOL SEMICOLON UNDERBAR",
	"APL FUNCTIONAL SYMBOL SLASH BAR",
	"APL FUNCTIONAL SYMBOL SQUISH QUAD",
	"APL FUNCTIONAL SYMBOL STAR DIAERESIS",
	"APL FUNCTIONAL SYMBOL STILE TILDE",
	"APL FUNCTIONAL SYMBOL TILDE DIAERESIS",
	"APL FUNCTIONAL SYMBOL UP CARET TILDE",
	"APL FUNCTIONAL SYMBOL UP SHOE JOT",
	"APL FUNCTIONAL SYMBOL UP TACK DIAERESIS",
	"APL FUNCTIONAL SYMBOL UP TACK JOT",
	"APL FUNCTIONAL SYMBOL UP TACK OVERBAR",
	"APL FUNCTIONAL SYMBOL UPWARDS VANE",
	"APL FUNCTIONAL SYMBOL ZILDE",
	"APOSTROPHE",
	"APPROACHES THE LIMIT",
	"APPROXIMATELY BUT NOT ACTUALLY EQUAL TO",
	"APPROXIMATELY EQUAL OR EQUAL TO",
	"APPROXIMATELY EQUAL TO",
	"APPROXIMATELY EQUAL TO OR THE IMAGE OF",
	"AQUARIUS",
	"ARABIC COMMA",
	"ARABIC CURLY DAMMA",
	"ARABIC CURLY DAMMATAN",
	"ARABIC CURLY FATHA",
	"ARABIC CURLY FATHATAN",
	"ARABIC CURLY KASRA",
	"ARABIC CURLY KASRATAN",
	"ARABIC DAMMA",
	"ARABIC DAMMA ISOLATED FORM",
	"ARABIC DAMMA MEDIAL FORM",
	"ARABIC DAMMA WITH DOT",
	"ARABIC DAMMATAN",
	"ARABIC DAMMATAN ISOLATED FORM",
	"ARABIC DATE SEPARATOR",
	"ARABIC DECIMAL SEPARATOR",
	"ARABIC DOUBLE RIGHT ARROWHEAD ABOVE",
	"ARABIC DOUBLE RIGHT ARROWHEAD ABOVE WITH DOT",
	"ARABIC EMPTY CENTRE HIGH STOP",
	"ARABIC EMPTY CENTRE LOW STOP",
	"ARABIC END OF AYAH",
	"ARABIC FATHA",
	"ARABIC FATHA ISOLATED FORM",
	"ARABIC FATHA MEDIAL FORM",
	"ARABIC FATHA WITH DOT ABOVE",
	"ARABIC FATHA WITH RING",
	"ARABIC FATHA WITH TWO DOTS",
	"ARABIC FATHATAN",
	"ARABIC FATHATAN ISOLATED FORM",
	"ARABIC FIVE POINTED STAR",
	"ARABIC FOOTNOTE MARKER",
	"ARABIC FULL STOP",
	"ARABIC HAMZA ABOVE",
	"ARABIC HAMZA BELOW",
	"ARABIC INVERTED DAMMA",
	"ARABIC KASRA",
	"ARABIC KASRA ISOLATED FORM",
	"ARABIC KASRA MEDIAL FORM",
	"ARABIC KASRA WITH DOT BELOW",
	"ARABIC KASRATAN",
	"ARABIC KASRATAN ISOLATED FORM",
	"ARABIC LEFT ARROWHEAD ABOVE",
	"ARABIC LEFT ARROWHEAD BELOW",
	"ARABIC LETTER AE",
	"ARABIC LETTER AIN",
	"ARABIC LETTER AIN FINAL FORM",
	"ARABIC LETTER AIN INITIAL FORM",
	"ARABIC LETTER AIN ISOLATED FORM",
	"ARABIC LETTER AIN MEDIAL FORM",
	"ARABIC LETTER AIN WITH THREE DOTS ABOVE",
	"ARABIC LETTER AIN WITH THREE DOTS POINTING DOWNWARDS ABOVE",
	"ARABIC LETTER AIN WITH TWO DOTS ABOVE",
	"ARABIC LETTER AIN WITH TWO DOTS VERTICALLY ABOVE",
	"ARABIC LETTER ALEF",
	"ARABIC LETTER ALEF FINAL FORM",
	"ARABIC LETTER ALEF ISOLATED FORM",
	"ARABIC LETTER ALEF MAKSURA",
	"ARABIC LETTER ALEF MAKSURA FINAL FORM",
	"ARABIC LETTER ALEF MAKSURA ISOLATED FORM",
	"ARABIC LETTER ALEF WASLA",
	"ARABIC LETTER ALEF WASLA FINAL FORM",
	"ARABIC LETTER ALEF WASLA ISOLATED FORM",
	"ARABIC LETTER ALEF WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE",
	"ARABIC LETTER ALEF WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE",
	"ARABIC LETTER ALEF WITH HAMZA ABOVE",
	"ARABIC LETTER ALEF WITH HAMZA ABOVE FINAL FORM",
	"ARABIC LETTER ALEF WITH HAMZA ABOVE ISOLATED FORM",
	"ARABIC LETTER ALEF WITH HAMZA BELOW",
	"ARABIC LETTER ALEF WITH HAMZA BELOW FINAL FORM",
	"ARABIC LETTER ALEF WITH HAMZA BELOW ISOLATED FORM",
	"ARABIC LETTER ALEF WITH MADDA ABOVE",
	"ARABIC LETTER ALEF WITH MADDA ABOVE FINAL FORM",
	"ARABIC LETTER ALEF WITH MADDA ABOVE ISOLATED FORM",
	"ARABIC LETTER ALEF WITH WAVY HAMZA ABOVE",
	"ARABIC LETTER ALEF WITH WAVY HAMZA BELOW",
	"ARABIC LETTER BEEH",
	"ARABIC LETTER BEEH FINAL FORM",
	"ARABIC LETTER BEEH INITIAL FORM",
	"ARABIC LETTER BEEH ISOLATED FORM",
	"ARABIC LETTER BEEH MEDIAL FORM",
	"ARABIC LETTER BEH",
	"ARABIC LETTER BEH FINAL FORM",
	"ARABIC LETTER BEH INITIAL FORM",
	"ARABIC LETTER BEH ISOLATED FORM",
	"ARABIC LETTER BEH MEDIAL FORM",
	"ARABIC LETTER BEH WITH DOT BELOW AND THREE DOTS ABOVE",
	"ARABIC LETTER BEH WITH INVERTED SMALL V BELOW",
	"ARABIC LETTER BEH WITH SMALL V",
	"ARABIC LETTER BEH WITH SMALL V BELOW",
	"ARABIC LETTER BEH WITH THREE DOTS HORIZONTALLY BELOW",
	"ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW",
	"ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW AND TWO DOTS ABOVE",
	"ARABIC LETTER BEH WITH TWO DOTS BELOW AND DOT ABOVE",
	"ARABIC LETTER BEHEH",
	"ARABIC LETTER BEHEH FINAL FORM",
	"ARABIC LETTER BEHEH INITIAL FORM",
	"ARABIC LETTER BEHEH ISOLATED FORM",
	"ARABIC LETTER BEHEH MEDIAL FORM",
	"ARABIC LETTER DAD",
	"ARABIC LETTER DAD FINAL FORM",
	"ARABIC LETTER DAD INITIAL FORM",
	"ARABIC LETTER DAD ISOLATED FORM",
	"ARABIC LETTER DAD MEDIAL FORM",
	"ARABIC LETTER DAD WITH DOT BELOW",
	"ARABIC LETTER DAHAL",
	"ARABIC LETTER DAHAL FINAL FORM",
	"ARABIC LETTER DAHAL ISOLATED FORM",
	"ARABIC LETTER DAL",
	"ARABIC LETTER DAL FINAL FORM",
	"ARABIC LETTER DAL ISOLATED FORM",
	"ARABIC LETTER DAL WITH DOT BELOW",
	"ARABIC LETTER DAL WITH DOT BELOW AND SMALL TAH",
	"ARABIC LETTER DAL WITH FOUR DOTS ABOVE",
	"ARABIC LETTER DAL WITH INVERTED SMALL V BELOW",
	"ARABIC LETTER DAL WITH INVERTED V",
	"ARABIC LETTER DAL WITH RING",
	"ARABIC LETTER DAL WITH THREE DOTS ABOVE DOWNWARDS",
	"ARABIC LETTER DAL WITH TWO DOTS VERTICALLY BELOW AND SMALL TAH",
	"ARABIC LETTER DDAHAL",
	"ARABIC LETTER DDAHAL FINAL FORM",
	"ARABIC LETTER DDAHAL ISOLATED FORM",
	"ARABIC LETTER DDAL",
	"ARABIC LETTER DDAL FINAL FORM",
	"ARABIC LETTER DDAL ISOLATED FORM",
	"ARABIC LETTER DOTLESS BEH",
	"ARABIC LETTER DOTLESS FEH",
	"ARABIC LETTER DOTLESS QAF",
	"ARABIC LETTER DUL",
	"ARABIC LETTER DUL FINAL FORM",
	"ARABIC LETTER DUL ISOLATED FORM",
	"ARABIC LETTER DYEH",
	"ARABIC LETTER DYEH FINAL FORM",
	"ARABIC LETTER DYEH INITIAL FORM",
	"ARABIC LETTER DYEH ISOLATED FORM",
	"ARABIC LETTER DYEH MEDIAL FORM",
	"ARABIC LETTER E",
	"ARABIC LETTER E FINAL FORM",
	"ARABIC LETTER E INITIAL FORM",
	"ARABIC LETTER E ISOLATED FORM",
	"ARABIC LETTER E MEDIAL FORM",
	"ARABIC LETTER FARSI YEH",
	"ARABIC LETTER FARSI YEH FINAL FORM",
	"ARABIC LETTER FARSI YEH INITIAL FORM",
	"ARABIC LETTER FARSI YEH ISOLATED FORM",
	"ARABIC LETTER FARSI YEH MEDIAL FORM",
	"ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT FOUR BELOW",
	"ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE",
	"ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE",
	"ARABIC LETTER FARSI YEH WITH INVERTED V",
	"ARABIC LETTER FARSI YEH WITH THREE DOTS ABOVE",
	"ARABIC LETTER FARSI YEH WITH TWO DOTS ABOVE",
	"ARABIC LETTER FEH",
	"ARABIC LETTER FEH FINAL FORM",
	"ARABIC LETTER FEH INITIAL FORM",
	"ARABIC LETTER FEH ISOLATED FORM",
	"ARABIC LETTER FEH MEDIAL FORM",
	"ARABIC LETTER FEH WITH DOT BELOW",
	"ARABIC LETTER FEH WITH DOT BELOW AND THREE DOTS ABOVE",
	"ARABIC LETTER FEH WITH DOT MOVED BELOW",
	"ARABIC LETTER FEH WITH THREE DOTS BELOW",
	"ARABIC LETTER FEH WITH THREE DOTS POINTING UPWARDS BELOW",
	"ARABIC LETTER FEH WITH TWO DOTS BELOW",
	"ARABIC LETTER GAF",
	"ARABIC LETTER GAF FINAL FORM",
	"ARABIC LETTER GAF INITIAL FORM",
	"ARABIC LETTER GAF ISOLATED FORM",
	"ARABIC LETTER GAF MEDIAL FORM",
	"ARABIC LETTER GAF WITH RING",
	"ARABIC LETTER GAF WITH THREE DOTS ABOVE",
	"ARABIC LETTER GAF WITH TWO DOTS BELOW",
	"ARABIC LETTER GHAIN",
	"ARABIC LETTER GHAIN FINAL FORM",
	"ARABIC LETTER GHAIN INITIAL FORM",
	"ARABIC LETTER GHAIN ISOLATED FORM",
	"ARABIC LETTER GHAIN MEDIAL FORM",
	"ARABIC LETTER GHAIN WITH DOT BELOW",
	"ARABIC LETTER GUEH",
	"ARABIC LETTER GUEH FINAL FORM",
	"ARABIC LETTER GUEH INITIAL FORM",
	"ARABIC LETTER GUEH ISOLATED FORM",
	"ARABIC LETTER GUEH MEDIAL FORM",
	"ARABIC LETTER HAH",
	"ARABIC LETTER HAH FINAL FORM",
	"ARABIC LETTER HAH INITIAL FORM",
	"ARABIC LETTER HAH ISOLATED FORM",
	"ARABIC LETTER HAH MEDIAL FORM",
	"ARABIC LETTER HAH WITH EXTENDED ARABIC-INDIC DIGIT FOUR BELOW",
	"ARABIC LETTER HAH WITH HAMZA ABOVE",
	"ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH ABOVE",
	"ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH AND TWO DOTS",
	"ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH BELOW",
	"ARABIC LETTER HAH WITH THREE DOTS ABOVE",
	"ARABIC LETTER HAH WITH THREE DOTS POINTING UPWARDS BELOW",
	"ARABIC LETTER HAH WITH TWO DOTS ABOVE",
	"ARABIC LETTER HAH WITH TWO DOTS VERTICAL ABOVE",
	"ARABIC LETTER HAMZA",
	"ARABIC LETTER HAMZA ISOLATED FORM",
	"ARABIC LETTER HEH",
	"ARABIC LETTER HEH DOACHASHMEE",
	"ARABIC LETTER HEH DOACHASHMEE FINAL FORM",
	"ARABIC LETTER HEH DOACHASHMEE INITIAL FORM",
	"ARABIC LETTER HEH DOACHASHMEE ISOLATED FORM",
	"ARABIC LETTER HEH DOACHASHMEE MEDIAL FORM",
	"ARABIC LETTER HEH FINAL FORM",
	"ARABIC LETTER HEH GOAL",
	"ARABIC LETTER HEH GOAL FINAL FORM",
	"ARABIC LETTER HEH GOAL INITIAL FORM",
	"ARABIC LETTER HEH GOAL ISOLATED FORM",
	"ARABIC LETTER HEH GOAL MEDIAL FORM",
	"ARABIC LETTER HEH GOAL WITH HAMZA ABOVE",
	"ARABIC LETTER HEH INITIAL FORM",
	"ARABIC LETTER HEH ISOLATED FORM",
	"ARABIC LETTER HEH MEDIAL FORM",
	"ARABIC LETTER HEH WITH INVERTED V",
	"ARABIC LETTER HEH WITH YEH ABOVE",
	"ARABIC LETTER HEH WITH YEH ABOVE FINAL FORM",
	"ARABIC LETTER HEH WITH YEH ABOVE ISOLATED FORM",
	"ARABIC LETTER HIGH HAMZA",
	"ARABIC LETTER HIGH HAMZA ALEF",
	"ARABIC LETTER HIGH HAMZA WAW",
	"ARABIC LETTER HIGH HAMZA YEH",
	"ARABIC LETTER JEEM",
	"ARABIC LETTER JEEM FINAL FORM",
	"ARABIC LETTER JEEM INITIAL FORM",
	"ARABIC LETTER JEEM ISOLATED FORM",
	"ARABIC LETTER JEEM MEDIAL FORM",
	"ARABIC LETTER JEEM WITH TWO DOTS ABOVE",
	"ARABIC LETTER JEH",
	"ARABIC LETTER JEH FINAL FORM",
	"ARABIC LETTER JEH ISOLATED FORM",
	"ARABIC LETTER KAF",
	"ARABIC LETTER KAF FINAL FORM",
	"ARABIC LETTER KAF INITIAL FORM",
	"ARABIC LETTER KAF ISOLATED FORM",
	"ARABIC LETTER KAF MEDIAL FORM",
	"ARABIC LETTER KAF WITH DOT ABOVE",
	"ARABIC LETTER KAF WITH RING",
	"ARABIC LETTER KAF WITH THREE DOTS BELOW",
	"ARABIC LETTER KAF WITH TWO DOTS ABOVE",
	"ARABIC LETTER KASHMIRI YEH",
	"ARABIC LETTER KEHEH",
	"ARABIC LETTER KEHEH FINAL FORM",
	"ARABIC LETTER KEHEH INITIAL FORM",
	"ARABIC LETTER KEHEH ISOLATED FORM",
	"ARABIC LETTER KEHEH MEDIAL FORM",
	"ARABIC LETTER KEHEH WITH DOT ABOVE",
	"ARABIC LETTER KEHEH WITH THREE DOTS ABOVE",
	"ARABIC LETTER KEHEH WITH THREE DOTS BELOW",
	"ARABIC LETTER KEHEH WITH THREE DOTS POINTING UPWARDS BELOW",
	"ARABIC LETTER KEHEH WITH TWO DOTS ABOVE",
	"ARABIC LETTER KHAH",
	"ARABIC LETTER KHAH FINAL FORM",
	"ARABIC LETTER KHAH INITIAL FORM",
	"ARABIC LETTER KHAH ISOLATED FORM",
	"ARABIC LETTER KHAH MEDIAL FORM",
	"ARABIC LETTER KIRGHIZ OE",
	"ARABIC LETTER KIRGHIZ OE FINAL FORM",
	"ARABIC LETTER KIRGHIZ OE ISOLATED FORM",
	"ARABIC LETTER KIRGHIZ YU",
	"ARABIC LETTER KIRGHIZ YU FINAL FORM",
	"ARABIC LETTER KIRGHIZ YU ISOLATED FORM",
	"ARABIC LETTER LAM",
	"ARABIC LETTER LAM FINAL FORM",
	"ARABIC LETTER LAM INITIAL FORM",
	"ARABIC LETTER LAM ISOLATED FORM",
	"ARABIC LETTER LAM MEDIAL FORM",
	"ARABIC LETTER LAM WITH BAR",
	"ARABIC LETTER LAM WITH DOT ABOVE",
	"ARABIC LETTER LAM WITH DOUBLE BAR",
	"ARABIC LETTER LAM WITH SMALL V",
	"ARABIC LETTER LAM WITH THREE DOTS ABOVE",
	"ARABIC LETTER LAM WITH THREE DOTS BELOW",
	"ARABIC LETTER MARK",
	"ARABIC LETTER MEEM",
	"ARABIC LETTER MEEM FINAL FORM",
	"ARABIC LETTER MEEM INITIAL FORM",
	"ARABIC LETTER MEEM ISOLATED FORM",
	"ARABIC LETTER MEEM MEDIAL FORM",
	"ARABIC LETTER MEEM WITH DOT ABOVE",
	"ARABIC LETTER MEEM WITH DOT BELOW",
	"ARABIC LETTER MEEM WITH THREE DOTS ABOVE",
	"ARABIC LETTER NG",
	"ARABIC LETTER NG FINAL FORM",
	"ARABIC LETTER NG INITIAL FORM",
	"ARABIC LETTER NG ISOLATED FORM",
	"ARABIC LETTER NG MEDIAL FORM",
	"ARABIC LETTER NGOEH",
	"ARABIC LETTER NGOEH FINAL FORM",
	"ARABIC LETTER NGOEH INITIAL FORM",
	"ARABIC LETTER NGOEH ISOLATED FORM",
	"ARABIC LETTER NGOEH MEDIAL FORM",
	"ARABIC LETTER NOON",
	"ARABIC LETTER NOON FINAL FORM",
	"ARABIC LETTER NOON GHUNNA",
	"ARABIC LETTER NOON GHUNNA FINAL FORM",
	"ARABIC LETTER NOON GHUNNA ISOLATED FORM",
	"ARABIC LETTER NOON INITIAL FORM",
	"ARABIC LETTER NOON ISOLATED FORM",
	"ARABIC LETTER NOON MEDIAL FORM",
	"ARABIC LETTER NOON WITH DOT BELOW",
	"ARABIC LETTER NOON WITH RING",
	"ARABIC LETTER NOON WITH SMALL TAH",
	"ARABIC LETTER NOON WITH SMALL V",
	"ARABIC LETTER NOON WITH THREE DOTS ABOVE",
	"ARABIC LETTER NOON WITH TWO DOTS BELOW",
	"ARABIC LETTER NYEH",
	"ARABIC LETTER NYEH FINAL FORM",
	"ARABIC LETTER NYEH INITIAL FORM",
	"ARABIC LETTER NYEH ISOLATED FORM",
	"ARABIC LETTER NYEH MEDIAL FORM",
	"ARABIC LETTER OE",
	"ARABIC LETTER OE FINAL FORM",
	"ARABIC LETTER OE ISOLATED FORM",
	"ARABIC LETTER PEH",
	"ARABIC LETTER PEH FINAL FORM",
	"ARABIC LETTER PEH INITIAL FORM",
	"ARABIC LETTER PEH ISOLATED FORM",
	"ARABIC LETTER PEH MEDIAL FORM",
	"ARABIC LETTER PEHEH",
	"ARABIC LETTER PEHEH FINAL FORM",
	"ARABIC LETTER PEHEH INITIAL FORM",
	"ARABIC LETTER PEHEH ISOLATED FORM",
	"ARABIC LETTER PEHEH MEDIAL FORM",
	"ARABIC LETTER QAF",
	"ARABIC LETTER QAF FINAL FORM",
	"ARABIC LETTER QAF INITIAL FORM",
	"ARABIC LETTER QAF ISOLATED FORM",
	"ARABIC LETTER QAF MEDIAL FORM",
	"ARABIC LETTER QAF WITH DOT ABOVE",
	"ARABIC LETTER QAF WITH DOT BELOW",
	"ARABIC LETTER QAF WITH THREE DOTS ABOVE",
	"ARABIC LETTER REH",
	"ARABIC LETTER REH FINAL FORM",
	"ARABIC LETTER REH ISOLATED FORM",
	"ARABIC LETTER REH WITH DOT BELOW",
	"ARABIC LETTER REH WITH DOT BELOW AND DOT ABOVE",
	"ARABIC LETTER REH WITH FOUR DOTS ABOVE",
	"ARABIC LETTER REH WITH HAMZA ABOVE",
	"ARABIC LETTER REH WITH INVERTED V",
	"ARABIC LETTER REH WITH LOOP",
	"ARABIC LETTER REH WITH RING",
	"ARABIC LETTER REH WITH SMALL ARABIC LETTER TAH AND TWO DOTS",
	"ARABIC LETTER REH WITH SMALL V",
	"ARABIC LETTER REH WITH SMALL V BELOW",
	"ARABIC LETTER REH WITH STROKE",
	"ARABIC LETTER REH WITH TWO DOTS ABOVE",
	"ARABIC LETTER REH WITH TWO DOTS VERTICALLY ABOVE",
	"ARABIC LETTER RNOON",
	"ARABIC LETTER RNOON FINAL FORM",
	"ARABIC LETTER RNOON INITIAL FORM",
	"ARABIC LETTER RNOON ISOLATED FORM",
	"ARABIC LETTER RNOON MEDIAL FORM",
	"ARABIC LETTER ROHINGYA YEH",
	"ARABIC LETTER RREH",
	"ARABIC LETTER RREH FINAL FORM",
	"ARABIC LETTER RREH ISOLATED FORM",
	"ARABIC LETTER SAD",
	"ARABIC LETTER SAD FINAL FORM",
	"ARABIC LETTER SAD INITIAL FORM",
	"ARABIC LETTER SAD ISOLATED FORM",
	"ARABIC LETTER SAD MEDIAL FORM",
	"ARABIC LETTER SAD WITH THREE DOTS ABOVE",
	"ARABIC LETTER SAD WITH TWO DOTS BELOW",
	"ARABIC LETTER SEEN",
	"ARABIC LETTER SEEN FINAL FORM",
	"ARABIC LETTER SEEN INITIAL FORM",
	"ARABIC LETTER SEEN ISOLATED FORM",
	"ARABIC LETTER SEEN MEDIAL FORM",
	"ARABIC LETTER SEEN WITH DOT BELOW AND DOT ABOVE",
	"ARABIC LETTER SEEN WITH EXTENDED ARABIC-INDIC DIGIT FOUR ABOVE",
	"ARABIC LETTER SEEN WITH FOUR DOTS ABOVE",
	"ARABIC LETTER SEEN WITH INVERTED V",
	"ARABIC LETTER SEEN WITH SMALL ARABIC LETTER TAH AND TWO DOTS",
	"ARABIC LETTER SEEN WITH THREE DOTS BELOW",
	"ARABIC LETTER SEEN WITH THREE DOTS BELOW AND THREE DOTS ABOVE",
	"ARABIC LETTER SEEN WITH TWO DOTS VERTICALLY ABOVE",
	"ARABIC LETTER SHEEN",
	"ARABIC LETTER SHEEN FINAL FORM",
	"ARABIC LETTER SHEEN INITIAL FORM",
	"ARABIC LETTER SHEEN ISOLATED FORM",
	"ARABIC LETTER SHEEN MEDIAL FORM",
	"ARABIC LETTER SHEEN WITH DOT BELOW",
	"ARABIC LETTER SUPERSCRIPT ALEF",
	"ARABIC LETTER SWASH KAF",
	"ARABIC LETTER TAH",
	"ARABIC LETTER TAH FINAL FORM",
	"ARABIC LETTER TAH INITIAL FORM",
	"ARABIC LETTER TAH ISOLATED FORM",
	"ARABIC LETTER TAH MEDIAL FORM",
	"ARABIC LETTER TAH WITH THREE DOTS ABOVE",
	"ARABIC LETTER TAH WITH TWO DOTS ABOVE",
	"ARABIC LETTER TCHEH",
	"ARABIC LETTER TCHEH FINAL FORM",
	"ARABIC LETTER TCHEH INITIAL FORM",
	"ARABIC LETTER TCHEH ISOLATED FORM",
	"ARABIC LETTER TCHEH MEDIAL FORM",
	"ARABIC LETTER TCHEH WITH DOT ABOVE",
	"ARABIC LETTER TCHEHEH",
	"ARABIC LETTER TCHEHEH FINAL FORM",
	"ARABIC LETTER TCHEHEH INITIAL FORM",
	"ARABIC LETTER TCHEHEH ISOLATED FORM",
	"ARABIC LETTER TCHEHEH MEDIAL FORM",
	"ARABIC LETTER TEH",
	"ARABIC LETTER TEH FINAL FORM",
	"ARABIC LETTER TEH INITIAL FORM",
	"ARABIC LETTER TEH ISOLATED FORM",
	"ARABIC LETTER TEH MARBUTA",
	"ARABIC LETTER TEH MARBUTA FINAL FORM",
	"ARABIC LETTER TEH MARBUTA GOAL",
	"ARABIC LETTER TEH MARBUTA ISOLATED FORM",
	"ARABIC LETTER TEH MEDIAL FORM",
	"ARABIC LETTER TEH WITH RING",
	"ARABIC LETTER TEH WITH THREE DOTS ABOVE DOWNWARDS",
	"ARABIC LETTER TEHEH",
	"ARABIC LETTER TEHEH FINAL FORM",
	"ARABIC LETTER TEHEH INITIAL FORM",
	"ARABIC LETTER TEHEH ISOLATED FORM",
	"ARABIC LETTER TEHEH MEDIAL FORM",
	"ARABIC LETTER THAL",
	"ARABIC LETTER THAL FINAL FORM",
	"ARABIC LETTER THAL ISOLATED FORM",
	"ARABIC LETTER THEH",
	"ARABIC LETTER THEH FINAL FORM",
	"ARABIC LETTER THEH INITIAL FORM",
	"ARABIC LETTER THEH ISOLATED FORM",
	"ARABIC LETTER THEH MEDIAL FORM",
	"ARABIC LETTER TTEH",
	"ARABIC LETTER TTEH FINAL FORM",
	"ARABIC LETTER TTEH INITIAL FORM",
	"ARABIC LETTER TTEH ISOLATED FORM",
	"ARABIC LETTER TTEH MEDIAL FORM",
	"ARABIC LETTER TTEHEH",
	"ARABIC LETTER TTEHEH FINAL FORM",
	"ARABIC LETTER TTEHEH INITIAL FORM",
	"ARABIC LETTER TTEHEH ISOLATED FORM",
	"ARABIC LETTER TTEHEH MEDIAL FORM",
	"ARABIC LETTER U",
	"ARABIC LETTER U FINAL FORM",
	"ARABIC LETTER U ISOLATED FORM",
	"ARABIC LETTER U WITH HAMZA ABOVE",
	"ARABIC LETTER U WITH HAMZA ABOVE ISOLATED FORM",
	"ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA INITIAL FORM",
	"ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA MEDIAL FORM",
	"ARABIC LETTER VE",
	"ARABIC LETTER VE FINAL FORM",
	"ARABIC LETTER VE ISOLATED FORM",
	"ARABIC LETTER VEH",
	"ARABIC LETTER VEH FINAL FORM",
	"ARABIC LETTER VEH INITIAL FORM",
	"ARABIC LETTER VEH ISOLATED FORM",
	"ARABIC LETTER VEH MEDIAL FORM",
	"ARABIC LETTER WAW",
	"ARABIC LETTER WAW FINAL FORM",
	"ARABIC LETTER WAW ISOLATED FORM",
	"ARABIC LETTER WAW WITH DOT ABOVE",
	"ARABIC LETTER WAW WITH DOT WITHIN",
	"ARABIC LETTER WAW WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE",
	"ARABIC LETTER WAW WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE",
	"ARABIC LETTER WAW WITH HAMZA ABOVE",
	"ARABIC LETTER WAW WITH HAMZA ABOVE FINAL FORM",
	"ARABIC LETTER WAW WITH HAMZA ABOVE ISOLATED FORM",
	"ARABIC LETTER WAW WITH RING",
	"ARABIC LETTER WAW WITH TWO DOTS ABOVE",
	"ARABIC LETTER YEH",
	"ARABIC LETTER YEH BARREE",
	"ARABIC LETTER YEH BARREE FINAL FORM",
	"ARABIC LETTER YEH BARREE ISOLATED FORM",
	"ARABIC LETTER YEH BARREE WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE",
	"ARABIC LETTER YEH BARREE WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE",
	"ARABIC LETTER YEH BARREE WITH HAMZA ABOVE",
	"ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM",
	"ARABIC LETTER YEH BARREE WITH HAMZA ABOVE ISOLATED FORM",
	"ARABIC LETTER YEH FINAL FORM",
	"ARABIC LETTER YEH INITIAL FORM",
	"ARABIC LETTER YEH ISOLATED FORM",
	"ARABIC LETTER YEH MEDIAL FORM",
	"ARABIC LETTER YEH WITH HAMZA ABOVE",
	"ARABIC LETTER YEH WITH HAMZA ABOVE FINAL FORM",
	"ARABIC LETTER YEH WITH HAMZA ABOVE INITIAL FORM",
	"ARABIC LETTER YEH WITH HAMZA ABOVE ISOLATED FORM",
	"ARABIC LETTER YEH WITH HAMZA ABOVE MEDIAL FORM",
	"ARABIC LETTER YEH WITH SMALL V",
	"ARABIC LETTER YEH WITH TAIL",
	"ARABIC LETTER YEH WITH THREE DOTS BELOW",
	"ARABIC LETTER YEH WITH TWO DOTS BELOW AND DOT ABOVE",
	"ARABIC LETTER YEH WITH TWO DOTS BELOW AND HAMZA ABOVE",
	"ARABIC LETTER YU",
	"ARABIC LETTER YU FINAL FORM",
	"ARABIC LETTER YU ISOLATED FORM",
	"ARABIC LETTER ZAH",
	"ARABIC LETTER ZAH FINAL FORM",
	"ARABIC LETTER ZAH INITIAL FORM",
	"ARABIC LETTER ZAH ISOLATED FORM",
	"ARABIC LETTER ZAH MEDIAL FORM",
	"ARABIC LETTER ZAIN",
	"ARABIC LETTER ZAIN FINAL FORM",
	"ARABIC LETTER ZAIN ISOLATED FORM",
	"ARABIC LIGATURE AIN WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE AIN WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE AIN WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE AIN WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE AIN WITH JEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE AIN WITH JEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE AIN WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE AIN WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE AIN WITH MEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE AIN WITH MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE AIN WITH MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE AIN WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE AIN WITH YEH FINAL FORM",
	"ARABIC LIGATURE AIN WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE AKBAR ISOLATED FORM",
	"ARABIC LIGATURE ALAYHE ISOLATED FORM",
	"ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF FINAL FORM",
	"ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF ISOLATED FORM",
	"ARABIC LIGATURE ALEF WITH FATHATAN FINAL FORM",
	"ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM",
	"ARABIC LIGATURE ALLAH ISOLATED FORM",
	"ARABIC LIGATURE BEH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE BEH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE BEH WITH HAH INITIAL FORM",
	"ARABIC LIGATURE BEH WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE BEH WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE BEH WITH HEH INITIAL FORM",
	"ARABIC LIGATURE BEH WITH HEH MEDIAL FORM",
	"ARABIC LIGATURE BEH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE BEH WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE BEH WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE BEH WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE BEH WITH KHAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE BEH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE BEH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE BEH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE BEH WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE BEH WITH NOON FINAL FORM",
	"ARABIC LIGATURE BEH WITH REH FINAL FORM",
	"ARABIC LIGATURE BEH WITH YEH FINAL FORM",
	"ARABIC LIGATURE BEH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE BEH WITH ZAIN FINAL FORM",
	"ARABIC LIGATURE BISMILLAH AR-RAHMAN AR-RAHEEM",
	"ARABIC LIGATURE DAD WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE DAD WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE DAD WITH HAH INITIAL FORM",
	"ARABIC LIGATURE DAD WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE DAD WITH HAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE DAD WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE DAD WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE DAD WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE DAD WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE DAD WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE DAD WITH KHAH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE DAD WITH KHAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE DAD WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE DAD WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE DAD WITH REH FINAL FORM",
	"ARABIC LIGATURE DAD WITH REH ISOLATED FORM",
	"ARABIC LIGATURE DAD WITH YEH FINAL FORM",
	"ARABIC LIGATURE DAD WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE FEH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE FEH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE FEH WITH HAH INITIAL FORM",
	"ARABIC LIGATURE FEH WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE FEH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE FEH WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE FEH WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE FEH WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE FEH WITH KHAH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE FEH WITH KHAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE FEH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE FEH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE FEH WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE FEH WITH YEH FINAL FORM",
	"ARABIC LIGATURE FEH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE GHAIN WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE GHAIN WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE GHAIN WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE GHAIN WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE GHAIN WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE GHAIN WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE GHAIN WITH MEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE GHAIN WITH MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE GHAIN WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE GHAIN WITH YEH FINAL FORM",
	"ARABIC LIGATURE GHAIN WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE HAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE HAH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE HAH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE HAH WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE HAH WITH JEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE HAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE HAH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE HAH WITH MEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE HAH WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE HAH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE HEH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE HEH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE HEH WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE HEH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE HEH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE HEH WITH MEEM WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE HEH WITH MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE HEH WITH SUPERSCRIPT ALEF INITIAL FORM",
	"ARABIC LIGATURE HEH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE JALLAJALALOUHOU",
	"ARABIC LIGATURE JEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE JEEM WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE JEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE JEEM WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE JEEM WITH HAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE JEEM WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE JEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE JEEM WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE JEEM WITH MEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE JEEM WITH MEEM WITH HAH FINAL FORM",
	"ARABIC LIGATURE JEEM WITH MEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE JEEM WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE JEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE JEEM WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE KAF WITH ALEF FINAL FORM",
	"ARABIC LIGATURE KAF WITH ALEF ISOLATED FORM",
	"ARABIC LIGATURE KAF WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE KAF WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE KAF WITH HAH INITIAL FORM",
	"ARABIC LIGATURE KAF WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE KAF WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE KAF WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE KAF WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE KAF WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE KAF WITH LAM FINAL FORM",
	"ARABIC LIGATURE KAF WITH LAM INITIAL FORM",
	"ARABIC LIGATURE KAF WITH LAM ISOLATED FORM",
	"ARABIC LIGATURE KAF WITH LAM MEDIAL FORM",
	"ARABIC LIGATURE KAF WITH MEEM FINAL FORM",
	"ARABIC LIGATURE KAF WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE KAF WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE KAF WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE KAF WITH MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE KAF WITH MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE KAF WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE KAF WITH YEH FINAL FORM",
	"ARABIC LIGATURE KAF WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE KHAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE KHAH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE KHAH WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE KHAH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE KHAH WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE KHAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE KHAH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE KHAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE KHAH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH ALEF FINAL FORM",
	"ARABIC LIGATURE LAM WITH ALEF ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE LAM WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE FINAL FORM",
	"ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW FINAL FORM",
	"ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE FINAL FORM",
	"ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE LAM WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH HAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE LAM WITH HAH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE LAM WITH HAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE LAM WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE LAM WITH HEH INITIAL FORM",
	"ARABIC LIGATURE LAM WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE LAM WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH JEEM WITH JEEM FINAL FORM",
	"ARABIC LIGATURE LAM WITH JEEM WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE LAM WITH JEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE LAM WITH JEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE LAM WITH JEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE LAM WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE LAM WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH KHAH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE LAM WITH KHAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE LAM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE LAM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE LAM WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE LAM WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE LAM WITH MEEM WITH HAH FINAL FORM",
	"ARABIC LIGATURE LAM WITH MEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE LAM WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE LAM WITH YEH FINAL FORM",
	"ARABIC LIGATURE LAM WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE MEEM WITH ALEF FINAL FORM",
	"ARABIC LIGATURE MEEM WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE MEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE MEEM WITH HAH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH HAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE MEEM WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE MEEM WITH JEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH JEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH JEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE MEEM WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE MEEM WITH KHAH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH KHAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE MEEM WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE MEEM WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE MEEM WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE MOHAMMAD ISOLATED FORM",
	"ARABIC LIGATURE NOON WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE NOON WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE NOON WITH HAH INITIAL FORM",
	"ARABIC LIGATURE NOON WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE NOON WITH HAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE NOON WITH HAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE NOON WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE NOON WITH HEH INITIAL FORM",
	"ARABIC LIGATURE NOON WITH HEH MEDIAL FORM",
	"ARABIC LIGATURE NOON WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE NOON WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE NOON WITH JEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE NOON WITH JEEM WITH HAH FINAL FORM",
	"ARABIC LIGATURE NOON WITH JEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE NOON WITH JEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE NOON WITH JEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE NOON WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE NOON WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE NOON WITH MEEM FINAL FORM",
	"ARABIC LIGATURE NOON WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE NOON WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE NOON WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE NOON WITH MEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE NOON WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE NOON WITH NOON FINAL FORM",
	"ARABIC LIGATURE NOON WITH REH FINAL FORM",
	"ARABIC LIGATURE NOON WITH YEH FINAL FORM",
	"ARABIC LIGATURE NOON WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE NOON WITH ZAIN FINAL FORM",
	"ARABIC LIGATURE QAF WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE QAF WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE QAF WITH HAH INITIAL FORM",
	"ARABIC LIGATURE QAF WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE QAF WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE QAF WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE QAF WITH MEEM WITH HAH FINAL FORM",
	"ARABIC LIGATURE QAF WITH MEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE QAF WITH MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE QAF WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE QAF WITH YEH FINAL FORM",
	"ARABIC LIGATURE QAF WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE QALA USED AS KORANIC STOP SIGN ISOLATED FORM",
	"ARABIC LIGATURE RASOUL ISOLATED FORM",
	"ARABIC LIGATURE REH WITH SUPERSCRIPT ALEF ISOLATED FORM",
	"ARABIC LIGATURE SAD WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE SAD WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE SAD WITH HAH INITIAL FORM",
	"ARABIC LIGATURE SAD WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE SAD WITH HAH WITH HAH FINAL FORM",
	"ARABIC LIGATURE SAD WITH HAH WITH HAH INITIAL FORM",
	"ARABIC LIGATURE SAD WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE SAD WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE SAD WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE SAD WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE SAD WITH MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE SAD WITH MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE SAD WITH REH FINAL FORM",
	"ARABIC LIGATURE SAD WITH REH ISOLATED FORM",
	"ARABIC LIGATURE SAD WITH YEH FINAL FORM",
	"ARABIC LIGATURE SAD WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE SALAM ISOLATED FORM",
	"ARABIC LIGATURE SALLA ISOLATED FORM",
	"ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM",
	"ARABIC LIGATURE SALLALLAHOU ALAYHE WASALLAM",
	"ARABIC LIGATURE SEEN WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE SEEN WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE SEEN WITH HAH INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE SEEN WITH HAH MEDIAL FORM",
	"ARABIC LIGATURE SEEN WITH HAH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH HEH INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH HEH MEDIAL FORM",
	"ARABIC LIGATURE SEEN WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE SEEN WITH JEEM MEDIAL FORM",
	"ARABIC LIGATURE SEEN WITH JEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE SEEN WITH JEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE SEEN WITH KHAH MEDIAL FORM",
	"ARABIC LIGATURE SEEN WITH KHAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE SEEN WITH KHAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE SEEN WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE SEEN WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE SEEN WITH MEEM WITH HAH FINAL FORM",
	"ARABIC LIGATURE SEEN WITH MEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH MEEM WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE SEEN WITH MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE SEEN WITH REH FINAL FORM",
	"ARABIC LIGATURE SEEN WITH REH ISOLATED FORM",
	"ARABIC LIGATURE SEEN WITH YEH FINAL FORM",
	"ARABIC LIGATURE SEEN WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE SHADDA WITH DAMMA ISOLATED FORM",
	"ARABIC LIGATURE SHADDA WITH DAMMA MEDIAL FORM",
	"ARABIC LIGATURE SHADDA WITH DAMMATAN ISOLATED FORM",
	"ARABIC LIGATURE SHADDA WITH FATHA ISOLATED FORM",
	"ARABIC LIGATURE SHADDA WITH FATHA MEDIAL FORM",
	"ARABIC LIGATURE SHADDA WITH KASRA ISOLATED FORM",
	"ARABIC LIGATURE SHADDA WITH KASRA MEDIAL FORM",
	"ARABIC LIGATURE SHADDA WITH KASRATAN ISOLATED FORM",
	"ARABIC LIGATURE SHADDA WITH SUPERSCRIPT ALEF ISOLATED FORM",
	"ARABIC LIGATURE SHEEN WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE SHEEN WITH HAH FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH HAH INITIAL FORM",
	"ARABIC LIGATURE SHEEN WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE SHEEN WITH HAH MEDIAL FORM",
	"ARABIC LIGATURE SHEEN WITH HAH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH HAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE SHEEN WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH HEH INITIAL FORM",
	"ARABIC LIGATURE SHEEN WITH HEH MEDIAL FORM",
	"ARABIC LIGATURE SHEEN WITH JEEM FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE SHEEN WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE SHEEN WITH JEEM MEDIAL FORM",
	"ARABIC LIGATURE SHEEN WITH JEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH KHAH FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE SHEEN WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE SHEEN WITH KHAH MEDIAL FORM",
	"ARABIC LIGATURE SHEEN WITH MEEM FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE SHEEN WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE SHEEN WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE SHEEN WITH REH FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH REH ISOLATED FORM",
	"ARABIC LIGATURE SHEEN WITH YEH FINAL FORM",
	"ARABIC LIGATURE SHEEN WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE TAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE TAH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE TAH WITH HAH INITIAL FORM",
	"ARABIC LIGATURE TAH WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE TAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE TAH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE TAH WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE TAH WITH MEEM WITH HAH FINAL FORM",
	"ARABIC LIGATURE TAH WITH MEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE TAH WITH MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE TAH WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE TAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE TAH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE TEH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE TEH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE TEH WITH HAH INITIAL FORM",
	"ARABIC LIGATURE TEH WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE TEH WITH HAH WITH JEEM FINAL FORM",
	"ARABIC LIGATURE TEH WITH HAH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE TEH WITH HAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE TEH WITH HEH INITIAL FORM",
	"ARABIC LIGATURE TEH WITH HEH MEDIAL FORM",
	"ARABIC LIGATURE TEH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE TEH WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE TEH WITH JEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE TEH WITH JEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE TEH WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE TEH WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE TEH WITH KHAH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE TEH WITH KHAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE TEH WITH KHAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE TEH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE TEH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE TEH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE TEH WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE TEH WITH MEEM WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE TEH WITH MEEM WITH HAH INITIAL FORM",
	"ARABIC LIGATURE TEH WITH MEEM WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE TEH WITH MEEM WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE TEH WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE TEH WITH NOON FINAL FORM",
	"ARABIC LIGATURE TEH WITH REH FINAL FORM",
	"ARABIC LIGATURE TEH WITH YEH FINAL FORM",
	"ARABIC LIGATURE TEH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE TEH WITH ZAIN FINAL FORM",
	"ARABIC LIGATURE THAL WITH SUPERSCRIPT ALEF ISOLATED FORM",
	"ARABIC LIGATURE THEH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE THEH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE THEH WITH HEH MEDIAL FORM",
	"ARABIC LIGATURE THEH WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE THEH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE THEH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE THEH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE THEH WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE THEH WITH NOON FINAL FORM",
	"ARABIC LIGATURE THEH WITH REH FINAL FORM",
	"ARABIC LIGATURE THEH WITH YEH FINAL FORM",
	"ARABIC LIGATURE THEH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE THEH WITH ZAIN FINAL FORM",
	"ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA INITIAL FORM",
	"ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE WASALLAM ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE YEH WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAH INITIAL FORM",
	"ARABIC LIGATURE YEH WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAH WITH YEH FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E INITIAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH INITIAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH INITIAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH MEDIAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH NOON FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH REH FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU FINAL FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ZAIN FINAL FORM",
	"ARABIC LIGATURE YEH WITH HEH INITIAL FORM",
	"ARABIC LIGATURE YEH WITH HEH MEDIAL FORM",
	"ARABIC LIGATURE YEH WITH JEEM INITIAL FORM",
	"ARABIC LIGATURE YEH WITH JEEM ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH JEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE YEH WITH KHAH INITIAL FORM",
	"ARABIC LIGATURE YEH WITH KHAH ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH MEEM FINAL FORM",
	"ARABIC LIGATURE YEH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE YEH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH MEEM MEDIAL FORM",
	"ARABIC LIGATURE YEH WITH MEEM WITH MEEM FINAL FORM",
	"ARABIC LIGATURE YEH WITH MEEM WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE YEH WITH MEEM WITH YEH FINAL FORM",
	"ARABIC LIGATURE YEH WITH NOON FINAL FORM",
	"ARABIC LIGATURE YEH WITH REH FINAL FORM",
	"ARABIC LIGATURE YEH WITH YEH FINAL FORM",
	"ARABIC LIGATURE YEH WITH YEH ISOLATED FORM",
	"ARABIC LIGATURE YEH WITH ZAIN FINAL FORM",
	"ARABIC LIGATURE ZAH WITH MEEM INITIAL FORM",
	"ARABIC LIGATURE ZAH WITH MEEM ISOLATED FORM",
	"ARABIC LIGATURE ZAH WITH MEEM MEDIAL FORM",
	"ARABIC MADDAH ABOVE",
	"ARABIC MARK NOON GHUNNA",
	"ARABIC MATHEMATICAL AIN",
	"ARABIC MATHEMATICAL ALEF",
	"ARABIC MATHEMATICAL BEH",
	"ARABIC MATHEMATICAL DAD",
	"ARABIC MATHEMATICAL DAL",
	"ARABIC MATHEMATICAL DOTLESS BEH",
	"ARABIC MATHEMATICAL DOTLESS FEH",
	"ARABIC MATHEMATICAL DOTLESS NOON",
	"ARABIC MATHEMATICAL DOTLESS QAF",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK AIN",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK BEH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK DAD",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK DAL",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK FEH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK GHAIN",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK HAH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK JEEM",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK KHAH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK LAM",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK MEEM",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK NOON",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK QAF",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK REH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK SAD",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK SEEN",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK SHEEN",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK TAH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK TEH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK THAL",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK THEH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK WAW",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK YEH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK ZAH",
	"ARABIC MATHEMATICAL DOUBLE-STRUCK ZAIN",
	"ARABIC MATHEMATICAL FEH",
	"ARABIC MATHEMATICAL GHAIN",
	"ARABIC MATHEMATICAL HAH",
	"ARABIC MATHEMATICAL INITIAL AIN",
	"ARABIC MATHEMATICAL INITIAL BEH",
	"ARABIC MATHEMATICAL INITIAL DAD",
	"ARABIC MATHEMATICAL INITIAL FEH",
	"ARABIC MATHEMATICAL INITIAL GHAIN",
	"ARABIC MATHEMATICAL INITIAL HAH",
	"ARABIC MATHEMATICAL INITIAL HEH",
	"ARABIC MATHEMATICAL INITIAL JEEM",
	"ARABIC MATHEMATICAL INITIAL KAF",
	"ARABIC MATHEMATICAL INITIAL KHAH",
	"ARABIC MATHEMATICAL INITIAL LAM",
	"ARABIC MATHEMATICAL INITIAL MEEM",
	"ARABIC MATHEMATICAL INITIAL NOON",
	"ARABIC MATHEMATICAL INITIAL QAF",
	"ARABIC MATHEMATICAL INITIAL SAD",
	"ARABIC MATHEMATICAL INITIAL SEEN",
	"ARABIC MATHEMATICAL INITIAL SHEEN",
	"ARABIC MATHEMATICAL INITIAL TEH",
	"ARABIC MATHEMATICAL INITIAL THEH",
	"ARABIC MATHEMATICAL INITIAL YEH",
	"ARABIC MATHEMATICAL JEEM",
	"ARABIC MATHEMATICAL KAF",
	"ARABIC MATHEMATICAL KHAH",
	"ARABIC MATHEMATICAL LAM",
	"ARABIC MATHEMATICAL LOOPED AIN",
	"ARABIC MATHEMATICAL LOOPED ALEF",
	"ARABIC MATHEMATICAL LOOPED BEH",
	"ARABIC MATHEMATICAL LOOPED DAD",
	"ARABIC MATHEMATICAL LOOPED DAL",
	"ARABIC MATHEMATICAL LOOPED FEH",
	"ARABIC MATHEMATICAL LOOPED GHAIN",
	"ARABIC MATHEMATICAL LOOPED HAH",
	"ARABIC MATHEMATICAL LOOPED HEH",
	"ARABIC MATHEMATICAL LOOPED JEEM",
	"ARABIC MATHEMATICAL LOOPED KHAH",
	"ARABIC MATHEMATICAL LOOPED LAM",
	"ARABIC MATHEMATICAL LOOPED MEEM",
	"ARABIC MATHEMATICAL LOOPED NOON",
	"ARABIC MATHEMATICAL LOOPED QAF",
	"ARABIC MATHEMATICAL LOOPED REH",
	"ARABIC MATHEMATICAL LOOPED SAD",
	"ARABIC MATHEMATICAL LOOPED SEEN",
	"ARABIC MATHEMATICAL LOOPED SHEEN",
	"ARABIC MATHEMATICAL LOOPED TAH",
	"ARABIC MATHEMATICAL LOOPED TEH",
	"ARABIC MATHEMATICAL LOOPED THAL",
	"ARABIC MATHEMATICAL LOOPED THEH",
	"ARABIC MATHEMATICAL LOOPED WAW",
	"ARABIC MATHEMATICAL LOOPED YEH",
	"ARABIC MATHEMATICAL LOOPED ZAH",
	"ARABIC MATHEMATICAL LOOPED ZAIN",
	"ARABIC MATHEMATICAL MEEM",
	"ARABIC MATHEMATICAL NOON",
	"ARABIC MATHEMATICAL OPERATOR HAH WITH DAL",
	"ARABIC MATHEMATICAL OPERATOR MEEM WITH HAH WITH TATWEEL",
	"ARABIC MATHEMATICAL QAF",
	"ARABIC MATHEMATICAL REH",
	"ARABIC MATHEMATICAL SAD",
	"ARABIC MATHEMATICAL SEEN",
	"ARABIC MATHEMATICAL SHEEN",
	"ARABIC MATHEMATICAL STRETCHED AIN",
	"ARABIC MATHEMATICAL STRETCHED BEH",
	"ARABIC MATHEMATICAL STRETCHED DAD",
	"ARABIC MATHEMATICAL STRETCHED DOTLESS BEH",
	"ARABIC MATHEMATICAL STRETCHED DOTLESS FEH",
	"ARABIC MATHEMATICAL STRETCHED FEH",
	"ARABIC MATHEMATICAL STRETCHED GHAIN",
	"ARABIC MATHEMATICAL STRETCHED HAH",
	"ARABIC MATHEMATICAL STRETCHED HEH",
	"ARABIC MATHEMATICAL STRETCHED JEEM",
	"ARABIC MATHEMATICAL STRETCHED KAF",
	"ARABIC MATHEMATICAL STRETCHED KHAH",
	"ARABIC MATHEMATICAL STRETCHED MEEM",
	"ARABIC MATHEMATICAL STRETCHED NOON",
	"ARABIC MATHEMATICAL STRETCHED QAF",
	"ARABIC MATHEMATICAL STRETCHED SAD",
	"ARABIC MATHEMATICAL STRETCHED SEEN",
	"ARABIC MATHEMATICAL STRETCHED SHEEN",
	"ARABIC MATHEMATICAL STRETCHED TAH",
	"ARABIC MATHEMATICAL STRETCHED TEH",
	"ARABIC MATHEMATICAL STRETCHED THEH",
	"ARABIC MATHEMATICAL STRETCHED YEH",
	"ARABIC MATHEMATICAL STRETCHED ZAH",
	"ARABIC MATHEMATICAL TAH",
	"ARABIC MATHEMATICAL TAILED AIN",
	"ARABIC MATHEMATICAL TAILED DAD",
	"ARABIC MATHEMATICAL TAILED DOTLESS NOON",
	"ARABIC MATHEMATICAL TAILED DOTLESS QAF",
	"ARABIC MATHEMATICAL TAILED GHAIN",
	"ARABIC MATHEMATICAL TAILED HAH",
	"ARABIC MATHEMATICAL TAILED JEEM",
	"ARABIC MATHEMATICAL TAILED KHAH",
	"ARABIC MATHEMATICAL TAILED LAM",
	"ARABIC MATHEMATICAL TAILED NOON",
	"ARABIC MATHEMATICAL TAILED QAF",
	"ARABIC MATHEMATICAL TAILED SAD",
	"ARABIC MATHEMATICAL TAILED SEEN",
	"ARABIC MATHEMATICAL TAILED SHEEN",
	"ARABIC MATHEMATICAL TAILED YEH",
	"ARABIC MATHEMATICAL TEH",
	"ARABIC MATHEMATICAL THAL",
	"ARABIC MATHEMATICAL THEH",
	"ARABIC MATHEMATICAL WAW",
	"ARABIC MATHEMATICAL YEH",
	"ARABIC MATHEMATICAL ZAH",
	"ARABIC MATHEMATICAL ZAIN",
	"ARABIC NUMBER SIGN",
	"ARABIC OPEN DAMMATAN",
	"ARABIC OPEN FATHATAN",
	"ARABIC OPEN KASRATAN",
	"ARABIC PERCENT SIGN",
	"ARABIC PLACE OF SAJDAH",
	"ARABIC POETIC VERSE SIGN",
	"ARABIC QUESTION MARK",
	"ARABIC RAY",
	"ARABIC REVERSED DAMMA",
	"ARABIC RIGHT ARROWHEAD ABOVE",
	"ARABIC RIGHT ARROWHEAD ABOVE WITH DOT",
	"ARABIC RIGHT ARROWHEAD BELOW",
	"ARABIC ROUNDED HIGH STOP WITH FILLED CENTRE",
	"ARABIC SEMICOLON",
	"ARABIC SHADDA",
	"ARABIC SHADDA ISOLATED FORM",
	"ARABIC SHADDA MEDIAL FORM",
	"ARABIC SIGN ALAYHE ASSALLAM",
	"ARABIC SIGN MISRA",
	"ARABIC SIGN RADI ALLAHOU ANHU",
	"ARABIC SIGN RAHMATULLAH ALAYHE",
	"ARABIC SIGN SAFHA",
	"ARABIC SIGN SALLALLAHOU ALAYHE WASSALLAM",
	"ARABIC SIGN SAMVAT",
	"ARABIC SIGN SANAH",
	"ARABIC SIGN SINDHI AMPERSAND",
	"ARABIC SIGN SINDHI POSTPOSITION MEN",
	"ARABIC SIGN TAKHALLUS",
	"ARABIC SMALL DAMMA",
	"ARABIC SMALL FATHA",
	"ARABIC SMALL HIGH DOTLESS HEAD OF KHAH",
	"ARABIC SMALL HIGH JEEM",
	"ARABIC SMALL HIGH LAM ALEF",
	"ARABIC SMALL HIGH LIGATURE ALEF WITH LAM WITH YEH",
	"ARABIC SMALL HIGH LIGATURE QAF WITH LAM WITH ALEF MAKSURA",
	"ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA",
	"ARABIC SMALL HIGH MADDA",
	"ARABIC SMALL HIGH MEEM INITIAL FORM",
	"ARABIC SMALL HIGH MEEM ISOLATED FORM",
	"ARABIC SMALL HIGH NOON",
	"ARABIC SMALL HIGH ROUNDED ZERO",
	"ARABIC SMALL HIGH SEEN",
	"ARABIC SMALL HIGH TAH",
	"ARABIC SMALL HIGH THREE DOTS",
	"ARABIC SMALL HIGH UPRIGHT RECTANGULAR ZERO",
	"ARABIC SMALL HIGH WAW",
	"ARABIC SMALL HIGH YEH",
	"ARABIC SMALL HIGH ZAIN",
	"ARABIC SMALL KASRA",
	"ARABIC SMALL LOW MEEM",
	"ARABIC SMALL LOW SEEN",
	"ARABIC SMALL WAW",
	"ARABIC SMALL YEH",
	"ARABIC START OF RUB EL HIZB",
	"ARABIC SUBSCRIPT ALEF",
	"ARABIC SUKUN",
	"ARABIC SUKUN ISOLATED FORM",
	"ARABIC SUKUN MEDIAL FORM",
	"ARABIC SYMBOL DOT ABOVE",
	"ARABIC SYMBOL DOT BELOW",
	"ARABIC SYMBOL DOUBLE VERTICAL BAR BELOW",
	"ARABIC SYMBOL FOUR DOTS ABOVE",
	"ARABIC SYMBOL FOUR DOTS BELOW",
	"ARABIC SYMBOL RING",
	"ARABIC SYMBOL SMALL TAH ABOVE",
	"ARABIC SYMBOL SMALL TAH BELOW",
	"ARABIC SYMBOL THREE DOTS ABOVE",
	"ARABIC SYMBOL THREE DOTS BELOW",
	"ARABIC SYMBOL THREE DOTS POINTING DOWNWARDS ABOVE",
	"ARABIC SYMBOL THREE DOTS POINTING DOWNWARDS BELOW",
	"ARABIC SYMBOL TWO DOTS ABOVE",
	"ARABIC SYMBOL TWO DOTS BELOW",
	"ARABIC SYMBOL TWO DOTS VERTICALLY ABOVE",
	"ARABIC SYMBOL TWO DOTS VERTICALLY BELOW",
	"ARABIC TAIL FRAGMENT",
	"ARABIC TATWEEL",
	"ARABIC TATWEEL WITH FATHATAN ABOVE",
	"ARABIC THOUSANDS SEPARATOR",
	"ARABIC TONE LOOP ABOVE",
	"ARABIC TONE LOOP BELOW",
	"ARABIC TONE ONE DOT ABOVE",
	"ARABIC TONE ONE DOT BELOW",
	"ARABIC TONE TWO DOTS ABOVE",
	"ARABIC TONE TWO DOTS BELOW",
	"ARABIC TRIPLE DOT PUNCTUATION MARK",
	"ARABIC VOWEL SIGN DOT BELOW",
	"ARABIC VOWEL SIGN INVERTED SMALL V ABOVE",
	"ARABIC VOWEL SIGN SMALL V ABOVE",
	"ARABIC WAVY HAMZA BELOW",
	"ARABIC ZWARAKAY",
	"ARABIC-INDIC CUBE ROOT",
	"ARABIC-INDIC DIGIT EIGHT",
	"ARABIC-INDIC DIGIT FIVE",
	"ARABIC-INDIC DIGIT FOUR",
	"ARABIC-INDIC DIGIT NINE",
	"ARABIC-INDIC DIGIT ONE",
	"ARABIC-INDIC DIGIT SEVEN",
	"ARABIC-INDIC DIGIT SIX",
	"ARABIC-INDIC DIGIT THREE",
	"ARABIC-INDIC DIGIT TWO",
	"ARABIC-INDIC DIGIT ZERO",
	"ARABIC-INDIC FOURTH ROOT",
	"ARABIC-INDIC PER MILLE SIGN",
	"ARABIC-INDIC PER TEN THOUSAND SIGN",
	"ARC",
	"ARIES",
	"ARMENIAN ABBREVIATION MARK",
	"ARMENIAN APOSTROPHE",
	"ARMENIAN CAPITAL LETTER AYB",
	"ARMENIAN CAPITAL LETTER BEN",
	"ARMENIAN CAPITAL LETTER CA",
	"ARMENIAN CAPITAL LETTER CHA",
	"ARMENIAN CAPITAL LETTER CHEH",
	"ARMENIAN CAPITAL LETTER CO",
	"ARMENIAN CAPITAL LETTER DA",
	"ARMENIAN CAPITAL LETTER ECH",
	"ARMENIAN CAPITAL LETTER EH",
	"ARMENIAN CAPITAL LETTER ET",
	"ARMENIAN CAPITAL LETTER FEH",
	"ARMENIAN CAPITAL LETTER GHAD",
	"ARMENIAN CAPITAL LETTER GIM",
	"ARMENIAN CAPITAL LETTER HO",
	"ARMENIAN CAPITAL LETTER INI",
	"ARMENIAN CAPITAL LETTER JA",
	"ARMENIAN CAPITAL LETTER JHEH",
	"ARMENIAN CAPITAL LETTER KEH",
	"ARMENIAN CAPITAL LETTER KEN",
	"ARMENIAN CAPITAL LETTER LIWN",
	"ARMENIAN CAPITAL LETTER MEN",
	"ARMENIAN CAPITAL LETTER NOW",
	"ARMENIAN CAPITAL LETTER OH",
	"ARMENIAN CAPITAL LETTER PEH",
	"ARMENIAN CAPITAL LETTER PIWR",
	"ARMENIAN CAPITAL LETTER RA",
	"ARMENIAN CAPITAL LETTER REH",
	"ARMENIAN CAPITAL LETTER SEH",
	"ARMENIAN CAPITAL LETTER SHA",
	"ARMENIAN CAPITAL LETTER TIWN",
	"ARMENIAN CAPITAL LETTER TO",
	"ARMENIAN CAPITAL LETTER VEW",
	"ARMENIAN CAPITAL LETTER VO",
	"ARMENIAN CAPITAL LETTER XEH",
	"ARMENIAN CAPITAL LETTER YI",
	"ARMENIAN CAPITAL LETTER YIWN",
	"ARMENIAN CAPITAL LETTER ZA",
	"ARMENIAN CAPITAL LETTER ZHE",
	"ARMENIAN COMMA",
	"ARMENIAN DRAM SIGN",
	"ARMENIAN EMPHASIS MARK",
	"ARMENIAN EXCLAMATION MARK",
	"ARMENIAN FULL STOP",
	"ARMENIAN HYPHEN",
	"ARMENIAN MODIFIER LETTER LEFT HALF RING",
	"ARMENIAN QUESTION MARK",
	"ARMENIAN SMALL LETTER AYB",
	"ARMENIAN SMALL LETTER BEN",
	"ARMENIAN SMALL LETTER CA",
	"ARMENIAN SMALL LETTER CHA",
	"ARMENIAN SMALL LETTER CHEH",
	"ARMENIAN SMALL LETTER CO",
	"ARMENIAN SMALL LETTER DA",
	"ARMENIAN SMALL LETTER ECH",
	"ARMENIAN SMALL LETTER EH",
	"ARMENIAN SMALL LETTER ET",
	"ARMENIAN SMALL LETTER FEH",
	"ARMENIAN SMALL LETTER GHAD",
	"ARMENIAN SMALL LETTER GIM",
	"ARMENIAN SMALL LETTER HO",
	"ARMENIAN SMALL LETTER INI",
	"ARMENIAN SMALL LETTER JA",
	"ARMENIAN SMALL LETTER JHEH",
	"ARMENIAN SMALL LETTER KEH",
	"ARMENIAN SMALL LETTER KEN",
	"ARMENIAN SMALL LETTER LIWN",
	"ARMENIAN SMALL LETTER MEN",
	"ARMENIAN SMALL LETTER NOW",
	"ARMENIAN SMALL LETTER OH",
	"ARMENIAN SMALL LETTER PEH",
	"ARMENIAN SMALL LETTER PIWR",
	"ARMENIAN SMALL LETTER RA",
	"ARMENIAN SMALL LETTER REH",
	"ARMENIAN SMALL LETTER SEH",
	"ARMENIAN SMALL LETTER SHA",
	"ARMENIAN SMALL LETTER TIWN",
	"ARMENIAN SMALL LETTER TO",
	"ARMENIAN SMALL LETTER VEW",
	"ARMENIAN SMALL LETTER VO",
	"ARMENIAN SMALL LETTER XEH",
	"ARMENIAN SMALL LETTER YI",
	"ARMENIAN SMALL LETTER YIWN",
	"ARMENIAN SMALL LETTER ZA",
	"ARMENIAN SMALL LETTER ZHE",
	"ARMENIAN SMALL LIGATURE ECH YIWN",
	"ARMENIAN SMALL LIGATURE MEN ECH",
	"ARMENIAN SMALL LIGATURE MEN INI",
	"ARMENIAN SMALL LIGATURE MEN NOW",
	"ARMENIAN SMALL LIGATURE MEN XEH",
	"ARMENIAN SMALL LIGATURE VEW NOW",
	"ARROW POINTING DOWNWARDS THEN CURVING LEFTWARDS",
	"ARROW POINTING DOWNWARDS THEN CURVING RIGHTWARDS",
	"ARROW POINTING RIGHTWARDS THEN CURVING DOWNWARDS",
	"ARROW POINTING RIGHTWARDS THEN CURVING UPWARDS",
	"ARTICULATED LORRY",
	"ARTIST PALETTE",
	"ASCENDING NODE",
	"ASSERTION",
	"ASTERISK",
	"ASTERISK OPERATOR",
	"ASTERISM",
	"ASTONISHED FACE",
	"ASTRONOMICAL SYMBOL FOR URANUS",
	"ASYMPTOTICALLY EQUAL TO",
	"ATHLETIC SHOE",
	"ATOM SYMBOL",
	"AUBERGINE",
	"AUSTRAL SIGN",
	"AUTOMATED TELLER MACHINE",
	"AUTOMOBILE",
	"AVESTAN ABBREVIATION MARK",
	"AVESTAN LETTER A",
	"AVESTAN LETTER AA",
	"AVESTAN LETTER AAN",
	"AVESTAN LETTER AAO",
	"AVESTAN LETTER AE",
	"AVESTAN LETTER AEE",
	"AVESTAN LETTER AN",
	"AVESTAN LETTER AO",
	"AVESTAN LETTER BE",
	"AVESTAN LETTER BHE",
	"AVESTAN LETTER CE",
	"AVESTAN LETTER DE",
	"AVESTAN LETTER DHE",
	"AVESTAN LETTER E",
	"AVESTAN LETTER EE",
	"AVESTAN LETTER FE",
	"AVESTAN LETTER GE",
	"AVESTAN LETTER GGE",
	"AVESTAN LETTER GHE",
	"AVESTAN LETTER HE",
	"AVESTAN LETTER HME",
	"AVESTAN LETTER I",
	"AVESTAN LETTER II",
	"AVESTAN LETTER JE",
	"AVESTAN LETTER KE",
	"AVESTAN LETTER LE",
	"AVESTAN LETTER ME",
	"AVESTAN LETTER NE",
	"AVESTAN LETTER NGE",
	"AVESTAN LETTER NGVE",
	"AVESTAN LETTER NGYE",
	"AVESTAN LETTER NNE",
	"AVESTAN LETTER NYE",
	"AVESTAN LETTER O",
	"AVESTAN LETTER OO",
	"AVESTAN LETTER PE",
	"AVESTAN LETTER RE",
	"AVESTAN LETTER SE",
	"AVESTAN LETTER SHE",
	"AVESTAN LETTER SHYE",
	"AVESTAN LETTER SSHE",
	"AVESTAN LETTER TE",
	"AVESTAN LETTER THE",
	"AVESTAN LETTER TTE",
	"AVESTAN LETTER U",
	"AVESTAN LETTER UU",
	"AVESTAN LETTER VE",
	"AVESTAN LETTER XE",
	"AVESTAN LETTER XVE",
	"AVESTAN LETTER XYE",
	"AVESTAN LETTER YE",
	"AVESTAN LETTER YYE",
	"AVESTAN LETTER ZE",
	"AVESTAN LETTER ZHE",
	"BABY",
	"BABY ANGEL",
	"BABY BOTTLE",
	"BABY CHICK",
	"BABY SYMBOL",
	"BACK WITH LEFTWARDS ARROW ABOVE",
	"BACK-TILTED SHADOWED WHITE RIGHTWARDS ARROW",
	"BACTRIAN CAMEL",
	"BAGGAGE CLAIM",
	"BALINESE ADEG ADEG",
	"BALINESE CARIK PAMUNGKAH",
	"BALINESE CARIK PAREREN",
	"BALINESE CARIK SIKI",
	"BALINESE DIGIT EIGHT",
	"BALINESE DIGIT FIVE",
	"BALINESE DIGIT FOUR",
	"BALINESE DIGIT NINE",
	"BALINESE DIGIT ONE",
	"BALINESE DIGIT SEVEN",
	"BALINESE DIGIT SIX",
	"BALINESE DIGIT THREE",
	"BALINESE DIGIT TWO",
	"BALINESE DIGIT ZERO",
	"BALINESE LETTER AIKARA",
	"BALINESE LETTER AKARA",
	"BALINESE LETTER AKARA TEDUNG",
	"BALINESE LETTER ASYURA SASAK",
	"BALINESE LETTER BA",
	"BALINESE LETTER BA KEMBANG",
	"BALINESE LETTER CA",
	"BALINESE LETTER CA LACA",
	"BALINESE LETTER DA",
	"BALINESE LETTER DA MADU",
	"BALINESE LETTER DA MURDA ALPAPRANA",
	"BALINESE LETTER DA MURDA MAHAPRANA",
	"BALINESE LETTER EF SASAK",
	"BALINESE LETTER EKARA",
	"BALINESE LETTER GA",
	"BALINESE LETTER GA GORA",
	"BALINESE LETTER HA",
	"BALINESE LETTER IKARA",
	"BALINESE LETTER IKARA TEDUNG",
	"BALINESE LETTER JA",
	"BALINESE LETTER JA JERA",
	"BALINESE LETTER KA",
	"BALINESE LETTER KA MAHAPRANA",
	"BALINESE LETTER KAF SASAK",
	"BALINESE LETTER KHOT SASAK",
	"BALINESE LETTER LA",
	"BALINESE LETTER LA LENGA",
	"BALINESE LETTER LA LENGA TEDUNG",
	"BALINESE LETTER MA",
	"BALINESE LETTER NA",
	"BALINESE LETTER NA RAMBAT",
	"BALINESE LETTER NGA",
	"BALINESE LETTER NYA",
	"BALINESE LETTER OKARA",
	"BALINESE LETTER OKARA TEDUNG",
	"BALINESE LETTER PA",
	"BALINESE LETTER PA KAPAL",
	"BALINESE LETTER RA",
	"BALINESE LETTER RA REPA",
	"BALINESE LETTER RA REPA TEDUNG",
	"BALINESE LETTER SA",
	"BALINESE LETTER SA SAGA",
	"BALINESE LETTER SA SAPA",
	"BALINESE LETTER TA",
	"BALINESE LETTER TA LATIK",
	"BALINESE LETTER TA MURDA MAHAPRANA",
	"BALINESE LETTER TA TAWA",
	"BALINESE LETTER TZIR SASAK",
	"BALINESE LETTER UKARA",
	"BALINESE LETTER UKARA TEDUNG",
	"BALINESE LETTER VE SASAK",
	"BALINESE LETTER WA",
	"BALINESE LETTER YA",
	"BALINESE LETTER ZAL SASAK",
	"BALINESE MUSICAL SYMBOL COMBINING BENDE",
	"BALINESE MUSICAL SYMBOL COMBINING ENDEP",
	"BALINESE MUSICAL SYMBOL COMBINING GONG",
	"BALINESE MUSICAL SYMBOL COMBINING JEGOGAN",
	"BALINESE MUSICAL SYMBOL COMBINING KEMPLI",
	"BALINESE MUSICAL SYMBOL COMBINING KEMPLI WITH JEGOGAN",
	"BALINESE MUSICAL SYMBOL COMBINING KEMPUL",
	"BALINESE MUSICAL SYMBOL COMBINING KEMPUL WITH JEGOGAN",
	"BALINESE MUSICAL SYMBOL COMBINING TEGEH",
	"BALINESE MUSICAL SYMBOL DAENG",
	"BALINESE MUSICAL SYMBOL DAING",
	"BALINESE MUSICAL SYMBOL DANG",
	"BALINESE MUSICAL SYMBOL DANG GEDE",
	"BALINESE MUSICAL SYMBOL DANG SURANG",
	"BALINESE MUSICAL SYMBOL DENG",
	"BALINESE MUSICAL SYMBOL DEUNG",
	"BALINESE MUSICAL SYMBOL DING",
	"BALINESE MUSICAL SYMBOL DONG",
	"BALINESE MUSICAL SYMBOL DUNG",
	"BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLAK",
	"BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLUK",
	"BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PANG",
	"BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PING",
	"BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PUNG",
	"BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TAK",
	"BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TUK",
	"BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DAG",
	"BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DUG",
	"BALINESE PAMADA",
	"BALINESE PAMENENG",
	"BALINESE PANTI",
	"BALINESE SIGN BISAH",
	"BALINESE SIGN CECEK",
	"BALINESE SIGN REREKAN",
	"BALINESE SIGN SURANG",
	"BALINESE SIGN ULU CANDRA",
	"BALINESE SIGN ULU RICEM",
	"BALINESE VOWEL SIGN LA LENGA",
	"BALINESE VOWEL SIGN LA LENGA TEDUNG",
	"BALINESE VOWEL SIGN PEPET",
	"BALINESE VOWEL SIGN PEPET TEDUNG",
	"BALINESE VOWEL SIGN RA REPA",
	"BALINESE VOWEL SIGN RA REPA TEDUNG",
	"BALINESE VOWEL SIGN SUKU",
	"BALINESE VOWEL SIGN SUKU ILUT",
	"BALINESE VOWEL SIGN TALING",
	"BALINESE VOWEL SIGN TALING REPA",
	"BALINESE VOWEL SIGN TALING REPA TEDUNG",
	"BALINESE VOWEL SIGN TALING TEDUNG",
	"BALINESE VOWEL SIGN TEDUNG",
	"BALINESE VOWEL SIGN ULU",
	"BALINESE VOWEL SIGN ULU SARI",
	"BALINESE WINDU",
	"BALLOON",
	"BALLOON-SPOKED ASTERISK",
	"BALLOT BOX",
	"BALLOT BOX WITH CHECK",
	"BALLOT BOX WITH X",
	"BALLOT X",
	"BAMUM COLON",
	"BAMUM COMBINING MARK KOQNDON",
	"BAMUM COMBINING MARK TUKWENTIS",
	"BAMUM COMMA",
	"BAMUM FULL STOP",
	"BAMUM LETTER A",
	"BAMUM LETTER EE",
	"BAMUM LETTER FAAMAE",
	"BAMUM LETTER FEE",
	"BAMUM LETTER FOM",
	"BAMUM LETTER FU",
	"BAMUM LETTER I",
	"BAMUM LETTER KA",
	"BAMUM LETTER KEN",
	"BAMUM LETTER KET",
	"BAMUM LETTER KEUX",
	"BAMUM LETTER KI",
	"BAMUM LETTER KO",
	"BAMUM LETTER KOGHOM",
	"BAMUM LETTER KOVUU",
	"BAMUM LETTER KPA",
	"BAMUM LETTER KU",
	"BAMUM LETTER KYEE",
	"BAMUM LETTER LA",
	"BAMUM LETTER LEEEE",
	"BAMUM LETTER LI",
	"BAMUM LETTER LOQ",
	"BAMUM LETTER LU",
	"BAMUM LETTER M",
	"BAMUM LETTER MA",
	"BAMUM LETTER MBAA",
	"BAMUM LETTER MBEN",
	"BAMUM LETTER MEEEE",
	"BAMUM LETTER MEN",
	"BAMUM LETTER MI",
	"BAMUM LETTER MO",
	"BAMUM LETTER MU",
	"BAMUM LETTER NA",
	"BAMUM LETTER NDAA",
	"BAMUM LETTER NGA",
	"BAMUM LETTER NGGA",
	"BAMUM LETTER NGKWAEN",
	"BAMUM LETTER NI",
	"BAMUM LETTER NJAEM",
	"BAMUM LETTER NJEE",
	"BAMUM LETTER NJUAE",
	"BAMUM LETTER NSHA",
	"BAMUM LETTER NTEE",
	"BAMUM LETTER NTUU",
	"BAMUM LETTER NU",
	"BAMUM LETTER NUAE",
	"BAMUM LETTER NYI",
	"BAMUM LETTER O",
	"BAMUM LETTER PA",
	"BAMUM LETTER PEE",
	"BAMUM LETTER PEUX",
	"BAMUM LETTER PHASE-A FIRI",
	"BAMUM LETTER PHASE-A GBIEE FON",
	"BAMUM LETTER PHASE-A GHEUAEGHEUAE",
	"BAMUM LETTER PHASE-A GHEUAERAE",
	"BAMUM LETTER PHASE-A KAFA",
	"BAMUM LETTER PHASE-A KAQ",
	"BAMUM LETTER PHASE-A KET",
	"BAMUM LETTER PHASE-A KEUKEUTNDA",
	"BAMUM LETTER PHASE-A KPOQ",
	"BAMUM LETTER PHASE-A KUOQ",
	"BAMUM LETTER PHASE-A LAPAQ",
	"BAMUM LETTER PHASE-A LET KUT",
	"BAMUM LETTER PHASE-A LOMMAE",
	"BAMUM LETTER PHASE-A LU",
	"BAMUM LETTER PHASE-A LUAEP",
	"BAMUM LETTER PHASE-A MAEKEUP",
	"BAMUM LETTER PHASE-A MAEM",
	"BAMUM LETTER PHASE-A MAEMBGBIEE",
	"BAMUM LETTER PHASE-A MAEMKPEN",
	"BAMUM LETTER PHASE-A MAEMVEUX",
	"BAMUM LETTER PHASE-A MAENYI",
	"BAMUM LETTER PHASE-A MAESI",
	"BAMUM LETTER PHASE-A MANSUAE",
	"BAMUM LETTER PHASE-A MAP PIEET",
	"BAMUM LETTER PHASE-A MBANYI",
	"BAMUM LETTER PHASE-A MBAQ",
	"BAMUM LETTER PHASE-A MEUNJOMNDEUQ",
	"BAMUM LETTER PHASE-A MGBASA",
	"BAMUM LETTER PHASE-A MON NGGEUAET",
	"BAMUM LETTER PHASE-A MOOMEUT",
	"BAMUM LETTER PHASE-A MOOMPUQ",
	"BAMUM LETTER PHASE-A MVEUAENGAM",
	"BAMUM LETTER PHASE-A NAA MFON",
	"BAMUM LETTER PHASE-A NAQ",
	"BAMUM LETTER PHASE-A NDA LEERAEWA",
	"BAMUM LETTER PHASE-A NDAANGGEUAET",
	"BAMUM LETTER PHASE-A NEN",
	"BAMUM LETTER PHASE-A NGANGU",
	"BAMUM LETTER PHASE-A NGGEN",
	"BAMUM LETTER PHASE-A NGKUE MFON",
	"BAMUM LETTER PHASE-A NGKUENZEUM",
	"BAMUM LETTER PHASE-A NIKA",
	"BAMUM LETTER PHASE-A NJAM",
	"BAMUM LETTER PHASE-A NKAARAE",
	"BAMUM LETTER PHASE-A NKINDI",
	"BAMUM LETTER PHASE-A NSHA",
	"BAMUM LETTER PHASE-A NSHIEE",
	"BAMUM LETTER PHASE-A NTAP",
	"BAMUM LETTER PHASE-A NTAP MFAA",
	"BAMUM LETTER PHASE-A NTAP NTAA",
	"BAMUM LETTER PHASE-A NTOQPEN",
	"BAMUM LETTER PHASE-A NYET",
	"BAMUM LETTER PHASE-A NYI",
	"BAMUM LETTER PHASE-A NYIT MONGKEUAEQ",
	"BAMUM LETTER PHASE-A NZA MFON",
	"BAMUM LETTER PHASE-A NZUN MEUT",
	"BAMUM LETTER PHASE-A PA LEERAEWA",
	"BAMUM LETTER PHASE-A PAAM",
	"BAMUM LETTER PHASE-A PAARAE",
	"BAMUM LETTER PHASE-A PAMSHAE",
	"BAMUM LETTER PHASE-A PASHAE",
	"BAMUM LETTER PHASE-A PET",
	"BAMUM LETTER PHASE-A PON MFON PIPAEMBA",
	"BAMUM LETTER PHASE-A PON MFON PIPAEMGBIEE",
	"BAMUM LETTER PHASE-A PON PA NJI PIPAEMBA",
	"BAMUM LETTER PHASE-A PON PA NJI PIPAEMGBIEE",
	"BAMUM LETTER PHASE-A PUP",
	"BAMUM LETTER PHASE-A ROM",
	"BAMUM LETTER PHASE-A SEUNYAM",
	"BAMUM LETTER PHASE-A SHINDA PA NJI",
	"BAMUM LETTER PHASE-A SHIRAE",
	"BAMUM LETTER PHASE-A SHOQ NSHUT YUM",
	"BAMUM LETTER PHASE-A SHUENSHUET",
	"BAMUM LETTER PHASE-A SHUM",
	"BAMUM LETTER PHASE-A SISA",
	"BAMUM LETTER PHASE-A SONJAM",
	"BAMUM LETTER PHASE-A SOQ",
	"BAMUM LETTER PHASE-A SOT",
	"BAMUM LETTER PHASE-A SUU",
	"BAMUM LETTER PHASE-A TEUAEN",
	"BAMUM LETTER PHASE-A TEUTEUWEN",
	"BAMUM LETTER PHASE-A TITA MFON",
	"BAMUM LETTER PHASE-A TU MAEMBA",
	"BAMUM LETTER PHASE-A TUAEP",
	"BAMUM LETTER PHASE-A U YUQ NAE",
	"BAMUM LETTER PHASE-A UNKNOWN",
	"BAMUM LETTER PHASE-A VEE",
	"BAMUM LETTER PHASE-B FEE",
	"BAMUM LETTER PHASE-B FEUX",
	"BAMUM LETTER PHASE-B GHEUGHEN",
	"BAMUM LETTER PHASE-B GHEUGHEUAEM",
	"BAMUM LETTER PHASE-B KAM",
	"BAMUM LETTER PHASE-B KEUAEM",
	"BAMUM LETTER PHASE-B KEUPUQ",
	"BAMUM LETTER PHASE-B KEUYEUX",
	"BAMUM LETTER PHASE-B KIEEM",
	"BAMUM LETTER PHASE-B KIQ",
	"BAMUM LETTER PHASE-B LAANAE",
	"BAMUM LETTER PHASE-B LAM NSHUT NYAM",
	"BAMUM LETTER PHASE-B LET",
	"BAMUM LETTER PHASE-B LOM NTEUM",
	"BAMUM LETTER PHASE-B MA",
	"BAMUM LETTER PHASE-B MA NJEUAENA",
	"BAMUM LETTER PHASE-B MA NJUQA",
	"BAMUM LETTER PHASE-B MBA MAELEE",
	"BAMUM LETTER PHASE-B MBAARAE",
	"BAMUM LETTER PHASE-B MBEURI",
	"BAMUM LETTER PHASE-B MBIT MBAAKET",
	"BAMUM LETTER PHASE-B MBUOQ",
	"BAMUM LETTER PHASE-B MEUQ",
	"BAMUM LETTER PHASE-B MEUT NGGEET",
	"BAMUM LETTER PHASE-B MFIYAQ",
	"BAMUM LETTER PHASE-B MFON TEUAEQ",
	"BAMUM LETTER PHASE-B MONTIEEN",
	"BAMUM LETTER PHASE-B NDU NJAA",
	"BAMUM LETTER PHASE-B NGGAAM",
	"BAMUM LETTER PHASE-B NGGEU MBU",
	"BAMUM LETTER PHASE-B NGGUOQ",
	"BAMUM LETTER PHASE-B NGGUOQ LARGE",
	"BAMUM LETTER PHASE-B NGKINDI MVOP",
	"BAMUM LETTER PHASE-B NGOM",
	"BAMUM LETTER PHASE-B NSEN",
	"BAMUM LETTER PHASE-B NSHUET",
	"BAMUM LETTER PHASE-B NTIEE SHEUOQ",
	"BAMUM LETTER PHASE-B NYAEMAE",
	"BAMUM LETTER PHASE-B NYI NTEUM",
	"BAMUM LETTER PHASE-B PARUM",
	"BAMUM LETTER PHASE-B PEESHI",
	"BAMUM LETTER PHASE-B PIT",
	"BAMUM LETTER PHASE-B PUNGAAM",
	"BAMUM LETTER PHASE-B SAKEUAE",
	"BAMUM LETTER PHASE-B SET TU",
	"BAMUM LETTER PHASE-B SHET NJAQ",
	"BAMUM LETTER PHASE-B SHEUAEQTU",
	"BAMUM LETTER PHASE-B SIEE",
	"BAMUM LETTER PHASE-B SUE",
	"BAMUM LETTER PHASE-B TAAM",
	"BAMUM LETTER PHASE-B TU MAEMGBIEE",
	"BAMUM LETTER PHASE-B TU NSIEE",
	"BAMUM LETTER PHASE-B VEUM",
	"BAMUM LETTER PHASE-B WUAET",
	"BAMUM LETTER PHASE-B YAFU LEERAEWA",
	"BAMUM LETTER PHASE-B YEURAE",
	"BAMUM LETTER PHASE-C BUNG",
	"BAMUM LETTER PHASE-C FUE",
	"BAMUM LETTER PHASE-C GBAYI",
	"BAMUM LETTER PHASE-C GHAP",
	"BAMUM LETTER PHASE-C GHARAE",
	"BAMUM LETTER PHASE-C KAA",
	"BAMUM LETTER PHASE-C KEN FATIGUE",
	"BAMUM LETTER PHASE-C KEN LAW",
	"BAMUM LETTER PHASE-C KET",
	"BAMUM LETTER PHASE-C KEUKAQ",
	"BAMUM LETTER PHASE-C KEUM",
	"BAMUM LETTER PHASE-C KEUSEUX",
	"BAMUM LETTER PHASE-C KEUSHEUAEP",
	"BAMUM LETTER PHASE-C KPARAQ",
	"BAMUM LETTER PHASE-C KUOP NKAARAE",
	"BAMUM LETTER PHASE-C KUT",
	"BAMUM LETTER PHASE-C LAM",
	"BAMUM LETTER PHASE-C LAP",
	"BAMUM LETTER PHASE-C LIQ",
	"BAMUM LETTER PHASE-C LU",
	"BAMUM LETTER PHASE-C MA KEUAERI",
	"BAMUM LETTER PHASE-C MA NSIEE",
	"BAMUM LETTER PHASE-C MAEMBA",
	"BAMUM LETTER PHASE-C MAESI",
	"BAMUM LETTER PHASE-C MBAA CABBAGE-TREE",
	"BAMUM LETTER PHASE-C MBAA PICKET",
	"BAMUM LETTER PHASE-C MBANYI",
	"BAMUM LETTER PHASE-C MBEEKEET",
	"BAMUM LETTER PHASE-C MBERAE",
	"BAMUM LETTER PHASE-C MBEUM",
	"BAMUM LETTER PHASE-C MBEUX",
	"BAMUM LETTER PHASE-C MBI",
	"BAMUM LETTER PHASE-C MBIRIEEN",
	"BAMUM LETTER PHASE-C MBIT",
	"BAMUM LETTER PHASE-C MBUAEM",
	"BAMUM LETTER PHASE-C MBUE",
	"BAMUM LETTER PHASE-C MGBASAQ",
	"BAMUM LETTER PHASE-C MIEE",
	"BAMUM LETTER PHASE-C MUAE",
	"BAMUM LETTER PHASE-C NANSANAQ",
	"BAMUM LETTER PHASE-C NAQ",
	"BAMUM LETTER PHASE-C NDAM",
	"BAMUM LETTER PHASE-C NDAP",
	"BAMUM LETTER PHASE-C NDEUAEREE",
	"BAMUM LETTER PHASE-C NDEUT",
	"BAMUM LETTER PHASE-C NDIDA",
	"BAMUM LETTER PHASE-C NDOMBU",
	"BAMUM LETTER PHASE-C NGAQ",
	"BAMUM LETTER PHASE-C NGGEN",
	"BAMUM LETTER PHASE-C NGGU",
	"BAMUM LETTER PHASE-C NGGUAEN NYAM",
	"BAMUM LETTER PHASE-C NGGUEET",
	"BAMUM LETTER PHASE-C NGGUM",
	"BAMUM LETTER PHASE-C NGGUON",
	"BAMUM LETTER PHASE-C NGKAQ",
	"BAMUM LETTER PHASE-C NGKUE MAEMBA",
	"BAMUM LETTER PHASE-C NGOM",
	"BAMUM LETTER PHASE-C NJAEM",
	"BAMUM LETTER PHASE-C NJAM",
	"BAMUM LETTER PHASE-C NJEEEE",
	"BAMUM LETTER PHASE-C NJEUX",
	"BAMUM LETTER PHASE-C NJUEQ",
	"BAMUM LETTER PHASE-C NSA",
	"BAMUM LETTER PHASE-C NSEUAEN",
	"BAMUM LETTER PHASE-C NSHAQ",
	"BAMUM LETTER PHASE-C NSOM",
	"BAMUM LETTER PHASE-C NSUN",
	"BAMUM LETTER PHASE-C NSUOT NGOM",
	"BAMUM LETTER PHASE-C NTAA",
	"BAMUM LETTER PHASE-C NTEN",
	"BAMUM LETTER PHASE-C NTEUNGBA",
	"BAMUM LETTER PHASE-C NTU MBIT",
	"BAMUM LETTER PHASE-C NYIR MKPARAQ MEUN",
	"BAMUM LETTER PHASE-C NZA",
	"BAMUM LETTER PHASE-C NZEUM",
	"BAMUM LETTER PHASE-C PEN",
	"BAMUM LETTER PHASE-C PIN",
	"BAMUM LETTER PHASE-C PIRIEEN",
	"BAMUM LETTER PHASE-C RU",
	"BAMUM LETTER PHASE-C SETFON",
	"BAMUM LETTER PHASE-C SEUX",
	"BAMUM LETTER PHASE-C SHIQ",
	"BAMUM LETTER PHASE-C SHUEQ",
	"BAMUM LETTER PHASE-C SUAET",
	"BAMUM LETTER PHASE-C TAASHAE",
	"BAMUM LETTER PHASE-C TET",
	"BAMUM LETTER PHASE-C TEUTEUX",
	"BAMUM LETTER PHASE-C TITA YUE",
	"BAMUM LETTER PHASE-C TITUAEP",
	"BAMUM LETTER PHASE-C VEUAEPEN",
	"BAMUM LETTER PHASE-C VEUX",
	"BAMUM LETTER PHASE-C WANGKUOQ",
	"BAMUM LETTER PHASE-C WUP",
	"BAMUM LETTER PHASE-C YAA",
	"BAMUM LETTER PHASE-C YEUQ",
	"BAMUM LETTER PHASE-C YU MUOMAE",
	"BAMUM LETTER PHASE-C YUM",
	"BAMUM LETTER PHASE-C YUWOQ",
	"BAMUM LETTER PHASE-D FAA",
	"BAMUM LETTER PHASE-D FEUFEUAET",
	"BAMUM LETTER PHASE-D GHAA",
	"BAMUM LETTER PHASE-D GHEUAE",
	"BAMUM LETTER PHASE-D KET",
	"BAMUM LETTER PHASE-D KEUAETMEUN",
	"BAMUM LETTER PHASE-D KEUM",
	"BAMUM LETTER PHASE-D KEUOT MBUAE",
	"BAMUM LETTER PHASE-D KEUP",
	"BAMUM LETTER PHASE-D KU",
	"BAMUM LETTER PHASE-D KUN",
	"BAMUM LETTER PHASE-D KUOM",
	"BAMUM LETTER PHASE-D KUQ",
	"BAMUM LETTER PHASE-D KWAET",
	"BAMUM LETTER PHASE-D KYEE",
	"BAMUM LETTER PHASE-D LEEEE",
	"BAMUM LETTER PHASE-D LET",
	"BAMUM LETTER PHASE-D LEUAEP",
	"BAMUM LETTER PHASE-D LEUM",
	"BAMUM LETTER PHASE-D LIEE",
	"BAMUM LETTER PHASE-D LOQ",
	"BAMUM LETTER PHASE-D LUM",
	"BAMUM LETTER PHASE-D M",
	"BAMUM LETTER PHASE-D MAENJET",
	"BAMUM LETTER PHASE-D MALEERI",
	"BAMUM LETTER PHASE-D MBAA",
	"BAMUM LETTER PHASE-D MBAA SEVEN",
	"BAMUM LETTER PHASE-D MBUO",
	"BAMUM LETTER PHASE-D MEEEE",
	"BAMUM LETTER PHASE-D MEUN",
	"BAMUM LETTER PHASE-D MEUT",
	"BAMUM LETTER PHASE-D MFEUAE",
	"BAMUM LETTER PHASE-D MFEUT",
	"BAMUM LETTER PHASE-D MFIEE",
	"BAMUM LETTER PHASE-D MFO",
	"BAMUM LETTER PHASE-D MFON",
	"BAMUM LETTER PHASE-D MGBEUN",
	"BAMUM LETTER PHASE-D MGBIEE",
	"BAMUM LETTER PHASE-D MGBOFUM",
	"BAMUM LETTER PHASE-D MONI",
	"BAMUM LETTER PHASE-D MU",
	"BAMUM LETTER PHASE-D MVOP",
	"BAMUM LETTER PHASE-D NDAM",
	"BAMUM LETTER PHASE-D NDEE",
	"BAMUM LETTER PHASE-D NDEUX",
	"BAMUM LETTER PHASE-D NDON",
	"BAMUM LETTER PHASE-D NGGAAM",
	"BAMUM LETTER PHASE-D NGGAAMAE",
	"BAMUM LETTER PHASE-D NGGAP",
	"BAMUM LETTER PHASE-D NGGEUX",
	"BAMUM LETTER PHASE-D NGGUOM",
	"BAMUM LETTER PHASE-D NGGWAEN",
	"BAMUM LETTER PHASE-D NGKAP",
	"BAMUM LETTER PHASE-D NGKEUAEQ",
	"BAMUM LETTER PHASE-D NGKEURI",
	"BAMUM LETTER PHASE-D NGKIEE",
	"BAMUM LETTER PHASE-D NGKUN",
	"BAMUM LETTER PHASE-D NGKYEE",
	"BAMUM LETTER PHASE-D NI",
	"BAMUM LETTER PHASE-D NJAP",
	"BAMUM LETTER PHASE-D NJEUAEM",
	"BAMUM LETTER PHASE-D NJEUT",
	"BAMUM LETTER PHASE-D NJI",
	"BAMUM LETTER PHASE-D NJIEE",
	"BAMUM LETTER PHASE-D NJUEQ",
	"BAMUM LETTER PHASE-D NSHEE",
	"BAMUM LETTER PHASE-D NSHUT",
	"BAMUM LETTER PHASE-D NSIEEP",
	"BAMUM LETTER PHASE-D NSIEET",
	"BAMUM LETTER PHASE-D NSUM",
	"BAMUM LETTER PHASE-D NTEE",
	"BAMUM LETTER PHASE-D NTEUM",
	"BAMUM LETTER PHASE-D NTUU",
	"BAMUM LETTER PHASE-D NU",
	"BAMUM LETTER PHASE-D NYAM",
	"BAMUM LETTER PHASE-D NYET",
	"BAMUM LETTER PHASE-D NYI",
	"BAMUM LETTER PHASE-D NYUE",
	"BAMUM LETTER PHASE-D PAP",
	"BAMUM LETTER PHASE-D PEE",
	"BAMUM LETTER PHASE-D PEUTAE",
	"BAMUM LETTER PHASE-D PIP",
	"BAMUM LETTER PHASE-D PUQ",
	"BAMUM LETTER PHASE-D PUUT",
	"BAMUM LETTER PHASE-D RAEM",
	"BAMUM LETTER PHASE-D REN MUCH",
	"BAMUM LETTER PHASE-D REN OLD",
	"BAMUM LETTER PHASE-D RII",
	"BAMUM LETTER PHASE-D SAP",
	"BAMUM LETTER PHASE-D SAQ",
	"BAMUM LETTER PHASE-D SEUAEQ",
	"BAMUM LETTER PHASE-D SHEE",
	"BAMUM LETTER PHASE-D SHEUAE",
	"BAMUM LETTER PHASE-D SHEUX",
	"BAMUM LETTER PHASE-D SHII",
	"BAMUM LETTER PHASE-D SHOQ",
	"BAMUM LETTER PHASE-D SHU",
	"BAMUM LETTER PHASE-D SOT",
	"BAMUM LETTER PHASE-D SUAE",
	"BAMUM LETTER PHASE-D SUE",
	"BAMUM LETTER PHASE-D SUU",
	"BAMUM LETTER PHASE-D TAE",
	"BAMUM LETTER PHASE-D TEEEE",
	"BAMUM LETTER PHASE-D TEUAEN",
	"BAMUM LETTER PHASE-D TEUN",
	"BAMUM LETTER PHASE-D TEUT",
	"BAMUM LETTER PHASE-D TI",
	"BAMUM LETTER PHASE-D TOQ",
	"BAMUM LETTER PHASE-D TU",
	"BAMUM LETTER PHASE-D TUOT",
	"BAMUM LETTER PHASE-D WAP",
	"BAMUM LETTER PHASE-D WUAEN",
	"BAMUM LETTER PHASE-D YAEMMAE",
	"BAMUM LETTER PHASE-D YEN",
	"BAMUM LETTER PHASE-D YUOM",
	"BAMUM LETTER PHASE-D YUOP",
	"BAMUM LETTER PHASE-D YUWOQ",
	"BAMUM LETTER PHASE-E A",
	"BAMUM LETTER PHASE-E FA",
	"BAMUM LETTER PHASE-E FAQ",
	"BAMUM LETTER PHASE-E FEE",
	"BAMUM LETTER PHASE-E FOM",
	"BAMUM LETTER PHASE-E FU CALL",
	"BAMUM LETTER PHASE-E FU I",
	"BAMUM LETTER PHASE-E FU REMEDY",
	"BAMUM LETTER PHASE-E FUE",
	"BAMUM LETTER PHASE-E FUET",
	"BAMUM LETTER PHASE-E GBET",
	"BAMUM LETTER PHASE-E GBEUX",
	"BAMUM LETTER PHASE-E GHAAMAE",
	"BAMUM LETTER PHASE-E GHET",
	"BAMUM LETTER PHASE-E GHEUAE",
	"BAMUM LETTER PHASE-E GHEUN",
	"BAMUM LETTER PHASE-E GHEUX",
	"BAMUM LETTER PHASE-E GHOM",
	"BAMUM LETTER PHASE-E I",
	"BAMUM LETTER PHASE-E KET",
	"BAMUM LETTER PHASE-E KEUAE",
	"BAMUM LETTER PHASE-E KEUX",
	"BAMUM LETTER PHASE-E KI",
	"BAMUM LETTER PHASE-E KO",
	"BAMUM LETTER PHASE-E KPEUX",
	"BAMUM LETTER PHASE-E KUET",
	"BAMUM LETTER PHASE-E KUOP",
	"BAMUM LETTER PHASE-E KUT",
	"BAMUM LETTER PHASE-E LAAM",
	"BAMUM LETTER PHASE-E LAP",
	"BAMUM LETTER PHASE-E LAQ",
	"BAMUM LETTER PHASE-E LEUAEM",
	"BAMUM LETTER PHASE-E LOM",
	"BAMUM LETTER PHASE-E LOON",
	"BAMUM LETTER PHASE-E LOOT",
	"BAMUM LETTER PHASE-E LOQ",
	"BAMUM LETTER PHASE-E LU",
	"BAMUM LETTER PHASE-E MA",
	"BAMUM LETTER PHASE-E MAE",
	"BAMUM LETTER PHASE-E MAEM",
	"BAMUM LETTER PHASE-E MAP",
	"BAMUM LETTER PHASE-E MAQ",
	"BAMUM LETTER PHASE-E MBEE",
	"BAMUM LETTER PHASE-E MBEUM",
	"BAMUM LETTER PHASE-E MEN",
	"BAMUM LETTER PHASE-E MFEUQ",
	"BAMUM LETTER PHASE-E MGBA",
	"BAMUM LETTER PHASE-E MGBEN",
	"BAMUM LETTER PHASE-E MI",
	"BAMUM LETTER PHASE-E MIEE",
	"BAMUM LETTER PHASE-E MON",
	"BAMUM LETTER PHASE-E MUAE",
	"BAMUM LETTER PHASE-E MVI",
	"BAMUM LETTER PHASE-E NA",
	"BAMUM LETTER PHASE-E NAE",
	"BAMUM LETTER PHASE-E NDAA MY HOUSE",
	"BAMUM LETTER PHASE-E NDAA SOFTNESS",
	"BAMUM LETTER PHASE-E NDAP",
	"BAMUM LETTER PHASE-E NDIAQ",
	"BAMUM LETTER PHASE-E NDIQ",
	"BAMUM LETTER PHASE-E NDUN",
	"BAMUM LETTER PHASE-E NGA",
	"BAMUM LETTER PHASE-E NGEUREUT",
	"BAMUM LETTER PHASE-E NGGEEEE",
	"BAMUM LETTER PHASE-E NGGEUAE",
	"BAMUM LETTER PHASE-E NGGEUAET",
	"BAMUM LETTER PHASE-E NGGUAESHAE NYAM",
	"BAMUM LETTER PHASE-E NGGUP",
	"BAMUM LETTER PHASE-E NGGURAE",
	"BAMUM LETTER PHASE-E NGKA",
	"BAMUM LETTER PHASE-E NGKAAMI",
	"BAMUM LETTER PHASE-E NGKEUAEM",
	"BAMUM LETTER PHASE-E NGKEUX",
	"BAMUM LETTER PHASE-E NGKUM",
	"BAMUM LETTER PHASE-E NGKUP",
	"BAMUM LETTER PHASE-E NGOP",
	"BAMUM LETTER PHASE-E NGOQ",
	"BAMUM LETTER PHASE-E NGUAE",
	"BAMUM LETTER PHASE-E NGUAET",
	"BAMUM LETTER PHASE-E NJAEMLI",
	"BAMUM LETTER PHASE-E NJEE",
	"BAMUM LETTER PHASE-E NJEE EPOCH",
	"BAMUM LETTER PHASE-E NJEUX",
	"BAMUM LETTER PHASE-E NKOM",
	"BAMUM LETTER PHASE-E NSHIEE",
	"BAMUM LETTER PHASE-E NSHUE",
	"BAMUM LETTER PHASE-E NSHUOP",
	"BAMUM LETTER PHASE-E NTAP",
	"BAMUM LETTER PHASE-E NTUM",
	"BAMUM LETTER PHASE-E NYI BETWEEN",
	"BAMUM LETTER PHASE-E NYI CLEAVER",
	"BAMUM LETTER PHASE-E NZAQ",
	"BAMUM LETTER PHASE-E NZUQ",
	"BAMUM LETTER PHASE-E O",
	"BAMUM LETTER PHASE-E PA PEOPLE",
	"BAMUM LETTER PHASE-E PA PLURAL",
	"BAMUM LETTER PHASE-E PAA",
	"BAMUM LETTER PHASE-E PAAM",
	"BAMUM LETTER PHASE-E PEEM",
	"BAMUM LETTER PHASE-E PEUT",
	"BAMUM LETTER PHASE-E PEUX",
	"BAMUM LETTER PHASE-E PI",
	"BAMUM LETTER PHASE-E PIEEQ",
	"BAMUM LETTER PHASE-E PIET",
	"BAMUM LETTER PHASE-E PO",
	"BAMUM LETTER PHASE-E POON",
	"BAMUM LETTER PHASE-E PU",
	"BAMUM LETTER PHASE-E PUAE",
	"BAMUM LETTER PHASE-E PUAQ",
	"BAMUM LETTER PHASE-E PUE",
	"BAMUM LETTER PHASE-E PUM",
	"BAMUM LETTER PHASE-E RAE",
	"BAMUM LETTER PHASE-E RAQ",
	"BAMUM LETTER PHASE-E REUX",
	"BAMUM LETTER PHASE-E RIMGBA",
	"BAMUM LETTER PHASE-E SAA",
	"BAMUM LETTER PHASE-E SEE",
	"BAMUM LETTER PHASE-E SET",
	"BAMUM LETTER PHASE-E SHEUAEQ",
	"BAMUM LETTER PHASE-E SHIQ",
	"BAMUM LETTER PHASE-E SHO",
	"BAMUM LETTER PHASE-E SHOQ",
	"BAMUM LETTER PHASE-E SOM",
	"BAMUM LETTER PHASE-E SUAEN",
	"BAMUM LETTER PHASE-E TAA",
	"BAMUM LETTER PHASE-E TAAQ",
	"BAMUM LETTER PHASE-E TAEN NTEUM",
	"BAMUM LETTER PHASE-E TAM",
	"BAMUM LETTER PHASE-E TAQ",
	"BAMUM LETTER PHASE-E TEN",
	"BAMUM LETTER PHASE-E TEU",
	"BAMUM LETTER PHASE-E TEUAEQ",
	"BAMUM LETTER PHASE-E TOO",
	"BAMUM LETTER PHASE-E TOON",
	"BAMUM LETTER PHASE-E TOQ",
	"BAMUM LETTER PHASE-E TUAE",
	"BAMUM LETTER PHASE-E TUM",
	"BAMUM LETTER PHASE-E TUMAE",
	"BAMUM LETTER PHASE-E VEE",
	"BAMUM LETTER PHASE-E VEUAE",
	"BAMUM LETTER PHASE-E VOM",
	"BAMUM LETTER PHASE-E WEUX",
	"BAMUM LETTER PHASE-E WUE",
	"BAMUM LETTER PHASE-E WUO",
	"BAMUM LETTER PHASE-E YAP",
	"BAMUM LETTER PHASE-E YEUAE",
	"BAMUM LETTER PHASE-E YEUAET",
	"BAMUM LETTER PHASE-E YEUM",
	"BAMUM LETTER PHASE-E YEUX",
	"BAMUM LETTER PHASE-E YIEE",
	"BAMUM LETTER PHASE-E YIT",
	"BAMUM LETTER PHASE-E YOQ COVER",
	"BAMUM LETTER PHASE-E YOQ SWIMMING",
	"BAMUM LETTER PHASE-E YUAEN",
	"BAMUM LETTER PHASE-E YUEQ",
	"BAMUM LETTER PHASE-E YUN",
	"BAMUM LETTER PHASE-E YUQ",
	"BAMUM LETTER PHASE-F EE",
	"BAMUM LETTER PHASE-F FOM",
	"BAMUM LETTER PHASE-F KA",
	"BAMUM LETTER PHASE-F KEN",
	"BAMUM LETTER PHASE-F KET",
	"BAMUM LETTER PHASE-F KO",
	"BAMUM LETTER PHASE-F KPA",
	"BAMUM LETTER PHASE-F KU",
	"BAMUM LETTER PHASE-F KYEE",
	"BAMUM LETTER PHASE-F LA",
	"BAMUM LETTER PHASE-F LI",
	"BAMUM LETTER PHASE-F LOQ",
	"BAMUM LETTER PHASE-F M",
	"BAMUM LETTER PHASE-F MA",
	"BAMUM LETTER PHASE-F MBAA",
	"BAMUM LETTER PHASE-F MBEN",
	"BAMUM LETTER PHASE-F MEEEE",
	"BAMUM LETTER PHASE-F MO",
	"BAMUM LETTER PHASE-F NDAA",
	"BAMUM LETTER PHASE-F NGGA",
	"BAMUM LETTER PHASE-F NGKWAEN",
	"BAMUM LETTER PHASE-F NI",
	"BAMUM LETTER PHASE-F NJAEM",
	"BAMUM LETTER PHASE-F NJUAE",
	"BAMUM LETTER PHASE-F NSHA",
	"BAMUM LETTER PHASE-F NTEE",
	"BAMUM LETTER PHASE-F NU",
	"BAMUM LETTER PHASE-F NUAE",
	"BAMUM LETTER PHASE-F NYI",
	"BAMUM LETTER PHASE-F PEE",
	"BAMUM LETTER PHASE-F PEUX",
	"BAMUM LETTER PHASE-F PUAE",
	"BAMUM LETTER PHASE-F REE",
	"BAMUM LETTER PHASE-F REN",
	"BAMUM LETTER PHASE-F REUX",
	"BAMUM LETTER PHASE-F RIEE",
	"BAMUM LETTER PHASE-F RII",
	"BAMUM LETTER PHASE-F RU",
	"BAMUM LETTER PHASE-F SAMBA",
	"BAMUM LETTER PHASE-F SEUX",
	"BAMUM LETTER PHASE-F SHII",
	"BAMUM LETTER PHASE-F SHO",
	"BAMUM LETTER PHASE-F SHU",
	"BAMUM LETTER PHASE-F SI",
	"BAMUM LETTER PHASE-F SUU",
	"BAMUM LETTER PHASE-F TAA",
	"BAMUM LETTER PHASE-F TAE",
	"BAMUM LETTER PHASE-F TET",
	"BAMUM LETTER PHASE-F U",
	"BAMUM LETTER PHASE-F VUEQ",
	"BAMUM LETTER PHASE-F WA",
	"BAMUM LETTER PHASE-F WUE",
	"BAMUM LETTER PHASE-F YA",
	"BAMUM LETTER PHASE-F YOQ",
	"BAMUM LETTER PI",
	"BAMUM LETTER PUAE",
	"BAMUM LETTER PUE",
	"BAMUM LETTER RAE",
	"BAMUM LETTER REE",
	"BAMUM LETTER REN",
	"BAMUM LETTER REUX",
	"BAMUM LETTER RIEE",
	"BAMUM LETTER RII",
	"BAMUM LETTER RU",
	"BAMUM LETTER SAMBA",
	"BAMUM LETTER SEUX",
	"BAMUM LETTER SHEUX",
	"BAMUM LETTER SHII",
	"BAMUM LETTER SHO",
	"BAMUM LETTER SHU",
	"BAMUM LETTER SI",
	"BAMUM LETTER SUU",
	"BAMUM LETTER TAA",
	"BAMUM LETTER TAE",
	"BAMUM LETTER TEN",
	"BAMUM LETTER TET",
	"BAMUM LETTER TI",
	"BAMUM LETTER U",
	"BAMUM LETTER WA",
	"BAMUM LETTER WUE",
	"BAMUM LETTER YA",
	"BAMUM LETTER YOQ",
	"BAMUM LETTER YUQ",
	"BAMUM NJAEMLI",
	"BAMUM QUESTION MARK",
	"BAMUM SEMICOLON",
	"BANANA",
	"BANK",
	"BANKNOTE WITH DOLLAR SIGN",
	"BANKNOTE WITH EURO SIGN",
	"BANKNOTE WITH POUND SIGN",
	"BANKNOTE WITH YEN SIGN",
	"BAR CHART",
	"BARBER POLE",
	"BASEBALL",
	"BASKETBALL AND HOOP",
	"BATAK CONSONANT SIGN H",
	"BATAK CONSONANT SIGN NG",
	"BATAK LETTER A",
	"BATAK LETTER BA",
	"BATAK LETTER CA",
	"BATAK LETTER DA",
	"BATAK LETTER GA",
	"BATAK LETTER HA",
	"BATAK LETTER I",
	"BATAK LETTER JA",
	"BATAK LETTER KARO BA",
	"BATAK LETTER LA",
	"BATAK LETTER MA",
	"BATAK LETTER MANDAILING HA",
	"BATAK LETTER MANDAILING NA",
	"BATAK LETTER MANDAILING SA",
	"BATAK LETTER MBA",
	"BATAK LETTER NA",
	"BATAK LETTER NDA",
	"BATAK LETTER NGA",
	"BATAK LETTER NORTHERN TA",
	"BATAK LETTER NYA",
	"BATAK LETTER PA",
	"BATAK LETTER PAKPAK WA",
	"BATAK LETTER RA",
	"BATAK LETTER SA",
	"BATAK LETTER SIMALUNGUN A",
	"BATAK LETTER SIMALUNGUN GA",
	"BATAK LETTER SIMALUNGUN HA",
	"BATAK LETTER SIMALUNGUN LA",
	"BATAK LETTER SIMALUNGUN MA",
	"BATAK LETTER SIMALUNGUN PA",
	"BATAK LETTER SIMALUNGUN RA",
	"BATAK LETTER SIMALUNGUN SA",
	"BATAK LETTER SIMALUNGUN WA",
	"BATAK LETTER SIMALUNGUN YA",
	"BATAK LETTER SOUTHERN TA",
	"BATAK LETTER U",
	"BATAK LETTER WA",
	"BATAK LETTER YA",
	"BATAK PANGOLAT",
	"BATAK PANONGONAN",
	"BATAK SIGN TOMPI",
	"BATAK SYMBOL BINDU JUDUL",
	"BATAK SYMBOL BINDU NA METEK",
	"BATAK SYMBOL BINDU PANGOLAT",
	"BATAK SYMBOL BINDU PINARBORAS",
	"BATAK VOWEL SIGN E",
	"BATAK VOWEL SIGN EE",
	"BATAK VOWEL SIGN I",
	"BATAK VOWEL SIGN KARO I",
	"BATAK VOWEL SIGN KARO O",
	"BATAK VOWEL SIGN O",
	"BATAK VOWEL SIGN PAKPAK E",
	"BATAK VOWEL SIGN U",
	"BATAK VOWEL SIGN U FOR SIMALUNGUN SA",
	"BATH",
	"BATHTUB",
	"BATTERY",
	"BEAMED EIGHTH NOTES",
	"BEAMED SIXTEENTH NOTES",
	"BEAR FACE",
	"BEATING HEART",
	"BECAUSE",
	"BEER MUG",
	"BELL",
	"BELL SYMBOL",
	"BELL WITH CANCELLATION STROKE",
	"BENGALI AU LENGTH MARK",
	"BENGALI CURRENCY DENOMINATOR SIXTEEN",
	"BENGALI CURRENCY NUMERATOR FOUR",
	"BENGALI CURRENCY NUMERATOR ONE",
	"BENGALI CURRENCY NUMERATOR ONE LESS THAN THE DENOMINATOR",
	"BENGALI CURRENCY NUMERATOR THREE",
	"BENGALI CURRENCY NUMERATOR TWO",
	"BENGALI DIGIT EIGHT",
	"BENGALI DIGIT FIVE",
	"BENGALI DIGIT FOUR",
	"BENGALI DIGIT NINE",
	"BENGALI DIGIT ONE",
	"BENGALI DIGIT SEVEN",
	"BENGALI DIGIT SIX",
	"BENGALI DIGIT THREE",
	"BENGALI DIGIT TWO",
	"BENGALI DIGIT ZERO",
	"BENGALI GANDA MARK",
	"BENGALI ISSHAR",
	"BENGALI LETTER A",
	"BENGALI LETTER AA",
	"BENGALI LETTER AI",
	"BENGALI LETTER AU",
	"BENGALI LETTER BA",
	"BENGALI LETTER BHA",
	"BENGALI LETTER CA",
	"BENGALI LETTER CHA",
	"BENGALI LETTER DA",
	"BENGALI LETTER DDA",
	"BENGALI LETTER DDHA",
	"BENGALI LETTER DHA",
	"BENGALI LETTER E",
	"BENGALI LETTER GA",
	"BENGALI LETTER GHA",
	"BENGALI LETTER HA",
	"BENGALI LETTER I",
	"BENGALI LETTER II",
	"BENGALI LETTER JA",
	"BENGALI LETTER JHA",
	"BENGALI LETTER KA",
	"BENGALI LETTER KHA",
	"BENGALI LETTER KHANDA TA",
	"BENGALI LETTER LA",
	"BENGALI LETTER MA",
	"BENGALI LETTER NA",
	"BENGALI LETTER NGA",
	"BENGALI LETTER NNA",
	"BENGALI LETTER NYA",
	"BENGALI LETTER O",
	"BENGALI LETTER PA",
	"BENGALI LETTER PHA",
	"BENGALI LETTER RA",
	"BENGALI LETTER RA WITH LOWER DIAGONAL",
	"BENGALI LETTER RA WITH MIDDLE DIAGONAL",
	"BENGALI LETTER RHA",
	"BENGALI LETTER RRA",
	"BENGALI LETTER SA",
	"BENGALI LETTER SHA",
	"BENGALI LETTER SSA",
	"BENGALI LETTER TA",
	"BENGALI LETTER THA",
	"BENGALI LETTER TTA",
	"BENGALI LETTER TTHA",
	"BENGALI LETTER U",
	"BENGALI LETTER UU",
	"BENGALI LETTER VOCALIC L",
	"BENGALI LETTER VOCALIC LL",
	"BENGALI LETTER VOCALIC R",
	"BENGALI LETTER VOCALIC RR",
	"BENGALI LETTER YA",
	"BENGALI LETTER YYA",
	"BENGALI RUPEE MARK",
	"BENGALI RUPEE SIGN",
	"BENGALI SIGN ANUSVARA",
	"BENGALI SIGN AVAGRAHA",
	"BENGALI SIGN CANDRABINDU",
	"BENGALI SIGN NUKTA",
	"BENGALI SIGN VIRAMA",
	"BENGALI SIGN VISARGA",
	"BENGALI VOWEL SIGN AA",
	"BENGALI VOWEL SIGN AI",
	"BENGALI VOWEL SIGN AU",
	"BENGALI VOWEL SIGN E",
	"BENGALI VOWEL SIGN I",
	"BENGALI VOWEL SIGN II",
	"BENGALI VOWEL SIGN O",
	"BENGALI VOWEL SIGN U",
	"BENGALI VOWEL SIGN UU",
	"BENGALI VOWEL SIGN VOCALIC L",
	"BENGALI VOWEL SIGN VOCALIC LL",
	"BENGALI VOWEL SIGN VOCALIC R",
	"BENGALI VOWEL SIGN VOCALIC RR",
	"BENTO BOX",
	"BENZENE RING",
	"BENZENE RING WITH CIRCLE",
	"BET SYMBOL",
	"BETWEEN",
	"BICYCLE",
	"BICYCLIST",
	"BIG REVERSE SOLIDUS",
	"BIG SOLIDUS",
	"BIKINI",
	"BILLIARDS",
	"BIOHAZARD SIGN",
	"BIRD",
	"BIRTHDAY CAKE",
	"BLACK BOWTIE",
	"BLACK CENTRE WHITE STAR",
	"BLACK CHESS BISHOP",
	"BLACK CHESS KING",
	"BLACK CHESS KNIGHT",
	"BLACK CHESS PAWN",
	"BLACK CHESS QUEEN",
	"BLACK CHESS ROOK",
	"BLACK CIRCLE",
	"BLACK CIRCLE WITH DOWN ARROW",
	"BLACK CIRCLE WITH TWO WHITE DOTS",
	"BLACK CIRCLE WITH WHITE DOT RIGHT",
	"BLACK CLUB SUIT",
	"BLACK CROSS ON SHIELD",
	"BLACK DIAMOND",
	"BLACK DIAMOND MINUS WHITE X",
	"BLACK DIAMOND SUIT",
	"BLACK DIAMOND WITH DOWN ARROW",
	"BLACK DOWN-POINTING DOUBLE TRIANGLE",
	"BLACK DOWN-POINTING SMALL TRIANGLE",
	"BLACK DOWN-POINTING TRIANGLE",
	"BLACK DRAUGHTS KING",
	"BLACK DRAUGHTS MAN",
	"BLACK FLAG",
	"BLACK FLORETTE",
	"BLACK FOUR POINTED STAR",
	"BLACK HEART SUIT",
	"BLACK HEXAGON",
	"BLACK HORIZONTAL ELLIPSE",
	"BLACK HOURGLASS",
	"BLACK LARGE CIRCLE",
	"BLACK LARGE SQUARE",
	"BLACK LEFT LANE MERGE",
	"BLACK LEFT POINTING INDEX",
	"BLACK LEFT-POINTING DOUBLE TRIANGLE",
	"BLACK LEFT-POINTING DOUBLE TRIANGLE WITH VERTICAL BAR",
	"BLACK LEFT-POINTING POINTER",
	"BLACK LEFT-POINTING SMALL TRIANGLE",
	"BLACK LEFT-POINTING TRIANGLE",
	"BLACK LEFTWARDS BULLET",
	"BLACK LOWER LEFT TRIANGLE",
	"BLACK LOWER RIGHT TRIANGLE",
	"BLACK LOZENGE",
	"BLACK MEDIUM DIAMOND",
	"BLACK MEDIUM LOZENGE",
	"BLACK MEDIUM SMALL SQUARE",
	"BLACK MEDIUM SQUARE",
	"BLACK MOON LILITH",
	"BLACK NIB",
	"BLACK PARALLELOGRAM",
	"BLACK PENTAGON",
	"BLACK QUESTION MARK ORNAMENT",
	"BLACK RECTANGLE",
	"BLACK RIGHT POINTING INDEX",
	"BLACK RIGHT-POINTING DOUBLE TRIANGLE",
	"BLACK RIGHT-POINTING DOUBLE TRIANGLE WITH VERTICAL BAR",
	"BLACK RIGHT-POINTING PENTAGON",
	"BLACK RIGHT-POINTING POINTER",
	"BLACK RIGHT-POINTING SMALL TRIANGLE",
	"BLACK RIGHT-POINTING TRIANGLE",
	"BLACK RIGHT-POINTING TRIANGLE WITH DOUBLE VERTICAL BAR",
	"BLACK RIGHTWARDS ARROW",
	"BLACK RIGHTWARDS ARROWHEAD",
	"BLACK RIGHTWARDS BULLET",
	"BLACK SCISSORS",
	"BLACK SHOGI PIECE",
	"BLACK SMALL DIAMOND",
	"BLACK SMALL LOZENGE",
	"BLACK SMALL SQUARE",
	"BLACK SMALL STAR",
	"BLACK SMILING FACE",
	"BLACK SNOWMAN",
	"BLACK SPADE SUIT",
	"BLACK SQUARE",
	"BLACK SQUARE BUTTON",
	"BLACK STAR",
	"BLACK SUN WITH RAYS",
	"BLACK TELEPHONE",
	"BLACK TRUCK",
	"BLACK TWO-WAY LEFT WAY TRAFFIC",
	"BLACK UNIVERSAL RECYCLING SYMBOL",
	"BLACK UP-POINTING DOUBLE TRIANGLE",
	"BLACK UP-POINTING SMALL TRIANGLE",
	"BLACK UP-POINTING TRIANGLE",
	"BLACK UPPER LEFT TRIANGLE",
	"BLACK UPPER RIGHT TRIANGLE",
	"BLACK VERTICAL ELLIPSE",
	"BLACK VERTICAL RECTANGLE",
	"BLACK VERY SMALL SQUARE",
	"BLACK-FEATHERED NORTH EAST ARROW",
	"BLACK-FEATHERED RIGHTWARDS ARROW",
	"BLACK-FEATHERED SOUTH EAST ARROW",
	"BLACK-LETTER CAPITAL C",
	"BLACK-LETTER CAPITAL H",
	"BLACK-LETTER CAPITAL I",
	"BLACK-LETTER CAPITAL R",
	"BLACK-LETTER CAPITAL Z",
	"BLANK SYMBOL",
	"BLOSSOM",
	"BLOWFISH",
	"BLUE BOOK",
	"BLUE HEART",
	"BOAR",
	"BOMB",
	"BOOKMARK",
	"BOOKMARK TABS",
	"BOOKS",
	"BOPOMOFO FINAL LETTER H",
	"BOPOMOFO FINAL LETTER K",
	"BOPOMOFO FINAL LETTER P",
	"BOPOMOFO FINAL LETTER T",
	"BOPOMOFO LETTER A",
	"BOPOMOFO LETTER AI",
	"BOPOMOFO LETTER AINN",
	"BOPOMOFO LETTER AM",
	"BOPOMOFO LETTER AN",
	"BOPOMOFO LETTER ANG",
	"BOPOMOFO LETTER ANN",
	"BOPOMOFO LETTER AU",
	"BOPOMOFO LETTER AUNN",
	"BOPOMOFO LETTER B",
	"BOPOMOFO LETTER BU",
	"BOPOMOFO LETTER C",
	"BOPOMOFO LETTER CH",
	"BOPOMOFO LETTER D",
	"BOPOMOFO LETTER E",
	"BOPOMOFO LETTER EE",
	"BOPOMOFO LETTER EH",
	"BOPOMOFO LETTER EI",
	"BOPOMOFO LETTER EN",
	"BOPOMOFO LETTER ENG",
	"BOPOMOFO LETTER ENN",
	"BOPOMOFO LETTER ER",
	"BOPOMOFO LETTER F",
	"BOPOMOFO LETTER G",
	"BOPOMOFO LETTER GH",
	"BOPOMOFO LETTER GN",
	"BOPOMOFO LETTER GU",
	"BOPOMOFO LETTER H",
	"BOPOMOFO LETTER I",
	"BOPOMOFO LETTER IH",
	"BOPOMOFO LETTER IM",
	"BOPOMOFO LETTER INN",
	"BOPOMOFO LETTER INNN",
	"BOPOMOFO LETTER IR",
	"BOPOMOFO LETTER IU",
	"BOPOMOFO LETTER J",
	"BOPOMOFO LETTER JI",
	"BOPOMOFO LETTER K",
	"BOPOMOFO LETTER L",
	"BOPOMOFO LETTER LH",
	"BOPOMOFO LETTER M",
	"BOPOMOFO LETTER N",
	"BOPOMOFO LETTER NG",
	"BOPOMOFO LETTER NGG",
	"BOPOMOFO LETTER O",
	"BOPOMOFO LETTER OM",
	"BOPOMOFO LETTER ONG",
	"BOPOMOFO LETTER ONN",
	"BOPOMOFO LETTER OO",
	"BOPOMOFO LETTER OU",
	"BOPOMOFO LETTER P",
	"BOPOMOFO LETTER Q",
	"BOPOMOFO LETTER R",
	"BOPOMOFO LETTER S",
	"BOPOMOFO LETTER SH",
	"BOPOMOFO LETTER T",
	"BOPOMOFO LETTER U",
	"BOPOMOFO LETTER UNN",
	"BOPOMOFO LETTER V",
	"BOPOMOFO LETTER X",
	"BOPOMOFO LETTER Z",
	"BOPOMOFO LETTER ZH",
	"BOPOMOFO LETTER ZI",
	"BOPOMOFO LETTER ZY",
	"BOTTOM ARC ANTICLOCKWISE ARROW",
	"BOTTOM CURLY BRACKET",
	"BOTTOM HALF INTEGRAL",
	"BOTTOM LEFT CORNER",
	"BOTTOM LEFT CROP",
	"BOTTOM LEFT HALF BRACKET",
	"BOTTOM PARENTHESIS",
	"BOTTOM RIGHT CORNER",
	"BOTTOM RIGHT CROP",
	"BOTTOM RIGHT HALF BRACKET",
	"BOTTOM SQUARE BRACKET",
	"BOTTOM SQUARE BRACKET OVER TOP SQUARE BRACKET",
	"BOTTOM TORTOISE SHELL BRACKET",
	"BOUQUET",
	"BOWLING",
	"BOWTIE",
	"BOWTIE WITH LEFT HALF BLACK",
	"BOWTIE WITH RIGHT HALF BLACK",
	"BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL",
	"BOX DRAWINGS DOUBLE DOWN AND LEFT",
	"BOX DRAWINGS DOUBLE DOWN AND RIGHT",
	"BOX DRAWINGS DOUBLE HORIZONTAL",
	"BOX DRAWINGS DOUBLE UP AND HORIZONTAL",
	"BOX DRAWINGS DOUBLE UP AND LEFT",
	"BOX DRAWINGS DOUBLE UP AND RIGHT",
	"BOX DRAWINGS DOUBLE VERTICAL",
	"BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL",
	"BOX DRAWINGS DOUBLE VERTICAL AND LEFT",
	"BOX DRAWINGS DOUBLE VERTICAL AND RIGHT",
	"BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE",
	"BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE",
	"BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE",
	"BOX DRAWINGS DOWN HEAVY AND HORIZONTAL LIGHT",
	"BOX DRAWINGS DOWN HEAVY AND LEFT LIGHT",
	"BOX DRAWINGS DOWN HEAVY AND LEFT UP LIGHT",
	"BOX DRAWINGS DOWN HEAVY AND RIGHT LIGHT",
	"BOX DRAWINGS DOWN HEAVY AND RIGHT UP LIGHT",
	"BOX DRAWINGS DOWN HEAVY AND UP HORIZONTAL LIGHT",
	"BOX DRAWINGS DOWN LIGHT AND HORIZONTAL HEAVY",
	"BOX DRAWINGS DOWN LIGHT AND LEFT HEAVY",
	"BOX DRAWINGS DOWN LIGHT AND LEFT UP HEAVY",
	"BOX DRAWINGS DOWN LIGHT AND RIGHT HEAVY",
	"BOX DRAWINGS DOWN LIGHT AND RIGHT UP HEAVY",
	"BOX DRAWINGS DOWN LIGHT AND UP HORIZONTAL HEAVY",
	"BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE",
	"BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE",
	"BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE",
	"BOX DRAWINGS HEAVY DOUBLE DASH HORIZONTAL",
	"BOX DRAWINGS HEAVY DOUBLE DASH VERTICAL",
	"BOX DRAWINGS HEAVY DOWN",
	"BOX DRAWINGS HEAVY DOWN AND HORIZONTAL",
	"BOX DRAWINGS HEAVY DOWN AND LEFT",
	"BOX DRAWINGS HEAVY DOWN AND RIGHT",
	"BOX DRAWINGS HEAVY HORIZONTAL",
	"BOX DRAWINGS HEAVY LEFT",
	"BOX DRAWINGS HEAVY LEFT AND LIGHT RIGHT",
	"BOX DRAWINGS HEAVY QUADRUPLE DASH HORIZONTAL",
	"BOX DRAWINGS HEAVY QUADRUPLE DASH VERTICAL",
	"BOX DRAWINGS HEAVY RIGHT",
	"BOX DRAWINGS HEAVY TRIPLE DASH HORIZONTAL",
	"BOX DRAWINGS HEAVY TRIPLE DASH VERTICAL",
	"BOX DRAWINGS HEAVY UP",
	"BOX DRAWINGS HEAVY UP AND HORIZONTAL",
	"BOX DRAWINGS HEAVY UP AND LEFT",
	"BOX DRAWINGS HEAVY UP AND LIGHT DOWN",
	"BOX DRAWINGS HEAVY UP AND RIGHT",
	"BOX DRAWINGS HEAVY VERTICAL",
	"BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL",
	"BOX DRAWINGS HEAVY VERTICAL AND LEFT",
	"BOX DRAWINGS HEAVY VERTICAL AND RIGHT",
	"BOX DRAWINGS LEFT DOWN HEAVY AND RIGHT UP LIGHT",
	"BOX DRAWINGS LEFT HEAVY AND RIGHT DOWN LIGHT",
	"BOX DRAWINGS LEFT HEAVY AND RIGHT UP LIGHT",
	"BOX DRAWINGS LEFT HEAVY AND RIGHT VERTICAL LIGHT",
	"BOX DRAWINGS LEFT LIGHT AND RIGHT DOWN HEAVY",
	"BOX DRAWINGS LEFT LIGHT AND RIGHT UP HEAVY",
	"BOX DRAWINGS LEFT LIGHT AND RIGHT VERTICAL HEAVY",
	"BOX DRAWINGS LEFT UP HEAVY AND RIGHT DOWN LIGHT",
	"BOX DRAWINGS LIGHT ARC DOWN AND LEFT",
	"BOX DRAWINGS LIGHT ARC DOWN AND RIGHT",
	"BOX DRAWINGS LIGHT ARC UP AND LEFT",
	"BOX DRAWINGS LIGHT ARC UP AND RIGHT",
	"BOX DRAWINGS LIGHT DIAGONAL CROSS",
	"BOX DRAWINGS LIGHT DIAGONAL UPPER LEFT TO LOWER RIGHT",
	"BOX DRAWINGS LIGHT DIAGONAL UPPER RIGHT TO LOWER LEFT",
	"BOX DRAWINGS LIGHT DOUBLE DASH HORIZONTAL",
	"BOX DRAWINGS LIGHT DOUBLE DASH VERTICAL",
	"BOX DRAWINGS LIGHT DOWN",
	"BOX DRAWINGS LIGHT DOWN AND HORIZONTAL",
	"BOX DRAWINGS LIGHT DOWN AND LEFT",
	"BOX DRAWINGS LIGHT DOWN AND RIGHT",
	"BOX DRAWINGS LIGHT HORIZONTAL",
	"BOX DRAWINGS LIGHT LEFT",
	"BOX DRAWINGS LIGHT LEFT AND HEAVY RIGHT",
	"BOX DRAWINGS LIGHT QUADRUPLE DASH HORIZONTAL",
	"BOX DRAWINGS LIGHT QUADRUPLE DASH VERTICAL",
	"BOX DRAWINGS LIGHT RIGHT",
	"BOX DRAWINGS LIGHT TRIPLE DASH HORIZONTAL",
	"BOX DRAWINGS LIGHT TRIPLE DASH VERTICAL",
	"BOX DRAWINGS LIGHT UP",
	"BOX DRAWINGS LIGHT UP AND HEAVY DOWN",
	"BOX DRAWINGS LIGHT UP AND HORIZONTAL",
	"BOX DRAWINGS LIGHT UP AND LEFT",
	"BOX DRAWINGS LIGHT UP AND RIGHT",
	"BOX DRAWINGS LIGHT VERTICAL",
	"BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL",
	"BOX DRAWINGS LIGHT VERTICAL AND LEFT",
	"BOX DRAWINGS LIGHT VERTICAL AND RIGHT",
	"BOX DRAWINGS RIGHT DOWN HEAVY AND LEFT UP LIGHT",
	"BOX DRAWINGS RIGHT HEAVY AND LEFT DOWN LIGHT",
	"BOX DRAWINGS RIGHT HEAVY AND LEFT UP LIGHT",
	"BOX DRAWINGS RIGHT HEAVY AND LEFT VERTICAL LIGHT",
	"BOX DRAWINGS RIGHT LIGHT AND LEFT DOWN HEAVY",
	"BOX DRAWINGS RIGHT LIGHT AND LEFT UP HEAVY",
	"BOX DRAWINGS RIGHT LIGHT AND LEFT VERTICAL HEAVY",
	"BOX DRAWINGS RIGHT UP HEAVY AND LEFT DOWN LIGHT",
	"BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE",
	"BOX DRAWINGS UP DOUBLE AND LEFT SINGLE",
	"BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE",
	"BOX DRAWINGS UP HEAVY AND DOWN HORIZONTAL LIGHT",
	"BOX DRAWINGS UP HEAVY AND HORIZONTAL LIGHT",
	"BOX DRAWINGS UP HEAVY AND LEFT DOWN LIGHT",
	"BOX DRAWINGS UP HEAVY AND LEFT LIGHT",
	"BOX DRAWINGS UP HEAVY AND RIGHT DOWN LIGHT",
	"BOX DRAWINGS UP HEAVY AND RIGHT LIGHT",
	"BOX DRAWINGS UP LIGHT AND DOWN HORIZONTAL HEAVY",
	"BOX DRAWINGS UP LIGHT AND HORIZONTAL HEAVY",
	"BOX DRAWINGS UP LIGHT AND LEFT DOWN HEAVY",
	"BOX DRAWINGS UP LIGHT AND LEFT HEAVY",
	"BOX DRAWINGS UP LIGHT AND RIGHT DOWN HEAVY",
	"BOX DRAWINGS UP LIGHT AND RIGHT HEAVY",
	"BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE",
	"BOX DRAWINGS UP SINGLE AND LEFT DOUBLE",
	"BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE",
	"BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE",
	"BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE",
	"BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE",
	"BOX DRAWINGS VERTICAL HEAVY AND HORIZONTAL LIGHT",
	"BOX DRAWINGS VERTICAL HEAVY AND LEFT LIGHT",
	"BOX DRAWINGS VERTICAL HEAVY AND RIGHT LIGHT",
	"BOX DRAWINGS VERTICAL LIGHT AND HORIZONTAL HEAVY",
	"BOX DRAWINGS VERTICAL LIGHT AND LEFT HEAVY",
	"BOX DRAWINGS VERTICAL LIGHT AND RIGHT HEAVY",
	"BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE",
	"BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE",
	"BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE",
	"BOY",
	"BRAHMI DANDA",
	"BRAHMI DIGIT EIGHT",
	"BRAHMI DIGIT FIVE",
	"BRAHMI DIGIT FOUR",
	"BRAHMI DIGIT NINE",
	"BRAHMI DIGIT ONE",
	"BRAHMI DIGIT SEVEN",
	"BRAHMI DIGIT SIX",
	"BRAHMI DIGIT THREE",
	"BRAHMI DIGIT TWO",
	"BRAHMI DIGIT ZERO",
	"BRAHMI DOUBLE DANDA",
	"BRAHMI LETTER A",
	"BRAHMI LETTER AA",
	"BRAHMI LETTER AI",
	"BRAHMI LETTER AU",
	"BRAHMI LETTER BA",
	"BRAHMI LETTER BHA",
	"BRAHMI LETTER CA",
	"BRAHMI LETTER CHA",
	"BRAHMI LETTER DA",
	"BRAHMI LETTER DDA",
	"BRAHMI LETTER DDHA",
	"BRAHMI LETTER DHA",
	"BRAHMI LETTER E",
	"BRAHMI LETTER GA",
	"BRAHMI LETTER GHA",
	"BRAHMI LETTER HA",
	"BRAHMI LETTER I",
	"BRAHMI LETTER II",
	"BRAHMI LETTER JA",
	"BRAHMI LETTER JHA",
	"BRAHMI LETTER KA",
	"BRAHMI LETTER KHA",
	"BRAHMI LETTER LA",
	"BRAHMI LETTER LLA",
	"BRAHMI LETTER MA",
	"BRAHMI LETTER NA",
	"BRAHMI LETTER NGA",
	"BRAHMI LETTER NNA",
	"BRAHMI LETTER NYA",
	"BRAHMI LETTER O",
	"BRAHMI LETTER OLD TAMIL LLLA",
	"BRAHMI LETTER OLD TAMIL NNNA",
	"BRAHMI LETTER OLD TAMIL RRA",
	"BRAHMI LETTER PA",
	"BRAHMI LETTER PHA",
	"BRAHMI LETTER RA",
	"BRAHMI LETTER SA",
	"BRAHMI LETTER SHA",
	"BRAHMI LETTER SSA",
	"BRAHMI LETTER TA",
	"BRAHMI LETTER THA",
	"BRAHMI LETTER TTA",
	"BRAHMI LETTER TTHA",
	"BRAHMI LETTER U",
	"BRAHMI LETTER UU",
	"BRAHMI LETTER VA",
	"BRAHMI LETTER VOCALIC L",
	"BRAHMI LETTER VOCALIC LL",
	"BRAHMI LETTER VOCALIC R",
	"BRAHMI LETTER VOCALIC RR",
	"BRAHMI LETTER YA",
	"BRAHMI NUMBER EIGHT",
	"BRAHMI NUMBER EIGHTY",
	"BRAHMI NUMBER FIFTY",
	"BRAHMI NUMBER FIVE",
	"BRAHMI NUMBER FORTY",
	"BRAHMI NUMBER FOUR",
	"BRAHMI NUMBER NINE",
	"BRAHMI NUMBER NINETY",
	"BRAHMI NUMBER ONE",
	"BRAHMI NUMBER ONE HUNDRED",
	"BRAHMI NUMBER ONE THOUSAND",
	"BRAHMI NUMBER SEVEN",
	"BRAHMI NUMBER SEVENTY",
	"BRAHMI NUMBER SIX",
	"BRAHMI NUMBER SIXTY",
	"BRAHMI NUMBER TEN",
	"BRAHMI NUMBER THIRTY",
	"BRAHMI NUMBER THREE",
	"BRAHMI NUMBER TWENTY",
	"BRAHMI NUMBER TWO",
	"BRAHMI PUNCTUATION CRESCENT BAR",
	"BRAHMI PUNCTUATION DOT",
	"BRAHMI PUNCTUATION DOUBLE DOT",
	"BRAHMI PUNCTUATION LINE",
	"BRAHMI PUNCTUATION LOTUS",
	"BRAHMI SIGN ANUSVARA",
	"BRAHMI SIGN CANDRABINDU",
	"BRAHMI SIGN JIHVAMULIYA",
	"BRAHMI SIGN UPADHMANIYA",
	"BRAHMI SIGN VISARGA",
	"BRAHMI VIRAMA",
	"BRAHMI VOWEL SIGN AA",
	"BRAHMI VOWEL SIGN AI",
	"BRAHMI VOWEL SIGN AU",
	"BRAHMI VOWEL SIGN BHATTIPROLU AA",
	"BRAHMI VOWEL SIGN E",
	"BRAHMI VOWEL SIGN I",
	"BRAHMI VOWEL SIGN II",
	"BRAHMI VOWEL SIGN O",
	"BRAHMI VOWEL SIGN U",
	"BRAHMI VOWEL SIGN UU",
	"BRAHMI VOWEL SIGN VOCALIC L",
	"BRAHMI VOWEL SIGN VOCALIC LL",
	"BRAHMI VOWEL SIGN VOCALIC R",
	"BRAHMI VOWEL SIGN VOCALIC RR",
	"BRAILLE PATTERN BLANK",
	"BREAD",
	"BREVE",
	"BRIDE WITH VEIL",
	"BRIDGE AT NIGHT",
	"BRIEFCASE",
	"BROKEN BAR",
	"BROKEN CIRCLE WITH NORTHWEST ARROW",
	"BROKEN HEART",
	"BUG",
	"BUGINESE END OF SECTION",
	"BUGINESE LETTER A",
	"BUGINESE LETTER BA",
	"BUGINESE LETTER CA",
	"BUGINESE LETTER DA",
	"BUGINESE LETTER GA",
	"BUGINESE LETTER HA",
	"BUGINESE LETTER JA",
	"BUGINESE LETTER KA",
	"BUGINESE LETTER LA",
	"BUGINESE LETTER MA",
	"BUGINESE LETTER MPA",
	"BUGINESE LETTER NA",
	"BUGINESE LETTER NGA",
	"BUGINESE LETTER NGKA",
	"BUGINESE LETTER NRA",
	"BUGINESE LETTER NYA",
	"BUGINESE LETTER NYCA",
	"BUGINESE LETTER PA",
	"BUGINESE LETTER RA",
	"BUGINESE LETTER SA",
	"BUGINESE LETTER TA",
	"BUGINESE LETTER VA",
	"BUGINESE LETTER YA",
	"BUGINESE PALLAWA",
	"BUGINESE VOWEL SIGN AE",
	"BUGINESE VOWEL SIGN E",
	"BUGINESE VOWEL SIGN I",
	"BUGINESE VOWEL SIGN O",
	"BUGINESE VOWEL SIGN U",
	"BUHID LETTER A",
	"BUHID LETTER BA",
	"BUHID LETTER DA",
	"BUHID LETTER GA",
	"BUHID LETTER HA",
	"BUHID LETTER I",
	"BUHID LETTER KA",
	"BUHID LETTER LA",
	"BUHID LETTER MA",
	"BUHID LETTER NA",
	"BUHID LETTER NGA",
	"BUHID LETTER PA",
	"BUHID LETTER RA",
	"BUHID LETTER SA",
	"BUHID LETTER TA",
	"BUHID LETTER U",
	"BUHID LETTER WA",
	"BUHID LETTER YA",
	"BUHID VOWEL SIGN I",
	"BUHID VOWEL SIGN U",
	"BULLET",
	"BULLET OPERATOR",
	"BULLSEYE",
	"BUS",
	"BUS STOP",
	"BUST IN SILHOUETTE",
	"BUSTS IN SILHOUETTE",
	"BYZANTINE MUSICAL SYMBOL AGOGI ARGI",
	"BYZANTINE MUSICAL SYMBOL AGOGI ARGOTERI",
	"BYZANTINE MUSICAL SYMBOL AGOGI GORGI",
	"BYZANTINE MUSICAL SYMBOL AGOGI GORGOTERI",
	"BYZANTINE MUSICAL SYMBOL AGOGI MESI",
	"BYZANTINE MUSICAL SYMBOL AGOGI METRIA",
	"BYZANTINE MUSICAL SYMBOL AGOGI POLI ARGI",
	"BYZANTINE MUSICAL SYMBOL AGOGI POLI GORGI",
	"BYZANTINE MUSICAL SYMBOL ANATRICHISMA",
	"BYZANTINE MUSICAL SYMBOL ANTIKENOKYLISMA",
	"BYZANTINE MUSICAL SYMBOL ANTIKENOMA",
	"BYZANTINE MUSICAL SYMBOL APESO EKFONITIKON",
	"BYZANTINE MUSICAL SYMBOL APESO EXO NEO",
	"BYZANTINE MUSICAL SYMBOL APLI",
	"BYZANTINE MUSICAL SYMBOL APODERMA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL APODERMA NEO",
	"BYZANTINE MUSICAL SYMBOL APOSTROFOI SYNDESMOS NEO",
	"BYZANTINE MUSICAL SYMBOL APOSTROFOI TELOUS ICHIMATOS",
	"BYZANTINE MUSICAL SYMBOL APOSTROFOS",
	"BYZANTINE MUSICAL SYMBOL APOSTROFOS DIPLI",
	"BYZANTINE MUSICAL SYMBOL APOSTROFOS NEO",
	"BYZANTINE MUSICAL SYMBOL APOTHEMA",
	"BYZANTINE MUSICAL SYMBOL ARGON",
	"BYZANTINE MUSICAL SYMBOL ARGOSYNTHETON",
	"BYZANTINE MUSICAL SYMBOL ARKTIKO DI",
	"BYZANTINE MUSICAL SYMBOL ARKTIKO GA",
	"BYZANTINE MUSICAL SYMBOL ARKTIKO KE",
	"BYZANTINE MUSICAL SYMBOL ARKTIKO NI",
	"BYZANTINE MUSICAL SYMBOL ARKTIKO PA",
	"BYZANTINE MUSICAL SYMBOL ARKTIKO VOU",
	"BYZANTINE MUSICAL SYMBOL ARKTIKO ZO",
	"BYZANTINE MUSICAL SYMBOL CHAMILI",
	"BYZANTINE MUSICAL SYMBOL CHAMILON",
	"BYZANTINE MUSICAL SYMBOL CHOREVMA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL CHOREVMA NEO",
	"BYZANTINE MUSICAL SYMBOL CHROA KLITON",
	"BYZANTINE MUSICAL SYMBOL CHROA SPATHI",
	"BYZANTINE MUSICAL SYMBOL CHROA ZYGOS",
	"BYZANTINE MUSICAL SYMBOL DASEIA",
	"BYZANTINE MUSICAL SYMBOL DIARGON",
	"BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MEGALI",
	"BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MIKRI",
	"BYZANTINE MUSICAL SYMBOL DIASTOLI DIPLI",
	"BYZANTINE MUSICAL SYMBOL DIASTOLI THESEOS",
	"BYZANTINE MUSICAL SYMBOL DIESIS APLI DYO DODEKATA",
	"BYZANTINE MUSICAL SYMBOL DIESIS DIGRAMMOS EX DODEKATA",
	"BYZANTINE MUSICAL SYMBOL DIESIS MONOGRAMMOS TESSERA DODEKATA",
	"BYZANTINE MUSICAL SYMBOL DIESIS TETARTIMORION",
	"BYZANTINE MUSICAL SYMBOL DIESIS TRIGRAMMOS OKTO DODEKATA",
	"BYZANTINE MUSICAL SYMBOL DIESIS TRITIMORION",
	"BYZANTINE MUSICAL SYMBOL DIFTOGGOS OU",
	"BYZANTINE MUSICAL SYMBOL DIGORGON",
	"BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA ANO",
	"BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA KATO",
	"BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON DEXIA",
	"BYZANTINE MUSICAL SYMBOL DIGRAMMA GG",
	"BYZANTINE MUSICAL SYMBOL DIPLI",
	"BYZANTINE MUSICAL SYMBOL DIPLI ARCHAION",
	"BYZANTINE MUSICAL SYMBOL DYO",
	"BYZANTINE MUSICAL SYMBOL EKSTREPTON",
	"BYZANTINE MUSICAL SYMBOL ELAFRON",
	"BYZANTINE MUSICAL SYMBOL ENARXIS KAI FTHORA VOU",
	"BYZANTINE MUSICAL SYMBOL ENDOFONON",
	"BYZANTINE MUSICAL SYMBOL EPEGERMA",
	"BYZANTINE MUSICAL SYMBOL ETERON ARGOSYNTHETON",
	"BYZANTINE MUSICAL SYMBOL ETERON PARAKALESMA",
	"BYZANTINE MUSICAL SYMBOL EXO EKFONITIKON",
	"BYZANTINE MUSICAL SYMBOL FANEROSIS DIFONIAS",
	"BYZANTINE MUSICAL SYMBOL FANEROSIS MONOFONIAS",
	"BYZANTINE MUSICAL SYMBOL FANEROSIS TETRAFONIAS",
	"BYZANTINE MUSICAL SYMBOL FHTORA SKLIRON CHROMA VASIS",
	"BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION DEYTEROU ICHOU",
	"BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI DI",
	"BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI KE",
	"BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NANA",
	"BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI ANO",
	"BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI KATO",
	"BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI PA",
	"BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI ZO",
	"BYZANTINE MUSICAL SYMBOL FTHORA ENARMONIOS ANTIFONIA",
	"BYZANTINE MUSICAL SYMBOL FTHORA I YFESIS TETARTIMORION",
	"BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA DIFONIAS",
	"BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA MONOFONIAS",
	"BYZANTINE MUSICAL SYMBOL FTHORA NAOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL FTHORA NENANO",
	"BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON CHROMA SYNAFI",
	"BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON DIATONON DI",
	"BYZANTINE MUSICAL SYMBOL GENIKI DIESIS",
	"BYZANTINE MUSICAL SYMBOL GENIKI YFESIS",
	"BYZANTINE MUSICAL SYMBOL GORGON ARCHAION",
	"BYZANTINE MUSICAL SYMBOL GORGON NEO ANO",
	"BYZANTINE MUSICAL SYMBOL GORGON NEO KATO",
	"BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON ARISTERA",
	"BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON DEXIA",
	"BYZANTINE MUSICAL SYMBOL GORGOSYNTHETON",
	"BYZANTINE MUSICAL SYMBOL GORTHMIKON N APLOUN",
	"BYZANTINE MUSICAL SYMBOL GORTHMIKON N DIPLOUN",
	"BYZANTINE MUSICAL SYMBOL GRONTHISMATA",
	"BYZANTINE MUSICAL SYMBOL ICHADIN",
	"BYZANTINE MUSICAL SYMBOL IMIDIARGON",
	"BYZANTINE MUSICAL SYMBOL IMIFONON",
	"BYZANTINE MUSICAL SYMBOL IMIFTHORA",
	"BYZANTINE MUSICAL SYMBOL IMIFTHORON",
	"BYZANTINE MUSICAL SYMBOL ISAKIA TELOUS ICHIMATOS",
	"BYZANTINE MUSICAL SYMBOL ISON ARCHAION",
	"BYZANTINE MUSICAL SYMBOL ISON NEO",
	"BYZANTINE MUSICAL SYMBOL KATAVA TROMIKON",
	"BYZANTINE MUSICAL SYMBOL KATAVASMA",
	"BYZANTINE MUSICAL SYMBOL KATHISTI",
	"BYZANTINE MUSICAL SYMBOL KENTIMA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL KENTIMA NEO ANO",
	"BYZANTINE MUSICAL SYMBOL KENTIMA NEO KATO",
	"BYZANTINE MUSICAL SYMBOL KENTIMA NEO MESO",
	"BYZANTINE MUSICAL SYMBOL KENTIMATA",
	"BYZANTINE MUSICAL SYMBOL KENTIMATA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL KENTIMATA NEO ANO",
	"BYZANTINE MUSICAL SYMBOL KENTIMATA NEO KATO",
	"BYZANTINE MUSICAL SYMBOL KENTIMATA NEO MESO",
	"BYZANTINE MUSICAL SYMBOL KLASMA",
	"BYZANTINE MUSICAL SYMBOL KLASMA ANO",
	"BYZANTINE MUSICAL SYMBOL KLASMA KATO",
	"BYZANTINE MUSICAL SYMBOL KONTEVMA",
	"BYZANTINE MUSICAL SYMBOL KONTEVMA ALLO",
	"BYZANTINE MUSICAL SYMBOL KORONIS",
	"BYZANTINE MUSICAL SYMBOL KOUFISMA",
	"BYZANTINE MUSICAL SYMBOL KRATIMA ALLO",
	"BYZANTINE MUSICAL SYMBOL KRATIMA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL KRATIMA NEO",
	"BYZANTINE MUSICAL SYMBOL KRATIMATA",
	"BYZANTINE MUSICAL SYMBOL KRATIMOKOUFISMA",
	"BYZANTINE MUSICAL SYMBOL KRATIMOYPORROON",
	"BYZANTINE MUSICAL SYMBOL KREMASTI",
	"BYZANTINE MUSICAL SYMBOL KYLISMA",
	"BYZANTINE MUSICAL SYMBOL LEIMMA DYO CHRONON",
	"BYZANTINE MUSICAL SYMBOL LEIMMA ENOS CHRONOU",
	"BYZANTINE MUSICAL SYMBOL LEIMMA IMISEOS CHRONOU",
	"BYZANTINE MUSICAL SYMBOL LEIMMA TESSARON CHRONON",
	"BYZANTINE MUSICAL SYMBOL LEIMMA TRION CHRONON",
	"BYZANTINE MUSICAL SYMBOL LEMOI",
	"BYZANTINE MUSICAL SYMBOL LYGISMA",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI DEYTEROS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI PROTOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA DEYTEROS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA LEGETOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS TETARTOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOVARYS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS LEGETOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA TRIFONIAS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA TRITOS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MARTYRIA VARYS ICHOS",
	"BYZANTINE MUSICAL SYMBOL MIKRON ISON",
	"BYZANTINE MUSICAL SYMBOL NANA",
	"BYZANTINE MUSICAL SYMBOL OLIGON ARCHAION",
	"BYZANTINE MUSICAL SYMBOL OLIGON NEO",
	"BYZANTINE MUSICAL SYMBOL OMALON",
	"BYZANTINE MUSICAL SYMBOL OXEIA DIPLI",
	"BYZANTINE MUSICAL SYMBOL OXEIA EKFONITIKON",
	"BYZANTINE MUSICAL SYMBOL OXEIA NEO",
	"BYZANTINE MUSICAL SYMBOL OXEIAI ARCHAION",
	"BYZANTINE MUSICAL SYMBOL OYRANISMA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL OYRANISMA NEO",
	"BYZANTINE MUSICAL SYMBOL PARAKALESMA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL PARAKALESMA NEO",
	"BYZANTINE MUSICAL SYMBOL PARAKLITIKI",
	"BYZANTINE MUSICAL SYMBOL PARAKLITIKI ARCHAION",
	"BYZANTINE MUSICAL SYMBOL PARAKLITIKI NEO",
	"BYZANTINE MUSICAL SYMBOL PARICHON",
	"BYZANTINE MUSICAL SYMBOL PELASTON",
	"BYZANTINE MUSICAL SYMBOL PELASTON NEO",
	"BYZANTINE MUSICAL SYMBOL PERISPOMENI",
	"BYZANTINE MUSICAL SYMBOL PETASMA",
	"BYZANTINE MUSICAL SYMBOL PETASTI",
	"BYZANTINE MUSICAL SYMBOL PETASTOKOUFISMA",
	"BYZANTINE MUSICAL SYMBOL PIASMA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL PIASMA NEO",
	"BYZANTINE MUSICAL SYMBOL PSIFISTOLYGISMA",
	"BYZANTINE MUSICAL SYMBOL PSIFISTON",
	"BYZANTINE MUSICAL SYMBOL PSIFISTON NEO",
	"BYZANTINE MUSICAL SYMBOL PSIFISTOPARAKALESMA",
	"BYZANTINE MUSICAL SYMBOL PSIFISTOSYNAGMA",
	"BYZANTINE MUSICAL SYMBOL PSILI",
	"BYZANTINE MUSICAL SYMBOL PSILON",
	"BYZANTINE MUSICAL SYMBOL RAPISMA",
	"BYZANTINE MUSICAL SYMBOL REVMA",
	"BYZANTINE MUSICAL SYMBOL SAXIMATA",
	"BYZANTINE MUSICAL SYMBOL SEISMA",
	"BYZANTINE MUSICAL SYMBOL SEISMA NEO",
	"BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS",
	"BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS DISIMOU",
	"BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TETRASIMOU",
	"BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TRISIMOU",
	"BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS",
	"BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS DISIMOU",
	"BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TETRASIMOU",
	"BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TRISIMOU",
	"BYZANTINE MUSICAL SYMBOL STAVROS",
	"BYZANTINE MUSICAL SYMBOL STAVROS APODEXIA",
	"BYZANTINE MUSICAL SYMBOL STIGMA",
	"BYZANTINE MUSICAL SYMBOL STRAGGISMATA",
	"BYZANTINE MUSICAL SYMBOL SYNAGMA ARCHAION",
	"BYZANTINE MUSICAL SYMBOL SYNAGMA META STAVROU",
	"BYZANTINE MUSICAL SYMBOL SYNAGMA NEO",
	"BYZANTINE MUSICAL SYMBOL SYNEVMA",
	"BYZANTINE MUSICAL SYMBOL SYRMA",
	"BYZANTINE MUSICAL SYMBOL SYRMATIKI",
	"BYZANTINE MUSICAL SYMBOL TELEIA",
	"BYZANTINE MUSICAL SYMBOL TESSERA",
	"BYZANTINE MUSICAL SYMBOL TETRAPLI",
	"BYZANTINE MUSICAL SYMBOL THEMA",
	"BYZANTINE MUSICAL SYMBOL THEMA APLOUN",
	"BYZANTINE MUSICAL SYMBOL THEMATISMOS ESO",
	"BYZANTINE MUSICAL SYMBOL THEMATISMOS EXO",
	"BYZANTINE MUSICAL SYMBOL THES KAI APOTHES",
	"BYZANTINE MUSICAL SYMBOL THITA",
	"BYZANTINE MUSICAL SYMBOL TINAGMA",
	"BYZANTINE MUSICAL SYMBOL TRIA",
	"BYZANTINE MUSICAL SYMBOL TRIGORGON",
	"BYZANTINE MUSICAL SYMBOL TRIPLI",
	"BYZANTINE MUSICAL SYMBOL TROMIKOLYGISMA",
	"BYZANTINE MUSICAL SYMBOL TROMIKON ALLO",
	"BYZANTINE MUSICAL SYMBOL TROMIKON ARCHAION",
	"BYZANTINE MUSICAL SYMBOL TROMIKON NEO",
	"BYZANTINE MUSICAL SYMBOL TROMIKOPARAKALESMA",
	"BYZANTINE MUSICAL SYMBOL TROMIKOPSIFISTON",
	"BYZANTINE MUSICAL SYMBOL TROMIKOSYNAGMA",
	"BYZANTINE MUSICAL SYMBOL VAREIA DIPLI",
	"BYZANTINE MUSICAL SYMBOL VAREIA EKFONITIKON",
	"BYZANTINE MUSICAL SYMBOL VAREIA NEO",
	"BYZANTINE MUSICAL SYMBOL VAREIAI ARCHAION",
	"BYZANTINE MUSICAL SYMBOL VATHY",
	"BYZANTINE MUSICAL SYMBOL XIRON KLASMA",
	"BYZANTINE MUSICAL SYMBOL YFEN ANO",
	"BYZANTINE MUSICAL SYMBOL YFEN KATO",
	"BYZANTINE MUSICAL SYMBOL YFESIS APLI DYO DODEKATA",
	"BYZANTINE MUSICAL SYMBOL YFESIS DIGRAMMOS EX DODEKATA",
	"BYZANTINE MUSICAL SYMBOL YFESIS MONOGRAMMOS TESSERA DODEKATA",
	"BYZANTINE MUSICAL SYMBOL YFESIS TRIGRAMMOS OKTO DODEKATA",
	"BYZANTINE MUSICAL SYMBOL YFESIS TRITIMORION",
	"BYZANTINE MUSICAL SYMBOL YPOKRISIS",
	"BYZANTINE MUSICAL SYMBOL YPOKRISIS DIPLI",
	"BYZANTINE MUSICAL SYMBOL YPORROI",
	"BYZANTINE MUSICAL SYMBOL YPSILI",
	"CACTUS",
	"CADA UNA",
	"CADUCEUS",
	"CALENDAR",
	"CAMERA",
	"CANADIAN SYLLABICS A",
	"CANADIAN SYLLABICS AA",
	"CANADIAN SYLLABICS AAI",
	"CANADIAN SYLLABICS AAY",
	"CANADIAN SYLLABICS AI",
	"CANADIAN SYLLABICS AIVILIK B",
	"CANADIAN SYLLABICS AN",
	"CANADIAN SYLLABICS ATHAPASCAN M",
	"CANADIAN SYLLABICS ATHAPASCAN S",
	"CANADIAN SYLLABICS AY",
	"CANADIAN SYLLABICS BEAVER DENE L",
	"CANADIAN SYLLABICS BEAVER DENE R",
	"CANADIAN SYLLABICS BIBLE-CREE Y",
	"CANADIAN SYLLABICS BLACKFOOT A",
	"CANADIAN SYLLABICS BLACKFOOT E",
	"CANADIAN SYLLABICS BLACKFOOT I",
	"CANADIAN SYLLABICS BLACKFOOT KA",
	"CANADIAN SYLLABICS BLACKFOOT KE",
	"CANADIAN SYLLABICS BLACKFOOT KI",
	"CANADIAN SYLLABICS BLACKFOOT KO",
	"CANADIAN SYLLABICS BLACKFOOT NA",
	"CANADIAN SYLLABICS BLACKFOOT NE",
	"CANADIAN SYLLABICS BLACKFOOT NI",
	"CANADIAN SYLLABICS BLACKFOOT NO",
	"CANADIAN SYLLABICS BLACKFOOT O",
	"CANADIAN SYLLABICS BLACKFOOT S",
	"CANADIAN SYLLABICS BLACKFOOT W",
	"CANADIAN SYLLABICS BLACKFOOT WA",
	"CANADIAN SYLLABICS BLACKFOOT WE",
	"CANADIAN SYLLABICS BLACKFOOT WI",
	"CANADIAN SYLLABICS BLACKFOOT WO",
	"CANADIAN SYLLABICS C",
	"CANADIAN SYLLABICS CA",
	"CANADIAN SYLLABICS CAA",
	"CANADIAN SYLLABICS CAAI",
	"CANADIAN SYLLABICS CARRIER CHA",
	"CANADIAN SYLLABICS CARRIER CHE",
	"CANADIAN SYLLABICS CARRIER CHEE",
	"CANADIAN SYLLABICS CARRIER CHI",
	"CANADIAN SYLLABICS CARRIER CHO",
	"CANADIAN SYLLABICS CARRIER CHU",
	"CANADIAN SYLLABICS CARRIER DEE",
	"CANADIAN SYLLABICS CARRIER DENE GEE",
	"CANADIAN SYLLABICS CARRIER DENTAL S",
	"CANADIAN SYLLABICS CARRIER DI",
	"CANADIAN SYLLABICS CARRIER DLA",
	"CANADIAN SYLLABICS CARRIER DLE",
	"CANADIAN SYLLABICS CARRIER DLEE",
	"CANADIAN SYLLABICS CARRIER DLI",
	"CANADIAN SYLLABICS CARRIER DLO",
	"CANADIAN SYLLABICS CARRIER DLU",
	"CANADIAN SYLLABICS CARRIER DZA",
	"CANADIAN SYLLABICS CARRIER DZE",
	"CANADIAN SYLLABICS CARRIER DZEE",
	"CANADIAN SYLLABICS CARRIER DZI",
	"CANADIAN SYLLABICS CARRIER DZO",
	"CANADIAN SYLLABICS CARRIER DZU",
	"CANADIAN SYLLABICS CARRIER EE",
	"CANADIAN SYLLABICS CARRIER GA",
	"CANADIAN SYLLABICS CARRIER GAA",
	"CANADIAN SYLLABICS CARRIER GE",
	"CANADIAN SYLLABICS CARRIER GEE",
	"CANADIAN SYLLABICS CARRIER GHA",
	"CANADIAN SYLLABICS CARRIER GHE",
	"CANADIAN SYLLABICS CARRIER GHEE",
	"CANADIAN SYLLABICS CARRIER GHI",
	"CANADIAN SYLLABICS CARRIER GHO",
	"CANADIAN SYLLABICS CARRIER GHU",
	"CANADIAN SYLLABICS CARRIER GI",
	"CANADIAN SYLLABICS CARRIER GO",
	"CANADIAN SYLLABICS CARRIER GU",
	"CANADIAN SYLLABICS CARRIER GWA",
	"CANADIAN SYLLABICS CARRIER GWU",
	"CANADIAN SYLLABICS CARRIER H",
	"CANADIAN SYLLABICS CARRIER HEE",
	"CANADIAN SYLLABICS CARRIER HI",
	"CANADIAN SYLLABICS CARRIER HWA",
	"CANADIAN SYLLABICS CARRIER HWE",
	"CANADIAN SYLLABICS CARRIER HWEE",
	"CANADIAN SYLLABICS CARRIER HWI",
	"CANADIAN SYLLABICS CARRIER HWO",
	"CANADIAN SYLLABICS CARRIER HWU",
	"CANADIAN SYLLABICS CARRIER I",
	"CANADIAN SYLLABICS CARRIER INITIAL Z",
	"CANADIAN SYLLABICS CARRIER JA",
	"CANADIAN SYLLABICS CARRIER JE",
	"CANADIAN SYLLABICS CARRIER JEE",
	"CANADIAN SYLLABICS CARRIER JI",
	"CANADIAN SYLLABICS CARRIER JJA",
	"CANADIAN SYLLABICS CARRIER JJE",
	"CANADIAN SYLLABICS CARRIER JJEE",
	"CANADIAN SYLLABICS CARRIER JJI",
	"CANADIAN SYLLABICS CARRIER JJO",
	"CANADIAN SYLLABICS CARRIER JJU",
	"CANADIAN SYLLABICS CARRIER JO",
	"CANADIAN SYLLABICS CARRIER JU",
	"CANADIAN SYLLABICS CARRIER JWA",
	"CANADIAN SYLLABICS CARRIER KHA",
	"CANADIAN SYLLABICS CARRIER KHE",
	"CANADIAN SYLLABICS CARRIER KHEE",
	"CANADIAN SYLLABICS CARRIER KHI",
	"CANADIAN SYLLABICS CARRIER KHO",
	"CANADIAN SYLLABICS CARRIER KHU",
	"CANADIAN SYLLABICS CARRIER KK",
	"CANADIAN SYLLABICS CARRIER KKA",
	"CANADIAN SYLLABICS CARRIER KKE",
	"CANADIAN SYLLABICS CARRIER KKEE",
	"CANADIAN SYLLABICS CARRIER KKI",
	"CANADIAN SYLLABICS CARRIER KKO",
	"CANADIAN SYLLABICS CARRIER KKU",
	"CANADIAN SYLLABICS CARRIER LA",
	"CANADIAN SYLLABICS CARRIER LE",
	"CANADIAN SYLLABICS CARRIER LEE",
	"CANADIAN SYLLABICS CARRIER LHA",
	"CANADIAN SYLLABICS CARRIER LHE",
	"CANADIAN SYLLABICS CARRIER LHEE",
	"CANADIAN SYLLABICS CARRIER LHI",
	"CANADIAN SYLLABICS CARRIER LHO",
	"CANADIAN SYLLABICS CARRIER LHU",
	"CANADIAN SYLLABICS CARRIER LI",
	"CANADIAN SYLLABICS CARRIER LO",
	"CANADIAN SYLLABICS CARRIER LU",
	"CANADIAN SYLLABICS CARRIER MA",
	"CANADIAN SYLLABICS CARRIER ME",
	"CANADIAN SYLLABICS CARRIER MEE",
	"CANADIAN SYLLABICS CARRIER MI",
	"CANADIAN SYLLABICS CARRIER MO",
	"CANADIAN SYLLABICS CARRIER MU",
	"CANADIAN SYLLABICS CARRIER NA",
	"CANADIAN SYLLABICS CARRIER NE",
	"CANADIAN SYLLABICS CARRIER NEE",
	"CANADIAN SYLLABICS CARRIER NG",
	"CANADIAN SYLLABICS CARRIER NI",
	"CANADIAN SYLLABICS CARRIER NO",
	"CANADIAN SYLLABICS CARRIER NU",
	"CANADIAN SYLLABICS CARRIER P",
	"CANADIAN SYLLABICS CARRIER PA",
	"CANADIAN SYLLABICS CARRIER PE",
	"CANADIAN SYLLABICS CARRIER PEE",
	"CANADIAN SYLLABICS CARRIER PI",
	"CANADIAN SYLLABICS CARRIER PO",
	"CANADIAN SYLLABICS CARRIER PU",
	"CANADIAN SYLLABICS CARRIER RA",
	"CANADIAN SYLLABICS CARRIER RE",
	"CANADIAN SYLLABICS CARRIER REE",
	"CANADIAN SYLLABICS CARRIER RI",
	"CANADIAN SYLLABICS CARRIER RO",
	"CANADIAN SYLLABICS CARRIER RU",
	"CANADIAN SYLLABICS CARRIER SA",
	"CANADIAN SYLLABICS CARRIER SE",
	"CANADIAN SYLLABICS CARRIER SEE",
	"CANADIAN SYLLABICS CARRIER SH",
	"CANADIAN SYLLABICS CARRIER SHA",
	"CANADIAN SYLLABICS CARRIER SHE",
	"CANADIAN SYLLABICS CARRIER SHEE",
	"CANADIAN SYLLABICS CARRIER SHI",
	"CANADIAN SYLLABICS CARRIER SHO",
	"CANADIAN SYLLABICS CARRIER SHU",
	"CANADIAN SYLLABICS CARRIER SI",
	"CANADIAN SYLLABICS CARRIER SO",
	"CANADIAN SYLLABICS CARRIER SU",
	"CANADIAN SYLLABICS CARRIER THA",
	"CANADIAN SYLLABICS CARRIER THE",
	"CANADIAN SYLLABICS CARRIER THEE",
	"CANADIAN SYLLABICS CARRIER THI",
	"CANADIAN SYLLABICS CARRIER THO",
	"CANADIAN SYLLABICS CARRIER THU",
	"CANADIAN SYLLABICS CARRIER TLA",
	"CANADIAN SYLLABICS CARRIER TLE",
	"CANADIAN SYLLABICS CARRIER TLEE",
	"CANADIAN SYLLABICS CARRIER TLHA",
	"CANADIAN SYLLABICS CARRIER TLHE",
	"CANADIAN SYLLABICS CARRIER TLHEE",
	"CANADIAN SYLLABICS CARRIER TLHI",
	"CANADIAN SYLLABICS CARRIER TLHO",
	"CANADIAN SYLLABICS CARRIER TLHU",
	"CANADIAN SYLLABICS CARRIER TLI",
	"CANADIAN SYLLABICS CARRIER TLO",
	"CANADIAN SYLLABICS CARRIER TLU",
	"CANADIAN SYLLABICS CARRIER TSA",
	"CANADIAN SYLLABICS CARRIER TSE",
	"CANADIAN SYLLABICS CARRIER TSEE",
	"CANADIAN SYLLABICS CARRIER TSI",
	"CANADIAN SYLLABICS CARRIER TSO",
	"CANADIAN SYLLABICS CARRIER TSU",
	"CANADIAN SYLLABICS CARRIER TTA",
	"CANADIAN SYLLABICS CARRIER TTE",
	"CANADIAN SYLLABICS CARRIER TTEE",
	"CANADIAN SYLLABICS CARRIER TTI",
	"CANADIAN SYLLABICS CARRIER TTO",
	"CANADIAN SYLLABICS CARRIER TTSA",
	"CANADIAN SYLLABICS CARRIER TTSE",
	"CANADIAN SYLLABICS CARRIER TTSEE",
	"CANADIAN SYLLABICS CARRIER TTSI",
	"CANADIAN SYLLABICS CARRIER TTSO",
	"CANADIAN SYLLABICS CARRIER TTSU",
	"CANADIAN SYLLABICS CARRIER TTU",
	"CANADIAN SYLLABICS CARRIER WA",
	"CANADIAN SYLLABICS CARRIER WE",
	"CANADIAN SYLLABICS CARRIER WEE",
	"CANADIAN SYLLABICS CARRIER WI",
	"CANADIAN SYLLABICS CARRIER WO",
	"CANADIAN SYLLABICS CARRIER WU",
	"CANADIAN SYLLABICS CARRIER YA",
	"CANADIAN SYLLABICS CARRIER YE",
	"CANADIAN SYLLABICS CARRIER YEE",
	"CANADIAN SYLLABICS CARRIER YI",
	"CANADIAN SYLLABICS CARRIER YO",
	"CANADIAN SYLLABICS CARRIER YU",
	"CANADIAN SYLLABICS CARRIER Z",
	"CANADIAN SYLLABICS CARRIER ZA",
	"CANADIAN SYLLABICS CARRIER ZE",
	"CANADIAN SYLLABICS CARRIER ZEE",
	"CANADIAN SYLLABICS CARRIER ZI",
	"CANADIAN SYLLABICS CARRIER ZO",
	"CANADIAN SYLLABICS CARRIER ZU",
	"CANADIAN SYLLABICS CE",
	"CANADIAN SYLLABICS CHI SIGN",
	"CANADIAN SYLLABICS CI",
	"CANADIAN SYLLABICS CII",
	"CANADIAN SYLLABICS CO",
	"CANADIAN SYLLABICS COO",
	"CANADIAN SYLLABICS CWA",
	"CANADIAN SYLLABICS CWAA",
	"CANADIAN SYLLABICS CWE",
	"CANADIAN SYLLABICS CWI",
	"CANADIAN SYLLABICS CWII",
	"CANADIAN SYLLABICS CWO",
	"CANADIAN SYLLABICS CWOO",
	"CANADIAN SYLLABICS E",
	"CANADIAN SYLLABICS EASTERN W",
	"CANADIAN SYLLABICS EN",
	"CANADIAN SYLLABICS F",
	"CANADIAN SYLLABICS FA",
	"CANADIAN SYLLABICS FAA",
	"CANADIAN SYLLABICS FAAI",
	"CANADIAN SYLLABICS FE",
	"CANADIAN SYLLABICS FI",
	"CANADIAN SYLLABICS FII",
	"CANADIAN SYLLABICS FINAL ACUTE",
	"CANADIAN SYLLABICS FINAL BOTTOM HALF RING",
	"CANADIAN SYLLABICS FINAL DOUBLE ACUTE",
	"CANADIAN SYLLABICS FINAL DOUBLE SHORT VERTICAL STROKES",
	"CANADIAN SYLLABICS FINAL DOWN TACK",
	"CANADIAN SYLLABICS FINAL GRAVE",
	"CANADIAN SYLLABICS FINAL MIDDLE DOT",
	"CANADIAN SYLLABICS FINAL PLUS",
	"CANADIAN SYLLABICS FINAL RAISED DOT",
	"CANADIAN SYLLABICS FINAL RIGHT HALF RING",
	"CANADIAN SYLLABICS FINAL RING",
	"CANADIAN SYLLABICS FINAL SHORT HORIZONTAL STROKE",
	"CANADIAN SYLLABICS FINAL SMALL RING",
	"CANADIAN SYLLABICS FINAL TOP HALF RING",
	"CANADIAN SYLLABICS FO",
	"CANADIAN SYLLABICS FOO",
	"CANADIAN SYLLABICS FULL STOP",
	"CANADIAN SYLLABICS FWAA",
	"CANADIAN SYLLABICS GLOTTAL STOP",
	"CANADIAN SYLLABICS HK",
	"CANADIAN SYLLABICS HYPHEN",
	"CANADIAN SYLLABICS I",
	"CANADIAN SYLLABICS II",
	"CANADIAN SYLLABICS IN",
	"CANADIAN SYLLABICS K",
	"CANADIAN SYLLABICS KA",
	"CANADIAN SYLLABICS KAA",
	"CANADIAN SYLLABICS KAAI",
	"CANADIAN SYLLABICS KAY",
	"CANADIAN SYLLABICS KE",
	"CANADIAN SYLLABICS KI",
	"CANADIAN SYLLABICS KII",
	"CANADIAN SYLLABICS KO",
	"CANADIAN SYLLABICS KOO",
	"CANADIAN SYLLABICS KW",
	"CANADIAN SYLLABICS KWA",
	"CANADIAN SYLLABICS KWAA",
	"CANADIAN SYLLABICS KWAY",
	"CANADIAN SYLLABICS KWE",
	"CANADIAN SYLLABICS KWI",
	"CANADIAN SYLLABICS KWII",
	"CANADIAN SYLLABICS KWO",
	"CANADIAN SYLLABICS KWOO",
	"CANADIAN SYLLABICS L",
	"CANADIAN SYLLABICS LA",
	"CANADIAN SYLLABICS LAA",
	"CANADIAN SYLLABICS LAAI",
	"CANADIAN SYLLABICS LAY",
	"CANADIAN SYLLABICS LE",
	"CANADIAN SYLLABICS LH",
	"CANADIAN SYLLABICS LHA",
	"CANADIAN SYLLABICS LHAA",
	"CANADIAN SYLLABICS LHI",
	"CANADIAN SYLLABICS LHII",
	"CANADIAN SYLLABICS LHO",
	"CANADIAN SYLLABICS LHOO",
	"CANADIAN SYLLABICS LI",
	"CANADIAN SYLLABICS LII",
	"CANADIAN SYLLABICS LO",
	"CANADIAN SYLLABICS LOO",
	"CANADIAN SYLLABICS LWA",
	"CANADIAN SYLLABICS LWAA",
	"CANADIAN SYLLABICS LWE",
	"CANADIAN SYLLABICS LWI",
	"CANADIAN SYLLABICS LWII",
	"CANADIAN SYLLABICS LWO",
	"CANADIAN SYLLABICS LWOO",
	"CANADIAN SYLLABICS M",
	"CANADIAN SYLLABICS MA",
	"CANADIAN SYLLABICS MAA",
	"CANADIAN SYLLABICS MAAI",
	"CANADIAN SYLLABICS MAY",
	"CANADIAN SYLLABICS ME",
	"CANADIAN SYLLABICS MEDIAL L",
	"CANADIAN SYLLABICS MEDIAL R",
	"CANADIAN SYLLABICS MH",
	"CANADIAN SYLLABICS MI",
	"CANADIAN SYLLABICS MII",
	"CANADIAN SYLLABICS MO",
	"CANADIAN SYLLABICS MOO",
	"CANADIAN SYLLABICS MOOSE-CREE SK",
	"CANADIAN SYLLABICS MWA",
	"CANADIAN SYLLABICS MWAA",
	"CANADIAN SYLLABICS MWE",
	"CANADIAN SYLLABICS MWI",
	"CANADIAN SYLLABICS MWII",
	"CANADIAN SYLLABICS MWO",
	"CANADIAN SYLLABICS MWOO",
	"CANADIAN SYLLABICS N",
	"CANADIAN SYLLABICS N-CREE THE",
	"CANADIAN SYLLABICS N-CREE THI",
	"CANADIAN SYLLABICS N-CREE THII",
	"CANADIAN SYLLABICS NA",
	"CANADIAN SYLLABICS NAA",
	"CANADIAN SYLLABICS NAAI",
	"CANADIAN SYLLABICS NASKAPI CWAA",
	"CANADIAN SYLLABICS NASKAPI KWAA",
	"CANADIAN SYLLABICS NASKAPI MWAA",
	"CANADIAN SYLLABICS NASKAPI NWAA",
	"CANADIAN SYLLABICS NASKAPI S-W",
	"CANADIAN SYLLABICS NASKAPI SCWA",
	"CANADIAN SYLLABICS NASKAPI SKW",
	"CANADIAN SYLLABICS NASKAPI SKWA",
	"CANADIAN SYLLABICS NASKAPI SPWA",
	"CANADIAN SYLLABICS NASKAPI STWA",
	"CANADIAN SYLLABICS NASKAPI SWAA",
	"CANADIAN SYLLABICS NASKAPI TWAA",
	"CANADIAN SYLLABICS NASKAPI WAA",
	"CANADIAN SYLLABICS NASKAPI WOO",
	"CANADIAN SYLLABICS NASKAPI YWAA",
	"CANADIAN SYLLABICS NAY",
	"CANADIAN SYLLABICS NE",
	"CANADIAN SYLLABICS NG",
	"CANADIAN SYLLABICS NGA",
	"CANADIAN SYLLABICS NGAA",
	"CANADIAN SYLLABICS NGAAI",
	"CANADIAN SYLLABICS NGAI",
	"CANADIAN SYLLABICS NGI",
	"CANADIAN SYLLABICS NGII",
	"CANADIAN SYLLABICS NGO",
	"CANADIAN SYLLABICS NGOO",
	"CANADIAN SYLLABICS NH",
	"CANADIAN SYLLABICS NI",
	"CANADIAN SYLLABICS NII",
	"CANADIAN SYLLABICS NNG",
	"CANADIAN SYLLABICS NNGA",
	"CANADIAN SYLLABICS NNGAA",
	"CANADIAN SYLLABICS NNGI",
	"CANADIAN SYLLABICS NNGII",
	"CANADIAN SYLLABICS NNGO",
	"CANADIAN SYLLABICS NNGOO",
	"CANADIAN SYLLABICS NO",
	"CANADIAN SYLLABICS NOO",
	"CANADIAN SYLLABICS NOY",
	"CANADIAN SYLLABICS NUNAVIK H",
	"CANADIAN SYLLABICS NUNAVIK HA",
	"CANADIAN SYLLABICS NUNAVIK HAA",
	"CANADIAN SYLLABICS NUNAVIK HE",
	"CANADIAN SYLLABICS NUNAVIK HI",
	"CANADIAN SYLLABICS NUNAVIK HII",
	"CANADIAN SYLLABICS NUNAVIK HO",
	"CANADIAN SYLLABICS NUNAVIK HOO",
	"CANADIAN SYLLABICS NUNAVUT H",
	"CANADIAN SYLLABICS NWA",
	"CANADIAN SYLLABICS NWAA",
	"CANADIAN SYLLABICS NWE",
	"CANADIAN SYLLABICS NWI",
	"CANADIAN SYLLABICS NWII",
	"CANADIAN SYLLABICS NWO",
	"CANADIAN SYLLABICS NWOO",
	"CANADIAN SYLLABICS O",
	"CANADIAN SYLLABICS OJIBWAY C",
	"CANADIAN SYLLABICS OJIBWAY K",
	"CANADIAN SYLLABICS OJIBWAY M",
	"CANADIAN SYLLABICS OJIBWAY N",
	"CANADIAN SYLLABICS OJIBWAY NWI",
	"CANADIAN SYLLABICS OJIBWAY NWII",
	"CANADIAN SYLLABICS OJIBWAY NWO",
	"CANADIAN SYLLABICS OJIBWAY NWOO",
	"CANADIAN SYLLABICS OJIBWAY P",
	"CANADIAN SYLLABICS OJIBWAY S",
	"CANADIAN SYLLABICS OJIBWAY SH",
	"CANADIAN SYLLABICS OJIBWAY T",
	"CANADIAN SYLLABICS ON",
	"CANADIAN SYLLABICS OO",
	"CANADIAN SYLLABICS OY",
	"CANADIAN SYLLABICS P",
	"CANADIAN SYLLABICS PA",
	"CANADIAN SYLLABICS PAA",
	"CANADIAN SYLLABICS PAAI",
	"CANADIAN SYLLABICS PAY",
	"CANADIAN SYLLABICS PE",
	"CANADIAN SYLLABICS PI",
	"CANADIAN SYLLABICS PII",
	"CANADIAN SYLLABICS PO",
	"CANADIAN SYLLABICS POO",
	"CANADIAN SYLLABICS POY",
	"CANADIAN SYLLABICS PWA",
	"CANADIAN SYLLABICS PWAA",
	"CANADIAN SYLLABICS PWE",
	"CANADIAN SYLLABICS PWI",
	"CANADIAN SYLLABICS PWII",
	"CANADIAN SYLLABICS PWO",
	"CANADIAN SYLLABICS PWOO",
	"CANADIAN SYLLABICS PWOY",
	"CANADIAN SYLLABICS Q",
	"CANADIAN SYLLABICS QA",
	"CANADIAN SYLLABICS QAA",
	"CANADIAN SYLLABICS QAAI",
	"CANADIAN SYLLABICS QAI",
	"CANADIAN SYLLABICS QI",
	"CANADIAN SYLLABICS QII",
	"CANADIAN SYLLABICS QO",
	"CANADIAN SYLLABICS QOO",
	"CANADIAN SYLLABICS R",
	"CANADIAN SYLLABICS R-CREE RE",
	"CANADIAN SYLLABICS R-CREE RWE",
	"CANADIAN SYLLABICS RA",
	"CANADIAN SYLLABICS RAA",
	"CANADIAN SYLLABICS RAAI",
	"CANADIAN SYLLABICS RAY",
	"CANADIAN SYLLABICS RE",
	"CANADIAN SYLLABICS RI",
	"CANADIAN SYLLABICS RII",
	"CANADIAN SYLLABICS RO",
	"CANADIAN SYLLABICS ROO",
	"CANADIAN SYLLABICS RWA",
	"CANADIAN SYLLABICS RWAA",
	"CANADIAN SYLLABICS RWEE",
	"CANADIAN SYLLABICS RWI",
	"CANADIAN SYLLABICS RWII",
	"CANADIAN SYLLABICS RWO",
	"CANADIAN SYLLABICS RWOO",
	"CANADIAN SYLLABICS S",
	"CANADIAN SYLLABICS SA",
	"CANADIAN SYLLABICS SAA",
	"CANADIAN SYLLABICS SAAI",
	"CANADIAN SYLLABICS SAY",
	"CANADIAN SYLLABICS SAYISI HA",
	"CANADIAN SYLLABICS SAYISI HE",
	"CANADIAN SYLLABICS SAYISI HI",
	"CANADIAN SYLLABICS SAYISI HO",
	"CANADIAN SYLLABICS SAYISI HOO",
	"CANADIAN SYLLABICS SAYISI JI",
	"CANADIAN SYLLABICS SAYISI JU",
	"CANADIAN SYLLABICS SAYISI JUU",
	"CANADIAN SYLLABICS SAYISI M",
	"CANADIAN SYLLABICS SAYISI SHA",
	"CANADIAN SYLLABICS SAYISI SHE",
	"CANADIAN SYLLABICS SAYISI SHI",
	"CANADIAN SYLLABICS SAYISI SHO",
	"CANADIAN SYLLABICS SAYISI SHOO",
	"CANADIAN SYLLABICS SAYISI SHWE",
	"CANADIAN SYLLABICS SAYISI TH",
	"CANADIAN SYLLABICS SAYISI YI",
	"CANADIAN SYLLABICS SE",
	"CANADIAN SYLLABICS SH",
	"CANADIAN SYLLABICS SHA",
	"CANADIAN SYLLABICS SHAA",
	"CANADIAN SYLLABICS SHAY",
	"CANADIAN SYLLABICS SHE",
	"CANADIAN SYLLABICS SHI",
	"CANADIAN SYLLABICS SHII",
	"CANADIAN SYLLABICS SHO",
	"CANADIAN SYLLABICS SHOO",
	"CANADIAN SYLLABICS SHOY",
	"CANADIAN SYLLABICS SHWA",
	"CANADIAN SYLLABICS SHWAA",
	"CANADIAN SYLLABICS SHWE",
	"CANADIAN SYLLABICS SHWI",
	"CANADIAN SYLLABICS SHWII",
	"CANADIAN SYLLABICS SHWO",
	"CANADIAN SYLLABICS SHWOO",
	"CANADIAN SYLLABICS SHWOY",
	"CANADIAN SYLLABICS SI",
	"CANADIAN SYLLABICS SII",
	"CANADIAN SYLLABICS SO",
	"CANADIAN SYLLABICS SOO",
	"CANADIAN SYLLABICS SOUTH-SLAVEY KAH",
	"CANADIAN SYLLABICS SOUTH-SLAVEY KEH",
	"CANADIAN SYLLABICS SOUTH-SLAVEY KIH",
	"CANADIAN SYLLABICS SOUTH-SLAVEY KOH",
	"CANADIAN SYLLABICS SOY",
	"CANADIAN SYLLABICS SW",
	"CANADIAN SYLLABICS SWA",
	"CANADIAN SYLLABICS SWAA",
	"CANADIAN SYLLABICS SWE",
	"CANADIAN SYLLABICS SWI",
	"CANADIAN SYLLABICS SWII",
	"CANADIAN SYLLABICS SWO",
	"CANADIAN SYLLABICS SWOO",
	"CANADIAN SYLLABICS T",
	"CANADIAN SYLLABICS TA",
	"CANADIAN SYLLABICS TAA",
	"CANADIAN SYLLABICS TAAI",
	"CANADIAN SYLLABICS TAY",
	"CANADIAN SYLLABICS TE",
	"CANADIAN SYLLABICS TH",
	"CANADIAN SYLLABICS TH-CREE TH",
	"CANADIAN SYLLABICS TH-CREE THA",
	"CANADIAN SYLLABICS TH-CREE THAA",
	"CANADIAN SYLLABICS TH-CREE THE",
	"CANADIAN SYLLABICS TH-CREE THI",
	"CANADIAN SYLLABICS TH-CREE THII",
	"CANADIAN SYLLABICS TH-CREE THO",
	"CANADIAN SYLLABICS TH-CREE THOO",
	"CANADIAN SYLLABICS THA",
	"CANADIAN SYLLABICS THAA",
	"CANADIAN SYLLABICS THE",
	"CANADIAN SYLLABICS THI",
	"CANADIAN SYLLABICS THII",
	"CANADIAN SYLLABICS THO",
	"CANADIAN SYLLABICS THOO",
	"CANADIAN SYLLABICS THWA",
	"CANADIAN SYLLABICS THWAA",
	"CANADIAN SYLLABICS THWE",
	"CANADIAN SYLLABICS TI",
	"CANADIAN SYLLABICS TII",
	"CANADIAN SYLLABICS TLHA",
	"CANADIAN SYLLABICS TLHE",
	"CANADIAN SYLLABICS TLHI",
	"CANADIAN SYLLABICS TLHO",
	"CANADIAN SYLLABICS TLHOO",
	"CANADIAN SYLLABICS TLHWE",
	"CANADIAN SYLLABICS TO",
	"CANADIAN SYLLABICS TOO",
	"CANADIAN SYLLABICS TTA",
	"CANADIAN SYLLABICS TTE",
	"CANADIAN SYLLABICS TTH",
	"CANADIAN SYLLABICS TTHA",
	"CANADIAN SYLLABICS TTHAA",
	"CANADIAN SYLLABICS TTHE",
	"CANADIAN SYLLABICS TTHI",
	"CANADIAN SYLLABICS TTHO",
	"CANADIAN SYLLABICS TTHOO",
	"CANADIAN SYLLABICS TTHWE",
	"CANADIAN SYLLABICS TTI",
	"CANADIAN SYLLABICS TTO",
	"CANADIAN SYLLABICS TWA",
	"CANADIAN SYLLABICS TWAA",
	"CANADIAN SYLLABICS TWE",
	"CANADIAN SYLLABICS TWI",
	"CANADIAN SYLLABICS TWII",
	"CANADIAN SYLLABICS TWO",
	"CANADIAN SYLLABICS TWOO",
	"CANADIAN SYLLABICS TYA",
	"CANADIAN SYLLABICS TYE",
	"CANADIAN SYLLABICS TYI",
	"CANADIAN SYLLABICS TYO",
	"CANADIAN SYLLABICS WA",
	"CANADIAN SYLLABICS WAA",
	"CANADIAN SYLLABICS WAY",
	"CANADIAN SYLLABICS WE",
	"CANADIAN SYLLABICS WEST-CREE CWA",
	"CANADIAN SYLLABICS WEST-CREE CWAA",
	"CANADIAN SYLLABICS WEST-CREE CWE",
	"CANADIAN SYLLABICS WEST-CREE CWI",
	"CANADIAN SYLLABICS WEST-CREE CWII",
	"CANADIAN SYLLABICS WEST-CREE CWO",
	"CANADIAN SYLLABICS WEST-CREE CWOO",
	"CANADIAN SYLLABICS WEST-CREE FWAA",
	"CANADIAN SYLLABICS WEST-CREE KWA",
	"CANADIAN SYLLABICS WEST-CREE KWAA",
	"CANADIAN SYLLABICS WEST-CREE KWE",
	"CANADIAN SYLLABICS WEST-CREE KWI",
	"CANADIAN SYLLABICS WEST-CREE KWII",
	"CANADIAN SYLLABICS WEST-CREE KWO",
	"CANADIAN SYLLABICS WEST-CREE KWOO",
	"CANADIAN SYLLABICS WEST-CREE L",
	"CANADIAN SYLLABICS WEST-CREE LA",
	"CANADIAN SYLLABICS WEST-CREE LAA",
	"CANADIAN SYLLABICS WEST-CREE LE",
	"CANADIAN SYLLABICS WEST-CREE LO",
	"CANADIAN SYLLABICS WEST-CREE LOO",
	"CANADIAN SYLLABICS WEST-CREE LWA",
	"CANADIAN SYLLABICS WEST-CREE LWAA",
	"CANADIAN SYLLABICS WEST-CREE LWE",
	"CANADIAN SYLLABICS WEST-CREE LWI",
	"CANADIAN SYLLABICS WEST-CREE LWII",
	"CANADIAN SYLLABICS WEST-CREE LWO",
	"CANADIAN SYLLABICS WEST-CREE LWOO",
	"CANADIAN SYLLABICS WEST-CREE M",
	"CANADIAN SYLLABICS WEST-CREE MWA",
	"CANADIAN SYLLABICS WEST-CREE MWAA",
	"CANADIAN SYLLABICS WEST-CREE MWE",
	"CANADIAN SYLLABICS WEST-CREE MWI",
	"CANADIAN SYLLABICS WEST-CREE MWII",
	"CANADIAN SYLLABICS WEST-CREE MWO",
	"CANADIAN SYLLABICS WEST-CREE MWOO",
	"CANADIAN SYLLABICS WEST-CREE NWA",
	"CANADIAN SYLLABICS WEST-CREE NWAA",
	"CANADIAN SYLLABICS WEST-CREE NWE",
	"CANADIAN SYLLABICS WEST-CREE P",
	"CANADIAN SYLLABICS WEST-CREE PWA",
	"CANADIAN SYLLABICS WEST-CREE PWAA",
	"CANADIAN SYLLABICS WEST-CREE PWE",
	"CANADIAN SYLLABICS WEST-CREE PWI",
	"CANADIAN SYLLABICS WEST-CREE PWII",
	"CANADIAN SYLLABICS WEST-CREE PWO",
	"CANADIAN SYLLABICS WEST-CREE PWOO",
	"CANADIAN SYLLABICS WEST-CREE R",
	"CANADIAN SYLLABICS WEST-CREE RA",
	"CANADIAN SYLLABICS WEST-CREE RE",
	"CANADIAN SYLLABICS WEST-CREE RI",
	"CANADIAN SYLLABICS WEST-CREE RO",
	"CANADIAN SYLLABICS WEST-CREE RWAA",
	"CANADIAN SYLLABICS WEST-CREE SHWA",
	"CANADIAN SYLLABICS WEST-CREE SHWAA",
	"CANADIAN SYLLABICS WEST-CREE SHWE",
	"CANADIAN SYLLABICS WEST-CREE SHWI",
	"CANADIAN SYLLABICS WEST-CREE SHWII",
	"CANADIAN SYLLABICS WEST-CREE SHWO",
	"CANADIAN SYLLABICS WEST-CREE SHWOO",
	"CANADIAN SYLLABICS WEST-CREE SWA",
	"CANADIAN SYLLABICS WEST-CREE SWAA",
	"CANADIAN SYLLABICS WEST-CREE SWE",
	"CANADIAN SYLLABICS WEST-CREE SWI",
	"CANADIAN SYLLABICS WEST-CREE SWII",
	"CANADIAN SYLLABICS WEST-CREE SWO",
	"CANADIAN SYLLABICS WEST-CREE SWOO",
	"CANADIAN SYLLABICS WEST-CREE THWAA",
	"CANADIAN SYLLABICS WEST-CREE TWA",
	"CANADIAN SYLLABICS WEST-CREE TWAA",
	"CANADIAN SYLLABICS WEST-CREE TWE",
	"CANADIAN SYLLABICS WEST-CREE TWI",
	"CANADIAN SYLLABICS WEST-CREE TWII",
	"CANADIAN SYLLABICS WEST-CREE TWO",
	"CANADIAN SYLLABICS WEST-CREE TWOO",
	"CANADIAN SYLLABICS WEST-CREE WA",
	"CANADIAN SYLLABICS WEST-CREE WAA",
	"CANADIAN SYLLABICS WEST-CREE WE",
	"CANADIAN SYLLABICS WEST-CREE WI",
	"CANADIAN SYLLABICS WEST-CREE WII",
	"CANADIAN SYLLABICS WEST-CREE WO",
	"CANADIAN SYLLABICS WEST-CREE WOO",
	"CANADIAN SYLLABICS WEST-CREE Y",
	"CANADIAN SYLLABICS WEST-CREE YWA",
	"CANADIAN SYLLABICS WEST-CREE YWAA",
	"CANADIAN SYLLABICS WEST-CREE YWE",
	"CANADIAN SYLLABICS WEST-CREE YWI",
	"CANADIAN SYLLABICS WEST-CREE YWII",
	"CANADIAN SYLLABICS WEST-CREE YWO",
	"CANADIAN SYLLABICS WEST-CREE YWOO",
	"CANADIAN SYLLABICS WESTERN W",
	"CANADIAN SYLLABICS WI",
	"CANADIAN SYLLABICS WII",
	"CANADIAN SYLLABICS WO",
	"CANADIAN SYLLABICS WOO",
	"CANADIAN SYLLABICS WOODS-CREE FINAL TH",
	"CANADIAN SYLLABICS WOODS-CREE TH",
	"CANADIAN SYLLABICS WOODS-CREE THA",
	"CANADIAN SYLLABICS WOODS-CREE THE",
	"CANADIAN SYLLABICS WOODS-CREE THI",
	"CANADIAN SYLLABICS WOODS-CREE THO",
	"CANADIAN SYLLABICS WOODS-CREE THWA",
	"CANADIAN SYLLABICS WOODS-CREE THWAA",
	"CANADIAN SYLLABICS WOODS-CREE THWEE",
	"CANADIAN SYLLABICS WOODS-CREE THWI",
	"CANADIAN SYLLABICS WOODS-CREE THWII",
	"CANADIAN SYLLABICS WOODS-CREE THWO",
	"CANADIAN SYLLABICS WOODS-CREE THWOO",
	"CANADIAN SYLLABICS Y",
	"CANADIAN SYLLABICS Y-CREE COO",
	"CANADIAN SYLLABICS Y-CREE KOO",
	"CANADIAN SYLLABICS Y-CREE LOO",
	"CANADIAN SYLLABICS Y-CREE MOO",
	"CANADIAN SYLLABICS Y-CREE NOO",
	"CANADIAN SYLLABICS Y-CREE OO",
	"CANADIAN SYLLABICS Y-CREE POO",
	"CANADIAN SYLLABICS Y-CREE PWAA",
	"CANADIAN SYLLABICS Y-CREE SOO",
	"CANADIAN SYLLABICS Y-CREE TOO",
	"CANADIAN SYLLABICS Y-CREE W",
	"CANADIAN SYLLABICS Y-CREE YOO",
	"CANADIAN SYLLABICS YA",
	"CANADIAN SYLLABICS YAA",
	"CANADIAN SYLLABICS YAAI",
	"CANADIAN SYLLABICS YAY",
	"CANADIAN SYLLABICS YE",
	"CANADIAN SYLLABICS YI",
	"CANADIAN SYLLABICS YII",
	"CANADIAN SYLLABICS YO",
	"CANADIAN SYLLABICS YOO",
	"CANADIAN SYLLABICS YOY",
	"CANADIAN SYLLABICS YWA",
	"CANADIAN SYLLABICS YWAA",
	"CANADIAN SYLLABICS YWE",
	"CANADIAN SYLLABICS YWI",
	"CANADIAN SYLLABICS YWII",
	"CANADIAN SYLLABICS YWO",
	"CANADIAN SYLLABICS YWOO",
	"CANCEL TAG",
	"CANCER",
	"CANDY",
	"CAPRICORN",
	"CAR SLIDING",
	"CARD INDEX",
	"CARE OF",
	"CARET",
	"CARET INSERTION POINT",
	"CARIAN LETTER A",
	"CARIAN LETTER B",
	"CARIAN LETTER D",
	"CARIAN LETTER E",
	"CARIAN LETTER G",
	"CARIAN LETTER I",
	"CARIAN LETTER II",
	"CARIAN LETTER K",
	"CARIAN LETTER L",
	"CARIAN LETTER LD",
	"CARIAN LETTER M",
	"CARIAN LETTER MB",
	"CARIAN LETTER N",
	"CARIAN LETTER ND",
	"CARIAN LETTER NG",
	"CARIAN LETTER NN",
	"CARIAN LETTER O",
	"CARIAN LETTER P",
	"CARIAN LETTER Q",
	"CARIAN LETTER R",
	"CARIAN LETTER RR",
	"CARIAN LETTER S",
	"CARIAN LETTER SH",
	"CARIAN LETTER SS",
	"CARIAN LETTER ST",
	"CARIAN LETTER T",
	"CARIAN LETTER TT",
	"CARIAN LETTER U",
	"CARIAN LETTER UU",
	"CARIAN LETTER UUU",
	"CARIAN LETTER UUUU",
	"CARIAN LETTER X",
	"CARON",
	"CAROUSEL HORSE",
	"CARP STREAMER",
	"CASTLE",
	"CAT",
	"CAT FACE",
	"CAT FACE WITH TEARS OF JOY",
	"CAT FACE WITH WRY SMILE",
	"CAUTION SIGN",
	"CEDI SIGN",
	"CEDILLA",
	"CENT SIGN",
	"CENTRE LINE SYMBOL",
	"CENTRELINE LOW LINE",
	"CENTRELINE OVERLINE",
	"CERES",
	"CHAINS",
	"CHAKMA AU MARK",
	"CHAKMA DANDA",
	"CHAKMA DIGIT EIGHT",
	"CHAKMA DIGIT FIVE",
	"CHAKMA DIGIT FOUR",
	"CHAKMA DIGIT NINE",
	"CHAKMA DIGIT ONE",
	"CHAKMA DIGIT SEVEN",
	"CHAKMA DIGIT SIX",
	"CHAKMA DIGIT THREE",
	"CHAKMA DIGIT TWO",
	"CHAKMA DIGIT ZERO",
	"CHAKMA DOUBLE DANDA",
	"CHAKMA LETTER AA",
	"CHAKMA LETTER BAA",
	"CHAKMA LETTER BHAA",
	"CHAKMA LETTER CAA",
	"CHAKMA LETTER CHAA",
	"CHAKMA LETTER DAA",
	"CHAKMA LETTER DDAA",
	"CHAKMA LETTER DDHAA",
	"CHAKMA LETTER DHAA",
	"CHAKMA LETTER E",
	"CHAKMA LETTER GAA",
	"CHAKMA LETTER GHAA",
	"CHAKMA LETTER HAA",
	"CHAKMA LETTER I",
	"CHAKMA LETTER JAA",
	"CHAKMA LETTER JHAA",
	"CHAKMA LETTER KAA",
	"CHAKMA LETTER KHAA",
	"CHAKMA LETTER LAA",
	"CHAKMA LETTER MAA",
	"CHAKMA LETTER NAA",
	"CHAKMA LETTER NGAA",
	"CHAKMA LETTER NNAA",
	"CHAKMA LETTER NYAA",
	"CHAKMA LETTER PAA",
	"CHAKMA LETTER PHAA",
	"CHAKMA LETTER RAA",
	"CHAKMA LETTER SAA",
	"CHAKMA LETTER TAA",
	"CHAKMA LETTER THAA",
	"CHAKMA LETTER TTAA",
	"CHAKMA LETTER TTHAA",
	"CHAKMA LETTER U",
	"CHAKMA LETTER WAA",
	"CHAKMA LETTER YAA",
	"CHAKMA LETTER YYAA",
	"CHAKMA MAAYYAA",
	"CHAKMA O MARK",
	"CHAKMA QUESTION MARK",
	"CHAKMA SECTION MARK",
	"CHAKMA SIGN ANUSVARA",
	"CHAKMA SIGN CANDRABINDU",
	"CHAKMA SIGN VISARGA",
	"CHAKMA VIRAMA",
	"CHAKMA VOWEL SIGN A",
	"CHAKMA VOWEL SIGN AI",
	"CHAKMA VOWEL SIGN AU",
	"CHAKMA VOWEL SIGN E",
	"CHAKMA VOWEL SIGN I",
	"CHAKMA VOWEL SIGN II",
	"CHAKMA VOWEL SIGN O",
	"CHAKMA VOWEL SIGN OI",
	"CHAKMA VOWEL SIGN U",
	"CHAKMA VOWEL SIGN UU",
	"CHAM CONSONANT SIGN FINAL H",
	"CHAM CONSONANT SIGN FINAL M",
	"CHAM CONSONANT SIGN FINAL NG",
	"CHAM CONSONANT SIGN LA",
	"CHAM CONSONANT SIGN RA",
	"CHAM CONSONANT SIGN WA",
	"CHAM CONSONANT SIGN YA",
	"CHAM DIGIT EIGHT",
	"CHAM DIGIT FIVE",
	"CHAM DIGIT FOUR",
	"CHAM DIGIT NINE",
	"CHAM DIGIT ONE",
	"CHAM DIGIT SEVEN",
	"CHAM DIGIT SIX",
	"CHAM DIGIT THREE",
	"CHAM DIGIT TWO",
	"CHAM DIGIT ZERO",
	"CHAM LETTER A",
	"CHAM LETTER AI",
	"CHAM LETTER BA",
	"CHAM LETTER BBA",
	"CHAM LETTER BHA",
	"CHAM LETTER CHA",
	"CHAM LETTER CHHA",
	"CHAM LETTER DA",
	"CHAM LETTER DDA",
	"CHAM LETTER DHA",
	"CHAM LETTER E",
	"CHAM LETTER FINAL CH",
	"CHAM LETTER FINAL G",
	"CHAM LETTER FINAL K",
	"CHAM LETTER FINAL L",
	"CHAM LETTER FINAL N",
	"CHAM LETTER FINAL NG",
	"CHAM LETTER FINAL P",
	"CHAM LETTER FINAL R",
	"CHAM LETTER FINAL SS",
	"CHAM LETTER FINAL T",
	"CHAM LETTER FINAL Y",
	"CHAM LETTER GA",
	"CHAM LETTER GHA",
	"CHAM LETTER HA",
	"CHAM LETTER I",
	"CHAM LETTER JA",
	"CHAM LETTER JHA",
	"CHAM LETTER KA",
	"CHAM LETTER KHA",
	"CHAM LETTER LA",
	"CHAM LETTER MA",
	"CHAM LETTER MUE",
	"CHAM LETTER NA",
	"CHAM LETTER NGA",
	"CHAM LETTER NGUE",
	"CHAM LETTER NHA",
	"CHAM LETTER NHJA",
	"CHAM LETTER NHUE",
	"CHAM LETTER NUE",
	"CHAM LETTER O",
	"CHAM LETTER PA",
	"CHAM LETTER PHA",
	"CHAM LETTER PPA",
	"CHAM LETTER RA",
	"CHAM LETTER SA",
	"CHAM LETTER SSA",
	"CHAM LETTER TA",
	"CHAM LETTER THA",
	"CHAM LETTER U",
	"CHAM LETTER VA",
	"CHAM LETTER YA",
	"CHAM PUNCTUATION DANDA",
	"CHAM PUNCTUATION DOUBLE DANDA",
	"CHAM PUNCTUATION SPIRAL",
	"CHAM PUNCTUATION TRIPLE DANDA",
	"CHAM VOWEL SIGN AA",
	"CHAM VOWEL SIGN AI",
	"CHAM VOWEL SIGN AU",
	"CHAM VOWEL SIGN EI",
	"CHAM VOWEL SIGN I",
	"CHAM VOWEL SIGN II",
	"CHAM VOWEL SIGN O",
	"CHAM VOWEL SIGN OE",
	"CHAM VOWEL SIGN U",
	"CHAM VOWEL SIGN UE",
	"CHARACTER TIE",
	"CHART WITH DOWNWARDS TREND",
	"CHART WITH UPWARDS TREND",
	"CHART WITH UPWARDS TREND AND YEN SIGN",
	"CHECK MARK",
	"CHEERING MEGAPHONE",
	"CHEQUERED FLAG",
	"CHEROKEE LETTER A",
	"CHEROKEE LETTER DA",
	"CHEROKEE LETTER DE",
	"CHEROKEE LETTER DI",
	"CHEROKEE LETTER DLA",
	"CHEROKEE LETTER DO",
	"CHEROKEE LETTER DU",
	"CHEROKEE LETTER DV",
	"CHEROKEE LETTER E",
	"CHEROKEE LETTER GA",
	"CHEROKEE LETTER GE",
	"CHEROKEE LETTER GI",
	"CHEROKEE LETTER GO",
	"CHEROKEE LETTER GU",
	"CHEROKEE LETTER GV",
	"CHEROKEE LETTER HA",
	"CHEROKEE LETTER HE",
	"CHEROKEE LETTER HI",
	"CHEROKEE LETTER HNA",
	"CHEROKEE LETTER HO",
	"CHEROKEE LETTER HU",
	"CHEROKEE LETTER HV",
	"CHEROKEE LETTER I",
	"CHEROKEE LETTER KA",
	"CHEROKEE LETTER LA",
	"CHEROKEE LETTER LE",
	"CHEROKEE LETTER LI",
	"CHEROKEE LETTER LO",
	"CHEROKEE LETTER LU",
	"CHEROKEE LETTER LV",
	"CHEROKEE LETTER MA",
	"CHEROKEE LETTER ME",
	"CHEROKEE LETTER MI",
	"CHEROKEE LETTER MO",
	"CHEROKEE LETTER MU",
	"CHEROKEE LETTER NA",
	"CHEROKEE LETTER NAH",
	"CHEROKEE LETTER NE",
	"CHEROKEE LETTER NI",
	"CHEROKEE LETTER NO",
	"CHEROKEE LETTER NU",
	"CHEROKEE LETTER NV",
	"CHEROKEE LETTER O",
	"CHEROKEE LETTER QUA",
	"CHEROKEE LETTER QUE",
	"CHEROKEE LETTER QUI",
	"CHEROKEE LETTER QUO",
	"CHEROKEE LETTER QUU",
	"CHEROKEE LETTER QUV",
	"CHEROKEE LETTER S",
	"CHEROKEE LETTER SA",
	"CHEROKEE LETTER SE",
	"CHEROKEE LETTER SI",
	"CHEROKEE LETTER SO",
	"CHEROKEE LETTER SU",
	"CHEROKEE LETTER SV",
	"CHEROKEE LETTER TA",
	"CHEROKEE LETTER TE",
	"CHEROKEE LETTER TI",
	"CHEROKEE LETTER TLA",
	"CHEROKEE LETTER TLE",
	"CHEROKEE LETTER TLI",
	"CHEROKEE LETTER TLO",
	"CHEROKEE LETTER TLU",
	"CHEROKEE LETTER TLV",
	"CHEROKEE LETTER TSA",
	"CHEROKEE LETTER TSE",
	"CHEROKEE LETTER TSI",
	"CHEROKEE LETTER TSO",
	"CHEROKEE LETTER TSU",
	"CHEROKEE LETTER TSV",
	"CHEROKEE LETTER U",
	"CHEROKEE LETTER V",
	"CHEROKEE LETTER WA",
	"CHEROKEE LETTER WE",
	"CHEROKEE LETTER WI",
	"CHEROKEE LETTER WO",
	"CHEROKEE LETTER WU",
	"CHEROKEE LETTER WV",
	"CHEROKEE LETTER YA",
	"CHEROKEE LETTER YE",
	"CHEROKEE LETTER YI",
	"CHEROKEE LETTER YO",
	"CHEROKEE LETTER YU",
	"CHEROKEE LETTER YV",
	"CHERRIES",
	"CHERRY BLOSSOM",
	"CHESTNUT",
	"CHI RHO",
	"CHICKEN",
	"CHILDREN CROSSING",
	"CHIRON",
	"CHOCOLATE BAR",
	"CHRISTMAS TREE",
	"CHURCH",
	"CINEMA",
	"CIRCLE DIVIDED BY HORIZONTAL BAR AND TOP HALF DIVIDED BY VERTICAL BAR",
	"CIRCLE WITH ALL BUT UPPER LEFT QUADRANT BLACK",
	"CIRCLE WITH HORIZONTAL BAR",
	"CIRCLE WITH LEFT HALF BLACK",
	"CIRCLE WITH LOWER HALF BLACK",
	"CIRCLE WITH RIGHT HALF BLACK",
	"CIRCLE WITH SMALL CIRCLE TO THE RIGHT",
	"CIRCLE WITH SUPERIMPOSED X",
	"CIRCLE WITH TWO HORIZONTAL STROKES TO THE RIGHT",
	"CIRCLE WITH UPPER HALF BLACK",
	"CIRCLE WITH UPPER RIGHT QUADRANT BLACK",
	"CIRCLE WITH VERTICAL FILL",
	"CIRCLED ANTICLOCKWISE-ROTATED DIVISION SIGN",
	"CIRCLED ASTERISK OPERATOR",
	"CIRCLED BULLET",
	"CIRCLED CD",
	"CIRCLED CROSS POMMEE",
	"CIRCLED CROSSING LANES",
	"CIRCLED DASH",
	"CIRCLED DIGIT EIGHT",
	"CIRCLED DIGIT FIVE",
	"CIRCLED DIGIT FOUR",
	"CIRCLED DIGIT NINE",
	"CIRCLED DIGIT ONE",
	"CIRCLED DIGIT SEVEN",
	"CIRCLED DIGIT SIX",
	"CIRCLED DIGIT THREE",
	"CIRCLED DIGIT TWO",
	"CIRCLED DIGIT ZERO",
	"CIRCLED DIVISION SIGN",
	"CIRCLED DIVISION SLASH",
	"CIRCLED DOT OPERATOR",
	"CIRCLED EQUALS",
	"CIRCLED GREATER-THAN",
	"CIRCLED HANGUL CHIEUCH",
	"CIRCLED HANGUL CHIEUCH A",
	"CIRCLED HANGUL CIEUC",
	"CIRCLED HANGUL CIEUC A",
	"CIRCLED HANGUL HIEUH",
	"CIRCLED HANGUL HIEUH A",
	"CIRCLED HANGUL IEUNG",
	"CIRCLED HANGUL IEUNG A",
	"CIRCLED HANGUL IEUNG U",
	"CIRCLED HANGUL KHIEUKH",
	"CIRCLED HANGUL KHIEUKH A",
	"CIRCLED HANGUL KIYEOK",
	"CIRCLED HANGUL KIYEOK A",
	"CIRCLED HANGUL MIEUM",
	"CIRCLED HANGUL MIEUM A",
	"CIRCLED HANGUL NIEUN",
	"CIRCLED HANGUL NIEUN A",
	"CIRCLED HANGUL PHIEUPH",
	"CIRCLED HANGUL PHIEUPH A",
	"CIRCLED HANGUL PIEUP",
	"CIRCLED HANGUL PIEUP A",
	"CIRCLED HANGUL RIEUL",
	"CIRCLED HANGUL RIEUL A",
	"CIRCLED HANGUL SIOS",
	"CIRCLED HANGUL SIOS A",
	"CIRCLED HANGUL THIEUTH",
	"CIRCLED HANGUL THIEUTH A",
	"CIRCLED HANGUL TIKEUT",
	"CIRCLED HANGUL TIKEUT A",
	"CIRCLED HEAVY WHITE RIGHTWARDS ARROW",
	"CIRCLED HORIZONTAL BAR WITH NOTCH",
	"CIRCLED IDEOGRAPH ACCEPT",
	"CIRCLED IDEOGRAPH ADVANTAGE",
	"CIRCLED IDEOGRAPH ALLIANCE",
	"CIRCLED IDEOGRAPH ATTENTION",
	"CIRCLED IDEOGRAPH CENTRE",
	"CIRCLED IDEOGRAPH CONGRATULATION",
	"CIRCLED IDEOGRAPH COPY",
	"CIRCLED IDEOGRAPH CORRECT",
	"CIRCLED IDEOGRAPH EARTH",
	"CIRCLED IDEOGRAPH EIGHT",
	"CIRCLED IDEOGRAPH ENTERPRISE",
	"CIRCLED IDEOGRAPH EXCELLENT",
	"CIRCLED IDEOGRAPH FEMALE",
	"CIRCLED IDEOGRAPH FINANCIAL",
	"CIRCLED IDEOGRAPH FIRE",
	"CIRCLED IDEOGRAPH FIVE",
	"CIRCLED IDEOGRAPH FOUR",
	"CIRCLED IDEOGRAPH HAVE",
	"CIRCLED IDEOGRAPH HIGH",
	"CIRCLED IDEOGRAPH ITEM",
	"CIRCLED IDEOGRAPH KINDERGARTEN",
	"CIRCLED IDEOGRAPH KOTO",
	"CIRCLED IDEOGRAPH LABOR",
	"CIRCLED IDEOGRAPH LEFT",
	"CIRCLED IDEOGRAPH LOW",
	"CIRCLED IDEOGRAPH MALE",
	"CIRCLED IDEOGRAPH MEDICINE",
	"CIRCLED IDEOGRAPH METAL",
	"CIRCLED IDEOGRAPH MOON",
	"CIRCLED IDEOGRAPH NAME",
	"CIRCLED IDEOGRAPH NIGHT",
	"CIRCLED IDEOGRAPH NINE",
	"CIRCLED IDEOGRAPH ONE",
	"CIRCLED IDEOGRAPH PRINT",
	"CIRCLED IDEOGRAPH QUESTION",
	"CIRCLED IDEOGRAPH RELIGION",
	"CIRCLED IDEOGRAPH RESOURCE",
	"CIRCLED IDEOGRAPH REST",
	"CIRCLED IDEOGRAPH RIGHT",
	"CIRCLED IDEOGRAPH SCHOOL",
	"CIRCLED IDEOGRAPH SECRET",
	"CIRCLED IDEOGRAPH SEVEN",
	"CIRCLED IDEOGRAPH SIX",
	"CIRCLED IDEOGRAPH SOCIETY",
	"CIRCLED IDEOGRAPH SPECIAL",
	"CIRCLED IDEOGRAPH STOCK",
	"CIRCLED IDEOGRAPH STUDY",
	"CIRCLED IDEOGRAPH SUITABLE",
	"CIRCLED IDEOGRAPH SUN",
	"CIRCLED IDEOGRAPH SUPERVISE",
	"CIRCLED IDEOGRAPH TEN",
	"CIRCLED IDEOGRAPH THREE",
	"CIRCLED IDEOGRAPH TWO",
	"CIRCLED IDEOGRAPH WATER",
	"CIRCLED IDEOGRAPH WOOD",
	"CIRCLED ITALIC LATIN CAPITAL LETTER C",
	"CIRCLED ITALIC LATIN CAPITAL LETTER R",
	"CIRCLED KATAKANA A",
	"CIRCLED KATAKANA E",
	"CIRCLED KATAKANA HA",
	"CIRCLED KATAKANA HE",
	"CIRCLED KATAKANA HI",
	"CIRCLED KATAKANA HO",
	"CIRCLED KATAKANA HU",
	"CIRCLED KATAKANA I",
	"CIRCLED KATAKANA KA",
	"CIRCLED KATAKANA KE",
	"CIRCLED KATAKANA KI",
	"CIRCLED KATAKANA KO",
	"CIRCLED KATAKANA KU",
	"CIRCLED KATAKANA MA",
	"CIRCLED KATAKANA ME",
	"CIRCLED KATAKANA MI",
	"CIRCLED KATAKANA MO",
	"CIRCLED KATAKANA MU",
	"CIRCLED KATAKANA NA",
	"CIRCLED KATAKANA NE",
	"CIRCLED KATAKANA NI",
	"CIRCLED KATAKANA NO",
	"CIRCLED KATAKANA NU",
	"CIRCLED KATAKANA O",
	"CIRCLED KATAKANA RA",
	"CIRCLED KATAKANA RE",
	"CIRCLED KATAKANA RI",
	"CIRCLED KATAKANA RO",
	"CIRCLED KATAKANA RU",
	"CIRCLED KATAKANA SA",
	"CIRCLED KATAKANA SE",
	"CIRCLED KATAKANA SI",
	"CIRCLED KATAKANA SO",
	"CIRCLED KATAKANA SU",
	"CIRCLED KATAKANA TA",
	"CIRCLED KATAKANA TE",
	"CIRCLED KATAKANA TI",
	"CIRCLED KATAKANA TO",
	"CIRCLED KATAKANA TU",
	"CIRCLED KATAKANA U",
	"CIRCLED KATAKANA WA",
	"CIRCLED KATAKANA WE",
	"CIRCLED KATAKANA WI",
	"CIRCLED KATAKANA WO",
	"CIRCLED KATAKANA YA",
	"CIRCLED KATAKANA YO",
	"CIRCLED KATAKANA YU",
	"CIRCLED KOREAN CHARACTER CHAMKO",
	"CIRCLED KOREAN CHARACTER JUEUI",
	"CIRCLED LATIN CAPITAL LETTER A",
	"CIRCLED LATIN CAPITAL LETTER B",
	"CIRCLED LATIN CAPITAL LETTER C",
	"CIRCLED LATIN CAPITAL LETTER D",
	"CIRCLED LATIN CAPITAL LETTER E",
	"CIRCLED LATIN CAPITAL LETTER F",
	"CIRCLED LATIN CAPITAL LETTER G",
	"CIRCLED LATIN CAPITAL LETTER H",
	"CIRCLED LATIN CAPITAL LETTER I",
	"CIRCLED LATIN CAPITAL LETTER J",
	"CIRCLED LATIN CAPITAL LETTER K",
	"CIRCLED LATIN CAPITAL LETTER L",
	"CIRCLED LATIN CAPITAL LETTER M",
	"CIRCLED LATIN CAPITAL LETTER N",
	"CIRCLED LATIN CAPITAL LETTER O",
	"CIRCLED LATIN CAPITAL LETTER P",
	"CIRCLED LATIN CAPITAL LETTER Q",
	"CIRCLED LATIN CAPITAL LETTER R",
	"CIRCLED LATIN CAPITAL LETTER S",
	"CIRCLED LATIN CAPITAL LETTER T",
	"CIRCLED LATIN CAPITAL LETTER U",
	"CIRCLED LATIN CAPITAL LETTER V",
	"CIRCLED LATIN CAPITAL LETTER W",
	"CIRCLED LATIN CAPITAL LETTER X",
	"CIRCLED LATIN CAPITAL LETTER Y",
	"CIRCLED LATIN CAPITAL LETTER Z",
	"CIRCLED LATIN SMALL LETTER A",
	"CIRCLED LATIN SMALL LETTER B",
	"CIRCLED LATIN SMALL LETTER C",
	"CIRCLED LATIN SMALL LETTER D",
	"CIRCLED LATIN SMALL LETTER E",
	"CIRCLED LATIN SMALL LETTER F",
	"CIRCLED LATIN SMALL LETTER G",
	"CIRCLED LATIN SMALL LETTER H",
	"CIRCLED LATIN SMALL LETTER I",
	"CIRCLED LATIN SMALL LETTER J",
	"CIRCLED LATIN SMALL LETTER K",
	"CIRCLED LATIN SMALL LETTER L",
	"CIRCLED LATIN SMALL LETTER M",
	"CIRCLED LATIN SMALL LETTER N",
	"CIRCLED LATIN SMALL LETTER O",
	"CIRCLED LATIN SMALL LETTER P",
	"CIRCLED LATIN SMALL LETTER Q",
	"CIRCLED LATIN SMALL LETTER R",
	"CIRCLED LATIN SMALL LETTER S",
	"CIRCLED LATIN SMALL LETTER T",
	"CIRCLED LATIN SMALL LETTER U",
	"CIRCLED LATIN SMALL LETTER V",
	"CIRCLED LATIN SMALL LETTER W",
	"CIRCLED LATIN SMALL LETTER X",
	"CIRCLED LATIN SMALL LETTER Y",
	"CIRCLED LATIN SMALL LETTER Z",
	"CIRCLED LESS-THAN",
	"CIRCLED MINUS",
	"CIRCLED MULTIPLICATION SIGN WITH CIRCUMFLEX ACCENT",
	"CIRCLED NUMBER EIGHTEEN",
	"CIRCLED NUMBER EIGHTY ON BLACK SQUARE",
	"CIRCLED NUMBER ELEVEN",
	"CIRCLED NUMBER FIFTEEN",
	"CIRCLED NUMBER FIFTY",
	"CIRCLED NUMBER FIFTY ON BLACK SQUARE",
	"CIRCLED NUMBER FORTY",
	"CIRCLED NUMBER FORTY EIGHT",
	"CIRCLED NUMBER FORTY FIVE",
	"CIRCLED NUMBER FORTY FOUR",
	"CIRCLED NUMBER FORTY NINE",
	"CIRCLED NUMBER FORTY ON BLACK SQUARE",
	"CIRCLED NUMBER FORTY ONE",
	"CIRCLED NUMBER FORTY SEVEN",
	"CIRCLED NUMBER FORTY SIX",
	"CIRCLED NUMBER FORTY THREE",
	"CIRCLED NUMBER FORTY TWO",
	"CIRCLED NUMBER FOURTEEN",
	"CIRCLED NUMBER NINETEEN",
	"CIRCLED NUMBER SEVENTEEN",
	"CIRCLED NUMBER SEVENTY ON BLACK SQUARE",
	"CIRCLED NUMBER SIXTEEN",
	"CIRCLED NUMBER SIXTY ON BLACK SQUARE",
	"CIRCLED NUMBER TEN",
	"CIRCLED NUMBER TEN ON BLACK SQUARE",
	"CIRCLED NUMBER THIRTEEN",
	"CIRCLED NUMBER THIRTY",
	"CIRCLED NUMBER THIRTY EIGHT",
	"CIRCLED NUMBER THIRTY FIVE",
	"CIRCLED NUMBER THIRTY FOUR",
	"CIRCLED NUMBER THIRTY NINE",
	"CIRCLED NUMBER THIRTY ON BLACK SQUARE",
	"CIRCLED NUMBER THIRTY ONE",
	"CIRCLED NUMBER THIRTY SEVEN",
	"CIRCLED NUMBER THIRTY SIX",
	"CIRCLED NUMBER THIRTY THREE",
	"CIRCLED NUMBER THIRTY TWO",
	"CIRCLED NUMBER TWELVE",
	"CIRCLED NUMBER TWENTY",
	"CIRCLED NUMBER TWENTY EIGHT",
	"CIRCLED NUMBER TWENTY FIVE",
	"CIRCLED NUMBER TWENTY FOUR",
	"CIRCLED NUMBER TWENTY NINE",
	"CIRCLED NUMBER TWENTY ON BLACK SQUARE",
	"CIRCLED NUMBER TWENTY ONE",
	"CIRCLED NUMBER TWENTY SEVEN",
	"CIRCLED NUMBER TWENTY SIX",
	"CIRCLED NUMBER TWENTY THREE",
	"CIRCLED NUMBER TWENTY TWO",
	"CIRCLED OPEN CENTRE EIGHT POINTED STAR",
	"CIRCLED PARALLEL",
	"CIRCLED PERPENDICULAR",
	"CIRCLED PLUS",
	"CIRCLED POSTAL MARK",
	"CIRCLED REVERSE SOLIDUS",
	"CIRCLED RING OPERATOR",
	"CIRCLED TIMES",
	"CIRCLED TRIANGLE DOWN",
	"CIRCLED VERTICAL BAR",
	"CIRCLED WHITE BULLET",
	"CIRCLED WHITE STAR",
	"CIRCLED WZ",
	"CIRCULATION FUNCTION",
	"CIRCUMFLEX ACCENT",
	"CIRCUS TENT",
	"CITYSCAPE AT DUSK",
	"CJK COMPATIBILITY IDEOGRAPH-2F80A",
	"CJK COMPATIBILITY IDEOGRAPH-2F80B",
	"CJK COMPATIBILITY IDEOGRAPH-2F80C",
	"CJK COMPATIBILITY IDEOGRAPH-2F80D",
	"CJK COMPATIBILITY IDEOGRAPH-2F80E",
	"CJK COMPATIBILITY IDEOGRAPH-2F80F",
	"CJK COMPATIBILITY IDEOGRAPH-2F81A",
	"CJK COMPATIBILITY IDEOGRAPH-2F81B",
	"CJK COMPATIBILITY IDEOGRAPH-2F81C",
	"CJK COMPATIBILITY IDEOGRAPH-2F81D",
	"CJK COMPATIBILITY IDEOGRAPH-2F81E",
	"CJK COMPATIBILITY IDEOGRAPH-2F81F",
	"CJK COMPATIBILITY IDEOGRAPH-2F82A",
	"CJK COMPATIBILITY IDEOGRAPH-2F82B",
	"CJK COMPATIBILITY IDEOGRAPH-2F82C",
	"CJK COMPATIBILITY IDEOGRAPH-2F82D",
	"CJK COMPATIBILITY IDEOGRAPH-2F82E",
	"CJK COMPATIBILITY IDEOGRAPH-2F82F",
	"CJK COMPATIBILITY IDEOGRAPH-2F83A",
	"CJK COMPATIBILITY IDEOGRAPH-2F83B",
	"CJK COMPATIBILITY IDEOGRAPH-2F83C",
	"CJK COMPATIBILITY IDEOGRAPH-2F83D",
	"CJK COMPATIBILITY IDEOGRAPH-2F83E",
	"CJK COMPATIBILITY IDEOGRAPH-2F83F",
	"CJK COMPATIBILITY IDEOGRAPH-2F84A",
	"CJK COMPATIBILITY IDEOGRAPH-2F84B",
	"CJK COMPATIBILITY IDEOGRAPH-2F84C",
	"CJK COMPATIBILITY IDEOGRAPH-2F84D",
	"CJK COMPATIBILITY IDEOGRAPH-2F84E",
	"CJK COMPATIBILITY IDEOGRAPH-2F84F",
	"CJK COMPATIBILITY IDEOGRAPH-2F85A",
	"CJK COMPATIBILITY IDEOGRAPH-2F85B",
	"CJK COMPATIBILITY IDEOGRAPH-2F85C",
	"CJK COMPATIBILITY IDEOGRAPH-2F85D",
	"CJK COMPATIBILITY IDEOGRAPH-2F85E",
	"CJK COMPATIBILITY IDEOGRAPH-2F85F",
	"CJK COMPATIBILITY IDEOGRAPH-2F86A",
	"CJK COMPATIBILITY IDEOGRAPH-2F86B",
	"CJK COMPATIBILITY IDEOGRAPH-2F86C",
	"CJK COMPATIBILITY IDEOGRAPH-2F86D",
	"CJK COMPATIBILITY IDEOGRAPH-2F86E",
	"CJK COMPATIBILITY IDEOGRAPH-2F86F",
	"CJK COMPATIBILITY IDEOGRAPH-2F87A",
	"CJK COMPATIBILITY IDEOGRAPH-2F87B",
	"CJK COMPATIBILITY IDEOGRAPH-2F87C",
	"CJK COMPATIBILITY IDEOGRAPH-2F87D",
	"CJK COMPATIBILITY IDEOGRAPH-2F87E",
	"CJK COMPATIBILITY IDEOGRAPH-2F87F",
	"CJK COMPATIBILITY IDEOGRAPH-2F88A",
	"CJK COMPATIBILITY IDEOGRAPH-2F88B",
	"CJK COMPATIBILITY IDEOGRAPH-2F88C",
	"CJK COMPATIBILITY IDEOGRAPH-2F88D",
	"CJK COMPATIBILITY IDEOGRAPH-2F88E",
	"CJK COMPATIBILITY IDEOGRAPH-2F88F",
	"CJK COMPATIBILITY IDEOGRAPH-2F89A",
	"CJK COMPATIBILITY IDEOGRAPH-2F89B",
	"CJK COMPATIBILITY IDEOGRAPH-2F89C",
	"CJK COMPATIBILITY IDEOGRAPH-2F89D",
	"CJK COMPATIBILITY IDEOGRAPH-2F89E",
	"CJK COMPATIBILITY IDEOGRAPH-2F89F",
	"CJK COMPATIBILITY IDEOGRAPH-2F8AA",
	"CJK COMPATIBILITY IDEOGRAPH-2F8AB",
	"CJK COMPATIBILITY IDEOGRAPH-2F8AC",
	"CJK COMPATIBILITY IDEOGRAPH-2F8AD",
	"CJK COMPATIBILITY IDEOGRAPH-2F8AE",
	"CJK COMPATIBILITY IDEOGRAPH-2F8AF",
	"CJK COMPATIBILITY IDEOGRAPH-2F8BA",
	"CJK COMPATIBILITY IDEOGRAPH-2F8BB",
	"CJK COMPATIBILITY IDEOGRAPH-2F8BC",
	"CJK COMPATIBILITY IDEOGRAPH-2F8BD",
	"CJK COMPATIBILITY IDEOGRAPH-2F8BE",
	"CJK COMPATIBILITY IDEOGRAPH-2F8BF",
	"CJK COMPATIBILITY IDEOGRAPH-2F8CA",
	"CJK COMPATIBILITY IDEOGRAPH-2F8CB",
	"CJK COMPATIBILITY IDEOGRAPH-2F8CC",
	"CJK COMPATIBILITY IDEOGRAPH-2F8CD",
	"CJK COMPATIBILITY IDEOGRAPH-2F8CE",
	"CJK COMPATIBILITY IDEOGRAPH-2F8CF",
	"CJK COMPATIBILITY IDEOGRAPH-2F8DA",
	"CJK COMPATIBILITY IDEOGRAPH-2F8DB",
	"CJK COMPATIBILITY IDEOGRAPH-2F8DC",
	"CJK COMPATIBILITY IDEOGRAPH-2F8DD",
	"CJK COMPATIBILITY IDEOGRAPH-2F8DE",
	"CJK COMPATIBILITY IDEOGRAPH-2F8DF",
	"CJK COMPATIBILITY IDEOGRAPH-2F8EA",
	"CJK COMPATIBILITY IDEOGRAPH-2F8EB",
	"CJK COMPATIBILITY IDEOGRAPH-2F8EC",
	"CJK COMPATIBILITY IDEOGRAPH-2F8ED",
	"CJK COMPATIBILITY IDEOGRAPH-2F8EE",
	"CJK COMPATIBILITY IDEOGRAPH-2F8EF",
	"CJK COMPATIBILITY IDEOGRAPH-2F8FA",
	"CJK COMPATIBILITY IDEOGRAPH-2F8FB",
	"CJK COMPATIBILITY IDEOGRAPH-2F8FC",
	"CJK COMPATIBILITY IDEOGRAPH-2F8FD",
	"CJK COMPATIBILITY IDEOGRAPH-2F8FE",
	"CJK COMPATIBILITY IDEOGRAPH-2F8FF",
	"CJK COMPATIBILITY IDEOGRAPH-2F90A",
	"CJK COMPATIBILITY IDEOGRAPH-2F90B",
	"CJK COMPATIBILITY IDEOGRAPH-2F90C",
	"CJK COMPATIBILITY IDEOGRAPH-2F90D",
	"CJK COMPATIBILITY IDEOGRAPH-2F90E",
	"CJK COMPATIBILITY IDEOGRAPH-2F90F",
	"CJK COMPATIBILITY IDEOGRAPH-2F91A",
	"CJK COMPATIBILITY IDEOGRAPH-2F91B",
	"CJK COMPATIBILITY IDEOGRAPH-2F91C",
	"CJK COMPATIBILITY IDEOGRAPH-2F91D",
	"CJK COMPATIBILITY IDEOGRAPH-2F91E",
	"CJK COMPATIBILITY IDEOGRAPH-2F91F",
	"CJK COMPATIBILITY IDEOGRAPH-2F92A",
	"CJK COMPATIBILITY IDEOGRAPH-2F92B",
	"CJK COMPATIBILITY IDEOGRAPH-2F92C",
	"CJK COMPATIBILITY IDEOGRAPH-2F92D",
	"CJK COMPATIBILITY IDEOGRAPH-2F92E",
	"CJK COMPATIBILITY IDEOGRAPH-2F92F",
	"CJK COMPATIBILITY IDEOGRAPH-2F93A",
	"CJK COMPATIBILITY IDEOGRAPH-2F93B",
	"CJK COMPATIBILITY IDEOGRAPH-2F93C",
	"CJK COMPATIBILITY IDEOGRAPH-2F93D",
	"CJK COMPATIBILITY IDEOGRAPH-2F93E",
	"CJK COMPATIBILITY IDEOGRAPH-2F93F",
	"CJK COMPATIBILITY IDEOGRAPH-2F94A",
	"CJK COMPATIBILITY IDEOGRAPH-2F94B",
	"CJK COMPATIBILITY IDEOGRAPH-2F94C",
	"CJK COMPATIBILITY IDEOGRAPH-2F94D",
	"CJK COMPATIBILITY IDEOGRAPH-2F94E",
	"CJK COMPATIBILITY IDEOGRAPH-2F94F",
	"CJK COMPATIBILITY IDEOGRAPH-2F95A",
	"CJK COMPATIBILITY IDEOGRAPH-2F95B",
	"CJK COMPATIBILITY IDEOGRAPH-2F95C",
	"CJK COMPATIBILITY IDEOGRAPH-2F95D",
	"CJK COMPATIBILITY IDEOGRAPH-2F95E",
	"CJK COMPATIBILITY IDEOGRAPH-2F95F",
	"CJK COMPATIBILITY IDEOGRAPH-2F96A",
	"CJK COMPATIBILITY IDEOGRAPH-2F96B",
	"CJK COMPATIBILITY IDEOGRAPH-2F96C",
	"CJK COMPATIBILITY IDEOGRAPH-2F96D",
	"CJK COMPATIBILITY IDEOGRAPH-2F96E",
	"CJK COMPATIBILITY IDEOGRAPH-2F96F",
	"CJK COMPATIBILITY IDEOGRAPH-2F97A",
	"CJK COMPATIBILITY IDEOGRAPH-2F97B",
	"CJK COMPATIBILITY IDEOGRAPH-2F97C",
	"CJK COMPATIBILITY IDEOGRAPH-2F97D",
	"CJK COMPATIBILITY IDEOGRAPH-2F97E",
	"CJK COMPATIBILITY IDEOGRAPH-2F97F",
	"CJK COMPATIBILITY IDEOGRAPH-2F98A",
	"CJK COMPATIBILITY IDEOGRAPH-2F98B",
	"CJK COMPATIBILITY IDEOGRAPH-2F98C",
	"CJK COMPATIBILITY IDEOGRAPH-2F98D",
	"CJK COMPATIBILITY IDEOGRAPH-2F98E",
	"CJK COMPATIBILITY IDEOGRAPH-2F98F",
	"CJK COMPATIBILITY IDEOGRAPH-2F99A",
	"CJK COMPATIBILITY IDEOGRAPH-2F99B",
	"CJK COMPATIBILITY IDEOGRAPH-2F99C",
	"CJK COMPATIBILITY IDEOGRAPH-2F99D",
	"CJK COMPATIBILITY IDEOGRAPH-2F99E",
	"CJK COMPATIBILITY IDEOGRAPH-2F99F",
	"CJK COMPATIBILITY IDEOGRAPH-2F9AA",
	"CJK COMPATIBILITY IDEOGRAPH-2F9AB",
	"CJK COMPATIBILITY IDEOGRAPH-2F9AC",
	"CJK COMPATIBILITY IDEOGRAPH-2F9AD",
	"CJK COMPATIBILITY IDEOGRAPH-2F9AE",
	"CJK COMPATIBILITY IDEOGRAPH-2F9AF",
	"CJK COMPATIBILITY IDEOGRAPH-2F9BA",
	"CJK COMPATIBILITY IDEOGRAPH-2F9BB",
	"CJK COMPATIBILITY IDEOGRAPH-2F9BC",
	"CJK COMPATIBILITY IDEOGRAPH-2F9BD",
	"CJK COMPATIBILITY IDEOGRAPH-2F9BE",
	"CJK COMPATIBILITY IDEOGRAPH-2F9BF",
	"CJK COMPATIBILITY IDEOGRAPH-2F9CA",
	"CJK COMPATIBILITY IDEOGRAPH-2F9CB",
	"CJK COMPATIBILITY IDEOGRAPH-2F9CC",
	"CJK COMPATIBILITY IDEOGRAPH-2F9CD",
	"CJK COMPATIBILITY IDEOGRAPH-2F9CE",
	"CJK COMPATIBILITY IDEOGRAPH-2F9CF",
	"CJK COMPATIBILITY IDEOGRAPH-2F9DA",
	"CJK COMPATIBILITY IDEOGRAPH-2F9DB",
	"CJK COMPATIBILITY IDEOGRAPH-2F9DC",
	"CJK COMPATIBILITY IDEOGRAPH-2F9DD",
	"CJK COMPATIBILITY IDEOGRAPH-2F9DE",
	"CJK COMPATIBILITY IDEOGRAPH-2F9DF",
	"CJK COMPATIBILITY IDEOGRAPH-2F9EA",
	"CJK COMPATIBILITY IDEOGRAPH-2F9EB",
	"CJK COMPATIBILITY IDEOGRAPH-2F9EC",
	"CJK COMPATIBILITY IDEOGRAPH-2F9ED",
	"CJK COMPATIBILITY IDEOGRAPH-2F9EE",
	"CJK COMPATIBILITY IDEOGRAPH-2F9EF",
	"CJK COMPATIBILITY IDEOGRAPH-2F9FA",
	"CJK COMPATIBILITY IDEOGRAPH-2F9FB",
	"CJK COMPATIBILITY IDEOGRAPH-2F9FC",
	"CJK COMPATIBILITY IDEOGRAPH-2F9FD",
	"CJK COMPATIBILITY IDEOGRAPH-2F9FE",
	"CJK COMPATIBILITY IDEOGRAPH-2F9FF",
	"CJK COMPATIBILITY IDEOGRAPH-2FA0A",
	"CJK COMPATIBILITY IDEOGRAPH-2FA0B",
	"CJK COMPATIBILITY IDEOGRAPH-2FA0C",
	"CJK COMPATIBILITY IDEOGRAPH-2FA0D",
	"CJK COMPATIBILITY IDEOGRAPH-2FA0E",
	"CJK COMPATIBILITY IDEOGRAPH-2FA0F",
	"CJK COMPATIBILITY IDEOGRAPH-2FA1A",
	"CJK COMPATIBILITY IDEOGRAPH-2FA1B",
	"CJK COMPATIBILITY IDEOGRAPH-2FA1C",
	"CJK COMPATIBILITY IDEOGRAPH-2FA1D",
	"CJK COMPATIBILITY IDEOGRAPH-F90A",
	"CJK COMPATIBILITY IDEOGRAPH-F90B",
	"CJK COMPATIBILITY IDEOGRAPH-F90C",
	"CJK COMPATIBILITY IDEOGRAPH-F90D",
	"CJK COMPATIBILITY IDEOGRAPH-F90E",
	"CJK COMPATIBILITY IDEOGRAPH-F90F",
	"CJK COMPATIBILITY IDEOGRAPH-F91A",
	"CJK COMPATIBILITY IDEOGRAPH-F91B",
	"CJK COMPATIBILITY IDEOGRAPH-F91C",
	"CJK COMPATIBILITY IDEOGRAPH-F91D",
	"CJK COMPATIBILITY IDEOGRAPH-F91E",
	"CJK COMPATIBILITY IDEOGRAPH-F91F",
	"CJK COMPATIBILITY IDEOGRAPH-F92A",
	"CJK COMPATIBILITY IDEOGRAPH-F92B",
	"CJK COMPATIBILITY IDEOGRAPH-F92C",
	"CJK COMPATIBILITY IDEOGRAPH-F92D",
	"CJK COMPATIBILITY IDEOGRAPH-F92E",
	"CJK COMPATIBILITY IDEOGRAPH-F92F",
	"CJK COMPATIBILITY IDEOGRAPH-F93A",
	"CJK COMPATIBILITY IDEOGRAPH-F93B",
	"CJK COMPATIBILITY IDEOGRAPH-F93C",
	"CJK COMPATIBILITY IDEOGRAPH-F93D",
	"CJK COMPATIBILITY IDEOGRAPH-F93E",
	"CJK COMPATIBILITY IDEOGRAPH-F93F",
	"CJK COMPATIBILITY IDEOGRAPH-F94A",
	"CJK COMPATIBILITY IDEOGRAPH-F94B",
	"CJK COMPATIBILITY IDEOGRAPH-F94C",
	"CJK COMPATIBILITY IDEOGRAPH-F94D",
	"CJK COMPATIBILITY IDEOGRAPH-F94E",
	"CJK COMPATIBILITY IDEOGRAPH-F94F",
	"CJK COMPATIBILITY IDEOGRAPH-F95A",
	"CJK COMPATIBILITY IDEOGRAPH-F95B",
	"CJK COMPATIBILITY IDEOGRAPH-F95C",
	"CJK COMPATIBILITY IDEOGRAPH-F95D",
	"CJK COMPATIBILITY IDEOGRAPH-F95E",
	"CJK COMPATIBILITY IDEOGRAPH-F95F",
	"CJK COMPATIBILITY IDEOGRAPH-F96A",
	"CJK COMPATIBILITY IDEOGRAPH-F96B",
	"CJK COMPATIBILITY IDEOGRAPH-F96C",
	"CJK COMPATIBILITY IDEOGRAPH-F96D",
	"CJK COMPATIBILITY IDEOGRAPH-F96E",
	"CJK COMPATIBILITY IDEOGRAPH-F96F",
	"CJK COMPATIBILITY IDEOGRAPH-F97A",
	"CJK COMPATIBILITY IDEOGRAPH-F97B",
	"CJK COMPATIBILITY IDEOGRAPH-F97C",
	"CJK COMPATIBILITY IDEOGRAPH-F97D",
	"CJK COMPATIBILITY IDEOGRAPH-F97E",
	"CJK COMPATIBILITY IDEOGRAPH-F97F",
	"CJK COMPATIBILITY IDEOGRAPH-F98A",
	"CJK COMPATIBILITY IDEOGRAPH-F98B",
	"CJK COMPATIBILITY IDEOGRAPH-F98C",
	"CJK COMPATIBILITY IDEOGRAPH-F98D",
	"CJK COMPATIBILITY IDEOGRAPH-F98E",
	"CJK COMPATIBILITY IDEOGRAPH-F98F",
	"CJK COMPATIBILITY IDEOGRAPH-F99A",
	"CJK COMPATIBILITY IDEOGRAPH-F99B",
	"CJK COMPATIBILITY IDEOGRAPH-F99C",
	"CJK COMPATIBILITY IDEOGRAPH-F99D",
	"CJK COMPATIBILITY IDEOGRAPH-F99E",
	"CJK COMPATIBILITY IDEOGRAPH-F99F",
	"CJK COMPATIBILITY IDEOGRAPH-F9AA",
	"CJK COMPATIBILITY IDEOGRAPH-F9AB",
	"CJK COMPATIBILITY IDEOGRAPH-F9AC",
	"CJK COMPATIBILITY IDEOGRAPH-F9AD",
	"CJK COMPATIBILITY IDEOGRAPH-F9AE",
	"CJK COMPATIBILITY IDEOGRAPH-F9AF",
	"CJK COMPATIBILITY IDEOGRAPH-F9BA",
	"CJK COMPATIBILITY IDEOGRAPH-F9BB",
	"CJK COMPATIBILITY IDEOGRAPH-F9BC",
	"CJK COMPATIBILITY IDEOGRAPH-F9BD",
	"CJK COMPATIBILITY IDEOGRAPH-F9BE",
	"CJK COMPATIBILITY IDEOGRAPH-F9BF",
	"CJK COMPATIBILITY IDEOGRAPH-F9CA",
	"CJK COMPATIBILITY IDEOGRAPH-F9CB",
	"CJK COMPATIBILITY IDEOGRAPH-F9CC",
	"CJK COMPATIBILITY IDEOGRAPH-F9CD",
	"CJK COMPATIBILITY IDEOGRAPH-F9CE",
	"CJK COMPATIBILITY IDEOGRAPH-F9CF",
	"CJK COMPATIBILITY IDEOGRAPH-F9DA",
	"CJK COMPATIBILITY IDEOGRAPH-F9DB",
	"CJK COMPATIBILITY IDEOGRAPH-F9DC",
	"CJK COMPATIBILITY IDEOGRAPH-F9DD",
	"CJK COMPATIBILITY IDEOGRAPH-F9DE",
	"CJK COMPATIBILITY IDEOGRAPH-F9DF",
	"CJK COMPATIBILITY IDEOGRAPH-F9EA",
	"CJK COMPATIBILITY IDEOGRAPH-F9EB",
	"CJK COMPATIBILITY IDEOGRAPH-F9EC",
	"CJK COMPATIBILITY IDEOGRAPH-F9ED",
	"CJK COMPATIBILITY IDEOGRAPH-F9EE",
	"CJK COMPATIBILITY IDEOGRAPH-F9EF",
	"CJK COMPATIBILITY IDEOGRAPH-F9FA",
	"CJK COMPATIBILITY IDEOGRAPH-F9FB",
	"CJK COMPATIBILITY IDEOGRAPH-F9FC",
	"CJK COMPATIBILITY IDEOGRAPH-F9FD",
	"CJK COMPATIBILITY IDEOGRAPH-F9FE",
	"CJK COMPATIBILITY IDEOGRAPH-F9FF",
	"CJK COMPATIBILITY IDEOGRAPH-FA0A",
	"CJK COMPATIBILITY IDEOGRAPH-FA0B",
	"CJK COMPATIBILITY IDEOGRAPH-FA0C",
	"CJK COMPATIBILITY IDEOGRAPH-FA0D",
	"CJK COMPATIBILITY IDEOGRAPH-FA0E",
	"CJK COMPATIBILITY IDEOGRAPH-FA0F",
	"CJK COMPATIBILITY IDEOGRAPH-FA1A",
	"CJK COMPATIBILITY IDEOGRAPH-FA1B",
	"CJK COMPATIBILITY IDEOGRAPH-FA1C",
	"CJK COMPATIBILITY IDEOGRAPH-FA1D",
	"CJK COMPATIBILITY IDEOGRAPH-FA1E",
	"CJK COMPATIBILITY IDEOGRAPH-FA1F",
	"CJK COMPATIBILITY IDEOGRAPH-FA2A",
	"CJK COMPATIBILITY IDEOGRAPH-FA2B",
	"CJK COMPATIBILITY IDEOGRAPH-FA2C",
	"CJK COMPATIBILITY IDEOGRAPH-FA2D",
	"CJK COMPATIBILITY IDEOGRAPH-FA2E",
	"CJK COMPATIBILITY IDEOGRAPH-FA2F",
	"CJK COMPATIBILITY IDEOGRAPH-FA3A",
	"CJK COMPATIBILITY IDEOGRAPH-FA3B",
	"CJK COMPATIBILITY IDEOGRAPH-FA3C",
	"CJK COMPATIBILITY IDEOGRAPH-FA3D",
	"CJK COMPATIBILITY IDEOGRAPH-FA3E",
	"CJK COMPATIBILITY IDEOGRAPH-FA3F",
	"CJK COMPATIBILITY IDEOGRAPH-FA4A",
	"CJK COMPATIBILITY IDEOGRAPH-FA4B",
	"CJK COMPATIBILITY IDEOGRAPH-FA4C",
	"CJK COMPATIBILITY IDEOGRAPH-FA4D",
	"CJK COMPATIBILITY IDEOGRAPH-FA4E",
	"CJK COMPATIBILITY IDEOGRAPH-FA4F",
	"CJK COMPATIBILITY IDEOGRAPH-FA5A",
	"CJK COMPATIBILITY IDEOGRAPH-FA5B",
	"CJK COMPATIBILITY IDEOGRAPH-FA5C",
	"CJK COMPATIBILITY IDEOGRAPH-FA5D",
	"CJK COMPATIBILITY IDEOGRAPH-FA5E",
	"CJK COMPATIBILITY IDEOGRAPH-FA5F",
	"CJK COMPATIBILITY IDEOGRAPH-FA6A",
	"CJK COMPATIBILITY IDEOGRAPH-FA6B",
	"CJK COMPATIBILITY IDEOGRAPH-FA6C",
	"CJK COMPATIBILITY IDEOGRAPH-FA6D",
	"CJK COMPATIBILITY IDEOGRAPH-FA7A",
	"CJK COMPATIBILITY IDEOGRAPH-FA7B",
	"CJK COMPATIBILITY IDEOGRAPH-FA7C",
	"CJK COMPATIBILITY IDEOGRAPH-FA7D",
	"CJK COMPATIBILITY IDEOGRAPH-FA7E",
	"CJK COMPATIBILITY IDEOGRAPH-FA7F",
	"CJK COMPATIBILITY IDEOGRAPH-FA8A",
	"CJK COMPATIBILITY IDEOGRAPH-FA8B",
	"CJK COMPATIBILITY IDEOGRAPH-FA8C",
	"CJK COMPATIBILITY IDEOGRAPH-FA8D",
	"CJK COMPATIBILITY IDEOGRAPH-FA8E",
	"CJK COMPATIBILITY IDEOGRAPH-FA8F",
	"CJK COMPATIBILITY IDEOGRAPH-FA9A",
	"CJK COMPATIBILITY IDEOGRAPH-FA9B",
	"CJK COMPATIBILITY IDEOGRAPH-FA9C",
	"CJK COMPATIBILITY IDEOGRAPH-FA9D",
	"CJK COMPATIBILITY IDEOGRAPH-FA9E",
	"CJK COMPATIBILITY IDEOGRAPH-FA9F",
	"CJK COMPATIBILITY IDEOGRAPH-FAAA",
	"CJK COMPATIBILITY IDEOGRAPH-FAAB",
	"CJK COMPATIBILITY IDEOGRAPH-FAAC",
	"CJK COMPATIBILITY IDEOGRAPH-FAAD",
	"CJK COMPATIBILITY IDEOGRAPH-FAAE",
	"CJK COMPATIBILITY IDEOGRAPH-FAAF",
	"CJK COMPATIBILITY IDEOGRAPH-FABA",
	"CJK COMPATIBILITY IDEOGRAPH-FABB",
	"CJK COMPATIBILITY IDEOGRAPH-FABC",
	"CJK COMPATIBILITY IDEOGRAPH-FABD",
	"CJK COMPATIBILITY IDEOGRAPH-FABE",
	"CJK COMPATIBILITY IDEOGRAPH-FABF",
	"CJK COMPATIBILITY IDEOGRAPH-FACA",
	"CJK COMPATIBILITY IDEOGRAPH-FACB",
	"CJK COMPATIBILITY IDEOGRAPH-FACC",
	"CJK COMPATIBILITY IDEOGRAPH-FACD",
	"CJK COMPATIBILITY IDEOGRAPH-FACE",
	"CJK COMPATIBILITY IDEOGRAPH-FACF",
	"CJK RADICAL BAMBOO",
	"CJK RADICAL BLUE",
	"CJK RADICAL BOLT OF CLOTH",
	"CJK RADICAL BONE",
	"CJK RADICAL BOX",
	"CJK RADICAL BRUSH ONE",
	"CJK RADICAL BRUSH TWO",
	"CJK RADICAL C-SIMPLIFIED BIRD",
	"CJK RADICAL C-SIMPLIFIED CART",
	"CJK RADICAL C-SIMPLIFIED DRAGON",
	"CJK RADICAL C-SIMPLIFIED EAT",
	"CJK RADICAL C-SIMPLIFIED EVEN",
	"CJK RADICAL C-SIMPLIFIED FISH",
	"CJK RADICAL C-SIMPLIFIED FLY",
	"CJK RADICAL C-SIMPLIFIED FROG",
	"CJK RADICAL C-SIMPLIFIED GATE",
	"CJK RADICAL C-SIMPLIFIED GOLD",
	"CJK RADICAL C-SIMPLIFIED HORSE",
	"CJK RADICAL C-SIMPLIFIED LEAF",
	"CJK RADICAL C-SIMPLIFIED LONG",
	"CJK RADICAL C-SIMPLIFIED SALT",
	"CJK RADICAL C-SIMPLIFIED SEE",
	"CJK RADICAL C-SIMPLIFIED SHELL",
	"CJK RADICAL C-SIMPLIFIED SILK",
	"CJK RADICAL C-SIMPLIFIED SPEECH",
	"CJK RADICAL C-SIMPLIFIED TANNED LEATHER",
	"CJK RADICAL C-SIMPLIFIED TOOTH",
	"CJK RADICAL C-SIMPLIFIED TURTLE",
	"CJK RADICAL C-SIMPLIFIED WIND",
	"CJK RADICAL CHOKE",
	"CJK RADICAL CITY",
	"CJK RADICAL CIVILIAN",
	"CJK RADICAL CLIFF",
	"CJK RADICAL CLOTHES",
	"CJK RADICAL COW",
	"CJK RADICAL DEATH",
	"CJK RADICAL DIVINATION",
	"CJK RADICAL DOG",
	"CJK RADICAL EAT ONE",
	"CJK RADICAL EAT THREE",
	"CJK RADICAL EAT TWO",
	"CJK RADICAL EWE",
	"CJK RADICAL EYE",
	"CJK RADICAL FIRE",
	"CJK RADICAL FOOT",
	"CJK RADICAL GHOST",
	"CJK RADICAL GRASS ONE",
	"CJK RADICAL GRASS THREE",
	"CJK RADICAL GRASS TWO",
	"CJK RADICAL HAND",
	"CJK RADICAL HEAD",
	"CJK RADICAL HEART ONE",
	"CJK RADICAL HEART TWO",
	"CJK RADICAL HORN",
	"CJK RADICAL J-SIMPLIFIED DRAGON",
	"CJK RADICAL J-SIMPLIFIED EVEN",
	"CJK RADICAL J-SIMPLIFIED TOOTH",
	"CJK RADICAL J-SIMPLIFIED TURTLE",
	"CJK RADICAL JADE",
	"CJK RADICAL KNIFE ONE",
	"CJK RADICAL KNIFE TWO",
	"CJK RADICAL LAME FOUR",
	"CJK RADICAL LAME ONE",
	"CJK RADICAL LAME THREE",
	"CJK RADICAL LAME TWO",
	"CJK RADICAL LONG ONE",
	"CJK RADICAL LONG TWO",
	"CJK RADICAL MEAT",
	"CJK RADICAL MESH",
	"CJK RADICAL MOON",
	"CJK RADICAL MORTAR",
	"CJK RADICAL MOTHER",
	"CJK RADICAL MOUND ONE",
	"CJK RADICAL MOUND TWO",
	"CJK RADICAL NET FOUR",
	"CJK RADICAL NET ONE",
	"CJK RADICAL NET THREE",
	"CJK RADICAL NET TWO",
	"CJK RADICAL OLD",
	"CJK RADICAL PAW ONE",
	"CJK RADICAL PAW TWO",
	"CJK RADICAL PERSON",
	"CJK RADICAL RAIN",
	"CJK RADICAL RAM",
	"CJK RADICAL RAP",
	"CJK RADICAL REPEAT",
	"CJK RADICAL SEAL",
	"CJK RADICAL SECOND ONE",
	"CJK RADICAL SECOND THREE",
	"CJK RADICAL SECOND TWO",
	"CJK RADICAL SHEEP",
	"CJK RADICAL SILK",
	"CJK RADICAL SIMPLIFIED HALF TREE TRUNK",
	"CJK RADICAL SIMPLIFIED HORN",
	"CJK RADICAL SIMPLIFIED WALK",
	"CJK RADICAL SIMPLIFIED WHEAT",
	"CJK RADICAL SIMPLIFIED YELLOW",
	"CJK RADICAL SMALL ONE",
	"CJK RADICAL SMALL TWO",
	"CJK RADICAL SNAKE",
	"CJK RADICAL SNOUT ONE",
	"CJK RADICAL SNOUT TWO",
	"CJK RADICAL SPIRIT ONE",
	"CJK RADICAL SPIRIT TWO",
	"CJK RADICAL SUN",
	"CJK RADICAL TABLE",
	"CJK RADICAL THREAD",
	"CJK RADICAL TIGER",
	"CJK RADICAL TURTLE",
	"CJK RADICAL WALK ONE",
	"CJK RADICAL WALK TWO",
	"CJK RADICAL WATER ONE",
	"CJK RADICAL WATER TWO",
	"CJK RADICAL WEST ONE",
	"CJK RADICAL WEST TWO",
	"CJK STROKE BXG",
	"CJK STROKE D",
	"CJK STROKE H",
	"CJK STROKE HG",
	"CJK STROKE HP",
	"CJK STROKE HPWG",
	"CJK STROKE HXWG",
	"CJK STROKE HZ",
	"CJK STROKE HZG",
	"CJK STROKE HZT",
	"CJK STROKE HZW",
	"CJK STROKE HZWG",
	"CJK STROKE HZZ",
	"CJK STROKE HZZP",
	"CJK STROKE HZZZ",
	"CJK STROKE HZZZG",
	"CJK STROKE N",
	"CJK STROKE P",
	"CJK STROKE PD",
	"CJK STROKE PG",
	"CJK STROKE PZ",
	"CJK STROKE Q",
	"CJK STROKE S",
	"CJK STROKE SG",
	"CJK STROKE SP",
	"CJK STROKE ST",
	"CJK STROKE SW",
	"CJK STROKE SWG",
	"CJK STROKE SWZ",
	"CJK STROKE SZ",
	"CJK STROKE SZWG",
	"CJK STROKE SZZ",
	"CJK STROKE T",
	"CJK STROKE TN",
	"CJK STROKE WG",
	"CJK STROKE XG",
	"CLAPPER BOARD",
	"CLAPPING HANDS SIGN",
	"CLEAR SCREEN SYMBOL",
	"CLINKING BEER MUGS",
	"CLIPBOARD",
	"CLOCK FACE EIGHT OCLOCK",
	"CLOCK FACE EIGHT-THIRTY",
	"CLOCK FACE ELEVEN OCLOCK",
	"CLOCK FACE ELEVEN-THIRTY",
	"CLOCK FACE FIVE OCLOCK",
	"CLOCK FACE FIVE-THIRTY",
	"CLOCK FACE FOUR OCLOCK",
	"CLOCK FACE FOUR-THIRTY",
	"CLOCK FACE NINE OCLOCK",
	"CLOCK FACE NINE-THIRTY",
	"CLOCK FACE ONE OCLOCK",
	"CLOCK FACE ONE-THIRTY",
	"CLOCK FACE SEVEN OCLOCK",
	"CLOCK FACE SEVEN-THIRTY",
	"CLOCK FACE SIX OCLOCK",
	"CLOCK FACE SIX-THIRTY",
	"CLOCK FACE TEN OCLOCK",
	"CLOCK FACE TEN-THIRTY",
	"CLOCK FACE THREE OCLOCK",
	"CLOCK FACE THREE-THIRTY",
	"CLOCK FACE TWELVE OCLOCK",
	"CLOCK FACE TWELVE-THIRTY",
	"CLOCK FACE TWO OCLOCK",
	"CLOCK FACE TWO-THIRTY",
	"CLOCKWISE CLOSED CIRCLE ARROW",
	"CLOCKWISE CONTOUR INTEGRAL",
	"CLOCKWISE DOWNWARDS AND UPWARDS OPEN CIRCLE ARROWS",
	"CLOCKWISE GAPPED CIRCLE ARROW",
	"CLOCKWISE INTEGRAL",
	"CLOCKWISE OPEN CIRCLE ARROW",
	"CLOCKWISE RIGHTWARDS AND LEFTWARDS OPEN CIRCLE ARROWS",
	"CLOCKWISE RIGHTWARDS AND LEFTWARDS OPEN CIRCLE ARROWS WITH CIRCLED ONE OVERLAY",
	"CLOCKWISE TOP SEMICIRCLE ARROW",
	"CLOSE UP",
	"CLOSED BOOK",
	"CLOSED INTERSECTION WITH SERIFS",
	"CLOSED LOCK WITH KEY",
	"CLOSED MAILBOX WITH LOWERED FLAG",
	"CLOSED MAILBOX WITH RAISED FLAG",
	"CLOSED SUBSET",
	"CLOSED SUBSET OR EQUAL TO",
	"CLOSED SUPERSET",
	"CLOSED SUPERSET OR EQUAL TO",
	"CLOSED UMBRELLA",
	"CLOSED UNION WITH SERIFS",
	"CLOSED UNION WITH SERIFS AND SMASH PRODUCT",
	"CLOUD",
	"COCKTAIL GLASS",
	"COFFIN",
	"COLLISION SYMBOL",
	"COLON",
	"COLON EQUALS",
	"COLON SIGN",
	"COMBINING ACUTE ACCENT",
	"COMBINING ACUTE ACCENT BELOW",
	"COMBINING ACUTE TONE MARK",
	"COMBINING ACUTE-GRAVE-ACUTE",
	"COMBINING ACUTE-MACRON",
	"COMBINING ALMOST EQUAL TO ABOVE",
	"COMBINING ALMOST EQUAL TO BELOW",
	"COMBINING ANNUITY SYMBOL",
	"COMBINING ANTICLOCKWISE ARROW ABOVE",
	"COMBINING ANTICLOCKWISE RING OVERLAY",
	"COMBINING ASTERISK ABOVE",
	"COMBINING ASTERISK BELOW",
	"COMBINING BREVE",
	"COMBINING BREVE BELOW",
	"COMBINING BREVE-MACRON",
	"COMBINING BRIDGE ABOVE",
	"COMBINING BRIDGE BELOW",
	"COMBINING CANDRABINDU",
	"COMBINING CARON",
	"COMBINING CARON BELOW",
	"COMBINING CEDILLA",
	"COMBINING CIRCUMFLEX ACCENT",
	"COMBINING CIRCUMFLEX ACCENT BELOW",
	"COMBINING CLOCKWISE ARROW ABOVE",
	"COMBINING CLOCKWISE RING OVERLAY",
	"COMBINING COMMA ABOVE",
	"COMBINING COMMA ABOVE RIGHT",
	"COMBINING COMMA BELOW",
	"COMBINING CONJOINING MACRON",
	"COMBINING CYRILLIC DASIA PNEUMATA",
	"COMBINING CYRILLIC HUNDRED MILLIONS SIGN",
	"COMBINING CYRILLIC HUNDRED THOUSANDS SIGN",
	"COMBINING CYRILLIC KAVYKA",
	"COMBINING CYRILLIC LETTER A",
	"COMBINING CYRILLIC LETTER BE",
	"COMBINING CYRILLIC LETTER BIG YUS",
	"COMBINING CYRILLIC LETTER CHE",
	"COMBINING CYRILLIC LETTER DE",
	"COMBINING CYRILLIC LETTER DJERV",
	"COMBINING CYRILLIC LETTER EL",
	"COMBINING CYRILLIC LETTER EM",
	"COMBINING CYRILLIC LETTER EN",
	"COMBINING CYRILLIC LETTER ER",
	"COMBINING CYRILLIC LETTER ES",
	"COMBINING CYRILLIC LETTER ES-TE",
	"COMBINING CYRILLIC LETTER FITA",
	"COMBINING CYRILLIC LETTER GHE",
	"COMBINING CYRILLIC LETTER HA",
	"COMBINING CYRILLIC LETTER HARD SIGN",
	"COMBINING CYRILLIC LETTER I",
	"COMBINING CYRILLIC LETTER IE",
	"COMBINING CYRILLIC LETTER IOTIFIED A",
	"COMBINING CYRILLIC LETTER IOTIFIED BIG YUS",
	"COMBINING CYRILLIC LETTER IOTIFIED E",
	"COMBINING CYRILLIC LETTER KA",
	"COMBINING CYRILLIC LETTER LITTLE YUS",
	"COMBINING CYRILLIC LETTER MONOGRAPH UK",
	"COMBINING CYRILLIC LETTER O",
	"COMBINING CYRILLIC LETTER OMEGA",
	"COMBINING CYRILLIC LETTER PE",
	"COMBINING CYRILLIC LETTER SHA",
	"COMBINING CYRILLIC LETTER SHCHA",
	"COMBINING CYRILLIC LETTER SOFT SIGN",
	"COMBINING CYRILLIC LETTER TE",
	"COMBINING CYRILLIC LETTER TSE",
	"COMBINING CYRILLIC LETTER U",
	"COMBINING CYRILLIC LETTER UKRAINIAN IE",
	"COMBINING CYRILLIC LETTER VE",
	"COMBINING CYRILLIC LETTER YAT",
	"COMBINING CYRILLIC LETTER YERU",
	"COMBINING CYRILLIC LETTER YI",
	"COMBINING CYRILLIC LETTER YU",
	"COMBINING CYRILLIC LETTER ZE",
	"COMBINING CYRILLIC LETTER ZHE",
	"COMBINING CYRILLIC MILLIONS SIGN",
	"COMBINING CYRILLIC PALATALIZATION",
	"COMBINING CYRILLIC PAYEROK",
	"COMBINING CYRILLIC POKRYTIE",
	"COMBINING CYRILLIC PSILI PNEUMATA",
	"COMBINING CYRILLIC TEN MILLIONS SIGN",
	"COMBINING CYRILLIC THOUSAND MILLIONS SIGN",
	"COMBINING CYRILLIC TITLO",
	"COMBINING CYRILLIC VZMET",
	"COMBINING DEVANAGARI DIGIT EIGHT",
	"COMBINING DEVANAGARI DIGIT FIVE",
	"COMBINING DEVANAGARI DIGIT FOUR",
	"COMBINING DEVANAGARI DIGIT NINE",
	"COMBINING DEVANAGARI DIGIT ONE",
	"COMBINING DEVANAGARI DIGIT SEVEN",
	"COMBINING DEVANAGARI DIGIT SIX",
	"COMBINING DEVANAGARI DIGIT THREE",
	"COMBINING DEVANAGARI DIGIT TWO",
	"COMBINING DEVANAGARI DIGIT ZERO",
	"COMBINING DEVANAGARI LETTER A",
	"COMBINING DEVANAGARI LETTER KA",
	"COMBINING DEVANAGARI LETTER NA",
	"COMBINING DEVANAGARI LETTER PA",
	"COMBINING DEVANAGARI LETTER RA",
	"COMBINING DEVANAGARI LETTER U",
	"COMBINING DEVANAGARI LETTER VI",
	"COMBINING DEVANAGARI SIGN AVAGRAHA",
	"COMBINING DIAERESIS",
	"COMBINING DIAERESIS BELOW",
	"COMBINING DOT ABOVE",
	"COMBINING DOT ABOVE RIGHT",
	"COMBINING DOT BELOW",
	"COMBINING DOTTED ACUTE ACCENT",
	"COMBINING DOTTED GRAVE ACCENT",
	"COMBINING DOUBLE ACUTE ACCENT",
	"COMBINING DOUBLE BREVE",
	"COMBINING DOUBLE BREVE BELOW",
	"COMBINING DOUBLE CIRCUMFLEX ABOVE",
	"COMBINING DOUBLE GRAVE ACCENT",
	"COMBINING DOUBLE INVERTED BREVE",
	"COMBINING DOUBLE INVERTED BREVE BELOW",
	"COMBINING DOUBLE LOW LINE",
	"COMBINING DOUBLE MACRON",
	"COMBINING DOUBLE MACRON BELOW",
	"COMBINING DOUBLE OVERLINE",
	"COMBINING DOUBLE RIGHTWARDS ARROW BELOW",
	"COMBINING DOUBLE RING BELOW",
	"COMBINING DOUBLE TILDE",
	"COMBINING DOUBLE TILDE LEFT HALF",
	"COMBINING DOUBLE TILDE RIGHT HALF",
	"COMBINING DOUBLE VERTICAL LINE ABOVE",
	"COMBINING DOUBLE VERTICAL LINE BELOW",
	"COMBINING DOUBLE VERTICAL STROKE OVERLAY",
	"COMBINING DOWN TACK BELOW",
	"COMBINING ENCLOSING CIRCLE",
	"COMBINING ENCLOSING CIRCLE BACKSLASH",
	"COMBINING ENCLOSING DIAMOND",
	"COMBINING ENCLOSING KEYCAP",
	"COMBINING ENCLOSING SCREEN",
	"COMBINING ENCLOSING SQUARE",
	"COMBINING ENCLOSING UPWARD POINTING TRIANGLE",
	"COMBINING EQUALS SIGN BELOW",
	"COMBINING FERMATA",
	"COMBINING FOUR DOTS ABOVE",
	"COMBINING GRAPHEME JOINER",
	"COMBINING GRAVE ACCENT",
	"COMBINING GRAVE ACCENT BELOW",
	"COMBINING GRAVE TONE MARK",
	"COMBINING GRAVE-ACUTE-GRAVE",
	"COMBINING GRAVE-MACRON",
	"COMBINING GREEK DIALYTIKA TONOS",
	"COMBINING GREEK KORONIS",
	"COMBINING GREEK MUSICAL PENTASEME",
	"COMBINING GREEK MUSICAL TETRASEME",
	"COMBINING GREEK MUSICAL TRISEME",
	"COMBINING GREEK PERISPOMENI",
	"COMBINING GREEK YPOGEGRAMMENI",
	"COMBINING HOMOTHETIC ABOVE",
	"COMBINING HOOK ABOVE",
	"COMBINING HORN",
	"COMBINING INVERTED BREVE",
	"COMBINING INVERTED BREVE BELOW",
	"COMBINING INVERTED BRIDGE BELOW",
	"COMBINING INVERTED DOUBLE ARCH BELOW",
	"COMBINING IS BELOW",
	"COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK",
	"COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK",
	"COMBINING LATIN LETTER SMALL CAPITAL G",
	"COMBINING LATIN LETTER SMALL CAPITAL L",
	"COMBINING LATIN LETTER SMALL CAPITAL M",
	"COMBINING LATIN LETTER SMALL CAPITAL N",
	"COMBINING LATIN LETTER SMALL CAPITAL R",
	"COMBINING LATIN SMALL LETTER A",
	"COMBINING LATIN SMALL LETTER AE",
	"COMBINING LATIN SMALL LETTER AO",
	"COMBINING LATIN SMALL LETTER AV",
	"COMBINING LATIN SMALL LETTER C",
	"COMBINING LATIN SMALL LETTER C CEDILLA",
	"COMBINING LATIN SMALL LETTER D",
	"COMBINING LATIN SMALL LETTER E",
	"COMBINING LATIN SMALL LETTER ETH",
	"COMBINING LATIN SMALL LETTER FLATTENED OPEN A ABOVE",
	"COMBINING LATIN SMALL LETTER G",
	"COMBINING LATIN SMALL LETTER H",
	"COMBINING LATIN SMALL LETTER I",
	"COMBINING LATIN SMALL LETTER INSULAR D",
	"COMBINING LATIN SMALL LETTER K",
	"COMBINING LATIN SMALL LETTER L",
	"COMBINING LATIN SMALL LETTER LONG S",
	"COMBINING LATIN SMALL LETTER M",
	"COMBINING LATIN SMALL LETTER N",
	"COMBINING LATIN SMALL LETTER O",
	"COMBINING LATIN SMALL LETTER R",
	"COMBINING LATIN SMALL LETTER R BELOW",
	"COMBINING LATIN SMALL LETTER R ROTUNDA",
	"COMBINING LATIN SMALL LETTER S",
	"COMBINING LATIN SMALL LETTER T",
	"COMBINING LATIN SMALL LETTER U",
	"COMBINING LATIN SMALL LETTER V",
	"COMBINING LATIN SMALL LETTER X",
	"COMBINING LATIN SMALL LETTER Z",
	"COMBINING LEFT ANGLE ABOVE",
	"COMBINING LEFT ANGLE BELOW",
	"COMBINING LEFT ARROW ABOVE",
	"COMBINING LEFT ARROW BELOW",
	"COMBINING LEFT ARROWHEAD ABOVE",
	"COMBINING LEFT ARROWHEAD BELOW",
	"COMBINING LEFT HALF RING ABOVE",
	"COMBINING LEFT HALF RING BELOW",
	"COMBINING LEFT HARPOON ABOVE",
	"COMBINING LEFT RIGHT ARROW ABOVE",
	"COMBINING LEFT RIGHT ARROW BELOW",
	"COMBINING LEFT TACK BELOW",
	"COMBINING LEFTWARDS ARROW OVERLAY",
	"COMBINING LEFTWARDS HARPOON WITH BARB DOWNWARDS",
	"COMBINING LIGATURE LEFT HALF",
	"COMBINING LIGATURE RIGHT HALF",
	"COMBINING LONG DOUBLE SOLIDUS OVERLAY",
	"COMBINING LONG SOLIDUS OVERLAY",
	"COMBINING LONG STROKE OVERLAY",
	"COMBINING LONG VERTICAL LINE OVERLAY",
	"COMBINING LOW LINE",
	"COMBINING MACRON",
	"COMBINING MACRON BELOW",
	"COMBINING MACRON LEFT HALF",
	"COMBINING MACRON RIGHT HALF",
	"COMBINING MACRON-ACUTE",
	"COMBINING MACRON-BREVE",
	"COMBINING MACRON-GRAVE",
	"COMBINING MINUS SIGN BELOW",
	"COMBINING NOT TILDE ABOVE",
	"COMBINING OGONEK",
	"COMBINING OGONEK ABOVE",
	"COMBINING OVERLINE",
	"COMBINING PALATALIZED HOOK BELOW",
	"COMBINING PLUS SIGN BELOW",
	"COMBINING RETROFLEX HOOK BELOW",
	"COMBINING REVERSE SOLIDUS OVERLAY",
	"COMBINING REVERSED COMMA ABOVE",
	"COMBINING RIGHT ARROW ABOVE",
	"COMBINING RIGHT ARROW BELOW",
	"COMBINING RIGHT ARROWHEAD ABOVE",
	"COMBINING RIGHT ARROWHEAD AND DOWN ARROWHEAD BELOW",
	"COMBINING RIGHT ARROWHEAD AND UP ARROWHEAD BELOW",
	"COMBINING RIGHT ARROWHEAD BELOW",
	"COMBINING RIGHT HALF RING ABOVE",
	"COMBINING RIGHT HALF RING BELOW",
	"COMBINING RIGHT HARPOON ABOVE",
	"COMBINING RIGHT TACK BELOW",
	"COMBINING RIGHTWARDS HARPOON WITH BARB DOWNWARDS",
	"COMBINING RING ABOVE",
	"COMBINING RING BELOW",
	"COMBINING RING OVERLAY",
	"COMBINING SEAGULL BELOW",
	"COMBINING SHORT SOLIDUS OVERLAY",
	"COMBINING SHORT STROKE OVERLAY",
	"COMBINING SHORT VERTICAL LINE OVERLAY",
	"COMBINING SNAKE BELOW",
	"COMBINING SQUARE BELOW",
	"COMBINING SUSPENSION MARK",
	"COMBINING THREE DOTS ABOVE",
	"COMBINING TILDE",
	"COMBINING TILDE BELOW",
	"COMBINING TILDE OVERLAY",
	"COMBINING TRIPLE UNDERDOT",
	"COMBINING TURNED COMMA ABOVE",
	"COMBINING UP TACK BELOW",
	"COMBINING UPWARDS ARROW BELOW",
	"COMBINING UR ABOVE",
	"COMBINING US ABOVE",
	"COMBINING VERTICAL LINE ABOVE",
	"COMBINING VERTICAL LINE BELOW",
	"COMBINING VERTICAL TILDE",
	"COMBINING WIDE BRIDGE ABOVE",
	"COMBINING X ABOVE",
	"COMBINING X BELOW",
	"COMBINING ZIGZAG ABOVE",
	"COMBINING ZIGZAG BELOW",
	"COMET",
	"COMMA",
	"COMMERCIAL AT",
	"COMMERCIAL MINUS SIGN",
	"COMPLEMENT",
	"COMPOSITION SYMBOL",
	"CONFETTI BALL",
	"CONFOUNDED FACE",
	"CONFUSED FACE",
	"CONGRUENT WITH DOT ABOVE",
	"CONICAL TAPER",
	"CONJUNCTION",
	"CONSTRUCTION SIGN",
	"CONSTRUCTION WORKER",
	"CONTAINS AS MEMBER",
	"CONTAINS AS NORMAL SUBGROUP",
	"CONTAINS AS NORMAL SUBGROUP OR EQUAL TO",
	"CONTAINS WITH LONG HORIZONTAL STROKE",
	"CONTAINS WITH OVERBAR",
	"CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE",
	"CONTINUOUS UNDERLINE SYMBOL",
	"CONTOUR INTEGRAL",
	"CONVENIENCE STORE",
	"COOKED RICE",
	"COOKIE",
	"COOKING",
	"COPTIC CAPITAL LETTER AKHMIMIC KHEI",
	"COPTIC CAPITAL LETTER ALFA",
	"COPTIC CAPITAL LETTER BOHAIRIC KHEI",
	"COPTIC CAPITAL LETTER CROSSED SHEI",
	"COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE",
	"COPTIC CAPITAL LETTER CRYPTOGRAMMIC GANGIA",
	"COPTIC CAPITAL LETTER CRYPTOGRAMMIC NI",
	"COPTIC CAPITAL LETTER CRYPTOGRAMMIC SHEI",
	"COPTIC CAPITAL LETTER DALDA",
	"COPTIC CAPITAL LETTER DEI",
	"COPTIC CAPITAL LETTER DIALECT-P ALEF",
	"COPTIC CAPITAL LETTER DIALECT-P HORI",
	"COPTIC CAPITAL LETTER DIALECT-P KAPA",
	"COPTIC CAPITAL LETTER DIALECT-P NI",
	"COPTIC CAPITAL LETTER EIE",
	"COPTIC CAPITAL LETTER FEI",
	"COPTIC CAPITAL LETTER FI",
	"COPTIC CAPITAL LETTER GAMMA",
	"COPTIC CAPITAL LETTER GANGIA",
	"COPTIC CAPITAL LETTER HATE",
	"COPTIC CAPITAL LETTER HORI",
	"COPTIC CAPITAL LETTER IAUDA",
	"COPTIC CAPITAL LETTER KAPA",
	"COPTIC CAPITAL LETTER KHEI",
	"COPTIC CAPITAL LETTER KHI",
	"COPTIC CAPITAL LETTER KSI",
	"COPTIC CAPITAL LETTER L-SHAPED HA",
	"COPTIC CAPITAL LETTER LAULA",
	"COPTIC CAPITAL LETTER MI",
	"COPTIC CAPITAL LETTER NI",
	"COPTIC CAPITAL LETTER O",
	"COPTIC CAPITAL LETTER OLD COPTIC AIN",
	"COPTIC CAPITAL LETTER OLD COPTIC DJA",
	"COPTIC CAPITAL LETTER OLD COPTIC ESH",
	"COPTIC CAPITAL LETTER OLD COPTIC GANGIA",
	"COPTIC CAPITAL LETTER OLD COPTIC HA",
	"COPTIC CAPITAL LETTER OLD COPTIC HAT",
	"COPTIC CAPITAL LETTER OLD COPTIC HEI",
	"COPTIC CAPITAL LETTER OLD COPTIC HORI",
	"COPTIC CAPITAL LETTER OLD COPTIC OOU",
	"COPTIC CAPITAL LETTER OLD COPTIC SHEI",
	"COPTIC CAPITAL LETTER OLD COPTIC SHIMA",
	"COPTIC CAPITAL LETTER OLD NUBIAN NGI",
	"COPTIC CAPITAL LETTER OLD NUBIAN NYI",
	"COPTIC CAPITAL LETTER OLD NUBIAN SHIMA",
	"COPTIC CAPITAL LETTER OLD NUBIAN WAU",
	"COPTIC CAPITAL LETTER OOU",
	"COPTIC CAPITAL LETTER PI",
	"COPTIC CAPITAL LETTER PSI",
	"COPTIC CAPITAL LETTER RO",
	"COPTIC CAPITAL LETTER SAMPI",
	"COPTIC CAPITAL LETTER SHEI",
	"COPTIC CAPITAL LETTER SHIMA",
	"COPTIC CAPITAL LETTER SIMA",
	"COPTIC CAPITAL LETTER SOU",
	"COPTIC CAPITAL LETTER TAU",
	"COPTIC CAPITAL LETTER THETHE",
	"COPTIC CAPITAL LETTER UA",
	"COPTIC CAPITAL LETTER VIDA",
	"COPTIC CAPITAL LETTER ZATA",
	"COPTIC COMBINING NI ABOVE",
	"COPTIC COMBINING SPIRITUS ASPER",
	"COPTIC COMBINING SPIRITUS LENIS",
	"COPTIC FRACTION ONE HALF",
	"COPTIC FULL STOP",
	"COPTIC MORPHOLOGICAL DIVIDER",
	"COPTIC OLD NUBIAN DIRECT QUESTION MARK",
	"COPTIC OLD NUBIAN FULL STOP",
	"COPTIC OLD NUBIAN INDIRECT QUESTION MARK",
	"COPTIC OLD NUBIAN VERSE DIVIDER",
	"COPTIC SMALL LETTER AKHMIMIC KHEI",
	"COPTIC SMALL LETTER ALFA",
	"COPTIC SMALL LETTER BOHAIRIC KHEI",
	"COPTIC SMALL LETTER CROSSED SHEI",
	"COPTIC SMALL LETTER CRYPTOGRAMMIC EIE",
	"COPTIC SMALL LETTER CRYPTOGRAMMIC GANGIA",
	"COPTIC SMALL LETTER CRYPTOGRAMMIC NI",
	"COPTIC SMALL LETTER CRYPTOGRAMMIC SHEI",
	"COPTIC SMALL LETTER DALDA",
	"COPTIC SMALL LETTER DEI",
	"COPTIC SMALL LETTER DIALECT-P ALEF",
	"COPTIC SMALL LETTER DIALECT-P HORI",
	"COPTIC SMALL LETTER DIALECT-P KAPA",
	"COPTIC SMALL LETTER DIALECT-P NI",
	"COPTIC SMALL LETTER EIE",
	"COPTIC SMALL LETTER FEI",
	"COPTIC SMALL LETTER FI",
	"COPTIC SMALL LETTER GAMMA",
	"COPTIC SMALL LETTER GANGIA",
	"COPTIC SMALL LETTER HATE",
	"COPTIC SMALL LETTER HORI",
	"COPTIC SMALL LETTER IAUDA",
	"COPTIC SMALL LETTER KAPA",
	"COPTIC SMALL LETTER KHEI",
	"COPTIC SMALL LETTER KHI",
	"COPTIC SMALL LETTER KSI",
	"COPTIC SMALL LETTER L-SHAPED HA",
	"COPTIC SMALL LETTER LAULA",
	"COPTIC SMALL LETTER MI",
	"COPTIC SMALL LETTER NI",
	"COPTIC SMALL LETTER O",
	"COPTIC SMALL LETTER OLD COPTIC AIN",
	"COPTIC SMALL LETTER OLD COPTIC DJA",
	"COPTIC SMALL LETTER OLD COPTIC ESH",
	"COPTIC SMALL LETTER OLD COPTIC GANGIA",
	"COPTIC SMALL LETTER OLD COPTIC HA",
	"COPTIC SMALL LETTER OLD COPTIC HAT",
	"COPTIC SMALL LETTER OLD COPTIC HEI",
	"COPTIC SMALL LETTER OLD COPTIC HORI",
	"COPTIC SMALL LETTER OLD COPTIC OOU",
	"COPTIC SMALL LETTER OLD COPTIC SHEI",
	"COPTIC SMALL LETTER OLD COPTIC SHIMA",
	"COPTIC SMALL LETTER OLD NUBIAN NGI",
	"COPTIC SMALL LETTER OLD NUBIAN NYI",
	"COPTIC SMALL LETTER OLD NUBIAN SHIMA",
	"COPTIC SMALL LETTER OLD NUBIAN WAU",
	"COPTIC SMALL LETTER OOU",
	"COPTIC SMALL LETTER PI",
	"COPTIC SMALL LETTER PSI",
	"COPTIC SMALL LETTER RO",
	"COPTIC SMALL LETTER SAMPI",
	"COPTIC SMALL LETTER SHEI",
	"COPTIC SMALL LETTER SHIMA",
	"COPTIC SMALL LETTER SIMA",
	"COPTIC SMALL LETTER SOU",
	"COPTIC SMALL LETTER TAU",
	"COPTIC SMALL LETTER THETHE",
	"COPTIC SMALL LETTER UA",
	"COPTIC SMALL LETTER VIDA",
	"COPTIC SMALL LETTER ZATA",
	"COPTIC SYMBOL KAI",
	"COPTIC SYMBOL KHI RO",
	"COPTIC SYMBOL MI RO",
	"COPTIC SYMBOL PI RO",
	"COPTIC SYMBOL SHIMA SIMA",
	"COPTIC SYMBOL STAUROS",
	"COPTIC SYMBOL TAU RO",
	"COPYRIGHT SIGN",
	"CORRESPONDS TO",
	"COUNTERBORE",
	"COUNTERSINK",
	"COUNTING ROD TENS DIGIT EIGHT",
	"COUNTING ROD TENS DIGIT FIVE",
	"COUNTING ROD TENS DIGIT FOUR",
	"COUNTING ROD TENS DIGIT NINE",
	"COUNTING ROD TENS DIGIT ONE",
	"COUNTING ROD TENS DIGIT SEVEN",
	"COUNTING ROD TENS DIGIT SIX",
	"COUNTING ROD TENS DIGIT THREE",
	"COUNTING ROD TENS DIGIT TWO",
	"COUNTING ROD UNIT DIGIT EIGHT",
	"COUNTING ROD UNIT DIGIT FIVE",
	"COUNTING ROD UNIT DIGIT FOUR",
	"COUNTING ROD UNIT DIGIT NINE",
	"COUNTING ROD UNIT DIGIT ONE",
	"COUNTING ROD UNIT DIGIT SEVEN",
	"COUNTING ROD UNIT DIGIT SIX",
	"COUNTING ROD UNIT DIGIT THREE",
	"COUNTING ROD UNIT DIGIT TWO",
	"COUPLE WITH HEART",
	"COW",
	"COW FACE",
	"CREDIT CARD",
	"CRESCENT MOON",
	"CROCODILE",
	"CROSS MARK",
	"CROSS OF JERUSALEM",
	"CROSS OF LORRAINE",
	"CROSS POMMEE",
	"CROSS POMMEE WITH HALF-CIRCLE BELOW",
	"CROSSED FLAGS",
	"CROSSED NEGATIVE SQUARED LATIN CAPITAL LETTER P",
	"CROSSED SWORDS",
	"CROSSING LANES",
	"CROWN",
	"CRUZEIRO SIGN",
	"CRYING CAT FACE",
	"CRYING FACE",
	"CRYSTAL BALL",
	"CUBE ROOT",
	"CUNEIFORM NUMERIC SIGN EIGHT ASH",
	"CUNEIFORM NUMERIC SIGN EIGHT DISH",
	"CUNEIFORM NUMERIC SIGN EIGHT U",
	"CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU",
	"CUNEIFORM NUMERIC SIGN FIVE ASH",
	"CUNEIFORM NUMERIC SIGN FIVE ASH TENU",
	"CUNEIFORM NUMERIC SIGN FIVE BAN2 VARIANT FORM",
	"CUNEIFORM NUMERIC SIGN FIVE BURU",
	"CUNEIFORM NUMERIC SIGN FIVE DISH",
	"CUNEIFORM NUMERIC SIGN FIVE GESHU",
	"CUNEIFORM NUMERIC SIGN FIVE SHARU",
	"CUNEIFORM NUMERIC SIGN FIVE SIXTHS DISH",
	"CUNEIFORM NUMERIC SIGN FIVE U",
	"CUNEIFORM NUMERIC SIGN FOUR ASH",
	"CUNEIFORM NUMERIC SIGN FOUR ASH TENU",
	"CUNEIFORM NUMERIC SIGN FOUR BAN2 VARIANT FORM",
	"CUNEIFORM NUMERIC SIGN FOUR BURU",
	"CUNEIFORM NUMERIC SIGN FOUR DISH",
	"CUNEIFORM NUMERIC SIGN FOUR GESHU",
	"CUNEIFORM NUMERIC SIGN FOUR SHARU",
	"CUNEIFORM NUMERIC SIGN FOUR U",
	"CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU",
	"CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU A",
	"CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU B",
	"CUNEIFORM NUMERIC SIGN NIGIDAESH",
	"CUNEIFORM NUMERIC SIGN NIGIDAMIN",
	"CUNEIFORM NUMERIC SIGN NINE ASH",
	"CUNEIFORM NUMERIC SIGN NINE DISH",
	"CUNEIFORM NUMERIC SIGN NINE U",
	"CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU",
	"CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU A",
	"CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE QUARTER",
	"CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE SIXTH",
	"CUNEIFORM NUMERIC SIGN ONE BURU",
	"CUNEIFORM NUMERIC SIGN ONE EIGHTH ASH",
	"CUNEIFORM NUMERIC SIGN ONE GESHU",
	"CUNEIFORM NUMERIC SIGN ONE QUARTER ASH",
	"CUNEIFORM NUMERIC SIGN ONE SHARU",
	"CUNEIFORM NUMERIC SIGN ONE THIRD DISH",
	"CUNEIFORM NUMERIC SIGN ONE THIRD VARIANT FORM A",
	"CUNEIFORM NUMERIC SIGN SEVEN ASH",
	"CUNEIFORM NUMERIC SIGN SEVEN DISH",
	"CUNEIFORM NUMERIC SIGN SEVEN U",
	"CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN A",
	"CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN B",
	"CUNEIFORM NUMERIC SIGN SHAR2 TIMES GAL PLUS DISH",
	"CUNEIFORM NUMERIC SIGN SHAR2 TIMES GAL PLUS MIN",
	"CUNEIFORM NUMERIC SIGN SIX ASH",
	"CUNEIFORM NUMERIC SIGN SIX ASH TENU",
	"CUNEIFORM NUMERIC SIGN SIX DISH",
	"CUNEIFORM NUMERIC SIGN SIX U",
	"CUNEIFORM NUMERIC SIGN THREE ASH",
	"CUNEIFORM NUMERIC SIGN THREE ASH TENU",
	"CUNEIFORM NUMERIC SIGN THREE BURU",
	"CUNEIFORM NUMERIC SIGN THREE BURU VARIANT FORM",
	"CUNEIFORM NUMERIC SIGN THREE DISH",
	"CUNEIFORM NUMERIC SIGN THREE GESHU",
	"CUNEIFORM NUMERIC SIGN THREE SHAR2 VARIANT FORM",
	"CUNEIFORM NUMERIC SIGN THREE SHARU",
	"CUNEIFORM NUMERIC SIGN THREE SHARU VARIANT FORM",
	"CUNEIFORM NUMERIC SIGN TWO ASH",
	"CUNEIFORM NUMERIC SIGN TWO ASH TENU",
	"CUNEIFORM NUMERIC SIGN TWO BURU",
	"CUNEIFORM NUMERIC SIGN TWO GESHU",
	"CUNEIFORM NUMERIC SIGN TWO SHARU",
	"CUNEIFORM NUMERIC SIGN TWO THIRDS DISH",
	"CUNEIFORM NUMERIC SIGN TWO THIRDS VARIANT FORM A",
	"CUNEIFORM PUNCTUATION SIGN DIAGONAL COLON",
	"CUNEIFORM PUNCTUATION SIGN DIAGONAL TRICOLON",
	"CUNEIFORM PUNCTUATION SIGN OLD ASSYRIAN WORD DIVIDER",
	"CUNEIFORM PUNCTUATION SIGN VERTICAL COLON",
	"CUNEIFORM SIGN A",
	"CUNEIFORM SIGN A TIMES A",
	"CUNEIFORM SIGN A TIMES BAD",
	"CUNEIFORM SIGN A TIMES GAN2 TENU",
	"CUNEIFORM SIGN A TIMES HA",
	"CUNEIFORM SIGN A TIMES IGI",
	"CUNEIFORM SIGN A TIMES LAGAR GUNU",
	"CUNEIFORM SIGN A TIMES MUSH",
	"CUNEIFORM SIGN A TIMES SAG",
	"CUNEIFORM SIGN AB",
	"CUNEIFORM SIGN AB GUNU",
	"CUNEIFORM SIGN AB TIMES DUN3 GUNU",
	"CUNEIFORM SIGN AB TIMES GAL",
	"CUNEIFORM SIGN AB TIMES GAN2 TENU",
	"CUNEIFORM SIGN AB TIMES HA",
	"CUNEIFORM SIGN AB TIMES IGI GUNU",
	"CUNEIFORM SIGN AB TIMES IMIN",
	"CUNEIFORM SIGN AB TIMES LAGAB",
	"CUNEIFORM SIGN AB TIMES SHESH",
	"CUNEIFORM SIGN AB TIMES U PLUS U PLUS U",
	"CUNEIFORM SIGN AB2 TIMES BALAG",
	"CUNEIFORM SIGN AB2 TIMES GAN2 TENU",
	"CUNEIFORM SIGN AB2 TIMES ME PLUS EN",
	"CUNEIFORM SIGN AD",
	"CUNEIFORM SIGN AK",
	"CUNEIFORM SIGN AK TIMES SHITA PLUS GISH",
	"CUNEIFORM SIGN AL",
	"CUNEIFORM SIGN AL TIMES AL",
	"CUNEIFORM SIGN AL TIMES GISH",
	"CUNEIFORM SIGN AL TIMES HA",
	"CUNEIFORM SIGN AL TIMES KI",
	"CUNEIFORM SIGN AL TIMES SHE",
	"CUNEIFORM SIGN AL TIMES USH",
	"CUNEIFORM SIGN ALAN",
	"CUNEIFORM SIGN ALEPH",
	"CUNEIFORM SIGN AMAR",
	"CUNEIFORM SIGN AMAR TIMES SHE",
	"CUNEIFORM SIGN AN",
	"CUNEIFORM SIGN AN OVER AN",
	"CUNEIFORM SIGN AN PLUS NAGA OPPOSING AN PLUS NAGA",
	"CUNEIFORM SIGN AN PLUS NAGA SQUARED",
	"CUNEIFORM SIGN AN THREE TIMES",
	"CUNEIFORM SIGN ANSHE",
	"CUNEIFORM SIGN APIN",
	"CUNEIFORM SIGN ARAD",
	"CUNEIFORM SIGN ARAD TIMES KUR",
	"CUNEIFORM SIGN ARKAB",
	"CUNEIFORM SIGN ASH",
	"CUNEIFORM SIGN ASH KABA TENU",
	"CUNEIFORM SIGN ASH OVER ASH OVER ASH",
	"CUNEIFORM SIGN ASH OVER ASH OVER ASH CROSSING ASH OVER ASH OVER ASH",
	"CUNEIFORM SIGN ASH OVER ASH TUG2 OVER TUG2 TUG2 OVER TUG2 PAP",
	"CUNEIFORM SIGN ASH ZIDA TENU",
	"CUNEIFORM SIGN ASHGAB",
	"CUNEIFORM SIGN BA",
	"CUNEIFORM SIGN BAD",
	"CUNEIFORM SIGN BAL",
	"CUNEIFORM SIGN BAL OVER BAL",
	"CUNEIFORM SIGN BALAG",
	"CUNEIFORM SIGN BAR",
	"CUNEIFORM SIGN BI",
	"CUNEIFORM SIGN BI TIMES A",
	"CUNEIFORM SIGN BI TIMES GAR",
	"CUNEIFORM SIGN BI TIMES IGI GUNU",
	"CUNEIFORM SIGN BU",
	"CUNEIFORM SIGN BU CROSSING BU",
	"CUNEIFORM SIGN BU OVER BU AB",
	"CUNEIFORM SIGN BU OVER BU UN",
	"CUNEIFORM SIGN BULUG",
	"CUNEIFORM SIGN BULUG OVER BULUG",
	"CUNEIFORM SIGN BUR",
	"CUNEIFORM SIGN DA",
	"CUNEIFORM SIGN DAG",
	"CUNEIFORM SIGN DAG KISIM5 TIMES A PLUS MASH",
	"CUNEIFORM SIGN DAG KISIM5 TIMES AMAR",
	"CUNEIFORM SIGN DAG KISIM5 TIMES BALAG",
	"CUNEIFORM SIGN DAG KISIM5 TIMES BI",
	"CUNEIFORM SIGN DAG KISIM5 TIMES GA",
	"CUNEIFORM SIGN DAG KISIM5 TIMES GA PLUS MASH",
	"CUNEIFORM SIGN DAG KISIM5 TIMES GI",
	"CUNEIFORM SIGN DAG KISIM5 TIMES GUD",
	"CUNEIFORM SIGN DAG KISIM5 TIMES HA",
	"CUNEIFORM SIGN DAG KISIM5 TIMES IR",
	"CUNEIFORM SIGN DAG KISIM5 TIMES IR PLUS LU",
	"CUNEIFORM SIGN DAG KISIM5 TIMES KAK",
	"CUNEIFORM SIGN DAG KISIM5 TIMES LA",
	"CUNEIFORM SIGN DAG KISIM5 TIMES LU",
	"CUNEIFORM SIGN DAG KISIM5 TIMES LUM",
	"CUNEIFORM SIGN DAG KISIM5 TIMES NE",
	"CUNEIFORM SIGN DAG KISIM5 TIMES PAP PLUS PAP",
	"CUNEIFORM SIGN DAG KISIM5 TIMES SI",
	"CUNEIFORM SIGN DAG KISIM5 TIMES USH",
	"CUNEIFORM SIGN DAM",
	"CUNEIFORM SIGN DAR",
	"CUNEIFORM SIGN DI",
	"CUNEIFORM SIGN DIB",
	"CUNEIFORM SIGN DIM",
	"CUNEIFORM SIGN DIM TIMES SHE",
	"CUNEIFORM SIGN DIN",
	"CUNEIFORM SIGN DIN KASKAL U GUNU DISH",
	"CUNEIFORM SIGN DISH",
	"CUNEIFORM SIGN DU",
	"CUNEIFORM SIGN DU GUNU",
	"CUNEIFORM SIGN DU OVER DU",
	"CUNEIFORM SIGN DU SHESHIG",
	"CUNEIFORM SIGN DUB",
	"CUNEIFORM SIGN DUG",
	"CUNEIFORM SIGN DUGUD",
	"CUNEIFORM SIGN DUH",
	"CUNEIFORM SIGN DUN",
	"CUNEIFORM SIGN DUN3 GUNU",
	"CUNEIFORM SIGN DUN3 GUNU GUNU",
	"CUNEIFORM SIGN E",
	"CUNEIFORM SIGN E OVER E NUN OVER NUN",
	"CUNEIFORM SIGN E TIMES PAP",
	"CUNEIFORM SIGN E2 TIMES A PLUS HA PLUS DA",
	"CUNEIFORM SIGN E2 TIMES GAR",
	"CUNEIFORM SIGN E2 TIMES MI",
	"CUNEIFORM SIGN E2 TIMES SAL",
	"CUNEIFORM SIGN E2 TIMES SHE",
	"CUNEIFORM SIGN E2 TIMES U",
	"CUNEIFORM SIGN EDIN",
	"CUNEIFORM SIGN EGIR",
	"CUNEIFORM SIGN EL",
	"CUNEIFORM SIGN EN",
	"CUNEIFORM SIGN EN CROSSING EN",
	"CUNEIFORM SIGN EN OPPOSING EN",
	"CUNEIFORM SIGN EN SQUARED",
	"CUNEIFORM SIGN EN TIMES GAN2 TENU",
	"CUNEIFORM SIGN EN TIMES ME",
	"CUNEIFORM SIGN EREN",
	"CUNEIFORM SIGN EZEN",
	"CUNEIFORM SIGN EZEN TIMES A",
	"CUNEIFORM SIGN EZEN TIMES A PLUS LAL",
	"CUNEIFORM SIGN EZEN TIMES A PLUS LAL TIMES LAL",
	"CUNEIFORM SIGN EZEN TIMES AN",
	"CUNEIFORM SIGN EZEN TIMES BAD",
	"CUNEIFORM SIGN EZEN TIMES DUN3 GUNU",
	"CUNEIFORM SIGN EZEN TIMES DUN3 GUNU GUNU",
	"CUNEIFORM SIGN EZEN TIMES HA",
	"CUNEIFORM SIGN EZEN TIMES HA GUNU",
	"CUNEIFORM SIGN EZEN TIMES IGI GUNU",
	"CUNEIFORM SIGN EZEN TIMES KASKAL",
	"CUNEIFORM SIGN EZEN TIMES KASKAL SQUARED",
	"CUNEIFORM SIGN EZEN TIMES LA",
	"CUNEIFORM SIGN EZEN TIMES LAL TIMES LAL",
	"CUNEIFORM SIGN EZEN TIMES LI",
	"CUNEIFORM SIGN EZEN TIMES LU",
	"CUNEIFORM SIGN EZEN TIMES UD",
	"CUNEIFORM SIGN GA",
	"CUNEIFORM SIGN GA GUNU",
	"CUNEIFORM SIGN GA2 TIMES A PLUS DA PLUS HA",
	"CUNEIFORM SIGN GA2 TIMES A PLUS HA",
	"CUNEIFORM SIGN GA2 TIMES A PLUS IGI",
	"CUNEIFORM SIGN GA2 TIMES AB2 TENU PLUS TAB",
	"CUNEIFORM SIGN GA2 TIMES AN",
	"CUNEIFORM SIGN GA2 TIMES ASH",
	"CUNEIFORM SIGN GA2 TIMES ASH2 PLUS GAL",
	"CUNEIFORM SIGN GA2 TIMES BAD",
	"CUNEIFORM SIGN GA2 TIMES BAR PLUS RA",
	"CUNEIFORM SIGN GA2 TIMES BUR",
	"CUNEIFORM SIGN GA2 TIMES BUR PLUS RA",
	"CUNEIFORM SIGN GA2 TIMES DA",
	"CUNEIFORM SIGN GA2 TIMES DI",
	"CUNEIFORM SIGN GA2 TIMES DIM TIMES SHE",
	"CUNEIFORM SIGN GA2 TIMES DUB",
	"CUNEIFORM SIGN GA2 TIMES EL",
	"CUNEIFORM SIGN GA2 TIMES EL PLUS LA",
	"CUNEIFORM SIGN GA2 TIMES EN",
	"CUNEIFORM SIGN GA2 TIMES EN TIMES GAN2 TENU",
	"CUNEIFORM SIGN GA2 TIMES GAN2 TENU",
	"CUNEIFORM SIGN GA2 TIMES GAR",
	"CUNEIFORM SIGN GA2 TIMES GI",
	"CUNEIFORM SIGN GA2 TIMES GI4 PLUS A",
	"CUNEIFORM SIGN GA2 TIMES GIR2 PLUS SU",
	"CUNEIFORM SIGN GA2 TIMES HAL",
	"CUNEIFORM SIGN GA2 TIMES HAL PLUS LA",
	"CUNEIFORM SIGN GA2 TIMES HI PLUS LI",
	"CUNEIFORM SIGN GA2 TIMES IGI GUNU",
	"CUNEIFORM SIGN GA2 TIMES ISH PLUS HU PLUS ASH",
	"CUNEIFORM SIGN GA2 TIMES KAK",
	"CUNEIFORM SIGN GA2 TIMES KASKAL",
	"CUNEIFORM SIGN GA2 TIMES KID",
	"CUNEIFORM SIGN GA2 TIMES KID PLUS LAL",
	"CUNEIFORM SIGN GA2 TIMES KU3 PLUS AN",
	"CUNEIFORM SIGN GA2 TIMES LA",
	"CUNEIFORM SIGN GA2 TIMES ME PLUS EN",
	"CUNEIFORM SIGN GA2 TIMES MI",
	"CUNEIFORM SIGN GA2 TIMES NUN",
	"CUNEIFORM SIGN GA2 TIMES NUN OVER NUN",
	"CUNEIFORM SIGN GA2 TIMES PA",
	"CUNEIFORM SIGN GA2 TIMES SAL",
	"CUNEIFORM SIGN GA2 TIMES SAR",
	"CUNEIFORM SIGN GA2 TIMES SHE",
	"CUNEIFORM SIGN GA2 TIMES SHE PLUS TUR",
	"CUNEIFORM SIGN GA2 TIMES SHID",
	"CUNEIFORM SIGN GA2 TIMES SUM",
	"CUNEIFORM SIGN GA2 TIMES U",
	"CUNEIFORM SIGN GA2 TIMES UD",
	"CUNEIFORM SIGN GA2 TIMES UD PLUS DU",
	"CUNEIFORM SIGN GABA",
	"CUNEIFORM SIGN GABA CROSSING GABA",
	"CUNEIFORM SIGN GAD",
	"CUNEIFORM SIGN GAD OVER GAD GAR OVER GAR",
	"CUNEIFORM SIGN GAL",
	"CUNEIFORM SIGN GAL GAD OVER GAD GAR OVER GAR",
	"CUNEIFORM SIGN GALAM",
	"CUNEIFORM SIGN GAM",
	"CUNEIFORM SIGN GAN",
	"CUNEIFORM SIGN GAN2 TENU",
	"CUNEIFORM SIGN GAR",
	"CUNEIFORM SIGN GASHAN",
	"CUNEIFORM SIGN GESHTIN",
	"CUNEIFORM SIGN GESHTIN TIMES KUR",
	"CUNEIFORM SIGN GI",
	"CUNEIFORM SIGN GI CROSSING GI",
	"CUNEIFORM SIGN GI TIMES E",
	"CUNEIFORM SIGN GI TIMES U",
	"CUNEIFORM SIGN GIDIM",
	"CUNEIFORM SIGN GIR2 GUNU",
	"CUNEIFORM SIGN GIR3 TIMES A PLUS IGI",
	"CUNEIFORM SIGN GIR3 TIMES GAN2 TENU",
	"CUNEIFORM SIGN GIR3 TIMES IGI",
	"CUNEIFORM SIGN GIR3 TIMES LU PLUS IGI",
	"CUNEIFORM SIGN GIR3 TIMES PA",
	"CUNEIFORM SIGN GISAL",
	"CUNEIFORM SIGN GISH",
	"CUNEIFORM SIGN GISH CROSSING GISH",
	"CUNEIFORM SIGN GISH TENU",
	"CUNEIFORM SIGN GISH TIMES BAD",
	"CUNEIFORM SIGN GU",
	"CUNEIFORM SIGN GU CROSSING GU",
	"CUNEIFORM SIGN GU2 GUNU",
	"CUNEIFORM SIGN GU2 TIMES KAK",
	"CUNEIFORM SIGN GU2 TIMES KAK TIMES IGI GUNU",
	"CUNEIFORM SIGN GU2 TIMES NUN",
	"CUNEIFORM SIGN GUD",
	"CUNEIFORM SIGN GUD OVER GUD LUGAL",
	"CUNEIFORM SIGN GUD TIMES A PLUS KUR",
	"CUNEIFORM SIGN GUD TIMES KUR",
	"CUNEIFORM SIGN GUL",
	"CUNEIFORM SIGN GUM",
	"CUNEIFORM SIGN GUM TIMES SHE",
	"CUNEIFORM SIGN GUR",
	"CUNEIFORM SIGN GURUN",
	"CUNEIFORM SIGN GURUSH",
	"CUNEIFORM SIGN HA",
	"CUNEIFORM SIGN HA GUNU",
	"CUNEIFORM SIGN HA TENU",
	"CUNEIFORM SIGN HAL",
	"CUNEIFORM SIGN HI",
	"CUNEIFORM SIGN HI TIMES ASH",
	"CUNEIFORM SIGN HI TIMES BAD",
	"CUNEIFORM SIGN HI TIMES DISH",
	"CUNEIFORM SIGN HI TIMES GAD",
	"CUNEIFORM SIGN HI TIMES KIN",
	"CUNEIFORM SIGN HI TIMES NUN",
	"CUNEIFORM SIGN HI TIMES SHE",
	"CUNEIFORM SIGN HI TIMES U",
	"CUNEIFORM SIGN HU",
	"CUNEIFORM SIGN HUB2 TIMES AN",
	"CUNEIFORM SIGN HUB2 TIMES HAL",
	"CUNEIFORM SIGN HUB2 TIMES KASKAL",
	"CUNEIFORM SIGN HUB2 TIMES LISH",
	"CUNEIFORM SIGN HUB2 TIMES UD",
	"CUNEIFORM SIGN I",
	"CUNEIFORM SIGN I A",
	"CUNEIFORM SIGN IB",
	"CUNEIFORM SIGN IDIM",
	"CUNEIFORM SIGN IDIM OVER IDIM BUR",
	"CUNEIFORM SIGN IDIM OVER IDIM SQUARED",
	"CUNEIFORM SIGN IG",
	"CUNEIFORM SIGN IGI",
	"CUNEIFORM SIGN IGI DIB",
	"CUNEIFORM SIGN IGI GUNU",
	"CUNEIFORM SIGN IGI OVER IGI SHIR OVER SHIR UD OVER UD",
	"CUNEIFORM SIGN IGI RI",
	"CUNEIFORM SIGN IL",
	"CUNEIFORM SIGN IL TIMES GAN2 TENU",
	"CUNEIFORM SIGN IM",
	"CUNEIFORM SIGN IM CROSSING IM",
	"CUNEIFORM SIGN IM OPPOSING IM",
	"CUNEIFORM SIGN IM SQUARED",
	"CUNEIFORM SIGN IMIN",
	"CUNEIFORM SIGN IN",
	"CUNEIFORM SIGN IR",
	"CUNEIFORM SIGN ISH",
	"CUNEIFORM SIGN KA",
	"CUNEIFORM SIGN KA TIMES A",
	"CUNEIFORM SIGN KA TIMES AD",
	"CUNEIFORM SIGN KA TIMES BAD",
	"CUNEIFORM SIGN KA TIMES BALAG",
	"CUNEIFORM SIGN KA TIMES BAR",
	"CUNEIFORM SIGN KA TIMES BI",
	"CUNEIFORM SIGN KA TIMES GA",
	"CUNEIFORM SIGN KA TIMES GAL",
	"CUNEIFORM SIGN KA TIMES GAN2 TENU",
	"CUNEIFORM SIGN KA TIMES GAR",
	"CUNEIFORM SIGN KA TIMES GAR PLUS SHA3 PLUS A",
	"CUNEIFORM SIGN KA TIMES GI",
	"CUNEIFORM SIGN KA TIMES GISH CROSSING GISH",
	"CUNEIFORM SIGN KA TIMES GISH PLUS SAR",
	"CUNEIFORM SIGN KA TIMES GU",
	"CUNEIFORM SIGN KA TIMES IGI",
	"CUNEIFORM SIGN KA TIMES IM",
	"CUNEIFORM SIGN KA TIMES KAK",
	"CUNEIFORM SIGN KA TIMES KI",
	"CUNEIFORM SIGN KA TIMES KID",
	"CUNEIFORM SIGN KA TIMES LI",
	"CUNEIFORM SIGN KA TIMES LU",
	"CUNEIFORM SIGN KA TIMES ME",
	"CUNEIFORM SIGN KA TIMES ME PLUS DU",
	"CUNEIFORM SIGN KA TIMES ME PLUS GI",
	"CUNEIFORM SIGN KA TIMES ME PLUS TE",
	"CUNEIFORM SIGN KA TIMES MI",
	"CUNEIFORM SIGN KA TIMES MI PLUS NUNUZ",
	"CUNEIFORM SIGN KA TIMES NE",
	"CUNEIFORM SIGN KA TIMES NUN",
	"CUNEIFORM SIGN KA TIMES PI",
	"CUNEIFORM SIGN KA TIMES RU",
	"CUNEIFORM SIGN KA TIMES SA",
	"CUNEIFORM SIGN KA TIMES SAR",
	"CUNEIFORM SIGN KA TIMES SHA",
	"CUNEIFORM SIGN KA TIMES SHE",
	"CUNEIFORM SIGN KA TIMES SHID",
	"CUNEIFORM SIGN KA TIMES SHU",
	"CUNEIFORM SIGN KA TIMES SIG",
	"CUNEIFORM SIGN KA TIMES SUHUR",
	"CUNEIFORM SIGN KA TIMES TAR",
	"CUNEIFORM SIGN KA TIMES U",
	"CUNEIFORM SIGN KA TIMES UD",
	"CUNEIFORM SIGN KA TIMES UMUM TIMES PA",
	"CUNEIFORM SIGN KA TIMES USH",
	"CUNEIFORM SIGN KA TIMES ZI",
	"CUNEIFORM SIGN KAB",
	"CUNEIFORM SIGN KAK",
	"CUNEIFORM SIGN KAK TIMES IGI GUNU",
	"CUNEIFORM SIGN KAL",
	"CUNEIFORM SIGN KAL CROSSING KAL",
	"CUNEIFORM SIGN KAL TIMES BAD",
	"CUNEIFORM SIGN KASKAL",
	"CUNEIFORM SIGN KASKAL LAGAB TIMES U OVER LAGAB TIMES U",
	"CUNEIFORM SIGN KASKAL OVER KASKAL LAGAB TIMES U OVER LAGAB TIMES U",
	"CUNEIFORM SIGN KI",
	"CUNEIFORM SIGN KI TIMES BAD",
	"CUNEIFORM SIGN KI TIMES U",
	"CUNEIFORM SIGN KI TIMES UD",
	"CUNEIFORM SIGN KID",
	"CUNEIFORM SIGN KIN",
	"CUNEIFORM SIGN KISAL",
	"CUNEIFORM SIGN KISH",
	"CUNEIFORM SIGN KU",
	"CUNEIFORM SIGN KU4 VARIANT FORM",
	"CUNEIFORM SIGN KUL",
	"CUNEIFORM SIGN KUL GUNU",
	"CUNEIFORM SIGN KUN",
	"CUNEIFORM SIGN KUR",
	"CUNEIFORM SIGN KUR OPPOSING KUR",
	"CUNEIFORM SIGN LA",
	"CUNEIFORM SIGN LAGAB",
	"CUNEIFORM SIGN LAGAB SQUARED",
	"CUNEIFORM SIGN LAGAB TIMES A",
	"CUNEIFORM SIGN LAGAB TIMES A PLUS DA PLUS HA",
	"CUNEIFORM SIGN LAGAB TIMES A PLUS GAR",
	"CUNEIFORM SIGN LAGAB TIMES A PLUS LAL",
	"CUNEIFORM SIGN LAGAB TIMES AL",
	"CUNEIFORM SIGN LAGAB TIMES AN",
	"CUNEIFORM SIGN LAGAB TIMES ASH ZIDA TENU",
	"CUNEIFORM SIGN LAGAB TIMES BAD",
	"CUNEIFORM SIGN LAGAB TIMES BI",
	"CUNEIFORM SIGN LAGAB TIMES DAR",
	"CUNEIFORM SIGN LAGAB TIMES EN",
	"CUNEIFORM SIGN LAGAB TIMES GA",
	"CUNEIFORM SIGN LAGAB TIMES GAR",
	"CUNEIFORM SIGN LAGAB TIMES GUD",
	"CUNEIFORM SIGN LAGAB TIMES GUD PLUS GUD",
	"CUNEIFORM SIGN LAGAB TIMES HA",
	"CUNEIFORM SIGN LAGAB TIMES HAL",
	"CUNEIFORM SIGN LAGAB TIMES HI TIMES NUN",
	"CUNEIFORM SIGN LAGAB TIMES IGI GUNU",
	"CUNEIFORM SIGN LAGAB TIMES IM",
	"CUNEIFORM SIGN LAGAB TIMES IM PLUS HA",
	"CUNEIFORM SIGN LAGAB TIMES IM PLUS LU",
	"CUNEIFORM SIGN LAGAB TIMES KI",
	"CUNEIFORM SIGN LAGAB TIMES KIN",
	"CUNEIFORM SIGN LAGAB TIMES KUL",
	"CUNEIFORM SIGN LAGAB TIMES KUL PLUS HI PLUS A",
	"CUNEIFORM SIGN LAGAB TIMES LAGAB",
	"CUNEIFORM SIGN LAGAB TIMES LISH",
	"CUNEIFORM SIGN LAGAB TIMES LU",
	"CUNEIFORM SIGN LAGAB TIMES LUL",
	"CUNEIFORM SIGN LAGAB TIMES ME",
	"CUNEIFORM SIGN LAGAB TIMES ME PLUS EN",
	"CUNEIFORM SIGN LAGAB TIMES MUSH",
	"CUNEIFORM SIGN LAGAB TIMES NE",
	"CUNEIFORM SIGN LAGAB TIMES SHE PLUS SUM",
	"CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH TENU",
	"CUNEIFORM SIGN LAGAB TIMES SUM",
	"CUNEIFORM SIGN LAGAB TIMES TAG",
	"CUNEIFORM SIGN LAGAB TIMES TE PLUS A PLUS SU PLUS NA",
	"CUNEIFORM SIGN LAGAB TIMES U",
	"CUNEIFORM SIGN LAGAB TIMES U PLUS A",
	"CUNEIFORM SIGN LAGAB TIMES U PLUS U PLUS U",
	"CUNEIFORM SIGN LAGAB TIMES U2 PLUS ASH",
	"CUNEIFORM SIGN LAGAB TIMES UD",
	"CUNEIFORM SIGN LAGAB TIMES USH",
	"CUNEIFORM SIGN LAGAR",
	"CUNEIFORM SIGN LAGAR GUNU",
	"CUNEIFORM SIGN LAGAR GUNU OVER LAGAR GUNU SHE",
	"CUNEIFORM SIGN LAGAR TIMES SHE",
	"CUNEIFORM SIGN LAGAR TIMES SHE PLUS SUM",
	"CUNEIFORM SIGN LAHSHU",
	"CUNEIFORM SIGN LAL",
	"CUNEIFORM SIGN LAL TIMES LAL",
	"CUNEIFORM SIGN LAM",
	"CUNEIFORM SIGN LAM TIMES KUR",
	"CUNEIFORM SIGN LAM TIMES KUR PLUS RU",
	"CUNEIFORM SIGN LI",
	"CUNEIFORM SIGN LIL",
	"CUNEIFORM SIGN LISH",
	"CUNEIFORM SIGN LU",
	"CUNEIFORM SIGN LU TIMES BAD",
	"CUNEIFORM SIGN LU2 SHESHIG",
	"CUNEIFORM SIGN LU2 SQUARED",
	"CUNEIFORM SIGN LU2 TENU",
	"CUNEIFORM SIGN LU2 TIMES AL",
	"CUNEIFORM SIGN LU2 TIMES BAD",
	"CUNEIFORM SIGN LU2 TIMES ESH2 TENU",
	"CUNEIFORM SIGN LU2 TIMES GAN2 TENU",
	"CUNEIFORM SIGN LU2 TIMES HI TIMES BAD",
	"CUNEIFORM SIGN LU2 TIMES IM",
	"CUNEIFORM SIGN LU2 TIMES KAD3 PLUS ASH",
	"CUNEIFORM SIGN LU2 TIMES KI",
	"CUNEIFORM SIGN LU2 TIMES LA PLUS ASH",
	"CUNEIFORM SIGN LU2 TIMES LAGAB",
	"CUNEIFORM SIGN LU2 TIMES ME PLUS EN",
	"CUNEIFORM SIGN LU2 TIMES NE",
	"CUNEIFORM SIGN LU2 TIMES NU",
	"CUNEIFORM SIGN LU2 TIMES SI PLUS ASH",
	"CUNEIFORM SIGN LU2 TIMES SIK2 PLUS BU",
	"CUNEIFORM SIGN LUGAL",
	"CUNEIFORM SIGN LUGAL OPPOSING LUGAL",
	"CUNEIFORM SIGN LUGAL OVER LUGAL",
	"CUNEIFORM SIGN LUGAL SHESHIG",
	"CUNEIFORM SIGN LUH",
	"CUNEIFORM SIGN LUL",
	"CUNEIFORM SIGN LUM",
	"CUNEIFORM SIGN LUM OVER LUM",
	"CUNEIFORM SIGN LUM OVER LUM GAR OVER GAR",
	"CUNEIFORM SIGN MA",
	"CUNEIFORM SIGN MA GUNU",
	"CUNEIFORM SIGN MAH",
	"CUNEIFORM SIGN MAR",
	"CUNEIFORM SIGN MASH",
	"CUNEIFORM SIGN ME",
	"CUNEIFORM SIGN MES",
	"CUNEIFORM SIGN MI",
	"CUNEIFORM SIGN MIN",
	"CUNEIFORM SIGN MU",
	"CUNEIFORM SIGN MU OVER MU",
	"CUNEIFORM SIGN MUG",
	"CUNEIFORM SIGN MUG GUNU",
	"CUNEIFORM SIGN MUNSUB",
	"CUNEIFORM SIGN MUSH",
	"CUNEIFORM SIGN MUSH CROSSING MUSH",
	"CUNEIFORM SIGN MUSH OVER MUSH",
	"CUNEIFORM SIGN MUSH OVER MUSH TIMES A PLUS NA",
	"CUNEIFORM SIGN MUSH TIMES A",
	"CUNEIFORM SIGN MUSH TIMES KUR",
	"CUNEIFORM SIGN MUSH TIMES ZA",
	"CUNEIFORM SIGN MUSH3 GUNU",
	"CUNEIFORM SIGN MUSH3 TIMES A",
	"CUNEIFORM SIGN MUSH3 TIMES A PLUS DI",
	"CUNEIFORM SIGN MUSH3 TIMES DI",
	"CUNEIFORM SIGN NA",
	"CUNEIFORM SIGN NAGA",
	"CUNEIFORM SIGN NAGA INVERTED",
	"CUNEIFORM SIGN NAGA OPPOSING NAGA",
	"CUNEIFORM SIGN NAGA TIMES SHU TENU",
	"CUNEIFORM SIGN NAGAR",
	"CUNEIFORM SIGN NAM",
	"CUNEIFORM SIGN NAM NUTILLU",
	"CUNEIFORM SIGN NE",
	"CUNEIFORM SIGN NE SHESHIG",
	"CUNEIFORM SIGN NE TIMES A",
	"CUNEIFORM SIGN NE TIMES UD",
	"CUNEIFORM SIGN NI",
	"CUNEIFORM SIGN NI TIMES E",
	"CUNEIFORM SIGN NIM",
	"CUNEIFORM SIGN NIM TIMES GAN2 TENU",
	"CUNEIFORM SIGN NIM TIMES GAR PLUS GAN2 TENU",
	"CUNEIFORM SIGN NINDA2 TIMES AN",
	"CUNEIFORM SIGN NINDA2 TIMES ASH",
	"CUNEIFORM SIGN NINDA2 TIMES ASH PLUS ASH",
	"CUNEIFORM SIGN NINDA2 TIMES GUD",
	"CUNEIFORM SIGN NINDA2 TIMES ME PLUS GAN2 TENU",
	"CUNEIFORM SIGN NINDA2 TIMES NE",
	"CUNEIFORM SIGN NINDA2 TIMES NUN",
	"CUNEIFORM SIGN NINDA2 TIMES SHE",
	"CUNEIFORM SIGN NINDA2 TIMES SHE PLUS A AN",
	"CUNEIFORM SIGN NINDA2 TIMES SHE PLUS ASH",
	"CUNEIFORM SIGN NINDA2 TIMES SHE PLUS ASH PLUS ASH",
	"CUNEIFORM SIGN NINDA2 TIMES U2 PLUS ASH",
	"CUNEIFORM SIGN NINDA2 TIMES USH",
	"CUNEIFORM SIGN NISAG",
	"CUNEIFORM SIGN NU",
	"CUNEIFORM SIGN NUN",
	"CUNEIFORM SIGN NUN CROSSING NUN",
	"CUNEIFORM SIGN NUN CROSSING NUN LAGAR OVER LAGAR",
	"CUNEIFORM SIGN NUN LAGAR TIMES GAR",
	"CUNEIFORM SIGN NUN LAGAR TIMES MASH",
	"CUNEIFORM SIGN NUN LAGAR TIMES SAL",
	"CUNEIFORM SIGN NUN LAGAR TIMES SAL OVER NUN LAGAR TIMES SAL",
	"CUNEIFORM SIGN NUN LAGAR TIMES USH",
	"CUNEIFORM SIGN NUN OVER NUN",
	"CUNEIFORM SIGN NUN TENU",
	"CUNEIFORM SIGN NUNUZ",
	"CUNEIFORM SIGN NUNUZ AB2 TIMES ASHGAB",
	"CUNEIFORM SIGN NUNUZ AB2 TIMES BI",
	"CUNEIFORM SIGN NUNUZ AB2 TIMES DUG",
	"CUNEIFORM SIGN NUNUZ AB2 TIMES GUD",
	"CUNEIFORM SIGN NUNUZ AB2 TIMES IGI GUNU",
	"CUNEIFORM SIGN NUNUZ AB2 TIMES LA",
	"CUNEIFORM SIGN NUNUZ AB2 TIMES NE",
	"CUNEIFORM SIGN NUNUZ KISIM5 TIMES BI",
	"CUNEIFORM SIGN NUNUZ KISIM5 TIMES BI U",
	"CUNEIFORM SIGN PA",
	"CUNEIFORM SIGN PAD",
	"CUNEIFORM SIGN PAN",
	"CUNEIFORM SIGN PAP",
	"CUNEIFORM SIGN PI",
	"CUNEIFORM SIGN PI CROSSING PI",
	"CUNEIFORM SIGN PI TIMES A",
	"CUNEIFORM SIGN PI TIMES AB",
	"CUNEIFORM SIGN PI TIMES BI",
	"CUNEIFORM SIGN PI TIMES BU",
	"CUNEIFORM SIGN PI TIMES E",
	"CUNEIFORM SIGN PI TIMES I",
	"CUNEIFORM SIGN PI TIMES IB",
	"CUNEIFORM SIGN PI TIMES U",
	"CUNEIFORM SIGN PIRIG",
	"CUNEIFORM SIGN PIRIG OPPOSING PIRIG",
	"CUNEIFORM SIGN PIRIG TIMES KAL",
	"CUNEIFORM SIGN PIRIG TIMES UD",
	"CUNEIFORM SIGN PIRIG TIMES ZA",
	"CUNEIFORM SIGN RA",
	"CUNEIFORM SIGN RAB",
	"CUNEIFORM SIGN RI",
	"CUNEIFORM SIGN RU",
	"CUNEIFORM SIGN SA",
	"CUNEIFORM SIGN SAG",
	"CUNEIFORM SIGN SAG GUNU",
	"CUNEIFORM SIGN SAG NUTILLU",
	"CUNEIFORM SIGN SAG OVER SAG",
	"CUNEIFORM SIGN SAG TIMES A",
	"CUNEIFORM SIGN SAG TIMES DU",
	"CUNEIFORM SIGN SAG TIMES DUB",
	"CUNEIFORM SIGN SAG TIMES HA",
	"CUNEIFORM SIGN SAG TIMES KAK",
	"CUNEIFORM SIGN SAG TIMES KUR",
	"CUNEIFORM SIGN SAG TIMES LUM",
	"CUNEIFORM SIGN SAG TIMES MI",
	"CUNEIFORM SIGN SAG TIMES NUN",
	"CUNEIFORM SIGN SAG TIMES SAL",
	"CUNEIFORM SIGN SAG TIMES SHID",
	"CUNEIFORM SIGN SAG TIMES TAB",
	"CUNEIFORM SIGN SAG TIMES UB",
	"CUNEIFORM SIGN SAG TIMES UM",
	"CUNEIFORM SIGN SAG TIMES UR",
	"CUNEIFORM SIGN SAG TIMES USH",
	"CUNEIFORM SIGN SAL",
	"CUNEIFORM SIGN SAR",
	"CUNEIFORM SIGN SHA",
	"CUNEIFORM SIGN SHA3 TIMES A",
	"CUNEIFORM SIGN SHA3 TIMES BAD",
	"CUNEIFORM SIGN SHA3 TIMES GISH",
	"CUNEIFORM SIGN SHA3 TIMES NE",
	"CUNEIFORM SIGN SHA3 TIMES TUR",
	"CUNEIFORM SIGN SHA3 TIMES U",
	"CUNEIFORM SIGN SHA3 TIMES U PLUS A",
	"CUNEIFORM SIGN SHE",
	"CUNEIFORM SIGN SHE HU",
	"CUNEIFORM SIGN SHE OVER SHE GAD OVER GAD GAR OVER GAR",
	"CUNEIFORM SIGN SHE OVER SHE TAB OVER TAB GAR OVER GAR",
	"CUNEIFORM SIGN SHEN",
	"CUNEIFORM SIGN SHESH",
	"CUNEIFORM SIGN SHESHLAM",
	"CUNEIFORM SIGN SHID",
	"CUNEIFORM SIGN SHID TIMES A",
	"CUNEIFORM SIGN SHID TIMES IM",
	"CUNEIFORM SIGN SHIM",
	"CUNEIFORM SIGN SHIM TIMES A",
	"CUNEIFORM SIGN SHIM TIMES BAL",
	"CUNEIFORM SIGN SHIM TIMES BULUG",
	"CUNEIFORM SIGN SHIM TIMES DIN",
	"CUNEIFORM SIGN SHIM TIMES GAR",
	"CUNEIFORM SIGN SHIM TIMES IGI",
	"CUNEIFORM SIGN SHIM TIMES IGI GUNU",
	"CUNEIFORM SIGN SHIM TIMES LUL",
	"CUNEIFORM SIGN SHIM TIMES MUG",
	"CUNEIFORM SIGN SHIM TIMES SAL",
	"CUNEIFORM SIGN SHINIG",
	"CUNEIFORM SIGN SHIR",
	"CUNEIFORM SIGN SHIR OVER SHIR BUR OVER BUR",
	"CUNEIFORM SIGN SHIR TENU",
	"CUNEIFORM SIGN SHITA",
	"CUNEIFORM SIGN SHU",
	"CUNEIFORM SIGN SHU OVER INVERTED SHU",
	"CUNEIFORM SIGN SHUBUR",
	"CUNEIFORM SIGN SI",
	"CUNEIFORM SIGN SI GUNU",
	"CUNEIFORM SIGN SIG",
	"CUNEIFORM SIGN SU",
	"CUNEIFORM SIGN SU OVER SU",
	"CUNEIFORM SIGN SUD",
	"CUNEIFORM SIGN SUHUR",
	"CUNEIFORM SIGN SUM",
	"CUNEIFORM SIGN SUMASH",
	"CUNEIFORM SIGN SUR",
	"CUNEIFORM SIGN TA",
	"CUNEIFORM SIGN TA ASTERISK",
	"CUNEIFORM SIGN TA GUNU",
	"CUNEIFORM SIGN TA TIMES HI",
	"CUNEIFORM SIGN TA TIMES MI",
	"CUNEIFORM SIGN TAB",
	"CUNEIFORM SIGN TAB OVER TAB NI OVER NI DISH OVER DISH",
	"CUNEIFORM SIGN TAB SQUARED",
	"CUNEIFORM SIGN TAG",
	"CUNEIFORM SIGN TAG TIMES BI",
	"CUNEIFORM SIGN TAG TIMES GUD",
	"CUNEIFORM SIGN TAG TIMES SHE",
	"CUNEIFORM SIGN TAG TIMES SHU",
	"CUNEIFORM SIGN TAG TIMES UD",
	"CUNEIFORM SIGN TAR",
	"CUNEIFORM SIGN TE",
	"CUNEIFORM SIGN TE GUNU",
	"CUNEIFORM SIGN TI",
	"CUNEIFORM SIGN TI TENU",
	"CUNEIFORM SIGN TIL",
	"CUNEIFORM SIGN TIR",
	"CUNEIFORM SIGN TIR OVER TIR",
	"CUNEIFORM SIGN TIR OVER TIR GAD OVER GAD GAR OVER GAR",
	"CUNEIFORM SIGN TU",
	"CUNEIFORM SIGN TUK",
	"CUNEIFORM SIGN TUM",
	"CUNEIFORM SIGN TUR",
	"CUNEIFORM SIGN TUR OVER TUR ZA OVER ZA",
	"CUNEIFORM SIGN U",
	"CUNEIFORM SIGN U GUD",
	"CUNEIFORM SIGN U OVER U PA OVER PA GAR OVER GAR",
	"CUNEIFORM SIGN U OVER U SUR OVER SUR",
	"CUNEIFORM SIGN U OVER U U REVERSED OVER U REVERSED",
	"CUNEIFORM SIGN U U U",
	"CUNEIFORM SIGN UB",
	"CUNEIFORM SIGN UD",
	"CUNEIFORM SIGN UD GUNU",
	"CUNEIFORM SIGN UD SHESHIG",
	"CUNEIFORM SIGN UD SHESHIG TIMES BAD",
	"CUNEIFORM SIGN UD TIMES BAD",
	"CUNEIFORM SIGN UD TIMES MI",
	"CUNEIFORM SIGN UD TIMES U PLUS U PLUS U",
	"CUNEIFORM SIGN UD TIMES U PLUS U PLUS U GUNU",
	"CUNEIFORM SIGN UDUG",
	"CUNEIFORM SIGN UM",
	"CUNEIFORM SIGN UM TIMES LAGAB",
	"CUNEIFORM SIGN UM TIMES ME PLUS DA",
	"CUNEIFORM SIGN UM TIMES U",
	"CUNEIFORM SIGN UMBIN",
	"CUNEIFORM SIGN UMUM",
	"CUNEIFORM SIGN UMUM TIMES KASKAL",
	"CUNEIFORM SIGN UMUM TIMES PA",
	"CUNEIFORM SIGN UN",
	"CUNEIFORM SIGN UN GUNU",
	"CUNEIFORM SIGN UR",
	"CUNEIFORM SIGN UR CROSSING UR",
	"CUNEIFORM SIGN UR SHESHIG",
	"CUNEIFORM SIGN UR2 TIMES A PLUS HA",
	"CUNEIFORM SIGN UR2 TIMES A PLUS NA",
	"CUNEIFORM SIGN UR2 TIMES AL",
	"CUNEIFORM SIGN UR2 TIMES HA",
	"CUNEIFORM SIGN UR2 TIMES NUN",
	"CUNEIFORM SIGN UR2 TIMES U2 PLUS ASH",
	"CUNEIFORM SIGN UR2 TIMES U2 PLUS BI",
	"CUNEIFORM SIGN URI",
	"CUNEIFORM SIGN URU",
	"CUNEIFORM SIGN URU TIMES A",
	"CUNEIFORM SIGN URU TIMES ASHGAB",
	"CUNEIFORM SIGN URU TIMES BAR",
	"CUNEIFORM SIGN URU TIMES DUN",
	"CUNEIFORM SIGN URU TIMES GA",
	"CUNEIFORM SIGN URU TIMES GAL",
	"CUNEIFORM SIGN URU TIMES GAN2 TENU",
	"CUNEIFORM SIGN URU TIMES GAR",
	"CUNEIFORM SIGN URU TIMES GU",
	"CUNEIFORM SIGN URU TIMES HA",
	"CUNEIFORM SIGN URU TIMES IGI",
	"CUNEIFORM SIGN URU TIMES IM",
	"CUNEIFORM SIGN URU TIMES ISH",
	"CUNEIFORM SIGN URU TIMES KI",
	"CUNEIFORM SIGN URU TIMES LUM",
	"CUNEIFORM SIGN URU TIMES MIN",
	"CUNEIFORM SIGN URU TIMES PA",
	"CUNEIFORM SIGN URU TIMES SHE",
	"CUNEIFORM SIGN URU TIMES TU",
	"CUNEIFORM SIGN URU TIMES U PLUS GUD",
	"CUNEIFORM SIGN URU TIMES UD",
	"CUNEIFORM SIGN URU TIMES URUDA",
	"CUNEIFORM SIGN URUDA",
	"CUNEIFORM SIGN URUDA TIMES U",
	"CUNEIFORM SIGN USH",
	"CUNEIFORM SIGN USH TIMES A",
	"CUNEIFORM SIGN USH TIMES KU",
	"CUNEIFORM SIGN USH TIMES KUR",
	"CUNEIFORM SIGN USHUMX",
	"CUNEIFORM SIGN USHX",
	"CUNEIFORM SIGN UTUKI",
	"CUNEIFORM SIGN UZ3 TIMES KASKAL",
	"CUNEIFORM SIGN UZU",
	"CUNEIFORM SIGN ZA",
	"CUNEIFORM SIGN ZA SQUARED TIMES KUR",
	"CUNEIFORM SIGN ZA TENU",
	"CUNEIFORM SIGN ZAG",
	"CUNEIFORM SIGN ZAMX",
	"CUNEIFORM SIGN ZI",
	"CUNEIFORM SIGN ZI OVER ZI",
	"CUNEIFORM SIGN ZIB",
	"CUNEIFORM SIGN ZIB KABA TENU",
	"CUNEIFORM SIGN ZIG",
	"CUNEIFORM SIGN ZU",
	"CUNEIFORM SIGN ZU5 TIMES A",
	"CUNEIFORM SIGN ZUBUR",
	"CUNEIFORM SIGN ZUM",
	"CUP ON BLACK SQUARE",
	"CURLY BRACKET EXTENSION",
	"CURLY LOGICAL AND",
	"CURLY LOGICAL OR",
	"CURLY LOOP",
	"CURRENCY EXCHANGE",
	"CURRENCY SIGN",
	"CURRY AND RICE",
	"CURVED STEM PARAGRAPH SIGN ORNAMENT",
	"CUSTARD",
	"CUSTOMS",
	"CYCLONE",
	"CYLINDRICITY",
	"CYPRIOT SYLLABLE A",
	"CYPRIOT SYLLABLE E",
	"CYPRIOT SYLLABLE I",
	"CYPRIOT SYLLABLE JA",
	"CYPRIOT SYLLABLE JO",
	"CYPRIOT SYLLABLE KA",
	"CYPRIOT SYLLABLE KE",
	"CYPRIOT SYLLABLE KI",
	"CYPRIOT SYLLABLE KO",
	"CYPRIOT SYLLABLE KU",
	"CYPRIOT SYLLABLE LA",
	"CYPRIOT SYLLABLE LE",
	"CYPRIOT SYLLABLE LI",
	"CYPRIOT SYLLABLE LO",
	"CYPRIOT SYLLABLE LU",
	"CYPRIOT SYLLABLE MA",
	"CYPRIOT SYLLABLE ME",
	"CYPRIOT SYLLABLE MI",
	"CYPRIOT SYLLABLE MO",
	"CYPRIOT SYLLABLE MU",
	"CYPRIOT SYLLABLE NA",
	"CYPRIOT SYLLABLE NE",
	"CYPRIOT SYLLABLE NI",
	"CYPRIOT SYLLABLE NO",
	"CYPRIOT SYLLABLE NU",
	"CYPRIOT SYLLABLE O",
	"CYPRIOT SYLLABLE PA",
	"CYPRIOT SYLLABLE PE",
	"CYPRIOT SYLLABLE PI",
	"CYPRIOT SYLLABLE PO",
	"CYPRIOT SYLLABLE PU",
	"CYPRIOT SYLLABLE RA",
	"CYPRIOT SYLLABLE RE",
	"CYPRIOT SYLLABLE RI",
	"CYPRIOT SYLLABLE RO",
	"CYPRIOT SYLLABLE RU",
	"CYPRIOT SYLLABLE SA",
	"CYPRIOT SYLLABLE SE",
	"CYPRIOT SYLLABLE SI",
	"CYPRIOT SYLLABLE SO",
	"CYPRIOT SYLLABLE SU",
	"CYPRIOT SYLLABLE TA",
	"CYPRIOT SYLLABLE TE",
	"CYPRIOT SYLLABLE TI",
	"CYPRIOT SYLLABLE TO",
	"CYPRIOT SYLLABLE TU",
	"CYPRIOT SYLLABLE U",
	"CYPRIOT SYLLABLE WA",
	"CYPRIOT SYLLABLE WE",
	"CYPRIOT SYLLABLE WI",
	"CYPRIOT SYLLABLE WO",
	"CYPRIOT SYLLABLE XA",
	"CYPRIOT SYLLABLE XE",
	"CYPRIOT SYLLABLE ZA",
	"CYPRIOT SYLLABLE ZO",
	"CYRILLIC CAPITAL LETTER A",
	"CYRILLIC CAPITAL LETTER A WITH BREVE",
	"CYRILLIC CAPITAL LETTER A WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER ABKHASIAN CHE",
	"CYRILLIC CAPITAL LETTER ABKHASIAN CHE WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER ABKHASIAN DZE",
	"CYRILLIC CAPITAL LETTER ABKHASIAN HA",
	"CYRILLIC CAPITAL LETTER ALEUT KA",
	"CYRILLIC CAPITAL LETTER BARRED O",
	"CYRILLIC CAPITAL LETTER BARRED O WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER BASHKIR KA",
	"CYRILLIC CAPITAL LETTER BE",
	"CYRILLIC CAPITAL LETTER BIG YUS",
	"CYRILLIC CAPITAL LETTER BINOCULAR O",
	"CYRILLIC CAPITAL LETTER BLENDED YUS",
	"CYRILLIC CAPITAL LETTER BROAD OMEGA",
	"CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I",
	"CYRILLIC CAPITAL LETTER CCHE",
	"CYRILLIC CAPITAL LETTER CHE",
	"CYRILLIC CAPITAL LETTER CHE WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER CHE WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER CHE WITH VERTICAL STROKE",
	"CYRILLIC CAPITAL LETTER CLOSED LITTLE YUS",
	"CYRILLIC CAPITAL LETTER DE",
	"CYRILLIC CAPITAL LETTER DJE",
	"CYRILLIC CAPITAL LETTER DJERV",
	"CYRILLIC CAPITAL LETTER DOUBLE MONOCULAR O",
	"CYRILLIC CAPITAL LETTER DWE",
	"CYRILLIC CAPITAL LETTER DZE",
	"CYRILLIC CAPITAL LETTER DZELO",
	"CYRILLIC CAPITAL LETTER DZHE",
	"CYRILLIC CAPITAL LETTER DZWE",
	"CYRILLIC CAPITAL LETTER DZZE",
	"CYRILLIC CAPITAL LETTER E",
	"CYRILLIC CAPITAL LETTER E WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER EF",
	"CYRILLIC CAPITAL LETTER EL",
	"CYRILLIC CAPITAL LETTER EL WITH HOOK",
	"CYRILLIC CAPITAL LETTER EL WITH MIDDLE HOOK",
	"CYRILLIC CAPITAL LETTER EL WITH TAIL",
	"CYRILLIC CAPITAL LETTER EM",
	"CYRILLIC CAPITAL LETTER EM WITH TAIL",
	"CYRILLIC CAPITAL LETTER EN",
	"CYRILLIC CAPITAL LETTER EN WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER EN WITH HOOK",
	"CYRILLIC CAPITAL LETTER EN WITH MIDDLE HOOK",
	"CYRILLIC CAPITAL LETTER EN WITH TAIL",
	"CYRILLIC CAPITAL LETTER ER",
	"CYRILLIC CAPITAL LETTER ER WITH TICK",
	"CYRILLIC CAPITAL LETTER ES",
	"CYRILLIC CAPITAL LETTER ES WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER FITA",
	"CYRILLIC CAPITAL LETTER GHE",
	"CYRILLIC CAPITAL LETTER GHE WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER GHE WITH MIDDLE HOOK",
	"CYRILLIC CAPITAL LETTER GHE WITH STROKE",
	"CYRILLIC CAPITAL LETTER GHE WITH STROKE AND HOOK",
	"CYRILLIC CAPITAL LETTER GHE WITH UPTURN",
	"CYRILLIC CAPITAL LETTER GJE",
	"CYRILLIC CAPITAL LETTER HA",
	"CYRILLIC CAPITAL LETTER HA WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER HA WITH HOOK",
	"CYRILLIC CAPITAL LETTER HA WITH STROKE",
	"CYRILLIC CAPITAL LETTER HARD SIGN",
	"CYRILLIC CAPITAL LETTER HWE",
	"CYRILLIC CAPITAL LETTER I",
	"CYRILLIC CAPITAL LETTER I WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER I WITH GRAVE",
	"CYRILLIC CAPITAL LETTER I WITH MACRON",
	"CYRILLIC CAPITAL LETTER IE",
	"CYRILLIC CAPITAL LETTER IE WITH BREVE",
	"CYRILLIC CAPITAL LETTER IE WITH GRAVE",
	"CYRILLIC CAPITAL LETTER IO",
	"CYRILLIC CAPITAL LETTER IOTA",
	"CYRILLIC CAPITAL LETTER IOTIFIED A",
	"CYRILLIC CAPITAL LETTER IOTIFIED BIG YUS",
	"CYRILLIC CAPITAL LETTER IOTIFIED CLOSED LITTLE YUS",
	"CYRILLIC CAPITAL LETTER IOTIFIED E",
	"CYRILLIC CAPITAL LETTER IOTIFIED LITTLE YUS",
	"CYRILLIC CAPITAL LETTER IOTIFIED YAT",
	"CYRILLIC CAPITAL LETTER IZHITSA",
	"CYRILLIC CAPITAL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT",
	"CYRILLIC CAPITAL LETTER JE",
	"CYRILLIC CAPITAL LETTER KA",
	"CYRILLIC CAPITAL LETTER KA WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER KA WITH HOOK",
	"CYRILLIC CAPITAL LETTER KA WITH STROKE",
	"CYRILLIC CAPITAL LETTER KA WITH VERTICAL STROKE",
	"CYRILLIC CAPITAL LETTER KHAKASSIAN CHE",
	"CYRILLIC CAPITAL LETTER KJE",
	"CYRILLIC CAPITAL LETTER KOMI DE",
	"CYRILLIC CAPITAL LETTER KOMI DJE",
	"CYRILLIC CAPITAL LETTER KOMI DZJE",
	"CYRILLIC CAPITAL LETTER KOMI LJE",
	"CYRILLIC CAPITAL LETTER KOMI NJE",
	"CYRILLIC CAPITAL LETTER KOMI SJE",
	"CYRILLIC CAPITAL LETTER KOMI TJE",
	"CYRILLIC CAPITAL LETTER KOMI ZJE",
	"CYRILLIC CAPITAL LETTER KOPPA",
	"CYRILLIC CAPITAL LETTER KSI",
	"CYRILLIC CAPITAL LETTER LHA",
	"CYRILLIC CAPITAL LETTER LITTLE YUS",
	"CYRILLIC CAPITAL LETTER LJE",
	"CYRILLIC CAPITAL LETTER MONOCULAR O",
	"CYRILLIC CAPITAL LETTER MONOGRAPH UK",
	"CYRILLIC CAPITAL LETTER NEUTRAL YER",
	"CYRILLIC CAPITAL LETTER NJE",
	"CYRILLIC CAPITAL LETTER O",
	"CYRILLIC CAPITAL LETTER O WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER OMEGA",
	"CYRILLIC CAPITAL LETTER OMEGA WITH TITLO",
	"CYRILLIC CAPITAL LETTER OT",
	"CYRILLIC CAPITAL LETTER PE",
	"CYRILLIC CAPITAL LETTER PE WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER PE WITH MIDDLE HOOK",
	"CYRILLIC CAPITAL LETTER PSI",
	"CYRILLIC CAPITAL LETTER QA",
	"CYRILLIC CAPITAL LETTER REVERSED DZE",
	"CYRILLIC CAPITAL LETTER REVERSED TSE",
	"CYRILLIC CAPITAL LETTER REVERSED YU",
	"CYRILLIC CAPITAL LETTER REVERSED ZE",
	"CYRILLIC CAPITAL LETTER RHA",
	"CYRILLIC CAPITAL LETTER ROUND OMEGA",
	"CYRILLIC CAPITAL LETTER SCHWA",
	"CYRILLIC CAPITAL LETTER SCHWA WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER SEMISOFT SIGN",
	"CYRILLIC CAPITAL LETTER SHA",
	"CYRILLIC CAPITAL LETTER SHCHA",
	"CYRILLIC CAPITAL LETTER SHHA",
	"CYRILLIC CAPITAL LETTER SHHA WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER SHORT I",
	"CYRILLIC CAPITAL LETTER SHORT I WITH TAIL",
	"CYRILLIC CAPITAL LETTER SHORT U",
	"CYRILLIC CAPITAL LETTER SHWE",
	"CYRILLIC CAPITAL LETTER SOFT DE",
	"CYRILLIC CAPITAL LETTER SOFT EL",
	"CYRILLIC CAPITAL LETTER SOFT EM",
	"CYRILLIC CAPITAL LETTER SOFT SIGN",
	"CYRILLIC CAPITAL LETTER STRAIGHT U",
	"CYRILLIC CAPITAL LETTER STRAIGHT U WITH STROKE",
	"CYRILLIC CAPITAL LETTER TCHE",
	"CYRILLIC CAPITAL LETTER TE",
	"CYRILLIC CAPITAL LETTER TE WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER TE WITH MIDDLE HOOK",
	"CYRILLIC CAPITAL LETTER TSE",
	"CYRILLIC CAPITAL LETTER TSHE",
	"CYRILLIC CAPITAL LETTER TSSE",
	"CYRILLIC CAPITAL LETTER TSWE",
	"CYRILLIC CAPITAL LETTER TWE",
	"CYRILLIC CAPITAL LETTER U",
	"CYRILLIC CAPITAL LETTER U WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE",
	"CYRILLIC CAPITAL LETTER U WITH MACRON",
	"CYRILLIC CAPITAL LETTER UK",
	"CYRILLIC CAPITAL LETTER UKRAINIAN IE",
	"CYRILLIC CAPITAL LETTER VE",
	"CYRILLIC CAPITAL LETTER WE",
	"CYRILLIC CAPITAL LETTER YA",
	"CYRILLIC CAPITAL LETTER YAE",
	"CYRILLIC CAPITAL LETTER YAT",
	"CYRILLIC CAPITAL LETTER YERU",
	"CYRILLIC CAPITAL LETTER YERU WITH BACK YER",
	"CYRILLIC CAPITAL LETTER YERU WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER YI",
	"CYRILLIC CAPITAL LETTER YN",
	"CYRILLIC CAPITAL LETTER YU",
	"CYRILLIC CAPITAL LETTER ZE",
	"CYRILLIC CAPITAL LETTER ZE WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER ZE WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER ZEMLYA",
	"CYRILLIC CAPITAL LETTER ZHE",
	"CYRILLIC CAPITAL LETTER ZHE WITH BREVE",
	"CYRILLIC CAPITAL LETTER ZHE WITH DESCENDER",
	"CYRILLIC CAPITAL LETTER ZHE WITH DIAERESIS",
	"CYRILLIC CAPITAL LETTER ZHWE",
	"CYRILLIC CAPITAL LIGATURE A IE",
	"CYRILLIC CAPITAL LIGATURE EN GHE",
	"CYRILLIC CAPITAL LIGATURE TE TSE",
	"CYRILLIC KAVYKA",
	"CYRILLIC LETTER MULTIOCULAR O",
	"CYRILLIC LETTER PALOCHKA",
	"CYRILLIC LETTER SMALL CAPITAL EL",
	"CYRILLIC PAYEROK",
	"CYRILLIC SMALL LETTER A",
	"CYRILLIC SMALL LETTER A WITH BREVE",
	"CYRILLIC SMALL LETTER A WITH DIAERESIS",
	"CYRILLIC SMALL LETTER ABKHASIAN CHE",
	"CYRILLIC SMALL LETTER ABKHASIAN CHE WITH DESCENDER",
	"CYRILLIC SMALL LETTER ABKHASIAN DZE",
	"CYRILLIC SMALL LETTER ABKHASIAN HA",
	"CYRILLIC SMALL LETTER ALEUT KA",
	"CYRILLIC SMALL LETTER BARRED O",
	"CYRILLIC SMALL LETTER BARRED O WITH DIAERESIS",
	"CYRILLIC SMALL LETTER BASHKIR KA",
	"CYRILLIC SMALL LETTER BE",
	"CYRILLIC SMALL LETTER BIG YUS",
	"CYRILLIC SMALL LETTER BINOCULAR O",
	"CYRILLIC SMALL LETTER BLENDED YUS",
	"CYRILLIC SMALL LETTER BROAD OMEGA",
	"CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I",
	"CYRILLIC SMALL LETTER CCHE",
	"CYRILLIC SMALL LETTER CHE",
	"CYRILLIC SMALL LETTER CHE WITH DESCENDER",
	"CYRILLIC SMALL LETTER CHE WITH DIAERESIS",
	"CYRILLIC SMALL LETTER CHE WITH VERTICAL STROKE",
	"CYRILLIC SMALL LETTER CLOSED LITTLE YUS",
	"CYRILLIC SMALL LETTER DE",
	"CYRILLIC SMALL LETTER DJE",
	"CYRILLIC SMALL LETTER DJERV",
	"CYRILLIC SMALL LETTER DOUBLE MONOCULAR O",
	"CYRILLIC SMALL LETTER DWE",
	"CYRILLIC SMALL LETTER DZE",
	"CYRILLIC SMALL LETTER DZELO",
	"CYRILLIC SMALL LETTER DZHE",
	"CYRILLIC SMALL LETTER DZWE",
	"CYRILLIC SMALL LETTER DZZE",
	"CYRILLIC SMALL LETTER E",
	"CYRILLIC SMALL LETTER E WITH DIAERESIS",
	"CYRILLIC SMALL LETTER EF",
	"CYRILLIC SMALL LETTER EL",
	"CYRILLIC SMALL LETTER EL WITH HOOK",
	"CYRILLIC SMALL LETTER EL WITH MIDDLE HOOK",
	"CYRILLIC SMALL LETTER EL WITH TAIL",
	"CYRILLIC SMALL LETTER EM",
	"CYRILLIC SMALL LETTER EM WITH TAIL",
	"CYRILLIC SMALL LETTER EN",
	"CYRILLIC SMALL LETTER EN WITH DESCENDER",
	"CYRILLIC SMALL LETTER EN WITH HOOK",
	"CYRILLIC SMALL LETTER EN WITH MIDDLE HOOK",
	"CYRILLIC SMALL LETTER EN WITH TAIL",
	"CYRILLIC SMALL LETTER ER",
	"CYRILLIC SMALL LETTER ER WITH TICK",
	"CYRILLIC SMALL LETTER ES",
	"CYRILLIC SMALL LETTER ES WITH DESCENDER",
	"CYRILLIC SMALL LETTER FITA",
	"CYRILLIC SMALL LETTER GHE",
	"CYRILLIC SMALL LETTER GHE WITH DESCENDER",
	"CYRILLIC SMALL LETTER GHE WITH MIDDLE HOOK",
	"CYRILLIC SMALL LETTER GHE WITH STROKE",
	"CYRILLIC SMALL LETTER GHE WITH STROKE AND HOOK",
	"CYRILLIC SMALL LETTER GHE WITH UPTURN",
	"CYRILLIC SMALL LETTER GJE",
	"CYRILLIC SMALL LETTER HA",
	"CYRILLIC SMALL LETTER HA WITH DESCENDER",
	"CYRILLIC SMALL LETTER HA WITH HOOK",
	"CYRILLIC SMALL LETTER HA WITH STROKE",
	"CYRILLIC SMALL LETTER HARD SIGN",
	"CYRILLIC SMALL LETTER HWE",
	"CYRILLIC SMALL LETTER I",
	"CYRILLIC SMALL LETTER I WITH DIAERESIS",
	"CYRILLIC SMALL LETTER I WITH GRAVE",
	"CYRILLIC SMALL LETTER I WITH MACRON",
	"CYRILLIC SMALL LETTER IE",
	"CYRILLIC SMALL LETTER IE WITH BREVE",
	"CYRILLIC SMALL LETTER IE WITH GRAVE",
	"CYRILLIC SMALL LETTER IO",
	"CYRILLIC SMALL LETTER IOTA",
	"CYRILLIC SMALL LETTER IOTIFIED A",
	"CYRILLIC SMALL LETTER IOTIFIED BIG YUS",
	"CYRILLIC SMALL LETTER IOTIFIED CLOSED LITTLE YUS",
	"CYRILLIC SMALL LETTER IOTIFIED E",
	"CYRILLIC SMALL LETTER IOTIFIED LITTLE YUS",
	"CYRILLIC SMALL LETTER IOTIFIED YAT",
	"CYRILLIC SMALL LETTER IZHITSA",
	"CYRILLIC SMALL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT",
	"CYRILLIC SMALL LETTER JE",
	"CYRILLIC SMALL LETTER KA",
	"CYRILLIC SMALL LETTER KA WITH DESCENDER",
	"CYRILLIC SMALL LETTER KA WITH HOOK",
	"CYRILLIC SMALL LETTER KA WITH STROKE",
	"CYRILLIC SMALL LETTER KA WITH VERTICAL STROKE",
	"CYRILLIC SMALL LETTER KHAKASSIAN CHE",
	"CYRILLIC SMALL LETTER KJE",
	"CYRILLIC SMALL LETTER KOMI DE",
	"CYRILLIC SMALL LETTER KOMI DJE",
	"CYRILLIC SMALL LETTER KOMI DZJE",
	"CYRILLIC SMALL LETTER KOMI LJE",
	"CYRILLIC SMALL LETTER KOMI NJE",
	"CYRILLIC SMALL LETTER KOMI SJE",
	"CYRILLIC SMALL LETTER KOMI TJE",
	"CYRILLIC SMALL LETTER KOMI ZJE",
	"CYRILLIC SMALL LETTER KOPPA",
	"CYRILLIC SMALL LETTER KSI",
	"CYRILLIC SMALL LETTER LHA",
	"CYRILLIC SMALL LETTER LITTLE YUS",
	"CYRILLIC SMALL LETTER LJE",
	"CYRILLIC SMALL LETTER MONOCULAR O",
	"CYRILLIC SMALL LETTER MONOGRAPH UK",
	"CYRILLIC SMALL LETTER NEUTRAL YER",
	"CYRILLIC SMALL LETTER NJE",
	"CYRILLIC SMALL LETTER O",
	"CYRILLIC SMALL LETTER O WITH DIAERESIS",
	"CYRILLIC SMALL LETTER OMEGA",
	"CYRILLIC SMALL LETTER OMEGA WITH TITLO",
	"CYRILLIC SMALL LETTER OT",
	"CYRILLIC SMALL LETTER PALOCHKA",
	"CYRILLIC SMALL LETTER PE",
	"CYRILLIC SMALL LETTER PE WITH DESCENDER",
	"CYRILLIC SMALL LETTER PE WITH MIDDLE HOOK",
	"CYRILLIC SMALL LETTER PSI",
	"CYRILLIC SMALL LETTER QA",
	"CYRILLIC SMALL LETTER REVERSED DZE",
	"CYRILLIC SMALL LETTER REVERSED TSE",
	"CYRILLIC SMALL LETTER REVERSED YU",
	"CYRILLIC SMALL LETTER REVERSED ZE",
	"CYRILLIC SMALL LETTER RHA",
	"CYRILLIC SMALL LETTER ROUND OMEGA",
	"CYRILLIC SMALL LETTER SCHWA",
	"CYRILLIC SMALL LETTER SCHWA WITH DIAERESIS",
	"CYRILLIC SMALL LETTER SEMISOFT SIGN",
	"CYRILLIC SMALL LETTER SHA",
	"CYRILLIC SMALL LETTER SHCHA",
	"CYRILLIC SMALL LETTER SHHA",
	"CYRILLIC SMALL LETTER SHHA WITH DESCENDER",
	"CYRILLIC SMALL LETTER SHORT I",
	"CYRILLIC SMALL LETTER SHORT I WITH TAIL",
	"CYRILLIC SMALL LETTER SHORT U",
	"CYRILLIC SMALL LETTER SHWE",
	"CYRILLIC SMALL LETTER SOFT DE",
	"CYRILLIC SMALL LETTER SOFT EL",
	"CYRILLIC SMALL LETTER SOFT EM",
	"CYRILLIC SMALL LETTER SOFT SIGN",
	"CYRILLIC SMALL LETTER STRAIGHT U",
	"CYRILLIC SMALL LETTER STRAIGHT U WITH STROKE",
	"CYRILLIC SMALL LETTER TCHE",
	"CYRILLIC SMALL LETTER TE",
	"CYRILLIC SMALL LETTER TE WITH DESCENDER",
	"CYRILLIC SMALL LETTER TE WITH MIDDLE HOOK",
	"CYRILLIC SMALL LETTER TSE",
	"CYRILLIC SMALL LETTER TSHE",
	"CYRILLIC SMALL LETTER TSSE",
	"CYRILLIC SMALL LETTER TSWE",
	"CYRILLIC SMALL LETTER TWE",
	"CYRILLIC SMALL LETTER U",
	"CYRILLIC SMALL LETTER U WITH DIAERESIS",
	"CYRILLIC SMALL LETTER U WITH DOUBLE ACUTE",
	"CYRILLIC SMALL LETTER U WITH MACRON",
	"CYRILLIC SMALL LETTER UK",
	"CYRILLIC SMALL LETTER UKRAINIAN IE",
	"CYRILLIC SMALL LETTER VE",
	"CYRILLIC SMALL LETTER WE",
	"CYRILLIC SMALL LETTER YA",
	"CYRILLIC SMALL LETTER YAE",
	"CYRILLIC SMALL LETTER YAT",
	"CYRILLIC SMALL LETTER YERU",
	"CYRILLIC SMALL LETTER YERU WITH BACK YER",
	"CYRILLIC SMALL LETTER YERU WITH DIAERESIS",
	"CYRILLIC SMALL LETTER YI",
	"CYRILLIC SMALL LETTER YN",
	"CYRILLIC SMALL LETTER YU",
	"CYRILLIC SMALL LETTER ZE",
	"CYRILLIC SMALL LETTER ZE WITH DESCENDER",
	"CYRILLIC SMALL LETTER ZE WITH DIAERESIS",
	"CYRILLIC SMALL LETTER ZEMLYA",
	"CYRILLIC SMALL LETTER ZHE",
	"CYRILLIC SMALL LETTER ZHE WITH BREVE",
	"CYRILLIC SMALL LETTER ZHE WITH DESCENDER",
	"CYRILLIC SMALL LETTER ZHE WITH DIAERESIS",
	"CYRILLIC SMALL LETTER ZHWE",
	"CYRILLIC SMALL LIGATURE A IE",
	"CYRILLIC SMALL LIGATURE EN GHE",
	"CYRILLIC SMALL LIGATURE TE TSE",
	"CYRILLIC THOUSANDS SIGN",
	"DAGGER",
	"DAGGER WITH LEFT GUARD",
	"DAGGER WITH RIGHT GUARD",
	"DALET SYMBOL",
	"DANCER",
	"DANGO",
	"DARK SHADE",
	"DASH SYMBOL",
	"DASHED LOW LINE",
	"DASHED OVERLINE",
	"DASHED TRIANGLE-HEADED RIGHTWARDS ARROW",
	"DECIDUOUS TREE",
	"DECIMAL EXPONENT SYMBOL",
	"DECIMAL SEPARATOR KEY SYMBOL",
	"DEGREE CELSIUS",
	"DEGREE FAHRENHEIT",
	"DEGREE SIGN",
	"DELIVERY TRUCK",
	"DELTA EQUAL TO",
	"DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL",
	"DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH CIRCLE",
	"DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH TRIANGLE",
	"DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH WAVE",
	"DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL",
	"DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH CIRCLE",
	"DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH TRIANGLE",
	"DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH WAVE",
	"DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM LEFT",
	"DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM RIGHT",
	"DENTISTRY SYMBOL LIGHT VERTICAL AND TOP LEFT",
	"DENTISTRY SYMBOL LIGHT VERTICAL AND TOP RIGHT",
	"DENTISTRY SYMBOL LIGHT VERTICAL AND WAVE",
	"DENTISTRY SYMBOL LIGHT VERTICAL WITH CIRCLE",
	"DENTISTRY SYMBOL LIGHT VERTICAL WITH TRIANGLE",
	"DEPARTMENT STORE",
	"DESCENDING NODE",
	"DESERET CAPITAL LETTER AY",
	"DESERET CAPITAL LETTER BEE",
	"DESERET CAPITAL LETTER CHEE",
	"DESERET CAPITAL LETTER DEE",
	"DESERET CAPITAL LETTER EF",
	"DESERET CAPITAL LETTER EL",
	"DESERET CAPITAL LETTER EM",
	"DESERET CAPITAL LETTER EN",
	"DESERET CAPITAL LETTER ENG",
	"DESERET CAPITAL LETTER ER",
	"DESERET CAPITAL LETTER ES",
	"DESERET CAPITAL LETTER ESH",
	"DESERET CAPITAL LETTER ETH",
	"DESERET CAPITAL LETTER EW",
	"DESERET CAPITAL LETTER GAY",
	"DESERET CAPITAL LETTER H",
	"DESERET CAPITAL LETTER JEE",
	"DESERET CAPITAL LETTER KAY",
	"DESERET CAPITAL LETTER LONG A",
	"DESERET CAPITAL LETTER LONG AH",
	"DESERET CAPITAL LETTER LONG E",
	"DESERET CAPITAL LETTER LONG I",
	"DESERET CAPITAL LETTER LONG O",
	"DESERET CAPITAL LETTER LONG OO",
	"DESERET CAPITAL LETTER OI",
	"DESERET CAPITAL LETTER OW",
	"DESERET CAPITAL LETTER PEE",
	"DESERET CAPITAL LETTER SHORT A",
	"DESERET CAPITAL LETTER SHORT AH",
	"DESERET CAPITAL LETTER SHORT E",
	"DESERET CAPITAL LETTER SHORT I",
	"DESERET CAPITAL LETTER SHORT O",
	"DESERET CAPITAL LETTER SHORT OO",
	"DESERET CAPITAL LETTER TEE",
	"DESERET CAPITAL LETTER THEE",
	"DESERET CAPITAL LETTER VEE",
	"DESERET CAPITAL LETTER WU",
	"DESERET CAPITAL LETTER YEE",
	"DESERET CAPITAL LETTER ZEE",
	"DESERET CAPITAL LETTER ZHEE",
	"DESERET SMALL LETTER AY",
	"DESERET SMALL LETTER BEE",
	"DESERET SMALL LETTER CHEE",
	"DESERET SMALL LETTER DEE",
	"DESERET SMALL LETTER EF",
	"DESERET SMALL LETTER EL",
	"DESERET SMALL LETTER EM",
	"DESERET SMALL LETTER EN",
	"DESERET SMALL LETTER ENG",
	"DESERET SMALL LETTER ER",
	"DESERET SMALL LETTER ES",
	"DESERET SMALL LETTER ESH",
	"DESERET SMALL LETTER ETH",
	"DESERET SMALL LETTER EW",
	"DESERET SMALL LETTER GAY",
	"DESERET SMALL LETTER H",
	"DESERET SMALL LETTER JEE",
	"DESERET SMALL LETTER KAY",
	"DESERET SMALL LETTER LONG A",
	"DESERET SMALL LETTER LONG AH",
	"DESERET SMALL LETTER LONG E",
	"DESERET SMALL LETTER LONG I",
	"DESERET SMALL LETTER LONG O",
	"DESERET SMALL LETTER LONG OO",
	"DESERET SMALL LETTER OI",
	"DESERET SMALL LETTER OW",
	"DESERET SMALL LETTER PEE",
	"DESERET SMALL LETTER SHORT A",
	"DESERET SMALL LETTER SHORT AH",
	"DESERET SMALL LETTER SHORT E",
	"DESERET SMALL LETTER SHORT I",
	"DESERET SMALL LETTER SHORT O",
	"DESERET SMALL LETTER SHORT OO",
	"DESERET SMALL LETTER TEE",
	"DESERET SMALL LETTER THEE",
	"DESERET SMALL LETTER VEE",
	"DESERET SMALL LETTER WU",
	"DESERET SMALL LETTER YEE",
	"DESERET SMALL LETTER ZEE",
	"DESERET SMALL LETTER ZHEE",
	"DEVANAGARI ABBREVIATION SIGN",
	"DEVANAGARI ACUTE ACCENT",
	"DEVANAGARI CARET",
	"DEVANAGARI DANDA",
	"DEVANAGARI DIGIT EIGHT",
	"DEVANAGARI DIGIT FIVE",
	"DEVANAGARI DIGIT FOUR",
	"DEVANAGARI DIGIT NINE",
	"DEVANAGARI DIGIT ONE",
	"DEVANAGARI DIGIT SEVEN",
	"DEVANAGARI DIGIT SIX",
	"DEVANAGARI DIGIT THREE",
	"DEVANAGARI DIGIT TWO",
	"DEVANAGARI DIGIT ZERO",
	"DEVANAGARI DOUBLE DANDA",
	"DEVANAGARI GAP FILLER",
	"DEVANAGARI GRAVE ACCENT",
	"DEVANAGARI HEADSTROKE",
	"DEVANAGARI LETTER A",
	"DEVANAGARI LETTER AA",
	"DEVANAGARI LETTER AI",
	"DEVANAGARI LETTER AU",
	"DEVANAGARI LETTER AW",
	"DEVANAGARI LETTER BA",
	"DEVANAGARI LETTER BBA",
	"DEVANAGARI LETTER BHA",
	"DEVANAGARI LETTER CA",
	"DEVANAGARI LETTER CANDRA A",
	"DEVANAGARI LETTER CANDRA E",
	"DEVANAGARI LETTER CANDRA O",
	"DEVANAGARI LETTER CHA",
	"DEVANAGARI LETTER DA",
	"DEVANAGARI LETTER DDA",
	"DEVANAGARI LETTER DDDA",
	"DEVANAGARI LETTER DDDHA",
	"DEVANAGARI LETTER DDHA",
	"DEVANAGARI LETTER DHA",
	"DEVANAGARI LETTER E",
	"DEVANAGARI LETTER FA",
	"DEVANAGARI LETTER GA",
	"DEVANAGARI LETTER GGA",
	"DEVANAGARI LETTER GHA",
	"DEVANAGARI LETTER GHHA",
	"DEVANAGARI LETTER GLOTTAL STOP",
	"DEVANAGARI LETTER HA",
	"DEVANAGARI LETTER HEAVY YA",
	"DEVANAGARI LETTER I",
	"DEVANAGARI LETTER II",
	"DEVANAGARI LETTER JA",
	"DEVANAGARI LETTER JHA",
	"DEVANAGARI LETTER JJA",
	"DEVANAGARI LETTER KA",
	"DEVANAGARI LETTER KHA",
	"DEVANAGARI LETTER KHHA",
	"DEVANAGARI LETTER LA",
	"DEVANAGARI LETTER LLA",
	"DEVANAGARI LETTER LLLA",
	"DEVANAGARI LETTER MA",
	"DEVANAGARI LETTER NA",
	"DEVANAGARI LETTER NGA",
	"DEVANAGARI LETTER NNA",
	"DEVANAGARI LETTER NNNA",
	"DEVANAGARI LETTER NYA",
	"DEVANAGARI LETTER O",
	"DEVANAGARI LETTER OE",
	"DEVANAGARI LETTER OOE",
	"DEVANAGARI LETTER PA",
	"DEVANAGARI LETTER PHA",
	"DEVANAGARI LETTER QA",
	"DEVANAGARI LETTER RA",
	"DEVANAGARI LETTER RHA",
	"DEVANAGARI LETTER RRA",
	"DEVANAGARI LETTER SA",
	"DEVANAGARI LETTER SHA",
	"DEVANAGARI LETTER SHORT A",
	"DEVANAGARI LETTER SHORT E",
	"DEVANAGARI LETTER SHORT O",
	"DEVANAGARI LETTER SSA",
	"DEVANAGARI LETTER TA",
	"DEVANAGARI LETTER THA",
	"DEVANAGARI LETTER TTA",
	"DEVANAGARI LETTER TTHA",
	"DEVANAGARI LETTER U",
	"DEVANAGARI LETTER UE",
	"DEVANAGARI LETTER UU",
	"DEVANAGARI LETTER UUE",
	"DEVANAGARI LETTER VA",
	"DEVANAGARI LETTER VOCALIC L",
	"DEVANAGARI LETTER VOCALIC LL",
	"DEVANAGARI LETTER VOCALIC R",
	"DEVANAGARI LETTER VOCALIC RR",
	"DEVANAGARI LETTER YA",
	"DEVANAGARI LETTER YYA",
	"DEVANAGARI LETTER ZA",
	"DEVANAGARI LETTER ZHA",
	"DEVANAGARI OM",
	"DEVANAGARI SIGN ANUSVARA",
	"DEVANAGARI SIGN AVAGRAHA",
	"DEVANAGARI SIGN CANDRABINDU",
	"DEVANAGARI SIGN CANDRABINDU AVAGRAHA",
	"DEVANAGARI SIGN CANDRABINDU THREE",
	"DEVANAGARI SIGN CANDRABINDU TWO",
	"DEVANAGARI SIGN CANDRABINDU VIRAMA",
	"DEVANAGARI SIGN DOUBLE CANDRABINDU VIRAMA",
	"DEVANAGARI SIGN HIGH SPACING DOT",
	"DEVANAGARI SIGN INVERTED CANDRABINDU",
	"DEVANAGARI SIGN NUKTA",
	"DEVANAGARI SIGN PUSHPIKA",
	"DEVANAGARI SIGN SPACING CANDRABINDU",
	"DEVANAGARI SIGN VIRAMA",
	"DEVANAGARI SIGN VISARGA",
	"DEVANAGARI STRESS SIGN ANUDATTA",
	"DEVANAGARI STRESS SIGN UDATTA",
	"DEVANAGARI VOWEL SIGN AA",
	"DEVANAGARI VOWEL SIGN AI",
	"DEVANAGARI VOWEL SIGN AU",
	"DEVANAGARI VOWEL SIGN AW",
	"DEVANAGARI VOWEL SIGN CANDRA E",
	"DEVANAGARI VOWEL SIGN CANDRA LONG E",
	"DEVANAGARI VOWEL SIGN CANDRA O",
	"DEVANAGARI VOWEL SIGN E",
	"DEVANAGARI VOWEL SIGN I",
	"DEVANAGARI VOWEL SIGN II",
	"DEVANAGARI VOWEL SIGN O",
	"DEVANAGARI VOWEL SIGN OE",
	"DEVANAGARI VOWEL SIGN OOE",
	"DEVANAGARI VOWEL SIGN PRISHTHAMATRA E",
	"DEVANAGARI VOWEL SIGN SHORT E",
	"DEVANAGARI VOWEL SIGN SHORT O",
	"DEVANAGARI VOWEL SIGN U",
	"DEVANAGARI VOWEL SIGN UE",
	"DEVANAGARI VOWEL SIGN UU",
	"DEVANAGARI VOWEL SIGN UUE",
	"DEVANAGARI VOWEL SIGN VOCALIC L",
	"DEVANAGARI VOWEL SIGN VOCALIC LL",
	"DEVANAGARI VOWEL SIGN VOCALIC R",
	"DEVANAGARI VOWEL SIGN VOCALIC RR",
	"DIAERESIS",
	"DIAMETER SIGN",
	"DIAMOND OPERATOR",
	"DIAMOND SHAPE WITH A DOT INSIDE",
	"DIAMOND WITH BOTTOM HALF BLACK",
	"DIAMOND WITH LEFT HALF BLACK",
	"DIAMOND WITH RIGHT HALF BLACK",
	"DIAMOND WITH TOP HALF BLACK",
	"DIFFERENCE BETWEEN",
	"DIGIT EIGHT",
	"DIGIT EIGHT COMMA",
	"DIGIT EIGHT FULL STOP",
	"DIGIT FIVE",
	"DIGIT FIVE COMMA",
	"DIGIT FIVE FULL STOP",
	"DIGIT FOUR",
	"DIGIT FOUR COMMA",
	"DIGIT FOUR FULL STOP",
	"DIGIT NINE",
	"DIGIT NINE COMMA",
	"DIGIT NINE FULL STOP",
	"DIGIT ONE",
	"DIGIT ONE COMMA",
	"DIGIT ONE FULL STOP",
	"DIGIT SEVEN",
	"DIGIT SEVEN COMMA",
	"DIGIT SEVEN FULL STOP",
	"DIGIT SIX",
	"DIGIT SIX COMMA",
	"DIGIT SIX FULL STOP",
	"DIGIT THREE",
	"DIGIT THREE COMMA",
	"DIGIT THREE FULL STOP",
	"DIGIT TWO",
	"DIGIT TWO COMMA",
	"DIGIT TWO FULL STOP",
	"DIGIT ZERO",
	"DIGIT ZERO COMMA",
	"DIGIT ZERO FULL STOP",
	"DIGRAM FOR EARTH",
	"DIGRAM FOR EARTHLY HEAVEN",
	"DIGRAM FOR EARTHLY HUMAN",
	"DIGRAM FOR GREATER YANG",
	"DIGRAM FOR GREATER YIN",
	"DIGRAM FOR HEAVENLY EARTH",
	"DIGRAM FOR HUMAN EARTH",
	"DIGRAM FOR LESSER YANG",
	"DIGRAM FOR LESSER YIN",
	"DIMENSION ORIGIN",
	"DINGBAT CIRCLED SANS-SERIF DIGIT EIGHT",
	"DINGBAT CIRCLED SANS-SERIF DIGIT FIVE",
	"DINGBAT CIRCLED SANS-SERIF DIGIT FOUR",
	"DINGBAT CIRCLED SANS-SERIF DIGIT NINE",
	"DINGBAT CIRCLED SANS-SERIF DIGIT ONE",
	"DINGBAT CIRCLED SANS-SERIF DIGIT SEVEN",
	"DINGBAT CIRCLED SANS-SERIF DIGIT SIX",
	"DINGBAT CIRCLED SANS-SERIF DIGIT THREE",
	"DINGBAT CIRCLED SANS-SERIF DIGIT TWO",
	"DINGBAT CIRCLED SANS-SERIF NUMBER TEN",
	"DINGBAT NEGATIVE CIRCLED DIGIT EIGHT",
	"DINGBAT NEGATIVE CIRCLED DIGIT FIVE",
	"DINGBAT NEGATIVE CIRCLED DIGIT FOUR",
	"DINGBAT NEGATIVE CIRCLED DIGIT NINE",
	"DINGBAT NEGATIVE CIRCLED DIGIT ONE",
	"DINGBAT NEGATIVE CIRCLED DIGIT SEVEN",
	"DINGBAT NEGATIVE CIRCLED DIGIT SIX",
	"DINGBAT NEGATIVE CIRCLED DIGIT THREE",
	"DINGBAT NEGATIVE CIRCLED DIGIT TWO",
	"DINGBAT NEGATIVE CIRCLED NUMBER TEN",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT EIGHT",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FIVE",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FOUR",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT NINE",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT ONE",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SEVEN",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SIX",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT THREE",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT TWO",
	"DINGBAT NEGATIVE CIRCLED SANS-SERIF NUMBER TEN",
	"DIRECT CURRENT SYMBOL FORM TWO",
	"DIRECT HIT",
	"DISABLED CAR",
	"DISAPPOINTED BUT RELIEVED FACE",
	"DISAPPOINTED FACE",
	"DISCONTINUOUS UNDERLINE SYMBOL",
	"DITTO MARK",
	"DIVIDES",
	"DIVISION SIGN",
	"DIVISION SLASH",
	"DIVISION TIMES",
	"DIVORCE SYMBOL",
	"DIZZY FACE",
	"DIZZY SYMBOL",
	"DO NOT LITTER SYMBOL",
	"DOES NOT CONTAIN AS MEMBER",
	"DOES NOT CONTAIN AS NORMAL SUBGROUP",
	"DOES NOT CONTAIN AS NORMAL SUBGROUP OR EQUAL",
	"DOES NOT DIVIDE",
	"DOES NOT DIVIDE WITH REVERSED NEGATION SLASH",
	"DOES NOT FORCE",
	"DOES NOT PRECEDE",
	"DOES NOT PRECEDE OR EQUAL",
	"DOES NOT PROVE",
	"DOES NOT SUCCEED",
	"DOES NOT SUCCEED OR EQUAL",
	"DOG",
	"DOG FACE",
	"DOLLAR SIGN",
	"DOLPHIN",
	"DOMINO TILE HORIZONTAL BACK",
	"DOMINO TILE VERTICAL BACK",
	"DONG SIGN",
	"DOOR",
	"DOT ABOVE",
	"DOT MINUS",
	"DOT OPERATOR",
	"DOT PLUS",
	"DOTTED CIRCLE",
	"DOTTED CROSS",
	"DOTTED FENCE",
	"DOTTED OBELOS",
	"DOTTED RIGHT-POINTING ANGLE",
	"DOTTED SQUARE",
	"DOTTED TRANSPOSITION MARKER",
	"DOUBLE ACUTE ACCENT",
	"DOUBLE CIRCLED DIGIT EIGHT",
	"DOUBLE CIRCLED DIGIT FIVE",
	"DOUBLE CIRCLED DIGIT FOUR",
	"DOUBLE CIRCLED DIGIT NINE",
	"DOUBLE CIRCLED DIGIT ONE",
	"DOUBLE CIRCLED DIGIT SEVEN",
	"DOUBLE CIRCLED DIGIT SIX",
	"DOUBLE CIRCLED DIGIT THREE",
	"DOUBLE CIRCLED DIGIT TWO",
	"DOUBLE CIRCLED NUMBER TEN",
	"DOUBLE COLON EQUAL",
	"DOUBLE CURLY LOOP",
	"DOUBLE DAGGER",
	"DOUBLE DOWN TACK",
	"DOUBLE EXCLAMATION MARK",
	"DOUBLE HIGH-REVERSED-9 QUOTATION MARK",
	"DOUBLE INTEGRAL",
	"DOUBLE INTERSECTION",
	"DOUBLE LEFT ARC GREATER-THAN BRACKET",
	"DOUBLE LOGICAL AND",
	"DOUBLE LOGICAL OR",
	"DOUBLE LOW LINE",
	"DOUBLE LOW-9 QUOTATION MARK",
	"DOUBLE NESTED GREATER-THAN",
	"DOUBLE NESTED LESS-THAN",
	"DOUBLE NESTED LESS-THAN WITH UNDERBAR",
	"DOUBLE OBLIQUE HYPHEN",
	"DOUBLE PLUS",
	"DOUBLE PRECEDES",
	"DOUBLE PRIME",
	"DOUBLE PRIME QUOTATION MARK",
	"DOUBLE QUESTION MARK",
	"DOUBLE RIGHT ARC LESS-THAN BRACKET",
	"DOUBLE SOLIDUS OPERATOR",
	"DOUBLE SQUARE INTERSECTION",
	"DOUBLE SQUARE UNION",
	"DOUBLE STROKE NOT SIGN",
	"DOUBLE SUBSET",
	"DOUBLE SUCCEEDS",
	"DOUBLE SUPERSET",
	"DOUBLE UNION",
	"DOUBLE UP TACK",
	"DOUBLE VERTICAL BAR DOUBLE LEFT TURNSTILE",
	"DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE",
	"DOUBLE VERTICAL BAR LEFT TURNSTILE",
	"DOUBLE VERTICAL LINE",
	"DOUBLE WAVY OVERLINE",
	"DOUBLE-ENDED MULTIMAP",
	"DOUBLE-LINE EQUAL TO OR GREATER-THAN",
	"DOUBLE-LINE EQUAL TO OR LESS-THAN",
	"DOUBLE-LINE SLANTED EQUAL TO OR GREATER-THAN",
	"DOUBLE-LINE SLANTED EQUAL TO OR LESS-THAN",
	"DOUBLE-LINE SLANTED GREATER-THAN OR EQUAL TO",
	"DOUBLE-LINE SLANTED LESS-THAN OR EQUAL TO",
	"DOUBLE-STRUCK CAPITAL C",
	"DOUBLE-STRUCK CAPITAL GAMMA",
	"DOUBLE-STRUCK CAPITAL H",
	"DOUBLE-STRUCK CAPITAL N",
	"DOUBLE-STRUCK CAPITAL P",
	"DOUBLE-STRUCK CAPITAL PI",
	"DOUBLE-STRUCK CAPITAL Q",
	"DOUBLE-STRUCK CAPITAL R",
	"DOUBLE-STRUCK CAPITAL Z",
	"DOUBLE-STRUCK ITALIC CAPITAL D",
	"DOUBLE-STRUCK ITALIC SMALL D",
	"DOUBLE-STRUCK ITALIC SMALL E",
	"DOUBLE-STRUCK ITALIC SMALL I",
	"DOUBLE-STRUCK ITALIC SMALL J",
	"DOUBLE-STRUCK N-ARY SUMMATION",
	"DOUBLE-STRUCK SMALL GAMMA",
	"DOUBLE-STRUCK SMALL PI",
	"DOUBLED FEMALE SIGN",
	"DOUBLED MALE SIGN",
	"DOUGHNUT",
	"DOWN ARROWHEAD",
	"DOWN FISH TAIL",
	"DOWN RIGHT DIAGONAL ELLIPSIS",
	"DOWN TACK",
	"DOWN TACK WITH CIRCLE BELOW",
	"DOWN-POINTING RED TRIANGLE",
	"DOWN-POINTING SMALL RED TRIANGLE",
	"DOWN-POINTING TRIANGLE WITH LEFT HALF BLACK",
	"DOWN-POINTING TRIANGLE WITH RIGHT HALF BLACK",
	"DOWNWARDS ANCORA",
	"DOWNWARDS ARROW",
	"DOWNWARDS ARROW FROM BAR",
	"DOWNWARDS ARROW LEFTWARDS OF UPWARDS ARROW",
	"DOWNWARDS ARROW TO BAR",
	"DOWNWARDS ARROW WITH CORNER LEFTWARDS",
	"DOWNWARDS ARROW WITH DOUBLE STROKE",
	"DOWNWARDS ARROW WITH HORIZONTAL STROKE",
	"DOWNWARDS ARROW WITH TIP LEFTWARDS",
	"DOWNWARDS ARROW WITH TIP RIGHTWARDS",
	"DOWNWARDS BLACK ARROW",
	"DOWNWARDS DASHED ARROW",
	"DOWNWARDS DOUBLE ARROW",
	"DOWNWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT",
	"DOWNWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT",
	"DOWNWARDS HARPOON WITH BARB LEFT FROM BAR",
	"DOWNWARDS HARPOON WITH BARB LEFT TO BAR",
	"DOWNWARDS HARPOON WITH BARB LEFTWARDS",
	"DOWNWARDS HARPOON WITH BARB RIGHT FROM BAR",
	"DOWNWARDS HARPOON WITH BARB RIGHT TO BAR",
	"DOWNWARDS HARPOON WITH BARB RIGHTWARDS",
	"DOWNWARDS PAIRED ARROWS",
	"DOWNWARDS QUADRUPLE ARROW",
	"DOWNWARDS TRIPLE ARROW",
	"DOWNWARDS TWO HEADED ARROW",
	"DOWNWARDS WHITE ARROW",
	"DOWNWARDS ZIGZAG ARROW",
	"DRACHMA SIGN",
	"DRAFTING POINT RIGHTWARDS ARROW",
	"DRAGON",
	"DRAGON FACE",
	"DRESS",
	"DRIVE SLOW SIGN",
	"DROMEDARY CAMEL",
	"DROPLET",
	"DVD",
	"E-MAIL SYMBOL",
	"EAR",
	"EAR OF MAIZE",
	"EAR OF RICE",
	"EARTH",
	"EARTH GLOBE AMERICAS",
	"EARTH GLOBE ASIA-AUSTRALIA",
	"EARTH GLOBE EUROPE-AFRICA",
	"EARTH GROUND",
	"EAST SYRIAC CROSS",
	"EDITORIAL CORONIS",
	"EGYPTIAN HIEROGLYPH A005A",
	"EGYPTIAN HIEROGLYPH A006A",
	"EGYPTIAN HIEROGLYPH A006B",
	"EGYPTIAN HIEROGLYPH A014A",
	"EGYPTIAN HIEROGLYPH A017A",
	"EGYPTIAN HIEROGLYPH A032A",
	"EGYPTIAN HIEROGLYPH A040A",
	"EGYPTIAN HIEROGLYPH A042A",
	"EGYPTIAN HIEROGLYPH A043A",
	"EGYPTIAN HIEROGLYPH A045A",
	"EGYPTIAN HIEROGLYPH AA007A",
	"EGYPTIAN HIEROGLYPH AA007B",
	"EGYPTIAN HIEROGLYPH B005A",
	"EGYPTIAN HIEROGLYPH C002A",
	"EGYPTIAN HIEROGLYPH C002B",
	"EGYPTIAN HIEROGLYPH C002C",
	"EGYPTIAN HIEROGLYPH C010A",
	"EGYPTIAN HIEROGLYPH D008A",
	"EGYPTIAN HIEROGLYPH D027A",
	"EGYPTIAN HIEROGLYPH D031A",
	"EGYPTIAN HIEROGLYPH D034A",
	"EGYPTIAN HIEROGLYPH D046A",
	"EGYPTIAN HIEROGLYPH D048A",
	"EGYPTIAN HIEROGLYPH D050A",
	"EGYPTIAN HIEROGLYPH D050B",
	"EGYPTIAN HIEROGLYPH D050C",
	"EGYPTIAN HIEROGLYPH D050D",
	"EGYPTIAN HIEROGLYPH D050E",
	"EGYPTIAN HIEROGLYPH D050F",
	"EGYPTIAN HIEROGLYPH D050G",
	"EGYPTIAN HIEROGLYPH D050H",
	"EGYPTIAN HIEROGLYPH D050I",
	"EGYPTIAN HIEROGLYPH D052A",
	"EGYPTIAN HIEROGLYPH D054A",
	"EGYPTIAN HIEROGLYPH D067A",
	"EGYPTIAN HIEROGLYPH D067B",
	"EGYPTIAN HIEROGLYPH D067C",
	"EGYPTIAN HIEROGLYPH D067D",
	"EGYPTIAN HIEROGLYPH D067E",
	"EGYPTIAN HIEROGLYPH D067F",
	"EGYPTIAN HIEROGLYPH D067G",
	"EGYPTIAN HIEROGLYPH D067H",
	"EGYPTIAN HIEROGLYPH E008A",
	"EGYPTIAN HIEROGLYPH E009A",
	"EGYPTIAN HIEROGLYPH E016A",
	"EGYPTIAN HIEROGLYPH E017A",
	"EGYPTIAN HIEROGLYPH E020A",
	"EGYPTIAN HIEROGLYPH E028A",
	"EGYPTIAN HIEROGLYPH E034A",
	"EGYPTIAN HIEROGLYPH F001A",
	"EGYPTIAN HIEROGLYPH F013A",
	"EGYPTIAN HIEROGLYPH F021A",
	"EGYPTIAN HIEROGLYPH F031A",
	"EGYPTIAN HIEROGLYPH F037A",
	"EGYPTIAN HIEROGLYPH F038A",
	"EGYPTIAN HIEROGLYPH F045A",
	"EGYPTIAN HIEROGLYPH F046A",
	"EGYPTIAN HIEROGLYPH F047A",
	"EGYPTIAN HIEROGLYPH F051A",
	"EGYPTIAN HIEROGLYPH F051B",
	"EGYPTIAN HIEROGLYPH F051C",
	"EGYPTIAN HIEROGLYPH G006A",
	"EGYPTIAN HIEROGLYPH G007A",
	"EGYPTIAN HIEROGLYPH G007B",
	"EGYPTIAN HIEROGLYPH G011A",
	"EGYPTIAN HIEROGLYPH G020A",
	"EGYPTIAN HIEROGLYPH G026A",
	"EGYPTIAN HIEROGLYPH G036A",
	"EGYPTIAN HIEROGLYPH G037A",
	"EGYPTIAN HIEROGLYPH G043A",
	"EGYPTIAN HIEROGLYPH G045A",
	"EGYPTIAN HIEROGLYPH H006A",
	"EGYPTIAN HIEROGLYPH I005A",
	"EGYPTIAN HIEROGLYPH I009A",
	"EGYPTIAN HIEROGLYPH I010A",
	"EGYPTIAN HIEROGLYPH I011A",
	"EGYPTIAN HIEROGLYPH L002A",
	"EGYPTIAN HIEROGLYPH L006A",
	"EGYPTIAN HIEROGLYPH M001A",
	"EGYPTIAN HIEROGLYPH M001B",
	"EGYPTIAN HIEROGLYPH M003A",
	"EGYPTIAN HIEROGLYPH M010A",
	"EGYPTIAN HIEROGLYPH M012A",
	"EGYPTIAN HIEROGLYPH M012B",
	"EGYPTIAN HIEROGLYPH M012C",
	"EGYPTIAN HIEROGLYPH M012D",
	"EGYPTIAN HIEROGLYPH M012E",
	"EGYPTIAN HIEROGLYPH M012F",
	"EGYPTIAN HIEROGLYPH M012G",
	"EGYPTIAN HIEROGLYPH M012H",
	"EGYPTIAN HIEROGLYPH M015A",
	"EGYPTIAN HIEROGLYPH M016A",
	"EGYPTIAN HIEROGLYPH M017A",
	"EGYPTIAN HIEROGLYPH M022A",
	"EGYPTIAN HIEROGLYPH M024A",
	"EGYPTIAN HIEROGLYPH M028A",
	"EGYPTIAN HIEROGLYPH M031A",
	"EGYPTIAN HIEROGLYPH M033A",
	"EGYPTIAN HIEROGLYPH M033B",
	"EGYPTIAN HIEROGLYPH M040A",
	"EGYPTIAN HIEROGLYPH N018A",
	"EGYPTIAN HIEROGLYPH N018B",
	"EGYPTIAN HIEROGLYPH N025A",
	"EGYPTIAN HIEROGLYPH N033A",
	"EGYPTIAN HIEROGLYPH N034A",
	"EGYPTIAN HIEROGLYPH N035A",
	"EGYPTIAN HIEROGLYPH N037A",
	"EGYPTIAN HIEROGLYPH NL005A",
	"EGYPTIAN HIEROGLYPH NL017A",
	"EGYPTIAN HIEROGLYPH NU010A",
	"EGYPTIAN HIEROGLYPH NU011A",
	"EGYPTIAN HIEROGLYPH NU018A",
	"EGYPTIAN HIEROGLYPH NU022A",
	"EGYPTIAN HIEROGLYPH O001A",
	"EGYPTIAN HIEROGLYPH O005A",
	"EGYPTIAN HIEROGLYPH O006A",
	"EGYPTIAN HIEROGLYPH O006B",
	"EGYPTIAN HIEROGLYPH O006C",
	"EGYPTIAN HIEROGLYPH O006D",
	"EGYPTIAN HIEROGLYPH O006E",
	"EGYPTIAN HIEROGLYPH O006F",
	"EGYPTIAN HIEROGLYPH O010A",
	"EGYPTIAN HIEROGLYPH O010B",
	"EGYPTIAN HIEROGLYPH O010C",
	"EGYPTIAN HIEROGLYPH O019A",
	"EGYPTIAN HIEROGLYPH O020A",
	"EGYPTIAN HIEROGLYPH O024A",
	"EGYPTIAN HIEROGLYPH O025A",
	"EGYPTIAN HIEROGLYPH O029A",
	"EGYPTIAN HIEROGLYPH O030A",
	"EGYPTIAN HIEROGLYPH O033A",
	"EGYPTIAN HIEROGLYPH O036A",
	"EGYPTIAN HIEROGLYPH O036B",
	"EGYPTIAN HIEROGLYPH O036C",
	"EGYPTIAN HIEROGLYPH O036D",
	"EGYPTIAN HIEROGLYPH O050A",
	"EGYPTIAN HIEROGLYPH O050B",
	"EGYPTIAN HIEROGLYPH P001A",
	"EGYPTIAN HIEROGLYPH P003A",
	"EGYPTIAN HIEROGLYPH R002A",
	"EGYPTIAN HIEROGLYPH R003A",
	"EGYPTIAN HIEROGLYPH R003B",
	"EGYPTIAN HIEROGLYPH R010A",
	"EGYPTIAN HIEROGLYPH R016A",
	"EGYPTIAN HIEROGLYPH S002A",
	"EGYPTIAN HIEROGLYPH S006A",
	"EGYPTIAN HIEROGLYPH S014A",
	"EGYPTIAN HIEROGLYPH S014B",
	"EGYPTIAN HIEROGLYPH S017A",
	"EGYPTIAN HIEROGLYPH S026A",
	"EGYPTIAN HIEROGLYPH S026B",
	"EGYPTIAN HIEROGLYPH S035A",
	"EGYPTIAN HIEROGLYPH T003A",
	"EGYPTIAN HIEROGLYPH T007A",
	"EGYPTIAN HIEROGLYPH T008A",
	"EGYPTIAN HIEROGLYPH T009A",
	"EGYPTIAN HIEROGLYPH T011A",
	"EGYPTIAN HIEROGLYPH T016A",
	"EGYPTIAN HIEROGLYPH T032A",
	"EGYPTIAN HIEROGLYPH T033A",
	"EGYPTIAN HIEROGLYPH U006A",
	"EGYPTIAN HIEROGLYPH U006B",
	"EGYPTIAN HIEROGLYPH U023A",
	"EGYPTIAN HIEROGLYPH U029A",
	"EGYPTIAN HIEROGLYPH U032A",
	"EGYPTIAN HIEROGLYPH V001A",
	"EGYPTIAN HIEROGLYPH V001B",
	"EGYPTIAN HIEROGLYPH V001C",
	"EGYPTIAN HIEROGLYPH V001D",
	"EGYPTIAN HIEROGLYPH V001E",
	"EGYPTIAN HIEROGLYPH V001F",
	"EGYPTIAN HIEROGLYPH V001G",
	"EGYPTIAN HIEROGLYPH V001H",
	"EGYPTIAN HIEROGLYPH V001I",
	"EGYPTIAN HIEROGLYPH V002A",
	"EGYPTIAN HIEROGLYPH V007A",
	"EGYPTIAN HIEROGLYPH V007B",
	"EGYPTIAN HIEROGLYPH V011A",
	"EGYPTIAN HIEROGLYPH V011B",
	"EGYPTIAN HIEROGLYPH V011C",
	"EGYPTIAN HIEROGLYPH V012A",
	"EGYPTIAN HIEROGLYPH V012B",
	"EGYPTIAN HIEROGLYPH V020A",
	"EGYPTIAN HIEROGLYPH V020B",
	"EGYPTIAN HIEROGLYPH V020C",
	"EGYPTIAN HIEROGLYPH V020D",
	"EGYPTIAN HIEROGLYPH V020E",
	"EGYPTIAN HIEROGLYPH V020F",
	"EGYPTIAN HIEROGLYPH V020G",
	"EGYPTIAN HIEROGLYPH V020H",
	"EGYPTIAN HIEROGLYPH V020I",
	"EGYPTIAN HIEROGLYPH V020J",
	"EGYPTIAN HIEROGLYPH V020K",
	"EGYPTIAN HIEROGLYPH V020L",
	"EGYPTIAN HIEROGLYPH V023A",
	"EGYPTIAN HIEROGLYPH V028A",
	"EGYPTIAN HIEROGLYPH V029A",
	"EGYPTIAN HIEROGLYPH V030A",
	"EGYPTIAN HIEROGLYPH V031A",
	"EGYPTIAN HIEROGLYPH V033A",
	"EGYPTIAN HIEROGLYPH V037A",
	"EGYPTIAN HIEROGLYPH V040A",
	"EGYPTIAN HIEROGLYPH W003A",
	"EGYPTIAN HIEROGLYPH W009A",
	"EGYPTIAN HIEROGLYPH W010A",
	"EGYPTIAN HIEROGLYPH W014A",
	"EGYPTIAN HIEROGLYPH W017A",
	"EGYPTIAN HIEROGLYPH W018A",
	"EGYPTIAN HIEROGLYPH W024A",
	"EGYPTIAN HIEROGLYPH X004A",
	"EGYPTIAN HIEROGLYPH X004B",
	"EGYPTIAN HIEROGLYPH X006A",
	"EGYPTIAN HIEROGLYPH X008A",
	"EGYPTIAN HIEROGLYPH Y001A",
	"EGYPTIAN HIEROGLYPH Z002A",
	"EGYPTIAN HIEROGLYPH Z002B",
	"EGYPTIAN HIEROGLYPH Z002C",
	"EGYPTIAN HIEROGLYPH Z002D",
	"EGYPTIAN HIEROGLYPH Z003A",
	"EGYPTIAN HIEROGLYPH Z003B",
	"EGYPTIAN HIEROGLYPH Z004A",
	"EGYPTIAN HIEROGLYPH Z005A",
	"EGYPTIAN HIEROGLYPH Z015A",
	"EGYPTIAN HIEROGLYPH Z015B",
	"EGYPTIAN HIEROGLYPH Z015C",
	"EGYPTIAN HIEROGLYPH Z015D",
	"EGYPTIAN HIEROGLYPH Z015E",
	"EGYPTIAN HIEROGLYPH Z015F",
	"EGYPTIAN HIEROGLYPH Z015G",
	"EGYPTIAN HIEROGLYPH Z015H",
	"EGYPTIAN HIEROGLYPH Z015I",
	"EGYPTIAN HIEROGLYPH Z016A",
	"EGYPTIAN HIEROGLYPH Z016B",
	"EGYPTIAN HIEROGLYPH Z016C",
	"EGYPTIAN HIEROGLYPH Z016D",
	"EGYPTIAN HIEROGLYPH Z016E",
	"EGYPTIAN HIEROGLYPH Z016F",
	"EGYPTIAN HIEROGLYPH Z016G",
	"EGYPTIAN HIEROGLYPH Z016H",
	"EIGHT PETALLED OUTLINED BLACK FLORETTE",
	"EIGHT POINTED BLACK STAR",
	"EIGHT POINTED PINWHEEL STAR",
	"EIGHT POINTED RECTILINEAR BLACK STAR",
	"EIGHT SPOKED ASTERISK",
	"EIGHT TEARDROP-SPOKED PROPELLER ASTERISK",
	"EIGHTH NOTE",
	"EJECT SYMBOL",
	"ELECTRIC ARROW",
	"ELECTRIC LIGHT BULB",
	"ELECTRIC PLUG",
	"ELECTRIC TORCH",
	"ELECTRICAL INTERSECTION",
	"ELEMENT OF",
	"ELEMENT OF OPENING DOWNWARDS",
	"ELEMENT OF OPENING UPWARDS",
	"ELEMENT OF WITH DOT ABOVE",
	"ELEMENT OF WITH LONG HORIZONTAL STROKE",
	"ELEMENT OF WITH OVERBAR",
	"ELEMENT OF WITH TWO HORIZONTAL STROKES",
	"ELEMENT OF WITH UNDERBAR",
	"ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE",
	"ELEPHANT",
	"EM DASH",
	"EM QUAD",
	"EM SPACE",
	"EMPHASIS SYMBOL",
	"EMPTY SET",
	"EMPTY SET WITH LEFT ARROW ABOVE",
	"EMPTY SET WITH OVERBAR",
	"EMPTY SET WITH RIGHT ARROW ABOVE",
	"EMPTY SET WITH SMALL CIRCLE ABOVE",
	"EN DASH",
	"EN QUAD",
	"EN SPACE",
	"END OF PROOF",
	"END WITH LEFTWARDS ARROW ABOVE",
	"ENTER SYMBOL",
	"ENVELOPE",
	"ENVELOPE WITH DOWNWARDS ARROW ABOVE",
	"EQUAL AND PARALLEL TO",
	"EQUAL TO BY DEFINITION",
	"EQUAL TO OR GREATER-THAN",
	"EQUAL TO OR LESS-THAN",
	"EQUAL TO OR PRECEDES",
	"EQUAL TO OR SUCCEEDS",
	"EQUALS COLON",
	"EQUALS SIGN",
	"EQUALS SIGN ABOVE LEFTWARDS ARROW",
	"EQUALS SIGN ABOVE PLUS SIGN",
	"EQUALS SIGN ABOVE RIGHTWARDS ARROW",
	"EQUALS SIGN ABOVE TILDE OPERATOR",
	"EQUALS SIGN AND SLANTED PARALLEL",
	"EQUALS SIGN AND SLANTED PARALLEL WITH TILDE ABOVE",
	"EQUALS SIGN WITH BUMPY ABOVE",
	"EQUALS SIGN WITH DOT BELOW",
	"EQUALS SIGN WITH TWO DOTS ABOVE AND TWO DOTS BELOW",
	"EQUALS WITH ASTERISK",
	"EQUIANGULAR TO",
	"EQUIVALENT TO",
	"EQUIVALENT WITH FOUR DOTS ABOVE",
	"ERASE TO THE LEFT",
	"ERASE TO THE RIGHT",
	"ERROR-BARRED BLACK CIRCLE",
	"ERROR-BARRED BLACK DIAMOND",
	"ERROR-BARRED BLACK SQUARE",
	"ERROR-BARRED WHITE CIRCLE",
	"ERROR-BARRED WHITE DIAMOND",
	"ERROR-BARRED WHITE SQUARE",
	"ESTIMATED SYMBOL",
	"ESTIMATES",
	"ETHIOPIC COLON",
	"ETHIOPIC COMBINING GEMINATION AND VOWEL LENGTH MARK",
	"ETHIOPIC COMBINING GEMINATION MARK",
	"ETHIOPIC COMBINING VOWEL LENGTH MARK",
	"ETHIOPIC COMMA",
	"ETHIOPIC DIGIT EIGHT",
	"ETHIOPIC DIGIT FIVE",
	"ETHIOPIC DIGIT FOUR",
	"ETHIOPIC DIGIT NINE",
	"ETHIOPIC DIGIT ONE",
	"ETHIOPIC DIGIT SEVEN",
	"ETHIOPIC DIGIT SIX",
	"ETHIOPIC DIGIT THREE",
	"ETHIOPIC DIGIT TWO",
	"ETHIOPIC FULL STOP",
	"ETHIOPIC NUMBER EIGHTY",
	"ETHIOPIC NUMBER FIFTY",
	"ETHIOPIC NUMBER FORTY",
	"ETHIOPIC NUMBER HUNDRED",
	"ETHIOPIC NUMBER NINETY",
	"ETHIOPIC NUMBER SEVENTY",
	"ETHIOPIC NUMBER SIXTY",
	"ETHIOPIC NUMBER TEN",
	"ETHIOPIC NUMBER TEN THOUSAND",
	"ETHIOPIC NUMBER THIRTY",
	"ETHIOPIC NUMBER TWENTY",
	"ETHIOPIC PARAGRAPH SEPARATOR",
	"ETHIOPIC PREFACE COLON",
	"ETHIOPIC QUESTION MARK",
	"ETHIOPIC SECTION MARK",
	"ETHIOPIC SEMICOLON",
	"ETHIOPIC SYLLABLE BA",
	"ETHIOPIC SYLLABLE BAA",
	"ETHIOPIC SYLLABLE BBA",
	"ETHIOPIC SYLLABLE BBAA",
	"ETHIOPIC SYLLABLE BBE",
	"ETHIOPIC SYLLABLE BBEE",
	"ETHIOPIC SYLLABLE BBI",
	"ETHIOPIC SYLLABLE BBO",
	"ETHIOPIC SYLLABLE BBU",
	"ETHIOPIC SYLLABLE BE",
	"ETHIOPIC SYLLABLE BEE",
	"ETHIOPIC SYLLABLE BI",
	"ETHIOPIC SYLLABLE BO",
	"ETHIOPIC SYLLABLE BOA",
	"ETHIOPIC SYLLABLE BU",
	"ETHIOPIC SYLLABLE BWA",
	"ETHIOPIC SYLLABLE BWE",
	"ETHIOPIC SYLLABLE BWEE",
	"ETHIOPIC SYLLABLE BWI",
	"ETHIOPIC SYLLABLE CA",
	"ETHIOPIC SYLLABLE CAA",
	"ETHIOPIC SYLLABLE CCA",
	"ETHIOPIC SYLLABLE CCAA",
	"ETHIOPIC SYLLABLE CCE",
	"ETHIOPIC SYLLABLE CCEE",
	"ETHIOPIC SYLLABLE CCHA",
	"ETHIOPIC SYLLABLE CCHAA",
	"ETHIOPIC SYLLABLE CCHE",
	"ETHIOPIC SYLLABLE CCHEE",
	"ETHIOPIC SYLLABLE CCHHA",
	"ETHIOPIC SYLLABLE CCHHAA",
	"ETHIOPIC SYLLABLE CCHHE",
	"ETHIOPIC SYLLABLE CCHHEE",
	"ETHIOPIC SYLLABLE CCHHI",
	"ETHIOPIC SYLLABLE CCHHO",
	"ETHIOPIC SYLLABLE CCHHU",
	"ETHIOPIC SYLLABLE CCHI",
	"ETHIOPIC SYLLABLE CCHO",
	"ETHIOPIC SYLLABLE CCHU",
	"ETHIOPIC SYLLABLE CCI",
	"ETHIOPIC SYLLABLE CCO",
	"ETHIOPIC SYLLABLE CCU",
	"ETHIOPIC SYLLABLE CE",
	"ETHIOPIC SYLLABLE CEE",
	"ETHIOPIC SYLLABLE CHA",
	"ETHIOPIC SYLLABLE CHAA",
	"ETHIOPIC SYLLABLE CHE",
	"ETHIOPIC SYLLABLE CHEE",
	"ETHIOPIC SYLLABLE CHI",
	"ETHIOPIC SYLLABLE CHO",
	"ETHIOPIC SYLLABLE CHOA",
	"ETHIOPIC SYLLABLE CHU",
	"ETHIOPIC SYLLABLE CHWA",
	"ETHIOPIC SYLLABLE CI",
	"ETHIOPIC SYLLABLE CO",
	"ETHIOPIC SYLLABLE COA",
	"ETHIOPIC SYLLABLE CU",
	"ETHIOPIC SYLLABLE CWA",
	"ETHIOPIC SYLLABLE DA",
	"ETHIOPIC SYLLABLE DAA",
	"ETHIOPIC SYLLABLE DDA",
	"ETHIOPIC SYLLABLE DDAA",
	"ETHIOPIC SYLLABLE DDE",
	"ETHIOPIC SYLLABLE DDEE",
	"ETHIOPIC SYLLABLE DDHAA",
	"ETHIOPIC SYLLABLE DDHE",
	"ETHIOPIC SYLLABLE DDHEE",
	"ETHIOPIC SYLLABLE DDHI",
	"ETHIOPIC SYLLABLE DDHO",
	"ETHIOPIC SYLLABLE DDHU",
	"ETHIOPIC SYLLABLE DDI",
	"ETHIOPIC SYLLABLE DDO",
	"ETHIOPIC SYLLABLE DDOA",
	"ETHIOPIC SYLLABLE DDU",
	"ETHIOPIC SYLLABLE DDWA",
	"ETHIOPIC SYLLABLE DE",
	"ETHIOPIC SYLLABLE DEE",
	"ETHIOPIC SYLLABLE DI",
	"ETHIOPIC SYLLABLE DO",
	"ETHIOPIC SYLLABLE DOA",
	"ETHIOPIC SYLLABLE DU",
	"ETHIOPIC SYLLABLE DWA",
	"ETHIOPIC SYLLABLE DZAA",
	"ETHIOPIC SYLLABLE DZE",
	"ETHIOPIC SYLLABLE DZEE",
	"ETHIOPIC SYLLABLE DZI",
	"ETHIOPIC SYLLABLE DZO",
	"ETHIOPIC SYLLABLE DZU",
	"ETHIOPIC SYLLABLE FA",
	"ETHIOPIC SYLLABLE FAA",
	"ETHIOPIC SYLLABLE FE",
	"ETHIOPIC SYLLABLE FEE",
	"ETHIOPIC SYLLABLE FI",
	"ETHIOPIC SYLLABLE FO",
	"ETHIOPIC SYLLABLE FU",
	"ETHIOPIC SYLLABLE FWA",
	"ETHIOPIC SYLLABLE FWE",
	"ETHIOPIC SYLLABLE FWEE",
	"ETHIOPIC SYLLABLE FWI",
	"ETHIOPIC SYLLABLE FYA",
	"ETHIOPIC SYLLABLE GA",
	"ETHIOPIC SYLLABLE GAA",
	"ETHIOPIC SYLLABLE GE",
	"ETHIOPIC SYLLABLE GEE",
	"ETHIOPIC SYLLABLE GGA",
	"ETHIOPIC SYLLABLE GGAA",
	"ETHIOPIC SYLLABLE GGE",
	"ETHIOPIC SYLLABLE GGEE",
	"ETHIOPIC SYLLABLE GGI",
	"ETHIOPIC SYLLABLE GGO",
	"ETHIOPIC SYLLABLE GGU",
	"ETHIOPIC SYLLABLE GGWA",
	"ETHIOPIC SYLLABLE GGWAA",
	"ETHIOPIC SYLLABLE GGWE",
	"ETHIOPIC SYLLABLE GGWEE",
	"ETHIOPIC SYLLABLE GGWI",
	"ETHIOPIC SYLLABLE GI",
	"ETHIOPIC SYLLABLE GLOTTAL A",
	"ETHIOPIC SYLLABLE GLOTTAL AA",
	"ETHIOPIC SYLLABLE GLOTTAL E",
	"ETHIOPIC SYLLABLE GLOTTAL EE",
	"ETHIOPIC SYLLABLE GLOTTAL I",
	"ETHIOPIC SYLLABLE GLOTTAL O",
	"ETHIOPIC SYLLABLE GLOTTAL OA",
	"ETHIOPIC SYLLABLE GLOTTAL U",
	"ETHIOPIC SYLLABLE GLOTTAL WA",
	"ETHIOPIC SYLLABLE GO",
	"ETHIOPIC SYLLABLE GOA",
	"ETHIOPIC SYLLABLE GU",
	"ETHIOPIC SYLLABLE GWA",
	"ETHIOPIC SYLLABLE GWAA",
	"ETHIOPIC SYLLABLE GWE",
	"ETHIOPIC SYLLABLE GWEE",
	"ETHIOPIC SYLLABLE GWI",
	"ETHIOPIC SYLLABLE GYA",
	"ETHIOPIC SYLLABLE GYAA",
	"ETHIOPIC SYLLABLE GYE",
	"ETHIOPIC SYLLABLE GYEE",
	"ETHIOPIC SYLLABLE GYI",
	"ETHIOPIC SYLLABLE GYO",
	"ETHIOPIC SYLLABLE GYU",
	"ETHIOPIC SYLLABLE HA",
	"ETHIOPIC SYLLABLE HAA",
	"ETHIOPIC SYLLABLE HE",
	"ETHIOPIC SYLLABLE HEE",
	"ETHIOPIC SYLLABLE HHA",
	"ETHIOPIC SYLLABLE HHAA",
	"ETHIOPIC SYLLABLE HHE",
	"ETHIOPIC SYLLABLE HHEE",
	"ETHIOPIC SYLLABLE HHI",
	"ETHIOPIC SYLLABLE HHO",
	"ETHIOPIC SYLLABLE HHU",
	"ETHIOPIC SYLLABLE HHWA",
	"ETHIOPIC SYLLABLE HI",
	"ETHIOPIC SYLLABLE HO",
	"ETHIOPIC SYLLABLE HOA",
	"ETHIOPIC SYLLABLE HU",
	"ETHIOPIC SYLLABLE JA",
	"ETHIOPIC SYLLABLE JAA",
	"ETHIOPIC SYLLABLE JE",
	"ETHIOPIC SYLLABLE JEE",
	"ETHIOPIC SYLLABLE JI",
	"ETHIOPIC SYLLABLE JO",
	"ETHIOPIC SYLLABLE JOA",
	"ETHIOPIC SYLLABLE JU",
	"ETHIOPIC SYLLABLE JWA",
	"ETHIOPIC SYLLABLE KA",
	"ETHIOPIC SYLLABLE KAA",
	"ETHIOPIC SYLLABLE KE",
	"ETHIOPIC SYLLABLE KEE",
	"ETHIOPIC SYLLABLE KI",
	"ETHIOPIC SYLLABLE KO",
	"ETHIOPIC SYLLABLE KOA",
	"ETHIOPIC SYLLABLE KU",
	"ETHIOPIC SYLLABLE KWA",
	"ETHIOPIC SYLLABLE KWAA",
	"ETHIOPIC SYLLABLE KWE",
	"ETHIOPIC SYLLABLE KWEE",
	"ETHIOPIC SYLLABLE KWI",
	"ETHIOPIC SYLLABLE KXA",
	"ETHIOPIC SYLLABLE KXAA",
	"ETHIOPIC SYLLABLE KXE",
	"ETHIOPIC SYLLABLE KXEE",
	"ETHIOPIC SYLLABLE KXI",
	"ETHIOPIC SYLLABLE KXO",
	"ETHIOPIC SYLLABLE KXU",
	"ETHIOPIC SYLLABLE KXWA",
	"ETHIOPIC SYLLABLE KXWAA",
	"ETHIOPIC SYLLABLE KXWE",
	"ETHIOPIC SYLLABLE KXWEE",
	"ETHIOPIC SYLLABLE KXWI",
	"ETHIOPIC SYLLABLE KYA",
	"ETHIOPIC SYLLABLE KYAA",
	"ETHIOPIC SYLLABLE KYE",
	"ETHIOPIC SYLLABLE KYEE",
	"ETHIOPIC SYLLABLE KYI",
	"ETHIOPIC SYLLABLE KYO",
	"ETHIOPIC SYLLABLE KYU",
	"ETHIOPIC SYLLABLE LA",
	"ETHIOPIC SYLLABLE LAA",
	"ETHIOPIC SYLLABLE LE",
	"ETHIOPIC SYLLABLE LEE",
	"ETHIOPIC SYLLABLE LI",
	"ETHIOPIC SYLLABLE LO",
	"ETHIOPIC SYLLABLE LOA",
	"ETHIOPIC SYLLABLE LU",
	"ETHIOPIC SYLLABLE LWA",
	"ETHIOPIC SYLLABLE MA",
	"ETHIOPIC SYLLABLE MAA",
	"ETHIOPIC SYLLABLE ME",
	"ETHIOPIC SYLLABLE MEE",
	"ETHIOPIC SYLLABLE MI",
	"ETHIOPIC SYLLABLE MO",
	"ETHIOPIC SYLLABLE MOA",
	"ETHIOPIC SYLLABLE MU",
	"ETHIOPIC SYLLABLE MWA",
	"ETHIOPIC SYLLABLE MWE",
	"ETHIOPIC SYLLABLE MWEE",
	"ETHIOPIC SYLLABLE MWI",
	"ETHIOPIC SYLLABLE MYA",
	"ETHIOPIC SYLLABLE NA",
	"ETHIOPIC SYLLABLE NAA",
	"ETHIOPIC SYLLABLE NE",
	"ETHIOPIC SYLLABLE NEE",
	"ETHIOPIC SYLLABLE NI",
	"ETHIOPIC SYLLABLE NO",
	"ETHIOPIC SYLLABLE NOA",
	"ETHIOPIC SYLLABLE NU",
	"ETHIOPIC SYLLABLE NWA",
	"ETHIOPIC SYLLABLE NYA",
	"ETHIOPIC SYLLABLE NYAA",
	"ETHIOPIC SYLLABLE NYE",
	"ETHIOPIC SYLLABLE NYEE",
	"ETHIOPIC SYLLABLE NYI",
	"ETHIOPIC SYLLABLE NYO",
	"ETHIOPIC SYLLABLE NYOA",
	"ETHIOPIC SYLLABLE NYU",
	"ETHIOPIC SYLLABLE NYWA",
	"ETHIOPIC SYLLABLE PA",
	"ETHIOPIC SYLLABLE PAA",
	"ETHIOPIC SYLLABLE PE",
	"ETHIOPIC SYLLABLE PEE",
	"ETHIOPIC SYLLABLE PHA",
	"ETHIOPIC SYLLABLE PHAA",
	"ETHIOPIC SYLLABLE PHARYNGEAL A",
	"ETHIOPIC SYLLABLE PHARYNGEAL AA",
	"ETHIOPIC SYLLABLE PHARYNGEAL E",
	"ETHIOPIC SYLLABLE PHARYNGEAL EE",
	"ETHIOPIC SYLLABLE PHARYNGEAL I",
	"ETHIOPIC SYLLABLE PHARYNGEAL O",
	"ETHIOPIC SYLLABLE PHARYNGEAL U",
	"ETHIOPIC SYLLABLE PHE",
	"ETHIOPIC SYLLABLE PHEE",
	"ETHIOPIC SYLLABLE PHI",
	"ETHIOPIC SYLLABLE PHO",
	"ETHIOPIC SYLLABLE PHOA",
	"ETHIOPIC SYLLABLE PHU",
	"ETHIOPIC SYLLABLE PHWA",
	"ETHIOPIC SYLLABLE PI",
	"ETHIOPIC SYLLABLE PO",
	"ETHIOPIC SYLLABLE POA",
	"ETHIOPIC SYLLABLE PU",
	"ETHIOPIC SYLLABLE PWA",
	"ETHIOPIC SYLLABLE PWE",
	"ETHIOPIC SYLLABLE PWEE",
	"ETHIOPIC SYLLABLE PWI",
	"ETHIOPIC SYLLABLE QA",
	"ETHIOPIC SYLLABLE QAA",
	"ETHIOPIC SYLLABLE QE",
	"ETHIOPIC SYLLABLE QEE",
	"ETHIOPIC SYLLABLE QHA",
	"ETHIOPIC SYLLABLE QHAA",
	"ETHIOPIC SYLLABLE QHE",
	"ETHIOPIC SYLLABLE QHEE",
	"ETHIOPIC SYLLABLE QHI",
	"ETHIOPIC SYLLABLE QHO",
	"ETHIOPIC SYLLABLE QHU",
	"ETHIOPIC SYLLABLE QHWA",
	"ETHIOPIC SYLLABLE QHWAA",
	"ETHIOPIC SYLLABLE QHWE",
	"ETHIOPIC SYLLABLE QHWEE",
	"ETHIOPIC SYLLABLE QHWI",
	"ETHIOPIC SYLLABLE QI",
	"ETHIOPIC SYLLABLE QO",
	"ETHIOPIC SYLLABLE QOA",
	"ETHIOPIC SYLLABLE QU",
	"ETHIOPIC SYLLABLE QWA",
	"ETHIOPIC SYLLABLE QWAA",
	"ETHIOPIC SYLLABLE QWE",
	"ETHIOPIC SYLLABLE QWEE",
	"ETHIOPIC SYLLABLE QWI",
	"ETHIOPIC SYLLABLE QYA",
	"ETHIOPIC SYLLABLE QYAA",
	"ETHIOPIC SYLLABLE QYE",
	"ETHIOPIC SYLLABLE QYEE",
	"ETHIOPIC SYLLABLE QYI",
	"ETHIOPIC SYLLABLE QYO",
	"ETHIOPIC SYLLABLE QYU",
	"ETHIOPIC SYLLABLE RA",
	"ETHIOPIC SYLLABLE RAA",
	"ETHIOPIC SYLLABLE RE",
	"ETHIOPIC SYLLABLE REE",
	"ETHIOPIC SYLLABLE RI",
	"ETHIOPIC SYLLABLE RO",
	"ETHIOPIC SYLLABLE ROA",
	"ETHIOPIC SYLLABLE RU",
	"ETHIOPIC SYLLABLE RWA",
	"ETHIOPIC SYLLABLE RYA",
	"ETHIOPIC SYLLABLE SA",
	"ETHIOPIC SYLLABLE SAA",
	"ETHIOPIC SYLLABLE SE",
	"ETHIOPIC SYLLABLE SEBATBEIT BWA",
	"ETHIOPIC SYLLABLE SEBATBEIT FWA",
	"ETHIOPIC SYLLABLE SEBATBEIT MWA",
	"ETHIOPIC SYLLABLE SEBATBEIT PWA",
	"ETHIOPIC SYLLABLE SEE",
	"ETHIOPIC SYLLABLE SHA",
	"ETHIOPIC SYLLABLE SHAA",
	"ETHIOPIC SYLLABLE SHE",
	"ETHIOPIC SYLLABLE SHEE",
	"ETHIOPIC SYLLABLE SHI",
	"ETHIOPIC SYLLABLE SHO",
	"ETHIOPIC SYLLABLE SHOA",
	"ETHIOPIC SYLLABLE SHU",
	"ETHIOPIC SYLLABLE SHWA",
	"ETHIOPIC SYLLABLE SI",
	"ETHIOPIC SYLLABLE SO",
	"ETHIOPIC SYLLABLE SOA",
	"ETHIOPIC SYLLABLE SSA",
	"ETHIOPIC SYLLABLE SSAA",
	"ETHIOPIC SYLLABLE SSE",
	"ETHIOPIC SYLLABLE SSEE",
	"ETHIOPIC SYLLABLE SSI",
	"ETHIOPIC SYLLABLE SSO",
	"ETHIOPIC SYLLABLE SSU",
	"ETHIOPIC SYLLABLE SU",
	"ETHIOPIC SYLLABLE SWA",
	"ETHIOPIC SYLLABLE SZA",
	"ETHIOPIC SYLLABLE SZAA",
	"ETHIOPIC SYLLABLE SZE",
	"ETHIOPIC SYLLABLE SZEE",
	"ETHIOPIC SYLLABLE SZI",
	"ETHIOPIC SYLLABLE SZO",
	"ETHIOPIC SYLLABLE SZU",
	"ETHIOPIC SYLLABLE SZWA",
	"ETHIOPIC SYLLABLE TA",
	"ETHIOPIC SYLLABLE TAA",
	"ETHIOPIC SYLLABLE TE",
	"ETHIOPIC SYLLABLE TEE",
	"ETHIOPIC SYLLABLE THA",
	"ETHIOPIC SYLLABLE THAA",
	"ETHIOPIC SYLLABLE THE",
	"ETHIOPIC SYLLABLE THEE",
	"ETHIOPIC SYLLABLE THI",
	"ETHIOPIC SYLLABLE THO",
	"ETHIOPIC SYLLABLE THOA",
	"ETHIOPIC SYLLABLE THU",
	"ETHIOPIC SYLLABLE THWA",
	"ETHIOPIC SYLLABLE TI",
	"ETHIOPIC SYLLABLE TO",
	"ETHIOPIC SYLLABLE TOA",
	"ETHIOPIC SYLLABLE TSA",
	"ETHIOPIC SYLLABLE TSAA",
	"ETHIOPIC SYLLABLE TSE",
	"ETHIOPIC SYLLABLE TSEE",
	"ETHIOPIC SYLLABLE TSI",
	"ETHIOPIC SYLLABLE TSO",
	"ETHIOPIC SYLLABLE TSU",
	"ETHIOPIC SYLLABLE TSWA",
	"ETHIOPIC SYLLABLE TTHAA",
	"ETHIOPIC SYLLABLE TTHE",
	"ETHIOPIC SYLLABLE TTHEE",
	"ETHIOPIC SYLLABLE TTHI",
	"ETHIOPIC SYLLABLE TTHO",
	"ETHIOPIC SYLLABLE TTHU",
	"ETHIOPIC SYLLABLE TU",
	"ETHIOPIC SYLLABLE TWA",
	"ETHIOPIC SYLLABLE TZA",
	"ETHIOPIC SYLLABLE TZAA",
	"ETHIOPIC SYLLABLE TZE",
	"ETHIOPIC SYLLABLE TZEE",
	"ETHIOPIC SYLLABLE TZI",
	"ETHIOPIC SYLLABLE TZO",
	"ETHIOPIC SYLLABLE TZOA",
	"ETHIOPIC SYLLABLE TZU",
	"ETHIOPIC SYLLABLE VA",
	"ETHIOPIC SYLLABLE VAA",
	"ETHIOPIC SYLLABLE VE",
	"ETHIOPIC SYLLABLE VEE",
	"ETHIOPIC SYLLABLE VI",
	"ETHIOPIC SYLLABLE VO",
	"ETHIOPIC SYLLABLE VU",
	"ETHIOPIC SYLLABLE VWA",
	"ETHIOPIC SYLLABLE WA",
	"ETHIOPIC SYLLABLE WAA",
	"ETHIOPIC SYLLABLE WE",
	"ETHIOPIC SYLLABLE WEE",
	"ETHIOPIC SYLLABLE WI",
	"ETHIOPIC SYLLABLE WO",
	"ETHIOPIC SYLLABLE WOA",
	"ETHIOPIC SYLLABLE WU",
	"ETHIOPIC SYLLABLE XA",
	"ETHIOPIC SYLLABLE XAA",
	"ETHIOPIC SYLLABLE XE",
	"ETHIOPIC SYLLABLE XEE",
	"ETHIOPIC SYLLABLE XI",
	"ETHIOPIC SYLLABLE XO",
	"ETHIOPIC SYLLABLE XOA",
	"ETHIOPIC SYLLABLE XU",
	"ETHIOPIC SYLLABLE XWA",
	"ETHIOPIC SYLLABLE XWAA",
	"ETHIOPIC SYLLABLE XWE",
	"ETHIOPIC SYLLABLE XWEE",
	"ETHIOPIC SYLLABLE XWI",
	"ETHIOPIC SYLLABLE XYA",
	"ETHIOPIC SYLLABLE XYAA",
	"ETHIOPIC SYLLABLE XYE",
	"ETHIOPIC SYLLABLE XYEE",
	"ETHIOPIC SYLLABLE XYI",
	"ETHIOPIC SYLLABLE XYO",
	"ETHIOPIC SYLLABLE XYU",
	"ETHIOPIC SYLLABLE YA",
	"ETHIOPIC SYLLABLE YAA",
	"ETHIOPIC SYLLABLE YE",
	"ETHIOPIC SYLLABLE YEE",
	"ETHIOPIC SYLLABLE YI",
	"ETHIOPIC SYLLABLE YO",
	"ETHIOPIC SYLLABLE YOA",
	"ETHIOPIC SYLLABLE YU",
	"ETHIOPIC SYLLABLE ZA",
	"ETHIOPIC SYLLABLE ZAA",
	"ETHIOPIC SYLLABLE ZE",
	"ETHIOPIC SYLLABLE ZEE",
	"ETHIOPIC SYLLABLE ZHA",
	"ETHIOPIC SYLLABLE ZHAA",
	"ETHIOPIC SYLLABLE ZHE",
	"ETHIOPIC SYLLABLE ZHEE",
	"ETHIOPIC SYLLABLE ZHI",
	"ETHIOPIC SYLLABLE ZHO",
	"ETHIOPIC SYLLABLE ZHU",
	"ETHIOPIC SYLLABLE ZHWA",
	"ETHIOPIC SYLLABLE ZI",
	"ETHIOPIC SYLLABLE ZO",
	"ETHIOPIC SYLLABLE ZOA",
	"ETHIOPIC SYLLABLE ZU",
	"ETHIOPIC SYLLABLE ZWA",
	"ETHIOPIC SYLLABLE ZZA",
	"ETHIOPIC SYLLABLE ZZAA",
	"ETHIOPIC SYLLABLE ZZE",
	"ETHIOPIC SYLLABLE ZZEE",
	"ETHIOPIC SYLLABLE ZZI",
	"ETHIOPIC SYLLABLE ZZO",
	"ETHIOPIC SYLLABLE ZZU",
	"ETHIOPIC TONAL MARK CHIRET",
	"ETHIOPIC TONAL MARK DERET",
	"ETHIOPIC TONAL MARK DERET-HIDET",
	"ETHIOPIC TONAL MARK DIFAT",
	"ETHIOPIC TONAL MARK HIDET",
	"ETHIOPIC TONAL MARK KENAT",
	"ETHIOPIC TONAL MARK KURT",
	"ETHIOPIC TONAL MARK RIKRIK",
	"ETHIOPIC TONAL MARK SHORT RIKRIK",
	"ETHIOPIC TONAL MARK YIZET",
	"ETHIOPIC WORDSPACE",
	"EULER CONSTANT",
	"EURO SIGN",
	"EURO-CURRENCY SIGN",
	"EUROPEAN CASTLE",
	"EUROPEAN POST OFFICE",
	"EVERGREEN TREE",
	"EXCESS",
	"EXCLAMATION MARK",
	"EXCLAMATION QUESTION MARK",
	"EXPRESSIONLESS FACE",
	"EXTENDED ARABIC-INDIC DIGIT EIGHT",
	"EXTENDED ARABIC-INDIC DIGIT FIVE",
	"EXTENDED ARABIC-INDIC DIGIT FOUR",
	"EXTENDED ARABIC-INDIC DIGIT NINE",
	"EXTENDED ARABIC-INDIC DIGIT ONE",
	"EXTENDED ARABIC-INDIC DIGIT SEVEN",
	"EXTENDED ARABIC-INDIC DIGIT SIX",
	"EXTENDED ARABIC-INDIC DIGIT THREE",
	"EXTENDED ARABIC-INDIC DIGIT TWO",
	"EXTENDED ARABIC-INDIC DIGIT ZERO",
	"EXTRATERRESTRIAL ALIEN",
	"EYEGLASSES",
	"EYES",
	"FACE MASSAGE",
	"FACE SAVOURING DELICIOUS FOOD",
	"FACE SCREAMING IN FEAR",
	"FACE THROWING A KISS",
	"FACE WITH COLD SWEAT",
	"FACE WITH LOOK OF TRIUMPH",
	"FACE WITH MEDICAL MASK",
	"FACE WITH NO GOOD GESTURE",
	"FACE WITH OK GESTURE",
	"FACE WITH OPEN MOUTH",
	"FACE WITH OPEN MOUTH AND COLD SWEAT",
	"FACE WITH STUCK-OUT TONGUE",
	"FACE WITH STUCK-OUT TONGUE AND TIGHTLY-CLOSED EYES",
	"FACE WITH STUCK-OUT TONGUE AND WINKING EYE",
	"FACE WITH TEARS OF JOY",
	"FACE WITHOUT MOUTH",
	"FACSIMILE SIGN",
	"FACTORY",
	"FALLEN LEAF",
	"FALLING DIAGONAL CROSSING NORTH EAST ARROW",
	"FALLING DIAGONAL CROSSING RISING DIAGONAL",
	"FALLING DIAGONAL IN WHITE CIRCLE IN BLACK SQUARE",
	"FAMILY",
	"FARSI SYMBOL",
	"FATHER CHRISTMAS",
	"FAX MACHINE",
	"FEARFUL FACE",
	"FEMALE SIGN",
	"FEMININE ORDINAL INDICATOR",
	"FERRIS WHEEL",
	"FERRY",
	"FIGURE DASH",
	"FIGURE SPACE",
	"FILE FOLDER",
	"FINITE PART INTEGRAL",
	"FIRE",
	"FIRE ENGINE",
	"FIREWORK SPARKLER",
	"FIREWORKS",
	"FIRST QUARTER MOON",
	"FIRST QUARTER MOON SYMBOL",
	"FIRST QUARTER MOON WITH FACE",
	"FIRST STRONG ISOLATE",
	"FISH",
	"FISH CAKE WITH SWIRL DESIGN",
	"FISHEYE",
	"FISHING POLE AND FISH",
	"FISTED HAND SIGN",
	"FIVE DOT MARK",
	"FIVE DOT PUNCTUATION",
	"FLAG IN HOLE",
	"FLATNESS",
	"FLEUR-DE-LIS",
	"FLEXED BICEPS",
	"FLOPPY DISK",
	"FLORAL HEART",
	"FLOWER",
	"FLOWER PLAYING CARDS",
	"FLOWER PUNCTUATION MARK",
	"FLUSHED FACE",
	"FOGGY",
	"FOOTPRINTS",
	"FOR ALL",
	"FORCES",
	"FORK AND KNIFE",
	"FORKED PARAGRAPHOS",
	"FORKING",
	"FOUNTAIN",
	"FOUR BALLOON-SPOKED ASTERISK",
	"FOUR CLUB-SPOKED ASTERISK",
	"FOUR DOT MARK",
	"FOUR DOT PUNCTUATION",
	"FOUR LEAF CLOVER",
	"FOUR TEARDROP-SPOKED ASTERISK",
	"FOUR-PER-EM SPACE",
	"FOURTH ROOT",
	"FRACTION NUMERATOR ONE",
	"FRACTION SLASH",
	"FRENCH FRANC SIGN",
	"FRENCH FRIES",
	"FRIED SHRIMP",
	"FROG FACE",
	"FRONT-FACING BABY CHICK",
	"FRONT-TILTED SHADOWED WHITE RIGHTWARDS ARROW",
	"FROWN",
	"FROWNING FACE WITH OPEN MOUTH",
	"FUEL PUMP",
	"FULL BLOCK",
	"FULL MOON SYMBOL",
	"FULL MOON WITH FACE",
	"FULL OUTER JOIN",
	"FULL STOP",
	"FULLWIDTH AMPERSAND",
	"FULLWIDTH APOSTROPHE",
	"FULLWIDTH ASTERISK",
	"FULLWIDTH BROKEN BAR",
	"FULLWIDTH CENT SIGN",
	"FULLWIDTH CIRCUMFLEX ACCENT",
	"FULLWIDTH COLON",
	"FULLWIDTH COMMA",
	"FULLWIDTH COMMERCIAL AT",
	"FULLWIDTH DIGIT EIGHT",
	"FULLWIDTH DIGIT FIVE",
	"FULLWIDTH DIGIT FOUR",
	"FULLWIDTH DIGIT NINE",
	"FULLWIDTH DIGIT ONE",
	"FULLWIDTH DIGIT SEVEN",
	"FULLWIDTH DIGIT SIX",
	"FULLWIDTH DIGIT THREE",
	"FULLWIDTH DIGIT TWO",
	"FULLWIDTH DIGIT ZERO",
	"FULLWIDTH DOLLAR SIGN",
	"FULLWIDTH EQUALS SIGN",
	"FULLWIDTH EXCLAMATION MARK",
	"FULLWIDTH FULL STOP",
	"FULLWIDTH GRAVE ACCENT",
	"FULLWIDTH GREATER-THAN SIGN",
	"FULLWIDTH HYPHEN-MINUS",
	"FULLWIDTH LATIN CAPITAL LETTER A",
	"FULLWIDTH LATIN CAPITAL LETTER B",
	"FULLWIDTH LATIN CAPITAL LETTER C",
	"FULLWIDTH LATIN CAPITAL LETTER D",
	"FULLWIDTH LATIN CAPITAL LETTER E",
	"FULLWIDTH LATIN CAPITAL LETTER F",
	"FULLWIDTH LATIN CAPITAL LETTER G",
	"FULLWIDTH LATIN CAPITAL LETTER H",
	"FULLWIDTH LATIN CAPITAL LETTER I",
	"FULLWIDTH LATIN CAPITAL LETTER J",
	"FULLWIDTH LATIN CAPITAL LETTER K",
	"FULLWIDTH LATIN CAPITAL LETTER L",
	"FULLWIDTH LATIN CAPITAL LETTER M",
	"FULLWIDTH LATIN CAPITAL LETTER N",
	"FULLWIDTH LATIN CAPITAL LETTER O",
	"FULLWIDTH LATIN CAPITAL LETTER P",
	"FULLWIDTH LATIN CAPITAL LETTER Q",
	"FULLWIDTH LATIN CAPITAL LETTER R",
	"FULLWIDTH LATIN CAPITAL LETTER S",
	"FULLWIDTH LATIN CAPITAL LETTER T",
	"FULLWIDTH LATIN CAPITAL LETTER U",
	"FULLWIDTH LATIN CAPITAL LETTER V",
	"FULLWIDTH LATIN CAPITAL LETTER W",
	"FULLWIDTH LATIN CAPITAL LETTER X",
	"FULLWIDTH LATIN CAPITAL LETTER Y",
	"FULLWIDTH LATIN CAPITAL LETTER Z",
	"FULLWIDTH LATIN SMALL LETTER A",
	"FULLWIDTH LATIN SMALL LETTER B",
	"FULLWIDTH LATIN SMALL LETTER C",
	"FULLWIDTH LATIN SMALL LETTER D",
	"FULLWIDTH LATIN SMALL LETTER E",
	"FULLWIDTH LATIN SMALL LETTER F",
	"FULLWIDTH LATIN SMALL LETTER G",
	"FULLWIDTH LATIN SMALL LETTER H",
	"FULLWIDTH LATIN SMALL LETTER I",
	"FULLWIDTH LATIN SMALL LETTER J",
	"FULLWIDTH LATIN SMALL LETTER K",
	"FULLWIDTH LATIN SMALL LETTER L",
	"FULLWIDTH LATIN SMALL LETTER M",
	"FULLWIDTH LATIN SMALL LETTER N",
	"FULLWIDTH LATIN SMALL LETTER O",
	"FULLWIDTH LATIN SMALL LETTER P",
	"FULLWIDTH LATIN SMALL LETTER Q",
	"FULLWIDTH LATIN SMALL LETTER R",
	"FULLWIDTH LATIN SMALL LETTER S",
	"FULLWIDTH LATIN SMALL LETTER T",
	"FULLWIDTH LATIN SMALL LETTER U",
	"FULLWIDTH LATIN SMALL LETTER V",
	"FULLWIDTH LATIN SMALL LETTER W",
	"FULLWIDTH LATIN SMALL LETTER X",
	"FULLWIDTH LATIN SMALL LETTER Y",
	"FULLWIDTH LATIN SMALL LETTER Z",
	"FULLWIDTH LEFT CURLY BRACKET",
	"FULLWIDTH LEFT PARENTHESIS",
	"FULLWIDTH LEFT SQUARE BRACKET",
	"FULLWIDTH LEFT WHITE PARENTHESIS",
	"FULLWIDTH LESS-THAN SIGN",
	"FULLWIDTH LOW LINE",
	"FULLWIDTH MACRON",
	"FULLWIDTH NOT SIGN",
	"FULLWIDTH NUMBER SIGN",
	"FULLWIDTH PERCENT SIGN",
	"FULLWIDTH PLUS SIGN",
	"FULLWIDTH POUND SIGN",
	"FULLWIDTH QUESTION MARK",
	"FULLWIDTH QUOTATION MARK",
	"FULLWIDTH REVERSE SOLIDUS",
	"FULLWIDTH RIGHT CURLY BRACKET",
	"FULLWIDTH RIGHT PARENTHESIS",
	"FULLWIDTH RIGHT SQUARE BRACKET",
	"FULLWIDTH RIGHT WHITE PARENTHESIS",
	"FULLWIDTH SEMICOLON",
	"FULLWIDTH SOLIDUS",
	"FULLWIDTH TILDE",
	"FULLWIDTH VERTICAL LINE",
	"FULLWIDTH WON SIGN",
	"FULLWIDTH YEN SIGN",
	"FUNCTION APPLICATION",
	"FUNERAL URN",
	"FUSE",
	"GAME DIE",
	"GEAR",
	"GEAR WITH HANDLES",
	"GEAR WITHOUT HUB",
	"GEM STONE",
	"GEMINI",
	"GEOMETRIC PROPORTION",
	"GEOMETRICALLY EQUAL TO",
	"GEOMETRICALLY EQUIVALENT TO",
	"GEORGIAN CAPITAL LETTER AEN",
	"GEORGIAN CAPITAL LETTER AN",
	"GEORGIAN CAPITAL LETTER BAN",
	"GEORGIAN CAPITAL LETTER CAN",
	"GEORGIAN CAPITAL LETTER CHAR",
	"GEORGIAN CAPITAL LETTER CHIN",
	"GEORGIAN CAPITAL LETTER CIL",
	"GEORGIAN CAPITAL LETTER DON",
	"GEORGIAN CAPITAL LETTER EN",
	"GEORGIAN CAPITAL LETTER GAN",
	"GEORGIAN CAPITAL LETTER GHAN",
	"GEORGIAN CAPITAL LETTER HAE",
	"GEORGIAN CAPITAL LETTER HAR",
	"GEORGIAN CAPITAL LETTER HE",
	"GEORGIAN CAPITAL LETTER HIE",
	"GEORGIAN CAPITAL LETTER HOE",
	"GEORGIAN CAPITAL LETTER IN",
	"GEORGIAN CAPITAL LETTER JHAN",
	"GEORGIAN CAPITAL LETTER JIL",
	"GEORGIAN CAPITAL LETTER KAN",
	"GEORGIAN CAPITAL LETTER KHAR",
	"GEORGIAN CAPITAL LETTER LAS",
	"GEORGIAN CAPITAL LETTER MAN",
	"GEORGIAN CAPITAL LETTER NAR",
	"GEORGIAN CAPITAL LETTER ON",
	"GEORGIAN CAPITAL LETTER PAR",
	"GEORGIAN CAPITAL LETTER PHAR",
	"GEORGIAN CAPITAL LETTER QAR",
	"GEORGIAN CAPITAL LETTER RAE",
	"GEORGIAN CAPITAL LETTER SAN",
	"GEORGIAN CAPITAL LETTER SHIN",
	"GEORGIAN CAPITAL LETTER TAN",
	"GEORGIAN CAPITAL LETTER TAR",
	"GEORGIAN CAPITAL LETTER UN",
	"GEORGIAN CAPITAL LETTER VIN",
	"GEORGIAN CAPITAL LETTER WE",
	"GEORGIAN CAPITAL LETTER XAN",
	"GEORGIAN CAPITAL LETTER YN",
	"GEORGIAN CAPITAL LETTER ZEN",
	"GEORGIAN CAPITAL LETTER ZHAR",
	"GEORGIAN LETTER AEN",
	"GEORGIAN LETTER AIN",
	"GEORGIAN LETTER AN",
	"GEORGIAN LETTER BAN",
	"GEORGIAN LETTER CAN",
	"GEORGIAN LETTER CHAR",
	"GEORGIAN LETTER CHIN",
	"GEORGIAN LETTER CIL",
	"GEORGIAN LETTER DON",
	"GEORGIAN LETTER ELIFI",
	"GEORGIAN LETTER EN",
	"GEORGIAN LETTER FI",
	"GEORGIAN LETTER GAN",
	"GEORGIAN LETTER GHAN",
	"GEORGIAN LETTER HAE",
	"GEORGIAN LETTER HAR",
	"GEORGIAN LETTER HARD SIGN",
	"GEORGIAN LETTER HE",
	"GEORGIAN LETTER HIE",
	"GEORGIAN LETTER HOE",
	"GEORGIAN LETTER IN",
	"GEORGIAN LETTER JHAN",
	"GEORGIAN LETTER JIL",
	"GEORGIAN LETTER KAN",
	"GEORGIAN LETTER KHAR",
	"GEORGIAN LETTER LABIAL SIGN",
	"GEORGIAN LETTER LAS",
	"GEORGIAN LETTER MAN",
	"GEORGIAN LETTER NAR",
	"GEORGIAN LETTER ON",
	"GEORGIAN LETTER PAR",
	"GEORGIAN LETTER PHAR",
	"GEORGIAN LETTER QAR",
	"GEORGIAN LETTER RAE",
	"GEORGIAN LETTER SAN",
	"GEORGIAN LETTER SHIN",
	"GEORGIAN LETTER TAN",
	"GEORGIAN LETTER TAR",
	"GEORGIAN LETTER TURNED GAN",
	"GEORGIAN LETTER UN",
	"GEORGIAN LETTER VIN",
	"GEORGIAN LETTER WE",
	"GEORGIAN LETTER XAN",
	"GEORGIAN LETTER YN",
	"GEORGIAN LETTER ZEN",
	"GEORGIAN LETTER ZHAR",
	"GEORGIAN PARAGRAPH SEPARATOR",
	"GEORGIAN SMALL LETTER AEN",
	"GEORGIAN SMALL LETTER AN",
	"GEORGIAN SMALL LETTER BAN",
	"GEORGIAN SMALL LETTER CAN",
	"GEORGIAN SMALL LETTER CHAR",
	"GEORGIAN SMALL LETTER CHIN",
	"GEORGIAN SMALL LETTER CIL",
	"GEORGIAN SMALL LETTER DON",
	"GEORGIAN SMALL LETTER EN",
	"GEORGIAN SMALL LETTER GAN",
	"GEORGIAN SMALL LETTER GHAN",
	"GEORGIAN SMALL LETTER HAE",
	"GEORGIAN SMALL LETTER HAR",
	"GEORGIAN SMALL LETTER HE",
	"GEORGIAN SMALL LETTER HIE",
	"GEORGIAN SMALL LETTER HOE",
	"GEORGIAN SMALL LETTER IN",
	"GEORGIAN SMALL LETTER JHAN",
	"GEORGIAN SMALL LETTER JIL",
	"GEORGIAN SMALL LETTER KAN",
	"GEORGIAN SMALL LETTER KHAR",
	"GEORGIAN SMALL LETTER LAS",
	"GEORGIAN SMALL LETTER MAN",
	"GEORGIAN SMALL LETTER NAR",
	"GEORGIAN SMALL LETTER ON",
	"GEORGIAN SMALL LETTER PAR",
	"GEORGIAN SMALL LETTER PHAR",
	"GEORGIAN SMALL LETTER QAR",
	"GEORGIAN SMALL LETTER RAE",
	"GEORGIAN SMALL LETTER SAN",
	"GEORGIAN SMALL LETTER SHIN",
	"GEORGIAN SMALL LETTER TAN",
	"GEORGIAN SMALL LETTER TAR",
	"GEORGIAN SMALL LETTER UN",
	"GEORGIAN SMALL LETTER VIN",
	"GEORGIAN SMALL LETTER WE",
	"GEORGIAN SMALL LETTER XAN",
	"GEORGIAN SMALL LETTER YN",
	"GEORGIAN SMALL LETTER ZEN",
	"GEORGIAN SMALL LETTER ZHAR",
	"GERMAN PENNY SIGN",
	"GETA MARK",
	"GHOST",
	"GIMEL SYMBOL",
	"GIRL",
	"GLAGOLITIC CAPITAL LETTER AZU",
	"GLAGOLITIC CAPITAL LETTER BIG YUS",
	"GLAGOLITIC CAPITAL LETTER BUKY",
	"GLAGOLITIC CAPITAL LETTER CHRIVI",
	"GLAGOLITIC CAPITAL LETTER DJERVI",
	"GLAGOLITIC CAPITAL LETTER DOBRO",
	"GLAGOLITIC CAPITAL LETTER DZELO",
	"GLAGOLITIC CAPITAL LETTER FITA",
	"GLAGOLITIC CAPITAL LETTER FRITU",
	"GLAGOLITIC CAPITAL LETTER GLAGOLI",
	"GLAGOLITIC CAPITAL LETTER HERU",
	"GLAGOLITIC CAPITAL LETTER I",
	"GLAGOLITIC CAPITAL LETTER INITIAL IZHE",
	"GLAGOLITIC CAPITAL LETTER IOTATED BIG YUS",
	"GLAGOLITIC CAPITAL LETTER IOTATED SMALL YUS",
	"GLAGOLITIC CAPITAL LETTER IZHE",
	"GLAGOLITIC CAPITAL LETTER IZHITSA",
	"GLAGOLITIC CAPITAL LETTER KAKO",
	"GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE",
	"GLAGOLITIC CAPITAL LETTER LJUDIJE",
	"GLAGOLITIC CAPITAL LETTER MYSLITE",
	"GLAGOLITIC CAPITAL LETTER NASHI",
	"GLAGOLITIC CAPITAL LETTER ONU",
	"GLAGOLITIC CAPITAL LETTER OTU",
	"GLAGOLITIC CAPITAL LETTER PE",
	"GLAGOLITIC CAPITAL LETTER POKOJI",
	"GLAGOLITIC CAPITAL LETTER RITSI",
	"GLAGOLITIC CAPITAL LETTER SHA",
	"GLAGOLITIC CAPITAL LETTER SHTA",
	"GLAGOLITIC CAPITAL LETTER SHTAPIC",
	"GLAGOLITIC CAPITAL LETTER SLOVO",
	"GLAGOLITIC CAPITAL LETTER SMALL YUS",
	"GLAGOLITIC CAPITAL LETTER SMALL YUS WITH TAIL",
	"GLAGOLITIC CAPITAL LETTER SPIDERY HA",
	"GLAGOLITIC CAPITAL LETTER TROKUTASTI A",
	"GLAGOLITIC CAPITAL LETTER TSI",
	"GLAGOLITIC CAPITAL LETTER TVRIDO",
	"GLAGOLITIC CAPITAL LETTER UKU",
	"GLAGOLITIC CAPITAL LETTER VEDE",
	"GLAGOLITIC CAPITAL LETTER YATI",
	"GLAGOLITIC CAPITAL LETTER YERI",
	"GLAGOLITIC CAPITAL LETTER YERU",
	"GLAGOLITIC CAPITAL LETTER YESTU",
	"GLAGOLITIC CAPITAL LETTER YO",
	"GLAGOLITIC CAPITAL LETTER YU",
	"GLAGOLITIC CAPITAL LETTER ZEMLJA",
	"GLAGOLITIC CAPITAL LETTER ZHIVETE",
	"GLAGOLITIC SMALL LETTER AZU",
	"GLAGOLITIC SMALL LETTER BIG YUS",
	"GLAGOLITIC SMALL LETTER BUKY",
	"GLAGOLITIC SMALL LETTER CHRIVI",
	"GLAGOLITIC SMALL LETTER DJERVI",
	"GLAGOLITIC SMALL LETTER DOBRO",
	"GLAGOLITIC SMALL LETTER DZELO",
	"GLAGOLITIC SMALL LETTER FITA",
	"GLAGOLITIC SMALL LETTER FRITU",
	"GLAGOLITIC SMALL LETTER GLAGOLI",
	"GLAGOLITIC SMALL LETTER HERU",
	"GLAGOLITIC SMALL LETTER I",
	"GLAGOLITIC SMALL LETTER INITIAL IZHE",
	"GLAGOLITIC SMALL LETTER IOTATED BIG YUS",
	"GLAGOLITIC SMALL LETTER IOTATED SMALL YUS",
	"GLAGOLITIC SMALL LETTER IZHE",
	"GLAGOLITIC SMALL LETTER IZHITSA",
	"GLAGOLITIC SMALL LETTER KAKO",
	"GLAGOLITIC SMALL LETTER LATINATE MYSLITE",
	"GLAGOLITIC SMALL LETTER LJUDIJE",
	"GLAGOLITIC SMALL LETTER MYSLITE",
	"GLAGOLITIC SMALL LETTER NASHI",
	"GLAGOLITIC SMALL LETTER ONU",
	"GLAGOLITIC SMALL LETTER OTU",
	"GLAGOLITIC SMALL LETTER PE",
	"GLAGOLITIC SMALL LETTER POKOJI",
	"GLAGOLITIC SMALL LETTER RITSI",
	"GLAGOLITIC SMALL LETTER SHA",
	"GLAGOLITIC SMALL LETTER SHTA",
	"GLAGOLITIC SMALL LETTER SHTAPIC",
	"GLAGOLITIC SMALL LETTER SLOVO",
	"GLAGOLITIC SMALL LETTER SMALL YUS",
	"GLAGOLITIC SMALL LETTER SMALL YUS WITH TAIL",
	"GLAGOLITIC SMALL LETTER SPIDERY HA",
	"GLAGOLITIC SMALL LETTER TROKUTASTI A",
	"GLAGOLITIC SMALL LETTER TSI",
	"GLAGOLITIC SMALL LETTER TVRIDO",
	"GLAGOLITIC SMALL LETTER UKU",
	"GLAGOLITIC SMALL LETTER VEDE",
	"GLAGOLITIC SMALL LETTER YATI",
	"GLAGOLITIC SMALL LETTER YERI",
	"GLAGOLITIC SMALL LETTER YERU",
	"GLAGOLITIC SMALL LETTER YESTU",
	"GLAGOLITIC SMALL LETTER YO",
	"GLAGOLITIC SMALL LETTER YU",
	"GLAGOLITIC SMALL LETTER ZEMLJA",
	"GLAGOLITIC SMALL LETTER ZHIVETE",
	"GLEICH STARK",
	"GLOBE WITH MERIDIANS",
	"GLOWING STAR",
	"GOAT",
	"GOTHIC LETTER AHSA",
	"GOTHIC LETTER AIHVUS",
	"GOTHIC LETTER BAIRKAN",
	"GOTHIC LETTER DAGS",
	"GOTHIC LETTER EIS",
	"GOTHIC LETTER FAIHU",
	"GOTHIC LETTER GIBA",
	"GOTHIC LETTER HAGL",
	"GOTHIC LETTER HWAIR",
	"GOTHIC LETTER IGGWS",
	"GOTHIC LETTER IUJA",
	"GOTHIC LETTER JER",
	"GOTHIC LETTER KUSMA",
	"GOTHIC LETTER LAGUS",
	"GOTHIC LETTER MANNA",
	"GOTHIC LETTER NAUTHS",
	"GOTHIC LETTER NINE HUNDRED",
	"GOTHIC LETTER NINETY",
	"GOTHIC LETTER OTHAL",
	"GOTHIC LETTER PAIRTHRA",
	"GOTHIC LETTER QAIRTHRA",
	"GOTHIC LETTER RAIDA",
	"GOTHIC LETTER SAUIL",
	"GOTHIC LETTER TEIWS",
	"GOTHIC LETTER THIUTH",
	"GOTHIC LETTER URUS",
	"GOTHIC LETTER WINJA",
	"GRADUATION CAP",
	"GRAPES",
	"GRAVE ACCENT",
	"GREATER-THAN ABOVE DOUBLE-LINE EQUAL ABOVE LESS-THAN",
	"GREATER-THAN ABOVE LESS-THAN ABOVE DOUBLE-LINE EQUAL",
	"GREATER-THAN ABOVE RIGHTWARDS ARROW",
	"GREATER-THAN ABOVE SIMILAR ABOVE LESS-THAN",
	"GREATER-THAN ABOVE SIMILAR OR EQUAL",
	"GREATER-THAN ABOVE SLANTED EQUAL ABOVE LESS-THAN ABOVE SLANTED EQUAL",
	"GREATER-THAN AND NOT APPROXIMATE",
	"GREATER-THAN AND SINGLE-LINE NOT EQUAL TO",
	"GREATER-THAN BESIDE LESS-THAN",
	"GREATER-THAN BUT NOT EQUAL TO",
	"GREATER-THAN BUT NOT EQUIVALENT TO",
	"GREATER-THAN CLOSED BY CURVE",
	"GREATER-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL",
	"GREATER-THAN EQUAL TO OR LESS-THAN",
	"GREATER-THAN OR APPROXIMATE",
	"GREATER-THAN OR EQUAL TO",
	"GREATER-THAN OR EQUIVALENT TO",
	"GREATER-THAN OR LESS-THAN",
	"GREATER-THAN OR SLANTED EQUAL TO",
	"GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE",
	"GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE LEFT",
	"GREATER-THAN OR SLANTED EQUAL TO WITH DOT INSIDE",
	"GREATER-THAN OVER EQUAL TO",
	"GREATER-THAN OVERLAPPING LESS-THAN",
	"GREATER-THAN SIGN",
	"GREATER-THAN WITH CIRCLE INSIDE",
	"GREATER-THAN WITH DOT",
	"GREATER-THAN WITH QUESTION MARK ABOVE",
	"GREEK ACROPHONIC ATTIC FIFTY",
	"GREEK ACROPHONIC ATTIC FIFTY STATERS",
	"GREEK ACROPHONIC ATTIC FIFTY TALENTS",
	"GREEK ACROPHONIC ATTIC FIFTY THOUSAND",
	"GREEK ACROPHONIC ATTIC FIFTY THOUSAND STATERS",
	"GREEK ACROPHONIC ATTIC FIVE",
	"GREEK ACROPHONIC ATTIC FIVE HUNDRED",
	"GREEK ACROPHONIC ATTIC FIVE HUNDRED STATERS",
	"GREEK ACROPHONIC ATTIC FIVE HUNDRED TALENTS",
	"GREEK ACROPHONIC ATTIC FIVE STATERS",
	"GREEK ACROPHONIC ATTIC FIVE TALENTS",
	"GREEK ACROPHONIC ATTIC FIVE THOUSAND",
	"GREEK ACROPHONIC ATTIC FIVE THOUSAND TALENTS",
	"GREEK ACROPHONIC ATTIC ONE DRACHMA",
	"GREEK ACROPHONIC ATTIC ONE HALF",
	"GREEK ACROPHONIC ATTIC ONE HUNDRED STATERS",
	"GREEK ACROPHONIC ATTIC ONE HUNDRED TALENTS",
	"GREEK ACROPHONIC ATTIC ONE QUARTER",
	"GREEK ACROPHONIC ATTIC ONE THOUSAND STATERS",
	"GREEK ACROPHONIC ATTIC ONE THOUSAND TALENTS",
	"GREEK ACROPHONIC ATTIC TEN MNAS",
	"GREEK ACROPHONIC ATTIC TEN STATERS",
	"GREEK ACROPHONIC ATTIC TEN TALENTS",
	"GREEK ACROPHONIC ATTIC TEN THOUSAND STATERS",
	"GREEK ACROPHONIC CARYSTIAN FIVE HUNDRED",
	"GREEK ACROPHONIC CYRENAIC TWO DRACHMAS",
	"GREEK ACROPHONIC DELPHIC FIVE MNAS",
	"GREEK ACROPHONIC EPIDAUREAN FIVE HUNDRED",
	"GREEK ACROPHONIC EPIDAUREAN TWO",
	"GREEK ACROPHONIC EPIDAUREAN TWO DRACHMAS",
	"GREEK ACROPHONIC HERAEUM ONE PLETHRON",
	"GREEK ACROPHONIC HERMIONIAN FIFTY",
	"GREEK ACROPHONIC HERMIONIAN ONE",
	"GREEK ACROPHONIC HERMIONIAN TEN",
	"GREEK ACROPHONIC MESSENIAN TEN",
	"GREEK ACROPHONIC NAXIAN FIVE HUNDRED",
	"GREEK ACROPHONIC STRATIAN FIFTY MNAS",
	"GREEK ACROPHONIC THESPIAN FIFTY",
	"GREEK ACROPHONIC THESPIAN FIVE HUNDRED",
	"GREEK ACROPHONIC THESPIAN FIVE THOUSAND",
	"GREEK ACROPHONIC THESPIAN ONE",
	"GREEK ACROPHONIC THESPIAN ONE HUNDRED",
	"GREEK ACROPHONIC THESPIAN ONE THOUSAND",
	"GREEK ACROPHONIC THESPIAN TEN",
	"GREEK ACROPHONIC THESPIAN THIRTY",
	"GREEK ACROPHONIC THESPIAN THREE HUNDRED",
	"GREEK ACROPHONIC THESPIAN TWO",
	"GREEK ACROPHONIC TROEZENIAN FIFTY",
	"GREEK ACROPHONIC TROEZENIAN FIFTY ALTERNATE FORM",
	"GREEK ACROPHONIC TROEZENIAN FIVE",
	"GREEK ACROPHONIC TROEZENIAN FIVE HUNDRED",
	"GREEK ACROPHONIC TROEZENIAN TEN",
	"GREEK ACROPHONIC TROEZENIAN TEN ALTERNATE FORM",
	"GREEK ANO TELEIA",
	"GREEK AROURA SIGN",
	"GREEK ARTABE SIGN",
	"GREEK BETA SYMBOL",
	"GREEK CAPITAL DOTTED LUNATE SIGMA SYMBOL",
	"GREEK CAPITAL KAI SYMBOL",
	"GREEK CAPITAL LETTER ALPHA",
	"GREEK CAPITAL LETTER ALPHA WITH DASIA",
	"GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA",
	"GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI",
	"GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH DASIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA",
	"GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH MACRON",
	"GREEK CAPITAL LETTER ALPHA WITH OXIA",
	"GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH PSILI",
	"GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA",
	"GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI",
	"GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH PSILI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA",
	"GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ALPHA WITH TONOS",
	"GREEK CAPITAL LETTER ALPHA WITH VARIA",
	"GREEK CAPITAL LETTER ALPHA WITH VRACHY",
	"GREEK CAPITAL LETTER ARCHAIC SAMPI",
	"GREEK CAPITAL LETTER BETA",
	"GREEK CAPITAL LETTER CHI",
	"GREEK CAPITAL LETTER DELTA",
	"GREEK CAPITAL LETTER EPSILON",
	"GREEK CAPITAL LETTER EPSILON WITH DASIA",
	"GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA",
	"GREEK CAPITAL LETTER EPSILON WITH DASIA AND VARIA",
	"GREEK CAPITAL LETTER EPSILON WITH OXIA",
	"GREEK CAPITAL LETTER EPSILON WITH PSILI",
	"GREEK CAPITAL LETTER EPSILON WITH PSILI AND OXIA",
	"GREEK CAPITAL LETTER EPSILON WITH PSILI AND VARIA",
	"GREEK CAPITAL LETTER EPSILON WITH TONOS",
	"GREEK CAPITAL LETTER EPSILON WITH VARIA",
	"GREEK CAPITAL LETTER ETA",
	"GREEK CAPITAL LETTER ETA WITH DASIA",
	"GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA",
	"GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI",
	"GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH DASIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA",
	"GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH OXIA",
	"GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH PSILI",
	"GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA",
	"GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI",
	"GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH PSILI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA",
	"GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER ETA WITH TONOS",
	"GREEK CAPITAL LETTER ETA WITH VARIA",
	"GREEK CAPITAL LETTER GAMMA",
	"GREEK CAPITAL LETTER HETA",
	"GREEK CAPITAL LETTER IOTA",
	"GREEK CAPITAL LETTER IOTA WITH DASIA",
	"GREEK CAPITAL LETTER IOTA WITH DASIA AND OXIA",
	"GREEK CAPITAL LETTER IOTA WITH DASIA AND PERISPOMENI",
	"GREEK CAPITAL LETTER IOTA WITH DASIA AND VARIA",
	"GREEK CAPITAL LETTER IOTA WITH DIALYTIKA",
	"GREEK CAPITAL LETTER IOTA WITH MACRON",
	"GREEK CAPITAL LETTER IOTA WITH OXIA",
	"GREEK CAPITAL LETTER IOTA WITH PSILI",
	"GREEK CAPITAL LETTER IOTA WITH PSILI AND OXIA",
	"GREEK CAPITAL LETTER IOTA WITH PSILI AND PERISPOMENI",
	"GREEK CAPITAL LETTER IOTA WITH PSILI AND VARIA",
	"GREEK CAPITAL LETTER IOTA WITH TONOS",
	"GREEK CAPITAL LETTER IOTA WITH VARIA",
	"GREEK CAPITAL LETTER IOTA WITH VRACHY",
	"GREEK CAPITAL LETTER KAPPA",
	"GREEK CAPITAL LETTER LAMDA",
	"GREEK CAPITAL LETTER MU",
	"GREEK CAPITAL LETTER NU",
	"GREEK CAPITAL LETTER OMEGA",
	"GREEK CAPITAL LETTER OMEGA WITH DASIA",
	"GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA",
	"GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI",
	"GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH DASIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA",
	"GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH OXIA",
	"GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH PSILI",
	"GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA",
	"GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI",
	"GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH PSILI AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA",
	"GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA AND PROSGEGRAMMENI",
	"GREEK CAPITAL LETTER OMEGA WITH TONOS",
	"GREEK CAPITAL LETTER OMEGA WITH VARIA",
	"GREEK CAPITAL LETTER OMICRON",
	"GREEK CAPITAL LETTER OMICRON WITH DASIA",
	"GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA",
	"GREEK CAPITAL LETTER OMICRON WITH DASIA AND VARIA",
	"GREEK CAPITAL LETTER OMICRON WITH OXIA",
	"GREEK CAPITAL LETTER OMICRON WITH PSILI",
	"GREEK CAPITAL LETTER OMICRON WITH PSILI AND OXIA",
	"GREEK CAPITAL LETTER OMICRON WITH PSILI AND VARIA",
	"GREEK CAPITAL LETTER OMICRON WITH TONOS",
	"GREEK CAPITAL LETTER OMICRON WITH VARIA",
	"GREEK CAPITAL LETTER PAMPHYLIAN DIGAMMA",
	"GREEK CAPITAL LETTER PHI",
	"GREEK CAPITAL LETTER PI",
	"GREEK CAPITAL LETTER PSI",
	"GREEK CAPITAL LETTER RHO",
	"GREEK CAPITAL LETTER RHO WITH DASIA",
	"GREEK CAPITAL LETTER SAN",
	"GREEK CAPITAL LETTER SHO",
	"GREEK CAPITAL LETTER SIGMA",
	"GREEK CAPITAL LETTER TAU",
	"GREEK CAPITAL LETTER THETA",
	"GREEK CAPITAL LETTER UPSILON",
	"GREEK CAPITAL LETTER UPSILON WITH DASIA",
	"GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA",
	"GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI",
	"GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA",
	"GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA",
	"GREEK CAPITAL LETTER UPSILON WITH MACRON",
	"GREEK CAPITAL LETTER UPSILON WITH OXIA",
	"GREEK CAPITAL LETTER UPSILON WITH TONOS",
	"GREEK CAPITAL LETTER UPSILON WITH VARIA",
	"GREEK CAPITAL LETTER UPSILON WITH VRACHY",
	"GREEK CAPITAL LETTER XI",
	"GREEK CAPITAL LETTER ZETA",
	"GREEK CAPITAL LUNATE SIGMA SYMBOL",
	"GREEK CAPITAL REVERSED DOTTED LUNATE SIGMA SYMBOL",
	"GREEK CAPITAL REVERSED LUNATE SIGMA SYMBOL",
	"GREEK CAPITAL THETA SYMBOL",
	"GREEK DASIA",
	"GREEK DASIA AND OXIA",
	"GREEK DASIA AND PERISPOMENI",
	"GREEK DASIA AND VARIA",
	"GREEK DIALYTIKA AND OXIA",
	"GREEK DIALYTIKA AND PERISPOMENI",
	"GREEK DIALYTIKA AND VARIA",
	"GREEK DIALYTIKA TONOS",
	"GREEK DRACHMA SIGN",
	"GREEK FIVE OBOLS SIGN",
	"GREEK FOUR OBOLS SIGN",
	"GREEK GRAMMA SIGN",
	"GREEK KAI SYMBOL",
	"GREEK KAPPA SYMBOL",
	"GREEK KORONIS",
	"GREEK KYATHOS BASE SIGN",
	"GREEK LETTER ARCHAIC KOPPA",
	"GREEK LETTER DIGAMMA",
	"GREEK LETTER KOPPA",
	"GREEK LETTER SAMPI",
	"GREEK LETTER SMALL CAPITAL GAMMA",
	"GREEK LETTER SMALL CAPITAL LAMDA",
	"GREEK LETTER SMALL CAPITAL PI",
	"GREEK LETTER SMALL CAPITAL PSI",
	"GREEK LETTER SMALL CAPITAL RHO",
	"GREEK LETTER STIGMA",
	"GREEK LETTER YOT",
	"GREEK LITRA SIGN",
	"GREEK LOWER NUMERAL SIGN",
	"GREEK LUNATE EPSILON SYMBOL",
	"GREEK LUNATE SIGMA SYMBOL",
	"GREEK METRETES SIGN",
	"GREEK MUSICAL LEIMMA",
	"GREEK NUMERAL SIGN",
	"GREEK OBOL SIGN",
	"GREEK ONE HALF SIGN",
	"GREEK ONE HALF SIGN ALTERNATE FORM",
	"GREEK OUNKIA SIGN",
	"GREEK OXIA",
	"GREEK PERISPOMENI",
	"GREEK PHI SYMBOL",
	"GREEK PI SYMBOL",
	"GREEK PROSGEGRAMMENI",
	"GREEK PSILI",
	"GREEK PSILI AND OXIA",
	"GREEK PSILI AND PERISPOMENI",
	"GREEK PSILI AND VARIA",
	"GREEK QUESTION MARK",
	"GREEK REVERSED LUNATE EPSILON SYMBOL",
	"GREEK RHO SYMBOL",
	"GREEK RHO WITH STROKE SYMBOL",
	"GREEK SMALL DOTTED LUNATE SIGMA SYMBOL",
	"GREEK SMALL LETTER ALPHA",
	"GREEK SMALL LETTER ALPHA WITH DASIA",
	"GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA",
	"GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI",
	"GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA",
	"GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH DASIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH MACRON",
	"GREEK SMALL LETTER ALPHA WITH OXIA",
	"GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH PERISPOMENI",
	"GREEK SMALL LETTER ALPHA WITH PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH PSILI",
	"GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA",
	"GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI",
	"GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA",
	"GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH TONOS",
	"GREEK SMALL LETTER ALPHA WITH VARIA",
	"GREEK SMALL LETTER ALPHA WITH VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ALPHA WITH VRACHY",
	"GREEK SMALL LETTER ALPHA WITH YPOGEGRAMMENI",
	"GREEK SMALL LETTER ARCHAIC KOPPA",
	"GREEK SMALL LETTER ARCHAIC SAMPI",
	"GREEK SMALL LETTER BETA",
	"GREEK SMALL LETTER CHI",
	"GREEK SMALL LETTER DELTA",
	"GREEK SMALL LETTER DIGAMMA",
	"GREEK SMALL LETTER EPSILON",
	"GREEK SMALL LETTER EPSILON WITH DASIA",
	"GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA",
	"GREEK SMALL LETTER EPSILON WITH DASIA AND VARIA",
	"GREEK SMALL LETTER EPSILON WITH OXIA",
	"GREEK SMALL LETTER EPSILON WITH PSILI",
	"GREEK SMALL LETTER EPSILON WITH PSILI AND OXIA",
	"GREEK SMALL LETTER EPSILON WITH PSILI AND VARIA",
	"GREEK SMALL LETTER EPSILON WITH TONOS",
	"GREEK SMALL LETTER EPSILON WITH VARIA",
	"GREEK SMALL LETTER ETA",
	"GREEK SMALL LETTER ETA WITH DASIA",
	"GREEK SMALL LETTER ETA WITH DASIA AND OXIA",
	"GREEK SMALL LETTER ETA WITH DASIA AND OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI",
	"GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH DASIA AND VARIA",
	"GREEK SMALL LETTER ETA WITH DASIA AND VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH DASIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH OXIA",
	"GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH PERISPOMENI",
	"GREEK SMALL LETTER ETA WITH PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH PSILI",
	"GREEK SMALL LETTER ETA WITH PSILI AND OXIA",
	"GREEK SMALL LETTER ETA WITH PSILI AND OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI",
	"GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH PSILI AND VARIA",
	"GREEK SMALL LETTER ETA WITH PSILI AND VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH PSILI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH TONOS",
	"GREEK SMALL LETTER ETA WITH VARIA",
	"GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER ETA WITH YPOGEGRAMMENI",
	"GREEK SMALL LETTER FINAL SIGMA",
	"GREEK SMALL LETTER GAMMA",
	"GREEK SMALL LETTER HETA",
	"GREEK SMALL LETTER IOTA",
	"GREEK SMALL LETTER IOTA WITH DASIA",
	"GREEK SMALL LETTER IOTA WITH DASIA AND OXIA",
	"GREEK SMALL LETTER IOTA WITH DASIA AND PERISPOMENI",
	"GREEK SMALL LETTER IOTA WITH DASIA AND VARIA",
	"GREEK SMALL LETTER IOTA WITH DIALYTIKA",
	"GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA",
	"GREEK SMALL LETTER IOTA WITH DIALYTIKA AND PERISPOMENI",
	"GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS",
	"GREEK SMALL LETTER IOTA WITH DIALYTIKA AND VARIA",
	"GREEK SMALL LETTER IOTA WITH MACRON",
	"GREEK SMALL LETTER IOTA WITH OXIA",
	"GREEK SMALL LETTER IOTA WITH PERISPOMENI",
	"GREEK SMALL LETTER IOTA WITH PSILI",
	"GREEK SMALL LETTER IOTA WITH PSILI AND OXIA",
	"GREEK SMALL LETTER IOTA WITH PSILI AND PERISPOMENI",
	"GREEK SMALL LETTER IOTA WITH PSILI AND VARIA",
	"GREEK SMALL LETTER IOTA WITH TONOS",
	"GREEK SMALL LETTER IOTA WITH VARIA",
	"GREEK SMALL LETTER IOTA WITH VRACHY",
	"GREEK SMALL LETTER KAPPA",
	"GREEK SMALL LETTER KOPPA",
	"GREEK SMALL LETTER LAMDA",
	"GREEK SMALL LETTER MU",
	"GREEK SMALL LETTER NU",
	"GREEK SMALL LETTER OMEGA",
	"GREEK SMALL LETTER OMEGA WITH DASIA",
	"GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA",
	"GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI",
	"GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA",
	"GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH DASIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH OXIA",
	"GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH PERISPOMENI",
	"GREEK SMALL LETTER OMEGA WITH PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH PSILI",
	"GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA",
	"GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI",
	"GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA",
	"GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH PSILI AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH TONOS",
	"GREEK SMALL LETTER OMEGA WITH VARIA",
	"GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMEGA WITH YPOGEGRAMMENI",
	"GREEK SMALL LETTER OMICRON",
	"GREEK SMALL LETTER OMICRON WITH DASIA",
	"GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA",
	"GREEK SMALL LETTER OMICRON WITH DASIA AND VARIA",
	"GREEK SMALL LETTER OMICRON WITH OXIA",
	"GREEK SMALL LETTER OMICRON WITH PSILI",
	"GREEK SMALL LETTER OMICRON WITH PSILI AND OXIA",
	"GREEK SMALL LETTER OMICRON WITH PSILI AND VARIA",
	"GREEK SMALL LETTER OMICRON WITH TONOS",
	"GREEK SMALL LETTER OMICRON WITH VARIA",
	"GREEK SMALL LETTER PAMPHYLIAN DIGAMMA",
	"GREEK SMALL LETTER PHI",
	"GREEK SMALL LETTER PI",
	"GREEK SMALL LETTER PSI",
	"GREEK SMALL LETTER RHO",
	"GREEK SMALL LETTER RHO WITH DASIA",
	"GREEK SMALL LETTER RHO WITH PSILI",
	"GREEK SMALL LETTER SAMPI",
	"GREEK SMALL LETTER SAN",
	"GREEK SMALL LETTER SHO",
	"GREEK SMALL LETTER SIGMA",
	"GREEK SMALL LETTER STIGMA",
	"GREEK SMALL LETTER TAU",
	"GREEK SMALL LETTER THETA",
	"GREEK SMALL LETTER UPSILON",
	"GREEK SMALL LETTER UPSILON WITH DASIA",
	"GREEK SMALL LETTER UPSILON WITH DASIA AND OXIA",
	"GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI",
	"GREEK SMALL LETTER UPSILON WITH DASIA AND VARIA",
	"GREEK SMALL LETTER UPSILON WITH DIALYTIKA",
	"GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND OXIA",
	"GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND PERISPOMENI",
	"GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS",
	"GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND VARIA",
	"GREEK SMALL LETTER UPSILON WITH MACRON",
	"GREEK SMALL LETTER UPSILON WITH OXIA",
	"GREEK SMALL LETTER UPSILON WITH PERISPOMENI",
	"GREEK SMALL LETTER UPSILON WITH PSILI",
	"GREEK SMALL LETTER UPSILON WITH PSILI AND OXIA",
	"GREEK SMALL LETTER UPSILON WITH PSILI AND PERISPOMENI",
	"GREEK SMALL LETTER UPSILON WITH PSILI AND VARIA",
	"GREEK SMALL LETTER UPSILON WITH TONOS",
	"GREEK SMALL LETTER UPSILON WITH VARIA",
	"GREEK SMALL LETTER UPSILON WITH VRACHY",
	"GREEK SMALL LETTER XI",
	"GREEK SMALL LETTER ZETA",
	"GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL",
	"GREEK SMALL REVERSED LUNATE SIGMA SYMBOL",
	"GREEK SUBSCRIPT SMALL LETTER BETA",
	"GREEK SUBSCRIPT SMALL LETTER CHI",
	"GREEK SUBSCRIPT SMALL LETTER GAMMA",
	"GREEK SUBSCRIPT SMALL LETTER PHI",
	"GREEK SUBSCRIPT SMALL LETTER RHO",
	"GREEK TALENT SIGN",
	"GREEK THETA SYMBOL",
	"GREEK THREE OBOLS SIGN",
	"GREEK THREE QUARTERS SIGN",
	"GREEK TONOS",
	"GREEK TRYBLION BASE SIGN",
	"GREEK TWO OBOLS SIGN",
	"GREEK TWO THIRDS SIGN",
	"GREEK UPSILON WITH ACUTE AND HOOK SYMBOL",
	"GREEK UPSILON WITH DIAERESIS AND HOOK SYMBOL",
	"GREEK UPSILON WITH HOOK SYMBOL",
	"GREEK VARIA",
	"GREEK XESTES SIGN",
	"GREEK YEAR SIGN",
	"GREEK YPOGEGRAMMENI",
	"GREEK ZERO SIGN",
	"GREEN APPLE",
	"GREEN BOOK",
	"GREEN HEART",
	"GRIMACING FACE",
	"GRINNING CAT FACE WITH SMILING EYES",
	"GRINNING FACE",
	"GRINNING FACE WITH SMILING EYES",
	"GROWING HEART",
	"GUARANI SIGN",
	"GUARDSMAN",
	"GUITAR",
	"GUJARATI ABBREVIATION SIGN",
	"GUJARATI DIGIT EIGHT",
	"GUJARATI DIGIT FIVE",
	"GUJARATI DIGIT FOUR",
	"GUJARATI DIGIT NINE",
	"GUJARATI DIGIT ONE",
	"GUJARATI DIGIT SEVEN",
	"GUJARATI DIGIT SIX",
	"GUJARATI DIGIT THREE",
	"GUJARATI DIGIT TWO",
	"GUJARATI DIGIT ZERO",
	"GUJARATI LETTER A",
	"GUJARATI LETTER AA",
	"GUJARATI LETTER AI",
	"GUJARATI LETTER AU",
	"GUJARATI LETTER BA",
	"GUJARATI LETTER BHA",
	"GUJARATI LETTER CA",
	"GUJARATI LETTER CHA",
	"GUJARATI LETTER DA",
	"GUJARATI LETTER DDA",
	"GUJARATI LETTER DDHA",
	"GUJARATI LETTER DHA",
	"GUJARATI LETTER E",
	"GUJARATI LETTER GA",
	"GUJARATI LETTER GHA",
	"GUJARATI LETTER HA",
	"GUJARATI LETTER I",
	"GUJARATI LETTER II",
	"GUJARATI LETTER JA",
	"GUJARATI LETTER JHA",
	"GUJARATI LETTER KA",
	"GUJARATI LETTER KHA",
	"GUJARATI LETTER LA",
	"GUJARATI LETTER LLA",
	"GUJARATI LETTER MA",
	"GUJARATI LETTER NA",
	"GUJARATI LETTER NGA",
	"GUJARATI LETTER NNA",
	"GUJARATI LETTER NYA",
	"GUJARATI LETTER O",
	"GUJARATI LETTER PA",
	"GUJARATI LETTER PHA",
	"GUJARATI LETTER RA",
	"GUJARATI LETTER SA",
	"GUJARATI LETTER SHA",
	"GUJARATI LETTER SSA",
	"GUJARATI LETTER TA",
	"GUJARATI LETTER THA",
	"GUJARATI LETTER TTA",
	"GUJARATI LETTER TTHA",
	"GUJARATI LETTER U",
	"GUJARATI LETTER UU",
	"GUJARATI LETTER VA",
	"GUJARATI LETTER VOCALIC L",
	"GUJARATI LETTER VOCALIC LL",
	"GUJARATI LETTER VOCALIC R",
	"GUJARATI LETTER VOCALIC RR",
	"GUJARATI LETTER YA",
	"GUJARATI OM",
	"GUJARATI RUPEE SIGN",
	"GUJARATI SIGN ANUSVARA",
	"GUJARATI SIGN AVAGRAHA",
	"GUJARATI SIGN CANDRABINDU",
	"GUJARATI SIGN NUKTA",
	"GUJARATI SIGN VIRAMA",
	"GUJARATI SIGN VISARGA",
	"GUJARATI VOWEL CANDRA E",
	"GUJARATI VOWEL CANDRA O",
	"GUJARATI VOWEL SIGN AA",
	"GUJARATI VOWEL SIGN AI",
	"GUJARATI VOWEL SIGN AU",
	"GUJARATI VOWEL SIGN CANDRA E",
	"GUJARATI VOWEL SIGN CANDRA O",
	"GUJARATI VOWEL SIGN E",
	"GUJARATI VOWEL SIGN I",
	"GUJARATI VOWEL SIGN II",
	"GUJARATI VOWEL SIGN O",
	"GUJARATI VOWEL SIGN U",
	"GUJARATI VOWEL SIGN UU",
	"GUJARATI VOWEL SIGN VOCALIC L",
	"GUJARATI VOWEL SIGN VOCALIC LL",
	"GUJARATI VOWEL SIGN VOCALIC R",
	"GUJARATI VOWEL SIGN VOCALIC RR",
	"GURMUKHI ADDAK",
	"GURMUKHI DIGIT EIGHT",
	"GURMUKHI DIGIT FIVE",
	"GURMUKHI DIGIT FOUR",
	"GURMUKHI DIGIT NINE",
	"GURMUKHI DIGIT ONE",
	"GURMUKHI DIGIT SEVEN",
	"GURMUKHI DIGIT SIX",
	"GURMUKHI DIGIT THREE",
	"GURMUKHI DIGIT TWO",
	"GURMUKHI DIGIT ZERO",
	"GURMUKHI EK ONKAR",
	"GURMUKHI IRI",
	"GURMUKHI LETTER A",
	"GURMUKHI LETTER AA",
	"GURMUKHI LETTER AI",
	"GURMUKHI LETTER AU",
	"GURMUKHI LETTER BA",
	"GURMUKHI LETTER BHA",
	"GURMUKHI LETTER CA",
	"GURMUKHI LETTER CHA",
	"GURMUKHI LETTER DA",
	"GURMUKHI LETTER DDA",
	"GURMUKHI LETTER DDHA",
	"GURMUKHI LETTER DHA",
	"GURMUKHI LETTER EE",
	"GURMUKHI LETTER FA",
	"GURMUKHI LETTER GA",
	"GURMUKHI LETTER GHA",
	"GURMUKHI LETTER GHHA",
	"GURMUKHI LETTER HA",
	"GURMUKHI LETTER I",
	"GURMUKHI LETTER II",
	"GURMUKHI LETTER JA",
	"GURMUKHI LETTER JHA",
	"GURMUKHI LETTER KA",
	"GURMUKHI LETTER KHA",
	"GURMUKHI LETTER KHHA",
	"GURMUKHI LETTER LA",
	"GURMUKHI LETTER LLA",
	"GURMUKHI LETTER MA",
	"GURMUKHI LETTER NA",
	"GURMUKHI LETTER NGA",
	"GURMUKHI LETTER NNA",
	"GURMUKHI LETTER NYA",
	"GURMUKHI LETTER OO",
	"GURMUKHI LETTER PA",
	"GURMUKHI LETTER PHA",
	"GURMUKHI LETTER RA",
	"GURMUKHI LETTER RRA",
	"GURMUKHI LETTER SA",
	"GURMUKHI LETTER SHA",
	"GURMUKHI LETTER TA",
	"GURMUKHI LETTER THA",
	"GURMUKHI LETTER TTA",
	"GURMUKHI LETTER TTHA",
	"GURMUKHI LETTER U",
	"GURMUKHI LETTER UU",
	"GURMUKHI LETTER VA",
	"GURMUKHI LETTER YA",
	"GURMUKHI LETTER ZA",
	"GURMUKHI SIGN ADAK BINDI",
	"GURMUKHI SIGN BINDI",
	"GURMUKHI SIGN NUKTA",
	"GURMUKHI SIGN UDAAT",
	"GURMUKHI SIGN VIRAMA",
	"GURMUKHI SIGN VISARGA",
	"GURMUKHI SIGN YAKASH",
	"GURMUKHI TIPPI",
	"GURMUKHI URA",
	"GURMUKHI VOWEL SIGN AA",
	"GURMUKHI VOWEL SIGN AI",
	"GURMUKHI VOWEL SIGN AU",
	"GURMUKHI VOWEL SIGN EE",
	"GURMUKHI VOWEL SIGN I",
	"GURMUKHI VOWEL SIGN II",
	"GURMUKHI VOWEL SIGN OO",
	"GURMUKHI VOWEL SIGN U",
	"GURMUKHI VOWEL SIGN UU",
	"HAIR SPACE",
	"HAIRCUT",
	"HALFWIDTH BLACK SQUARE",
	"HALFWIDTH DOWNWARDS ARROW",
	"HALFWIDTH FORMS LIGHT VERTICAL",
	"HALFWIDTH HANGUL FILLER",
	"HALFWIDTH HANGUL LETTER A",
	"HALFWIDTH HANGUL LETTER AE",
	"HALFWIDTH HANGUL LETTER CHIEUCH",
	"HALFWIDTH HANGUL LETTER CIEUC",
	"HALFWIDTH HANGUL LETTER E",
	"HALFWIDTH HANGUL LETTER EO",
	"HALFWIDTH HANGUL LETTER EU",
	"HALFWIDTH HANGUL LETTER HIEUH",
	"HALFWIDTH HANGUL LETTER I",
	"HALFWIDTH HANGUL LETTER IEUNG",
	"HALFWIDTH HANGUL LETTER KHIEUKH",
	"HALFWIDTH HANGUL LETTER KIYEOK",
	"HALFWIDTH HANGUL LETTER KIYEOK-SIOS",
	"HALFWIDTH HANGUL LETTER MIEUM",
	"HALFWIDTH HANGUL LETTER NIEUN",
	"HALFWIDTH HANGUL LETTER NIEUN-CIEUC",
	"HALFWIDTH HANGUL LETTER NIEUN-HIEUH",
	"HALFWIDTH HANGUL LETTER O",
	"HALFWIDTH HANGUL LETTER OE",
	"HALFWIDTH HANGUL LETTER PHIEUPH",
	"HALFWIDTH HANGUL LETTER PIEUP",
	"HALFWIDTH HANGUL LETTER PIEUP-SIOS",
	"HALFWIDTH HANGUL LETTER RIEUL",
	"HALFWIDTH HANGUL LETTER RIEUL-HIEUH",
	"HALFWIDTH HANGUL LETTER RIEUL-KIYEOK",
	"HALFWIDTH HANGUL LETTER RIEUL-MIEUM",
	"HALFWIDTH HANGUL LETTER RIEUL-PHIEUPH",
	"HALFWIDTH HANGUL LETTER RIEUL-PIEUP",
	"HALFWIDTH HANGUL LETTER RIEUL-SIOS",
	"HALFWIDTH HANGUL LETTER RIEUL-THIEUTH",
	"HALFWIDTH HANGUL LETTER SIOS",
	"HALFWIDTH HANGUL LETTER SSANGCIEUC",
	"HALFWIDTH HANGUL LETTER SSANGKIYEOK",
	"HALFWIDTH HANGUL LETTER SSANGPIEUP",
	"HALFWIDTH HANGUL LETTER SSANGSIOS",
	"HALFWIDTH HANGUL LETTER SSANGTIKEUT",
	"HALFWIDTH HANGUL LETTER THIEUTH",
	"HALFWIDTH HANGUL LETTER TIKEUT",
	"HALFWIDTH HANGUL LETTER U",
	"HALFWIDTH HANGUL LETTER WA",
	"HALFWIDTH HANGUL LETTER WAE",
	"HALFWIDTH HANGUL LETTER WE",
	"HALFWIDTH HANGUL LETTER WEO",
	"HALFWIDTH HANGUL LETTER WI",
	"HALFWIDTH HANGUL LETTER YA",
	"HALFWIDTH HANGUL LETTER YAE",
	"HALFWIDTH HANGUL LETTER YE",
	"HALFWIDTH HANGUL LETTER YEO",
	"HALFWIDTH HANGUL LETTER YI",
	"HALFWIDTH HANGUL LETTER YO",
	"HALFWIDTH HANGUL LETTER YU",
	"HALFWIDTH IDEOGRAPHIC COMMA",
	"HALFWIDTH IDEOGRAPHIC FULL STOP",
	"HALFWIDTH KATAKANA LETTER A",
	"HALFWIDTH KATAKANA LETTER E",
	"HALFWIDTH KATAKANA LETTER HA",
	"HALFWIDTH KATAKANA LETTER HE",
	"HALFWIDTH KATAKANA LETTER HI",
	"HALFWIDTH KATAKANA LETTER HO",
	"HALFWIDTH KATAKANA LETTER HU",
	"HALFWIDTH KATAKANA LETTER I",
	"HALFWIDTH KATAKANA LETTER KA",
	"HALFWIDTH KATAKANA LETTER KE",
	"HALFWIDTH KATAKANA LETTER KI",
	"HALFWIDTH KATAKANA LETTER KO",
	"HALFWIDTH KATAKANA LETTER KU",
	"HALFWIDTH KATAKANA LETTER MA",
	"HALFWIDTH KATAKANA LETTER ME",
	"HALFWIDTH KATAKANA LETTER MI",
	"HALFWIDTH KATAKANA LETTER MO",
	"HALFWIDTH KATAKANA LETTER MU",
	"HALFWIDTH KATAKANA LETTER N",
	"HALFWIDTH KATAKANA LETTER NA",
	"HALFWIDTH KATAKANA LETTER NE",
	"HALFWIDTH KATAKANA LETTER NI",
	"HALFWIDTH KATAKANA LETTER NO",
	"HALFWIDTH KATAKANA LETTER NU",
	"HALFWIDTH KATAKANA LETTER O",
	"HALFWIDTH KATAKANA LETTER RA",
	"HALFWIDTH KATAKANA LETTER RE",
	"HALFWIDTH KATAKANA LETTER RI",
	"HALFWIDTH KATAKANA LETTER RO",
	"HALFWIDTH KATAKANA LETTER RU",
	"HALFWIDTH KATAKANA LETTER SA",
	"HALFWIDTH KATAKANA LETTER SE",
	"HALFWIDTH KATAKANA LETTER SI",
	"HALFWIDTH KATAKANA LETTER SMALL A",
	"HALFWIDTH KATAKANA LETTER SMALL E",
	"HALFWIDTH KATAKANA LETTER SMALL I",
	"HALFWIDTH KATAKANA LETTER SMALL O",
	"HALFWIDTH KATAKANA LETTER SMALL TU",
	"HALFWIDTH KATAKANA LETTER SMALL U",
	"HALFWIDTH KATAKANA LETTER SMALL YA",
	"HALFWIDTH KATAKANA LETTER SMALL YO",
	"HALFWIDTH KATAKANA LETTER SMALL YU",
	"HALFWIDTH KATAKANA LETTER SO",
	"HALFWIDTH KATAKANA LETTER SU",
	"HALFWIDTH KATAKANA LETTER TA",
	"HALFWIDTH KATAKANA LETTER TE",
	"HALFWIDTH KATAKANA LETTER TI",
	"HALFWIDTH KATAKANA LETTER TO",
	"HALFWIDTH KATAKANA LETTER TU",
	"HALFWIDTH KATAKANA LETTER U",
	"HALFWIDTH KATAKANA LETTER WA",
	"HALFWIDTH KATAKANA LETTER WO",
	"HALFWIDTH KATAKANA LETTER YA",
	"HALFWIDTH KATAKANA LETTER YO",
	"HALFWIDTH KATAKANA LETTER YU",
	"HALFWIDTH KATAKANA MIDDLE DOT",
	"HALFWIDTH KATAKANA SEMI-VOICED SOUND MARK",
	"HALFWIDTH KATAKANA VOICED SOUND MARK",
	"HALFWIDTH KATAKANA-HIRAGANA PROLONGED SOUND MARK",
	"HALFWIDTH LEFT CORNER BRACKET",
	"HALFWIDTH LEFTWARDS ARROW",
	"HALFWIDTH RIGHT CORNER BRACKET",
	"HALFWIDTH RIGHTWARDS ARROW",
	"HALFWIDTH UPWARDS ARROW",
	"HALFWIDTH WHITE CIRCLE",
	"HAMBURGER",
	"HAMMER",
	"HAMMER AND PICK",
	"HAMMER AND SICKLE",
	"HAMSTER FACE",
	"HANDBAG",
	"HANGUL CHOSEONG CEONGCHIEUMCHIEUCH",
	"HANGUL CHOSEONG CEONGCHIEUMCIEUC",
	"HANGUL CHOSEONG CEONGCHIEUMSIOS",
	"HANGUL CHOSEONG CEONGCHIEUMSSANGCIEUC",
	"HANGUL CHOSEONG CEONGCHIEUMSSANGSIOS",
	"HANGUL CHOSEONG CHIEUCH",
	"HANGUL CHOSEONG CHIEUCH-HIEUH",
	"HANGUL CHOSEONG CHIEUCH-KHIEUKH",
	"HANGUL CHOSEONG CHITUEUMCHIEUCH",
	"HANGUL CHOSEONG CHITUEUMCIEUC",
	"HANGUL CHOSEONG CHITUEUMSIOS",
	"HANGUL CHOSEONG CHITUEUMSSANGCIEUC",
	"HANGUL CHOSEONG CHITUEUMSSANGSIOS",
	"HANGUL CHOSEONG CIEUC",
	"HANGUL CHOSEONG CIEUC-IEUNG",
	"HANGUL CHOSEONG FILLER",
	"HANGUL CHOSEONG HIEUH",
	"HANGUL CHOSEONG HIEUH-SIOS",
	"HANGUL CHOSEONG IEUNG",
	"HANGUL CHOSEONG IEUNG-CHIEUCH",
	"HANGUL CHOSEONG IEUNG-CIEUC",
	"HANGUL CHOSEONG IEUNG-HIEUH",
	"HANGUL CHOSEONG IEUNG-KIYEOK",
	"HANGUL CHOSEONG IEUNG-MIEUM",
	"HANGUL CHOSEONG IEUNG-PANSIOS",
	"HANGUL CHOSEONG IEUNG-PHIEUPH",
	"HANGUL CHOSEONG IEUNG-PIEUP",
	"HANGUL CHOSEONG IEUNG-RIEUL",
	"HANGUL CHOSEONG IEUNG-SIOS",
	"HANGUL CHOSEONG IEUNG-THIEUTH",
	"HANGUL CHOSEONG IEUNG-TIKEUT",
	"HANGUL CHOSEONG KAPYEOUNMIEUM",
	"HANGUL CHOSEONG KAPYEOUNPHIEUPH",
	"HANGUL CHOSEONG KAPYEOUNPIEUP",
	"HANGUL CHOSEONG KAPYEOUNRIEUL",
	"HANGUL CHOSEONG KAPYEOUNSSANGPIEUP",
	"HANGUL CHOSEONG KHIEUKH",
	"HANGUL CHOSEONG KIYEOK",
	"HANGUL CHOSEONG KIYEOK-TIKEUT",
	"HANGUL CHOSEONG MIEUM",
	"HANGUL CHOSEONG MIEUM-KIYEOK",
	"HANGUL CHOSEONG MIEUM-PIEUP",
	"HANGUL CHOSEONG MIEUM-SIOS",
	"HANGUL CHOSEONG MIEUM-TIKEUT",
	"HANGUL CHOSEONG NIEUN",
	"HANGUL CHOSEONG NIEUN-CIEUC",
	"HANGUL CHOSEONG NIEUN-HIEUH",
	"HANGUL CHOSEONG NIEUN-KIYEOK",
	"HANGUL CHOSEONG NIEUN-PIEUP",
	"HANGUL CHOSEONG NIEUN-SIOS",
	"HANGUL CHOSEONG NIEUN-TIKEUT",
	"HANGUL CHOSEONG PANSIOS",
	"HANGUL CHOSEONG PHIEUPH",
	"HANGUL CHOSEONG PHIEUPH-HIEUH",
	"HANGUL CHOSEONG PHIEUPH-PIEUP",
	"HANGUL CHOSEONG PIEUP",
	"HANGUL CHOSEONG PIEUP-CHIEUCH",
	"HANGUL CHOSEONG PIEUP-CIEUC",
	"HANGUL CHOSEONG PIEUP-HIEUH",
	"HANGUL CHOSEONG PIEUP-KHIEUKH",
	"HANGUL CHOSEONG PIEUP-KIYEOK",
	"HANGUL CHOSEONG PIEUP-NIEUN",
	"HANGUL CHOSEONG PIEUP-PHIEUPH",
	"HANGUL CHOSEONG PIEUP-SIOS",
	"HANGUL CHOSEONG PIEUP-SIOS-CIEUC",
	"HANGUL CHOSEONG PIEUP-SIOS-KIYEOK",
	"HANGUL CHOSEONG PIEUP-SIOS-PIEUP",
	"HANGUL CHOSEONG PIEUP-SIOS-THIEUTH",
	"HANGUL CHOSEONG PIEUP-SIOS-TIKEUT",
	"HANGUL CHOSEONG PIEUP-SSANGSIOS",
	"HANGUL CHOSEONG PIEUP-THIEUTH",
	"HANGUL CHOSEONG PIEUP-TIKEUT",
	"HANGUL CHOSEONG RIEUL",
	"HANGUL CHOSEONG RIEUL-CIEUC",
	"HANGUL CHOSEONG RIEUL-HIEUH",
	"HANGUL CHOSEONG RIEUL-KAPYEOUNPIEUP",
	"HANGUL CHOSEONG RIEUL-KHIEUKH",
	"HANGUL CHOSEONG RIEUL-KIYEOK",
	"HANGUL CHOSEONG RIEUL-MIEUM",
	"HANGUL CHOSEONG RIEUL-NIEUN",
	"HANGUL CHOSEONG RIEUL-PIEUP",
	"HANGUL CHOSEONG RIEUL-SIOS",
	"HANGUL CHOSEONG RIEUL-SSANGKIYEOK",
	"HANGUL CHOSEONG RIEUL-SSANGPIEUP",
	"HANGUL CHOSEONG RIEUL-SSANGTIKEUT",
	"HANGUL CHOSEONG RIEUL-TIKEUT",
	"HANGUL CHOSEONG SIOS",
	"HANGUL CHOSEONG SIOS-CHIEUCH",
	"HANGUL CHOSEONG SIOS-CIEUC",
	"HANGUL CHOSEONG SIOS-HIEUH",
	"HANGUL CHOSEONG SIOS-IEUNG",
	"HANGUL CHOSEONG SIOS-KHIEUKH",
	"HANGUL CHOSEONG SIOS-KIYEOK",
	"HANGUL CHOSEONG SIOS-MIEUM",
	"HANGUL CHOSEONG SIOS-NIEUN",
	"HANGUL CHOSEONG SIOS-PHIEUPH",
	"HANGUL CHOSEONG SIOS-PIEUP",
	"HANGUL CHOSEONG SIOS-PIEUP-KIYEOK",
	"HANGUL CHOSEONG SIOS-RIEUL",
	"HANGUL CHOSEONG SIOS-SSANGSIOS",
	"HANGUL CHOSEONG SIOS-THIEUTH",
	"HANGUL CHOSEONG SIOS-TIKEUT",
	"HANGUL CHOSEONG SSANGCIEUC",
	"HANGUL CHOSEONG SSANGCIEUC-HIEUH",
	"HANGUL CHOSEONG SSANGHIEUH",
	"HANGUL CHOSEONG SSANGIEUNG",
	"HANGUL CHOSEONG SSANGKIYEOK",
	"HANGUL CHOSEONG SSANGNIEUN",
	"HANGUL CHOSEONG SSANGPIEUP",
	"HANGUL CHOSEONG SSANGRIEUL",
	"HANGUL CHOSEONG SSANGSIOS",
	"HANGUL CHOSEONG SSANGSIOS-PIEUP",
	"HANGUL CHOSEONG SSANGTHIEUTH",
	"HANGUL CHOSEONG SSANGTIKEUT",
	"HANGUL CHOSEONG SSANGYEORINHIEUH",
	"HANGUL CHOSEONG THIEUTH",
	"HANGUL CHOSEONG TIKEUT",
	"HANGUL CHOSEONG TIKEUT-CIEUC",
	"HANGUL CHOSEONG TIKEUT-KIYEOK",
	"HANGUL CHOSEONG TIKEUT-MIEUM",
	"HANGUL CHOSEONG TIKEUT-PIEUP",
	"HANGUL CHOSEONG TIKEUT-RIEUL",
	"HANGUL CHOSEONG TIKEUT-SIOS",
	"HANGUL CHOSEONG YEORINHIEUH",
	"HANGUL CHOSEONG YESIEUNG",
	"HANGUL DOUBLE DOT TONE MARK",
	"HANGUL FILLER",
	"HANGUL JONGSEONG CHIEUCH",
	"HANGUL JONGSEONG CIEUC",
	"HANGUL JONGSEONG CIEUC-PIEUP",
	"HANGUL JONGSEONG CIEUC-SSANGPIEUP",
	"HANGUL JONGSEONG HIEUH",
	"HANGUL JONGSEONG HIEUH-MIEUM",
	"HANGUL JONGSEONG HIEUH-NIEUN",
	"HANGUL JONGSEONG HIEUH-PIEUP",
	"HANGUL JONGSEONG HIEUH-RIEUL",
	"HANGUL JONGSEONG IEUNG",
	"HANGUL JONGSEONG IEUNG-KHIEUKH",
	"HANGUL JONGSEONG IEUNG-KIYEOK",
	"HANGUL JONGSEONG IEUNG-SSANGKIYEOK",
	"HANGUL JONGSEONG KAPYEOUNMIEUM",
	"HANGUL JONGSEONG KAPYEOUNPHIEUPH",
	"HANGUL JONGSEONG KAPYEOUNPIEUP",
	"HANGUL JONGSEONG KAPYEOUNRIEUL",
	"HANGUL JONGSEONG KHIEUKH",
	"HANGUL JONGSEONG KIYEOK",
	"HANGUL JONGSEONG KIYEOK-CHIEUCH",
	"HANGUL JONGSEONG KIYEOK-HIEUH",
	"HANGUL JONGSEONG KIYEOK-KHIEUKH",
	"HANGUL JONGSEONG KIYEOK-NIEUN",
	"HANGUL JONGSEONG KIYEOK-PIEUP",
	"HANGUL JONGSEONG KIYEOK-RIEUL",
	"HANGUL JONGSEONG KIYEOK-SIOS",
	"HANGUL JONGSEONG KIYEOK-SIOS-KIYEOK",
	"HANGUL JONGSEONG MIEUM",
	"HANGUL JONGSEONG MIEUM-CHIEUCH",
	"HANGUL JONGSEONG MIEUM-CIEUC",
	"HANGUL JONGSEONG MIEUM-HIEUH",
	"HANGUL JONGSEONG MIEUM-KIYEOK",
	"HANGUL JONGSEONG MIEUM-NIEUN",
	"HANGUL JONGSEONG MIEUM-PANSIOS",
	"HANGUL JONGSEONG MIEUM-PIEUP",
	"HANGUL JONGSEONG MIEUM-PIEUP-SIOS",
	"HANGUL JONGSEONG MIEUM-RIEUL",
	"HANGUL JONGSEONG MIEUM-SIOS",
	"HANGUL JONGSEONG MIEUM-SSANGNIEUN",
	"HANGUL JONGSEONG MIEUM-SSANGSIOS",
	"HANGUL JONGSEONG NIEUN",
	"HANGUL JONGSEONG NIEUN-CHIEUCH",
	"HANGUL JONGSEONG NIEUN-CIEUC",
	"HANGUL JONGSEONG NIEUN-HIEUH",
	"HANGUL JONGSEONG NIEUN-KIYEOK",
	"HANGUL JONGSEONG NIEUN-PANSIOS",
	"HANGUL JONGSEONG NIEUN-RIEUL",
	"HANGUL JONGSEONG NIEUN-SIOS",
	"HANGUL JONGSEONG NIEUN-THIEUTH",
	"HANGUL JONGSEONG NIEUN-TIKEUT",
	"HANGUL JONGSEONG PANSIOS",
	"HANGUL JONGSEONG PANSIOS-KAPYEOUNPIEUP",
	"HANGUL JONGSEONG PANSIOS-PIEUP",
	"HANGUL JONGSEONG PHIEUPH",
	"HANGUL JONGSEONG PHIEUPH-PIEUP",
	"HANGUL JONGSEONG PHIEUPH-SIOS",
	"HANGUL JONGSEONG PHIEUPH-THIEUTH",
	"HANGUL JONGSEONG PIEUP",
	"HANGUL JONGSEONG PIEUP-CHIEUCH",
	"HANGUL JONGSEONG PIEUP-CIEUC",
	"HANGUL JONGSEONG PIEUP-HIEUH",
	"HANGUL JONGSEONG PIEUP-MIEUM",
	"HANGUL JONGSEONG PIEUP-PHIEUPH",
	"HANGUL JONGSEONG PIEUP-RIEUL",
	"HANGUL JONGSEONG PIEUP-RIEUL-PHIEUPH",
	"HANGUL JONGSEONG PIEUP-SIOS",
	"HANGUL JONGSEONG PIEUP-SIOS-TIKEUT",
	"HANGUL JONGSEONG PIEUP-TIKEUT",
	"HANGUL JONGSEONG RIEUL",
	"HANGUL JONGSEONG RIEUL-HIEUH",
	"HANGUL JONGSEONG RIEUL-KAPYEOUNPIEUP",
	"HANGUL JONGSEONG RIEUL-KHIEUKH",
	"HANGUL JONGSEONG RIEUL-KIYEOK",
	"HANGUL JONGSEONG RIEUL-KIYEOK-HIEUH",
	"HANGUL JONGSEONG RIEUL-KIYEOK-SIOS",
	"HANGUL JONGSEONG RIEUL-MIEUM",
	"HANGUL JONGSEONG RIEUL-MIEUM-HIEUH",
	"HANGUL JONGSEONG RIEUL-MIEUM-KIYEOK",
	"HANGUL JONGSEONG RIEUL-MIEUM-SIOS",
	"HANGUL JONGSEONG RIEUL-NIEUN",
	"HANGUL JONGSEONG RIEUL-PANSIOS",
	"HANGUL JONGSEONG RIEUL-PHIEUPH",
	"HANGUL JONGSEONG RIEUL-PIEUP",
	"HANGUL JONGSEONG RIEUL-PIEUP-HIEUH",
	"HANGUL JONGSEONG RIEUL-PIEUP-PHIEUPH",
	"HANGUL JONGSEONG RIEUL-PIEUP-SIOS",
	"HANGUL JONGSEONG RIEUL-PIEUP-TIKEUT",
	"HANGUL JONGSEONG RIEUL-SIOS",
	"HANGUL JONGSEONG RIEUL-SSANGKIYEOK",
	"HANGUL JONGSEONG RIEUL-SSANGSIOS",
	"HANGUL JONGSEONG RIEUL-THIEUTH",
	"HANGUL JONGSEONG RIEUL-TIKEUT",
	"HANGUL JONGSEONG RIEUL-TIKEUT-HIEUH",
	"HANGUL JONGSEONG RIEUL-YEORINHIEUH",
	"HANGUL JONGSEONG RIEUL-YEORINHIEUH-HIEUH",
	"HANGUL JONGSEONG RIEUL-YESIEUNG",
	"HANGUL JONGSEONG SIOS",
	"HANGUL JONGSEONG SIOS-CHIEUCH",
	"HANGUL JONGSEONG SIOS-CIEUC",
	"HANGUL JONGSEONG SIOS-HIEUH",
	"HANGUL JONGSEONG SIOS-KAPYEOUNPIEUP",
	"HANGUL JONGSEONG SIOS-KIYEOK",
	"HANGUL JONGSEONG SIOS-MIEUM",
	"HANGUL JONGSEONG SIOS-PANSIOS",
	"HANGUL JONGSEONG SIOS-PIEUP",
	"HANGUL JONGSEONG SIOS-RIEUL",
	"HANGUL JONGSEONG SIOS-THIEUTH",
	"HANGUL JONGSEONG SIOS-TIKEUT",
	"HANGUL JONGSEONG SSANGCIEUC",
	"HANGUL JONGSEONG SSANGIEUNG",
	"HANGUL JONGSEONG SSANGKIYEOK",
	"HANGUL JONGSEONG SSANGMIEUM",
	"HANGUL JONGSEONG SSANGNIEUN",
	"HANGUL JONGSEONG SSANGPIEUP",
	"HANGUL JONGSEONG SSANGRIEUL",
	"HANGUL JONGSEONG SSANGRIEUL-KHIEUKH",
	"HANGUL JONGSEONG SSANGSIOS",
	"HANGUL JONGSEONG SSANGSIOS-KIYEOK",
	"HANGUL JONGSEONG SSANGSIOS-TIKEUT",
	"HANGUL JONGSEONG SSANGTIKEUT",
	"HANGUL JONGSEONG SSANGTIKEUT-PIEUP",
	"HANGUL JONGSEONG THIEUTH",
	"HANGUL JONGSEONG TIKEUT",
	"HANGUL JONGSEONG TIKEUT-CHIEUCH",
	"HANGUL JONGSEONG TIKEUT-CIEUC",
	"HANGUL JONGSEONG TIKEUT-KIYEOK",
	"HANGUL JONGSEONG TIKEUT-PIEUP",
	"HANGUL JONGSEONG TIKEUT-RIEUL",
	"HANGUL JONGSEONG TIKEUT-SIOS",
	"HANGUL JONGSEONG TIKEUT-SIOS-KIYEOK",
	"HANGUL JONGSEONG TIKEUT-THIEUTH",
	"HANGUL JONGSEONG YEORINHIEUH",
	"HANGUL JONGSEONG YESIEUNG",
	"HANGUL JONGSEONG YESIEUNG-HIEUH",
	"HANGUL JONGSEONG YESIEUNG-MIEUM",
	"HANGUL JONGSEONG YESIEUNG-PANSIOS",
	"HANGUL JONGSEONG YESIEUNG-SIOS",
	"HANGUL JUNGSEONG A",
	"HANGUL JUNGSEONG A-EU",
	"HANGUL JUNGSEONG A-O",
	"HANGUL JUNGSEONG A-U",
	"HANGUL JUNGSEONG AE",
	"HANGUL JUNGSEONG ARAEA",
	"HANGUL JUNGSEONG ARAEA-A",
	"HANGUL JUNGSEONG ARAEA-E",
	"HANGUL JUNGSEONG ARAEA-EO",
	"HANGUL JUNGSEONG ARAEA-I",
	"HANGUL JUNGSEONG ARAEA-U",
	"HANGUL JUNGSEONG E",
	"HANGUL JUNGSEONG EO",
	"HANGUL JUNGSEONG EO-EU",
	"HANGUL JUNGSEONG EO-O",
	"HANGUL JUNGSEONG EO-U",
	"HANGUL JUNGSEONG EU",
	"HANGUL JUNGSEONG EU-A",
	"HANGUL JUNGSEONG EU-E",
	"HANGUL JUNGSEONG EU-EO",
	"HANGUL JUNGSEONG EU-EU",
	"HANGUL JUNGSEONG EU-O",
	"HANGUL JUNGSEONG EU-U",
	"HANGUL JUNGSEONG FILLER",
	"HANGUL JUNGSEONG I",
	"HANGUL JUNGSEONG I-A",
	"HANGUL JUNGSEONG I-ARAEA",
	"HANGUL JUNGSEONG I-EU",
	"HANGUL JUNGSEONG I-I",
	"HANGUL JUNGSEONG I-O",
	"HANGUL JUNGSEONG I-O-I",
	"HANGUL JUNGSEONG I-U",
	"HANGUL JUNGSEONG I-YA",
	"HANGUL JUNGSEONG I-YA-O",
	"HANGUL JUNGSEONG I-YAE",
	"HANGUL JUNGSEONG I-YE",
	"HANGUL JUNGSEONG I-YEO",
	"HANGUL JUNGSEONG I-YO",
	"HANGUL JUNGSEONG I-YU",
	"HANGUL JUNGSEONG O",
	"HANGUL JUNGSEONG O-E",
	"HANGUL JUNGSEONG O-EO",
	"HANGUL JUNGSEONG O-O",
	"HANGUL JUNGSEONG O-O-I",
	"HANGUL JUNGSEONG O-U",
	"HANGUL JUNGSEONG O-YA",
	"HANGUL JUNGSEONG O-YAE",
	"HANGUL JUNGSEONG O-YE",
	"HANGUL JUNGSEONG O-YEO",
	"HANGUL JUNGSEONG OE",
	"HANGUL JUNGSEONG SSANGARAEA",
	"HANGUL JUNGSEONG U",
	"HANGUL JUNGSEONG U-A",
	"HANGUL JUNGSEONG U-AE",
	"HANGUL JUNGSEONG U-EO-EU",
	"HANGUL JUNGSEONG U-I-I",
	"HANGUL JUNGSEONG U-U",
	"HANGUL JUNGSEONG U-YE",
	"HANGUL JUNGSEONG U-YEO",
	"HANGUL JUNGSEONG WA",
	"HANGUL JUNGSEONG WAE",
	"HANGUL JUNGSEONG WE",
	"HANGUL JUNGSEONG WEO",
	"HANGUL JUNGSEONG WI",
	"HANGUL JUNGSEONG YA",
	"HANGUL JUNGSEONG YA-O",
	"HANGUL JUNGSEONG YA-U",
	"HANGUL JUNGSEONG YA-YO",
	"HANGUL JUNGSEONG YAE",
	"HANGUL JUNGSEONG YE",
	"HANGUL JUNGSEONG YEO",
	"HANGUL JUNGSEONG YEO-O",
	"HANGUL JUNGSEONG YEO-U",
	"HANGUL JUNGSEONG YEO-YA",
	"HANGUL JUNGSEONG YI",
	"HANGUL JUNGSEONG YI-U",
	"HANGUL JUNGSEONG YO",
	"HANGUL JUNGSEONG YO-A",
	"HANGUL JUNGSEONG YO-AE",
	"HANGUL JUNGSEONG YO-EO",
	"HANGUL JUNGSEONG YO-I",
	"HANGUL JUNGSEONG YO-O",
	"HANGUL JUNGSEONG YO-YA",
	"HANGUL JUNGSEONG YO-YAE",
	"HANGUL JUNGSEONG YO-YEO",
	"HANGUL JUNGSEONG YU",
	"HANGUL JUNGSEONG YU-A",
	"HANGUL JUNGSEONG YU-AE",
	"HANGUL JUNGSEONG YU-E",
	"HANGUL JUNGSEONG YU-EO",
	"HANGUL JUNGSEONG YU-I",
	"HANGUL JUNGSEONG YU-O",
	"HANGUL JUNGSEONG YU-U",
	"HANGUL JUNGSEONG YU-YE",
	"HANGUL JUNGSEONG YU-YEO",
	"HANGUL LETTER A",
	"HANGUL LETTER AE",
	"HANGUL LETTER ARAEA",
	"HANGUL LETTER ARAEAE",
	"HANGUL LETTER CHIEUCH",
	"HANGUL LETTER CIEUC",
	"HANGUL LETTER E",
	"HANGUL LETTER EO",
	"HANGUL LETTER EU",
	"HANGUL LETTER HIEUH",
	"HANGUL LETTER I",
	"HANGUL LETTER IEUNG",
	"HANGUL LETTER KAPYEOUNMIEUM",
	"HANGUL LETTER KAPYEOUNPHIEUPH",
	"HANGUL LETTER KAPYEOUNPIEUP",
	"HANGUL LETTER KAPYEOUNSSANGPIEUP",
	"HANGUL LETTER KHIEUKH",
	"HANGUL LETTER KIYEOK",
	"HANGUL LETTER KIYEOK-SIOS",
	"HANGUL LETTER MIEUM",
	"HANGUL LETTER MIEUM-PANSIOS",
	"HANGUL LETTER MIEUM-PIEUP",
	"HANGUL LETTER MIEUM-SIOS",
	"HANGUL LETTER NIEUN",
	"HANGUL LETTER NIEUN-CIEUC",
	"HANGUL LETTER NIEUN-HIEUH",
	"HANGUL LETTER NIEUN-PANSIOS",
	"HANGUL LETTER NIEUN-SIOS",
	"HANGUL LETTER NIEUN-TIKEUT",
	"HANGUL LETTER O",
	"HANGUL LETTER OE",
	"HANGUL LETTER PANSIOS",
	"HANGUL LETTER PHIEUPH",
	"HANGUL LETTER PIEUP",
	"HANGUL LETTER PIEUP-CIEUC",
	"HANGUL LETTER PIEUP-KIYEOK",
	"HANGUL LETTER PIEUP-SIOS",
	"HANGUL LETTER PIEUP-SIOS-KIYEOK",
	"HANGUL LETTER PIEUP-SIOS-TIKEUT",
	"HANGUL LETTER PIEUP-THIEUTH",
	"HANGUL LETTER PIEUP-TIKEUT",
	"HANGUL LETTER RIEUL",
	"HANGUL LETTER RIEUL-HIEUH",
	"HANGUL LETTER RIEUL-KIYEOK",
	"HANGUL LETTER RIEUL-KIYEOK-SIOS",
	"HANGUL LETTER RIEUL-MIEUM",
	"HANGUL LETTER RIEUL-PANSIOS",
	"HANGUL LETTER RIEUL-PHIEUPH",
	"HANGUL LETTER RIEUL-PIEUP",
	"HANGUL LETTER RIEUL-PIEUP-SIOS",
	"HANGUL LETTER RIEUL-SIOS",
	"HANGUL LETTER RIEUL-THIEUTH",
	"HANGUL LETTER RIEUL-TIKEUT",
	"HANGUL LETTER RIEUL-YEORINHIEUH",
	"HANGUL LETTER SIOS",
	"HANGUL LETTER SIOS-CIEUC",
	"HANGUL LETTER SIOS-KIYEOK",
	"HANGUL LETTER SIOS-NIEUN",
	"HANGUL LETTER SIOS-PIEUP",
	"HANGUL LETTER SIOS-TIKEUT",
	"HANGUL LETTER SSANGCIEUC",
	"HANGUL LETTER SSANGHIEUH",
	"HANGUL LETTER SSANGIEUNG",
	"HANGUL LETTER SSANGKIYEOK",
	"HANGUL LETTER SSANGNIEUN",
	"HANGUL LETTER SSANGPIEUP",
	"HANGUL LETTER SSANGSIOS",
	"HANGUL LETTER SSANGTIKEUT",
	"HANGUL LETTER THIEUTH",
	"HANGUL LETTER TIKEUT",
	"HANGUL LETTER U",
	"HANGUL LETTER WA",
	"HANGUL LETTER WAE",
	"HANGUL LETTER WE",
	"HANGUL LETTER WEO",
	"HANGUL LETTER WI",
	"HANGUL LETTER YA",
	"HANGUL LETTER YAE",
	"HANGUL LETTER YE",
	"HANGUL LETTER YEO",
	"HANGUL LETTER YEORINHIEUH",
	"HANGUL LETTER YESIEUNG",
	"HANGUL LETTER YESIEUNG-PANSIOS",
	"HANGUL LETTER YESIEUNG-SIOS",
	"HANGUL LETTER YI",
	"HANGUL LETTER YO",
	"HANGUL LETTER YO-I",
	"HANGUL LETTER YO-YA",
	"HANGUL LETTER YO-YAE",
	"HANGUL LETTER YU",
	"HANGUL LETTER YU-I",
	"HANGUL LETTER YU-YE",
	"HANGUL LETTER YU-YEO",
	"HANGUL SINGLE DOT TONE MARK",
	"HANGZHOU NUMERAL EIGHT",
	"HANGZHOU NUMERAL FIVE",
	"HANGZHOU NUMERAL FOUR",
	"HANGZHOU NUMERAL NINE",
	"HANGZHOU NUMERAL ONE",
	"HANGZHOU NUMERAL SEVEN",
	"HANGZHOU NUMERAL SIX",
	"HANGZHOU NUMERAL TEN",
	"HANGZHOU NUMERAL THIRTY",
	"HANGZHOU NUMERAL THREE",
	"HANGZHOU NUMERAL TWENTY",
	"HANGZHOU NUMERAL TWO",
	"HANUNOO LETTER A",
	"HANUNOO LETTER BA",
	"HANUNOO LETTER DA",
	"HANUNOO LETTER GA",
	"HANUNOO LETTER HA",
	"HANUNOO LETTER I",
	"HANUNOO LETTER KA",
	"HANUNOO LETTER LA",
	"HANUNOO LETTER MA",
	"HANUNOO LETTER NA",
	"HANUNOO LETTER NGA",
	"HANUNOO LETTER PA",
	"HANUNOO LETTER RA",
	"HANUNOO LETTER SA",
	"HANUNOO LETTER TA",
	"HANUNOO LETTER U",
	"HANUNOO LETTER WA",
	"HANUNOO LETTER YA",
	"HANUNOO SIGN PAMUDPOD",
	"HANUNOO VOWEL SIGN I",
	"HANUNOO VOWEL SIGN U",
	"HAPPY PERSON RAISING ONE HAND",
	"HATCHING CHICK",
	"HEADPHONE",
	"HEADSTONE GRAVEYARD SYMBOL",
	"HEAR-NO-EVIL MONKEY",
	"HEART DECORATION",
	"HEART WITH ARROW",
	"HEART WITH RIBBON",
	"HEAVY ASTERISK",
	"HEAVY BALLOT X",
	"HEAVY BLACK CURVED DOWNWARDS AND RIGHTWARDS ARROW",
	"HEAVY BLACK CURVED UPWARDS AND RIGHTWARDS ARROW",
	"HEAVY BLACK HEART",
	"HEAVY BLACK-FEATHERED NORTH EAST ARROW",
	"HEAVY BLACK-FEATHERED RIGHTWARDS ARROW",
	"HEAVY BLACK-FEATHERED SOUTH EAST ARROW",
	"HEAVY CHECK MARK",
	"HEAVY CHEVRON SNOWFLAKE",
	"HEAVY CIRCLE",
	"HEAVY CIRCLE WITH CIRCLE INSIDE",
	"HEAVY CIRCLE WITH STROKE AND TWO DOTS ABOVE",
	"HEAVY CIRCLED SALTIRE",
	"HEAVY CONCAVE-POINTED BLACK RIGHTWARDS ARROW",
	"HEAVY DASHED TRIANGLE-HEADED RIGHTWARDS ARROW",
	"HEAVY DIVISION SIGN",
	"HEAVY DOLLAR SIGN",
	"HEAVY DOUBLE COMMA QUOTATION MARK ORNAMENT",
	"HEAVY DOUBLE TURNED COMMA QUOTATION MARK ORNAMENT",
	"HEAVY EIGHT POINTED RECTILINEAR BLACK STAR",
	"HEAVY EIGHT TEARDROP-SPOKED PROPELLER ASTERISK",
	"HEAVY EXCLAMATION MARK ORNAMENT",
	"HEAVY EXCLAMATION MARK SYMBOL",
	"HEAVY FOUR BALLOON-SPOKED ASTERISK",
	"HEAVY GREEK CROSS",
	"HEAVY HEART EXCLAMATION MARK ORNAMENT",
	"HEAVY LARGE CIRCLE",
	"HEAVY LEFT-POINTING ANGLE BRACKET ORNAMENT",
	"HEAVY LEFT-POINTING ANGLE QUOTATION MARK ORNAMENT",
	"HEAVY LOW DOUBLE COMMA QUOTATION MARK ORNAMENT",
	"HEAVY LOW SINGLE COMMA QUOTATION MARK ORNAMENT",
	"HEAVY LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW",
	"HEAVY MINUS SIGN",
	"HEAVY MULTIPLICATION X",
	"HEAVY NORTH EAST ARROW",
	"HEAVY OPEN CENTRE CROSS",
	"HEAVY OUTLINED BLACK STAR",
	"HEAVY OVAL WITH OVAL INSIDE",
	"HEAVY PLUS SIGN",
	"HEAVY RIGHT-POINTING ANGLE BRACKET ORNAMENT",
	"HEAVY RIGHT-POINTING ANGLE QUOTATION MARK ORNAMENT",
	"HEAVY RIGHTWARDS ARROW",
	"HEAVY ROUND-TIPPED RIGHTWARDS ARROW",
	"HEAVY SINGLE COMMA QUOTATION MARK ORNAMENT",
	"HEAVY SINGLE TURNED COMMA QUOTATION MARK ORNAMENT",
	"HEAVY SOUTH EAST ARROW",
	"HEAVY SPARKLE",
	"HEAVY TEARDROP-SHANKED RIGHTWARDS ARROW",
	"HEAVY TEARDROP-SPOKED ASTERISK",
	"HEAVY TEARDROP-SPOKED PINWHEEL ASTERISK",
	"HEAVY TRIANGLE-HEADED RIGHTWARDS ARROW",
	"HEAVY UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW",
	"HEAVY VERTICAL BAR",
	"HEAVY WEDGE-TAILED RIGHTWARDS ARROW",
	"HEAVY WHITE DOWN-POINTING TRIANGLE",
	"HEAVY WIDE-HEADED RIGHTWARDS ARROW",
	"HEBREW ACCENT ATNAH HAFUKH",
	"HEBREW ACCENT DARGA",
	"HEBREW ACCENT DEHI",
	"HEBREW ACCENT ETNAHTA",
	"HEBREW ACCENT GERESH",
	"HEBREW ACCENT GERESH MUQDAM",
	"HEBREW ACCENT GERSHAYIM",
	"HEBREW ACCENT ILUY",
	"HEBREW ACCENT MAHAPAKH",
	"HEBREW ACCENT MERKHA",
	"HEBREW ACCENT MERKHA KEFULA",
	"HEBREW ACCENT MUNAH",
	"HEBREW ACCENT OLE",
	"HEBREW ACCENT PASHTA",
	"HEBREW ACCENT PAZER",
	"HEBREW ACCENT QADMA",
	"HEBREW ACCENT QARNEY PARA",
	"HEBREW ACCENT REVIA",
	"HEBREW ACCENT SEGOL",
	"HEBREW ACCENT SHALSHELET",
	"HEBREW ACCENT TELISHA GEDOLA",
	"HEBREW ACCENT TELISHA QETANA",
	"HEBREW ACCENT TEVIR",
	"HEBREW ACCENT TIPEHA",
	"HEBREW ACCENT YERAH BEN YOMO",
	"HEBREW ACCENT YETIV",
	"HEBREW ACCENT ZAQEF GADOL",
	"HEBREW ACCENT ZAQEF QATAN",
	"HEBREW ACCENT ZARQA",
	"HEBREW ACCENT ZINOR",
	"HEBREW LETTER ALEF",
	"HEBREW LETTER ALEF WITH MAPIQ",
	"HEBREW LETTER ALEF WITH PATAH",
	"HEBREW LETTER ALEF WITH QAMATS",
	"HEBREW LETTER ALTERNATIVE AYIN",
	"HEBREW LETTER ALTERNATIVE PLUS SIGN",
	"HEBREW LETTER AYIN",
	"HEBREW LETTER BET",
	"HEBREW LETTER BET WITH DAGESH",
	"HEBREW LETTER BET WITH RAFE",
	"HEBREW LETTER DALET",
	"HEBREW LETTER DALET WITH DAGESH",
	"HEBREW LETTER FINAL KAF",
	"HEBREW LETTER FINAL KAF WITH DAGESH",
	"HEBREW LETTER FINAL MEM",
	"HEBREW LETTER FINAL NUN",
	"HEBREW LETTER FINAL PE",
	"HEBREW LETTER FINAL PE WITH DAGESH",
	"HEBREW LETTER FINAL TSADI",
	"HEBREW LETTER GIMEL",
	"HEBREW LETTER GIMEL WITH DAGESH",
	"HEBREW LETTER HE",
	"HEBREW LETTER HE WITH MAPIQ",
	"HEBREW LETTER HET",
	"HEBREW LETTER KAF",
	"HEBREW LETTER KAF WITH DAGESH",
	"HEBREW LETTER KAF WITH RAFE",
	"HEBREW LETTER LAMED",
	"HEBREW LETTER LAMED WITH DAGESH",
	"HEBREW LETTER MEM",
	"HEBREW LETTER MEM WITH DAGESH",
	"HEBREW LETTER NUN",
	"HEBREW LETTER NUN WITH DAGESH",
	"HEBREW LETTER PE",
	"HEBREW LETTER PE WITH DAGESH",
	"HEBREW LETTER PE WITH RAFE",
	"HEBREW LETTER QOF",
	"HEBREW LETTER QOF WITH DAGESH",
	"HEBREW LETTER RESH",
	"HEBREW LETTER RESH WITH DAGESH",
	"HEBREW LETTER SAMEKH",
	"HEBREW LETTER SAMEKH WITH DAGESH",
	"HEBREW LETTER SHIN",
	"HEBREW LETTER SHIN WITH DAGESH",
	"HEBREW LETTER SHIN WITH DAGESH AND SHIN DOT",
	"HEBREW LETTER SHIN WITH DAGESH AND SIN DOT",
	"HEBREW LETTER SHIN WITH SHIN DOT",
	"HEBREW LETTER SHIN WITH SIN DOT",
	"HEBREW LETTER TAV",
	"HEBREW LETTER TAV WITH DAGESH",
	"HEBREW LETTER TET",
	"HEBREW LETTER TET WITH DAGESH",
	"HEBREW LETTER TSADI",
	"HEBREW LETTER TSADI WITH DAGESH",
	"HEBREW LETTER VAV",
	"HEBREW LETTER VAV WITH DAGESH",
	"HEBREW LETTER VAV WITH HOLAM",
	"HEBREW LETTER WIDE ALEF",
	"HEBREW LETTER WIDE DALET",
	"HEBREW LETTER WIDE FINAL MEM",
	"HEBREW LETTER WIDE HE",
	"HEBREW LETTER WIDE KAF",
	"HEBREW LETTER WIDE LAMED",
	"HEBREW LETTER WIDE RESH",
	"HEBREW LETTER WIDE TAV",
	"HEBREW LETTER YOD",
	"HEBREW LETTER YOD WITH DAGESH",
	"HEBREW LETTER YOD WITH HIRIQ",
	"HEBREW LETTER ZAYIN",
	"HEBREW LETTER ZAYIN WITH DAGESH",
	"HEBREW LIGATURE ALEF LAMED",
	"HEBREW LIGATURE YIDDISH DOUBLE VAV",
	"HEBREW LIGATURE YIDDISH DOUBLE YOD",
	"HEBREW LIGATURE YIDDISH VAV YOD",
	"HEBREW LIGATURE YIDDISH YOD YOD PATAH",
	"HEBREW MARK LOWER DOT",
	"HEBREW MARK MASORA CIRCLE",
	"HEBREW MARK UPPER DOT",
	"HEBREW POINT DAGESH OR MAPIQ",
	"HEBREW POINT HATAF PATAH",
	"HEBREW POINT HATAF QAMATS",
	"HEBREW POINT HATAF SEGOL",
	"HEBREW POINT HIRIQ",
	"HEBREW POINT HOLAM",
	"HEBREW POINT HOLAM HASER FOR VAV",
	"HEBREW POINT JUDEO-SPANISH VARIKA",
	"HEBREW POINT METEG",
	"HEBREW POINT PATAH",
	"HEBREW POINT QAMATS",
	"HEBREW POINT QAMATS QATAN",
	"HEBREW POINT QUBUTS",
	"HEBREW POINT RAFE",
	"HEBREW POINT SEGOL",
	"HEBREW POINT SHEVA",
	"HEBREW POINT SHIN DOT",
	"HEBREW POINT SIN DOT",
	"HEBREW POINT TSERE",
	"HEBREW PUNCTUATION GERESH",
	"HEBREW PUNCTUATION GERSHAYIM",
	"HEBREW PUNCTUATION MAQAF",
	"HEBREW PUNCTUATION NUN HAFUKHA",
	"HEBREW PUNCTUATION PASEQ",
	"HEBREW PUNCTUATION SOF PASUQ",
	"HELICOPTER",
	"HELM SYMBOL",
	"HELMET WITH WHITE CROSS",
	"HERB",
	"HERMITIAN CONJUGATE MATRIX",
	"HEXAGRAM FOR ABUNDANCE",
	"HEXAGRAM FOR AFTER COMPLETION",
	"HEXAGRAM FOR APPROACH",
	"HEXAGRAM FOR BEFORE COMPLETION",
	"HEXAGRAM FOR BITING THROUGH",
	"HEXAGRAM FOR BREAKTHROUGH",
	"HEXAGRAM FOR COMING TO MEET",
	"HEXAGRAM FOR CONFLICT",
	"HEXAGRAM FOR CONTEMPLATION",
	"HEXAGRAM FOR DARKENING OF THE LIGHT",
	"HEXAGRAM FOR DECREASE",
	"HEXAGRAM FOR DELIVERANCE",
	"HEXAGRAM FOR DEVELOPMENT",
	"HEXAGRAM FOR DIFFICULTY AT THE BEGINNING",
	"HEXAGRAM FOR DISPERSION",
	"HEXAGRAM FOR DURATION",
	"HEXAGRAM FOR ENTHUSIASM",
	"HEXAGRAM FOR FELLOWSHIP",
	"HEXAGRAM FOR FOLLOWING",
	"HEXAGRAM FOR GATHERING TOGETHER",
	"HEXAGRAM FOR GRACE",
	"HEXAGRAM FOR GREAT POSSESSION",
	"HEXAGRAM FOR GREAT POWER",
	"HEXAGRAM FOR GREAT PREPONDERANCE",
	"HEXAGRAM FOR GREAT TAMING",
	"HEXAGRAM FOR HOLDING TOGETHER",
	"HEXAGRAM FOR INCREASE",
	"HEXAGRAM FOR INFLUENCE",
	"HEXAGRAM FOR INNER TRUTH",
	"HEXAGRAM FOR INNOCENCE",
	"HEXAGRAM FOR LIMITATION",
	"HEXAGRAM FOR MODESTY",
	"HEXAGRAM FOR MOUTH CORNERS",
	"HEXAGRAM FOR OBSTRUCTION",
	"HEXAGRAM FOR OPPOSITION",
	"HEXAGRAM FOR OPPRESSION",
	"HEXAGRAM FOR PEACE",
	"HEXAGRAM FOR PROGRESS",
	"HEXAGRAM FOR PUSHING UPWARD",
	"HEXAGRAM FOR RETREAT",
	"HEXAGRAM FOR RETURN",
	"HEXAGRAM FOR REVOLUTION",
	"HEXAGRAM FOR SMALL PREPONDERANCE",
	"HEXAGRAM FOR SMALL TAMING",
	"HEXAGRAM FOR SPLITTING APART",
	"HEXAGRAM FOR STANDSTILL",
	"HEXAGRAM FOR THE ABYSMAL WATER",
	"HEXAGRAM FOR THE ARMY",
	"HEXAGRAM FOR THE AROUSING THUNDER",
	"HEXAGRAM FOR THE CAULDRON",
	"HEXAGRAM FOR THE CLINGING FIRE",
	"HEXAGRAM FOR THE CREATIVE HEAVEN",
	"HEXAGRAM FOR THE FAMILY",
	"HEXAGRAM FOR THE GENTLE WIND",
	"HEXAGRAM FOR THE JOYOUS LAKE",
	"HEXAGRAM FOR THE KEEPING STILL MOUNTAIN",
	"HEXAGRAM FOR THE MARRYING MAIDEN",
	"HEXAGRAM FOR THE RECEPTIVE EARTH",
	"HEXAGRAM FOR THE WANDERER",
	"HEXAGRAM FOR THE WELL",
	"HEXAGRAM FOR TREADING",
	"HEXAGRAM FOR WAITING",
	"HEXAGRAM FOR WORK ON THE DECAYED",
	"HEXAGRAM FOR YOUTHFUL FOLLY",
	"HIBISCUS",
	"HIGH BRIGHTNESS SYMBOL",
	"HIGH VOLTAGE SIGN",
	"HIGH-HEELED SHOE",
	"HIGH-SPEED TRAIN",
	"HIGH-SPEED TRAIN WITH BULLET NOSE",
	"HIRAGANA DIGRAPH YORI",
	"HIRAGANA ITERATION MARK",
	"HIRAGANA LETTER A",
	"HIRAGANA LETTER ARCHAIC YE",
	"HIRAGANA LETTER BA",
	"HIRAGANA LETTER BE",
	"HIRAGANA LETTER BI",
	"HIRAGANA LETTER BO",
	"HIRAGANA LETTER BU",
	"HIRAGANA LETTER DA",
	"HIRAGANA LETTER DE",
	"HIRAGANA LETTER DI",
	"HIRAGANA LETTER DO",
	"HIRAGANA LETTER DU",
	"HIRAGANA LETTER E",
	"HIRAGANA LETTER GA",
	"HIRAGANA LETTER GE",
	"HIRAGANA LETTER GI",
	"HIRAGANA LETTER GO",
	"HIRAGANA LETTER GU",
	"HIRAGANA LETTER HA",
	"HIRAGANA LETTER HE",
	"HIRAGANA LETTER HI",
	"HIRAGANA LETTER HO",
	"HIRAGANA LETTER HU",
	"HIRAGANA LETTER I",
	"HIRAGANA LETTER KA",
	"HIRAGANA LETTER KE",
	"HIRAGANA LETTER KI",
	"HIRAGANA LETTER KO",
	"HIRAGANA LETTER KU",
	"HIRAGANA LETTER MA",
	"HIRAGANA LETTER ME",
	"HIRAGANA LETTER MI",
	"HIRAGANA LETTER MO",
	"HIRAGANA LETTER MU",
	"HIRAGANA LETTER N",
	"HIRAGANA LETTER NA",
	"HIRAGANA LETTER NE",
	"HIRAGANA LETTER NI",
	"HIRAGANA LETTER NO",
	"HIRAGANA LETTER NU",
	"HIRAGANA LETTER O",
	"HIRAGANA LETTER PA",
	"HIRAGANA LETTER PE",
	"HIRAGANA LETTER PI",
	"HIRAGANA LETTER PO",
	"HIRAGANA LETTER PU",
	"HIRAGANA LETTER RA",
	"HIRAGANA LETTER RE",
	"HIRAGANA LETTER RI",
	"HIRAGANA LETTER RO",
	"HIRAGANA LETTER RU",
	"HIRAGANA LETTER SA",
	"HIRAGANA LETTER SE",
	"HIRAGANA LETTER SI",
	"HIRAGANA LETTER SMALL A",
	"HIRAGANA LETTER SMALL E",
	"HIRAGANA LETTER SMALL I",
	"HIRAGANA LETTER SMALL KA",
	"HIRAGANA LETTER SMALL KE",
	"HIRAGANA LETTER SMALL O",
	"HIRAGANA LETTER SMALL TU",
	"HIRAGANA LETTER SMALL U",
	"HIRAGANA LETTER SMALL WA",
	"HIRAGANA LETTER SMALL YA",
	"HIRAGANA LETTER SMALL YO",
	"HIRAGANA LETTER SMALL YU",
	"HIRAGANA LETTER SO",
	"HIRAGANA LETTER SU",
	"HIRAGANA LETTER TA",
	"HIRAGANA LETTER TE",
	"HIRAGANA LETTER TI",
	"HIRAGANA LETTER TO",
	"HIRAGANA LETTER TU",
	"HIRAGANA LETTER U",
	"HIRAGANA LETTER VU",
	"HIRAGANA LETTER WA",
	"HIRAGANA LETTER WE",
	"HIRAGANA LETTER WI",
	"HIRAGANA LETTER WO",
	"HIRAGANA LETTER YA",
	"HIRAGANA LETTER YO",
	"HIRAGANA LETTER YU",
	"HIRAGANA LETTER ZA",
	"HIRAGANA LETTER ZE",
	"HIRAGANA LETTER ZI",
	"HIRAGANA LETTER ZO",
	"HIRAGANA LETTER ZU",
	"HIRAGANA VOICED ITERATION MARK",
	"HISTORIC SITE",
	"HOCHO",
	"HOMOTHETIC",
	"HONEY POT",
	"HONEYBEE",
	"HORIZONTAL BAR",
	"HORIZONTAL BLACK HEXAGON",
	"HORIZONTAL ELLIPSIS",
	"HORIZONTAL LINE EXTENSION",
	"HORIZONTAL MALE WITH STROKE SIGN",
	"HORIZONTAL TRAFFIC LIGHT",
	"HORSE",
	"HORSE FACE",
	"HORSE RACING",
	"HOSPITAL",
	"HOT BEVERAGE",
	"HOT SPRINGS",
	"HOTEL",
	"HOURGLASS",
	"HOURGLASS WITH FLOWING SAND",
	"HOUSE",
	"HOUSE BUILDING",
	"HOUSE WITH GARDEN",
	"HRYVNIA SIGN",
	"HUNDRED POINTS SYMBOL",
	"HUSHED FACE",
	"HYPHEN",
	"HYPHEN BULLET",
	"HYPHEN WITH DIAERESIS",
	"HYPHEN-MINUS",
	"HYPHENATION POINT",
	"HYPODIASTOLE",
	"HYSTERESIS SYMBOL",
	"ICE CREAM",
	"ICE SKATE",
	"IDENTICAL TO",
	"IDENTICAL TO AND SLANTED PARALLEL",
	"IDENTICAL WITH DOT ABOVE",
	"IDEOGRAPHIC ANNOTATION BOTTOM MARK",
	"IDEOGRAPHIC ANNOTATION EARTH MARK",
	"IDEOGRAPHIC ANNOTATION FIRST MARK",
	"IDEOGRAPHIC ANNOTATION FOUR MARK",
	"IDEOGRAPHIC ANNOTATION FOURTH MARK",
	"IDEOGRAPHIC ANNOTATION HEAVEN MARK",
	"IDEOGRAPHIC ANNOTATION LINKING MARK",
	"IDEOGRAPHIC ANNOTATION MAN MARK",
	"IDEOGRAPHIC ANNOTATION MIDDLE MARK",
	"IDEOGRAPHIC ANNOTATION ONE MARK",
	"IDEOGRAPHIC ANNOTATION REVERSE MARK",
	"IDEOGRAPHIC ANNOTATION SECOND MARK",
	"IDEOGRAPHIC ANNOTATION THIRD MARK",
	"IDEOGRAPHIC ANNOTATION THREE MARK",
	"IDEOGRAPHIC ANNOTATION TOP MARK",
	"IDEOGRAPHIC ANNOTATION TWO MARK",
	"IDEOGRAPHIC CLOSING MARK",
	"IDEOGRAPHIC COMMA",
	"IDEOGRAPHIC DEPARTING TONE MARK",
	"IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO BELOW",
	"IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO MIDDLE AND BELOW",
	"IDEOGRAPHIC DESCRIPTION CHARACTER FULL SURROUND",
	"IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO MIDDLE AND RIGHT",
	"IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO RIGHT",
	"IDEOGRAPHIC DESCRIPTION CHARACTER OVERLAID",
	"IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM ABOVE",
	"IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM BELOW",
	"IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LEFT",
	"IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LOWER LEFT",
	"IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER LEFT",
	"IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER RIGHT",
	"IDEOGRAPHIC ENTERING TONE MARK",
	"IDEOGRAPHIC FULL STOP",
	"IDEOGRAPHIC HALF FILL SPACE",
	"IDEOGRAPHIC ITERATION MARK",
	"IDEOGRAPHIC LEVEL TONE MARK",
	"IDEOGRAPHIC NUMBER ZERO",
	"IDEOGRAPHIC RISING TONE MARK",
	"IDEOGRAPHIC SPACE",
	"IDEOGRAPHIC TELEGRAPH LINE FEED SEPARATOR SYMBOL",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR APRIL",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR AUGUST",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHT",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ELEVEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIFTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIVE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOUR",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOURTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINETEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ONE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVENTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIX",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIXTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY-ONE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THREE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWELVE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-EIGHT",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FIVE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FOUR",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-NINE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-ONE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SEVEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SIX",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-THREE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-TWO",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWO",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR DECEMBER",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR FEBRUARY",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHT",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ELEVEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIFTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIVE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOUR",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOURTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINETEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ONE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVENTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIX",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIXTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THIRTEEN",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THREE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWELVE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-FOUR",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-ONE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-THREE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-TWO",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWO",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ZERO",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR JANUARY",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR JULY",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR JUNE",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR MARCH",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR MAY",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR NOVEMBER",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR OCTOBER",
	"IDEOGRAPHIC TELEGRAPH SYMBOL FOR SEPTEMBER",
	"IDEOGRAPHIC VARIATION INDICATOR",
	"IMAGE OF",
	"IMAGE OF OR APPROXIMATELY EQUAL TO",
	"IMP",
	"IMPERIAL ARAMAIC LETTER ALEPH",
	"IMPERIAL ARAMAIC LETTER AYIN",
	"IMPERIAL ARAMAIC LETTER BETH",
	"IMPERIAL ARAMAIC LETTER DALETH",
	"IMPERIAL ARAMAIC LETTER GIMEL",
	"IMPERIAL ARAMAIC LETTER HE",
	"IMPERIAL ARAMAIC LETTER HETH",
	"IMPERIAL ARAMAIC LETTER KAPH",
	"IMPERIAL ARAMAIC LETTER LAMEDH",
	"IMPERIAL ARAMAIC LETTER MEM",
	"IMPERIAL ARAMAIC LETTER NUN",
	"IMPERIAL ARAMAIC LETTER PE",
	"IMPERIAL ARAMAIC LETTER QOPH",
	"IMPERIAL ARAMAIC LETTER RESH",
	"IMPERIAL ARAMAIC LETTER SADHE",
	"IMPERIAL ARAMAIC LETTER SAMEKH",
	"IMPERIAL ARAMAIC LETTER SHIN",
	"IMPERIAL ARAMAIC LETTER TAW",
	"IMPERIAL ARAMAIC LETTER TETH",
	"IMPERIAL ARAMAIC LETTER WAW",
	"IMPERIAL ARAMAIC LETTER YODH",
	"IMPERIAL ARAMAIC LETTER ZAYIN",
	"IMPERIAL ARAMAIC NUMBER ONE",
	"IMPERIAL ARAMAIC NUMBER ONE HUNDRED",
	"IMPERIAL ARAMAIC NUMBER ONE THOUSAND",
	"IMPERIAL ARAMAIC NUMBER TEN",
	"IMPERIAL ARAMAIC NUMBER TEN THOUSAND",
	"IMPERIAL ARAMAIC NUMBER THREE",
	"IMPERIAL ARAMAIC NUMBER TWENTY",
	"IMPERIAL ARAMAIC NUMBER TWO",
	"IMPERIAL ARAMAIC SECTION SIGN",
	"INBOX TRAY",
	"INCOMING ENVELOPE",
	"INCOMPLETE INFINITY",
	"INCREASES AS",
	"INCREMENT",
	"INDIAN RUPEE SIGN",
	"INFINITY",
	"INFINITY NEGATED WITH VERTICAL BAR",
	"INFORMATION DESK PERSON",
	"INFORMATION SOURCE",
	"INHIBIT ARABIC FORM SHAPING",
	"INHIBIT SYMMETRIC SWAPPING",
	"INPUT SYMBOL FOR LATIN CAPITAL LETTERS",
	"INPUT SYMBOL FOR LATIN LETTERS",
	"INPUT SYMBOL FOR LATIN SMALL LETTERS",
	"INPUT SYMBOL FOR NUMBERS",
	"INPUT SYMBOL FOR SYMBOLS",
	"INSCRIPTIONAL PAHLAVI LETTER ALEPH",
	"INSCRIPTIONAL PAHLAVI LETTER BETH",
	"INSCRIPTIONAL PAHLAVI LETTER DALETH",
	"INSCRIPTIONAL PAHLAVI LETTER GIMEL",
	"INSCRIPTIONAL PAHLAVI LETTER HE",
	"INSCRIPTIONAL PAHLAVI LETTER HETH",
	"INSCRIPTIONAL PAHLAVI LETTER KAPH",
	"INSCRIPTIONAL PAHLAVI LETTER LAMEDH",
	"INSCRIPTIONAL PAHLAVI LETTER MEM-QOPH",
	"INSCRIPTIONAL PAHLAVI LETTER NUN",
	"INSCRIPTIONAL PAHLAVI LETTER PE",
	"INSCRIPTIONAL PAHLAVI LETTER SADHE",
	"INSCRIPTIONAL PAHLAVI LETTER SAMEKH",
	"INSCRIPTIONAL PAHLAVI LETTER SHIN",
	"INSCRIPTIONAL PAHLAVI LETTER TAW",
	"INSCRIPTIONAL PAHLAVI LETTER TETH",
	"INSCRIPTIONAL PAHLAVI LETTER WAW-AYIN-RESH",
	"INSCRIPTIONAL PAHLAVI LETTER YODH",
	"INSCRIPTIONAL PAHLAVI LETTER ZAYIN",
	"INSCRIPTIONAL PAHLAVI NUMBER FOUR",
	"INSCRIPTIONAL PAHLAVI NUMBER ONE",
	"INSCRIPTIONAL PAHLAVI NUMBER ONE HUNDRED",
	"INSCRIPTIONAL PAHLAVI NUMBER ONE THOUSAND",
	"INSCRIPTIONAL PAHLAVI NUMBER TEN",
	"INSCRIPTIONAL PAHLAVI NUMBER THREE",
	"INSCRIPTIONAL PAHLAVI NUMBER TWENTY",
	"INSCRIPTIONAL PAHLAVI NUMBER TWO",
	"INSCRIPTIONAL PARTHIAN LETTER ALEPH",
	"INSCRIPTIONAL PARTHIAN LETTER AYIN",
	"INSCRIPTIONAL PARTHIAN LETTER BETH",
	"INSCRIPTIONAL PARTHIAN LETTER DALETH",
	"INSCRIPTIONAL PARTHIAN LETTER GIMEL",
	"INSCRIPTIONAL PARTHIAN LETTER HE",
	"INSCRIPTIONAL PARTHIAN LETTER HETH",
	"INSCRIPTIONAL PARTHIAN LETTER KAPH",
	"INSCRIPTIONAL PARTHIAN LETTER LAMEDH",
	"INSCRIPTIONAL PARTHIAN LETTER MEM",
	"INSCRIPTIONAL PARTHIAN LETTER NUN",
	"INSCRIPTIONAL PARTHIAN LETTER PE",
	"INSCRIPTIONAL PARTHIAN LETTER QOPH",
	"INSCRIPTIONAL PARTHIAN LETTER RESH",
	"INSCRIPTIONAL PARTHIAN LETTER SADHE",
	"INSCRIPTIONAL PARTHIAN LETTER SAMEKH",
	"INSCRIPTIONAL PARTHIAN LETTER SHIN",
	"INSCRIPTIONAL PARTHIAN LETTER TAW",
	"INSCRIPTIONAL PARTHIAN LETTER TETH",
	"INSCRIPTIONAL PARTHIAN LETTER WAW",
	"INSCRIPTIONAL PARTHIAN LETTER YODH",
	"INSCRIPTIONAL PARTHIAN LETTER ZAYIN",
	"INSCRIPTIONAL PARTHIAN NUMBER FOUR",
	"INSCRIPTIONAL PARTHIAN NUMBER ONE",
	"INSCRIPTIONAL PARTHIAN NUMBER ONE HUNDRED",
	"INSCRIPTIONAL PARTHIAN NUMBER ONE THOUSAND",
	"INSCRIPTIONAL PARTHIAN NUMBER TEN",
	"INSCRIPTIONAL PARTHIAN NUMBER THREE",
	"INSCRIPTIONAL PARTHIAN NUMBER TWENTY",
	"INSCRIPTIONAL PARTHIAN NUMBER TWO",
	"INSERTION SYMBOL",
	"INTEGRAL",
	"INTEGRAL AROUND A POINT OPERATOR",
	"INTEGRAL AVERAGE WITH SLASH",
	"INTEGRAL EXTENSION",
	"INTEGRAL WITH DOUBLE STROKE",
	"INTEGRAL WITH INTERSECTION",
	"INTEGRAL WITH LEFTWARDS ARROW WITH HOOK",
	"INTEGRAL WITH OVERBAR",
	"INTEGRAL WITH TIMES SIGN",
	"INTEGRAL WITH UNDERBAR",
	"INTEGRAL WITH UNION",
	"INTERCALATE",
	"INTERIOR PRODUCT",
	"INTERLINEAR ANNOTATION ANCHOR",
	"INTERLINEAR ANNOTATION SEPARATOR",
	"INTERLINEAR ANNOTATION TERMINATOR",
	"INTERLOCKED FEMALE AND MALE SIGN",
	"INTERROBANG",
	"INTERSECTION",
	"INTERSECTION ABOVE BAR ABOVE UNION",
	"INTERSECTION ABOVE UNION",
	"INTERSECTION BESIDE AND JOINED WITH INTERSECTION",
	"INTERSECTION WITH DOT",
	"INTERSECTION WITH LOGICAL AND",
	"INTERSECTION WITH OVERBAR",
	"INVERSE BULLET",
	"INVERSE WHITE CIRCLE",
	"INVERTED EXCLAMATION MARK",
	"INVERTED INTERROBANG",
	"INVERTED LAZY S",
	"INVERTED OHM SIGN",
	"INVERTED PENTAGRAM",
	"INVERTED QUESTION MARK",
	"INVERTED UNDERTIE",
	"INVISIBLE PLUS",
	"INVISIBLE SEPARATOR",
	"INVISIBLE TIMES",
	"IZAKAYA LANTERN",
	"JACK-O-LANTERN",
	"JAPANESE BANK SYMBOL",
	"JAPANESE CASTLE",
	"JAPANESE DOLLS",
	"JAPANESE GOBLIN",
	"JAPANESE INDUSTRIAL STANDARD SYMBOL",
	"JAPANESE OGRE",
	"JAPANESE POST OFFICE",
	"JAPANESE SYMBOL FOR BEGINNER",
	"JAVANESE CONSONANT SIGN CAKRA",
	"JAVANESE CONSONANT SIGN KERET",
	"JAVANESE CONSONANT SIGN PENGKAL",
	"JAVANESE DIGIT EIGHT",
	"JAVANESE DIGIT FIVE",
	"JAVANESE DIGIT FOUR",
	"JAVANESE DIGIT NINE",
	"JAVANESE DIGIT ONE",
	"JAVANESE DIGIT SEVEN",
	"JAVANESE DIGIT SIX",
	"JAVANESE DIGIT THREE",
	"JAVANESE DIGIT TWO",
	"JAVANESE DIGIT ZERO",
	"JAVANESE LEFT RERENGGAN",
	"JAVANESE LETTER A",
	"JAVANESE LETTER AI",
	"JAVANESE LETTER BA",
	"JAVANESE LETTER BA MURDA",
	"JAVANESE LETTER CA",
	"JAVANESE LETTER CA MURDA",
	"JAVANESE LETTER DA",
	"JAVANESE LETTER DA MAHAPRANA",
	"JAVANESE LETTER DDA",
	"JAVANESE LETTER DDA MAHAPRANA",
	"JAVANESE LETTER E",
	"JAVANESE LETTER GA",
	"JAVANESE LETTER GA MURDA",
	"JAVANESE LETTER HA",
	"JAVANESE LETTER I",
	"JAVANESE LETTER I KAWI",
	"JAVANESE LETTER II",
	"JAVANESE LETTER JA",
	"JAVANESE LETTER JA MAHAPRANA",
	"JAVANESE LETTER KA",
	"JAVANESE LETTER KA MURDA",
	"JAVANESE LETTER KA SASAK",
	"JAVANESE LETTER LA",
	"JAVANESE LETTER MA",
	"JAVANESE LETTER NA",
	"JAVANESE LETTER NA MURDA",
	"JAVANESE LETTER NGA",
	"JAVANESE LETTER NGA LELET",
	"JAVANESE LETTER NGA LELET RASWADI",
	"JAVANESE LETTER NYA",
	"JAVANESE LETTER NYA MURDA",
	"JAVANESE LETTER O",
	"JAVANESE LETTER PA",
	"JAVANESE LETTER PA CEREK",
	"JAVANESE LETTER PA MURDA",
	"JAVANESE LETTER RA",
	"JAVANESE LETTER RA AGUNG",
	"JAVANESE LETTER SA",
	"JAVANESE LETTER SA MAHAPRANA",
	"JAVANESE LETTER SA MURDA",
	"JAVANESE LETTER TA",
	"JAVANESE LETTER TA MURDA",
	"JAVANESE LETTER TTA",
	"JAVANESE LETTER TTA MAHAPRANA",
	"JAVANESE LETTER U",
	"JAVANESE LETTER WA",
	"JAVANESE LETTER YA",
	"JAVANESE PADA ADEG",
	"JAVANESE PADA ADEG ADEG",
	"JAVANESE PADA ANDAP",
	"JAVANESE PADA ISEN-ISEN",
	"JAVANESE PADA LINGSA",
	"JAVANESE PADA LUHUR",
	"JAVANESE PADA LUNGSI",
	"JAVANESE PADA MADYA",
	"JAVANESE PADA PANGKAT",
	"JAVANESE PADA PISELEH",
	"JAVANESE PADA TIRTA TUMETES",
	"JAVANESE PADA WINDU",
	"JAVANESE PANGKON",
	"JAVANESE PANGRANGKEP",
	"JAVANESE RIGHT RERENGGAN",
	"JAVANESE SIGN CECAK",
	"JAVANESE SIGN CECAK TELU",
	"JAVANESE SIGN LAYAR",
	"JAVANESE SIGN PANYANGGA",
	"JAVANESE SIGN WIGNYAN",
	"JAVANESE TURNED PADA PISELEH",
	"JAVANESE VOWEL SIGN DIRGA MURE",
	"JAVANESE VOWEL SIGN PEPET",
	"JAVANESE VOWEL SIGN SUKU",
	"JAVANESE VOWEL SIGN SUKU MENDUT",
	"JAVANESE VOWEL SIGN TALING",
	"JAVANESE VOWEL SIGN TARUNG",
	"JAVANESE VOWEL SIGN TOLONG",
	"JAVANESE VOWEL SIGN WULU",
	"JAVANESE VOWEL SIGN WULU MELIK",
	"JEANS",
	"JOIN",
	"JUNO",
	"JUPITER",
	"KAITHI ABBREVIATION SIGN",
	"KAITHI DANDA",
	"KAITHI DOUBLE DANDA",
	"KAITHI DOUBLE SECTION MARK",
	"KAITHI ENUMERATION SIGN",
	"KAITHI LETTER A",
	"KAITHI LETTER AA",
	"KAITHI LETTER AI",
	"KAITHI LETTER AU",
	"KAITHI LETTER BA",
	"KAITHI LETTER BHA",
	"KAITHI LETTER CA",
	"KAITHI LETTER CHA",
	"KAITHI LETTER DA",
	"KAITHI LETTER DDA",
	"KAITHI LETTER DDDHA",
	"KAITHI LETTER DDHA",
	"KAITHI LETTER DHA",
	"KAITHI LETTER E",
	"KAITHI LETTER GA",
	"KAITHI LETTER GHA",
	"KAITHI LETTER HA",
	"KAITHI LETTER I",
	"KAITHI LETTER II",
	"KAITHI LETTER JA",
	"KAITHI LETTER JHA",
	"KAITHI LETTER KA",
	"KAITHI LETTER KHA",
	"KAITHI LETTER LA",
	"KAITHI LETTER MA",
	"KAITHI LETTER NA",
	"KAITHI LETTER NGA",
	"KAITHI LETTER NNA",
	"KAITHI LETTER NYA",
	"KAITHI LETTER O",
	"KAITHI LETTER PA",
	"KAITHI LETTER PHA",
	"KAITHI LETTER RA",
	"KAITHI LETTER RHA",
	"KAITHI LETTER SA",
	"KAITHI LETTER SHA",
	"KAITHI LETTER SSA",
	"KAITHI LETTER TA",
	"KAITHI LETTER THA",
	"KAITHI LETTER TTA",
	"KAITHI LETTER TTHA",
	"KAITHI LETTER U",
	"KAITHI LETTER UU",
	"KAITHI LETTER VA",
	"KAITHI LETTER YA",
	"KAITHI NUMBER SIGN",
	"KAITHI SECTION MARK",
	"KAITHI SIGN ANUSVARA",
	"KAITHI SIGN CANDRABINDU",
	"KAITHI SIGN NUKTA",
	"KAITHI SIGN VIRAMA",
	"KAITHI SIGN VISARGA",
	"KAITHI VOWEL SIGN AA",
	"KAITHI VOWEL SIGN AI",
	"KAITHI VOWEL SIGN AU",
	"KAITHI VOWEL SIGN E",
	"KAITHI VOWEL SIGN I",
	"KAITHI VOWEL SIGN II",
	"KAITHI VOWEL SIGN O",
	"KAITHI VOWEL SIGN U",
	"KAITHI VOWEL SIGN UU",
	"KANGXI RADICAL AGAIN",
	"KANGXI RADICAL AND",
	"KANGXI RADICAL ARRIVE",
	"KANGXI RADICAL ARROW",
	"KANGXI RADICAL AXE",
	"KANGXI RADICAL BADGER",
	"KANGXI RADICAL BAMBOO",
	"KANGXI RADICAL BEAN",
	"KANGXI RADICAL BIG",
	"KANGXI RADICAL BIRD",
	"KANGXI RADICAL BITTER",
	"KANGXI RADICAL BLACK",
	"KANGXI RADICAL BLOOD",
	"KANGXI RADICAL BLUE",
	"KANGXI RADICAL BOAT",
	"KANGXI RADICAL BODY",
	"KANGXI RADICAL BOLT OF CLOTH",
	"KANGXI RADICAL BONE",
	"KANGXI RADICAL BOW",
	"KANGXI RADICAL BRANCH",
	"KANGXI RADICAL BRISTLE",
	"KANGXI RADICAL BRUSH",
	"KANGXI RADICAL CART",
	"KANGXI RADICAL CAULDRON",
	"KANGXI RADICAL CAVE",
	"KANGXI RADICAL CHILD",
	"KANGXI RADICAL CITY",
	"KANGXI RADICAL CLAN",
	"KANGXI RADICAL CLAW",
	"KANGXI RADICAL CLIFF",
	"KANGXI RADICAL CLOTHES",
	"KANGXI RADICAL COLOR",
	"KANGXI RADICAL COMPARE",
	"KANGXI RADICAL CORPSE",
	"KANGXI RADICAL COVER",
	"KANGXI RADICAL COW",
	"KANGXI RADICAL DEATH",
	"KANGXI RADICAL DEER",
	"KANGXI RADICAL DIPPER",
	"KANGXI RADICAL DISH",
	"KANGXI RADICAL DISTINGUISH",
	"KANGXI RADICAL DIVINATION",
	"KANGXI RADICAL DO NOT",
	"KANGXI RADICAL DOG",
	"KANGXI RADICAL DOOR",
	"KANGXI RADICAL DOT",
	"KANGXI RADICAL DOTTED CLIFF",
	"KANGXI RADICAL DOTTED TENT",
	"KANGXI RADICAL DOUBLE X",
	"KANGXI RADICAL DOWN BOX",
	"KANGXI RADICAL DRAGON",
	"KANGXI RADICAL DRUM",
	"KANGXI RADICAL DRY",
	"KANGXI RADICAL EAR",
	"KANGXI RADICAL EARTH",
	"KANGXI RADICAL EAT",
	"KANGXI RADICAL EIGHT",
	"KANGXI RADICAL EMBROIDERY",
	"KANGXI RADICAL ENCLOSURE",
	"KANGXI RADICAL ENTER",
	"KANGXI RADICAL EVEN",
	"KANGXI RADICAL EVENING",
	"KANGXI RADICAL EYE",
	"KANGXI RADICAL FACE",
	"KANGXI RADICAL FANG",
	"KANGXI RADICAL FATHER",
	"KANGXI RADICAL FEATHER",
	"KANGXI RADICAL FIELD",
	"KANGXI RADICAL FIGHT",
	"KANGXI RADICAL FIRE",
	"KANGXI RADICAL FISH",
	"KANGXI RADICAL FLUTE",
	"KANGXI RADICAL FLY",
	"KANGXI RADICAL FOOT",
	"KANGXI RADICAL FRAGRANT",
	"KANGXI RADICAL FROG",
	"KANGXI RADICAL FUR",
	"KANGXI RADICAL GATE",
	"KANGXI RADICAL GHOST",
	"KANGXI RADICAL GO",
	"KANGXI RADICAL GO SLOWLY",
	"KANGXI RADICAL GOLD",
	"KANGXI RADICAL GRAIN",
	"KANGXI RADICAL GRASS",
	"KANGXI RADICAL HAIR",
	"KANGXI RADICAL HALBERD",
	"KANGXI RADICAL HALF TREE TRUNK",
	"KANGXI RADICAL HAND",
	"KANGXI RADICAL HEAD",
	"KANGXI RADICAL HEART",
	"KANGXI RADICAL HEMP",
	"KANGXI RADICAL HIDING ENCLOSURE",
	"KANGXI RADICAL HOOK",
	"KANGXI RADICAL HORN",
	"KANGXI RADICAL HORSE",
	"KANGXI RADICAL ICE",
	"KANGXI RADICAL INCH",
	"KANGXI RADICAL INSECT",
	"KANGXI RADICAL JADE",
	"KANGXI RADICAL JAR",
	"KANGXI RADICAL KNIFE",
	"KANGXI RADICAL LACK",
	"KANGXI RADICAL LAME",
	"KANGXI RADICAL LEAF",
	"KANGXI RADICAL LEATHER",
	"KANGXI RADICAL LEEK",
	"KANGXI RADICAL LEGS",
	"KANGXI RADICAL LID",
	"KANGXI RADICAL LIFE",
	"KANGXI RADICAL LINE",
	"KANGXI RADICAL LONG",
	"KANGXI RADICAL LONG STRIDE",
	"KANGXI RADICAL MAN",
	"KANGXI RADICAL MEAT",
	"KANGXI RADICAL MELON",
	"KANGXI RADICAL MILLET",
	"KANGXI RADICAL MINISTER",
	"KANGXI RADICAL MOON",
	"KANGXI RADICAL MORNING",
	"KANGXI RADICAL MORTAR",
	"KANGXI RADICAL MOUND",
	"KANGXI RADICAL MOUNTAIN",
	"KANGXI RADICAL MOUTH",
	"KANGXI RADICAL NET",
	"KANGXI RADICAL NOSE",
	"KANGXI RADICAL NOT",
	"KANGXI RADICAL OLD",
	"KANGXI RADICAL ONE",
	"KANGXI RADICAL ONESELF",
	"KANGXI RADICAL OPEN BOX",
	"KANGXI RADICAL OPPOSE",
	"KANGXI RADICAL PIG",
	"KANGXI RADICAL PLOW",
	"KANGXI RADICAL POWER",
	"KANGXI RADICAL PRIVATE",
	"KANGXI RADICAL PROFOUND",
	"KANGXI RADICAL RAIN",
	"KANGXI RADICAL RAP",
	"KANGXI RADICAL RAT",
	"KANGXI RADICAL RED",
	"KANGXI RADICAL RICE",
	"KANGXI RADICAL RIGHT OPEN BOX",
	"KANGXI RADICAL RIVER",
	"KANGXI RADICAL ROOF",
	"KANGXI RADICAL RUN",
	"KANGXI RADICAL SACRIFICIAL WINE",
	"KANGXI RADICAL SALT",
	"KANGXI RADICAL SAY",
	"KANGXI RADICAL SCHOLAR",
	"KANGXI RADICAL SCRIPT",
	"KANGXI RADICAL SEAL",
	"KANGXI RADICAL SECOND",
	"KANGXI RADICAL SEE",
	"KANGXI RADICAL SELF",
	"KANGXI RADICAL SHEEP",
	"KANGXI RADICAL SHELL",
	"KANGXI RADICAL SHOOT",
	"KANGXI RADICAL SHORT TAILED BIRD",
	"KANGXI RADICAL SHORT THREAD",
	"KANGXI RADICAL SICKNESS",
	"KANGXI RADICAL SILK",
	"KANGXI RADICAL SKIN",
	"KANGXI RADICAL SLASH",
	"KANGXI RADICAL SLAVE",
	"KANGXI RADICAL SLICE",
	"KANGXI RADICAL SMALL",
	"KANGXI RADICAL SNOUT",
	"KANGXI RADICAL SOUND",
	"KANGXI RADICAL SPEAR",
	"KANGXI RADICAL SPEECH",
	"KANGXI RADICAL SPIRIT",
	"KANGXI RADICAL SPOON",
	"KANGXI RADICAL SPROUT",
	"KANGXI RADICAL SQUARE",
	"KANGXI RADICAL STAND",
	"KANGXI RADICAL STEAM",
	"KANGXI RADICAL STEP",
	"KANGXI RADICAL STONE",
	"KANGXI RADICAL STOP",
	"KANGXI RADICAL STOPPING",
	"KANGXI RADICAL SUN",
	"KANGXI RADICAL SWEET",
	"KANGXI RADICAL TABLE",
	"KANGXI RADICAL TALL",
	"KANGXI RADICAL TANNED LEATHER",
	"KANGXI RADICAL TEN",
	"KANGXI RADICAL TIGER",
	"KANGXI RADICAL TILE",
	"KANGXI RADICAL TONGUE",
	"KANGXI RADICAL TOOTH",
	"KANGXI RADICAL TRACK",
	"KANGXI RADICAL TREE",
	"KANGXI RADICAL TRIPOD",
	"KANGXI RADICAL TURBAN",
	"KANGXI RADICAL TURTLE",
	"KANGXI RADICAL TWO",
	"KANGXI RADICAL TWO HANDS",
	"KANGXI RADICAL USE",
	"KANGXI RADICAL VALLEY",
	"KANGXI RADICAL VILLAGE",
	"KANGXI RADICAL WALK",
	"KANGXI RADICAL WALK ENCLOSURE",
	"KANGXI RADICAL WATER",
	"KANGXI RADICAL WEAPON",
	"KANGXI RADICAL WEST",
	"KANGXI RADICAL WHEAT",
	"KANGXI RADICAL WHITE",
	"KANGXI RADICAL WIND",
	"KANGXI RADICAL WINE",
	"KANGXI RADICAL WOMAN",
	"KANGXI RADICAL WORK",
	"KANGXI RADICAL WRAP",
	"KANGXI RADICAL WRONG",
	"KANGXI RADICAL YELLOW",
	"KANNADA AI LENGTH MARK",
	"KANNADA DIGIT EIGHT",
	"KANNADA DIGIT FIVE",
	"KANNADA DIGIT FOUR",
	"KANNADA DIGIT NINE",
	"KANNADA DIGIT ONE",
	"KANNADA DIGIT SEVEN",
	"KANNADA DIGIT SIX",
	"KANNADA DIGIT THREE",
	"KANNADA DIGIT TWO",
	"KANNADA DIGIT ZERO",
	"KANNADA LENGTH MARK",
	"KANNADA LETTER A",
	"KANNADA LETTER AA",
	"KANNADA LETTER AI",
	"KANNADA LETTER AU",
	"KANNADA LETTER BA",
	"KANNADA LETTER BHA",
	"KANNADA LETTER CA",
	"KANNADA LETTER CHA",
	"KANNADA LETTER DA",
	"KANNADA LETTER DDA",
	"KANNADA LETTER DDHA",
	"KANNADA LETTER DHA",
	"KANNADA LETTER E",
	"KANNADA LETTER EE",
	"KANNADA LETTER FA",
	"KANNADA LETTER GA",
	"KANNADA LETTER GHA",
	"KANNADA LETTER HA",
	"KANNADA LETTER I",
	"KANNADA LETTER II",
	"KANNADA LETTER JA",
	"KANNADA LETTER JHA",
	"KANNADA LETTER KA",
	"KANNADA LETTER KHA",
	"KANNADA LETTER LA",
	"KANNADA LETTER LLA",
	"KANNADA LETTER MA",
	"KANNADA LETTER NA",
	"KANNADA LETTER NGA",
	"KANNADA LETTER NNA",
	"KANNADA LETTER NYA",
	"KANNADA LETTER O",
	"KANNADA LETTER OO",
	"KANNADA LETTER PA",
	"KANNADA LETTER PHA",
	"KANNADA LETTER RA",
	"KANNADA LETTER RRA",
	"KANNADA LETTER SA",
	"KANNADA LETTER SHA",
	"KANNADA LETTER SSA",
	"KANNADA LETTER TA",
	"KANNADA LETTER THA",
	"KANNADA LETTER TTA",
	"KANNADA LETTER TTHA",
	"KANNADA LETTER U",
	"KANNADA LETTER UU",
	"KANNADA LETTER VA",
	"KANNADA LETTER VOCALIC L",
	"KANNADA LETTER VOCALIC LL",
	"KANNADA LETTER VOCALIC R",
	"KANNADA LETTER VOCALIC RR",
	"KANNADA LETTER YA",
	"KANNADA SIGN ANUSVARA",
	"KANNADA SIGN AVAGRAHA",
	"KANNADA SIGN JIHVAMULIYA",
	"KANNADA SIGN NUKTA",
	"KANNADA SIGN UPADHMANIYA",
	"KANNADA SIGN VIRAMA",
	"KANNADA SIGN VISARGA",
	"KANNADA VOWEL SIGN AA",
	"KANNADA VOWEL SIGN AI",
	"KANNADA VOWEL SIGN AU",
	"KANNADA VOWEL SIGN E",
	"KANNADA VOWEL SIGN EE",
	"KANNADA VOWEL SIGN I",
	"KANNADA VOWEL SIGN II",
	"KANNADA VOWEL SIGN O",
	"KANNADA VOWEL SIGN OO",
	"KANNADA VOWEL SIGN U",
	"KANNADA VOWEL SIGN UU",
	"KANNADA VOWEL SIGN VOCALIC L",
	"KANNADA VOWEL SIGN VOCALIC LL",
	"KANNADA VOWEL SIGN VOCALIC R",
	"KANNADA VOWEL SIGN VOCALIC RR",
	"KATAKANA DIGRAPH KOTO",
	"KATAKANA ITERATION MARK",
	"KATAKANA LETTER A",
	"KATAKANA LETTER ARCHAIC E",
	"KATAKANA LETTER BA",
	"KATAKANA LETTER BE",
	"KATAKANA LETTER BI",
	"KATAKANA LETTER BO",
	"KATAKANA LETTER BU",
	"KATAKANA LETTER DA",
	"KATAKANA LETTER DE",
	"KATAKANA LETTER DI",
	"KATAKANA LETTER DO",
	"KATAKANA LETTER DU",
	"KATAKANA LETTER E",
	"KATAKANA LETTER GA",
	"KATAKANA LETTER GE",
	"KATAKANA LETTER GI",
	"KATAKANA LETTER GO",
	"KATAKANA LETTER GU",
	"KATAKANA LETTER HA",
	"KATAKANA LETTER HE",
	"KATAKANA LETTER HI",
	"KATAKANA LETTER HO",
	"KATAKANA LETTER HU",
	"KATAKANA LETTER I",
	"KATAKANA LETTER KA",
	"KATAKANA LETTER KE",
	"KATAKANA LETTER KI",
	"KATAKANA LETTER KO",
	"KATAKANA LETTER KU",
	"KATAKANA LETTER MA",
	"KATAKANA LETTER ME",
	"KATAKANA LETTER MI",
	"KATAKANA LETTER MO",
	"KATAKANA LETTER MU",
	"KATAKANA LETTER N",
	"KATAKANA LETTER NA",
	"KATAKANA LETTER NE",
	"KATAKANA LETTER NI",
	"KATAKANA LETTER NO",
	"KATAKANA LETTER NU",
	"KATAKANA LETTER O",
	"KATAKANA LETTER PA",
	"KATAKANA LETTER PE",
	"KATAKANA LETTER PI",
	"KATAKANA LETTER PO",
	"KATAKANA LETTER PU",
	"KATAKANA LETTER RA",
	"KATAKANA LETTER RE",
	"KATAKANA LETTER RI",
	"KATAKANA LETTER RO",
	"KATAKANA LETTER RU",
	"KATAKANA LETTER SA",
	"KATAKANA LETTER SE",
	"KATAKANA LETTER SI",
	"KATAKANA LETTER SMALL A",
	"KATAKANA LETTER SMALL E",
	"KATAKANA LETTER SMALL HA",
	"KATAKANA LETTER SMALL HE",
	"KATAKANA LETTER SMALL HI",
	"KATAKANA LETTER SMALL HO",
	"KATAKANA LETTER SMALL HU",
	"KATAKANA LETTER SMALL I",
	"KATAKANA LETTER SMALL KA",
	"KATAKANA LETTER SMALL KE",
	"KATAKANA LETTER SMALL KU",
	"KATAKANA LETTER SMALL MU",
	"KATAKANA LETTER SMALL NU",
	"KATAKANA LETTER SMALL O",
	"KATAKANA LETTER SMALL RA",
	"KATAKANA LETTER SMALL RE",
	"KATAKANA LETTER SMALL RI",
	"KATAKANA LETTER SMALL RO",
	"KATAKANA LETTER SMALL RU",
	"KATAKANA LETTER SMALL SI",
	"KATAKANA LETTER SMALL SU",
	"KATAKANA LETTER SMALL TO",
	"KATAKANA LETTER SMALL TU",
	"KATAKANA LETTER SMALL U",
	"KATAKANA LETTER SMALL WA",
	"KATAKANA LETTER SMALL YA",
	"KATAKANA LETTER SMALL YO",
	"KATAKANA LETTER SMALL YU",
	"KATAKANA LETTER SO",
	"KATAKANA LETTER SU",
	"KATAKANA LETTER TA",
	"KATAKANA LETTER TE",
	"KATAKANA LETTER TI",
	"KATAKANA LETTER TO",
	"KATAKANA LETTER TU",
	"KATAKANA LETTER U",
	"KATAKANA LETTER VA",
	"KATAKANA LETTER VE",
	"KATAKANA LETTER VI",
	"KATAKANA LETTER VO",
	"KATAKANA LETTER VU",
	"KATAKANA LETTER WA",
	"KATAKANA LETTER WE",
	"KATAKANA LETTER WI",
	"KATAKANA LETTER WO",
	"KATAKANA LETTER YA",
	"KATAKANA LETTER YO",
	"KATAKANA LETTER YU",
	"KATAKANA LETTER ZA",
	"KATAKANA LETTER ZE",
	"KATAKANA LETTER ZI",
	"KATAKANA LETTER ZO",
	"KATAKANA LETTER ZU",
	"KATAKANA MIDDLE DOT",
	"KATAKANA VOICED ITERATION MARK",
	"KATAKANA-HIRAGANA DOUBLE HYPHEN",
	"KATAKANA-HIRAGANA PROLONGED SOUND MARK",
	"KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK",
	"KATAKANA-HIRAGANA VOICED SOUND MARK",
	"KAYAH LI DIGIT EIGHT",
	"KAYAH LI DIGIT FIVE",
	"KAYAH LI DIGIT FOUR",
	"KAYAH LI DIGIT NINE",
	"KAYAH LI DIGIT ONE",
	"KAYAH LI DIGIT SEVEN",
	"KAYAH LI DIGIT SIX",
	"KAYAH LI DIGIT THREE",
	"KAYAH LI DIGIT TWO",
	"KAYAH LI DIGIT ZERO",
	"KAYAH LI LETTER A",
	"KAYAH LI LETTER BA",
	"KAYAH LI LETTER CA",
	"KAYAH LI LETTER DA",
	"KAYAH LI LETTER GA",
	"KAYAH LI LETTER HA",
	"KAYAH LI LETTER HTA",
	"KAYAH LI LETTER I",
	"KAYAH LI LETTER KA",
	"KAYAH LI LETTER KHA",
	"KAYAH LI LETTER LA",
	"KAYAH LI LETTER MA",
	"KAYAH LI LETTER NA",
	"KAYAH LI LETTER NGA",
	"KAYAH LI LETTER NYA",
	"KAYAH LI LETTER OE",
	"KAYAH LI LETTER OO",
	"KAYAH LI LETTER PA",
	"KAYAH LI LETTER PHA",
	"KAYAH LI LETTER RA",
	"KAYAH LI LETTER SA",
	"KAYAH LI LETTER SHA",
	"KAYAH LI LETTER TA",
	"KAYAH LI LETTER THA",
	"KAYAH LI LETTER VA",
	"KAYAH LI LETTER WA",
	"KAYAH LI LETTER YA",
	"KAYAH LI LETTER ZA",
	"KAYAH LI SIGN CWI",
	"KAYAH LI SIGN SHYA",
	"KAYAH LI TONE CALYA",
	"KAYAH LI TONE CALYA PLOPHU",
	"KAYAH LI TONE PLOPHU",
	"KAYAH LI VOWEL E",
	"KAYAH LI VOWEL EE",
	"KAYAH LI VOWEL O",
	"KAYAH LI VOWEL U",
	"KAYAH LI VOWEL UE",
	"KELVIN SIGN",
	"KEY",
	"KEYBOARD",
	"KEYCAP TEN",
	"KHAROSHTHI DIGIT FOUR",
	"KHAROSHTHI DIGIT ONE",
	"KHAROSHTHI DIGIT THREE",
	"KHAROSHTHI DIGIT TWO",
	"KHAROSHTHI LETTER A",
	"KHAROSHTHI LETTER BA",
	"KHAROSHTHI LETTER BHA",
	"KHAROSHTHI LETTER CA",
	"KHAROSHTHI LETTER CHA",
	"KHAROSHTHI LETTER DA",
	"KHAROSHTHI LETTER DDA",
	"KHAROSHTHI LETTER DDHA",
	"KHAROSHTHI LETTER DHA",
	"KHAROSHTHI LETTER GA",
	"KHAROSHTHI LETTER GHA",
	"KHAROSHTHI LETTER HA",
	"KHAROSHTHI LETTER JA",
	"KHAROSHTHI LETTER KA",
	"KHAROSHTHI LETTER KHA",
	"KHAROSHTHI LETTER KKA",
	"KHAROSHTHI LETTER LA",
	"KHAROSHTHI LETTER MA",
	"KHAROSHTHI LETTER NA",
	"KHAROSHTHI LETTER NNA",
	"KHAROSHTHI LETTER NYA",
	"KHAROSHTHI LETTER PA",
	"KHAROSHTHI LETTER PHA",
	"KHAROSHTHI LETTER RA",
	"KHAROSHTHI LETTER SA",
	"KHAROSHTHI LETTER SHA",
	"KHAROSHTHI LETTER SSA",
	"KHAROSHTHI LETTER TA",
	"KHAROSHTHI LETTER THA",
	"KHAROSHTHI LETTER TTA",
	"KHAROSHTHI LETTER TTHA",
	"KHAROSHTHI LETTER TTTHA",
	"KHAROSHTHI LETTER VA",
	"KHAROSHTHI LETTER YA",
	"KHAROSHTHI LETTER ZA",
	"KHAROSHTHI NUMBER ONE HUNDRED",
	"KHAROSHTHI NUMBER ONE THOUSAND",
	"KHAROSHTHI NUMBER TEN",
	"KHAROSHTHI NUMBER TWENTY",
	"KHAROSHTHI PUNCTUATION CIRCLE",
	"KHAROSHTHI PUNCTUATION CRESCENT BAR",
	"KHAROSHTHI PUNCTUATION DANDA",
	"KHAROSHTHI PUNCTUATION DOT",
	"KHAROSHTHI PUNCTUATION DOUBLE DANDA",
	"KHAROSHTHI PUNCTUATION LINES",
	"KHAROSHTHI PUNCTUATION LOTUS",
	"KHAROSHTHI PUNCTUATION MANGALAM",
	"KHAROSHTHI PUNCTUATION SMALL CIRCLE",
	"KHAROSHTHI SIGN ANUSVARA",
	"KHAROSHTHI SIGN BAR ABOVE",
	"KHAROSHTHI SIGN CAUDA",
	"KHAROSHTHI SIGN DOT BELOW",
	"KHAROSHTHI SIGN DOUBLE RING BELOW",
	"KHAROSHTHI SIGN VISARGA",
	"KHAROSHTHI VIRAMA",
	"KHAROSHTHI VOWEL LENGTH MARK",
	"KHAROSHTHI VOWEL SIGN E",
	"KHAROSHTHI VOWEL SIGN I",
	"KHAROSHTHI VOWEL SIGN O",
	"KHAROSHTHI VOWEL SIGN U",
	"KHAROSHTHI VOWEL SIGN VOCALIC R",
	"KHMER CURRENCY SYMBOL RIEL",
	"KHMER DIGIT EIGHT",
	"KHMER DIGIT FIVE",
	"KHMER DIGIT FOUR",
	"KHMER DIGIT NINE",
	"KHMER DIGIT ONE",
	"KHMER DIGIT SEVEN",
	"KHMER DIGIT SIX",
	"KHMER DIGIT THREE",
	"KHMER DIGIT TWO",
	"KHMER DIGIT ZERO",
	"KHMER INDEPENDENT VOWEL LY",
	"KHMER INDEPENDENT VOWEL LYY",
	"KHMER INDEPENDENT VOWEL QAA",
	"KHMER INDEPENDENT VOWEL QAI",
	"KHMER INDEPENDENT VOWEL QAQ",
	"KHMER INDEPENDENT VOWEL QAU",
	"KHMER INDEPENDENT VOWEL QE",
	"KHMER INDEPENDENT VOWEL QI",
	"KHMER INDEPENDENT VOWEL QII",
	"KHMER INDEPENDENT VOWEL QOO TYPE ONE",
	"KHMER INDEPENDENT VOWEL QOO TYPE TWO",
	"KHMER INDEPENDENT VOWEL QU",
	"KHMER INDEPENDENT VOWEL QUK",
	"KHMER INDEPENDENT VOWEL QUU",
	"KHMER INDEPENDENT VOWEL QUUV",
	"KHMER INDEPENDENT VOWEL RY",
	"KHMER INDEPENDENT VOWEL RYY",
	"KHMER LETTER BA",
	"KHMER LETTER CA",
	"KHMER LETTER CHA",
	"KHMER LETTER CHO",
	"KHMER LETTER CO",
	"KHMER LETTER DA",
	"KHMER LETTER DO",
	"KHMER LETTER HA",
	"KHMER LETTER KA",
	"KHMER LETTER KHA",
	"KHMER LETTER KHO",
	"KHMER LETTER KO",
	"KHMER LETTER LA",
	"KHMER LETTER LO",
	"KHMER LETTER MO",
	"KHMER LETTER NGO",
	"KHMER LETTER NNO",
	"KHMER LETTER NO",
	"KHMER LETTER NYO",
	"KHMER LETTER PHA",
	"KHMER LETTER PHO",
	"KHMER LETTER PO",
	"KHMER LETTER QA",
	"KHMER LETTER RO",
	"KHMER LETTER SA",
	"KHMER LETTER SHA",
	"KHMER LETTER SSO",
	"KHMER LETTER TA",
	"KHMER LETTER THA",
	"KHMER LETTER THO",
	"KHMER LETTER TO",
	"KHMER LETTER TTHA",
	"KHMER LETTER TTHO",
	"KHMER LETTER VO",
	"KHMER LETTER YO",
	"KHMER SIGN AHSDA",
	"KHMER SIGN ATTHACAN",
	"KHMER SIGN AVAKRAHASANYA",
	"KHMER SIGN BANTOC",
	"KHMER SIGN BARIYOOSAN",
	"KHMER SIGN BATHAMASAT",
	"KHMER SIGN BEYYAL",
	"KHMER SIGN CAMNUC PII KUUH",
	"KHMER SIGN COENG",
	"KHMER SIGN KAKABAT",
	"KHMER SIGN KHAN",
	"KHMER SIGN KOOMUUT",
	"KHMER SIGN LEK TOO",
	"KHMER SIGN MUUSIKATOAN",
	"KHMER SIGN NIKAHIT",
	"KHMER SIGN PHNAEK MUAN",
	"KHMER SIGN REAHMUK",
	"KHMER SIGN ROBAT",
	"KHMER SIGN SAMYOK SANNYA",
	"KHMER SIGN TOANDAKHIAT",
	"KHMER SIGN TRIISAP",
	"KHMER SIGN VIRIAM",
	"KHMER SIGN YUUKALEAPINTU",
	"KHMER SYMBOL BEI KOET",
	"KHMER SYMBOL BEI ROC",
	"KHMER SYMBOL BUON KOET",
	"KHMER SYMBOL BUON ROC",
	"KHMER SYMBOL DAP KOET",
	"KHMER SYMBOL DAP ROC",
	"KHMER SYMBOL DAP-BEI KOET",
	"KHMER SYMBOL DAP-BEI ROC",
	"KHMER SYMBOL DAP-BUON KOET",
	"KHMER SYMBOL DAP-BUON ROC",
	"KHMER SYMBOL DAP-MUOY KOET",
	"KHMER SYMBOL DAP-MUOY ROC",
	"KHMER SYMBOL DAP-PII KOET",
	"KHMER SYMBOL DAP-PII ROC",
	"KHMER SYMBOL DAP-PRAM KOET",
	"KHMER SYMBOL DAP-PRAM ROC",
	"KHMER SYMBOL LEK ATTAK BEI",
	"KHMER SYMBOL LEK ATTAK BUON",
	"KHMER SYMBOL LEK ATTAK MUOY",
	"KHMER SYMBOL LEK ATTAK PII",
	"KHMER SYMBOL LEK ATTAK PRAM",
	"KHMER SYMBOL LEK ATTAK PRAM-BEI",
	"KHMER SYMBOL LEK ATTAK PRAM-BUON",
	"KHMER SYMBOL LEK ATTAK PRAM-MUOY",
	"KHMER SYMBOL LEK ATTAK PRAM-PII",
	"KHMER SYMBOL LEK ATTAK SON",
	"KHMER SYMBOL MUOY KOET",
	"KHMER SYMBOL MUOY ROC",
	"KHMER SYMBOL PATHAMASAT",
	"KHMER SYMBOL PII KOET",
	"KHMER SYMBOL PII ROC",
	"KHMER SYMBOL PRAM KOET",
	"KHMER SYMBOL PRAM ROC",
	"KHMER SYMBOL PRAM-BEI KOET",
	"KHMER SYMBOL PRAM-BEI ROC",
	"KHMER SYMBOL PRAM-BUON KOET",
	"KHMER SYMBOL PRAM-BUON ROC",
	"KHMER SYMBOL PRAM-MUOY KOET",
	"KHMER SYMBOL PRAM-MUOY ROC",
	"KHMER SYMBOL PRAM-PII KOET",
	"KHMER SYMBOL PRAM-PII ROC",
	"KHMER SYMBOL TUTEYASAT",
	"KHMER VOWEL INHERENT AA",
	"KHMER VOWEL INHERENT AQ",
	"KHMER VOWEL SIGN AA",
	"KHMER VOWEL SIGN AE",
	"KHMER VOWEL SIGN AI",
	"KHMER VOWEL SIGN AU",
	"KHMER VOWEL SIGN E",
	"KHMER VOWEL SIGN I",
	"KHMER VOWEL SIGN IE",
	"KHMER VOWEL SIGN II",
	"KHMER VOWEL SIGN OE",
	"KHMER VOWEL SIGN OO",
	"KHMER VOWEL SIGN U",
	"KHMER VOWEL SIGN UA",
	"KHMER VOWEL SIGN UU",
	"KHMER VOWEL SIGN Y",
	"KHMER VOWEL SIGN YA",
	"KHMER VOWEL SIGN YY",
	"KIMONO",
	"KIP SIGN",
	"KISS",
	"KISS MARK",
	"KISSING CAT FACE WITH CLOSED EYES",
	"KISSING FACE",
	"KISSING FACE WITH CLOSED EYES",
	"KISSING FACE WITH SMILING EYES",
	"KOALA",
	"KOREAN STANDARD SYMBOL",
	"L B BAR SYMBOL",
	"LADY BEETLE",
	"LANGUAGE TAG",
	"LAO CANCELLATION MARK",
	"LAO DIGIT EIGHT",
	"LAO DIGIT FIVE",
	"LAO DIGIT FOUR",
	"LAO DIGIT NINE",
	"LAO DIGIT ONE",
	"LAO DIGIT SEVEN",
	"LAO DIGIT SIX",
	"LAO DIGIT THREE",
	"LAO DIGIT TWO",
	"LAO DIGIT ZERO",
	"LAO ELLIPSIS",
	"LAO HO MO",
	"LAO HO NO",
	"LAO KO LA",
	"LAO LETTER BO",
	"LAO LETTER CO",
	"LAO LETTER DO",
	"LAO LETTER FO SUNG",
	"LAO LETTER FO TAM",
	"LAO LETTER HO SUNG",
	"LAO LETTER HO TAM",
	"LAO LETTER KHMU GO",
	"LAO LETTER KHMU NYO",
	"LAO LETTER KHO SUNG",
	"LAO LETTER KHO TAM",
	"LAO LETTER KO",
	"LAO LETTER LO LING",
	"LAO LETTER LO LOOT",
	"LAO LETTER MO",
	"LAO LETTER NGO",
	"LAO LETTER NO",
	"LAO LETTER NYO",
	"LAO LETTER O",
	"LAO LETTER PHO SUNG",
	"LAO LETTER PHO TAM",
	"LAO LETTER PO",
	"LAO LETTER SO SUNG",
	"LAO LETTER SO TAM",
	"LAO LETTER THO SUNG",
	"LAO LETTER THO TAM",
	"LAO LETTER TO",
	"LAO LETTER WO",
	"LAO LETTER YO",
	"LAO NIGGAHITA",
	"LAO SEMIVOWEL SIGN LO",
	"LAO SEMIVOWEL SIGN NYO",
	"LAO TONE MAI CATAWA",
	"LAO TONE MAI EK",
	"LAO TONE MAI THO",
	"LAO TONE MAI TI",
	"LAO VOWEL SIGN A",
	"LAO VOWEL SIGN AA",
	"LAO VOWEL SIGN AI",
	"LAO VOWEL SIGN AM",
	"LAO VOWEL SIGN AY",
	"LAO VOWEL SIGN E",
	"LAO VOWEL SIGN EI",
	"LAO VOWEL SIGN I",
	"LAO VOWEL SIGN II",
	"LAO VOWEL SIGN MAI KAN",
	"LAO VOWEL SIGN MAI KON",
	"LAO VOWEL SIGN O",
	"LAO VOWEL SIGN U",
	"LAO VOWEL SIGN UU",
	"LAO VOWEL SIGN Y",
	"LAO VOWEL SIGN YY",
	"LARGE BLUE CIRCLE",
	"LARGE BLUE DIAMOND",
	"LARGE CIRCLE",
	"LARGE DOWN TACK",
	"LARGE LEFT TRIANGLE OPERATOR",
	"LARGE ONE DOT OVER TWO DOTS PUNCTUATION",
	"LARGE ONE RING OVER TWO RINGS PUNCTUATION",
	"LARGE ORANGE DIAMOND",
	"LARGE RED CIRCLE",
	"LARGE TRIPLE VERTICAL BAR OPERATOR",
	"LARGE TWO DOTS OVER ONE DOT PUNCTUATION",
	"LARGE TWO RINGS OVER ONE RING PUNCTUATION",
	"LARGE UP TACK",
	"LARGER THAN",
	"LARGER THAN OR EQUAL TO",
	"LAST QUARTER MOON",
	"LAST QUARTER MOON SYMBOL",
	"LAST QUARTER MOON WITH FACE",
	"LATIN CAPITAL LETTER A",
	"LATIN CAPITAL LETTER A WITH ACUTE",
	"LATIN CAPITAL LETTER A WITH BREVE",
	"LATIN CAPITAL LETTER A WITH BREVE AND ACUTE",
	"LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW",
	"LATIN CAPITAL LETTER A WITH BREVE AND GRAVE",
	"LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE",
	"LATIN CAPITAL LETTER A WITH BREVE AND TILDE",
	"LATIN CAPITAL LETTER A WITH CARON",
	"LATIN CAPITAL LETTER A WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE",
	"LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW",
	"LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE",
	"LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE",
	"LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE",
	"LATIN CAPITAL LETTER A WITH DIAERESIS",
	"LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON",
	"LATIN CAPITAL LETTER A WITH DOT ABOVE",
	"LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON",
	"LATIN CAPITAL LETTER A WITH DOT BELOW",
	"LATIN CAPITAL LETTER A WITH DOUBLE GRAVE",
	"LATIN CAPITAL LETTER A WITH GRAVE",
	"LATIN CAPITAL LETTER A WITH HOOK ABOVE",
	"LATIN CAPITAL LETTER A WITH INVERTED BREVE",
	"LATIN CAPITAL LETTER A WITH MACRON",
	"LATIN CAPITAL LETTER A WITH OGONEK",
	"LATIN CAPITAL LETTER A WITH RING ABOVE",
	"LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE",
	"LATIN CAPITAL LETTER A WITH RING BELOW",
	"LATIN CAPITAL LETTER A WITH STROKE",
	"LATIN CAPITAL LETTER A WITH TILDE",
	"LATIN CAPITAL LETTER AA",
	"LATIN CAPITAL LETTER AE",
	"LATIN CAPITAL LETTER AE WITH ACUTE",
	"LATIN CAPITAL LETTER AE WITH MACRON",
	"LATIN CAPITAL LETTER AFRICAN D",
	"LATIN CAPITAL LETTER ALPHA",
	"LATIN CAPITAL LETTER AO",
	"LATIN CAPITAL LETTER AU",
	"LATIN CAPITAL LETTER AV",
	"LATIN CAPITAL LETTER AV WITH HORIZONTAL BAR",
	"LATIN CAPITAL LETTER AY",
	"LATIN CAPITAL LETTER B",
	"LATIN CAPITAL LETTER B WITH DOT ABOVE",
	"LATIN CAPITAL LETTER B WITH DOT BELOW",
	"LATIN CAPITAL LETTER B WITH HOOK",
	"LATIN CAPITAL LETTER B WITH LINE BELOW",
	"LATIN CAPITAL LETTER B WITH STROKE",
	"LATIN CAPITAL LETTER B WITH TOPBAR",
	"LATIN CAPITAL LETTER BROKEN L",
	"LATIN CAPITAL LETTER C",
	"LATIN CAPITAL LETTER C WITH ACUTE",
	"LATIN CAPITAL LETTER C WITH BAR",
	"LATIN CAPITAL LETTER C WITH CARON",
	"LATIN CAPITAL LETTER C WITH CEDILLA",
	"LATIN CAPITAL LETTER C WITH CEDILLA AND ACUTE",
	"LATIN CAPITAL LETTER C WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER C WITH DOT ABOVE",
	"LATIN CAPITAL LETTER C WITH HOOK",
	"LATIN CAPITAL LETTER C WITH STROKE",
	"LATIN CAPITAL LETTER CON",
	"LATIN CAPITAL LETTER CUATRILLO",
	"LATIN CAPITAL LETTER CUATRILLO WITH COMMA",
	"LATIN CAPITAL LETTER D",
	"LATIN CAPITAL LETTER D WITH CARON",
	"LATIN CAPITAL LETTER D WITH CEDILLA",
	"LATIN CAPITAL LETTER D WITH CIRCUMFLEX BELOW",
	"LATIN CAPITAL LETTER D WITH DOT ABOVE",
	"LATIN CAPITAL LETTER D WITH DOT BELOW",
	"LATIN CAPITAL LETTER D WITH HOOK",
	"LATIN CAPITAL LETTER D WITH LINE BELOW",
	"LATIN CAPITAL LETTER D WITH SMALL LETTER Z",
	"LATIN CAPITAL LETTER D WITH SMALL LETTER Z WITH CARON",
	"LATIN CAPITAL LETTER D WITH STROKE",
	"LATIN CAPITAL LETTER D WITH TOPBAR",
	"LATIN CAPITAL LETTER DZ",
	"LATIN CAPITAL LETTER DZ WITH CARON",
	"LATIN CAPITAL LETTER E",
	"LATIN CAPITAL LETTER E WITH ACUTE",
	"LATIN CAPITAL LETTER E WITH BREVE",
	"LATIN CAPITAL LETTER E WITH CARON",
	"LATIN CAPITAL LETTER E WITH CEDILLA",
	"LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE",
	"LATIN CAPITAL LETTER E WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE",
	"LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW",
	"LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE",
	"LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE",
	"LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE",
	"LATIN CAPITAL LETTER E WITH CIRCUMFLEX BELOW",
	"LATIN CAPITAL LETTER E WITH DIAERESIS",
	"LATIN CAPITAL LETTER E WITH DOT ABOVE",
	"LATIN CAPITAL LETTER E WITH DOT BELOW",
	"LATIN CAPITAL LETTER E WITH DOUBLE GRAVE",
	"LATIN CAPITAL LETTER E WITH GRAVE",
	"LATIN CAPITAL LETTER E WITH HOOK ABOVE",
	"LATIN CAPITAL LETTER E WITH INVERTED BREVE",
	"LATIN CAPITAL LETTER E WITH MACRON",
	"LATIN CAPITAL LETTER E WITH MACRON AND ACUTE",
	"LATIN CAPITAL LETTER E WITH MACRON AND GRAVE",
	"LATIN CAPITAL LETTER E WITH OGONEK",
	"LATIN CAPITAL LETTER E WITH STROKE",
	"LATIN CAPITAL LETTER E WITH TILDE",
	"LATIN CAPITAL LETTER E WITH TILDE BELOW",
	"LATIN CAPITAL LETTER EGYPTOLOGICAL AIN",
	"LATIN CAPITAL LETTER EGYPTOLOGICAL ALEF",
	"LATIN CAPITAL LETTER ENG",
	"LATIN CAPITAL LETTER ESH",
	"LATIN CAPITAL LETTER ET",
	"LATIN CAPITAL LETTER ETH",
	"LATIN CAPITAL LETTER EZH",
	"LATIN CAPITAL LETTER EZH REVERSED",
	"LATIN CAPITAL LETTER EZH WITH CARON",
	"LATIN CAPITAL LETTER F",
	"LATIN CAPITAL LETTER F WITH DOT ABOVE",
	"LATIN CAPITAL LETTER F WITH HOOK",
	"LATIN CAPITAL LETTER G",
	"LATIN CAPITAL LETTER G WITH ACUTE",
	"LATIN CAPITAL LETTER G WITH BREVE",
	"LATIN CAPITAL LETTER G WITH CARON",
	"LATIN CAPITAL LETTER G WITH CEDILLA",
	"LATIN CAPITAL LETTER G WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER G WITH DOT ABOVE",
	"LATIN CAPITAL LETTER G WITH HOOK",
	"LATIN CAPITAL LETTER G WITH MACRON",
	"LATIN CAPITAL LETTER G WITH OBLIQUE STROKE",
	"LATIN CAPITAL LETTER G WITH STROKE",
	"LATIN CAPITAL LETTER GAMMA",
	"LATIN CAPITAL LETTER GLOTTAL STOP",
	"LATIN CAPITAL LETTER H",
	"LATIN CAPITAL LETTER H WITH BREVE BELOW",
	"LATIN CAPITAL LETTER H WITH CARON",
	"LATIN CAPITAL LETTER H WITH CEDILLA",
	"LATIN CAPITAL LETTER H WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER H WITH DESCENDER",
	"LATIN CAPITAL LETTER H WITH DIAERESIS",
	"LATIN CAPITAL LETTER H WITH DOT ABOVE",
	"LATIN CAPITAL LETTER H WITH DOT BELOW",
	"LATIN CAPITAL LETTER H WITH HOOK",
	"LATIN CAPITAL LETTER H WITH STROKE",
	"LATIN CAPITAL LETTER HALF H",
	"LATIN CAPITAL LETTER HENG",
	"LATIN CAPITAL LETTER HWAIR",
	"LATIN CAPITAL LETTER I",
	"LATIN CAPITAL LETTER I WITH ACUTE",
	"LATIN CAPITAL LETTER I WITH BREVE",
	"LATIN CAPITAL LETTER I WITH CARON",
	"LATIN CAPITAL LETTER I WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER I WITH DIAERESIS",
	"LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE",
	"LATIN CAPITAL LETTER I WITH DOT ABOVE",
	"LATIN CAPITAL LETTER I WITH DOT BELOW",
	"LATIN CAPITAL LETTER I WITH DOUBLE GRAVE",
	"LATIN CAPITAL LETTER I WITH GRAVE",
	"LATIN CAPITAL LETTER I WITH HOOK ABOVE",
	"LATIN CAPITAL LETTER I WITH INVERTED BREVE",
	"LATIN CAPITAL LETTER I WITH MACRON",
	"LATIN CAPITAL LETTER I WITH OGONEK",
	"LATIN CAPITAL LETTER I WITH STROKE",
	"LATIN CAPITAL LETTER I WITH TILDE",
	"LATIN CAPITAL LETTER I WITH TILDE BELOW",
	"LATIN CAPITAL LETTER INSULAR D",
	"LATIN CAPITAL LETTER INSULAR F",
	"LATIN CAPITAL LETTER INSULAR G",
	"LATIN CAPITAL LETTER INSULAR R",
	"LATIN CAPITAL LETTER INSULAR S",
	"LATIN CAPITAL LETTER INSULAR T",
	"LATIN CAPITAL LETTER IOTA",
	"LATIN CAPITAL LETTER IS",
	"LATIN CAPITAL LETTER J",
	"LATIN CAPITAL LETTER J WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER J WITH STROKE",
	"LATIN CAPITAL LETTER K",
	"LATIN CAPITAL LETTER K WITH ACUTE",
	"LATIN CAPITAL LETTER K WITH CARON",
	"LATIN CAPITAL LETTER K WITH CEDILLA",
	"LATIN CAPITAL LETTER K WITH DESCENDER",
	"LATIN CAPITAL LETTER K WITH DIAGONAL STROKE",
	"LATIN CAPITAL LETTER K WITH DOT BELOW",
	"LATIN CAPITAL LETTER K WITH HOOK",
	"LATIN CAPITAL LETTER K WITH LINE BELOW",
	"LATIN CAPITAL LETTER K WITH OBLIQUE STROKE",
	"LATIN CAPITAL LETTER K WITH STROKE",
	"LATIN CAPITAL LETTER K WITH STROKE AND DIAGONAL STROKE",
	"LATIN CAPITAL LETTER L",
	"LATIN CAPITAL LETTER L WITH ACUTE",
	"LATIN CAPITAL LETTER L WITH BAR",
	"LATIN CAPITAL LETTER L WITH CARON",
	"LATIN CAPITAL LETTER L WITH CEDILLA",
	"LATIN CAPITAL LETTER L WITH CIRCUMFLEX BELOW",
	"LATIN CAPITAL LETTER L WITH DOT BELOW",
	"LATIN CAPITAL LETTER L WITH DOT BELOW AND MACRON",
	"LATIN CAPITAL LETTER L WITH DOUBLE BAR",
	"LATIN CAPITAL LETTER L WITH HIGH STROKE",
	"LATIN CAPITAL LETTER L WITH LINE BELOW",
	"LATIN CAPITAL LETTER L WITH MIDDLE DOT",
	"LATIN CAPITAL LETTER L WITH MIDDLE TILDE",
	"LATIN CAPITAL LETTER L WITH SMALL LETTER J",
	"LATIN CAPITAL LETTER L WITH STROKE",
	"LATIN CAPITAL LETTER LJ",
	"LATIN CAPITAL LETTER M",
	"LATIN CAPITAL LETTER M WITH ACUTE",
	"LATIN CAPITAL LETTER M WITH DOT ABOVE",
	"LATIN CAPITAL LETTER M WITH DOT BELOW",
	"LATIN CAPITAL LETTER M WITH HOOK",
	"LATIN CAPITAL LETTER MIDDLE-WELSH LL",
	"LATIN CAPITAL LETTER MIDDLE-WELSH V",
	"LATIN CAPITAL LETTER N",
	"LATIN CAPITAL LETTER N WITH ACUTE",
	"LATIN CAPITAL LETTER N WITH CARON",
	"LATIN CAPITAL LETTER N WITH CEDILLA",
	"LATIN CAPITAL LETTER N WITH CIRCUMFLEX BELOW",
	"LATIN CAPITAL LETTER N WITH DESCENDER",
	"LATIN CAPITAL LETTER N WITH DOT ABOVE",
	"LATIN CAPITAL LETTER N WITH DOT BELOW",
	"LATIN CAPITAL LETTER N WITH GRAVE",
	"LATIN CAPITAL LETTER N WITH LEFT HOOK",
	"LATIN CAPITAL LETTER N WITH LINE BELOW",
	"LATIN CAPITAL LETTER N WITH LONG RIGHT LEG",
	"LATIN CAPITAL LETTER N WITH OBLIQUE STROKE",
	"LATIN CAPITAL LETTER N WITH SMALL LETTER J",
	"LATIN CAPITAL LETTER N WITH TILDE",
	"LATIN CAPITAL LETTER NJ",
	"LATIN CAPITAL LETTER O",
	"LATIN CAPITAL LETTER O WITH ACUTE",
	"LATIN CAPITAL LETTER O WITH BREVE",
	"LATIN CAPITAL LETTER O WITH CARON",
	"LATIN CAPITAL LETTER O WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE",
	"LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW",
	"LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE",
	"LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE",
	"LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE",
	"LATIN CAPITAL LETTER O WITH DIAERESIS",
	"LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON",
	"LATIN CAPITAL LETTER O WITH DOT ABOVE",
	"LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON",
	"LATIN CAPITAL LETTER O WITH DOT BELOW",
	"LATIN CAPITAL LETTER O WITH DOUBLE ACUTE",
	"LATIN CAPITAL LETTER O WITH DOUBLE GRAVE",
	"LATIN CAPITAL LETTER O WITH GRAVE",
	"LATIN CAPITAL LETTER O WITH HOOK ABOVE",
	"LATIN CAPITAL LETTER O WITH HORN",
	"LATIN CAPITAL LETTER O WITH HORN AND ACUTE",
	"LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW",
	"LATIN CAPITAL LETTER O WITH HORN AND GRAVE",
	"LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE",
	"LATIN CAPITAL LETTER O WITH HORN AND TILDE",
	"LATIN CAPITAL LETTER O WITH INVERTED BREVE",
	"LATIN CAPITAL LETTER O WITH LONG STROKE OVERLAY",
	"LATIN CAPITAL LETTER O WITH LOOP",
	"LATIN CAPITAL LETTER O WITH MACRON",
	"LATIN CAPITAL LETTER O WITH MACRON AND ACUTE",
	"LATIN CAPITAL LETTER O WITH MACRON AND GRAVE",
	"LATIN CAPITAL LETTER O WITH MIDDLE TILDE",
	"LATIN CAPITAL LETTER O WITH OGONEK",
	"LATIN CAPITAL LETTER O WITH OGONEK AND MACRON",
	"LATIN CAPITAL LETTER O WITH STROKE",
	"LATIN CAPITAL LETTER O WITH STROKE AND ACUTE",
	"LATIN CAPITAL LETTER O WITH TILDE",
	"LATIN CAPITAL LETTER O WITH TILDE AND ACUTE",
	"LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS",
	"LATIN CAPITAL LETTER O WITH TILDE AND MACRON",
	"LATIN CAPITAL LETTER OI",
	"LATIN CAPITAL LETTER OO",
	"LATIN CAPITAL LETTER OPEN E",
	"LATIN CAPITAL LETTER OPEN O",
	"LATIN CAPITAL LETTER OU",
	"LATIN CAPITAL LETTER P",
	"LATIN CAPITAL LETTER P WITH ACUTE",
	"LATIN CAPITAL LETTER P WITH DOT ABOVE",
	"LATIN CAPITAL LETTER P WITH FLOURISH",
	"LATIN CAPITAL LETTER P WITH HOOK",
	"LATIN CAPITAL LETTER P WITH SQUIRREL TAIL",
	"LATIN CAPITAL LETTER P WITH STROKE",
	"LATIN CAPITAL LETTER P WITH STROKE THROUGH DESCENDER",
	"LATIN CAPITAL LETTER Q",
	"LATIN CAPITAL LETTER Q WITH DIAGONAL STROKE",
	"LATIN CAPITAL LETTER Q WITH STROKE THROUGH DESCENDER",
	"LATIN CAPITAL LETTER R",
	"LATIN CAPITAL LETTER R ROTUNDA",
	"LATIN CAPITAL LETTER R WITH ACUTE",
	"LATIN CAPITAL LETTER R WITH CARON",
	"LATIN CAPITAL LETTER R WITH CEDILLA",
	"LATIN CAPITAL LETTER R WITH DOT ABOVE",
	"LATIN CAPITAL LETTER R WITH DOT BELOW",
	"LATIN CAPITAL LETTER R WITH DOT BELOW AND MACRON",
	"LATIN CAPITAL LETTER R WITH DOUBLE GRAVE",
	"LATIN CAPITAL LETTER R WITH INVERTED BREVE",
	"LATIN CAPITAL LETTER R WITH LINE BELOW",
	"LATIN CAPITAL LETTER R WITH OBLIQUE STROKE",
	"LATIN CAPITAL LETTER R WITH STROKE",
	"LATIN CAPITAL LETTER R WITH TAIL",
	"LATIN CAPITAL LETTER REVERSED C WITH DOT",
	"LATIN CAPITAL LETTER REVERSED E",
	"LATIN CAPITAL LETTER RUM ROTUNDA",
	"LATIN CAPITAL LETTER S",
	"LATIN CAPITAL LETTER S WITH ACUTE",
	"LATIN CAPITAL LETTER S WITH ACUTE AND DOT ABOVE",
	"LATIN CAPITAL LETTER S WITH CARON",
	"LATIN CAPITAL LETTER S WITH CARON AND DOT ABOVE",
	"LATIN CAPITAL LETTER S WITH CEDILLA",
	"LATIN CAPITAL LETTER S WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER S WITH COMMA BELOW",
	"LATIN CAPITAL LETTER S WITH DOT ABOVE",
	"LATIN CAPITAL LETTER S WITH DOT BELOW",
	"LATIN CAPITAL LETTER S WITH DOT BELOW AND DOT ABOVE",
	"LATIN CAPITAL LETTER S WITH OBLIQUE STROKE",
	"LATIN CAPITAL LETTER S WITH SWASH TAIL",
	"LATIN CAPITAL LETTER SALTILLO",
	"LATIN CAPITAL LETTER SCHWA",
	"LATIN CAPITAL LETTER SHARP S",
	"LATIN CAPITAL LETTER SMALL Q WITH HOOK TAIL",
	"LATIN CAPITAL LETTER T",
	"LATIN CAPITAL LETTER T WITH CARON",
	"LATIN CAPITAL LETTER T WITH CEDILLA",
	"LATIN CAPITAL LETTER T WITH CIRCUMFLEX BELOW",
	"LATIN CAPITAL LETTER T WITH COMMA BELOW",
	"LATIN CAPITAL LETTER T WITH DIAGONAL STROKE",
	"LATIN CAPITAL LETTER T WITH DOT ABOVE",
	"LATIN CAPITAL LETTER T WITH DOT BELOW",
	"LATIN CAPITAL LETTER T WITH HOOK",
	"LATIN CAPITAL LETTER T WITH LINE BELOW",
	"LATIN CAPITAL LETTER T WITH RETROFLEX HOOK",
	"LATIN CAPITAL LETTER T WITH STROKE",
	"LATIN CAPITAL LETTER THORN",
	"LATIN CAPITAL LETTER THORN WITH STROKE",
	"LATIN CAPITAL LETTER THORN WITH STROKE THROUGH DESCENDER",
	"LATIN CAPITAL LETTER TONE FIVE",
	"LATIN CAPITAL LETTER TONE SIX",
	"LATIN CAPITAL LETTER TONE TWO",
	"LATIN CAPITAL LETTER TRESILLO",
	"LATIN CAPITAL LETTER TURNED A",
	"LATIN CAPITAL LETTER TURNED ALPHA",
	"LATIN CAPITAL LETTER TURNED H",
	"LATIN CAPITAL LETTER TURNED INSULAR G",
	"LATIN CAPITAL LETTER TURNED L",
	"LATIN CAPITAL LETTER TURNED M",
	"LATIN CAPITAL LETTER TURNED V",
	"LATIN CAPITAL LETTER TZ",
	"LATIN CAPITAL LETTER U",
	"LATIN CAPITAL LETTER U BAR",
	"LATIN CAPITAL LETTER U WITH ACUTE",
	"LATIN CAPITAL LETTER U WITH BREVE",
	"LATIN CAPITAL LETTER U WITH CARON",
	"LATIN CAPITAL LETTER U WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER U WITH CIRCUMFLEX BELOW",
	"LATIN CAPITAL LETTER U WITH DIAERESIS",
	"LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE",
	"LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON",
	"LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE",
	"LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON",
	"LATIN CAPITAL LETTER U WITH DIAERESIS BELOW",
	"LATIN CAPITAL LETTER U WITH DOT BELOW",
	"LATIN CAPITAL LETTER U WITH DOUBLE ACUTE",
	"LATIN CAPITAL LETTER U WITH DOUBLE GRAVE",
	"LATIN CAPITAL LETTER U WITH GRAVE",
	"LATIN CAPITAL LETTER U WITH HOOK ABOVE",
	"LATIN CAPITAL LETTER U WITH HORN",
	"LATIN CAPITAL LETTER U WITH HORN AND ACUTE",
	"LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW",
	"LATIN CAPITAL LETTER U WITH HORN AND GRAVE",
	"LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE",
	"LATIN CAPITAL LETTER U WITH HORN AND TILDE",
	"LATIN CAPITAL LETTER U WITH INVERTED BREVE",
	"LATIN CAPITAL LETTER U WITH MACRON",
	"LATIN CAPITAL LETTER U WITH MACRON AND DIAERESIS",
	"LATIN CAPITAL LETTER U WITH OGONEK",
	"LATIN CAPITAL LETTER U WITH RING ABOVE",
	"LATIN CAPITAL LETTER U WITH TILDE",
	"LATIN CAPITAL LETTER U WITH TILDE AND ACUTE",
	"LATIN CAPITAL LETTER U WITH TILDE BELOW",
	"LATIN CAPITAL LETTER UPSILON",
	"LATIN CAPITAL LETTER V",
	"LATIN CAPITAL LETTER V WITH DIAGONAL STROKE",
	"LATIN CAPITAL LETTER V WITH DOT BELOW",
	"LATIN CAPITAL LETTER V WITH HOOK",
	"LATIN CAPITAL LETTER V WITH TILDE",
	"LATIN CAPITAL LETTER VEND",
	"LATIN CAPITAL LETTER VISIGOTHIC Z",
	"LATIN CAPITAL LETTER VY",
	"LATIN CAPITAL LETTER W",
	"LATIN CAPITAL LETTER W WITH ACUTE",
	"LATIN CAPITAL LETTER W WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER W WITH DIAERESIS",
	"LATIN CAPITAL LETTER W WITH DOT ABOVE",
	"LATIN CAPITAL LETTER W WITH DOT BELOW",
	"LATIN CAPITAL LETTER W WITH GRAVE",
	"LATIN CAPITAL LETTER W WITH HOOK",
	"LATIN CAPITAL LETTER WYNN",
	"LATIN CAPITAL LETTER X",
	"LATIN CAPITAL LETTER X WITH DIAERESIS",
	"LATIN CAPITAL LETTER X WITH DOT ABOVE",
	"LATIN CAPITAL LETTER Y",
	"LATIN CAPITAL LETTER Y WITH ACUTE",
	"LATIN CAPITAL LETTER Y WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER Y WITH DIAERESIS",
	"LATIN CAPITAL LETTER Y WITH DOT ABOVE",
	"LATIN CAPITAL LETTER Y WITH DOT BELOW",
	"LATIN CAPITAL LETTER Y WITH GRAVE",
	"LATIN CAPITAL LETTER Y WITH HOOK",
	"LATIN CAPITAL LETTER Y WITH HOOK ABOVE",
	"LATIN CAPITAL LETTER Y WITH LOOP",
	"LATIN CAPITAL LETTER Y WITH MACRON",
	"LATIN CAPITAL LETTER Y WITH STROKE",
	"LATIN CAPITAL LETTER Y WITH TILDE",
	"LATIN CAPITAL LETTER YOGH",
	"LATIN CAPITAL LETTER Z",
	"LATIN CAPITAL LETTER Z WITH ACUTE",
	"LATIN CAPITAL LETTER Z WITH CARON",
	"LATIN CAPITAL LETTER Z WITH CIRCUMFLEX",
	"LATIN CAPITAL LETTER Z WITH DESCENDER",
	"LATIN CAPITAL LETTER Z WITH DOT ABOVE",
	"LATIN CAPITAL LETTER Z WITH DOT BELOW",
	"LATIN CAPITAL LETTER Z WITH HOOK",
	"LATIN CAPITAL LETTER Z WITH LINE BELOW",
	"LATIN CAPITAL LETTER Z WITH STROKE",
	"LATIN CAPITAL LETTER Z WITH SWASH TAIL",
	"LATIN CAPITAL LIGATURE IJ",
	"LATIN CAPITAL LIGATURE OE",
	"LATIN CROSS",
	"LATIN EPIGRAPHIC LETTER ARCHAIC M",
	"LATIN EPIGRAPHIC LETTER I LONGA",
	"LATIN EPIGRAPHIC LETTER INVERTED M",
	"LATIN EPIGRAPHIC LETTER REVERSED F",
	"LATIN EPIGRAPHIC LETTER REVERSED P",
	"LATIN LETTER AIN",
	"LATIN LETTER ALVEOLAR CLICK",
	"LATIN LETTER BIDENTAL PERCUSSIVE",
	"LATIN LETTER BILABIAL CLICK",
	"LATIN LETTER BILABIAL PERCUSSIVE",
	"LATIN LETTER DENTAL CLICK",
	"LATIN LETTER GLOTTAL STOP",
	"LATIN LETTER GLOTTAL STOP WITH STROKE",
	"LATIN LETTER INVERTED GLOTTAL STOP",
	"LATIN LETTER INVERTED GLOTTAL STOP WITH STROKE",
	"LATIN LETTER LATERAL CLICK",
	"LATIN LETTER PHARYNGEAL VOICED FRICATIVE",
	"LATIN LETTER RETROFLEX CLICK",
	"LATIN LETTER REVERSED ESH LOOP",
	"LATIN LETTER REVERSED GLOTTAL STOP WITH STROKE",
	"LATIN LETTER SMALL CAPITAL A",
	"LATIN LETTER SMALL CAPITAL AE",
	"LATIN LETTER SMALL CAPITAL B",
	"LATIN LETTER SMALL CAPITAL BARRED B",
	"LATIN LETTER SMALL CAPITAL C",
	"LATIN LETTER SMALL CAPITAL D",
	"LATIN LETTER SMALL CAPITAL E",
	"LATIN LETTER SMALL CAPITAL ETH",
	"LATIN LETTER SMALL CAPITAL EZH",
	"LATIN LETTER SMALL CAPITAL F",
	"LATIN LETTER SMALL CAPITAL G",
	"LATIN LETTER SMALL CAPITAL G WITH HOOK",
	"LATIN LETTER SMALL CAPITAL H",
	"LATIN LETTER SMALL CAPITAL I",
	"LATIN LETTER SMALL CAPITAL INVERTED R",
	"LATIN LETTER SMALL CAPITAL J",
	"LATIN LETTER SMALL CAPITAL K",
	"LATIN LETTER SMALL CAPITAL L",
	"LATIN LETTER SMALL CAPITAL L WITH STROKE",
	"LATIN LETTER SMALL CAPITAL M",
	"LATIN LETTER SMALL CAPITAL N",
	"LATIN LETTER SMALL CAPITAL O",
	"LATIN LETTER SMALL CAPITAL OE",
	"LATIN LETTER SMALL CAPITAL OPEN O",
	"LATIN LETTER SMALL CAPITAL OU",
	"LATIN LETTER SMALL CAPITAL P",
	"LATIN LETTER SMALL CAPITAL R",
	"LATIN LETTER SMALL CAPITAL REVERSED N",
	"LATIN LETTER SMALL CAPITAL REVERSED R",
	"LATIN LETTER SMALL CAPITAL RUM",
	"LATIN LETTER SMALL CAPITAL S",
	"LATIN LETTER SMALL CAPITAL T",
	"LATIN LETTER SMALL CAPITAL TURNED E",
	"LATIN LETTER SMALL CAPITAL TURNED M",
	"LATIN LETTER SMALL CAPITAL TURNED R",
	"LATIN LETTER SMALL CAPITAL U",
	"LATIN LETTER SMALL CAPITAL V",
	"LATIN LETTER SMALL CAPITAL W",
	"LATIN LETTER SMALL CAPITAL Y",
	"LATIN LETTER SMALL CAPITAL Z",
	"LATIN LETTER STRETCHED C",
	"LATIN LETTER TWO WITH STROKE",
	"LATIN LETTER VOICED LARYNGEAL SPIRANT",
	"LATIN LETTER WYNN",
	"LATIN LETTER YR",
	"LATIN SMALL CAPITAL LETTER I WITH STROKE",
	"LATIN SMALL CAPITAL LETTER U WITH STROKE",
	"LATIN SMALL LETTER A",
	"LATIN SMALL LETTER A WITH ACUTE",
	"LATIN SMALL LETTER A WITH BREVE",
	"LATIN SMALL LETTER A WITH BREVE AND ACUTE",
	"LATIN SMALL LETTER A WITH BREVE AND DOT BELOW",
	"LATIN SMALL LETTER A WITH BREVE AND GRAVE",
	"LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE",
	"LATIN SMALL LETTER A WITH BREVE AND TILDE",
	"LATIN SMALL LETTER A WITH CARON",
	"LATIN SMALL LETTER A WITH CIRCUMFLEX",
	"LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE",
	"LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW",
	"LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE",
	"LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE",
	"LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE",
	"LATIN SMALL LETTER A WITH DIAERESIS",
	"LATIN SMALL LETTER A WITH DIAERESIS AND MACRON",
	"LATIN SMALL LETTER A WITH DOT ABOVE",
	"LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON",
	"LATIN SMALL LETTER A WITH DOT BELOW",
	"LATIN SMALL LETTER A WITH DOUBLE GRAVE",
	"LATIN SMALL LETTER A WITH GRAVE",
	"LATIN SMALL LETTER A WITH HOOK ABOVE",
	"LATIN SMALL LETTER A WITH INVERTED BREVE",
	"LATIN SMALL LETTER A WITH MACRON",
	"LATIN SMALL LETTER A WITH OGONEK",
	"LATIN SMALL LETTER A WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER A WITH RIGHT HALF RING",
	"LATIN SMALL LETTER A WITH RING ABOVE",
	"LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE",
	"LATIN SMALL LETTER A WITH RING BELOW",
	"LATIN SMALL LETTER A WITH STROKE",
	"LATIN SMALL LETTER A WITH TILDE",
	"LATIN SMALL LETTER AA",
	"LATIN SMALL LETTER AE",
	"LATIN SMALL LETTER AE WITH ACUTE",
	"LATIN SMALL LETTER AE WITH MACRON",
	"LATIN SMALL LETTER ALPHA",
	"LATIN SMALL LETTER ALPHA WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER AO",
	"LATIN SMALL LETTER AU",
	"LATIN SMALL LETTER AV",
	"LATIN SMALL LETTER AV WITH HORIZONTAL BAR",
	"LATIN SMALL LETTER AY",
	"LATIN SMALL LETTER B",
	"LATIN SMALL LETTER B WITH DOT ABOVE",
	"LATIN SMALL LETTER B WITH DOT BELOW",
	"LATIN SMALL LETTER B WITH HOOK",
	"LATIN SMALL LETTER B WITH LINE BELOW",
	"LATIN SMALL LETTER B WITH MIDDLE TILDE",
	"LATIN SMALL LETTER B WITH PALATAL HOOK",
	"LATIN SMALL LETTER B WITH STROKE",
	"LATIN SMALL LETTER B WITH TOPBAR",
	"LATIN SMALL LETTER BARRED O",
	"LATIN SMALL LETTER BOTTOM HALF O",
	"LATIN SMALL LETTER BROKEN L",
	"LATIN SMALL LETTER C",
	"LATIN SMALL LETTER C WITH ACUTE",
	"LATIN SMALL LETTER C WITH BAR",
	"LATIN SMALL LETTER C WITH CARON",
	"LATIN SMALL LETTER C WITH CEDILLA",
	"LATIN SMALL LETTER C WITH CEDILLA AND ACUTE",
	"LATIN SMALL LETTER C WITH CIRCUMFLEX",
	"LATIN SMALL LETTER C WITH CURL",
	"LATIN SMALL LETTER C WITH DOT ABOVE",
	"LATIN SMALL LETTER C WITH HOOK",
	"LATIN SMALL LETTER C WITH STROKE",
	"LATIN SMALL LETTER CLOSED OMEGA",
	"LATIN SMALL LETTER CLOSED OPEN E",
	"LATIN SMALL LETTER CLOSED REVERSED OPEN E",
	"LATIN SMALL LETTER CON",
	"LATIN SMALL LETTER CUATRILLO",
	"LATIN SMALL LETTER CUATRILLO WITH COMMA",
	"LATIN SMALL LETTER D",
	"LATIN SMALL LETTER D WITH CARON",
	"LATIN SMALL LETTER D WITH CEDILLA",
	"LATIN SMALL LETTER D WITH CIRCUMFLEX BELOW",
	"LATIN SMALL LETTER D WITH CURL",
	"LATIN SMALL LETTER D WITH DOT ABOVE",
	"LATIN SMALL LETTER D WITH DOT BELOW",
	"LATIN SMALL LETTER D WITH HOOK",
	"LATIN SMALL LETTER D WITH HOOK AND TAIL",
	"LATIN SMALL LETTER D WITH LINE BELOW",
	"LATIN SMALL LETTER D WITH MIDDLE TILDE",
	"LATIN SMALL LETTER D WITH PALATAL HOOK",
	"LATIN SMALL LETTER D WITH STROKE",
	"LATIN SMALL LETTER D WITH TAIL",
	"LATIN SMALL LETTER D WITH TOPBAR",
	"LATIN SMALL LETTER DB DIGRAPH",
	"LATIN SMALL LETTER DELTA",
	"LATIN SMALL LETTER DEZH DIGRAPH",
	"LATIN SMALL LETTER DOTLESS I",
	"LATIN SMALL LETTER DOTLESS J",
	"LATIN SMALL LETTER DOTLESS J WITH STROKE",
	"LATIN SMALL LETTER DOTLESS J WITH STROKE AND HOOK",
	"LATIN SMALL LETTER DUM",
	"LATIN SMALL LETTER DZ",
	"LATIN SMALL LETTER DZ DIGRAPH",
	"LATIN SMALL LETTER DZ DIGRAPH WITH CURL",
	"LATIN SMALL LETTER DZ WITH CARON",
	"LATIN SMALL LETTER E",
	"LATIN SMALL LETTER E WITH ACUTE",
	"LATIN SMALL LETTER E WITH BREVE",
	"LATIN SMALL LETTER E WITH CARON",
	"LATIN SMALL LETTER E WITH CEDILLA",
	"LATIN SMALL LETTER E WITH CEDILLA AND BREVE",
	"LATIN SMALL LETTER E WITH CIRCUMFLEX",
	"LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE",
	"LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW",
	"LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE",
	"LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE",
	"LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE",
	"LATIN SMALL LETTER E WITH CIRCUMFLEX BELOW",
	"LATIN SMALL LETTER E WITH DIAERESIS",
	"LATIN SMALL LETTER E WITH DOT ABOVE",
	"LATIN SMALL LETTER E WITH DOT BELOW",
	"LATIN SMALL LETTER E WITH DOUBLE GRAVE",
	"LATIN SMALL LETTER E WITH GRAVE",
	"LATIN SMALL LETTER E WITH HOOK ABOVE",
	"LATIN SMALL LETTER E WITH INVERTED BREVE",
	"LATIN SMALL LETTER E WITH MACRON",
	"LATIN SMALL LETTER E WITH MACRON AND ACUTE",
	"LATIN SMALL LETTER E WITH MACRON AND GRAVE",
	"LATIN SMALL LETTER E WITH NOTCH",
	"LATIN SMALL LETTER E WITH OGONEK",
	"LATIN SMALL LETTER E WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER E WITH STROKE",
	"LATIN SMALL LETTER E WITH TILDE",
	"LATIN SMALL LETTER E WITH TILDE BELOW",
	"LATIN SMALL LETTER EGYPTOLOGICAL AIN",
	"LATIN SMALL LETTER EGYPTOLOGICAL ALEF",
	"LATIN SMALL LETTER ENG",
	"LATIN SMALL LETTER ESH",
	"LATIN SMALL LETTER ESH WITH CURL",
	"LATIN SMALL LETTER ESH WITH PALATAL HOOK",
	"LATIN SMALL LETTER ESH WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER ET",
	"LATIN SMALL LETTER ETH",
	"LATIN SMALL LETTER EZH",
	"LATIN SMALL LETTER EZH REVERSED",
	"LATIN SMALL LETTER EZH WITH CARON",
	"LATIN SMALL LETTER EZH WITH CURL",
	"LATIN SMALL LETTER EZH WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER EZH WITH TAIL",
	"LATIN SMALL LETTER F",
	"LATIN SMALL LETTER F WITH DOT ABOVE",
	"LATIN SMALL LETTER F WITH HOOK",
	"LATIN SMALL LETTER F WITH MIDDLE TILDE",
	"LATIN SMALL LETTER F WITH PALATAL HOOK",
	"LATIN SMALL LETTER FENG DIGRAPH",
	"LATIN SMALL LETTER G",
	"LATIN SMALL LETTER G WITH ACUTE",
	"LATIN SMALL LETTER G WITH BREVE",
	"LATIN SMALL LETTER G WITH CARON",
	"LATIN SMALL LETTER G WITH CEDILLA",
	"LATIN SMALL LETTER G WITH CIRCUMFLEX",
	"LATIN SMALL LETTER G WITH DOT ABOVE",
	"LATIN SMALL LETTER G WITH HOOK",
	"LATIN SMALL LETTER G WITH MACRON",
	"LATIN SMALL LETTER G WITH OBLIQUE STROKE",
	"LATIN SMALL LETTER G WITH PALATAL HOOK",
	"LATIN SMALL LETTER G WITH STROKE",
	"LATIN SMALL LETTER GAMMA",
	"LATIN SMALL LETTER GLOTTAL STOP",
	"LATIN SMALL LETTER H",
	"LATIN SMALL LETTER H WITH BREVE BELOW",
	"LATIN SMALL LETTER H WITH CARON",
	"LATIN SMALL LETTER H WITH CEDILLA",
	"LATIN SMALL LETTER H WITH CIRCUMFLEX",
	"LATIN SMALL LETTER H WITH DESCENDER",
	"LATIN SMALL LETTER H WITH DIAERESIS",
	"LATIN SMALL LETTER H WITH DOT ABOVE",
	"LATIN SMALL LETTER H WITH DOT BELOW",
	"LATIN SMALL LETTER H WITH HOOK",
	"LATIN SMALL LETTER H WITH LINE BELOW",
	"LATIN SMALL LETTER H WITH STROKE",
	"LATIN SMALL LETTER HALF H",
	"LATIN SMALL LETTER HENG",
	"LATIN SMALL LETTER HENG WITH HOOK",
	"LATIN SMALL LETTER HV",
	"LATIN SMALL LETTER I",
	"LATIN SMALL LETTER I WITH ACUTE",
	"LATIN SMALL LETTER I WITH BREVE",
	"LATIN SMALL LETTER I WITH CARON",
	"LATIN SMALL LETTER I WITH CIRCUMFLEX",
	"LATIN SMALL LETTER I WITH DIAERESIS",
	"LATIN SMALL LETTER I WITH DIAERESIS AND ACUTE",
	"LATIN SMALL LETTER I WITH DOT BELOW",
	"LATIN SMALL LETTER I WITH DOUBLE GRAVE",
	"LATIN SMALL LETTER I WITH GRAVE",
	"LATIN SMALL LETTER I WITH HOOK ABOVE",
	"LATIN SMALL LETTER I WITH INVERTED BREVE",
	"LATIN SMALL LETTER I WITH MACRON",
	"LATIN SMALL LETTER I WITH OGONEK",
	"LATIN SMALL LETTER I WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER I WITH STROKE",
	"LATIN SMALL LETTER I WITH TILDE",
	"LATIN SMALL LETTER I WITH TILDE BELOW",
	"LATIN SMALL LETTER INSULAR D",
	"LATIN SMALL LETTER INSULAR F",
	"LATIN SMALL LETTER INSULAR G",
	"LATIN SMALL LETTER INSULAR R",
	"LATIN SMALL LETTER INSULAR S",
	"LATIN SMALL LETTER INSULAR T",
	"LATIN SMALL LETTER IOTA",
	"LATIN SMALL LETTER IOTA WITH STROKE",
	"LATIN SMALL LETTER IS",
	"LATIN SMALL LETTER J",
	"LATIN SMALL LETTER J WITH CARON",
	"LATIN SMALL LETTER J WITH CIRCUMFLEX",
	"LATIN SMALL LETTER J WITH CROSSED-TAIL",
	"LATIN SMALL LETTER J WITH STROKE",
	"LATIN SMALL LETTER K",
	"LATIN SMALL LETTER K WITH ACUTE",
	"LATIN SMALL LETTER K WITH CARON",
	"LATIN SMALL LETTER K WITH CEDILLA",
	"LATIN SMALL LETTER K WITH DESCENDER",
	"LATIN SMALL LETTER K WITH DIAGONAL STROKE",
	"LATIN SMALL LETTER K WITH DOT BELOW",
	"LATIN SMALL LETTER K WITH HOOK",
	"LATIN SMALL LETTER K WITH LINE BELOW",
	"LATIN SMALL LETTER K WITH OBLIQUE STROKE",
	"LATIN SMALL LETTER K WITH PALATAL HOOK",
	"LATIN SMALL LETTER K WITH STROKE",
	"LATIN SMALL LETTER K WITH STROKE AND DIAGONAL STROKE",
	"LATIN SMALL LETTER KRA",
	"LATIN SMALL LETTER L",
	"LATIN SMALL LETTER L WITH ACUTE",
	"LATIN SMALL LETTER L WITH BAR",
	"LATIN SMALL LETTER L WITH BELT",
	"LATIN SMALL LETTER L WITH CARON",
	"LATIN SMALL LETTER L WITH CEDILLA",
	"LATIN SMALL LETTER L WITH CIRCUMFLEX BELOW",
	"LATIN SMALL LETTER L WITH CURL",
	"LATIN SMALL LETTER L WITH DOT BELOW",
	"LATIN SMALL LETTER L WITH DOT BELOW AND MACRON",
	"LATIN SMALL LETTER L WITH DOUBLE BAR",
	"LATIN SMALL LETTER L WITH HIGH STROKE",
	"LATIN SMALL LETTER L WITH LINE BELOW",
	"LATIN SMALL LETTER L WITH MIDDLE DOT",
	"LATIN SMALL LETTER L WITH MIDDLE TILDE",
	"LATIN SMALL LETTER L WITH PALATAL HOOK",
	"LATIN SMALL LETTER L WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER L WITH RETROFLEX HOOK AND BELT",
	"LATIN SMALL LETTER L WITH STROKE",
	"LATIN SMALL LETTER LAMBDA WITH STROKE",
	"LATIN SMALL LETTER LEZH",
	"LATIN SMALL LETTER LJ",
	"LATIN SMALL LETTER LONG S",
	"LATIN SMALL LETTER LONG S WITH DIAGONAL STROKE",
	"LATIN SMALL LETTER LONG S WITH DOT ABOVE",
	"LATIN SMALL LETTER LONG S WITH HIGH STROKE",
	"LATIN SMALL LETTER LS DIGRAPH",
	"LATIN SMALL LETTER LUM",
	"LATIN SMALL LETTER LZ DIGRAPH",
	"LATIN SMALL LETTER M",
	"LATIN SMALL LETTER M WITH ACUTE",
	"LATIN SMALL LETTER M WITH DOT ABOVE",
	"LATIN SMALL LETTER M WITH DOT BELOW",
	"LATIN SMALL LETTER M WITH HOOK",
	"LATIN SMALL LETTER M WITH MIDDLE TILDE",
	"LATIN SMALL LETTER M WITH PALATAL HOOK",
	"LATIN SMALL LETTER MIDDLE-WELSH LL",
	"LATIN SMALL LETTER MIDDLE-WELSH V",
	"LATIN SMALL LETTER MUM",
	"LATIN SMALL LETTER N",
	"LATIN SMALL LETTER N PRECEDED BY APOSTROPHE",
	"LATIN SMALL LETTER N WITH ACUTE",
	"LATIN SMALL LETTER N WITH CARON",
	"LATIN SMALL LETTER N WITH CEDILLA",
	"LATIN SMALL LETTER N WITH CIRCUMFLEX BELOW",
	"LATIN SMALL LETTER N WITH CURL",
	"LATIN SMALL LETTER N WITH DESCENDER",
	"LATIN SMALL LETTER N WITH DOT ABOVE",
	"LATIN SMALL LETTER N WITH DOT BELOW",
	"LATIN SMALL LETTER N WITH GRAVE",
	"LATIN SMALL LETTER N WITH LEFT HOOK",
	"LATIN SMALL LETTER N WITH LINE BELOW",
	"LATIN SMALL LETTER N WITH LONG RIGHT LEG",
	"LATIN SMALL LETTER N WITH MIDDLE TILDE",
	"LATIN SMALL LETTER N WITH OBLIQUE STROKE",
	"LATIN SMALL LETTER N WITH PALATAL HOOK",
	"LATIN SMALL LETTER N WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER N WITH TILDE",
	"LATIN SMALL LETTER NJ",
	"LATIN SMALL LETTER NUM",
	"LATIN SMALL LETTER O",
	"LATIN SMALL LETTER O WITH ACUTE",
	"LATIN SMALL LETTER O WITH BREVE",
	"LATIN SMALL LETTER O WITH CARON",
	"LATIN SMALL LETTER O WITH CIRCUMFLEX",
	"LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE",
	"LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW",
	"LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE",
	"LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE",
	"LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE",
	"LATIN SMALL LETTER O WITH DIAERESIS",
	"LATIN SMALL LETTER O WITH DIAERESIS AND MACRON",
	"LATIN SMALL LETTER O WITH DOT ABOVE",
	"LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON",
	"LATIN SMALL LETTER O WITH DOT BELOW",
	"LATIN SMALL LETTER O WITH DOUBLE ACUTE",
	"LATIN SMALL LETTER O WITH DOUBLE GRAVE",
	"LATIN SMALL LETTER O WITH GRAVE",
	"LATIN SMALL LETTER O WITH HOOK ABOVE",
	"LATIN SMALL LETTER O WITH HORN",
	"LATIN SMALL LETTER O WITH HORN AND ACUTE",
	"LATIN SMALL LETTER O WITH HORN AND DOT BELOW",
	"LATIN SMALL LETTER O WITH HORN AND GRAVE",
	"LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE",
	"LATIN SMALL LETTER O WITH HORN AND TILDE",
	"LATIN SMALL LETTER O WITH INVERTED BREVE",
	"LATIN SMALL LETTER O WITH LONG STROKE OVERLAY",
	"LATIN SMALL LETTER O WITH LOOP",
	"LATIN SMALL LETTER O WITH LOW RING INSIDE",
	"LATIN SMALL LETTER O WITH MACRON",
	"LATIN SMALL LETTER O WITH MACRON AND ACUTE",
	"LATIN SMALL LETTER O WITH MACRON AND GRAVE",
	"LATIN SMALL LETTER O WITH OGONEK",
	"LATIN SMALL LETTER O WITH OGONEK AND MACRON",
	"LATIN SMALL LETTER O WITH STROKE",
	"LATIN SMALL LETTER O WITH STROKE AND ACUTE",
	"LATIN SMALL LETTER O WITH TILDE",
	"LATIN SMALL LETTER O WITH TILDE AND ACUTE",
	"LATIN SMALL LETTER O WITH TILDE AND DIAERESIS",
	"LATIN SMALL LETTER O WITH TILDE AND MACRON",
	"LATIN SMALL LETTER OI",
	"LATIN SMALL LETTER OO",
	"LATIN SMALL LETTER OPEN E",
	"LATIN SMALL LETTER OPEN E WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER OPEN O",
	"LATIN SMALL LETTER OPEN O WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER OU",
	"LATIN SMALL LETTER P",
	"LATIN SMALL LETTER P WITH ACUTE",
	"LATIN SMALL LETTER P WITH DOT ABOVE",
	"LATIN SMALL LETTER P WITH FLOURISH",
	"LATIN SMALL LETTER P WITH HOOK",
	"LATIN SMALL LETTER P WITH MIDDLE TILDE",
	"LATIN SMALL LETTER P WITH PALATAL HOOK",
	"LATIN SMALL LETTER P WITH SQUIRREL TAIL",
	"LATIN SMALL LETTER P WITH STROKE",
	"LATIN SMALL LETTER P WITH STROKE THROUGH DESCENDER",
	"LATIN SMALL LETTER PHI",
	"LATIN SMALL LETTER Q",
	"LATIN SMALL LETTER Q WITH DIAGONAL STROKE",
	"LATIN SMALL LETTER Q WITH HOOK",
	"LATIN SMALL LETTER Q WITH HOOK TAIL",
	"LATIN SMALL LETTER Q WITH STROKE THROUGH DESCENDER",
	"LATIN SMALL LETTER QP DIGRAPH",
	"LATIN SMALL LETTER R",
	"LATIN SMALL LETTER R ROTUNDA",
	"LATIN SMALL LETTER R WITH ACUTE",
	"LATIN SMALL LETTER R WITH CARON",
	"LATIN SMALL LETTER R WITH CEDILLA",
	"LATIN SMALL LETTER R WITH DOT ABOVE",
	"LATIN SMALL LETTER R WITH DOT BELOW",
	"LATIN SMALL LETTER R WITH DOT BELOW AND MACRON",
	"LATIN SMALL LETTER R WITH DOUBLE GRAVE",
	"LATIN SMALL LETTER R WITH FISHHOOK",
	"LATIN SMALL LETTER R WITH FISHHOOK AND MIDDLE TILDE",
	"LATIN SMALL LETTER R WITH INVERTED BREVE",
	"LATIN SMALL LETTER R WITH LINE BELOW",
	"LATIN SMALL LETTER R WITH LONG LEG",
	"LATIN SMALL LETTER R WITH MIDDLE TILDE",
	"LATIN SMALL LETTER R WITH OBLIQUE STROKE",
	"LATIN SMALL LETTER R WITH PALATAL HOOK",
	"LATIN SMALL LETTER R WITH STROKE",
	"LATIN SMALL LETTER R WITH TAIL",
	"LATIN SMALL LETTER RAMS HORN",
	"LATIN SMALL LETTER REVERSED C",
	"LATIN SMALL LETTER REVERSED C WITH DOT",
	"LATIN SMALL LETTER REVERSED E",
	"LATIN SMALL LETTER REVERSED OPEN E",
	"LATIN SMALL LETTER REVERSED OPEN E WITH HOOK",
	"LATIN SMALL LETTER REVERSED OPEN E WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER REVERSED R WITH FISHHOOK",
	"LATIN SMALL LETTER RUM",
	"LATIN SMALL LETTER RUM ROTUNDA",
	"LATIN SMALL LETTER S",
	"LATIN SMALL LETTER S WITH ACUTE",
	"LATIN SMALL LETTER S WITH ACUTE AND DOT ABOVE",
	"LATIN SMALL LETTER S WITH CARON",
	"LATIN SMALL LETTER S WITH CARON AND DOT ABOVE",
	"LATIN SMALL LETTER S WITH CEDILLA",
	"LATIN SMALL LETTER S WITH CIRCUMFLEX",
	"LATIN SMALL LETTER S WITH COMMA BELOW",
	"LATIN SMALL LETTER S WITH DOT ABOVE",
	"LATIN SMALL LETTER S WITH DOT BELOW",
	"LATIN SMALL LETTER S WITH DOT BELOW AND DOT ABOVE",
	"LATIN SMALL LETTER S WITH HOOK",
	"LATIN SMALL LETTER S WITH MIDDLE TILDE",
	"LATIN SMALL LETTER S WITH OBLIQUE STROKE",
	"LATIN SMALL LETTER S WITH PALATAL HOOK",
	"LATIN SMALL LETTER S WITH SWASH TAIL",
	"LATIN SMALL LETTER SALTILLO",
	"LATIN SMALL LETTER SCHWA",
	"LATIN SMALL LETTER SCHWA WITH HOOK",
	"LATIN SMALL LETTER SCHWA WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER SCRIPT G",
	"LATIN SMALL LETTER SHARP S",
	"LATIN SMALL LETTER SIDEWAYS DIAERESIZED U",
	"LATIN SMALL LETTER SIDEWAYS O",
	"LATIN SMALL LETTER SIDEWAYS O WITH STROKE",
	"LATIN SMALL LETTER SIDEWAYS OPEN O",
	"LATIN SMALL LETTER SIDEWAYS TURNED M",
	"LATIN SMALL LETTER SIDEWAYS U",
	"LATIN SMALL LETTER SQUAT REVERSED ESH",
	"LATIN SMALL LETTER T",
	"LATIN SMALL LETTER T WITH CARON",
	"LATIN SMALL LETTER T WITH CEDILLA",
	"LATIN SMALL LETTER T WITH CIRCUMFLEX BELOW",
	"LATIN SMALL LETTER T WITH COMMA BELOW",
	"LATIN SMALL LETTER T WITH CURL",
	"LATIN SMALL LETTER T WITH DIAERESIS",
	"LATIN SMALL LETTER T WITH DIAGONAL STROKE",
	"LATIN SMALL LETTER T WITH DOT ABOVE",
	"LATIN SMALL LETTER T WITH DOT BELOW",
	"LATIN SMALL LETTER T WITH HOOK",
	"LATIN SMALL LETTER T WITH LINE BELOW",
	"LATIN SMALL LETTER T WITH MIDDLE TILDE",
	"LATIN SMALL LETTER T WITH PALATAL HOOK",
	"LATIN SMALL LETTER T WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER T WITH STROKE",
	"LATIN SMALL LETTER TAILLESS PHI",
	"LATIN SMALL LETTER TC DIGRAPH WITH CURL",
	"LATIN SMALL LETTER TESH DIGRAPH",
	"LATIN SMALL LETTER TH WITH STRIKETHROUGH",
	"LATIN SMALL LETTER THORN",
	"LATIN SMALL LETTER THORN WITH STROKE",
	"LATIN SMALL LETTER THORN WITH STROKE THROUGH DESCENDER",
	"LATIN SMALL LETTER TONE FIVE",
	"LATIN SMALL LETTER TONE SIX",
	"LATIN SMALL LETTER TONE TWO",
	"LATIN SMALL LETTER TOP HALF O",
	"LATIN SMALL LETTER TRESILLO",
	"LATIN SMALL LETTER TS DIGRAPH",
	"LATIN SMALL LETTER TUM",
	"LATIN SMALL LETTER TURNED A",
	"LATIN SMALL LETTER TURNED AE",
	"LATIN SMALL LETTER TURNED ALPHA",
	"LATIN SMALL LETTER TURNED DELTA",
	"LATIN SMALL LETTER TURNED E",
	"LATIN SMALL LETTER TURNED G",
	"LATIN SMALL LETTER TURNED H",
	"LATIN SMALL LETTER TURNED H WITH FISHHOOK",
	"LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL",
	"LATIN SMALL LETTER TURNED I",
	"LATIN SMALL LETTER TURNED INSULAR G",
	"LATIN SMALL LETTER TURNED K",
	"LATIN SMALL LETTER TURNED L",
	"LATIN SMALL LETTER TURNED M",
	"LATIN SMALL LETTER TURNED M WITH LONG LEG",
	"LATIN SMALL LETTER TURNED OE",
	"LATIN SMALL LETTER TURNED OPEN E",
	"LATIN SMALL LETTER TURNED R",
	"LATIN SMALL LETTER TURNED R WITH HOOK",
	"LATIN SMALL LETTER TURNED R WITH LONG LEG",
	"LATIN SMALL LETTER TURNED R WITH TAIL",
	"LATIN SMALL LETTER TURNED T",
	"LATIN SMALL LETTER TURNED V",
	"LATIN SMALL LETTER TURNED W",
	"LATIN SMALL LETTER TURNED Y",
	"LATIN SMALL LETTER TZ",
	"LATIN SMALL LETTER U",
	"LATIN SMALL LETTER U BAR",
	"LATIN SMALL LETTER U WITH ACUTE",
	"LATIN SMALL LETTER U WITH BREVE",
	"LATIN SMALL LETTER U WITH CARON",
	"LATIN SMALL LETTER U WITH CIRCUMFLEX",
	"LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW",
	"LATIN SMALL LETTER U WITH DIAERESIS",
	"LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE",
	"LATIN SMALL LETTER U WITH DIAERESIS AND CARON",
	"LATIN SMALL LETTER U WITH DIAERESIS AND GRAVE",
	"LATIN SMALL LETTER U WITH DIAERESIS AND MACRON",
	"LATIN SMALL LETTER U WITH DIAERESIS BELOW",
	"LATIN SMALL LETTER U WITH DOT BELOW",
	"LATIN SMALL LETTER U WITH DOUBLE ACUTE",
	"LATIN SMALL LETTER U WITH DOUBLE GRAVE",
	"LATIN SMALL LETTER U WITH GRAVE",
	"LATIN SMALL LETTER U WITH HOOK ABOVE",
	"LATIN SMALL LETTER U WITH HORN",
	"LATIN SMALL LETTER U WITH HORN AND ACUTE",
	"LATIN SMALL LETTER U WITH HORN AND DOT BELOW",
	"LATIN SMALL LETTER U WITH HORN AND GRAVE",
	"LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE",
	"LATIN SMALL LETTER U WITH HORN AND TILDE",
	"LATIN SMALL LETTER U WITH INVERTED BREVE",
	"LATIN SMALL LETTER U WITH MACRON",
	"LATIN SMALL LETTER U WITH MACRON AND DIAERESIS",
	"LATIN SMALL LETTER U WITH OGONEK",
	"LATIN SMALL LETTER U WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER U WITH RING ABOVE",
	"LATIN SMALL LETTER U WITH TILDE",
	"LATIN SMALL LETTER U WITH TILDE AND ACUTE",
	"LATIN SMALL LETTER U WITH TILDE BELOW",
	"LATIN SMALL LETTER UE",
	"LATIN SMALL LETTER UM",
	"LATIN SMALL LETTER UPSILON",
	"LATIN SMALL LETTER UPSILON WITH STROKE",
	"LATIN SMALL LETTER V",
	"LATIN SMALL LETTER V WITH CURL",
	"LATIN SMALL LETTER V WITH DIAGONAL STROKE",
	"LATIN SMALL LETTER V WITH DOT BELOW",
	"LATIN SMALL LETTER V WITH HOOK",
	"LATIN SMALL LETTER V WITH PALATAL HOOK",
	"LATIN SMALL LETTER V WITH RIGHT HOOK",
	"LATIN SMALL LETTER V WITH TILDE",
	"LATIN SMALL LETTER VEND",
	"LATIN SMALL LETTER VISIGOTHIC Z",
	"LATIN SMALL LETTER VY",
	"LATIN SMALL LETTER W",
	"LATIN SMALL LETTER W WITH ACUTE",
	"LATIN SMALL LETTER W WITH CIRCUMFLEX",
	"LATIN SMALL LETTER W WITH DIAERESIS",
	"LATIN SMALL LETTER W WITH DOT ABOVE",
	"LATIN SMALL LETTER W WITH DOT BELOW",
	"LATIN SMALL LETTER W WITH GRAVE",
	"LATIN SMALL LETTER W WITH HOOK",
	"LATIN SMALL LETTER W WITH RING ABOVE",
	"LATIN SMALL LETTER X",
	"LATIN SMALL LETTER X WITH DIAERESIS",
	"LATIN SMALL LETTER X WITH DOT ABOVE",
	"LATIN SMALL LETTER X WITH PALATAL HOOK",
	"LATIN SMALL LETTER Y",
	"LATIN SMALL LETTER Y WITH ACUTE",
	"LATIN SMALL LETTER Y WITH CIRCUMFLEX",
	"LATIN SMALL LETTER Y WITH DIAERESIS",
	"LATIN SMALL LETTER Y WITH DOT ABOVE",
	"LATIN SMALL LETTER Y WITH DOT BELOW",
	"LATIN SMALL LETTER Y WITH GRAVE",
	"LATIN SMALL LETTER Y WITH HOOK",
	"LATIN SMALL LETTER Y WITH HOOK ABOVE",
	"LATIN SMALL LETTER Y WITH LOOP",
	"LATIN SMALL LETTER Y WITH MACRON",
	"LATIN SMALL LETTER Y WITH RING ABOVE",
	"LATIN SMALL LETTER Y WITH STROKE",
	"LATIN SMALL LETTER Y WITH TILDE",
	"LATIN SMALL LETTER YOGH",
	"LATIN SMALL LETTER Z",
	"LATIN SMALL LETTER Z WITH ACUTE",
	"LATIN SMALL LETTER Z WITH CARON",
	"LATIN SMALL LETTER Z WITH CIRCUMFLEX",
	"LATIN SMALL LETTER Z WITH CURL",
	"LATIN SMALL LETTER Z WITH DESCENDER",
	"LATIN SMALL LETTER Z WITH DOT ABOVE",
	"LATIN SMALL LETTER Z WITH DOT BELOW",
	"LATIN SMALL LETTER Z WITH HOOK",
	"LATIN SMALL LETTER Z WITH LINE BELOW",
	"LATIN SMALL LETTER Z WITH MIDDLE TILDE",
	"LATIN SMALL LETTER Z WITH PALATAL HOOK",
	"LATIN SMALL LETTER Z WITH RETROFLEX HOOK",
	"LATIN SMALL LETTER Z WITH STROKE",
	"LATIN SMALL LETTER Z WITH SWASH TAIL",
	"LATIN SMALL LIGATURE FF",
	"LATIN SMALL LIGATURE FFI",
	"LATIN SMALL LIGATURE FFL",
	"LATIN SMALL LIGATURE FI",
	"LATIN SMALL LIGATURE FL",
	"LATIN SMALL LIGATURE IJ",
	"LATIN SMALL LIGATURE LONG S T",
	"LATIN SMALL LIGATURE OE",
	"LATIN SMALL LIGATURE ST",
	"LATIN SUBSCRIPT SMALL LETTER A",
	"LATIN SUBSCRIPT SMALL LETTER E",
	"LATIN SUBSCRIPT SMALL LETTER H",
	"LATIN SUBSCRIPT SMALL LETTER I",
	"LATIN SUBSCRIPT SMALL LETTER J",
	"LATIN SUBSCRIPT SMALL LETTER K",
	"LATIN SUBSCRIPT SMALL LETTER L",
	"LATIN SUBSCRIPT SMALL LETTER M",
	"LATIN SUBSCRIPT SMALL LETTER N",
	"LATIN SUBSCRIPT SMALL LETTER O",
	"LATIN SUBSCRIPT SMALL LETTER P",
	"LATIN SUBSCRIPT SMALL LETTER R",
	"LATIN SUBSCRIPT SMALL LETTER S",
	"LATIN SUBSCRIPT SMALL LETTER SCHWA",
	"LATIN SUBSCRIPT SMALL LETTER T",
	"LATIN SUBSCRIPT SMALL LETTER U",
	"LATIN SUBSCRIPT SMALL LETTER V",
	"LATIN SUBSCRIPT SMALL LETTER X",
	"LEAF FLUTTERING IN WIND",
	"LEDGER",
	"LEFT AND RIGHT DOUBLE TURNSTILE",
	"LEFT AND RIGHT TACK",
	"LEFT ANGLE BRACKET",
	"LEFT ANGLE BRACKET WITH DOT",
	"LEFT ARC LESS-THAN BRACKET",
	"LEFT ARROW WITH CIRCLED PLUS",
	"LEFT ARROW WITH SMALL CIRCLE",
	"LEFT BARB DOWN RIGHT BARB DOWN HARPOON",
	"LEFT BARB DOWN RIGHT BARB UP HARPOON",
	"LEFT BARB UP RIGHT BARB DOWN HARPOON",
	"LEFT BARB UP RIGHT BARB UP HARPOON",
	"LEFT BLACK LENTICULAR BRACKET",
	"LEFT BLACK TORTOISE SHELL BRACKET",
	"LEFT CEILING",
	"LEFT CLOSED ENTRY",
	"LEFT CORNER BRACKET",
	"LEFT CURLY BRACKET",
	"LEFT CURLY BRACKET LOWER HOOK",
	"LEFT CURLY BRACKET MIDDLE PIECE",
	"LEFT CURLY BRACKET UPPER HOOK",
	"LEFT DOTTED SUBSTITUTION BRACKET",
	"LEFT DOUBLE ANGLE BRACKET",
	"LEFT DOUBLE PARENTHESIS",
	"LEFT DOUBLE QUOTATION MARK",
	"LEFT DOUBLE WIGGLY FENCE",
	"LEFT FISH TAIL",
	"LEFT FIVE EIGHTHS BLOCK",
	"LEFT FLOOR",
	"LEFT HALF BLACK CIRCLE",
	"LEFT HALF BLOCK",
	"LEFT LOW PARAPHRASE BRACKET",
	"LEFT LUGGAGE",
	"LEFT MULTIMAP",
	"LEFT NORMAL FACTOR SEMIDIRECT PRODUCT",
	"LEFT ONE EIGHTH BLOCK",
	"LEFT ONE QUARTER BLOCK",
	"LEFT OUTER JOIN",
	"LEFT PARENTHESIS",
	"LEFT PARENTHESIS EXTENSION",
	"LEFT PARENTHESIS LOWER HOOK",
	"LEFT PARENTHESIS UPPER HOOK",
	"LEFT RAISED OMISSION BRACKET",
	"LEFT RIGHT ARROW",
	"LEFT RIGHT ARROW THROUGH SMALL CIRCLE",
	"LEFT RIGHT ARROW WITH DOUBLE VERTICAL STROKE",
	"LEFT RIGHT ARROW WITH STROKE",
	"LEFT RIGHT ARROW WITH VERTICAL STROKE",
	"LEFT RIGHT BLACK ARROW",
	"LEFT RIGHT DOUBLE ARROW",
	"LEFT RIGHT DOUBLE ARROW WITH STROKE",
	"LEFT RIGHT DOUBLE ARROW WITH VERTICAL STROKE",
	"LEFT RIGHT OPEN-HEADED ARROW",
	"LEFT RIGHT WAVE ARROW",
	"LEFT RIGHT WHITE ARROW",
	"LEFT S-SHAPED BAG DELIMITER",
	"LEFT SEMIDIRECT PRODUCT",
	"LEFT SEVEN EIGHTHS BLOCK",
	"LEFT SIDEWAYS U BRACKET",
	"LEFT SINGLE QUOTATION MARK",
	"LEFT SQUARE BRACKET",
	"LEFT SQUARE BRACKET EXTENSION",
	"LEFT SQUARE BRACKET LOWER CORNER",
	"LEFT SQUARE BRACKET UPPER CORNER",
	"LEFT SQUARE BRACKET WITH QUILL",
	"LEFT SQUARE BRACKET WITH TICK IN BOTTOM CORNER",
	"LEFT SQUARE BRACKET WITH TICK IN TOP CORNER",
	"LEFT SQUARE BRACKET WITH UNDERBAR",
	"LEFT SUBSTITUTION BRACKET",
	"LEFT TACK",
	"LEFT THREE EIGHTHS BLOCK",
	"LEFT THREE QUARTERS BLOCK",
	"LEFT TORTOISE SHELL BRACKET",
	"LEFT TRANSPOSITION BRACKET",
	"LEFT TRIANGLE BESIDE VERTICAL BAR",
	"LEFT VERTICAL BAR WITH QUILL",
	"LEFT VERTICAL BOX LINE",
	"LEFT WHITE CORNER BRACKET",
	"LEFT WHITE CURLY BRACKET",
	"LEFT WHITE LENTICULAR BRACKET",
	"LEFT WHITE PARENTHESIS",
	"LEFT WHITE SQUARE BRACKET",
	"LEFT WHITE TORTOISE SHELL BRACKET",
	"LEFT WIGGLY FENCE",
	"LEFT-FACING SVASTI SIGN",
	"LEFT-FACING SVASTI SIGN WITH DOTS",
	"LEFT-HANDED INTERLACED PENTAGRAM",
	"LEFT-POINTING ANGLE BRACKET",
	"LEFT-POINTING CURVED ANGLE BRACKET",
	"LEFT-POINTING DOUBLE ANGLE QUOTATION MARK",
	"LEFT-POINTING MAGNIFYING GLASS",
	"LEFT-SHADED WHITE RIGHTWARDS ARROW",
	"LEFT-SIDE ARC ANTICLOCKWISE ARROW",
	"LEFT-TO-RIGHT EMBEDDING",
	"LEFT-TO-RIGHT ISOLATE",
	"LEFT-TO-RIGHT MARK",
	"LEFT-TO-RIGHT OVERRIDE",
	"LEFTWARDS ARROW",
	"LEFTWARDS ARROW ABOVE ALMOST EQUAL TO",
	"LEFTWARDS ARROW ABOVE REVERSE ALMOST EQUAL TO",
	"LEFTWARDS ARROW ABOVE REVERSE TILDE OPERATOR",
	"LEFTWARDS ARROW ABOVE SHORT RIGHTWARDS ARROW",
	"LEFTWARDS ARROW ABOVE TILDE OPERATOR",
	"LEFTWARDS ARROW FROM BAR",
	"LEFTWARDS ARROW FROM BAR TO BLACK DIAMOND",
	"LEFTWARDS ARROW OVER RIGHTWARDS ARROW",
	"LEFTWARDS ARROW THROUGH LESS-THAN",
	"LEFTWARDS ARROW THROUGH SUBSET",
	"LEFTWARDS ARROW THROUGH X",
	"LEFTWARDS ARROW TO BAR",
	"LEFTWARDS ARROW TO BAR OVER RIGHTWARDS ARROW TO BAR",
	"LEFTWARDS ARROW TO BLACK DIAMOND",
	"LEFTWARDS ARROW WITH DOTTED STEM",
	"LEFTWARDS ARROW WITH DOUBLE VERTICAL STROKE",
	"LEFTWARDS ARROW WITH HOOK",
	"LEFTWARDS ARROW WITH LOOP",
	"LEFTWARDS ARROW WITH PLUS BELOW",
	"LEFTWARDS ARROW WITH STROKE",
	"LEFTWARDS ARROW WITH TAIL",
	"LEFTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE",
	"LEFTWARDS ARROW WITH TAIL WITH VERTICAL STROKE",
	"LEFTWARDS ARROW WITH TIP DOWNWARDS",
	"LEFTWARDS ARROW WITH TIP UPWARDS",
	"LEFTWARDS ARROW WITH VERTICAL STROKE",
	"LEFTWARDS ARROW-TAIL",
	"LEFTWARDS BLACK ARROW",
	"LEFTWARDS DASHED ARROW",
	"LEFTWARDS DOUBLE ARROW",
	"LEFTWARDS DOUBLE ARROW FROM BAR",
	"LEFTWARDS DOUBLE ARROW WITH STROKE",
	"LEFTWARDS DOUBLE ARROW WITH VERTICAL STROKE",
	"LEFTWARDS DOUBLE ARROW-TAIL",
	"LEFTWARDS DOUBLE DASH ARROW",
	"LEFTWARDS HARPOON OVER RIGHTWARDS HARPOON",
	"LEFTWARDS HARPOON WITH BARB DOWN ABOVE RIGHTWARDS HARPOON WITH BARB DOWN",
	"LEFTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH",
	"LEFTWARDS HARPOON WITH BARB DOWN FROM BAR",
	"LEFTWARDS HARPOON WITH BARB DOWN TO BAR",
	"LEFTWARDS HARPOON WITH BARB DOWNWARDS",
	"LEFTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB DOWN",
	"LEFTWARDS HARPOON WITH BARB UP ABOVE LONG DASH",
	"LEFTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB UP",
	"LEFTWARDS HARPOON WITH BARB UP FROM BAR",
	"LEFTWARDS HARPOON WITH BARB UP TO BAR",
	"LEFTWARDS HARPOON WITH BARB UPWARDS",
	"LEFTWARDS OPEN-HEADED ARROW",
	"LEFTWARDS PAIRED ARROWS",
	"LEFTWARDS QUADRUPLE ARROW",
	"LEFTWARDS SQUIGGLE ARROW",
	"LEFTWARDS TRIPLE ARROW",
	"LEFTWARDS TRIPLE DASH ARROW",
	"LEFTWARDS TWO HEADED ARROW",
	"LEFTWARDS TWO-HEADED ARROW FROM BAR",
	"LEFTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE",
	"LEFTWARDS TWO-HEADED ARROW WITH TAIL",
	"LEFTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE",
	"LEFTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE",
	"LEFTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE",
	"LEFTWARDS TWO-HEADED TRIPLE DASH ARROW",
	"LEFTWARDS WAVE ARROW",
	"LEFTWARDS WHITE ARROW",
	"LEMON",
	"LEO",
	"LEOPARD",
	"LEPCHA CONSONANT SIGN K",
	"LEPCHA CONSONANT SIGN KANG",
	"LEPCHA CONSONANT SIGN L",
	"LEPCHA CONSONANT SIGN M",
	"LEPCHA CONSONANT SIGN N",
	"LEPCHA CONSONANT SIGN NYIN-DO",
	"LEPCHA CONSONANT SIGN P",
	"LEPCHA CONSONANT SIGN R",
	"LEPCHA CONSONANT SIGN T",
	"LEPCHA DIGIT EIGHT",
	"LEPCHA DIGIT FIVE",
	"LEPCHA DIGIT FOUR",
	"LEPCHA DIGIT NINE",
	"LEPCHA DIGIT ONE",
	"LEPCHA DIGIT SEVEN",
	"LEPCHA DIGIT SIX",
	"LEPCHA DIGIT THREE",
	"LEPCHA DIGIT TWO",
	"LEPCHA DIGIT ZERO",
	"LEPCHA LETTER A",
	"LEPCHA LETTER BA",
	"LEPCHA LETTER BLA",
	"LEPCHA LETTER CA",
	"LEPCHA LETTER CHA",
	"LEPCHA LETTER DA",
	"LEPCHA LETTER DDA",
	"LEPCHA LETTER DZA",
	"LEPCHA LETTER FA",
	"LEPCHA LETTER FLA",
	"LEPCHA LETTER GA",
	"LEPCHA LETTER GLA",
	"LEPCHA LETTER HA",
	"LEPCHA LETTER HLA",
	"LEPCHA LETTER JA",
	"LEPCHA LETTER KA",
	"LEPCHA LETTER KHA",
	"LEPCHA LETTER KLA",
	"LEPCHA LETTER LA",
	"LEPCHA LETTER MA",
	"LEPCHA LETTER MLA",
	"LEPCHA LETTER NA",
	"LEPCHA LETTER NGA",
	"LEPCHA LETTER NYA",
	"LEPCHA LETTER PA",
	"LEPCHA LETTER PHA",
	"LEPCHA LETTER PLA",
	"LEPCHA LETTER RA",
	"LEPCHA LETTER SA",
	"LEPCHA LETTER SHA",
	"LEPCHA LETTER TA",
	"LEPCHA LETTER THA",
	"LEPCHA LETTER TSA",
	"LEPCHA LETTER TSHA",
	"LEPCHA LETTER TTA",
	"LEPCHA LETTER TTHA",
	"LEPCHA LETTER VA",
	"LEPCHA LETTER WA",
	"LEPCHA LETTER YA",
	"LEPCHA PUNCTUATION CER-WA",
	"LEPCHA PUNCTUATION NYET THYOOM TA-ROL",
	"LEPCHA PUNCTUATION TA-ROL",
	"LEPCHA PUNCTUATION TSHOOK",
	"LEPCHA PUNCTUATION TSHOOK CER-WA",
	"LEPCHA SIGN NUKTA",
	"LEPCHA SIGN RAN",
	"LEPCHA SUBJOINED LETTER RA",
	"LEPCHA SUBJOINED LETTER YA",
	"LEPCHA VOWEL SIGN AA",
	"LEPCHA VOWEL SIGN E",
	"LEPCHA VOWEL SIGN I",
	"LEPCHA VOWEL SIGN O",
	"LEPCHA VOWEL SIGN OO",
	"LEPCHA VOWEL SIGN U",
	"LEPCHA VOWEL SIGN UU",
	"LESS-THAN ABOVE DOUBLE-LINE EQUAL ABOVE GREATER-THAN",
	"LESS-THAN ABOVE GREATER-THAN ABOVE DOUBLE-LINE EQUAL",
	"LESS-THAN ABOVE LEFTWARDS ARROW",
	"LESS-THAN ABOVE SIMILAR ABOVE GREATER-THAN",
	"LESS-THAN ABOVE SIMILAR OR EQUAL",
	"LESS-THAN ABOVE SLANTED EQUAL ABOVE GREATER-THAN ABOVE SLANTED EQUAL",
	"LESS-THAN AND NOT APPROXIMATE",
	"LESS-THAN AND SINGLE-LINE NOT EQUAL TO",
	"LESS-THAN BUT NOT EQUAL TO",
	"LESS-THAN BUT NOT EQUIVALENT TO",
	"LESS-THAN CLOSED BY CURVE",
	"LESS-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL",
	"LESS-THAN EQUAL TO OR GREATER-THAN",
	"LESS-THAN OR APPROXIMATE",
	"LESS-THAN OR EQUAL TO",
	"LESS-THAN OR EQUIVALENT TO",
	"LESS-THAN OR GREATER-THAN",
	"LESS-THAN OR SLANTED EQUAL TO",
	"LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE",
	"LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE RIGHT",
	"LESS-THAN OR SLANTED EQUAL TO WITH DOT INSIDE",
	"LESS-THAN OVER EQUAL TO",
	"LESS-THAN SIGN",
	"LESS-THAN WITH CIRCLE INSIDE",
	"LESS-THAN WITH DOT",
	"LESS-THAN WITH QUESTION MARK ABOVE",
	"LIBRA",
	"LIGHT LEFT TORTOISE SHELL BRACKET ORNAMENT",
	"LIGHT RAIL",
	"LIGHT RIGHT TORTOISE SHELL BRACKET ORNAMENT",
	"LIGHT SHADE",
	"LIGHT VERTICAL BAR",
	"LIGHTNING",
	"LIMBU DIGIT EIGHT",
	"LIMBU DIGIT FIVE",
	"LIMBU DIGIT FOUR",
	"LIMBU DIGIT NINE",
	"LIMBU DIGIT ONE",
	"LIMBU DIGIT SEVEN",
	"LIMBU DIGIT SIX",
	"LIMBU DIGIT THREE",
	"LIMBU DIGIT TWO",
	"LIMBU DIGIT ZERO",
	"LIMBU EXCLAMATION MARK",
	"LIMBU LETTER BA",
	"LIMBU LETTER BHA",
	"LIMBU LETTER CA",
	"LIMBU LETTER CHA",
	"LIMBU LETTER DA",
	"LIMBU LETTER DHA",
	"LIMBU LETTER GA",
	"LIMBU LETTER GHA",
	"LIMBU LETTER HA",
	"LIMBU LETTER JA",
	"LIMBU LETTER JHA",
	"LIMBU LETTER KA",
	"LIMBU LETTER KHA",
	"LIMBU LETTER LA",
	"LIMBU LETTER MA",
	"LIMBU LETTER NA",
	"LIMBU LETTER NGA",
	"LIMBU LETTER PA",
	"LIMBU LETTER PHA",
	"LIMBU LETTER RA",
	"LIMBU LETTER SA",
	"LIMBU LETTER SHA",
	"LIMBU LETTER SSA",
	"LIMBU LETTER TA",
	"LIMBU LETTER THA",
	"LIMBU LETTER WA",
	"LIMBU LETTER YA",
	"LIMBU LETTER YAN",
	"LIMBU QUESTION MARK",
	"LIMBU SIGN KEMPHRENG",
	"LIMBU SIGN LOO",
	"LIMBU SIGN MUKPHRENG",
	"LIMBU SIGN SA-I",
	"LIMBU SMALL LETTER ANUSVARA",
	"LIMBU SMALL LETTER KA",
	"LIMBU SMALL LETTER LA",
	"LIMBU SMALL LETTER MA",
	"LIMBU SMALL LETTER NA",
	"LIMBU SMALL LETTER NGA",
	"LIMBU SMALL LETTER PA",
	"LIMBU SMALL LETTER RA",
	"LIMBU SMALL LETTER TA",
	"LIMBU SUBJOINED LETTER RA",
	"LIMBU SUBJOINED LETTER WA",
	"LIMBU SUBJOINED LETTER YA",
	"LIMBU VOWEL SIGN A",
	"LIMBU VOWEL SIGN AI",
	"LIMBU VOWEL SIGN AU",
	"LIMBU VOWEL SIGN E",
	"LIMBU VOWEL SIGN EE",
	"LIMBU VOWEL SIGN I",
	"LIMBU VOWEL SIGN O",
	"LIMBU VOWEL SIGN OO",
	"LIMBU VOWEL SIGN U",
	"LIMBU VOWEL-CARRIER LETTER",
	"LIMITED LIABILITY SIGN",
	"LINE INTEGRATION NOT INCLUDING THE POLE",
	"LINE INTEGRATION WITH RECTANGULAR PATH AROUND POLE",
	"LINE INTEGRATION WITH SEMICIRCULAR PATH AROUND POLE",
	"LINE SEPARATOR",
	"LINEAR B IDEOGRAM B100 MAN",
	"LINEAR B IDEOGRAM B102 WOMAN",
	"LINEAR B IDEOGRAM B104 DEER",
	"LINEAR B IDEOGRAM B105 EQUID",
	"LINEAR B IDEOGRAM B105F MARE",
	"LINEAR B IDEOGRAM B105M STALLION",
	"LINEAR B IDEOGRAM B106F EWE",
	"LINEAR B IDEOGRAM B106M RAM",
	"LINEAR B IDEOGRAM B107F SHE-GOAT",
	"LINEAR B IDEOGRAM B107M HE-GOAT",
	"LINEAR B IDEOGRAM B108F SOW",
	"LINEAR B IDEOGRAM B108M BOAR",
	"LINEAR B IDEOGRAM B109F COW",
	"LINEAR B IDEOGRAM B109M BULL",
	"LINEAR B IDEOGRAM B120 WHEAT",
	"LINEAR B IDEOGRAM B121 BARLEY",
	"LINEAR B IDEOGRAM B122 OLIVE",
	"LINEAR B IDEOGRAM B123 SPICE",
	"LINEAR B IDEOGRAM B125 CYPERUS",
	"LINEAR B IDEOGRAM B130 OIL",
	"LINEAR B IDEOGRAM B131 WINE",
	"LINEAR B IDEOGRAM B140 BRONZE",
	"LINEAR B IDEOGRAM B141 GOLD",
	"LINEAR B IDEOGRAM B145 WOOL",
	"LINEAR B IDEOGRAM B151 HORN",
	"LINEAR B IDEOGRAM B159 CLOTH",
	"LINEAR B IDEOGRAM B162 GARMENT",
	"LINEAR B IDEOGRAM B163 ARMOUR",
	"LINEAR B IDEOGRAM B173 MONTH",
	"LINEAR B IDEOGRAM B176 TREE",
	"LINEAR B IDEOGRAM B191 HELMET",
	"LINEAR B IDEOGRAM B220 FOOTSTOOL",
	"LINEAR B IDEOGRAM B225 BATHTUB",
	"LINEAR B IDEOGRAM B230 SPEAR",
	"LINEAR B IDEOGRAM B231 ARROW",
	"LINEAR B IDEOGRAM B233 SWORD",
	"LINEAR B IDEOGRAM B240 WHEELED CHARIOT",
	"LINEAR B IDEOGRAM B241 CHARIOT",
	"LINEAR B IDEOGRAM B242 CHARIOT FRAME",
	"LINEAR B IDEOGRAM B243 WHEEL",
	"LINEAR B IDEOGRAM B254 DART",
	"LINEAR B MONOGRAM B127 KAPO",
	"LINEAR B MONOGRAM B128 KANAKO",
	"LINEAR B MONOGRAM B133 AREPA",
	"LINEAR B MONOGRAM B135 MERI",
	"LINEAR B MONOGRAM B247 DIPTE",
	"LINEAR B SYLLABLE B001 DA",
	"LINEAR B SYLLABLE B002 RO",
	"LINEAR B SYLLABLE B003 PA",
	"LINEAR B SYLLABLE B004 TE",
	"LINEAR B SYLLABLE B005 TO",
	"LINEAR B SYLLABLE B006 NA",
	"LINEAR B SYLLABLE B007 DI",
	"LINEAR B SYLLABLE B008 A",
	"LINEAR B SYLLABLE B009 SE",
	"LINEAR B SYLLABLE B010 U",
	"LINEAR B SYLLABLE B011 PO",
	"LINEAR B SYLLABLE B012 SO",
	"LINEAR B SYLLABLE B013 ME",
	"LINEAR B SYLLABLE B014 DO",
	"LINEAR B SYLLABLE B015 MO",
	"LINEAR B SYLLABLE B016 QA",
	"LINEAR B SYLLABLE B017 ZA",
	"LINEAR B SYLLABLE B020 ZO",
	"LINEAR B SYLLABLE B021 QI",
	"LINEAR B SYLLABLE B023 MU",
	"LINEAR B SYLLABLE B024 NE",
	"LINEAR B SYLLABLE B026 RU",
	"LINEAR B SYLLABLE B027 RE",
	"LINEAR B SYLLABLE B028 I",
	"LINEAR B SYLLABLE B030 NI",
	"LINEAR B SYLLABLE B031 SA",
	"LINEAR B SYLLABLE B032 QO",
	"LINEAR B SYLLABLE B036 JO",
	"LINEAR B SYLLABLE B037 TI",
	"LINEAR B SYLLABLE B038 E",
	"LINEAR B SYLLABLE B039 PI",
	"LINEAR B SYLLABLE B040 WI",
	"LINEAR B SYLLABLE B041 SI",
	"LINEAR B SYLLABLE B042 WO",
	"LINEAR B SYLLABLE B044 KE",
	"LINEAR B SYLLABLE B045 DE",
	"LINEAR B SYLLABLE B046 JE",
	"LINEAR B SYLLABLE B048 NWA",
	"LINEAR B SYLLABLE B050 PU",
	"LINEAR B SYLLABLE B051 DU",
	"LINEAR B SYLLABLE B052 NO",
	"LINEAR B SYLLABLE B053 RI",
	"LINEAR B SYLLABLE B054 WA",
	"LINEAR B SYLLABLE B055 NU",
	"LINEAR B SYLLABLE B057 JA",
	"LINEAR B SYLLABLE B058 SU",
	"LINEAR B SYLLABLE B059 TA",
	"LINEAR B SYLLABLE B060 RA",
	"LINEAR B SYLLABLE B061 O",
	"LINEAR B SYLLABLE B062 PTE",
	"LINEAR B SYLLABLE B065 JU",
	"LINEAR B SYLLABLE B067 KI",
	"LINEAR B SYLLABLE B069 TU",
	"LINEAR B SYLLABLE B070 KO",
	"LINEAR B SYLLABLE B071 DWE",
	"LINEAR B SYLLABLE B072 PE",
	"LINEAR B SYLLABLE B073 MI",
	"LINEAR B SYLLABLE B074 ZE",
	"LINEAR B SYLLABLE B075 WE",
	"LINEAR B SYLLABLE B077 KA",
	"LINEAR B SYLLABLE B078 QE",
	"LINEAR B SYLLABLE B080 MA",
	"LINEAR B SYLLABLE B081 KU",
	"LINEAR B SYLLABLE B085 AU",
	"LINEAR B SYLLABLE B087 TWE",
	"LINEAR B SYLLABLE B090 DWO",
	"LINEAR B SYLLABLE B091 TWO",
	"LINK SYMBOL",
	"LIPSTICK",
	"LIRA SIGN",
	"LISU LETTER A",
	"LISU LETTER AE",
	"LISU LETTER BA",
	"LISU LETTER CA",
	"LISU LETTER CHA",
	"LISU LETTER DA",
	"LISU LETTER DZA",
	"LISU LETTER E",
	"LISU LETTER EU",
	"LISU LETTER FA",
	"LISU LETTER GA",
	"LISU LETTER GHA",
	"LISU LETTER HA",
	"LISU LETTER HHA",
	"LISU LETTER I",
	"LISU LETTER JA",
	"LISU LETTER KA",
	"LISU LETTER KHA",
	"LISU LETTER LA",
	"LISU LETTER MA",
	"LISU LETTER NA",
	"LISU LETTER NGA",
	"LISU LETTER O",
	"LISU LETTER OE",
	"LISU LETTER PA",
	"LISU LETTER PHA",
	"LISU LETTER SA",
	"LISU LETTER SHA",
	"LISU LETTER TA",
	"LISU LETTER THA",
	"LISU LETTER TONE MYA BO",
	"LISU LETTER TONE MYA CYA",
	"LISU LETTER TONE MYA JEU",
	"LISU LETTER TONE MYA NA",
	"LISU LETTER TONE MYA TI",
	"LISU LETTER TONE NA PO",
	"LISU LETTER TSA",
	"LISU LETTER TSHA",
	"LISU LETTER U",
	"LISU LETTER UE",
	"LISU LETTER UH",
	"LISU LETTER WA",
	"LISU LETTER XA",
	"LISU LETTER YA",
	"LISU LETTER ZA",
	"LISU LETTER ZHA",
	"LISU PUNCTUATION COMMA",
	"LISU PUNCTUATION FULL STOP",
	"LIVRE TOURNOIS SIGN",
	"LOCK",
	"LOCK WITH INK PEN",
	"LOGICAL AND",
	"LOGICAL AND WITH DOT ABOVE",
	"LOGICAL AND WITH DOUBLE OVERBAR",
	"LOGICAL AND WITH DOUBLE UNDERBAR",
	"LOGICAL AND WITH HORIZONTAL DASH",
	"LOGICAL AND WITH MIDDLE STEM",
	"LOGICAL AND WITH UNDERBAR",
	"LOGICAL OR",
	"LOGICAL OR OVERLAPPING LOGICAL AND",
	"LOGICAL OR WITH DOT ABOVE",
	"LOGICAL OR WITH DOUBLE OVERBAR",
	"LOGICAL OR WITH DOUBLE UNDERBAR",
	"LOGICAL OR WITH HORIZONTAL DASH",
	"LOGICAL OR WITH MIDDLE STEM",
	"LOLLIPOP",
	"LONG DASH FROM LEFT MEMBER OF DOUBLE VERTICAL",
	"LONG DIVISION",
	"LONG LEFT RIGHT ARROW",
	"LONG LEFT RIGHT DOUBLE ARROW",
	"LONG LEFT TACK",
	"LONG LEFTWARDS ARROW",
	"LONG LEFTWARDS ARROW FROM BAR",
	"LONG LEFTWARDS DOUBLE ARROW",
	"LONG LEFTWARDS DOUBLE ARROW FROM BAR",
	"LONG LEFTWARDS SQUIGGLE ARROW",
	"LONG RIGHT TACK",
	"LONG RIGHTWARDS ARROW",
	"LONG RIGHTWARDS ARROW FROM BAR",
	"LONG RIGHTWARDS DOUBLE ARROW",
	"LONG RIGHTWARDS DOUBLE ARROW FROM BAR",
	"LONG RIGHTWARDS SQUIGGLE ARROW",
	"LOUDLY CRYING FACE",
	"LOVE HOTEL",
	"LOVE LETTER",
	"LOW ASTERISK",
	"LOW BRIGHTNESS SYMBOL",
	"LOW DOUBLE PRIME QUOTATION MARK",
	"LOW LINE",
	"LOWER BLADE SCISSORS",
	"LOWER FIVE EIGHTHS BLOCK",
	"LOWER HALF BLOCK",
	"LOWER HALF CIRCLE",
	"LOWER HALF INVERSE WHITE CIRCLE",
	"LOWER LEFT QUADRANT CIRCULAR ARC",
	"LOWER LEFT SEMICIRCULAR ANTICLOCKWISE ARROW",
	"LOWER LEFT TRIANGLE",
	"LOWER ONE EIGHTH BLOCK",
	"LOWER ONE QUARTER BLOCK",
	"LOWER RIGHT CORNER WITH DOT",
	"LOWER RIGHT DROP-SHADOWED WHITE SQUARE",
	"LOWER RIGHT PENCIL",
	"LOWER RIGHT QUADRANT CIRCULAR ARC",
	"LOWER RIGHT SEMICIRCULAR CLOCKWISE ARROW",
	"LOWER RIGHT SHADOWED WHITE SQUARE",
	"LOWER RIGHT TRIANGLE",
	"LOWER SEVEN EIGHTHS BLOCK",
	"LOWER THREE EIGHTHS BLOCK",
	"LOWER THREE QUARTERS BLOCK",
	"LOZENGE",
	"LOZENGE DIVIDED BY HORIZONTAL RULE",
	"LYCIAN LETTER A",
	"LYCIAN LETTER AN",
	"LYCIAN LETTER B",
	"LYCIAN LETTER BH",
	"LYCIAN LETTER D",
	"LYCIAN LETTER E",
	"LYCIAN LETTER EN",
	"LYCIAN LETTER G",
	"LYCIAN LETTER H",
	"LYCIAN LETTER I",
	"LYCIAN LETTER J",
	"LYCIAN LETTER K",
	"LYCIAN LETTER KK",
	"LYCIAN LETTER L",
	"LYCIAN LETTER M",
	"LYCIAN LETTER MM",
	"LYCIAN LETTER N",
	"LYCIAN LETTER NN",
	"LYCIAN LETTER P",
	"LYCIAN LETTER Q",
	"LYCIAN LETTER R",
	"LYCIAN LETTER S",
	"LYCIAN LETTER T",
	"LYCIAN LETTER TH",
	"LYCIAN LETTER TT",
	"LYCIAN LETTER U",
	"LYCIAN LETTER W",
	"LYCIAN LETTER X",
	"LYCIAN LETTER Z",
	"LYDIAN LETTER A",
	"LYDIAN LETTER AN",
	"LYDIAN LETTER B",
	"LYDIAN LETTER C",
	"LYDIAN LETTER D",
	"LYDIAN LETTER E",
	"LYDIAN LETTER EN",
	"LYDIAN LETTER F",
	"LYDIAN LETTER G",
	"LYDIAN LETTER I",
	"LYDIAN LETTER K",
	"LYDIAN LETTER L",
	"LYDIAN LETTER LY",
	"LYDIAN LETTER M",
	"LYDIAN LETTER N",
	"LYDIAN LETTER NN",
	"LYDIAN LETTER O",
	"LYDIAN LETTER Q",
	"LYDIAN LETTER R",
	"LYDIAN LETTER S",
	"LYDIAN LETTER SS",
	"LYDIAN LETTER T",
	"LYDIAN LETTER TT",
	"LYDIAN LETTER U",
	"LYDIAN LETTER V",
	"LYDIAN LETTER Y",
	"LYDIAN TRIANGULAR MARK",
	"MACRON",
	"MAHJONG TILE AUTUMN",
	"MAHJONG TILE BACK",
	"MAHJONG TILE BAMBOO",
	"MAHJONG TILE CHRYSANTHEMUM",
	"MAHJONG TILE EAST WIND",
	"MAHJONG TILE EIGHT OF BAMBOOS",
	"MAHJONG TILE EIGHT OF CHARACTERS",
	"MAHJONG TILE EIGHT OF CIRCLES",
	"MAHJONG TILE FIVE OF BAMBOOS",
	"MAHJONG TILE FIVE OF CHARACTERS",
	"MAHJONG TILE FIVE OF CIRCLES",
	"MAHJONG TILE FOUR OF BAMBOOS",
	"MAHJONG TILE FOUR OF CHARACTERS",
	"MAHJONG TILE FOUR OF CIRCLES",
	"MAHJONG TILE GREEN DRAGON",
	"MAHJONG TILE JOKER",
	"MAHJONG TILE NINE OF BAMBOOS",
	"MAHJONG TILE NINE OF CHARACTERS",
	"MAHJONG TILE NINE OF CIRCLES",
	"MAHJONG TILE NORTH WIND",
	"MAHJONG TILE ONE OF BAMBOOS",
	"MAHJONG TILE ONE OF CHARACTERS",
	"MAHJONG TILE ONE OF CIRCLES",
	"MAHJONG TILE ORCHID",
	"MAHJONG TILE PLUM",
	"MAHJONG TILE RED DRAGON",
	"MAHJONG TILE SEVEN OF BAMBOOS",
	"MAHJONG TILE SEVEN OF CHARACTERS",
	"MAHJONG TILE SEVEN OF CIRCLES",
	"MAHJONG TILE SIX OF BAMBOOS",
	"MAHJONG TILE SIX OF CHARACTERS",
	"MAHJONG TILE SIX OF CIRCLES",
	"MAHJONG TILE SOUTH WIND",
	"MAHJONG TILE SPRING",
	"MAHJONG TILE SUMMER",
	"MAHJONG TILE THREE OF BAMBOOS",
	"MAHJONG TILE THREE OF CHARACTERS",
	"MAHJONG TILE THREE OF CIRCLES",
	"MAHJONG TILE TWO OF BAMBOOS",
	"MAHJONG TILE TWO OF CHARACTERS",
	"MAHJONG TILE TWO OF CIRCLES",
	"MAHJONG TILE WEST WIND",
	"MAHJONG TILE WHITE DRAGON",
	"MAHJONG TILE WINTER",
	"MALAYALAM AU LENGTH MARK",
	"MALAYALAM DATE MARK",
	"MALAYALAM DIGIT EIGHT",
	"MALAYALAM DIGIT FIVE",
	"MALAYALAM DIGIT FOUR",
	"MALAYALAM DIGIT NINE",
	"MALAYALAM DIGIT ONE",
	"MALAYALAM DIGIT SEVEN",
	"MALAYALAM DIGIT SIX",
	"MALAYALAM DIGIT THREE",
	"MALAYALAM DIGIT TWO",
	"MALAYALAM DIGIT ZERO",
	"MALAYALAM FRACTION ONE HALF",
	"MALAYALAM FRACTION ONE QUARTER",
	"MALAYALAM FRACTION THREE QUARTERS",
	"MALAYALAM LETTER A",
	"MALAYALAM LETTER AA",
	"MALAYALAM LETTER AI",
	"MALAYALAM LETTER AU",
	"MALAYALAM LETTER BA",
	"MALAYALAM LETTER BHA",
	"MALAYALAM LETTER CA",
	"MALAYALAM LETTER CHA",
	"MALAYALAM LETTER CHILLU K",
	"MALAYALAM LETTER CHILLU L",
	"MALAYALAM LETTER CHILLU LL",
	"MALAYALAM LETTER CHILLU N",
	"MALAYALAM LETTER CHILLU NN",
	"MALAYALAM LETTER CHILLU RR",
	"MALAYALAM LETTER DA",
	"MALAYALAM LETTER DDA",
	"MALAYALAM LETTER DDHA",
	"MALAYALAM LETTER DHA",
	"MALAYALAM LETTER DOT REPH",
	"MALAYALAM LETTER E",
	"MALAYALAM LETTER EE",
	"MALAYALAM LETTER GA",
	"MALAYALAM LETTER GHA",
	"MALAYALAM LETTER HA",
	"MALAYALAM LETTER I",
	"MALAYALAM LETTER II",
	"MALAYALAM LETTER JA",
	"MALAYALAM LETTER JHA",
	"MALAYALAM LETTER KA",
	"MALAYALAM LETTER KHA",
	"MALAYALAM LETTER LA",
	"MALAYALAM LETTER LLA",
	"MALAYALAM LETTER LLLA",
	"MALAYALAM LETTER MA",
	"MALAYALAM LETTER NA",
	"MALAYALAM LETTER NGA",
	"MALAYALAM LETTER NNA",
	"MALAYALAM LETTER NNNA",
	"MALAYALAM LETTER NYA",
	"MALAYALAM LETTER O",
	"MALAYALAM LETTER OO",
	"MALAYALAM LETTER PA",
	"MALAYALAM LETTER PHA",
	"MALAYALAM LETTER RA",
	"MALAYALAM LETTER RRA",
	"MALAYALAM LETTER SA",
	"MALAYALAM LETTER SHA",
	"MALAYALAM LETTER SSA",
	"MALAYALAM LETTER TA",
	"MALAYALAM LETTER THA",
	"MALAYALAM LETTER TTA",
	"MALAYALAM LETTER TTHA",
	"MALAYALAM LETTER TTTA",
	"MALAYALAM LETTER U",
	"MALAYALAM LETTER UU",
	"MALAYALAM LETTER VA",
	"MALAYALAM LETTER VOCALIC L",
	"MALAYALAM LETTER VOCALIC LL",
	"MALAYALAM LETTER VOCALIC R",
	"MALAYALAM LETTER VOCALIC RR",
	"MALAYALAM LETTER YA",
	"MALAYALAM NUMBER ONE HUNDRED",
	"MALAYALAM NUMBER ONE THOUSAND",
	"MALAYALAM NUMBER TEN",
	"MALAYALAM SIGN ANUSVARA",
	"MALAYALAM SIGN AVAGRAHA",
	"MALAYALAM SIGN VIRAMA",
	"MALAYALAM SIGN VISARGA",
	"MALAYALAM VOWEL SIGN AA",
	"MALAYALAM VOWEL SIGN AI",
	"MALAYALAM VOWEL SIGN AU",
	"MALAYALAM VOWEL SIGN E",
	"MALAYALAM VOWEL SIGN EE",
	"MALAYALAM VOWEL SIGN I",
	"MALAYALAM VOWEL SIGN II",
	"MALAYALAM VOWEL SIGN O",
	"MALAYALAM VOWEL SIGN OO",
	"MALAYALAM VOWEL SIGN U",
	"MALAYALAM VOWEL SIGN UU",
	"MALAYALAM VOWEL SIGN VOCALIC L",
	"MALAYALAM VOWEL SIGN VOCALIC LL",
	"MALAYALAM VOWEL SIGN VOCALIC R",
	"MALAYALAM VOWEL SIGN VOCALIC RR",
	"MALE AND FEMALE SIGN",
	"MALE SIGN",
	"MALE WITH STROKE AND MALE AND FEMALE SIGN",
	"MALE WITH STROKE SIGN",
	"MALTESE CROSS",
	"MAN",
	"MAN AND WOMAN HOLDING HANDS",
	"MAN WITH GUA PI MAO",
	"MAN WITH TURBAN",
	"MANDAIC AFFRICATION MARK",
	"MANDAIC GEMINATION MARK",
	"MANDAIC LETTER AB",
	"MANDAIC LETTER AD",
	"MANDAIC LETTER AG",
	"MANDAIC LETTER AH",
	"MANDAIC LETTER AIN",
	"MANDAIC LETTER AK",
	"MANDAIC LETTER AKSA",
	"MANDAIC LETTER AL",
	"MANDAIC LETTER AM",
	"MANDAIC LETTER AN",
	"MANDAIC LETTER AP",
	"MANDAIC LETTER AQ",
	"MANDAIC LETTER AR",
	"MANDAIC LETTER AS",
	"MANDAIC LETTER ASH",
	"MANDAIC LETTER ASZ",
	"MANDAIC LETTER AT",
	"MANDAIC LETTER ATT",
	"MANDAIC LETTER AZ",
	"MANDAIC LETTER DUSHENNA",
	"MANDAIC LETTER HALQA",
	"MANDAIC LETTER IN",
	"MANDAIC LETTER IT",
	"MANDAIC LETTER KAD",
	"MANDAIC LETTER USHENNA",
	"MANDAIC PUNCTUATION",
	"MANDAIC VOCALIZATION MARK",
	"MANS SHOE",
	"MAP SYMBOL FOR LIGHTHOUSE",
	"MAPLE LEAF",
	"MARRIAGE SYMBOL",
	"MASCULINE ORDINAL INDICATOR",
	"MASU MARK",
	"MATHEMATICAL BOLD CAPITAL A",
	"MATHEMATICAL BOLD CAPITAL ALPHA",
	"MATHEMATICAL BOLD CAPITAL B",
	"MATHEMATICAL BOLD CAPITAL BETA",
	"MATHEMATICAL BOLD CAPITAL C",
	"MATHEMATICAL BOLD CAPITAL CHI",
	"MATHEMATICAL BOLD CAPITAL D",
	"MATHEMATICAL BOLD CAPITAL DELTA",
	"MATHEMATICAL BOLD CAPITAL DIGAMMA",
	"MATHEMATICAL BOLD CAPITAL E",
	"MATHEMATICAL BOLD CAPITAL EPSILON",
	"MATHEMATICAL BOLD CAPITAL ETA",
	"MATHEMATICAL BOLD CAPITAL F",
	"MATHEMATICAL BOLD CAPITAL G",
	"MATHEMATICAL BOLD CAPITAL GAMMA",
	"MATHEMATICAL BOLD CAPITAL H",
	"MATHEMATICAL BOLD CAPITAL I",
	"MATHEMATICAL BOLD CAPITAL IOTA",
	"MATHEMATICAL BOLD CAPITAL J",
	"MATHEMATICAL BOLD CAPITAL K",
	"MATHEMATICAL BOLD CAPITAL KAPPA",
	"MATHEMATICAL BOLD CAPITAL L",
	"MATHEMATICAL BOLD CAPITAL LAMDA",
	"MATHEMATICAL BOLD CAPITAL M",
	"MATHEMATICAL BOLD CAPITAL MU",
	"MATHEMATICAL BOLD CAPITAL N",
	"MATHEMATICAL BOLD CAPITAL NU",
	"MATHEMATICAL BOLD CAPITAL O",
	"MATHEMATICAL BOLD CAPITAL OMEGA",
	"MATHEMATICAL BOLD CAPITAL OMICRON",
	"MATHEMATICAL BOLD CAPITAL P",
	"MATHEMATICAL BOLD CAPITAL PHI",
	"MATHEMATICAL BOLD CAPITAL PI",
	"MATHEMATICAL BOLD CAPITAL PSI",
	"MATHEMATICAL BOLD CAPITAL Q",
	"MATHEMATICAL BOLD CAPITAL R",
	"MATHEMATICAL BOLD CAPITAL RHO",
	"MATHEMATICAL BOLD CAPITAL S",
	"MATHEMATICAL BOLD CAPITAL SIGMA",
	"MATHEMATICAL BOLD CAPITAL T",
	"MATHEMATICAL BOLD CAPITAL TAU",
	"MATHEMATICAL BOLD CAPITAL THETA",
	"MATHEMATICAL BOLD CAPITAL THETA SYMBOL",
	"MATHEMATICAL BOLD CAPITAL U",
	"MATHEMATICAL BOLD CAPITAL UPSILON",
	"MATHEMATICAL BOLD CAPITAL V",
	"MATHEMATICAL BOLD CAPITAL W",
	"MATHEMATICAL BOLD CAPITAL X",
	"MATHEMATICAL BOLD CAPITAL XI",
	"MATHEMATICAL BOLD CAPITAL Y",
	"MATHEMATICAL BOLD CAPITAL Z",
	"MATHEMATICAL BOLD CAPITAL ZETA",
	"MATHEMATICAL BOLD DIGIT EIGHT",
	"MATHEMATICAL BOLD DIGIT FIVE",
	"MATHEMATICAL BOLD DIGIT FOUR",
	"MATHEMATICAL BOLD DIGIT NINE",
	"MATHEMATICAL BOLD DIGIT ONE",
	"MATHEMATICAL BOLD DIGIT SEVEN",
	"MATHEMATICAL BOLD DIGIT SIX",
	"MATHEMATICAL BOLD DIGIT THREE",
	"MATHEMATICAL BOLD DIGIT TWO",
	"MATHEMATICAL BOLD DIGIT ZERO",
	"MATHEMATICAL BOLD EPSILON SYMBOL",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL A",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL B",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL C",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL D",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL E",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL F",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL G",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL H",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL I",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL J",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL K",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL L",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL M",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL N",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL O",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL P",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL Q",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL R",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL S",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL T",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL U",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL V",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL W",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL X",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL Y",
	"MATHEMATICAL BOLD FRAKTUR CAPITAL Z",
	"MATHEMATICAL BOLD FRAKTUR SMALL A",
	"MATHEMATICAL BOLD FRAKTUR SMALL B",
	"MATHEMATICAL BOLD FRAKTUR SMALL C",
	"MATHEMATICAL BOLD FRAKTUR SMALL D",
	"MATHEMATICAL BOLD FRAKTUR SMALL E",
	"MATHEMATICAL BOLD FRAKTUR SMALL F",
	"MATHEMATICAL BOLD FRAKTUR SMALL G",
	"MATHEMATICAL BOLD FRAKTUR SMALL H",
	"MATHEMATICAL BOLD FRAKTUR SMALL I",
	"MATHEMATICAL BOLD FRAKTUR SMALL J",
	"MATHEMATICAL BOLD FRAKTUR SMALL K",
	"MATHEMATICAL BOLD FRAKTUR SMALL L",
	"MATHEMATICAL BOLD FRAKTUR SMALL M",
	"MATHEMATICAL BOLD FRAKTUR SMALL N",
	"MATHEMATICAL BOLD FRAKTUR SMALL O",
	"MATHEMATICAL BOLD FRAKTUR SMALL P",
	"MATHEMATICAL BOLD FRAKTUR SMALL Q",
	"MATHEMATICAL BOLD FRAKTUR SMALL R",
	"MATHEMATICAL BOLD FRAKTUR SMALL S",
	"MATHEMATICAL BOLD FRAKTUR SMALL T",
	"MATHEMATICAL BOLD FRAKTUR SMALL U",
	"MATHEMATICAL BOLD FRAKTUR SMALL V",
	"MATHEMATICAL BOLD FRAKTUR SMALL W",
	"MATHEMATICAL BOLD FRAKTUR SMALL X",
	"MATHEMATICAL BOLD FRAKTUR SMALL Y",
	"MATHEMATICAL BOLD FRAKTUR SMALL Z",
	"MATHEMATICAL BOLD ITALIC CAPITAL A",
	"MATHEMATICAL BOLD ITALIC CAPITAL ALPHA",
	"MATHEMATICAL BOLD ITALIC CAPITAL B",
	"MATHEMATICAL BOLD ITALIC CAPITAL BETA",
	"MATHEMATICAL BOLD ITALIC CAPITAL C",
	"MATHEMATICAL BOLD ITALIC CAPITAL CHI",
	"MATHEMATICAL BOLD ITALIC CAPITAL D",
	"MATHEMATICAL BOLD ITALIC CAPITAL DELTA",
	"MATHEMATICAL BOLD ITALIC CAPITAL E",
	"MATHEMATICAL BOLD ITALIC CAPITAL EPSILON",
	"MATHEMATICAL BOLD ITALIC CAPITAL ETA",
	"MATHEMATICAL BOLD ITALIC CAPITAL F",
	"MATHEMATICAL BOLD ITALIC CAPITAL G",
	"MATHEMATICAL BOLD ITALIC CAPITAL GAMMA",
	"MATHEMATICAL BOLD ITALIC CAPITAL H",
	"MATHEMATICAL BOLD ITALIC CAPITAL I",
	"MATHEMATICAL BOLD ITALIC CAPITAL IOTA",
	"MATHEMATICAL BOLD ITALIC CAPITAL J",
	"MATHEMATICAL BOLD ITALIC CAPITAL K",
	"MATHEMATICAL BOLD ITALIC CAPITAL KAPPA",
	"MATHEMATICAL BOLD ITALIC CAPITAL L",
	"MATHEMATICAL BOLD ITALIC CAPITAL LAMDA",
	"MATHEMATICAL BOLD ITALIC CAPITAL M",
	"MATHEMATICAL BOLD ITALIC CAPITAL MU",
	"MATHEMATICAL BOLD ITALIC CAPITAL N",
	"MATHEMATICAL BOLD ITALIC CAPITAL NU",
	"MATHEMATICAL BOLD ITALIC CAPITAL O",
	"MATHEMATICAL BOLD ITALIC CAPITAL OMEGA",
	"MATHEMATICAL BOLD ITALIC CAPITAL OMICRON",
	"MATHEMATICAL BOLD ITALIC CAPITAL P",
	"MATHEMATICAL BOLD ITALIC CAPITAL PHI",
	"MATHEMATICAL BOLD ITALIC CAPITAL PI",
	"MATHEMATICAL BOLD ITALIC CAPITAL PSI",
	"MATHEMATICAL BOLD ITALIC CAPITAL Q",
	"MATHEMATICAL BOLD ITALIC CAPITAL R",
	"MATHEMATICAL BOLD ITALIC CAPITAL RHO",
	"MATHEMATICAL BOLD ITALIC CAPITAL S",
	"MATHEMATICAL BOLD ITALIC CAPITAL SIGMA",
	"MATHEMATICAL BOLD ITALIC CAPITAL T",
	"MATHEMATICAL BOLD ITALIC CAPITAL TAU",
	"MATHEMATICAL BOLD ITALIC CAPITAL THETA",
	"MATHEMATICAL BOLD ITALIC CAPITAL THETA SYMBOL",
	"MATHEMATICAL BOLD ITALIC CAPITAL U",
	"MATHEMATICAL BOLD ITALIC CAPITAL UPSILON",
	"MATHEMATICAL BOLD ITALIC CAPITAL V",
	"MATHEMATICAL BOLD ITALIC CAPITAL W",
	"MATHEMATICAL BOLD ITALIC CAPITAL X",
	"MATHEMATICAL BOLD ITALIC CAPITAL XI",
	"MATHEMATICAL BOLD ITALIC CAPITAL Y",
	"MATHEMATICAL BOLD ITALIC CAPITAL Z",
	"MATHEMATICAL BOLD ITALIC CAPITAL ZETA",
	"MATHEMATICAL BOLD ITALIC EPSILON SYMBOL",
	"MATHEMATICAL BOLD ITALIC KAPPA SYMBOL",
	"MATHEMATICAL BOLD ITALIC NABLA",
	"MATHEMATICAL BOLD ITALIC PARTIAL DIFFERENTIAL",
	"MATHEMATICAL BOLD ITALIC PHI SYMBOL",
	"MATHEMATICAL BOLD ITALIC PI SYMBOL",
	"MATHEMATICAL BOLD ITALIC RHO SYMBOL",
	"MATHEMATICAL BOLD ITALIC SMALL A",
	"MATHEMATICAL BOLD ITALIC SMALL ALPHA",
	"MATHEMATICAL BOLD ITALIC SMALL B",
	"MATHEMATICAL BOLD ITALIC SMALL BETA",
	"MATHEMATICAL BOLD ITALIC SMALL C",
	"MATHEMATICAL BOLD ITALIC SMALL CHI",
	"MATHEMATICAL BOLD ITALIC SMALL D",
	"MATHEMATICAL BOLD ITALIC SMALL DELTA",
	"MATHEMATICAL BOLD ITALIC SMALL E",
	"MATHEMATICAL BOLD ITALIC SMALL EPSILON",
	"MATHEMATICAL BOLD ITALIC SMALL ETA",
	"MATHEMATICAL BOLD ITALIC SMALL F",
	"MATHEMATICAL BOLD ITALIC SMALL FINAL SIGMA",
	"MATHEMATICAL BOLD ITALIC SMALL G",
	"MATHEMATICAL BOLD ITALIC SMALL GAMMA",
	"MATHEMATICAL BOLD ITALIC SMALL H",
	"MATHEMATICAL BOLD ITALIC SMALL I",
	"MATHEMATICAL BOLD ITALIC SMALL IOTA",
	"MATHEMATICAL BOLD ITALIC SMALL J",
	"MATHEMATICAL BOLD ITALIC SMALL K",
	"MATHEMATICAL BOLD ITALIC SMALL KAPPA",
	"MATHEMATICAL BOLD ITALIC SMALL L",
	"MATHEMATICAL BOLD ITALIC SMALL LAMDA",
	"MATHEMATICAL BOLD ITALIC SMALL M",
	"MATHEMATICAL BOLD ITALIC SMALL MU",
	"MATHEMATICAL BOLD ITALIC SMALL N",
	"MATHEMATICAL BOLD ITALIC SMALL NU",
	"MATHEMATICAL BOLD ITALIC SMALL O",
	"MATHEMATICAL BOLD ITALIC SMALL OMEGA",
	"MATHEMATICAL BOLD ITALIC SMALL OMICRON",
	"MATHEMATICAL BOLD ITALIC SMALL P",
	"MATHEMATICAL BOLD ITALIC SMALL PHI",
	"MATHEMATICAL BOLD ITALIC SMALL PI",
	"MATHEMATICAL BOLD ITALIC SMALL PSI",
	"MATHEMATICAL BOLD ITALIC SMALL Q",
	"MATHEMATICAL BOLD ITALIC SMALL R",
	"MATHEMATICAL BOLD ITALIC SMALL RHO",
	"MATHEMATICAL BOLD ITALIC SMALL S",
	"MATHEMATICAL BOLD ITALIC SMALL SIGMA",
	"MATHEMATICAL BOLD ITALIC SMALL T",
	"MATHEMATICAL BOLD ITALIC SMALL TAU",
	"MATHEMATICAL BOLD ITALIC SMALL THETA",
	"MATHEMATICAL BOLD ITALIC SMALL U",
	"MATHEMATICAL BOLD ITALIC SMALL UPSILON",
	"MATHEMATICAL BOLD ITALIC SMALL V",
	"MATHEMATICAL BOLD ITALIC SMALL W",
	"MATHEMATICAL BOLD ITALIC SMALL X",
	"MATHEMATICAL BOLD ITALIC SMALL XI",
	"MATHEMATICAL BOLD ITALIC SMALL Y",
	"MATHEMATICAL BOLD ITALIC SMALL Z",
	"MATHEMATICAL BOLD ITALIC SMALL ZETA",
	"MATHEMATICAL BOLD ITALIC THETA SYMBOL",
	"MATHEMATICAL BOLD KAPPA SYMBOL",
	"MATHEMATICAL BOLD NABLA",
	"MATHEMATICAL BOLD PARTIAL DIFFERENTIAL",
	"MATHEMATICAL BOLD PHI SYMBOL",
	"MATHEMATICAL BOLD PI SYMBOL",
	"MATHEMATICAL BOLD RHO SYMBOL",
	"MATHEMATICAL BOLD SCRIPT CAPITAL A",
	"MATHEMATICAL BOLD SCRIPT CAPITAL B",
	"MATHEMATICAL BOLD SCRIPT CAPITAL C",
	"MATHEMATICAL BOLD SCRIPT CAPITAL D",
	"MATHEMATICAL BOLD SCRIPT CAPITAL E",
	"MATHEMATICAL BOLD SCRIPT CAPITAL F",
	"MATHEMATICAL BOLD SCRIPT CAPITAL G",
	"MATHEMATICAL BOLD SCRIPT CAPITAL H",
	"MATHEMATICAL BOLD SCRIPT CAPITAL I",
	"MATHEMATICAL BOLD SCRIPT CAPITAL J",
	"MATHEMATICAL BOLD SCRIPT CAPITAL K",
	"MATHEMATICAL BOLD SCRIPT CAPITAL L",
	"MATHEMATICAL BOLD SCRIPT CAPITAL M",
	"MATHEMATICAL BOLD SCRIPT CAPITAL N",
	"MATHEMATICAL BOLD SCRIPT CAPITAL O",
	"MATHEMATICAL BOLD SCRIPT CAPITAL P",
	"MATHEMATICAL BOLD SCRIPT CAPITAL Q",
	"MATHEMATICAL BOLD SCRIPT CAPITAL R",
	"MATHEMATICAL BOLD SCRIPT CAPITAL S",
	"MATHEMATICAL BOLD SCRIPT CAPITAL T",
	"MATHEMATICAL BOLD SCRIPT CAPITAL U",
	"MATHEMATICAL BOLD SCRIPT CAPITAL V",
	"MATHEMATICAL BOLD SCRIPT CAPITAL W",
	"MATHEMATICAL BOLD SCRIPT CAPITAL X",
	"MATHEMATICAL BOLD SCRIPT CAPITAL Y",
	"MATHEMATICAL BOLD SCRIPT CAPITAL Z",
	"MATHEMATICAL BOLD SCRIPT SMALL A",
	"MATHEMATICAL BOLD SCRIPT SMALL B",
	"MATHEMATICAL BOLD SCRIPT SMALL C",
	"MATHEMATICAL BOLD SCRIPT SMALL D",
	"MATHEMATICAL BOLD SCRIPT SMALL E",
	"MATHEMATICAL BOLD SCRIPT SMALL F",
	"MATHEMATICAL BOLD SCRIPT SMALL G",
	"MATHEMATICAL BOLD SCRIPT SMALL H",
	"MATHEMATICAL BOLD SCRIPT SMALL I",
	"MATHEMATICAL BOLD SCRIPT SMALL J",
	"MATHEMATICAL BOLD SCRIPT SMALL K",
	"MATHEMATICAL BOLD SCRIPT SMALL L",
	"MATHEMATICAL BOLD SCRIPT SMALL M",
	"MATHEMATICAL BOLD SCRIPT SMALL N",
	"MATHEMATICAL BOLD SCRIPT SMALL O",
	"MATHEMATICAL BOLD SCRIPT SMALL P",
	"MATHEMATICAL BOLD SCRIPT SMALL Q",
	"MATHEMATICAL BOLD SCRIPT SMALL R",
	"MATHEMATICAL BOLD SCRIPT SMALL S",
	"MATHEMATICAL BOLD SCRIPT SMALL T",
	"MATHEMATICAL BOLD SCRIPT SMALL U",
	"MATHEMATICAL BOLD SCRIPT SMALL V",
	"MATHEMATICAL BOLD SCRIPT SMALL W",
	"MATHEMATICAL BOLD SCRIPT SMALL X",
	"MATHEMATICAL BOLD SCRIPT SMALL Y",
	"MATHEMATICAL BOLD SCRIPT SMALL Z",
	"MATHEMATICAL BOLD SMALL A",
	"MATHEMATICAL BOLD SMALL ALPHA",
	"MATHEMATICAL BOLD SMALL B",
	"MATHEMATICAL BOLD SMALL BETA",
	"MATHEMATICAL BOLD SMALL C",
	"MATHEMATICAL BOLD SMALL CHI",
	"MATHEMATICAL BOLD SMALL D",
	"MATHEMATICAL BOLD SMALL DELTA",
	"MATHEMATICAL BOLD SMALL DIGAMMA",
	"MATHEMATICAL BOLD SMALL E",
	"MATHEMATICAL BOLD SMALL EPSILON",
	"MATHEMATICAL BOLD SMALL ETA",
	"MATHEMATICAL BOLD SMALL F",
	"MATHEMATICAL BOLD SMALL FINAL SIGMA",
	"MATHEMATICAL BOLD SMALL G",
	"MATHEMATICAL BOLD SMALL GAMMA",
	"MATHEMATICAL BOLD SMALL H",
	"MATHEMATICAL BOLD SMALL I",
	"MATHEMATICAL BOLD SMALL IOTA",
	"MATHEMATICAL BOLD SMALL J",
	"MATHEMATICAL BOLD SMALL K",
	"MATHEMATICAL BOLD SMALL KAPPA",
	"MATHEMATICAL BOLD SMALL L",
	"MATHEMATICAL BOLD SMALL LAMDA",
	"MATHEMATICAL BOLD SMALL M",
	"MATHEMATICAL BOLD SMALL MU",
	"MATHEMATICAL BOLD SMALL N",
	"MATHEMATICAL BOLD SMALL NU",
	"MATHEMATICAL BOLD SMALL O",
	"MATHEMATICAL BOLD SMALL OMEGA",
	"MATHEMATICAL BOLD SMALL OMICRON",
	"MATHEMATICAL BOLD SMALL P",
	"MATHEMATICAL BOLD SMALL PHI",
	"MATHEMATICAL BOLD SMALL PI",
	"MATHEMATICAL BOLD SMALL PSI",
	"MATHEMATICAL BOLD SMALL Q",
	"MATHEMATICAL BOLD SMALL R",
	"MATHEMATICAL BOLD SMALL RHO",
	"MATHEMATICAL BOLD SMALL S",
	"MATHEMATICAL BOLD SMALL SIGMA",
	"MATHEMATICAL BOLD SMALL T",
	"MATHEMATICAL BOLD SMALL TAU",
	"MATHEMATICAL BOLD SMALL THETA",
	"MATHEMATICAL BOLD SMALL U",
	"MATHEMATICAL BOLD SMALL UPSILON",
	"MATHEMATICAL BOLD SMALL V",
	"MATHEMATICAL BOLD SMALL W",
	"MATHEMATICAL BOLD SMALL X",
	"MATHEMATICAL BOLD SMALL XI",
	"MATHEMATICAL BOLD SMALL Y",
	"MATHEMATICAL BOLD SMALL Z",
	"MATHEMATICAL BOLD SMALL ZETA",
	"MATHEMATICAL BOLD THETA SYMBOL",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL A",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL B",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL D",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL E",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL F",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL G",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL I",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL J",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL K",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL L",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL M",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL O",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL S",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL T",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL U",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL V",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL W",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL X",
	"MATHEMATICAL DOUBLE-STRUCK CAPITAL Y",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT EIGHT",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT FIVE",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT FOUR",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT NINE",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT ONE",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT SEVEN",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT SIX",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT THREE",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT TWO",
	"MATHEMATICAL DOUBLE-STRUCK DIGIT ZERO",
	"MATHEMATICAL DOUBLE-STRUCK SMALL A",
	"MATHEMATICAL DOUBLE-STRUCK SMALL B",
	"MATHEMATICAL DOUBLE-STRUCK SMALL C",
	"MATHEMATICAL DOUBLE-STRUCK SMALL D",
	"MATHEMATICAL DOUBLE-STRUCK SMALL E",
	"MATHEMATICAL DOUBLE-STRUCK SMALL F",
	"MATHEMATICAL DOUBLE-STRUCK SMALL G",
	"MATHEMATICAL DOUBLE-STRUCK SMALL H",
	"MATHEMATICAL DOUBLE-STRUCK SMALL I",
	"MATHEMATICAL DOUBLE-STRUCK SMALL J",
	"MATHEMATICAL DOUBLE-STRUCK SMALL K",
	"MATHEMATICAL DOUBLE-STRUCK SMALL L",
	"MATHEMATICAL DOUBLE-STRUCK SMALL M",
	"MATHEMATICAL DOUBLE-STRUCK SMALL N",
	"MATHEMATICAL DOUBLE-STRUCK SMALL O",
	"MATHEMATICAL DOUBLE-STRUCK SMALL P",
	"MATHEMATICAL DOUBLE-STRUCK SMALL Q",
	"MATHEMATICAL DOUBLE-STRUCK SMALL R",
	"MATHEMATICAL DOUBLE-STRUCK SMALL S",
	"MATHEMATICAL DOUBLE-STRUCK SMALL T",
	"MATHEMATICAL DOUBLE-STRUCK SMALL U",
	"MATHEMATICAL DOUBLE-STRUCK SMALL V",
	"MATHEMATICAL DOUBLE-STRUCK SMALL W",
	"MATHEMATICAL DOUBLE-STRUCK SMALL X",
	"MATHEMATICAL DOUBLE-STRUCK SMALL Y",
	"MATHEMATICAL DOUBLE-STRUCK SMALL Z",
	"MATHEMATICAL FALLING DIAGONAL",
	"MATHEMATICAL FRAKTUR CAPITAL A",
	"MATHEMATICAL FRAKTUR CAPITAL B",
	"MATHEMATICAL FRAKTUR CAPITAL D",
	"MATHEMATICAL FRAKTUR CAPITAL E",
	"MATHEMATICAL FRAKTUR CAPITAL F",
	"MATHEMATICAL FRAKTUR CAPITAL G",
	"MATHEMATICAL FRAKTUR CAPITAL J",
	"MATHEMATICAL FRAKTUR CAPITAL K",
	"MATHEMATICAL FRAKTUR CAPITAL L",
	"MATHEMATICAL FRAKTUR CAPITAL M",
	"MATHEMATICAL FRAKTUR CAPITAL N",
	"MATHEMATICAL FRAKTUR CAPITAL O",
	"MATHEMATICAL FRAKTUR CAPITAL P",
	"MATHEMATICAL FRAKTUR CAPITAL Q",
	"MATHEMATICAL FRAKTUR CAPITAL S",
	"MATHEMATICAL FRAKTUR CAPITAL T",
	"MATHEMATICAL FRAKTUR CAPITAL U",
	"MATHEMATICAL FRAKTUR CAPITAL V",
	"MATHEMATICAL FRAKTUR CAPITAL W",
	"MATHEMATICAL FRAKTUR CAPITAL X",
	"MATHEMATICAL FRAKTUR CAPITAL Y",
	"MATHEMATICAL FRAKTUR SMALL A",
	"MATHEMATICAL FRAKTUR SMALL B",
	"MATHEMATICAL FRAKTUR SMALL C",
	"MATHEMATICAL FRAKTUR SMALL D",
	"MATHEMATICAL FRAKTUR SMALL E",
	"MATHEMATICAL FRAKTUR SMALL F",
	"MATHEMATICAL FRAKTUR SMALL G",
	"MATHEMATICAL FRAKTUR SMALL H",
	"MATHEMATICAL FRAKTUR SMALL I",
	"MATHEMATICAL FRAKTUR SMALL J",
	"MATHEMATICAL FRAKTUR SMALL K",
	"MATHEMATICAL FRAKTUR SMALL L",
	"MATHEMATICAL FRAKTUR SMALL M",
	"MATHEMATICAL FRAKTUR SMALL N",
	"MATHEMATICAL FRAKTUR SMALL O",
	"MATHEMATICAL FRAKTUR SMALL P",
	"MATHEMATICAL FRAKTUR SMALL Q",
	"MATHEMATICAL FRAKTUR SMALL R",
	"MATHEMATICAL FRAKTUR SMALL S",
	"MATHEMATICAL FRAKTUR SMALL T",
	"MATHEMATICAL FRAKTUR SMALL U",
	"MATHEMATICAL FRAKTUR SMALL V",
	"MATHEMATICAL FRAKTUR SMALL W",
	"MATHEMATICAL FRAKTUR SMALL X",
	"MATHEMATICAL FRAKTUR SMALL Y",
	"MATHEMATICAL FRAKTUR SMALL Z",
	"MATHEMATICAL ITALIC CAPITAL A",
	"MATHEMATICAL ITALIC CAPITAL ALPHA",
	"MATHEMATICAL ITALIC CAPITAL B",
	"MATHEMATICAL ITALIC CAPITAL BETA",
	"MATHEMATICAL ITALIC CAPITAL C",
	"MATHEMATICAL ITALIC CAPITAL CHI",
	"MATHEMATICAL ITALIC CAPITAL D",
	"MATHEMATICAL ITALIC CAPITAL DELTA",
	"MATHEMATICAL ITALIC CAPITAL E",
	"MATHEMATICAL ITALIC CAPITAL EPSILON",
	"MATHEMATICAL ITALIC CAPITAL ETA",
	"MATHEMATICAL ITALIC CAPITAL F",
	"MATHEMATICAL ITALIC CAPITAL G",
	"MATHEMATICAL ITALIC CAPITAL GAMMA",
	"MATHEMATICAL ITALIC CAPITAL H",
	"MATHEMATICAL ITALIC CAPITAL I",
	"MATHEMATICAL ITALIC CAPITAL IOTA",
	"MATHEMATICAL ITALIC CAPITAL J",
	"MATHEMATICAL ITALIC CAPITAL K",
	"MATHEMATICAL ITALIC CAPITAL KAPPA",
	"MATHEMATICAL ITALIC CAPITAL L",
	"MATHEMATICAL ITALIC CAPITAL LAMDA",
	"MATHEMATICAL ITALIC CAPITAL M",
	"MATHEMATICAL ITALIC CAPITAL MU",
	"MATHEMATICAL ITALIC CAPITAL N",
	"MATHEMATICAL ITALIC CAPITAL NU",
	"MATHEMATICAL ITALIC CAPITAL O",
	"MATHEMATICAL ITALIC CAPITAL OMEGA",
	"MATHEMATICAL ITALIC CAPITAL OMICRON",
	"MATHEMATICAL ITALIC CAPITAL P",
	"MATHEMATICAL ITALIC CAPITAL PHI",
	"MATHEMATICAL ITALIC CAPITAL PI",
	"MATHEMATICAL ITALIC CAPITAL PSI",
	"MATHEMATICAL ITALIC CAPITAL Q",
	"MATHEMATICAL ITALIC CAPITAL R",
	"MATHEMATICAL ITALIC CAPITAL RHO",
	"MATHEMATICAL ITALIC CAPITAL S",
	"MATHEMATICAL ITALIC CAPITAL SIGMA",
	"MATHEMATICAL ITALIC CAPITAL T",
	"MATHEMATICAL ITALIC CAPITAL TAU",
	"MATHEMATICAL ITALIC CAPITAL THETA",
	"MATHEMATICAL ITALIC CAPITAL THETA SYMBOL",
	"MATHEMATICAL ITALIC CAPITAL U",
	"MATHEMATICAL ITALIC CAPITAL UPSILON",
	"MATHEMATICAL ITALIC CAPITAL V",
	"MATHEMATICAL ITALIC CAPITAL W",
	"MATHEMATICAL ITALIC CAPITAL X",
	"MATHEMATICAL ITALIC CAPITAL XI",
	"MATHEMATICAL ITALIC CAPITAL Y",
	"MATHEMATICAL ITALIC CAPITAL Z",
	"MATHEMATICAL ITALIC CAPITAL ZETA",
	"MATHEMATICAL ITALIC EPSILON SYMBOL",
	"MATHEMATICAL ITALIC KAPPA SYMBOL",
	"MATHEMATICAL ITALIC NABLA",
	"MATHEMATICAL ITALIC PARTIAL DIFFERENTIAL",
	"MATHEMATICAL ITALIC PHI SYMBOL",
	"MATHEMATICAL ITALIC PI SYMBOL",
	"MATHEMATICAL ITALIC RHO SYMBOL",
	"MATHEMATICAL ITALIC SMALL A",
	"MATHEMATICAL ITALIC SMALL ALPHA",
	"MATHEMATICAL ITALIC SMALL B",
	"MATHEMATICAL ITALIC SMALL BETA",
	"MATHEMATICAL ITALIC SMALL C",
	"MATHEMATICAL ITALIC SMALL CHI",
	"MATHEMATICAL ITALIC SMALL D",
	"MATHEMATICAL ITALIC SMALL DELTA",
	"MATHEMATICAL ITALIC SMALL DOTLESS I",
	"MATHEMATICAL ITALIC SMALL DOTLESS J",
	"MATHEMATICAL ITALIC SMALL E",
	"MATHEMATICAL ITALIC SMALL EPSILON",
	"MATHEMATICAL ITALIC SMALL ETA",
	"MATHEMATICAL ITALIC SMALL F",
	"MATHEMATICAL ITALIC SMALL FINAL SIGMA",
	"MATHEMATICAL ITALIC SMALL G",
	"MATHEMATICAL ITALIC SMALL GAMMA",
	"MATHEMATICAL ITALIC SMALL I",
	"MATHEMATICAL ITALIC SMALL IOTA",
	"MATHEMATICAL ITALIC SMALL J",
	"MATHEMATICAL ITALIC SMALL K",
	"MATHEMATICAL ITALIC SMALL KAPPA",
	"MATHEMATICAL ITALIC SMALL L",
	"MATHEMATICAL ITALIC SMALL LAMDA",
	"MATHEMATICAL ITALIC SMALL M",
	"MATHEMATICAL ITALIC SMALL MU",
	"MATHEMATICAL ITALIC SMALL N",
	"MATHEMATICAL ITALIC SMALL NU",
	"MATHEMATICAL ITALIC SMALL O",
	"MATHEMATICAL ITALIC SMALL OMEGA",
	"MATHEMATICAL ITALIC SMALL OMICRON",
	"MATHEMATICAL ITALIC SMALL P",
	"MATHEMATICAL ITALIC SMALL PHI",
	"MATHEMATICAL ITALIC SMALL PI",
	"MATHEMATICAL ITALIC SMALL PSI",
	"MATHEMATICAL ITALIC SMALL Q",
	"MATHEMATICAL ITALIC SMALL R",
	"MATHEMATICAL ITALIC SMALL RHO",
	"MATHEMATICAL ITALIC SMALL S",
	"MATHEMATICAL ITALIC SMALL SIGMA",
	"MATHEMATICAL ITALIC SMALL T",
	"MATHEMATICAL ITALIC SMALL TAU",
	"MATHEMATICAL ITALIC SMALL THETA",
	"MATHEMATICAL ITALIC SMALL U",
	"MATHEMATICAL ITALIC SMALL UPSILON",
	"MATHEMATICAL ITALIC SMALL V",
	"MATHEMATICAL ITALIC SMALL W",
	"MATHEMATICAL ITALIC SMALL X",
	"MATHEMATICAL ITALIC SMALL XI",
	"MATHEMATICAL ITALIC SMALL Y",
	"MATHEMATICAL ITALIC SMALL Z",
	"MATHEMATICAL ITALIC SMALL ZETA",
	"MATHEMATICAL ITALIC THETA SYMBOL",
	"MATHEMATICAL LEFT ANGLE BRACKET",
	"MATHEMATICAL LEFT DOUBLE ANGLE BRACKET",
	"MATHEMATICAL LEFT FLATTENED PARENTHESIS",
	"MATHEMATICAL LEFT WHITE SQUARE BRACKET",
	"MATHEMATICAL LEFT WHITE TORTOISE SHELL BRACKET",
	"MATHEMATICAL MONOSPACE CAPITAL A",
	"MATHEMATICAL MONOSPACE CAPITAL B",
	"MATHEMATICAL MONOSPACE CAPITAL C",
	"MATHEMATICAL MONOSPACE CAPITAL D",
	"MATHEMATICAL MONOSPACE CAPITAL E",
	"MATHEMATICAL MONOSPACE CAPITAL F",
	"MATHEMATICAL MONOSPACE CAPITAL G",
	"MATHEMATICAL MONOSPACE CAPITAL H",
	"MATHEMATICAL MONOSPACE CAPITAL I",
	"MATHEMATICAL MONOSPACE CAPITAL J",
	"MATHEMATICAL MONOSPACE CAPITAL K",
	"MATHEMATICAL MONOSPACE CAPITAL L",
	"MATHEMATICAL MONOSPACE CAPITAL M",
	"MATHEMATICAL MONOSPACE CAPITAL N",
	"MATHEMATICAL MONOSPACE CAPITAL O",
	"MATHEMATICAL MONOSPACE CAPITAL P",
	"MATHEMATICAL MONOSPACE CAPITAL Q",
	"MATHEMATICAL MONOSPACE CAPITAL R",
	"MATHEMATICAL MONOSPACE CAPITAL S",
	"MATHEMATICAL MONOSPACE CAPITAL T",
	"MATHEMATICAL MONOSPACE CAPITAL U",
	"MATHEMATICAL MONOSPACE CAPITAL V",
	"MATHEMATICAL MONOSPACE CAPITAL W",
	"MATHEMATICAL MONOSPACE CAPITAL X",
	"MATHEMATICAL MONOSPACE CAPITAL Y",
	"MATHEMATICAL MONOSPACE CAPITAL Z",
	"MATHEMATICAL MONOSPACE DIGIT EIGHT",
	"MATHEMATICAL MONOSPACE DIGIT FIVE",
	"MATHEMATICAL MONOSPACE DIGIT FOUR",
	"MATHEMATICAL MONOSPACE DIGIT NINE",
	"MATHEMATICAL MONOSPACE DIGIT ONE",
	"MATHEMATICAL MONOSPACE DIGIT SEVEN",
	"MATHEMATICAL MONOSPACE DIGIT SIX",
	"MATHEMATICAL MONOSPACE DIGIT THREE",
	"MATHEMATICAL MONOSPACE DIGIT TWO",
	"MATHEMATICAL MONOSPACE DIGIT ZERO",
	"MATHEMATICAL MONOSPACE SMALL A",
	"MATHEMATICAL MONOSPACE SMALL B",
	"MATHEMATICAL MONOSPACE SMALL C",
	"MATHEMATICAL MONOSPACE SMALL D",
	"MATHEMATICAL MONOSPACE SMALL E",
	"MATHEMATICAL MONOSPACE SMALL F",
	"MATHEMATICAL MONOSPACE SMALL G",
	"MATHEMATICAL MONOSPACE SMALL H",
	"MATHEMATICAL MONOSPACE SMALL I",
	"MATHEMATICAL MONOSPACE SMALL J",
	"MATHEMATICAL MONOSPACE SMALL K",
	"MATHEMATICAL MONOSPACE SMALL L",
	"MATHEMATICAL MONOSPACE SMALL M",
	"MATHEMATICAL MONOSPACE SMALL N",
	"MATHEMATICAL MONOSPACE SMALL O",
	"MATHEMATICAL MONOSPACE SMALL P",
	"MATHEMATICAL MONOSPACE SMALL Q",
	"MATHEMATICAL MONOSPACE SMALL R",
	"MATHEMATICAL MONOSPACE SMALL S",
	"MATHEMATICAL MONOSPACE SMALL T",
	"MATHEMATICAL MONOSPACE SMALL U",
	"MATHEMATICAL MONOSPACE SMALL V",
	"MATHEMATICAL MONOSPACE SMALL W",
	"MATHEMATICAL MONOSPACE SMALL X",
	"MATHEMATICAL MONOSPACE SMALL Y",
	"MATHEMATICAL MONOSPACE SMALL Z",
	"MATHEMATICAL RIGHT ANGLE BRACKET",
	"MATHEMATICAL RIGHT DOUBLE ANGLE BRACKET",
	"MATHEMATICAL RIGHT FLATTENED PARENTHESIS",
	"MATHEMATICAL RIGHT WHITE SQUARE BRACKET",
	"MATHEMATICAL RIGHT WHITE TORTOISE SHELL BRACKET",
	"MATHEMATICAL RISING DIAGONAL",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL A",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL ALPHA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL B",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL BETA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL C",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL CHI",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL D",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL DELTA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL E",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL EPSILON",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL ETA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL F",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL G",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL GAMMA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL H",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL I",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL IOTA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL J",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL K",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL KAPPA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL L",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL LAMDA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL M",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL MU",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL N",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL NU",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL O",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL OMICRON",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL P",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL PHI",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL PI",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL PSI",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL Q",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL R",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL RHO",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL S",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL SIGMA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL T",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL TAU",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL U",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL UPSILON",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL V",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL W",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL X",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL XI",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL Y",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL Z",
	"MATHEMATICAL SANS-SERIF BOLD CAPITAL ZETA",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT EIGHT",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT FIVE",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT FOUR",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT NINE",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT ONE",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT SEVEN",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT SIX",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT THREE",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT TWO",
	"MATHEMATICAL SANS-SERIF BOLD DIGIT ZERO",
	"MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL A",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ALPHA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL B",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL BETA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL C",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL CHI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL D",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL DELTA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL E",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL EPSILON",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ETA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL F",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL G",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL GAMMA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL H",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL I",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL IOTA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL J",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL K",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL KAPPA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL L",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL LAMDA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL M",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL MU",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL N",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL NU",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL O",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMICRON",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL P",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PHI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PSI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Q",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL R",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL RHO",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL S",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL SIGMA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL T",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL TAU",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL U",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL UPSILON",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL V",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL W",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL X",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL XI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Y",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Z",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ZETA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC KAPPA SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC NABLA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC PARTIAL DIFFERENTIAL",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC PHI SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC PI SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC RHO SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL A",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL B",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL BETA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL C",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL CHI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL D",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL DELTA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL E",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL EPSILON",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ETA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL F",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL FINAL SIGMA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL G",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL GAMMA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL H",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL I",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL IOTA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL J",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL K",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL KAPPA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL L",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL LAMDA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL M",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL MU",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL N",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL NU",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL O",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMICRON",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL P",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PHI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PSI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Q",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL R",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL RHO",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL S",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL SIGMA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL T",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL TAU",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL THETA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL U",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL UPSILON",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL V",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL W",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL X",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL XI",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Y",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Z",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ZETA",
	"MATHEMATICAL SANS-SERIF BOLD ITALIC THETA SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD KAPPA SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD NABLA",
	"MATHEMATICAL SANS-SERIF BOLD PARTIAL DIFFERENTIAL",
	"MATHEMATICAL SANS-SERIF BOLD PHI SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD PI SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD RHO SYMBOL",
	"MATHEMATICAL SANS-SERIF BOLD SMALL A",
	"MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL B",
	"MATHEMATICAL SANS-SERIF BOLD SMALL BETA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL C",
	"MATHEMATICAL SANS-SERIF BOLD SMALL CHI",
	"MATHEMATICAL SANS-SERIF BOLD SMALL D",
	"MATHEMATICAL SANS-SERIF BOLD SMALL DELTA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL E",
	"MATHEMATICAL SANS-SERIF BOLD SMALL EPSILON",
	"MATHEMATICAL SANS-SERIF BOLD SMALL ETA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL F",
	"MATHEMATICAL SANS-SERIF BOLD SMALL FINAL SIGMA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL G",
	"MATHEMATICAL SANS-SERIF BOLD SMALL GAMMA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL H",
	"MATHEMATICAL SANS-SERIF BOLD SMALL I",
	"MATHEMATICAL SANS-SERIF BOLD SMALL IOTA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL J",
	"MATHEMATICAL SANS-SERIF BOLD SMALL K",
	"MATHEMATICAL SANS-SERIF BOLD SMALL KAPPA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL L",
	"MATHEMATICAL SANS-SERIF BOLD SMALL LAMDA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL M",
	"MATHEMATICAL SANS-SERIF BOLD SMALL MU",
	"MATHEMATICAL SANS-SERIF BOLD SMALL N",
	"MATHEMATICAL SANS-SERIF BOLD SMALL NU",
	"MATHEMATICAL SANS-SERIF BOLD SMALL O",
	"MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL OMICRON",
	"MATHEMATICAL SANS-SERIF BOLD SMALL P",
	"MATHEMATICAL SANS-SERIF BOLD SMALL PHI",
	"MATHEMATICAL SANS-SERIF BOLD SMALL PI",
	"MATHEMATICAL SANS-SERIF BOLD SMALL PSI",
	"MATHEMATICAL SANS-SERIF BOLD SMALL Q",
	"MATHEMATICAL SANS-SERIF BOLD SMALL R",
	"MATHEMATICAL SANS-SERIF BOLD SMALL RHO",
	"MATHEMATICAL SANS-SERIF BOLD SMALL S",
	"MATHEMATICAL SANS-SERIF BOLD SMALL SIGMA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL T",
	"MATHEMATICAL SANS-SERIF BOLD SMALL TAU",
	"MATHEMATICAL SANS-SERIF BOLD SMALL THETA",
	"MATHEMATICAL SANS-SERIF BOLD SMALL U",
	"MATHEMATICAL SANS-SERIF BOLD SMALL UPSILON",
	"MATHEMATICAL SANS-SERIF BOLD SMALL V",
	"MATHEMATICAL SANS-SERIF BOLD SMALL W",
	"MATHEMATICAL SANS-SERIF BOLD SMALL X",
	"MATHEMATICAL SANS-SERIF BOLD SMALL XI",
	"MATHEMATICAL SANS-SERIF BOLD SMALL Y",
	"MATHEMATICAL SANS-SERIF BOLD SMALL Z",
	"MATHEMATICAL SANS-SERIF BOLD SMALL ZETA",
	"MATHEMATICAL SANS-SERIF BOLD THETA SYMBOL",
	"MATHEMATICAL SANS-SERIF CAPITAL A",
	"MATHEMATICAL SANS-SERIF CAPITAL B",
	"MATHEMATICAL SANS-SERIF CAPITAL C",
	"MATHEMATICAL SANS-SERIF CAPITAL D",
	"MATHEMATICAL SANS-SERIF CAPITAL E",
	"MATHEMATICAL SANS-SERIF CAPITAL F",
	"MATHEMATICAL SANS-SERIF CAPITAL G",
	"MATHEMATICAL SANS-SERIF CAPITAL H",
	"MATHEMATICAL SANS-SERIF CAPITAL I",
	"MATHEMATICAL SANS-SERIF CAPITAL J",
	"MATHEMATICAL SANS-SERIF CAPITAL K",
	"MATHEMATICAL SANS-SERIF CAPITAL L",
	"MATHEMATICAL SANS-SERIF CAPITAL M",
	"MATHEMATICAL SANS-SERIF CAPITAL N",
	"MATHEMATICAL SANS-SERIF CAPITAL O",
	"MATHEMATICAL SANS-SERIF CAPITAL P",
	"MATHEMATICAL SANS-SERIF CAPITAL Q",
	"MATHEMATICAL SANS-SERIF CAPITAL R",
	"MATHEMATICAL SANS-SERIF CAPITAL S",
	"MATHEMATICAL SANS-SERIF CAPITAL T",
	"MATHEMATICAL SANS-SERIF CAPITAL U",
	"MATHEMATICAL SANS-SERIF CAPITAL V",
	"MATHEMATICAL SANS-SERIF CAPITAL W",
	"MATHEMATICAL SANS-SERIF CAPITAL X",
	"MATHEMATICAL SANS-SERIF CAPITAL Y",
	"MATHEMATICAL SANS-SERIF CAPITAL Z",
	"MATHEMATICAL SANS-SERIF DIGIT EIGHT",
	"MATHEMATICAL SANS-SERIF DIGIT FIVE",
	"MATHEMATICAL SANS-SERIF DIGIT FOUR",
	"MATHEMATICAL SANS-SERIF DIGIT NINE",
	"MATHEMATICAL SANS-SERIF DIGIT ONE",
	"MATHEMATICAL SANS-SERIF DIGIT SEVEN",
	"MATHEMATICAL SANS-SERIF DIGIT SIX",
	"MATHEMATICAL SANS-SERIF DIGIT THREE",
	"MATHEMATICAL SANS-SERIF DIGIT TWO",
	"MATHEMATICAL SANS-SERIF DIGIT ZERO",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL A",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL B",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL C",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL D",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL E",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL F",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL G",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL H",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL I",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL J",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL K",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL L",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL M",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL N",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL O",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL P",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL Q",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL R",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL S",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL T",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL U",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL V",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL W",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL X",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL Y",
	"MATHEMATICAL SANS-SERIF ITALIC CAPITAL Z",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL A",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL B",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL C",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL D",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL E",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL F",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL G",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL H",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL I",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL J",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL K",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL L",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL M",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL N",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL O",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL P",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL Q",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL R",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL S",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL T",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL U",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL V",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL W",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL X",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL Y",
	"MATHEMATICAL SANS-SERIF ITALIC SMALL Z",
	"MATHEMATICAL SANS-SERIF SMALL A",
	"MATHEMATICAL SANS-SERIF SMALL B",
	"MATHEMATICAL SANS-SERIF SMALL C",
	"MATHEMATICAL SANS-SERIF SMALL D",
	"MATHEMATICAL SANS-SERIF SMALL E",
	"MATHEMATICAL SANS-SERIF SMALL F",
	"MATHEMATICAL SANS-SERIF SMALL G",
	"MATHEMATICAL SANS-SERIF SMALL H",
	"MATHEMATICAL SANS-SERIF SMALL I",
	"MATHEMATICAL SANS-SERIF SMALL J",
	"MATHEMATICAL SANS-SERIF SMALL K",
	"MATHEMATICAL SANS-SERIF SMALL L",
	"MATHEMATICAL SANS-SERIF SMALL M",
	"MATHEMATICAL SANS-SERIF SMALL N",
	"MATHEMATICAL SANS-SERIF SMALL O",
	"MATHEMATICAL SANS-SERIF SMALL P",
	"MATHEMATICAL SANS-SERIF SMALL Q",
	"MATHEMATICAL SANS-SERIF SMALL R",
	"MATHEMATICAL SANS-SERIF SMALL S",
	"MATHEMATICAL SANS-SERIF SMALL T",
	"MATHEMATICAL SANS-SERIF SMALL U",
	"MATHEMATICAL SANS-SERIF SMALL V",
	"MATHEMATICAL SANS-SERIF SMALL W",
	"MATHEMATICAL SANS-SERIF SMALL X",
	"MATHEMATICAL SANS-SERIF SMALL Y",
	"MATHEMATICAL SANS-SERIF SMALL Z",
	"MATHEMATICAL SCRIPT CAPITAL A",
	"MATHEMATICAL SCRIPT CAPITAL C",
	"MATHEMATICAL SCRIPT CAPITAL D",
	"MATHEMATICAL SCRIPT CAPITAL G",
	"MATHEMATICAL SCRIPT CAPITAL J",
	"MATHEMATICAL SCRIPT CAPITAL K",
	"MATHEMATICAL SCRIPT CAPITAL N",
	"MATHEMATICAL SCRIPT CAPITAL O",
	"MATHEMATICAL SCRIPT CAPITAL P",
	"MATHEMATICAL SCRIPT CAPITAL Q",
	"MATHEMATICAL SCRIPT CAPITAL S",
	"MATHEMATICAL SCRIPT CAPITAL T",
	"MATHEMATICAL SCRIPT CAPITAL U",
	"MATHEMATICAL SCRIPT CAPITAL V",
	"MATHEMATICAL SCRIPT CAPITAL W",
	"MATHEMATICAL SCRIPT CAPITAL X",
	"MATHEMATICAL SCRIPT CAPITAL Y",
	"MATHEMATICAL SCRIPT CAPITAL Z",
	"MATHEMATICAL SCRIPT SMALL A",
	"MATHEMATICAL SCRIPT SMALL B",
	"MATHEMATICAL SCRIPT SMALL C",
	"MATHEMATICAL SCRIPT SMALL D",
	"MATHEMATICAL SCRIPT SMALL F",
	"MATHEMATICAL SCRIPT SMALL H",
	"MATHEMATICAL SCRIPT SMALL I",
	"MATHEMATICAL SCRIPT SMALL J",
	"MATHEMATICAL SCRIPT SMALL K",
	"MATHEMATICAL SCRIPT SMALL L",
	"MATHEMATICAL SCRIPT SMALL M",
	"MATHEMATICAL SCRIPT SMALL N",
	"MATHEMATICAL SCRIPT SMALL P",
	"MATHEMATICAL SCRIPT SMALL Q",
	"MATHEMATICAL SCRIPT SMALL R",
	"MATHEMATICAL SCRIPT SMALL S",
	"MATHEMATICAL SCRIPT SMALL T",
	"MATHEMATICAL SCRIPT SMALL U",
	"MATHEMATICAL SCRIPT SMALL V",
	"MATHEMATICAL SCRIPT SMALL W",
	"MATHEMATICAL SCRIPT SMALL X",
	"MATHEMATICAL SCRIPT SMALL Y",
	"MATHEMATICAL SCRIPT SMALL Z",
	"MEASURED ANGLE",
	"MEASURED ANGLE OPENING LEFT",
	"MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND LEFT",
	"MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND RIGHT",
	"MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND DOWN",
	"MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND UP",
	"MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND DOWN",
	"MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND UP",
	"MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND LEFT",
	"MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND RIGHT",
	"MEASURED BY",
	"MEASURED RIGHT ANGLE WITH DOT",
	"MEAT ON BONE",
	"MEDIUM BLACK CIRCLE",
	"MEDIUM FLATTENED LEFT PARENTHESIS ORNAMENT",
	"MEDIUM FLATTENED RIGHT PARENTHESIS ORNAMENT",
	"MEDIUM LEFT CURLY BRACKET ORNAMENT",
	"MEDIUM LEFT PARENTHESIS ORNAMENT",
	"MEDIUM LEFT-POINTING ANGLE BRACKET ORNAMENT",
	"MEDIUM MATHEMATICAL SPACE",
	"MEDIUM RIGHT CURLY BRACKET ORNAMENT",
	"MEDIUM RIGHT PARENTHESIS ORNAMENT",
	"MEDIUM RIGHT-POINTING ANGLE BRACKET ORNAMENT",
	"MEDIUM SHADE",
	"MEDIUM SMALL WHITE CIRCLE",
	"MEDIUM VERTICAL BAR",
	"MEDIUM WHITE CIRCLE",
	"MEETEI MAYEK AHANG KHUDAM",
	"MEETEI MAYEK ANJI",
	"MEETEI MAYEK APUN IYEK",
	"MEETEI MAYEK CHEIKHAN",
	"MEETEI MAYEK CHEIKHEI",
	"MEETEI MAYEK DIGIT EIGHT",
	"MEETEI MAYEK DIGIT FIVE",
	"MEETEI MAYEK DIGIT FOUR",
	"MEETEI MAYEK DIGIT NINE",
	"MEETEI MAYEK DIGIT ONE",
	"MEETEI MAYEK DIGIT SEVEN",
	"MEETEI MAYEK DIGIT SIX",
	"MEETEI MAYEK DIGIT THREE",
	"MEETEI MAYEK DIGIT TWO",
	"MEETEI MAYEK DIGIT ZERO",
	"MEETEI MAYEK LETTER ATIYA",
	"MEETEI MAYEK LETTER BA",
	"MEETEI MAYEK LETTER BHAM",
	"MEETEI MAYEK LETTER CHA",
	"MEETEI MAYEK LETTER CHIL",
	"MEETEI MAYEK LETTER DDA",
	"MEETEI MAYEK LETTER DDHA",
	"MEETEI MAYEK LETTER DHOU",
	"MEETEI MAYEK LETTER DIL",
	"MEETEI MAYEK LETTER E",
	"MEETEI MAYEK LETTER GHOU",
	"MEETEI MAYEK LETTER GOK",
	"MEETEI MAYEK LETTER HUK",
	"MEETEI MAYEK LETTER I",
	"MEETEI MAYEK LETTER I LONSUM",
	"MEETEI MAYEK LETTER JHAM",
	"MEETEI MAYEK LETTER JIL",
	"MEETEI MAYEK LETTER KHOU",
	"MEETEI MAYEK LETTER KOK",
	"MEETEI MAYEK LETTER KOK LONSUM",
	"MEETEI MAYEK LETTER LAI",
	"MEETEI MAYEK LETTER LAI LONSUM",
	"MEETEI MAYEK LETTER MIT",
	"MEETEI MAYEK LETTER MIT LONSUM",
	"MEETEI MAYEK LETTER NA",
	"MEETEI MAYEK LETTER NA LONSUM",
	"MEETEI MAYEK LETTER NGOU",
	"MEETEI MAYEK LETTER NGOU LONSUM",
	"MEETEI MAYEK LETTER NNA",
	"MEETEI MAYEK LETTER NYA",
	"MEETEI MAYEK LETTER O",
	"MEETEI MAYEK LETTER PA",
	"MEETEI MAYEK LETTER PA LONSUM",
	"MEETEI MAYEK LETTER PHAM",
	"MEETEI MAYEK LETTER RAI",
	"MEETEI MAYEK LETTER SAM",
	"MEETEI MAYEK LETTER SHA",
	"MEETEI MAYEK LETTER SSA",
	"MEETEI MAYEK LETTER THOU",
	"MEETEI MAYEK LETTER TIL",
	"MEETEI MAYEK LETTER TIL LONSUM",
	"MEETEI MAYEK LETTER TTA",
	"MEETEI MAYEK LETTER TTHA",
	"MEETEI MAYEK LETTER UN",
	"MEETEI MAYEK LETTER WAI",
	"MEETEI MAYEK LETTER YANG",
	"MEETEI MAYEK LUM IYEK",
	"MEETEI MAYEK SYLLABLE REPETITION MARK",
	"MEETEI MAYEK VIRAMA",
	"MEETEI MAYEK VOWEL SIGN AAI",
	"MEETEI MAYEK VOWEL SIGN AAU",
	"MEETEI MAYEK VOWEL SIGN ANAP",
	"MEETEI MAYEK VOWEL SIGN AU",
	"MEETEI MAYEK VOWEL SIGN CHEINAP",
	"MEETEI MAYEK VOWEL SIGN II",
	"MEETEI MAYEK VOWEL SIGN INAP",
	"MEETEI MAYEK VOWEL SIGN NUNG",
	"MEETEI MAYEK VOWEL SIGN ONAP",
	"MEETEI MAYEK VOWEL SIGN SOUNAP",
	"MEETEI MAYEK VOWEL SIGN UNAP",
	"MEETEI MAYEK VOWEL SIGN UU",
	"MEETEI MAYEK VOWEL SIGN VISARGA",
	"MEETEI MAYEK VOWEL SIGN YENAP",
	"MEETEI MAYEK WORD REPETITION MARK",
	"MELON",
	"MEMO",
	"MENS SYMBOL",
	"MERCURY",
	"MEROITIC CURSIVE LETTER A",
	"MEROITIC CURSIVE LETTER ARCHAIC SA",
	"MEROITIC CURSIVE LETTER BA",
	"MEROITIC CURSIVE LETTER DA",
	"MEROITIC CURSIVE LETTER E",
	"MEROITIC CURSIVE LETTER HHA",
	"MEROITIC CURSIVE LETTER I",
	"MEROITIC CURSIVE LETTER KA",
	"MEROITIC CURSIVE LETTER KHA",
	"MEROITIC CURSIVE LETTER LA",
	"MEROITIC CURSIVE LETTER MA",
	"MEROITIC CURSIVE LETTER NA",
	"MEROITIC CURSIVE LETTER NE",
	"MEROITIC CURSIVE LETTER O",
	"MEROITIC CURSIVE LETTER PA",
	"MEROITIC CURSIVE LETTER QA",
	"MEROITIC CURSIVE LETTER RA",
	"MEROITIC CURSIVE LETTER SA",
	"MEROITIC CURSIVE LETTER SE",
	"MEROITIC CURSIVE LETTER TA",
	"MEROITIC CURSIVE LETTER TE",
	"MEROITIC CURSIVE LETTER TO",
	"MEROITIC CURSIVE LETTER WA",
	"MEROITIC CURSIVE LETTER YA",
	"MEROITIC CURSIVE LOGOGRAM IMN",
	"MEROITIC CURSIVE LOGOGRAM RMT",
	"MEROITIC HIEROGLYPHIC LETTER A",
	"MEROITIC HIEROGLYPHIC LETTER BA",
	"MEROITIC HIEROGLYPHIC LETTER DA",
	"MEROITIC HIEROGLYPHIC LETTER E",
	"MEROITIC HIEROGLYPHIC LETTER HHA",
	"MEROITIC HIEROGLYPHIC LETTER I",
	"MEROITIC HIEROGLYPHIC LETTER KA",
	"MEROITIC HIEROGLYPHIC LETTER KHA",
	"MEROITIC HIEROGLYPHIC LETTER LA",
	"MEROITIC HIEROGLYPHIC LETTER MA",
	"MEROITIC HIEROGLYPHIC LETTER NA",
	"MEROITIC HIEROGLYPHIC LETTER NE",
	"MEROITIC HIEROGLYPHIC LETTER O",
	"MEROITIC HIEROGLYPHIC LETTER PA",
	"MEROITIC HIEROGLYPHIC LETTER QA",
	"MEROITIC HIEROGLYPHIC LETTER RA",
	"MEROITIC HIEROGLYPHIC LETTER SA",
	"MEROITIC HIEROGLYPHIC LETTER SE",
	"MEROITIC HIEROGLYPHIC LETTER TA",
	"MEROITIC HIEROGLYPHIC LETTER TE",
	"MEROITIC HIEROGLYPHIC LETTER TO",
	"MEROITIC HIEROGLYPHIC LETTER WA",
	"MEROITIC HIEROGLYPHIC LETTER YA",
	"MEROITIC HIEROGLYPHIC SYMBOL VIDJ",
	"METRICAL BREVE",
	"METRICAL LONG OVER SHORT",
	"METRICAL LONG OVER TWO SHORTS",
	"METRICAL PENTASEME",
	"METRICAL SHORT OVER LONG",
	"METRICAL TETRASEME",
	"METRICAL TRISEME",
	"METRICAL TWO SHORTS JOINED",
	"METRICAL TWO SHORTS OVER LONG",
	"METRO",
	"MIAO LETTER AH",
	"MIAO LETTER ARCHAIC MA",
	"MIAO LETTER ARCHAIC NA",
	"MIAO LETTER ARCHAIC NGA",
	"MIAO LETTER ARCHAIC ZZA",
	"MIAO LETTER BA",
	"MIAO LETTER DA",
	"MIAO LETTER DDA",
	"MIAO LETTER DLHA",
	"MIAO LETTER DLHYA",
	"MIAO LETTER DZA",
	"MIAO LETTER DZHA",
	"MIAO LETTER DZZA",
	"MIAO LETTER FA",
	"MIAO LETTER GA",
	"MIAO LETTER GHA",
	"MIAO LETTER GHHA",
	"MIAO LETTER HA",
	"MIAO LETTER HHA",
	"MIAO LETTER KA",
	"MIAO LETTER LA",
	"MIAO LETTER LHA",
	"MIAO LETTER LHYA",
	"MIAO LETTER LYA",
	"MIAO LETTER MA",
	"MIAO LETTER MHA",
	"MIAO LETTER NA",
	"MIAO LETTER NASALIZATION",
	"MIAO LETTER NGA",
	"MIAO LETTER NGHA",
	"MIAO LETTER NHA",
	"MIAO LETTER NNA",
	"MIAO LETTER NNHA",
	"MIAO LETTER NYA",
	"MIAO LETTER NYHA",
	"MIAO LETTER PA",
	"MIAO LETTER PLA",
	"MIAO LETTER QA",
	"MIAO LETTER QGA",
	"MIAO LETTER REFORMED TSHA",
	"MIAO LETTER SA",
	"MIAO LETTER SHA",
	"MIAO LETTER SSA",
	"MIAO LETTER TA",
	"MIAO LETTER TLHA",
	"MIAO LETTER TLHYA",
	"MIAO LETTER TSA",
	"MIAO LETTER TSHA",
	"MIAO LETTER TSSA",
	"MIAO LETTER TTA",
	"MIAO LETTER VA",
	"MIAO LETTER VFA",
	"MIAO LETTER WA",
	"MIAO LETTER XA",
	"MIAO LETTER YI DZHA",
	"MIAO LETTER YI KA",
	"MIAO LETTER YI NNA",
	"MIAO LETTER YI PA",
	"MIAO LETTER YI TA",
	"MIAO LETTER YI TSA",
	"MIAO LETTER YI TSHA",
	"MIAO LETTER YI TTA",
	"MIAO LETTER ZA",
	"MIAO LETTER ZHA",
	"MIAO LETTER ZSA",
	"MIAO LETTER ZSHA",
	"MIAO LETTER ZZA",
	"MIAO LETTER ZZSA",
	"MIAO LETTER ZZSYA",
	"MIAO LETTER ZZYA",
	"MIAO SIGN ASPIRATION",
	"MIAO SIGN REFORMED ASPIRATION",
	"MIAO SIGN REFORMED VOICING",
	"MIAO TONE ABOVE",
	"MIAO TONE BELOW",
	"MIAO TONE RIGHT",
	"MIAO TONE TOP RIGHT",
	"MIAO VOWEL SIGN A",
	"MIAO VOWEL SIGN AA",
	"MIAO VOWEL SIGN AE",
	"MIAO VOWEL SIGN AEE",
	"MIAO VOWEL SIGN AHH",
	"MIAO VOWEL SIGN AI",
	"MIAO VOWEL SIGN AN",
	"MIAO VOWEL SIGN ANG",
	"MIAO VOWEL SIGN AU",
	"MIAO VOWEL SIGN E",
	"MIAO VOWEL SIGN EI",
	"MIAO VOWEL SIGN EN",
	"MIAO VOWEL SIGN ENG",
	"MIAO VOWEL SIGN ER",
	"MIAO VOWEL SIGN ERR",
	"MIAO VOWEL SIGN I",
	"MIAO VOWEL SIGN IA",
	"MIAO VOWEL SIGN IAN",
	"MIAO VOWEL SIGN IANG",
	"MIAO VOWEL SIGN IE",
	"MIAO VOWEL SIGN II",
	"MIAO VOWEL SIGN ING",
	"MIAO VOWEL SIGN IO",
	"MIAO VOWEL SIGN IU",
	"MIAO VOWEL SIGN N",
	"MIAO VOWEL SIGN NG",
	"MIAO VOWEL SIGN O",
	"MIAO VOWEL SIGN OEY",
	"MIAO VOWEL SIGN OO",
	"MIAO VOWEL SIGN OU",
	"MIAO VOWEL SIGN ROUNDED ER",
	"MIAO VOWEL SIGN ROUNDED ERR",
	"MIAO VOWEL SIGN U",
	"MIAO VOWEL SIGN UA",
	"MIAO VOWEL SIGN UAN",
	"MIAO VOWEL SIGN UANG",
	"MIAO VOWEL SIGN UEI",
	"MIAO VOWEL SIGN UNG",
	"MIAO VOWEL SIGN UU",
	"MIAO VOWEL SIGN W",
	"MIAO VOWEL SIGN WO",
	"MIAO VOWEL SIGN Y",
	"MIAO VOWEL SIGN YI",
	"MICRO SIGN",
	"MICROPHONE",
	"MICROSCOPE",
	"MIDDLE DOT",
	"MIDLINE HORIZONTAL ELLIPSIS",
	"MILKY WAY",
	"MILL SIGN",
	"MINIBUS",
	"MINIDISC",
	"MINUS SIGN",
	"MINUS SIGN IN TRIANGLE",
	"MINUS SIGN WITH COMMA ABOVE",
	"MINUS SIGN WITH DOT BELOW",
	"MINUS SIGN WITH FALLING DOTS",
	"MINUS SIGN WITH RISING DOTS",
	"MINUS TILDE",
	"MINUS-OR-PLUS SIGN",
	"MINY",
	"MOBILE PHONE",
	"MOBILE PHONE OFF",
	"MOBILE PHONE WITH RIGHTWARDS ARROW AT LEFT",
	"MODELS",
	"MODIFIER LETTER ACUTE ACCENT",
	"MODIFIER LETTER APOSTROPHE",
	"MODIFIER LETTER BEGIN HIGH TONE",
	"MODIFIER LETTER BEGIN LOW TONE",
	"MODIFIER LETTER CAPITAL A",
	"MODIFIER LETTER CAPITAL AE",
	"MODIFIER LETTER CAPITAL B",
	"MODIFIER LETTER CAPITAL BARRED B",
	"MODIFIER LETTER CAPITAL D",
	"MODIFIER LETTER CAPITAL E",
	"MODIFIER LETTER CAPITAL G",
	"MODIFIER LETTER CAPITAL H",
	"MODIFIER LETTER CAPITAL H WITH STROKE",
	"MODIFIER LETTER CAPITAL I",
	"MODIFIER LETTER CAPITAL J",
	"MODIFIER LETTER CAPITAL K",
	"MODIFIER LETTER CAPITAL L",
	"MODIFIER LETTER CAPITAL M",
	"MODIFIER LETTER CAPITAL N",
	"MODIFIER LETTER CAPITAL O",
	"MODIFIER LETTER CAPITAL OU",
	"MODIFIER LETTER CAPITAL P",
	"MODIFIER LETTER CAPITAL R",
	"MODIFIER LETTER CAPITAL REVERSED E",
	"MODIFIER LETTER CAPITAL REVERSED N",
	"MODIFIER LETTER CAPITAL T",
	"MODIFIER LETTER CAPITAL U",
	"MODIFIER LETTER CAPITAL V",
	"MODIFIER LETTER CAPITAL W",
	"MODIFIER LETTER CENTRED LEFT HALF RING",
	"MODIFIER LETTER CENTRED RIGHT HALF RING",
	"MODIFIER LETTER CHINESE TONE YANG PING",
	"MODIFIER LETTER CHINESE TONE YANG QU",
	"MODIFIER LETTER CHINESE TONE YANG RU",
	"MODIFIER LETTER CHINESE TONE YANG SHANG",
	"MODIFIER LETTER CHINESE TONE YIN PING",
	"MODIFIER LETTER CHINESE TONE YIN QU",
	"MODIFIER LETTER CHINESE TONE YIN RU",
	"MODIFIER LETTER CHINESE TONE YIN SHANG",
	"MODIFIER LETTER CIRCUMFLEX ACCENT",
	"MODIFIER LETTER COLON",
	"MODIFIER LETTER CROSS ACCENT",
	"MODIFIER LETTER CYRILLIC EN",
	"MODIFIER LETTER DOT HORIZONTAL BAR",
	"MODIFIER LETTER DOT SLASH",
	"MODIFIER LETTER DOT VERTICAL BAR",
	"MODIFIER LETTER DOUBLE APOSTROPHE",
	"MODIFIER LETTER DOUBLE PRIME",
	"MODIFIER LETTER DOWN ARROWHEAD",
	"MODIFIER LETTER DOWN TACK",
	"MODIFIER LETTER END HIGH TONE",
	"MODIFIER LETTER END LOW TONE",
	"MODIFIER LETTER EXTRA-HIGH DOTTED LEFT-STEM TONE BAR",
	"MODIFIER LETTER EXTRA-HIGH DOTTED TONE BAR",
	"MODIFIER LETTER EXTRA-HIGH LEFT-STEM TONE BAR",
	"MODIFIER LETTER EXTRA-HIGH TONE BAR",
	"MODIFIER LETTER EXTRA-LOW DOTTED LEFT-STEM TONE BAR",
	"MODIFIER LETTER EXTRA-LOW DOTTED TONE BAR",
	"MODIFIER LETTER EXTRA-LOW LEFT-STEM TONE BAR",
	"MODIFIER LETTER EXTRA-LOW TONE BAR",
	"MODIFIER LETTER GEORGIAN NAR",
	"MODIFIER LETTER GLOTTAL STOP",
	"MODIFIER LETTER GRAVE ACCENT",
	"MODIFIER LETTER HALF TRIANGULAR COLON",
	"MODIFIER LETTER HIGH DOTTED LEFT-STEM TONE BAR",
	"MODIFIER LETTER HIGH DOTTED TONE BAR",
	"MODIFIER LETTER HIGH LEFT-STEM TONE BAR",
	"MODIFIER LETTER HIGH TONE BAR",
	"MODIFIER LETTER LEFT ARROWHEAD",
	"MODIFIER LETTER LEFT HALF RING",
	"MODIFIER LETTER LOW ACUTE ACCENT",
	"MODIFIER LETTER LOW CIRCUMFLEX ACCENT",
	"MODIFIER LETTER LOW DOTTED LEFT-STEM TONE BAR",
	"MODIFIER LETTER LOW DOTTED TONE BAR",
	"MODIFIER LETTER LOW DOWN ARROWHEAD",
	"MODIFIER LETTER LOW GRAVE ACCENT",
	"MODIFIER LETTER LOW INVERTED EXCLAMATION MARK",
	"MODIFIER LETTER LOW LEFT ARROW",
	"MODIFIER LETTER LOW LEFT ARROWHEAD",
	"MODIFIER LETTER LOW LEFT-STEM TONE BAR",
	"MODIFIER LETTER LOW MACRON",
	"MODIFIER LETTER LOW RIGHT ARROWHEAD",
	"MODIFIER LETTER LOW RING",
	"MODIFIER LETTER LOW TILDE",
	"MODIFIER LETTER LOW TONE BAR",
	"MODIFIER LETTER LOW UP ARROWHEAD",
	"MODIFIER LETTER LOW VERTICAL LINE",
	"MODIFIER LETTER LOWER RIGHT CORNER ANGLE",
	"MODIFIER LETTER MACRON",
	"MODIFIER LETTER MID DOTTED LEFT-STEM TONE BAR",
	"MODIFIER LETTER MID DOTTED TONE BAR",
	"MODIFIER LETTER MID LEFT-STEM TONE BAR",
	"MODIFIER LETTER MID TONE BAR",
	"MODIFIER LETTER MIDDLE DOUBLE ACUTE ACCENT",
	"MODIFIER LETTER MIDDLE DOUBLE GRAVE ACCENT",
	"MODIFIER LETTER MIDDLE GRAVE ACCENT",
	"MODIFIER LETTER MINUS SIGN",
	"MODIFIER LETTER OPEN SHELF",
	"MODIFIER LETTER PLUS SIGN",
	"MODIFIER LETTER PRIME",
	"MODIFIER LETTER RAISED COLON",
	"MODIFIER LETTER RAISED DOWN ARROW",
	"MODIFIER LETTER RAISED EXCLAMATION MARK",
	"MODIFIER LETTER RAISED INVERTED EXCLAMATION MARK",
	"MODIFIER LETTER RAISED UP ARROW",
	"MODIFIER LETTER REVERSED COMMA",
	"MODIFIER LETTER REVERSED GLOTTAL STOP",
	"MODIFIER LETTER RHOTIC HOOK",
	"MODIFIER LETTER RIGHT ARROWHEAD",
	"MODIFIER LETTER RIGHT HALF RING",
	"MODIFIER LETTER SHELF",
	"MODIFIER LETTER SHORT EQUALS SIGN",
	"MODIFIER LETTER SMALL A",
	"MODIFIER LETTER SMALL AIN",
	"MODIFIER LETTER SMALL ALPHA",
	"MODIFIER LETTER SMALL B",
	"MODIFIER LETTER SMALL BARRED O",
	"MODIFIER LETTER SMALL BETA",
	"MODIFIER LETTER SMALL BOTTOM HALF O",
	"MODIFIER LETTER SMALL C",
	"MODIFIER LETTER SMALL C WITH CURL",
	"MODIFIER LETTER SMALL CAPITAL I",
	"MODIFIER LETTER SMALL CAPITAL I WITH STROKE",
	"MODIFIER LETTER SMALL CAPITAL INVERTED R",
	"MODIFIER LETTER SMALL CAPITAL L",
	"MODIFIER LETTER SMALL CAPITAL N",
	"MODIFIER LETTER SMALL CAPITAL U",
	"MODIFIER LETTER SMALL CHI",
	"MODIFIER LETTER SMALL D",
	"MODIFIER LETTER SMALL DELTA",
	"MODIFIER LETTER SMALL DOTLESS J WITH STROKE",
	"MODIFIER LETTER SMALL E",
	"MODIFIER LETTER SMALL ENG",
	"MODIFIER LETTER SMALL ESH",
	"MODIFIER LETTER SMALL ETH",
	"MODIFIER LETTER SMALL EZH",
	"MODIFIER LETTER SMALL F",
	"MODIFIER LETTER SMALL G",
	"MODIFIER LETTER SMALL GAMMA",
	"MODIFIER LETTER SMALL GREEK GAMMA",
	"MODIFIER LETTER SMALL GREEK PHI",
	"MODIFIER LETTER SMALL H",
	"MODIFIER LETTER SMALL H WITH HOOK",
	"MODIFIER LETTER SMALL I WITH STROKE",
	"MODIFIER LETTER SMALL IOTA",
	"MODIFIER LETTER SMALL J",
	"MODIFIER LETTER SMALL J WITH CROSSED-TAIL",
	"MODIFIER LETTER SMALL K",
	"MODIFIER LETTER SMALL L",
	"MODIFIER LETTER SMALL L WITH PALATAL HOOK",
	"MODIFIER LETTER SMALL L WITH RETROFLEX HOOK",
	"MODIFIER LETTER SMALL LIGATURE OE",
	"MODIFIER LETTER SMALL M",
	"MODIFIER LETTER SMALL M WITH HOOK",
	"MODIFIER LETTER SMALL N WITH LEFT HOOK",
	"MODIFIER LETTER SMALL N WITH RETROFLEX HOOK",
	"MODIFIER LETTER SMALL O",
	"MODIFIER LETTER SMALL OPEN E",
	"MODIFIER LETTER SMALL OPEN O",
	"MODIFIER LETTER SMALL P",
	"MODIFIER LETTER SMALL PHI",
	"MODIFIER LETTER SMALL R",
	"MODIFIER LETTER SMALL REVERSED GLOTTAL STOP",
	"MODIFIER LETTER SMALL REVERSED OPEN E",
	"MODIFIER LETTER SMALL S",
	"MODIFIER LETTER SMALL S WITH HOOK",
	"MODIFIER LETTER SMALL SCHWA",
	"MODIFIER LETTER SMALL SCRIPT G",
	"MODIFIER LETTER SMALL SIDEWAYS U",
	"MODIFIER LETTER SMALL T",
	"MODIFIER LETTER SMALL T WITH PALATAL HOOK",
	"MODIFIER LETTER SMALL THETA",
	"MODIFIER LETTER SMALL TOP HALF O",
	"MODIFIER LETTER SMALL TURNED A",
	"MODIFIER LETTER SMALL TURNED AE",
	"MODIFIER LETTER SMALL TURNED ALPHA",
	"MODIFIER LETTER SMALL TURNED H",
	"MODIFIER LETTER SMALL TURNED I",
	"MODIFIER LETTER SMALL TURNED M",
	"MODIFIER LETTER SMALL TURNED M WITH LONG LEG",
	"MODIFIER LETTER SMALL TURNED OPEN E",
	"MODIFIER LETTER SMALL TURNED R",
	"MODIFIER LETTER SMALL TURNED R WITH HOOK",
	"MODIFIER LETTER SMALL TURNED V",
	"MODIFIER LETTER SMALL U",
	"MODIFIER LETTER SMALL U BAR",
	"MODIFIER LETTER SMALL UPSILON",
	"MODIFIER LETTER SMALL V",
	"MODIFIER LETTER SMALL V WITH HOOK",
	"MODIFIER LETTER SMALL W",
	"MODIFIER LETTER SMALL X",
	"MODIFIER LETTER SMALL Y",
	"MODIFIER LETTER SMALL Z",
	"MODIFIER LETTER SMALL Z WITH CURL",
	"MODIFIER LETTER SMALL Z WITH RETROFLEX HOOK",
	"MODIFIER LETTER STRESS AND HIGH TONE",
	"MODIFIER LETTER STRESS AND LOW TONE",
	"MODIFIER LETTER TRIANGULAR COLON",
	"MODIFIER LETTER TURNED COMMA",
	"MODIFIER LETTER UNASPIRATED",
	"MODIFIER LETTER UP ARROWHEAD",
	"MODIFIER LETTER UP TACK",
	"MODIFIER LETTER US",
	"MODIFIER LETTER VERTICAL LINE",
	"MODIFIER LETTER VOICING",
	"MODIFIER LETTER YANG DEPARTING TONE MARK",
	"MODIFIER LETTER YIN DEPARTING TONE MARK",
	"MODULO TWO SUM",
	"MONEY BAG",
	"MONEY WITH WINGS",
	"MONGOLIAN BIRGA",
	"MONGOLIAN COLON",
	"MONGOLIAN COMMA",
	"MONGOLIAN DIGIT EIGHT",
	"MONGOLIAN DIGIT FIVE",
	"MONGOLIAN DIGIT FOUR",
	"MONGOLIAN DIGIT NINE",
	"MONGOLIAN DIGIT ONE",
	"MONGOLIAN DIGIT SEVEN",
	"MONGOLIAN DIGIT SIX",
	"MONGOLIAN DIGIT THREE",
	"MONGOLIAN DIGIT TWO",
	"MONGOLIAN DIGIT ZERO",
	"MONGOLIAN ELLIPSIS",
	"MONGOLIAN FOUR DOTS",
	"MONGOLIAN FREE VARIATION SELECTOR ONE",
	"MONGOLIAN FREE VARIATION SELECTOR THREE",
	"MONGOLIAN FREE VARIATION SELECTOR TWO",
	"MONGOLIAN FULL STOP",
	"MONGOLIAN LETTER A",
	"MONGOLIAN LETTER ALI GALI A",
	"MONGOLIAN LETTER ALI GALI AH",
	"MONGOLIAN LETTER ALI GALI ANUSVARA ONE",
	"MONGOLIAN LETTER ALI GALI BALUDA",
	"MONGOLIAN LETTER ALI GALI CA",
	"MONGOLIAN LETTER ALI GALI DA",
	"MONGOLIAN LETTER ALI GALI DAGALGA",
	"MONGOLIAN LETTER ALI GALI DAMARU",
	"MONGOLIAN LETTER ALI GALI DDA",
	"MONGOLIAN LETTER ALI GALI HALF U",
	"MONGOLIAN LETTER ALI GALI HALF YA",
	"MONGOLIAN LETTER ALI GALI I",
	"MONGOLIAN LETTER ALI GALI INVERTED UBADAMA",
	"MONGOLIAN LETTER ALI GALI KA",
	"MONGOLIAN LETTER ALI GALI NGA",
	"MONGOLIAN LETTER ALI GALI NNA",
	"MONGOLIAN LETTER ALI GALI PA",
	"MONGOLIAN LETTER ALI GALI PHA",
	"MONGOLIAN LETTER ALI GALI SSA",
	"MONGOLIAN LETTER ALI GALI TA",
	"MONGOLIAN LETTER ALI GALI THREE BALUDA",
	"MONGOLIAN LETTER ALI GALI TTA",
	"MONGOLIAN LETTER ALI GALI TTHA",
	"MONGOLIAN LETTER ALI GALI UBADAMA",
	"MONGOLIAN LETTER ALI GALI VISARGA ONE",
	"MONGOLIAN LETTER ALI GALI ZA",
	"MONGOLIAN LETTER ALI GALI ZHA",
	"MONGOLIAN LETTER ANG",
	"MONGOLIAN LETTER BA",
	"MONGOLIAN LETTER CHA",
	"MONGOLIAN LETTER CHI",
	"MONGOLIAN LETTER DA",
	"MONGOLIAN LETTER E",
	"MONGOLIAN LETTER EE",
	"MONGOLIAN LETTER FA",
	"MONGOLIAN LETTER GA",
	"MONGOLIAN LETTER HAA",
	"MONGOLIAN LETTER I",
	"MONGOLIAN LETTER JA",
	"MONGOLIAN LETTER KA",
	"MONGOLIAN LETTER KHA",
	"MONGOLIAN LETTER LA",
	"MONGOLIAN LETTER LHA",
	"MONGOLIAN LETTER MA",
	"MONGOLIAN LETTER MANCHU ALI GALI BHA",
	"MONGOLIAN LETTER MANCHU ALI GALI CA",
	"MONGOLIAN LETTER MANCHU ALI GALI CYA",
	"MONGOLIAN LETTER MANCHU ALI GALI DDHA",
	"MONGOLIAN LETTER MANCHU ALI GALI DHA",
	"MONGOLIAN LETTER MANCHU ALI GALI GHA",
	"MONGOLIAN LETTER MANCHU ALI GALI JHA",
	"MONGOLIAN LETTER MANCHU ALI GALI LHA",
	"MONGOLIAN LETTER MANCHU ALI GALI NGA",
	"MONGOLIAN LETTER MANCHU ALI GALI SSA",
	"MONGOLIAN LETTER MANCHU ALI GALI TA",
	"MONGOLIAN LETTER MANCHU ALI GALI TTA",
	"MONGOLIAN LETTER MANCHU ALI GALI ZA",
	"MONGOLIAN LETTER MANCHU ALI GALI ZHA",
	"MONGOLIAN LETTER MANCHU FA",
	"MONGOLIAN LETTER MANCHU I",
	"MONGOLIAN LETTER MANCHU KA",
	"MONGOLIAN LETTER MANCHU RA",
	"MONGOLIAN LETTER MANCHU ZHA",
	"MONGOLIAN LETTER NA",
	"MONGOLIAN LETTER O",
	"MONGOLIAN LETTER OE",
	"MONGOLIAN LETTER PA",
	"MONGOLIAN LETTER QA",
	"MONGOLIAN LETTER RA",
	"MONGOLIAN LETTER SA",
	"MONGOLIAN LETTER SHA",
	"MONGOLIAN LETTER SIBE ANG",
	"MONGOLIAN LETTER SIBE CHA",
	"MONGOLIAN LETTER SIBE DA",
	"MONGOLIAN LETTER SIBE E",
	"MONGOLIAN LETTER SIBE FA",
	"MONGOLIAN LETTER SIBE GA",
	"MONGOLIAN LETTER SIBE GAA",
	"MONGOLIAN LETTER SIBE HA",
	"MONGOLIAN LETTER SIBE HAA",
	"MONGOLIAN LETTER SIBE I",
	"MONGOLIAN LETTER SIBE IY",
	"MONGOLIAN LETTER SIBE JA",
	"MONGOLIAN LETTER SIBE KA",
	"MONGOLIAN LETTER SIBE PA",
	"MONGOLIAN LETTER SIBE RAA",
	"MONGOLIAN LETTER SIBE SHA",
	"MONGOLIAN LETTER SIBE TA",
	"MONGOLIAN LETTER SIBE TSA",
	"MONGOLIAN LETTER SIBE U",
	"MONGOLIAN LETTER SIBE UE",
	"MONGOLIAN LETTER SIBE ZA",
	"MONGOLIAN LETTER SIBE ZHA",
	"MONGOLIAN LETTER TA",
	"MONGOLIAN LETTER TODO ALI GALI TA",
	"MONGOLIAN LETTER TODO ALI GALI ZHA",
	"MONGOLIAN LETTER TODO ANG",
	"MONGOLIAN LETTER TODO BA",
	"MONGOLIAN LETTER TODO CHA",
	"MONGOLIAN LETTER TODO DA",
	"MONGOLIAN LETTER TODO DZA",
	"MONGOLIAN LETTER TODO E",
	"MONGOLIAN LETTER TODO GA",
	"MONGOLIAN LETTER TODO GAA",
	"MONGOLIAN LETTER TODO HAA",
	"MONGOLIAN LETTER TODO I",
	"MONGOLIAN LETTER TODO JA",
	"MONGOLIAN LETTER TODO JIA",
	"MONGOLIAN LETTER TODO KA",
	"MONGOLIAN LETTER TODO LONG VOWEL SIGN",
	"MONGOLIAN LETTER TODO MA",
	"MONGOLIAN LETTER TODO NIA",
	"MONGOLIAN LETTER TODO O",
	"MONGOLIAN LETTER TODO OE",
	"MONGOLIAN LETTER TODO PA",
	"MONGOLIAN LETTER TODO QA",
	"MONGOLIAN LETTER TODO TA",
	"MONGOLIAN LETTER TODO TSA",
	"MONGOLIAN LETTER TODO U",
	"MONGOLIAN LETTER TODO UE",
	"MONGOLIAN LETTER TODO WA",
	"MONGOLIAN LETTER TODO YA",
	"MONGOLIAN LETTER TSA",
	"MONGOLIAN LETTER U",
	"MONGOLIAN LETTER UE",
	"MONGOLIAN LETTER WA",
	"MONGOLIAN LETTER YA",
	"MONGOLIAN LETTER ZA",
	"MONGOLIAN LETTER ZHI",
	"MONGOLIAN LETTER ZRA",
	"MONGOLIAN MANCHU COMMA",
	"MONGOLIAN MANCHU FULL STOP",
	"MONGOLIAN NIRUGU",
	"MONGOLIAN SIBE SYLLABLE BOUNDARY MARKER",
	"MONGOLIAN TODO SOFT HYPHEN",
	"MONGOLIAN VOWEL SEPARATOR",
	"MONKEY",
	"MONKEY FACE",
	"MONOGRAM FOR EARTH",
	"MONOGRAM FOR YANG",
	"MONOGRAM FOR YIN",
	"MONORAIL",
	"MONOSTABLE SYMBOL",
	"MOON VIEWING CEREMONY",
	"MOUNT FUJI",
	"MOUNTAIN",
	"MOUNTAIN BICYCLIST",
	"MOUNTAIN CABLEWAY",
	"MOUNTAIN RAILWAY",
	"MOUSE",
	"MOUSE FACE",
	"MOUTH",
	"MOVIE CAMERA",
	"MOYAI",
	"MUCH GREATER-THAN",
	"MUCH LESS-THAN",
	"MULTIMAP",
	"MULTIPLE MUSICAL NOTES",
	"MULTIPLICATION SIGN",
	"MULTIPLICATION SIGN IN DOUBLE CIRCLE",
	"MULTIPLICATION SIGN IN LEFT HALF CIRCLE",
	"MULTIPLICATION SIGN IN RIGHT HALF CIRCLE",
	"MULTIPLICATION SIGN IN TRIANGLE",
	"MULTIPLICATION SIGN WITH DOT ABOVE",
	"MULTIPLICATION SIGN WITH UNDERBAR",
	"MULTIPLICATION X",
	"MULTISET",
	"MULTISET MULTIPLICATION",
	"MULTISET UNION",
	"MUSHROOM",
	"MUSIC FLAT SIGN",
	"MUSIC NATURAL SIGN",
	"MUSIC SHARP SIGN",
	"MUSICAL KEYBOARD",
	"MUSICAL NOTE",
	"MUSICAL SCORE",
	"MUSICAL SYMBOL ARPEGGIATO DOWN",
	"MUSICAL SYMBOL ARPEGGIATO UP",
	"MUSICAL SYMBOL BEGIN BEAM",
	"MUSICAL SYMBOL BEGIN PHRASE",
	"MUSICAL SYMBOL BEGIN SLUR",
	"MUSICAL SYMBOL BEGIN TIE",
	"MUSICAL SYMBOL BRACE",
	"MUSICAL SYMBOL BRACKET",
	"MUSICAL SYMBOL BREATH MARK",
	"MUSICAL SYMBOL BREVE",
	"MUSICAL SYMBOL BREVIS",
	"MUSICAL SYMBOL BREVIS REST",
	"MUSICAL SYMBOL C CLEF",
	"MUSICAL SYMBOL CAESURA",
	"MUSICAL SYMBOL CIRCLE X NOTEHEAD",
	"MUSICAL SYMBOL CLIMACUS",
	"MUSICAL SYMBOL CLIVIS",
	"MUSICAL SYMBOL CLUSTER NOTEHEAD BLACK",
	"MUSICAL SYMBOL CLUSTER NOTEHEAD WHITE",
	"MUSICAL SYMBOL CODA",
	"MUSICAL SYMBOL COMBINING ACCENT",
	"MUSICAL SYMBOL COMBINING ACCENT-STACCATO",
	"MUSICAL SYMBOL COMBINING AUGMENTATION DOT",
	"MUSICAL SYMBOL COMBINING BEND",
	"MUSICAL SYMBOL COMBINING DOIT",
	"MUSICAL SYMBOL COMBINING DOUBLE TONGUE",
	"MUSICAL SYMBOL COMBINING DOWN BOW",
	"MUSICAL SYMBOL COMBINING FLIP",
	"MUSICAL SYMBOL COMBINING HARMONIC",
	"MUSICAL SYMBOL COMBINING LOURE",
	"MUSICAL SYMBOL COMBINING MARCATO",
	"MUSICAL SYMBOL COMBINING MARCATO-STACCATO",
	"MUSICAL SYMBOL COMBINING RIP",
	"MUSICAL SYMBOL COMBINING SMEAR",
	"MUSICAL SYMBOL COMBINING SNAP PIZZICATO",
	"MUSICAL SYMBOL COMBINING SPRECHGESANG STEM",
	"MUSICAL SYMBOL COMBINING STACCATISSIMO",
	"MUSICAL SYMBOL COMBINING STACCATO",
	"MUSICAL SYMBOL COMBINING STEM",
	"MUSICAL SYMBOL COMBINING TENUTO",
	"MUSICAL SYMBOL COMBINING TRIPLE TONGUE",
	"MUSICAL SYMBOL COMBINING UP BOW",
	"MUSICAL SYMBOL COMMON TIME",
	"MUSICAL SYMBOL CRESCENDO",
	"MUSICAL SYMBOL CROIX",
	"MUSICAL SYMBOL CUT TIME",
	"MUSICAL SYMBOL DA CAPO",
	"MUSICAL SYMBOL DAL SEGNO",
	"MUSICAL SYMBOL DAMP",
	"MUSICAL SYMBOL DAMP ALL",
	"MUSICAL SYMBOL DASHED BARLINE",
	"MUSICAL SYMBOL DECRESCENDO",
	"MUSICAL SYMBOL DEGREE SLASH",
	"MUSICAL SYMBOL DOUBLE BARLINE",
	"MUSICAL SYMBOL DOUBLE FLAT",
	"MUSICAL SYMBOL DOUBLE SHARP",
	"MUSICAL SYMBOL EIGHTH NOTE",
	"MUSICAL SYMBOL EIGHTH REST",
	"MUSICAL SYMBOL END BEAM",
	"MUSICAL SYMBOL END OF STIMME",
	"MUSICAL SYMBOL END PHRASE",
	"MUSICAL SYMBOL END SLUR",
	"MUSICAL SYMBOL END TIE",
	"MUSICAL SYMBOL F CLEF",
	"MUSICAL SYMBOL F CLEF OTTAVA ALTA",
	"MUSICAL SYMBOL F CLEF OTTAVA BASSA",
	"MUSICAL SYMBOL FERMATA",
	"MUSICAL SYMBOL FERMATA BELOW",
	"MUSICAL SYMBOL FINAL BARLINE",
	"MUSICAL SYMBOL FIVE-LINE STAFF",
	"MUSICAL SYMBOL FLAT DOWN",
	"MUSICAL SYMBOL FLAT UP",
	"MUSICAL SYMBOL FORTE",
	"MUSICAL SYMBOL FOUR-LINE STAFF",
	"MUSICAL SYMBOL FOUR-STRING FRETBOARD",
	"MUSICAL SYMBOL FUSA BLACK",
	"MUSICAL SYMBOL FUSA WHITE",
	"MUSICAL SYMBOL G CLEF",
	"MUSICAL SYMBOL G CLEF OTTAVA ALTA",
	"MUSICAL SYMBOL G CLEF OTTAVA BASSA",
	"MUSICAL SYMBOL GLISSANDO DOWN",
	"MUSICAL SYMBOL GLISSANDO UP",
	"MUSICAL SYMBOL GRACE NOTE NO SLASH",
	"MUSICAL SYMBOL GRACE NOTE SLASH",
	"MUSICAL SYMBOL GREGORIAN C CLEF",
	"MUSICAL SYMBOL GREGORIAN F CLEF",
	"MUSICAL SYMBOL HALF NOTE",
	"MUSICAL SYMBOL HALF PEDAL MARK",
	"MUSICAL SYMBOL HALF REST",
	"MUSICAL SYMBOL HAUPTSTIMME",
	"MUSICAL SYMBOL INVERTED TURN",
	"MUSICAL SYMBOL LEFT REPEAT SIGN",
	"MUSICAL SYMBOL LONGA",
	"MUSICAL SYMBOL LONGA IMPERFECTA REST",
	"MUSICAL SYMBOL LONGA PERFECTA REST",
	"MUSICAL SYMBOL MAXIMA",
	"MUSICAL SYMBOL MEZZO",
	"MUSICAL SYMBOL MINIMA",
	"MUSICAL SYMBOL MINIMA BLACK",
	"MUSICAL SYMBOL MINIMA REST",
	"MUSICAL SYMBOL MOON NOTEHEAD BLACK",
	"MUSICAL SYMBOL MOON NOTEHEAD WHITE",
	"MUSICAL SYMBOL MULTI REST",
	"MUSICAL SYMBOL MULTIPLE MEASURE REST",
	"MUSICAL SYMBOL NATURAL DOWN",
	"MUSICAL SYMBOL NATURAL UP",
	"MUSICAL SYMBOL NEBENSTIMME",
	"MUSICAL SYMBOL NOTEHEAD BLACK",
	"MUSICAL SYMBOL NULL NOTEHEAD",
	"MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH NOTE",
	"MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH REST",
	"MUSICAL SYMBOL ONE-LINE STAFF",
	"MUSICAL SYMBOL OTTAVA ALTA",
	"MUSICAL SYMBOL OTTAVA BASSA",
	"MUSICAL SYMBOL PARENTHESIS NOTEHEAD",
	"MUSICAL SYMBOL PEDAL MARK",
	"MUSICAL SYMBOL PEDAL UP MARK",
	"MUSICAL SYMBOL PES SUBPUNCTIS",
	"MUSICAL SYMBOL PIANO",
	"MUSICAL SYMBOL PLUS NOTEHEAD",
	"MUSICAL SYMBOL PODATUS",
	"MUSICAL SYMBOL PORRECTUS",
	"MUSICAL SYMBOL PORRECTUS FLEXUS",
	"MUSICAL SYMBOL QUARTER NOTE",
	"MUSICAL SYMBOL QUARTER REST",
	"MUSICAL SYMBOL QUARTER TONE FLAT",
	"MUSICAL SYMBOL QUARTER TONE SHARP",
	"MUSICAL SYMBOL QUINDICESIMA ALTA",
	"MUSICAL SYMBOL QUINDICESIMA BASSA",
	"MUSICAL SYMBOL REPEAT DOTS",
	"MUSICAL SYMBOL REVERSE FINAL BARLINE",
	"MUSICAL SYMBOL RIGHT REPEAT SIGN",
	"MUSICAL SYMBOL RINFORZANDO",
	"MUSICAL SYMBOL SCANDICUS",
	"MUSICAL SYMBOL SCANDICUS FLEXUS",
	"MUSICAL SYMBOL SEGNO",
	"MUSICAL SYMBOL SEMIBREVIS BLACK",
	"MUSICAL SYMBOL SEMIBREVIS REST",
	"MUSICAL SYMBOL SEMIBREVIS WHITE",
	"MUSICAL SYMBOL SEMIMINIMA BLACK",
	"MUSICAL SYMBOL SEMIMINIMA REST",
	"MUSICAL SYMBOL SEMIMINIMA WHITE",
	"MUSICAL SYMBOL SHARP DOWN",
	"MUSICAL SYMBOL SHARP UP",
	"MUSICAL SYMBOL SHORT BARLINE",
	"MUSICAL SYMBOL SINGLE BARLINE",
	"MUSICAL SYMBOL SIX-LINE STAFF",
	"MUSICAL SYMBOL SIX-STRING FRETBOARD",
	"MUSICAL SYMBOL SIXTEENTH NOTE",
	"MUSICAL SYMBOL SIXTEENTH REST",
	"MUSICAL SYMBOL SIXTY-FOURTH NOTE",
	"MUSICAL SYMBOL SIXTY-FOURTH REST",
	"MUSICAL SYMBOL SQUARE B",
	"MUSICAL SYMBOL SQUARE NOTEHEAD BLACK",
	"MUSICAL SYMBOL SQUARE NOTEHEAD WHITE",
	"MUSICAL SYMBOL SUBITO",
	"MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA",
	"MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE PERFECTA",
	"MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE IMPERFECTA",
	"MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA",
	"MUSICAL SYMBOL THIRTY-SECOND NOTE",
	"MUSICAL SYMBOL THIRTY-SECOND REST",
	"MUSICAL SYMBOL THREE-LINE STAFF",
	"MUSICAL SYMBOL TORCULUS",
	"MUSICAL SYMBOL TORCULUS RESUPINUS",
	"MUSICAL SYMBOL TR",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN BLACK",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN WHITE",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT BLACK",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT WHITE",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT BLACK",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT WHITE",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD UP BLACK",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT BLACK",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT WHITE",
	"MUSICAL SYMBOL TRIANGLE NOTEHEAD UP WHITE",
	"MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN BLACK",
	"MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN WHITE",
	"MUSICAL SYMBOL TURN",
	"MUSICAL SYMBOL TURN SLASH",
	"MUSICAL SYMBOL TURN UP",
	"MUSICAL SYMBOL TWO-LINE STAFF",
	"MUSICAL SYMBOL VIRGA",
	"MUSICAL SYMBOL VOID NOTEHEAD",
	"MUSICAL SYMBOL WHOLE NOTE",
	"MUSICAL SYMBOL WHOLE REST",
	"MUSICAL SYMBOL WITH FINGERNAILS",
	"MUSICAL SYMBOL X NOTEHEAD",
	"MUSICAL SYMBOL Z",
	"MYANMAR CONSONANT SIGN MEDIAL HA",
	"MYANMAR CONSONANT SIGN MEDIAL RA",
	"MYANMAR CONSONANT SIGN MEDIAL WA",
	"MYANMAR CONSONANT SIGN MEDIAL YA",
	"MYANMAR CONSONANT SIGN MON MEDIAL LA",
	"MYANMAR CONSONANT SIGN MON MEDIAL MA",
	"MYANMAR CONSONANT SIGN MON MEDIAL NA",
	"MYANMAR CONSONANT SIGN SHAN MEDIAL WA",
	"MYANMAR DIGIT EIGHT",
	"MYANMAR DIGIT FIVE",
	"MYANMAR DIGIT FOUR",
	"MYANMAR DIGIT NINE",
	"MYANMAR DIGIT ONE",
	"MYANMAR DIGIT SEVEN",
	"MYANMAR DIGIT SIX",
	"MYANMAR DIGIT THREE",
	"MYANMAR DIGIT TWO",
	"MYANMAR DIGIT ZERO",
	"MYANMAR LETTER A",
	"MYANMAR LETTER AITON RA",
	"MYANMAR LETTER AU",
	"MYANMAR LETTER BA",
	"MYANMAR LETTER BHA",
	"MYANMAR LETTER CA",
	"MYANMAR LETTER CHA",
	"MYANMAR LETTER DA",
	"MYANMAR LETTER DDA",
	"MYANMAR LETTER DDHA",
	"MYANMAR LETTER DHA",
	"MYANMAR LETTER E",
	"MYANMAR LETTER EASTERN PWO KAREN GHWA",
	"MYANMAR LETTER EASTERN PWO KAREN NNA",
	"MYANMAR LETTER EASTERN PWO KAREN YWA",
	"MYANMAR LETTER GA",
	"MYANMAR LETTER GHA",
	"MYANMAR LETTER GREAT SA",
	"MYANMAR LETTER HA",
	"MYANMAR LETTER I",
	"MYANMAR LETTER II",
	"MYANMAR LETTER JA",
	"MYANMAR LETTER JHA",
	"MYANMAR LETTER KA",
	"MYANMAR LETTER KHA",
	"MYANMAR LETTER KHAMTI CA",
	"MYANMAR LETTER KHAMTI CHA",
	"MYANMAR LETTER KHAMTI DDA",
	"MYANMAR LETTER KHAMTI DDHA",
	"MYANMAR LETTER KHAMTI DHA",
	"MYANMAR LETTER KHAMTI FA",
	"MYANMAR LETTER KHAMTI GA",
	"MYANMAR LETTER KHAMTI HA",
	"MYANMAR LETTER KHAMTI HHA",
	"MYANMAR LETTER KHAMTI JA",
	"MYANMAR LETTER KHAMTI JHA",
	"MYANMAR LETTER KHAMTI NA",
	"MYANMAR LETTER KHAMTI NYA",
	"MYANMAR LETTER KHAMTI RA",
	"MYANMAR LETTER KHAMTI SA",
	"MYANMAR LETTER KHAMTI TTA",
	"MYANMAR LETTER KHAMTI TTHA",
	"MYANMAR LETTER KHAMTI XA",
	"MYANMAR LETTER KHAMTI ZA",
	"MYANMAR LETTER LA",
	"MYANMAR LETTER LLA",
	"MYANMAR LETTER MA",
	"MYANMAR LETTER MON BBA",
	"MYANMAR LETTER MON BBE",
	"MYANMAR LETTER MON E",
	"MYANMAR LETTER MON JHA",
	"MYANMAR LETTER MON NGA",
	"MYANMAR LETTER NA",
	"MYANMAR LETTER NGA",
	"MYANMAR LETTER NNA",
	"MYANMAR LETTER NNYA",
	"MYANMAR LETTER NYA",
	"MYANMAR LETTER O",
	"MYANMAR LETTER PA",
	"MYANMAR LETTER PHA",
	"MYANMAR LETTER RA",
	"MYANMAR LETTER RUMAI PALAUNG FA",
	"MYANMAR LETTER SA",
	"MYANMAR LETTER SGAW KAREN SHA",
	"MYANMAR LETTER SHA",
	"MYANMAR LETTER SHAN A",
	"MYANMAR LETTER SHAN BA",
	"MYANMAR LETTER SHAN CA",
	"MYANMAR LETTER SHAN DA",
	"MYANMAR LETTER SHAN FA",
	"MYANMAR LETTER SHAN GA",
	"MYANMAR LETTER SHAN HA",
	"MYANMAR LETTER SHAN KA",
	"MYANMAR LETTER SHAN KHA",
	"MYANMAR LETTER SHAN NA",
	"MYANMAR LETTER SHAN NYA",
	"MYANMAR LETTER SHAN PHA",
	"MYANMAR LETTER SHAN THA",
	"MYANMAR LETTER SHAN ZA",
	"MYANMAR LETTER SSA",
	"MYANMAR LETTER TA",
	"MYANMAR LETTER THA",
	"MYANMAR LETTER TTA",
	"MYANMAR LETTER TTHA",
	"MYANMAR LETTER U",
	"MYANMAR LETTER UU",
	"MYANMAR LETTER VOCALIC L",
	"MYANMAR LETTER VOCALIC LL",
	"MYANMAR LETTER VOCALIC R",
	"MYANMAR LETTER VOCALIC RR",
	"MYANMAR LETTER WA",
	"MYANMAR LETTER WESTERN PWO KAREN PWA",
	"MYANMAR LETTER WESTERN PWO KAREN THA",
	"MYANMAR LETTER YA",
	"MYANMAR LOGOGRAM KHAMTI HM",
	"MYANMAR LOGOGRAM KHAMTI OAY",
	"MYANMAR LOGOGRAM KHAMTI QN",
	"MYANMAR MODIFIER LETTER KHAMTI REDUPLICATION",
	"MYANMAR SHAN DIGIT EIGHT",
	"MYANMAR SHAN DIGIT FIVE",
	"MYANMAR SHAN DIGIT FOUR",
	"MYANMAR SHAN DIGIT NINE",
	"MYANMAR SHAN DIGIT ONE",
	"MYANMAR SHAN DIGIT SEVEN",
	"MYANMAR SHAN DIGIT SIX",
	"MYANMAR SHAN DIGIT THREE",
	"MYANMAR SHAN DIGIT TWO",
	"MYANMAR SHAN DIGIT ZERO",
	"MYANMAR SIGN ANUSVARA",
	"MYANMAR SIGN ASAT",
	"MYANMAR SIGN DOT BELOW",
	"MYANMAR SIGN LITTLE SECTION",
	"MYANMAR SIGN PAO KAREN TONE",
	"MYANMAR SIGN SECTION",
	"MYANMAR SIGN SHAN COUNCIL EMPHATIC TONE",
	"MYANMAR SIGN VIRAMA",
	"MYANMAR SIGN VISARGA",
	"MYANMAR SYMBOL AFOREMENTIONED",
	"MYANMAR SYMBOL AITON EXCLAMATION",
	"MYANMAR SYMBOL AITON ONE",
	"MYANMAR SYMBOL AITON TWO",
	"MYANMAR SYMBOL COMPLETED",
	"MYANMAR SYMBOL GENITIVE",
	"MYANMAR SYMBOL LOCATIVE",
	"MYANMAR SYMBOL SHAN EXCLAMATION",
	"MYANMAR SYMBOL SHAN ONE",
	"MYANMAR TONE MARK SGAW KAREN HATHI",
	"MYANMAR TONE MARK SGAW KAREN KE PHO",
	"MYANMAR VOWEL SIGN AA",
	"MYANMAR VOWEL SIGN AI",
	"MYANMAR VOWEL SIGN AITON A",
	"MYANMAR VOWEL SIGN AITON AI",
	"MYANMAR VOWEL SIGN E",
	"MYANMAR VOWEL SIGN E ABOVE",
	"MYANMAR VOWEL SIGN GEBA KAREN I",
	"MYANMAR VOWEL SIGN I",
	"MYANMAR VOWEL SIGN II",
	"MYANMAR VOWEL SIGN KAYAH EE",
	"MYANMAR VOWEL SIGN KAYAH OE",
	"MYANMAR VOWEL SIGN KAYAH U",
	"MYANMAR VOWEL SIGN MON II",
	"MYANMAR VOWEL SIGN MON O",
	"MYANMAR VOWEL SIGN SGAW KAREN EU",
	"MYANMAR VOWEL SIGN SHAN AA",
	"MYANMAR VOWEL SIGN SHAN E",
	"MYANMAR VOWEL SIGN SHAN E ABOVE",
	"MYANMAR VOWEL SIGN SHAN FINAL Y",
	"MYANMAR VOWEL SIGN TALL AA",
	"MYANMAR VOWEL SIGN U",
	"MYANMAR VOWEL SIGN UU",
	"MYANMAR VOWEL SIGN VOCALIC L",
	"MYANMAR VOWEL SIGN VOCALIC LL",
	"MYANMAR VOWEL SIGN VOCALIC R",
	"MYANMAR VOWEL SIGN VOCALIC RR",
	"MYANMAR VOWEL SIGN WESTERN PWO KAREN EU",
	"MYANMAR VOWEL SIGN WESTERN PWO KAREN UE",
	"N-ARY CIRCLED DOT OPERATOR",
	"N-ARY CIRCLED PLUS OPERATOR",
	"N-ARY CIRCLED TIMES OPERATOR",
	"N-ARY COPRODUCT",
	"N-ARY INTERSECTION",
	"N-ARY LOGICAL AND",
	"N-ARY LOGICAL OR",
	"N-ARY PRODUCT",
	"N-ARY SQUARE INTERSECTION OPERATOR",
	"N-ARY SQUARE UNION OPERATOR",
	"N-ARY SUMMATION",
	"N-ARY TIMES OPERATOR",
	"N-ARY UNION",
	"N-ARY UNION OPERATOR WITH DOT",
	"N-ARY UNION OPERATOR WITH PLUS",
	"N-ARY WHITE VERTICAL BAR",
	"NABLA",
	"NAIL POLISH",
	"NAIRA SIGN",
	"NAME BADGE",
	"NAND",
	"NARROW NO-BREAK SPACE",
	"NATIONAL DIGIT SHAPES",
	"NECKTIE",
	"NEGATED DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE",
	"NEGATIVE CIRCLED DIGIT ZERO",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER A",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER B",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER C",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER D",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER E",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER F",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER G",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER H",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER I",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER J",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER K",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER L",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER M",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER N",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER O",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER P",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER Q",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER R",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER S",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER T",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER U",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER V",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER W",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER X",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER Y",
	"NEGATIVE CIRCLED LATIN CAPITAL LETTER Z",
	"NEGATIVE CIRCLED NUMBER EIGHTEEN",
	"NEGATIVE CIRCLED NUMBER ELEVEN",
	"NEGATIVE CIRCLED NUMBER FIFTEEN",
	"NEGATIVE CIRCLED NUMBER FOURTEEN",
	"NEGATIVE CIRCLED NUMBER NINETEEN",
	"NEGATIVE CIRCLED NUMBER SEVENTEEN",
	"NEGATIVE CIRCLED NUMBER SIXTEEN",
	"NEGATIVE CIRCLED NUMBER THIRTEEN",
	"NEGATIVE CIRCLED NUMBER TWELVE",
	"NEGATIVE CIRCLED NUMBER TWENTY",
	"NEGATIVE SQUARED AB",
	"NEGATIVE SQUARED CROSS MARK",
	"NEGATIVE SQUARED IC",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER A",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER B",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER C",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER D",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER E",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER F",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER G",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER H",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER I",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER J",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER K",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER L",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER M",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER N",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER O",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER P",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER Q",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER R",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER S",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER T",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER U",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER V",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER W",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER X",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER Y",
	"NEGATIVE SQUARED LATIN CAPITAL LETTER Z",
	"NEGATIVE SQUARED PA",
	"NEGATIVE SQUARED SA",
	"NEGATIVE SQUARED WC",
	"NEITHER A SUBSET OF NOR EQUAL TO",
	"NEITHER A SUPERSET OF NOR EQUAL TO",
	"NEITHER APPROXIMATELY NOR ACTUALLY EQUAL TO",
	"NEITHER GREATER-THAN NOR EQUAL TO",
	"NEITHER GREATER-THAN NOR EQUIVALENT TO",
	"NEITHER GREATER-THAN NOR LESS-THAN",
	"NEITHER LESS-THAN NOR EQUAL TO",
	"NEITHER LESS-THAN NOR EQUIVALENT TO",
	"NEITHER LESS-THAN NOR GREATER-THAN",
	"NEPTUNE",
	"NEUTER",
	"NEUTRAL FACE",
	"NEW MOON SYMBOL",
	"NEW MOON WITH FACE",
	"NEW SHEQEL SIGN",
	"NEW TAI LUE DIGIT EIGHT",
	"NEW TAI LUE DIGIT FIVE",
	"NEW TAI LUE DIGIT FOUR",
	"NEW TAI LUE DIGIT NINE",
	"NEW TAI LUE DIGIT ONE",
	"NEW TAI LUE DIGIT SEVEN",
	"NEW TAI LUE DIGIT SIX",
	"NEW TAI LUE DIGIT THREE",
	"NEW TAI LUE DIGIT TWO",
	"NEW TAI LUE DIGIT ZERO",
	"NEW TAI LUE LETTER FINAL B",
	"NEW TAI LUE LETTER FINAL D",
	"NEW TAI LUE LETTER FINAL K",
	"NEW TAI LUE LETTER FINAL M",
	"NEW TAI LUE LETTER FINAL N",
	"NEW TAI LUE LETTER FINAL NG",
	"NEW TAI LUE LETTER FINAL V",
	"NEW TAI LUE LETTER HIGH BA",
	"NEW TAI LUE LETTER HIGH DA",
	"NEW TAI LUE LETTER HIGH FA",
	"NEW TAI LUE LETTER HIGH HA",
	"NEW TAI LUE LETTER HIGH KA",
	"NEW TAI LUE LETTER HIGH KVA",
	"NEW TAI LUE LETTER HIGH LA",
	"NEW TAI LUE LETTER HIGH MA",
	"NEW TAI LUE LETTER HIGH NA",
	"NEW TAI LUE LETTER HIGH NGA",
	"NEW TAI LUE LETTER HIGH PA",
	"NEW TAI LUE LETTER HIGH PHA",
	"NEW TAI LUE LETTER HIGH QA",
	"NEW TAI LUE LETTER HIGH SA",
	"NEW TAI LUE LETTER HIGH SUA",
	"NEW TAI LUE LETTER HIGH TA",
	"NEW TAI LUE LETTER HIGH THA",
	"NEW TAI LUE LETTER HIGH TSA",
	"NEW TAI LUE LETTER HIGH VA",
	"NEW TAI LUE LETTER HIGH XA",
	"NEW TAI LUE LETTER HIGH XVA",
	"NEW TAI LUE LETTER HIGH YA",
	"NEW TAI LUE LETTER LOW BA",
	"NEW TAI LUE LETTER LOW DA",
	"NEW TAI LUE LETTER LOW FA",
	"NEW TAI LUE LETTER LOW HA",
	"NEW TAI LUE LETTER LOW KA",
	"NEW TAI LUE LETTER LOW KVA",
	"NEW TAI LUE LETTER LOW LA",
	"NEW TAI LUE LETTER LOW MA",
	"NEW TAI LUE LETTER LOW NA",
	"NEW TAI LUE LETTER LOW NGA",
	"NEW TAI LUE LETTER LOW PA",
	"NEW TAI LUE LETTER LOW PHA",
	"NEW TAI LUE LETTER LOW QA",
	"NEW TAI LUE LETTER LOW SA",
	"NEW TAI LUE LETTER LOW SUA",
	"NEW TAI LUE LETTER LOW TA",
	"NEW TAI LUE LETTER LOW THA",
	"NEW TAI LUE LETTER LOW TSA",
	"NEW TAI LUE LETTER LOW VA",
	"NEW TAI LUE LETTER LOW XA",
	"NEW TAI LUE LETTER LOW XVA",
	"NEW TAI LUE LETTER LOW YA",
	"NEW TAI LUE SIGN LAE",
	"NEW TAI LUE SIGN LAEV",
	"NEW TAI LUE THAM DIGIT ONE",
	"NEW TAI LUE VOWEL SIGN AA",
	"NEW TAI LUE VOWEL SIGN AAY",
	"NEW TAI LUE VOWEL SIGN AE",
	"NEW TAI LUE VOWEL SIGN AY",
	"NEW TAI LUE VOWEL SIGN E",
	"NEW TAI LUE VOWEL SIGN II",
	"NEW TAI LUE VOWEL SIGN IY",
	"NEW TAI LUE VOWEL SIGN O",
	"NEW TAI LUE VOWEL SIGN OA",
	"NEW TAI LUE VOWEL SIGN OAY",
	"NEW TAI LUE VOWEL SIGN OY",
	"NEW TAI LUE VOWEL SIGN U",
	"NEW TAI LUE VOWEL SIGN UE",
	"NEW TAI LUE VOWEL SIGN UEY",
	"NEW TAI LUE VOWEL SIGN UU",
	"NEW TAI LUE VOWEL SIGN UY",
	"NEW TAI LUE VOWEL SIGN VOWEL SHORTENER",
	"NEWSPAPER",
	"NEXT PAGE",
	"NIGHT WITH STARS",
	"NKO COMBINING DOUBLE DOT ABOVE",
	"NKO COMBINING LONG DESCENDING TONE",
	"NKO COMBINING LONG HIGH TONE",
	"NKO COMBINING LONG LOW TONE",
	"NKO COMBINING LONG RISING TONE",
	"NKO COMBINING NASALIZATION MARK",
	"NKO COMBINING SHORT HIGH TONE",
	"NKO COMBINING SHORT LOW TONE",
	"NKO COMBINING SHORT RISING TONE",
	"NKO COMMA",
	"NKO DIGIT EIGHT",
	"NKO DIGIT FIVE",
	"NKO DIGIT FOUR",
	"NKO DIGIT NINE",
	"NKO DIGIT ONE",
	"NKO DIGIT SEVEN",
	"NKO DIGIT SIX",
	"NKO DIGIT THREE",
	"NKO DIGIT TWO",
	"NKO DIGIT ZERO",
	"NKO EXCLAMATION MARK",
	"NKO HIGH TONE APOSTROPHE",
	"NKO LAJANYALAN",
	"NKO LETTER A",
	"NKO LETTER BA",
	"NKO LETTER CHA",
	"NKO LETTER DA",
	"NKO LETTER DAGBASINNA",
	"NKO LETTER E",
	"NKO LETTER EE",
	"NKO LETTER FA",
	"NKO LETTER GBA",
	"NKO LETTER HA",
	"NKO LETTER I",
	"NKO LETTER JA",
	"NKO LETTER JONA CHA",
	"NKO LETTER JONA JA",
	"NKO LETTER JONA RA",
	"NKO LETTER KA",
	"NKO LETTER LA",
	"NKO LETTER MA",
	"NKO LETTER N",
	"NKO LETTER NA",
	"NKO LETTER NA WOLOSO",
	"NKO LETTER NYA",
	"NKO LETTER NYA WOLOSO",
	"NKO LETTER O",
	"NKO LETTER OO",
	"NKO LETTER PA",
	"NKO LETTER RA",
	"NKO LETTER RRA",
	"NKO LETTER SA",
	"NKO LETTER TA",
	"NKO LETTER U",
	"NKO LETTER WA",
	"NKO LETTER YA",
	"NKO LOW TONE APOSTROPHE",
	"NKO SYMBOL GBAKURUNEN",
	"NKO SYMBOL OO DENNEN",
	"NO BICYCLES",
	"NO ENTRY",
	"NO ENTRY SIGN",
	"NO MOBILE PHONES",
	"NO ONE UNDER EIGHTEEN SYMBOL",
	"NO PEDESTRIANS",
	"NO SMOKING SYMBOL",
	"NO-BREAK SPACE",
	"NOMINAL DIGIT SHAPES",
	"NON-BREAKING HYPHEN",
	"NON-POTABLE WATER SYMBOL",
	"NONFORKING",
	"NOR",
	"NORMAL SUBGROUP OF",
	"NORMAL SUBGROUP OF OR EQUAL TO",
	"NORTH EAST AND SOUTH WEST ARROW",
	"NORTH EAST ARROW",
	"NORTH EAST ARROW AND SOUTH EAST ARROW",
	"NORTH EAST ARROW CROSSING NORTH WEST ARROW",
	"NORTH EAST ARROW CROSSING SOUTH EAST ARROW",
	"NORTH EAST ARROW WITH HOOK",
	"NORTH EAST BLACK ARROW",
	"NORTH EAST DOUBLE ARROW",
	"NORTH EAST WHITE ARROW",
	"NORTH INDIC FRACTION ONE EIGHTH",
	"NORTH INDIC FRACTION ONE HALF",
	"NORTH INDIC FRACTION ONE QUARTER",
	"NORTH INDIC FRACTION ONE SIXTEENTH",
	"NORTH INDIC FRACTION THREE QUARTERS",
	"NORTH INDIC FRACTION THREE SIXTEENTHS",
	"NORTH INDIC PLACEHOLDER MARK",
	"NORTH INDIC QUANTITY MARK",
	"NORTH INDIC QUARTER MARK",
	"NORTH INDIC RUPEE MARK",
	"NORTH WEST AND SOUTH EAST ARROW",
	"NORTH WEST ARROW",
	"NORTH WEST ARROW AND NORTH EAST ARROW",
	"NORTH WEST ARROW CROSSING NORTH EAST ARROW",
	"NORTH WEST ARROW TO CORNER",
	"NORTH WEST ARROW TO LONG BAR",
	"NORTH WEST ARROW WITH HOOK",
	"NORTH WEST BLACK ARROW",
	"NORTH WEST DOUBLE ARROW",
	"NORTH WEST WHITE ARROW",
	"NOSE",
	"NOT A SUBSET OF",
	"NOT A SUPERSET OF",
	"NOT ALMOST EQUAL TO",
	"NOT AN ELEMENT OF",
	"NOT ASYMPTOTICALLY EQUAL TO",
	"NOT CHECK MARK",
	"NOT EQUAL TO",
	"NOT EQUIVALENT TO",
	"NOT GREATER-THAN",
	"NOT IDENTICAL TO",
	"NOT LESS-THAN",
	"NOT NORMAL SUBGROUP OF",
	"NOT NORMAL SUBGROUP OF OR EQUAL TO",
	"NOT PARALLEL TO",
	"NOT SIGN",
	"NOT SQUARE IMAGE OF OR EQUAL TO",
	"NOT SQUARE ORIGINAL OF OR EQUAL TO",
	"NOT TILDE",
	"NOT TRUE",
	"NOTCHED LEFT SEMICIRCLE WITH THREE DOTS",
	"NOTCHED LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW",
	"NOTCHED UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW",
	"NOTEBOOK",
	"NOTEBOOK WITH DECORATIVE COVER",
	"NUMBER EIGHTEEN FULL STOP",
	"NUMBER ELEVEN FULL STOP",
	"NUMBER FIFTEEN FULL STOP",
	"NUMBER FOURTEEN FULL STOP",
	"NUMBER NINETEEN FULL STOP",
	"NUMBER SEVENTEEN FULL STOP",
	"NUMBER SIGN",
	"NUMBER SIXTEEN FULL STOP",
	"NUMBER TEN FULL STOP",
	"NUMBER THIRTEEN FULL STOP",
	"NUMBER TWELVE FULL STOP",
	"NUMBER TWENTY FULL STOP",
	"NUMERO SIGN",
	"NUT AND BOLT",
	"OBJECT REPLACEMENT CHARACTER",
	"OBLIQUE ANGLE OPENING DOWN",
	"OBLIQUE ANGLE OPENING UP",
	"OCR AMOUNT OF CHECK",
	"OCR BELT BUCKLE",
	"OCR BOW TIE",
	"OCR BRANCH BANK IDENTIFICATION",
	"OCR CHAIR",
	"OCR CUSTOMER ACCOUNT NUMBER",
	"OCR DASH",
	"OCR DOUBLE BACKSLASH",
	"OCR FORK",
	"OCR HOOK",
	"OCR INVERTED FORK",
	"OCTOPUS",
	"ODEN",
	"OFFICE BUILDING",
	"OGHAM FEATHER MARK",
	"OGHAM LETTER AILM",
	"OGHAM LETTER BEITH",
	"OGHAM LETTER CEIRT",
	"OGHAM LETTER COLL",
	"OGHAM LETTER DAIR",
	"OGHAM LETTER EABHADH",
	"OGHAM LETTER EADHADH",
	"OGHAM LETTER EAMHANCHOLL",
	"OGHAM LETTER FEARN",
	"OGHAM LETTER GORT",
	"OGHAM LETTER IFIN",
	"OGHAM LETTER IODHADH",
	"OGHAM LETTER LUIS",
	"OGHAM LETTER MUIN",
	"OGHAM LETTER NGEADAL",
	"OGHAM LETTER NION",
	"OGHAM LETTER ONN",
	"OGHAM LETTER OR",
	"OGHAM LETTER PEITH",
	"OGHAM LETTER RUIS",
	"OGHAM LETTER SAIL",
	"OGHAM LETTER STRAIF",
	"OGHAM LETTER TINNE",
	"OGHAM LETTER UATH",
	"OGHAM LETTER UILLEANN",
	"OGHAM LETTER UR",
	"OGHAM REVERSED FEATHER MARK",
	"OGHAM SPACE MARK",
	"OGONEK",
	"OHM SIGN",
	"OK HAND SIGN",
	"OL CHIKI AHAD",
	"OL CHIKI DIGIT EIGHT",
	"OL CHIKI DIGIT FIVE",
	"OL CHIKI DIGIT FOUR",
	"OL CHIKI DIGIT NINE",
	"OL CHIKI DIGIT ONE",
	"OL CHIKI DIGIT SEVEN",
	"OL CHIKI DIGIT SIX",
	"OL CHIKI DIGIT THREE",
	"OL CHIKI DIGIT TWO",
	"OL CHIKI DIGIT ZERO",
	"OL CHIKI GAAHLAA TTUDDAAG",
	"OL CHIKI LETTER AAJ",
	"OL CHIKI LETTER AAK",
	"OL CHIKI LETTER AAM",
	"OL CHIKI LETTER AAW",
	"OL CHIKI LETTER AG",
	"OL CHIKI LETTER AL",
	"OL CHIKI LETTER ANG",
	"OL CHIKI LETTER AT",
	"OL CHIKI LETTER EDD",
	"OL CHIKI LETTER EN",
	"OL CHIKI LETTER EP",
	"OL CHIKI LETTER ERR",
	"OL CHIKI LETTER IH",
	"OL CHIKI LETTER INY",
	"OL CHIKI LETTER IR",
	"OL CHIKI LETTER IS",
	"OL CHIKI LETTER LA",
	"OL CHIKI LETTER LAA",
	"OL CHIKI LETTER LE",
	"OL CHIKI LETTER LI",
	"OL CHIKI LETTER LO",
	"OL CHIKI LETTER LU",
	"OL CHIKI LETTER OB",
	"OL CHIKI LETTER OH",
	"OL CHIKI LETTER OTT",
	"OL CHIKI LETTER OV",
	"OL CHIKI LETTER UC",
	"OL CHIKI LETTER UD",
	"OL CHIKI LETTER UNN",
	"OL CHIKI LETTER UY",
	"OL CHIKI MU TTUDDAG",
	"OL CHIKI MU-GAAHLAA TTUDDAAG",
	"OL CHIKI PHAARKAA",
	"OL CHIKI PUNCTUATION DOUBLE MUCAAD",
	"OL CHIKI PUNCTUATION MUCAAD",
	"OL CHIKI RELAA",
	"OLD ITALIC LETTER A",
	"OLD ITALIC LETTER BE",
	"OLD ITALIC LETTER CHE",
	"OLD ITALIC LETTER DE",
	"OLD ITALIC LETTER E",
	"OLD ITALIC LETTER EF",
	"OLD ITALIC LETTER EKS",
	"OLD ITALIC LETTER EL",
	"OLD ITALIC LETTER EM",
	"OLD ITALIC LETTER EN",
	"OLD ITALIC LETTER ER",
	"OLD ITALIC LETTER ERS",
	"OLD ITALIC LETTER ES",
	"OLD ITALIC LETTER ESH",
	"OLD ITALIC LETTER HE",
	"OLD ITALIC LETTER I",
	"OLD ITALIC LETTER II",
	"OLD ITALIC LETTER KA",
	"OLD ITALIC LETTER KE",
	"OLD ITALIC LETTER KHE",
	"OLD ITALIC LETTER KU",
	"OLD ITALIC LETTER O",
	"OLD ITALIC LETTER PE",
	"OLD ITALIC LETTER PHE",
	"OLD ITALIC LETTER SHE",
	"OLD ITALIC LETTER TE",
	"OLD ITALIC LETTER THE",
	"OLD ITALIC LETTER U",
	"OLD ITALIC LETTER UU",
	"OLD ITALIC LETTER VE",
	"OLD ITALIC LETTER ZE",
	"OLD ITALIC NUMERAL FIFTY",
	"OLD ITALIC NUMERAL FIVE",
	"OLD ITALIC NUMERAL ONE",
	"OLD ITALIC NUMERAL TEN",
	"OLD PERSIAN NUMBER HUNDRED",
	"OLD PERSIAN NUMBER ONE",
	"OLD PERSIAN NUMBER TEN",
	"OLD PERSIAN NUMBER TWENTY",
	"OLD PERSIAN NUMBER TWO",
	"OLD PERSIAN SIGN A",
	"OLD PERSIAN SIGN AURAMAZDAA",
	"OLD PERSIAN SIGN AURAMAZDAAHA",
	"OLD PERSIAN SIGN BA",
	"OLD PERSIAN SIGN BAGA",
	"OLD PERSIAN SIGN BUUMISH",
	"OLD PERSIAN SIGN CA",
	"OLD PERSIAN SIGN DA",
	"OLD PERSIAN SIGN DAHYAAUSH",
	"OLD PERSIAN SIGN DI",
	"OLD PERSIAN SIGN DU",
	"OLD PERSIAN SIGN FA",
	"OLD PERSIAN SIGN GA",
	"OLD PERSIAN SIGN GU",
	"OLD PERSIAN SIGN HA",
	"OLD PERSIAN SIGN I",
	"OLD PERSIAN SIGN JA",
	"OLD PERSIAN SIGN JI",
	"OLD PERSIAN SIGN KA",
	"OLD PERSIAN SIGN KU",
	"OLD PERSIAN SIGN LA",
	"OLD PERSIAN SIGN MA",
	"OLD PERSIAN SIGN MI",
	"OLD PERSIAN SIGN MU",
	"OLD PERSIAN SIGN NA",
	"OLD PERSIAN SIGN NU",
	"OLD PERSIAN SIGN PA",
	"OLD PERSIAN SIGN RA",
	"OLD PERSIAN SIGN RU",
	"OLD PERSIAN SIGN SA",
	"OLD PERSIAN SIGN SHA",
	"OLD PERSIAN SIGN SSA",
	"OLD PERSIAN SIGN TA",
	"OLD PERSIAN SIGN THA",
	"OLD PERSIAN SIGN TU",
	"OLD PERSIAN SIGN U",
	"OLD PERSIAN SIGN VA",
	"OLD PERSIAN SIGN VI",
	"OLD PERSIAN SIGN XA",
	"OLD PERSIAN SIGN XSHAAYATHIYA",
	"OLD PERSIAN SIGN YA",
	"OLD PERSIAN SIGN ZA",
	"OLD PERSIAN WORD DIVIDER",
	"OLD SOUTH ARABIAN LETTER ALEF",
	"OLD SOUTH ARABIAN LETTER AYN",
	"OLD SOUTH ARABIAN LETTER BETH",
	"OLD SOUTH ARABIAN LETTER DALETH",
	"OLD SOUTH ARABIAN LETTER DHADHE",
	"OLD SOUTH ARABIAN LETTER DHALETH",
	"OLD SOUTH ARABIAN LETTER FE",
	"OLD SOUTH ARABIAN LETTER GHAYN",
	"OLD SOUTH ARABIAN LETTER GIMEL",
	"OLD SOUTH ARABIAN LETTER HE",
	"OLD SOUTH ARABIAN LETTER HETH",
	"OLD SOUTH ARABIAN LETTER KAPH",
	"OLD SOUTH ARABIAN LETTER KHETH",
	"OLD SOUTH ARABIAN LETTER LAMEDH",
	"OLD SOUTH ARABIAN LETTER MEM",
	"OLD SOUTH ARABIAN LETTER NUN",
	"OLD SOUTH ARABIAN LETTER QOPH",
	"OLD SOUTH ARABIAN LETTER RESH",
	"OLD SOUTH ARABIAN LETTER SADHE",
	"OLD SOUTH ARABIAN LETTER SAMEKH",
	"OLD SOUTH ARABIAN LETTER SAT",
	"OLD SOUTH ARABIAN LETTER SHIN",
	"OLD SOUTH ARABIAN LETTER TAW",
	"OLD SOUTH ARABIAN LETTER TETH",
	"OLD SOUTH ARABIAN LETTER THAW",
	"OLD SOUTH ARABIAN LETTER THETH",
	"OLD SOUTH ARABIAN LETTER WAW",
	"OLD SOUTH ARABIAN LETTER YODH",
	"OLD SOUTH ARABIAN LETTER ZAYN",
	"OLD SOUTH ARABIAN NUMBER FIFTY",
	"OLD SOUTH ARABIAN NUMBER ONE",
	"OLD SOUTH ARABIAN NUMERIC INDICATOR",
	"OLD TURKIC LETTER ORKHON A",
	"OLD TURKIC LETTER ORKHON AB",
	"OLD TURKIC LETTER ORKHON AD",
	"OLD TURKIC LETTER ORKHON AEB",
	"OLD TURKIC LETTER ORKHON AED",
	"OLD TURKIC LETTER ORKHON AEG",
	"OLD TURKIC LETTER ORKHON AEK",
	"OLD TURKIC LETTER ORKHON AEL",
	"OLD TURKIC LETTER ORKHON AEN",
	"OLD TURKIC LETTER ORKHON AER",
	"OLD TURKIC LETTER ORKHON AES",
	"OLD TURKIC LETTER ORKHON AET",
	"OLD TURKIC LETTER ORKHON AEY",
	"OLD TURKIC LETTER ORKHON AG",
	"OLD TURKIC LETTER ORKHON AL",
	"OLD TURKIC LETTER ORKHON AN",
	"OLD TURKIC LETTER ORKHON AQ",
	"OLD TURKIC LETTER ORKHON AR",
	"OLD TURKIC LETTER ORKHON AS",
	"OLD TURKIC LETTER ORKHON ASH",
	"OLD TURKIC LETTER ORKHON AT",
	"OLD TURKIC LETTER ORKHON AY",
	"OLD TURKIC LETTER ORKHON BASH",
	"OLD TURKIC LETTER ORKHON EC",
	"OLD TURKIC LETTER ORKHON ELT",
	"OLD TURKIC LETTER ORKHON EM",
	"OLD TURKIC LETTER ORKHON ENC",
	"OLD TURKIC LETTER ORKHON ENG",
	"OLD TURKIC LETTER ORKHON ENT",
	"OLD TURKIC LETTER ORKHON ENY",
	"OLD TURKIC LETTER ORKHON EP",
	"OLD TURKIC LETTER ORKHON ESH",
	"OLD TURKIC LETTER ORKHON EZ",
	"OLD TURKIC LETTER ORKHON I",
	"OLD TURKIC LETTER ORKHON IC",
	"OLD TURKIC LETTER ORKHON IQ",
	"OLD TURKIC LETTER ORKHON O",
	"OLD TURKIC LETTER ORKHON OE",
	"OLD TURKIC LETTER ORKHON OEK",
	"OLD TURKIC LETTER ORKHON OP",
	"OLD TURKIC LETTER ORKHON OQ",
	"OLD TURKIC LETTER ORKHON OT",
	"OLD TURKIC LETTER YENISEI A",
	"OLD TURKIC LETTER YENISEI AB",
	"OLD TURKIC LETTER YENISEI AD",
	"OLD TURKIC LETTER YENISEI AE",
	"OLD TURKIC LETTER YENISEI AEB",
	"OLD TURKIC LETTER YENISEI AEG",
	"OLD TURKIC LETTER YENISEI AEK",
	"OLD TURKIC LETTER YENISEI AEN",
	"OLD TURKIC LETTER YENISEI AENG",
	"OLD TURKIC LETTER YENISEI AET",
	"OLD TURKIC LETTER YENISEI AEY",
	"OLD TURKIC LETTER YENISEI AG",
	"OLD TURKIC LETTER YENISEI AL",
	"OLD TURKIC LETTER YENISEI ANG",
	"OLD TURKIC LETTER YENISEI AQ",
	"OLD TURKIC LETTER YENISEI AR",
	"OLD TURKIC LETTER YENISEI ASH",
	"OLD TURKIC LETTER YENISEI AT",
	"OLD TURKIC LETTER YENISEI AY",
	"OLD TURKIC LETTER YENISEI E",
	"OLD TURKIC LETTER YENISEI EC",
	"OLD TURKIC LETTER YENISEI ENC",
	"OLD TURKIC LETTER YENISEI ENT",
	"OLD TURKIC LETTER YENISEI ENY",
	"OLD TURKIC LETTER YENISEI ESH",
	"OLD TURKIC LETTER YENISEI EZ",
	"OLD TURKIC LETTER YENISEI I",
	"OLD TURKIC LETTER YENISEI IQ",
	"OLD TURKIC LETTER YENISEI OE",
	"OLD TURKIC LETTER YENISEI OEK",
	"OLD TURKIC LETTER YENISEI OQ",
	"OLDER MAN",
	"OLDER WOMAN",
	"ON WITH EXCLAMATION MARK WITH LEFT RIGHT ARROW ABOVE",
	"ONCOMING AUTOMOBILE",
	"ONCOMING BUS",
	"ONCOMING POLICE CAR",
	"ONCOMING TAXI",
	"ONE DOT LEADER",
	"ONE DOT OVER TWO DOTS PUNCTUATION",
	"OPEN BOOK",
	"OPEN BOX",
	"OPEN CENTRE ASTERISK",
	"OPEN CENTRE BLACK STAR",
	"OPEN CENTRE CROSS",
	"OPEN CENTRE TEARDROP-SPOKED ASTERISK",
	"OPEN FILE FOLDER",
	"OPEN HANDS SIGN",
	"OPEN LOCK",
	"OPEN MAILBOX WITH LOWERED FLAG",
	"OPEN MAILBOX WITH RAISED FLAG",
	"OPEN SUBSET",
	"OPEN SUPERSET",
	"OPEN-CIRCUIT-OUTPUT H-TYPE SYMBOL",
	"OPEN-CIRCUIT-OUTPUT L-TYPE SYMBOL",
	"OPEN-OUTLINED RIGHTWARDS ARROW",
	"OPHIUCHUS",
	"OPPOSITION",
	"OPTICAL DISC",
	"OPTION KEY",
	"OR WITH DOT INSIDE",
	"ORANGE BOOK",
	"ORIGINAL OF",
	"ORIYA AI LENGTH MARK",
	"ORIYA AU LENGTH MARK",
	"ORIYA DIGIT EIGHT",
	"ORIYA DIGIT FIVE",
	"ORIYA DIGIT FOUR",
	"ORIYA DIGIT NINE",
	"ORIYA DIGIT ONE",
	"ORIYA DIGIT SEVEN",
	"ORIYA DIGIT SIX",
	"ORIYA DIGIT THREE",
	"ORIYA DIGIT TWO",
	"ORIYA DIGIT ZERO",
	"ORIYA FRACTION ONE EIGHTH",
	"ORIYA FRACTION ONE HALF",
	"ORIYA FRACTION ONE QUARTER",
	"ORIYA FRACTION ONE SIXTEENTH",
	"ORIYA FRACTION THREE QUARTERS",
	"ORIYA FRACTION THREE SIXTEENTHS",
	"ORIYA ISSHAR",
	"ORIYA LETTER A",
	"ORIYA LETTER AA",
	"ORIYA LETTER AI",
	"ORIYA LETTER AU",
	"ORIYA LETTER BA",
	"ORIYA LETTER BHA",
	"ORIYA LETTER CA",
	"ORIYA LETTER CHA",
	"ORIYA LETTER DA",
	"ORIYA LETTER DDA",
	"ORIYA LETTER DDHA",
	"ORIYA LETTER DHA",
	"ORIYA LETTER E",
	"ORIYA LETTER GA",
	"ORIYA LETTER GHA",
	"ORIYA LETTER HA",
	"ORIYA LETTER I",
	"ORIYA LETTER II",
	"ORIYA LETTER JA",
	"ORIYA LETTER JHA",
	"ORIYA LETTER KA",
	"ORIYA LETTER KHA",
	"ORIYA LETTER LA",
	"ORIYA LETTER LLA",
	"ORIYA LETTER MA",
	"ORIYA LETTER NA",
	"ORIYA LETTER NGA",
	"ORIYA LETTER NNA",
	"ORIYA LETTER NYA",
	"ORIYA LETTER O",
	"ORIYA LETTER PA",
	"ORIYA LETTER PHA",
	"ORIYA LETTER RA",
	"ORIYA LETTER RHA",
	"ORIYA LETTER RRA",
	"ORIYA LETTER SA",
	"ORIYA LETTER SHA",
	"ORIYA LETTER SSA",
	"ORIYA LETTER TA",
	"ORIYA LETTER THA",
	"ORIYA LETTER TTA",
	"ORIYA LETTER TTHA",
	"ORIYA LETTER U",
	"ORIYA LETTER UU",
	"ORIYA LETTER VA",
	"ORIYA LETTER VOCALIC L",
	"ORIYA LETTER VOCALIC LL",
	"ORIYA LETTER VOCALIC R",
	"ORIYA LETTER VOCALIC RR",
	"ORIYA LETTER WA",
	"ORIYA LETTER YA",
	"ORIYA LETTER YYA",
	"ORIYA SIGN ANUSVARA",
	"ORIYA SIGN AVAGRAHA",
	"ORIYA SIGN CANDRABINDU",
	"ORIYA SIGN NUKTA",
	"ORIYA SIGN VIRAMA",
	"ORIYA SIGN VISARGA",
	"ORIYA VOWEL SIGN AA",
	"ORIYA VOWEL SIGN AI",
	"ORIYA VOWEL SIGN AU",
	"ORIYA VOWEL SIGN E",
	"ORIYA VOWEL SIGN I",
	"ORIYA VOWEL SIGN II",
	"ORIYA VOWEL SIGN O",
	"ORIYA VOWEL SIGN U",
	"ORIYA VOWEL SIGN UU",
	"ORIYA VOWEL SIGN VOCALIC L",
	"ORIYA VOWEL SIGN VOCALIC LL",
	"ORIYA VOWEL SIGN VOCALIC R",
	"ORIYA VOWEL SIGN VOCALIC RR",
	"ORNATE LEFT PARENTHESIS",
	"ORNATE RIGHT PARENTHESIS",
	"ORTHODOX CROSS",
	"OSMANYA DIGIT EIGHT",
	"OSMANYA DIGIT FIVE",
	"OSMANYA DIGIT FOUR",
	"OSMANYA DIGIT NINE",
	"OSMANYA DIGIT ONE",
	"OSMANYA DIGIT SEVEN",
	"OSMANYA DIGIT SIX",
	"OSMANYA DIGIT THREE",
	"OSMANYA DIGIT TWO",
	"OSMANYA DIGIT ZERO",
	"OSMANYA LETTER A",
	"OSMANYA LETTER AA",
	"OSMANYA LETTER ALEF",
	"OSMANYA LETTER BA",
	"OSMANYA LETTER CAYN",
	"OSMANYA LETTER DEEL",
	"OSMANYA LETTER DHA",
	"OSMANYA LETTER E",
	"OSMANYA LETTER EE",
	"OSMANYA LETTER FA",
	"OSMANYA LETTER GA",
	"OSMANYA LETTER HA",
	"OSMANYA LETTER I",
	"OSMANYA LETTER JA",
	"OSMANYA LETTER KAAF",
	"OSMANYA LETTER KHA",
	"OSMANYA LETTER LAAN",
	"OSMANYA LETTER MIIN",
	"OSMANYA LETTER NUUN",
	"OSMANYA LETTER O",
	"OSMANYA LETTER OO",
	"OSMANYA LETTER QAAF",
	"OSMANYA LETTER RA",
	"OSMANYA LETTER SA",
	"OSMANYA LETTER SHIIN",
	"OSMANYA LETTER TA",
	"OSMANYA LETTER U",
	"OSMANYA LETTER WAW",
	"OSMANYA LETTER XA",
	"OSMANYA LETTER YA",
	"OUNCE SIGN",
	"OUTBOX TRAY",
	"OUTLINED BLACK STAR",
	"OUTLINED GREEK CROSS",
	"OUTLINED LATIN CROSS",
	"OUTLINED WHITE STAR",
	"OVERLINE",
	"OX",
	"PACKAGE",
	"PAGE FACING UP",
	"PAGE WITH CURL",
	"PAGER",
	"PALLAS",
	"PALM BRANCH",
	"PALM TREE",
	"PANDA FACE",
	"PAPERCLIP",
	"PARAGRAPH SEPARATOR",
	"PARAGRAPHOS",
	"PARALLEL TO",
	"PARALLEL WITH HORIZONTAL STROKE",
	"PARALLEL WITH TILDE OPERATOR",
	"PARENTHESIZED DIGIT EIGHT",
	"PARENTHESIZED DIGIT FIVE",
	"PARENTHESIZED DIGIT FOUR",
	"PARENTHESIZED DIGIT NINE",
	"PARENTHESIZED DIGIT ONE",
	"PARENTHESIZED DIGIT SEVEN",
	"PARENTHESIZED DIGIT SIX",
	"PARENTHESIZED DIGIT THREE",
	"PARENTHESIZED DIGIT TWO",
	"PARENTHESIZED HANGUL CHIEUCH",
	"PARENTHESIZED HANGUL CHIEUCH A",
	"PARENTHESIZED HANGUL CIEUC",
	"PARENTHESIZED HANGUL CIEUC A",
	"PARENTHESIZED HANGUL CIEUC U",
	"PARENTHESIZED HANGUL HIEUH",
	"PARENTHESIZED HANGUL HIEUH A",
	"PARENTHESIZED HANGUL IEUNG",
	"PARENTHESIZED HANGUL IEUNG A",
	"PARENTHESIZED HANGUL KHIEUKH",
	"PARENTHESIZED HANGUL KHIEUKH A",
	"PARENTHESIZED HANGUL KIYEOK",
	"PARENTHESIZED HANGUL KIYEOK A",
	"PARENTHESIZED HANGUL MIEUM",
	"PARENTHESIZED HANGUL MIEUM A",
	"PARENTHESIZED HANGUL NIEUN",
	"PARENTHESIZED HANGUL NIEUN A",
	"PARENTHESIZED HANGUL PHIEUPH",
	"PARENTHESIZED HANGUL PHIEUPH A",
	"PARENTHESIZED HANGUL PIEUP",
	"PARENTHESIZED HANGUL PIEUP A",
	"PARENTHESIZED HANGUL RIEUL",
	"PARENTHESIZED HANGUL RIEUL A",
	"PARENTHESIZED HANGUL SIOS",
	"PARENTHESIZED HANGUL SIOS A",
	"PARENTHESIZED HANGUL THIEUTH",
	"PARENTHESIZED HANGUL THIEUTH A",
	"PARENTHESIZED HANGUL TIKEUT",
	"PARENTHESIZED HANGUL TIKEUT A",
	"PARENTHESIZED IDEOGRAPH ALLIANCE",
	"PARENTHESIZED IDEOGRAPH CALL",
	"PARENTHESIZED IDEOGRAPH CONGRATULATION",
	"PARENTHESIZED IDEOGRAPH EARTH",
	"PARENTHESIZED IDEOGRAPH EIGHT",
	"PARENTHESIZED IDEOGRAPH ENTERPRISE",
	"PARENTHESIZED IDEOGRAPH FESTIVAL",
	"PARENTHESIZED IDEOGRAPH FINANCIAL",
	"PARENTHESIZED IDEOGRAPH FIRE",
	"PARENTHESIZED IDEOGRAPH FIVE",
	"PARENTHESIZED IDEOGRAPH FOUR",
	"PARENTHESIZED IDEOGRAPH HAVE",
	"PARENTHESIZED IDEOGRAPH LABOR",
	"PARENTHESIZED IDEOGRAPH METAL",
	"PARENTHESIZED IDEOGRAPH MOON",
	"PARENTHESIZED IDEOGRAPH NAME",
	"PARENTHESIZED IDEOGRAPH NINE",
	"PARENTHESIZED IDEOGRAPH ONE",
	"PARENTHESIZED IDEOGRAPH REACH",
	"PARENTHESIZED IDEOGRAPH REPRESENT",
	"PARENTHESIZED IDEOGRAPH RESOURCE",
	"PARENTHESIZED IDEOGRAPH REST",
	"PARENTHESIZED IDEOGRAPH SELF",
	"PARENTHESIZED IDEOGRAPH SEVEN",
	"PARENTHESIZED IDEOGRAPH SIX",
	"PARENTHESIZED IDEOGRAPH SOCIETY",
	"PARENTHESIZED IDEOGRAPH SPECIAL",
	"PARENTHESIZED IDEOGRAPH STOCK",
	"PARENTHESIZED IDEOGRAPH STUDY",
	"PARENTHESIZED IDEOGRAPH SUN",
	"PARENTHESIZED IDEOGRAPH SUPERVISE",
	"PARENTHESIZED IDEOGRAPH TEN",
	"PARENTHESIZED IDEOGRAPH THREE",
	"PARENTHESIZED IDEOGRAPH TWO",
	"PARENTHESIZED IDEOGRAPH WATER",
	"PARENTHESIZED IDEOGRAPH WOOD",
	"PARENTHESIZED KOREAN CHARACTER O HU",
	"PARENTHESIZED KOREAN CHARACTER OJEON",
	"PARENTHESIZED LATIN CAPITAL LETTER A",
	"PARENTHESIZED LATIN CAPITAL LETTER B",
	"PARENTHESIZED LATIN CAPITAL LETTER C",
	"PARENTHESIZED LATIN CAPITAL LETTER D",
	"PARENTHESIZED LATIN CAPITAL LETTER E",
	"PARENTHESIZED LATIN CAPITAL LETTER F",
	"PARENTHESIZED LATIN CAPITAL LETTER G",
	"PARENTHESIZED LATIN CAPITAL LETTER H",
	"PARENTHESIZED LATIN CAPITAL LETTER I",
	"PARENTHESIZED LATIN CAPITAL LETTER J",
	"PARENTHESIZED LATIN CAPITAL LETTER K",
	"PARENTHESIZED LATIN CAPITAL LETTER L",
	"PARENTHESIZED LATIN CAPITAL LETTER M",
	"PARENTHESIZED LATIN CAPITAL LETTER N",
	"PARENTHESIZED LATIN CAPITAL LETTER O",
	"PARENTHESIZED LATIN CAPITAL LETTER P",
	"PARENTHESIZED LATIN CAPITAL LETTER Q",
	"PARENTHESIZED LATIN CAPITAL LETTER R",
	"PARENTHESIZED LATIN CAPITAL LETTER S",
	"PARENTHESIZED LATIN CAPITAL LETTER T",
	"PARENTHESIZED LATIN CAPITAL LETTER U",
	"PARENTHESIZED LATIN CAPITAL LETTER V",
	"PARENTHESIZED LATIN CAPITAL LETTER W",
	"PARENTHESIZED LATIN CAPITAL LETTER X",
	"PARENTHESIZED LATIN CAPITAL LETTER Y",
	"PARENTHESIZED LATIN CAPITAL LETTER Z",
	"PARENTHESIZED LATIN SMALL LETTER A",
	"PARENTHESIZED LATIN SMALL LETTER B",
	"PARENTHESIZED LATIN SMALL LETTER C",
	"PARENTHESIZED LATIN SMALL LETTER D",
	"PARENTHESIZED LATIN SMALL LETTER E",
	"PARENTHESIZED LATIN SMALL LETTER F",
	"PARENTHESIZED LATIN SMALL LETTER G",
	"PARENTHESIZED LATIN SMALL LETTER H",
	"PARENTHESIZED LATIN SMALL LETTER I",
	"PARENTHESIZED LATIN SMALL LETTER J",
	"PARENTHESIZED LATIN SMALL LETTER K",
	"PARENTHESIZED LATIN SMALL LETTER L",
	"PARENTHESIZED LATIN SMALL LETTER M",
	"PARENTHESIZED LATIN SMALL LETTER N",
	"PARENTHESIZED LATIN SMALL LETTER O",
	"PARENTHESIZED LATIN SMALL LETTER P",
	"PARENTHESIZED LATIN SMALL LETTER Q",
	"PARENTHESIZED LATIN SMALL LETTER R",
	"PARENTHESIZED LATIN SMALL LETTER S",
	"PARENTHESIZED LATIN SMALL LETTER T",
	"PARENTHESIZED LATIN SMALL LETTER U",
	"PARENTHESIZED LATIN SMALL LETTER V",
	"PARENTHESIZED LATIN SMALL LETTER W",
	"PARENTHESIZED LATIN SMALL LETTER X",
	"PARENTHESIZED LATIN SMALL LETTER Y",
	"PARENTHESIZED LATIN SMALL LETTER Z",
	"PARENTHESIZED NUMBER EIGHTEEN",
	"PARENTHESIZED NUMBER ELEVEN",
	"PARENTHESIZED NUMBER FIFTEEN",
	"PARENTHESIZED NUMBER FOURTEEN",
	"PARENTHESIZED NUMBER NINETEEN",
	"PARENTHESIZED NUMBER SEVENTEEN",
	"PARENTHESIZED NUMBER SIXTEEN",
	"PARENTHESIZED NUMBER TEN",
	"PARENTHESIZED NUMBER THIRTEEN",
	"PARENTHESIZED NUMBER TWELVE",
	"PARENTHESIZED NUMBER TWENTY",
	"PART ALTERNATION MARK",
	"PARTIAL DIFFERENTIAL",
	"PARTIALLY-RECYCLED PAPER SYMBOL",
	"PARTNERSHIP SIGN",
	"PARTY POPPER",
	"PASSIVE-PULL-DOWN-OUTPUT SYMBOL",
	"PASSIVE-PULL-UP-OUTPUT SYMBOL",
	"PASSPORT CONTROL",
	"PAW PRINTS",
	"PEACE SYMBOL",
	"PEACH",
	"PEAR",
	"PEDESTRIAN",
	"PENCIL",
	"PENGUIN",
	"PENSIVE FACE",
	"PENTAGRAM",
	"PER MILLE SIGN",
	"PER SIGN",
	"PER TEN THOUSAND SIGN",
	"PERCENT SIGN",
	"PERFORMING ARTS",
	"PERMANENT PAPER SIGN",
	"PERPENDICULAR",
	"PERPENDICULAR WITH S",
	"PERSEVERING FACE",
	"PERSON BOWING DEEPLY",
	"PERSON FROWNING",
	"PERSON RAISING BOTH HANDS IN CELEBRATION",
	"PERSON WITH BALL",
	"PERSON WITH BLOND HAIR",
	"PERSON WITH FOLDED HANDS",
	"PERSON WITH POUTING FACE",
	"PERSONAL COMPUTER",
	"PERSPECTIVE",
	"PESETA SIGN",
	"PESO SIGN",
	"PHAGS-PA DOUBLE HEAD MARK",
	"PHAGS-PA LETTER A",
	"PHAGS-PA LETTER ALTERNATE YA",
	"PHAGS-PA LETTER ASPIRATED FA",
	"PHAGS-PA LETTER BA",
	"PHAGS-PA LETTER CA",
	"PHAGS-PA LETTER CANDRABINDU",
	"PHAGS-PA LETTER CHA",
	"PHAGS-PA LETTER DA",
	"PHAGS-PA LETTER DDA",
	"PHAGS-PA LETTER DZA",
	"PHAGS-PA LETTER E",
	"PHAGS-PA LETTER EE",
	"PHAGS-PA LETTER FA",
	"PHAGS-PA LETTER GA",
	"PHAGS-PA LETTER GGA",
	"PHAGS-PA LETTER HA",
	"PHAGS-PA LETTER I",
	"PHAGS-PA LETTER JA",
	"PHAGS-PA LETTER KA",
	"PHAGS-PA LETTER KHA",
	"PHAGS-PA LETTER LA",
	"PHAGS-PA LETTER MA",
	"PHAGS-PA LETTER NA",
	"PHAGS-PA LETTER NGA",
	"PHAGS-PA LETTER NNA",
	"PHAGS-PA LETTER NYA",
	"PHAGS-PA LETTER O",
	"PHAGS-PA LETTER PA",
	"PHAGS-PA LETTER PHA",
	"PHAGS-PA LETTER QA",
	"PHAGS-PA LETTER RA",
	"PHAGS-PA LETTER SA",
	"PHAGS-PA LETTER SHA",
	"PHAGS-PA LETTER SMALL A",
	"PHAGS-PA LETTER TA",
	"PHAGS-PA LETTER THA",
	"PHAGS-PA LETTER TSA",
	"PHAGS-PA LETTER TSHA",
	"PHAGS-PA LETTER TTA",
	"PHAGS-PA LETTER TTHA",
	"PHAGS-PA LETTER U",
	"PHAGS-PA LETTER VOICED HA",
	"PHAGS-PA LETTER VOICELESS SHA",
	"PHAGS-PA LETTER WA",
	"PHAGS-PA LETTER XA",
	"PHAGS-PA LETTER YA",
	"PHAGS-PA LETTER ZA",
	"PHAGS-PA LETTER ZHA",
	"PHAGS-PA MARK DOUBLE SHAD",
	"PHAGS-PA MARK SHAD",
	"PHAGS-PA SINGLE HEAD MARK",
	"PHAGS-PA SUBJOINED LETTER RA",
	"PHAGS-PA SUBJOINED LETTER WA",
	"PHAGS-PA SUBJOINED LETTER YA",
	"PHAGS-PA SUPERFIXED LETTER RA",
	"PHAISTOS DISC SIGN ARROW",
	"PHAISTOS DISC SIGN BEE",
	"PHAISTOS DISC SIGN BEEHIVE",
	"PHAISTOS DISC SIGN BOOMERANG",
	"PHAISTOS DISC SIGN BOW",
	"PHAISTOS DISC SIGN BULLS LEG",
	"PHAISTOS DISC SIGN CAPTIVE",
	"PHAISTOS DISC SIGN CARPENTRY PLANE",
	"PHAISTOS DISC SIGN CAT",
	"PHAISTOS DISC SIGN CHILD",
	"PHAISTOS DISC SIGN CLUB",
	"PHAISTOS DISC SIGN COLUMN",
	"PHAISTOS DISC SIGN COMB",
	"PHAISTOS DISC SIGN COMBINING OBLIQUE STROKE",
	"PHAISTOS DISC SIGN DOLIUM",
	"PHAISTOS DISC SIGN DOVE",
	"PHAISTOS DISC SIGN EAGLE",
	"PHAISTOS DISC SIGN FLUTE",
	"PHAISTOS DISC SIGN GAUNTLET",
	"PHAISTOS DISC SIGN GRATER",
	"PHAISTOS DISC SIGN HELMET",
	"PHAISTOS DISC SIGN HIDE",
	"PHAISTOS DISC SIGN HORN",
	"PHAISTOS DISC SIGN LID",
	"PHAISTOS DISC SIGN LILY",
	"PHAISTOS DISC SIGN MANACLES",
	"PHAISTOS DISC SIGN MATTOCK",
	"PHAISTOS DISC SIGN OX BACK",
	"PHAISTOS DISC SIGN PAPYRUS",
	"PHAISTOS DISC SIGN PEDESTRIAN",
	"PHAISTOS DISC SIGN PLANE TREE",
	"PHAISTOS DISC SIGN PLUMED HEAD",
	"PHAISTOS DISC SIGN RAM",
	"PHAISTOS DISC SIGN ROSETTE",
	"PHAISTOS DISC SIGN SAW",
	"PHAISTOS DISC SIGN SHIELD",
	"PHAISTOS DISC SIGN SHIP",
	"PHAISTOS DISC SIGN SLING",
	"PHAISTOS DISC SIGN SMALL AXE",
	"PHAISTOS DISC SIGN STRAINER",
	"PHAISTOS DISC SIGN TATTOOED HEAD",
	"PHAISTOS DISC SIGN TIARA",
	"PHAISTOS DISC SIGN TUNNY",
	"PHAISTOS DISC SIGN VINE",
	"PHAISTOS DISC SIGN WAVY BAND",
	"PHAISTOS DISC SIGN WOMAN",
	"PHILIPPINE DOUBLE PUNCTUATION",
	"PHILIPPINE SINGLE PUNCTUATION",
	"PHOENICIAN LETTER AIN",
	"PHOENICIAN LETTER ALF",
	"PHOENICIAN LETTER BET",
	"PHOENICIAN LETTER DELT",
	"PHOENICIAN LETTER GAML",
	"PHOENICIAN LETTER HE",
	"PHOENICIAN LETTER HET",
	"PHOENICIAN LETTER KAF",
	"PHOENICIAN LETTER LAMD",
	"PHOENICIAN LETTER MEM",
	"PHOENICIAN LETTER NUN",
	"PHOENICIAN LETTER PE",
	"PHOENICIAN LETTER QOF",
	"PHOENICIAN LETTER ROSH",
	"PHOENICIAN LETTER SADE",
	"PHOENICIAN LETTER SEMK",
	"PHOENICIAN LETTER SHIN",
	"PHOENICIAN LETTER TAU",
	"PHOENICIAN LETTER TET",
	"PHOENICIAN LETTER WAU",
	"PHOENICIAN LETTER YOD",
	"PHOENICIAN LETTER ZAI",
	"PHOENICIAN NUMBER ONE",
	"PHOENICIAN NUMBER ONE HUNDRED",
	"PHOENICIAN NUMBER TEN",
	"PHOENICIAN NUMBER THREE",
	"PHOENICIAN NUMBER TWENTY",
	"PHOENICIAN NUMBER TWO",
	"PHOENICIAN WORD SEPARATOR",
	"PICK",
	"PIG",
	"PIG FACE",
	"PIG NOSE",
	"PILCROW SIGN",
	"PILE OF POO",
	"PILL",
	"PINE DECORATION",
	"PINEAPPLE",
	"PINWHEEL STAR",
	"PISCES",
	"PISTOL",
	"PITCHFORK",
	"PITCHFORK WITH TEE TOP",
	"PLACE OF INTEREST SIGN",
	"PLANCK CONSTANT",
	"PLANCK CONSTANT OVER TWO PI",
	"PLAYING CARD ACE OF CLUBS",
	"PLAYING CARD ACE OF DIAMONDS",
	"PLAYING CARD ACE OF HEARTS",
	"PLAYING CARD ACE OF SPADES",
	"PLAYING CARD BACK",
	"PLAYING CARD BLACK JOKER",
	"PLAYING CARD EIGHT OF CLUBS",
	"PLAYING CARD EIGHT OF DIAMONDS",
	"PLAYING CARD EIGHT OF HEARTS",
	"PLAYING CARD EIGHT OF SPADES",
	"PLAYING CARD FIVE OF CLUBS",
	"PLAYING CARD FIVE OF DIAMONDS",
	"PLAYING CARD FIVE OF HEARTS",
	"PLAYING CARD FIVE OF SPADES",
	"PLAYING CARD FOUR OF CLUBS",
	"PLAYING CARD FOUR OF DIAMONDS",
	"PLAYING CARD FOUR OF HEARTS",
	"PLAYING CARD FOUR OF SPADES",
	"PLAYING CARD JACK OF CLUBS",
	"PLAYING CARD JACK OF DIAMONDS",
	"PLAYING CARD JACK OF HEARTS",
	"PLAYING CARD JACK OF SPADES",
	"PLAYING CARD KING OF CLUBS",
	"PLAYING CARD KING OF DIAMONDS",
	"PLAYING CARD KING OF HEARTS",
	"PLAYING CARD KING OF SPADES",
	"PLAYING CARD KNIGHT OF CLUBS",
	"PLAYING CARD KNIGHT OF DIAMONDS",
	"PLAYING CARD KNIGHT OF HEARTS",
	"PLAYING CARD KNIGHT OF SPADES",
	"PLAYING CARD NINE OF CLUBS",
	"PLAYING CARD NINE OF DIAMONDS",
	"PLAYING CARD NINE OF HEARTS",
	"PLAYING CARD NINE OF SPADES",
	"PLAYING CARD QUEEN OF CLUBS",
	"PLAYING CARD QUEEN OF DIAMONDS",
	"PLAYING CARD QUEEN OF HEARTS",
	"PLAYING CARD QUEEN OF SPADES",
	"PLAYING CARD SEVEN OF CLUBS",
	"PLAYING CARD SEVEN OF DIAMONDS",
	"PLAYING CARD SEVEN OF HEARTS",
	"PLAYING CARD SEVEN OF SPADES",
	"PLAYING CARD SIX OF CLUBS",
	"PLAYING CARD SIX OF DIAMONDS",
	"PLAYING CARD SIX OF HEARTS",
	"PLAYING CARD SIX OF SPADES",
	"PLAYING CARD TEN OF CLUBS",
	"PLAYING CARD TEN OF DIAMONDS",
	"PLAYING CARD TEN OF HEARTS",
	"PLAYING CARD TEN OF SPADES",
	"PLAYING CARD THREE OF CLUBS",
	"PLAYING CARD THREE OF DIAMONDS",
	"PLAYING CARD THREE OF HEARTS",
	"PLAYING CARD THREE OF SPADES",
	"PLAYING CARD TWO OF CLUBS",
	"PLAYING CARD TWO OF DIAMONDS",
	"PLAYING CARD TWO OF HEARTS",
	"PLAYING CARD TWO OF SPADES",
	"PLAYING CARD WHITE JOKER",
	"PLUS SIGN",
	"PLUS SIGN ABOVE EQUALS SIGN",
	"PLUS SIGN IN LEFT HALF CIRCLE",
	"PLUS SIGN IN RIGHT HALF CIRCLE",
	"PLUS SIGN IN TRIANGLE",
	"PLUS SIGN WITH BLACK TRIANGLE",
	"PLUS SIGN WITH CIRCUMFLEX ACCENT ABOVE",
	"PLUS SIGN WITH DOT BELOW",
	"PLUS SIGN WITH SMALL CIRCLE ABOVE",
	"PLUS SIGN WITH SUBSCRIPT TWO",
	"PLUS SIGN WITH TILDE ABOVE",
	"PLUS SIGN WITH TILDE BELOW",
	"PLUS-MINUS SIGN",
	"PLUTO",
	"POLICE CAR",
	"POLICE CARS REVOLVING LIGHT",
	"POLICE OFFICER",
	"POODLE",
	"POP DIRECTIONAL FORMATTING",
	"POP DIRECTIONAL ISOLATE",
	"POSITION INDICATOR",
	"POSTAL HORN",
	"POSTAL MARK",
	"POSTAL MARK FACE",
	"POSTBOX",
	"POT OF FOOD",
	"POTABLE WATER SYMBOL",
	"POUCH",
	"POULTRY LEG",
	"POUND SIGN",
	"POUTING CAT FACE",
	"POUTING FACE",
	"PRECEDES",
	"PRECEDES ABOVE ALMOST EQUAL TO",
	"PRECEDES ABOVE EQUALS SIGN",
	"PRECEDES ABOVE NOT ALMOST EQUAL TO",
	"PRECEDES ABOVE NOT EQUAL TO",
	"PRECEDES ABOVE SINGLE-LINE EQUALS SIGN",
	"PRECEDES ABOVE SINGLE-LINE NOT EQUAL TO",
	"PRECEDES BUT NOT EQUIVALENT TO",
	"PRECEDES OR EQUAL TO",
	"PRECEDES OR EQUIVALENT TO",
	"PRECEDES UNDER RELATION",
	"PRESCRIPTION TAKE",
	"PRESENTATION FORM FOR VERTICAL COLON",
	"PRESENTATION FORM FOR VERTICAL COMMA",
	"PRESENTATION FORM FOR VERTICAL EM DASH",
	"PRESENTATION FORM FOR VERTICAL EN DASH",
	"PRESENTATION FORM FOR VERTICAL EXCLAMATION MARK",
	"PRESENTATION FORM FOR VERTICAL HORIZONTAL ELLIPSIS",
	"PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC COMMA",
	"PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC FULL STOP",
	"PRESENTATION FORM FOR VERTICAL LEFT ANGLE BRACKET",
	"PRESENTATION FORM FOR VERTICAL LEFT BLACK LENTICULAR BRACKET",
	"PRESENTATION FORM FOR VERTICAL LEFT CORNER BRACKET",
	"PRESENTATION FORM FOR VERTICAL LEFT CURLY BRACKET",
	"PRESENTATION FORM FOR VERTICAL LEFT DOUBLE ANGLE BRACKET",
	"PRESENTATION FORM FOR VERTICAL LEFT PARENTHESIS",
	"PRESENTATION FORM FOR VERTICAL LEFT SQUARE BRACKET",
	"PRESENTATION FORM FOR VERTICAL LEFT TORTOISE SHELL BRACKET",
	"PRESENTATION FORM FOR VERTICAL LEFT WHITE CORNER BRACKET",
	"PRESENTATION FORM FOR VERTICAL LEFT WHITE LENTICULAR BRACKET",
	"PRESENTATION FORM FOR VERTICAL LOW LINE",
	"PRESENTATION FORM FOR VERTICAL QUESTION MARK",
	"PRESENTATION FORM FOR VERTICAL RIGHT ANGLE BRACKET",
	"PRESENTATION FORM FOR VERTICAL RIGHT BLACK LENTICULAR BRACKET",
	"PRESENTATION FORM FOR VERTICAL RIGHT CORNER BRACKET",
	"PRESENTATION FORM FOR VERTICAL RIGHT CURLY BRACKET",
	"PRESENTATION FORM FOR VERTICAL RIGHT DOUBLE ANGLE BRACKET",
	"PRESENTATION FORM FOR VERTICAL RIGHT PARENTHESIS",
	"PRESENTATION FORM FOR VERTICAL RIGHT SQUARE BRACKET",
	"PRESENTATION FORM FOR VERTICAL RIGHT TORTOISE SHELL BRACKET",
	"PRESENTATION FORM FOR VERTICAL RIGHT WHITE CORNER BRACKET",
	"PRESENTATION FORM FOR VERTICAL RIGHT WHITE LENTICULAR BRAKCET",
	"PRESENTATION FORM FOR VERTICAL SEMICOLON",
	"PRESENTATION FORM FOR VERTICAL TWO DOT LEADER",
	"PRESENTATION FORM FOR VERTICAL WAVY LOW LINE",
	"PREVIOUS PAGE",
	"PRIME",
	"PRINCESS",
	"PRINT SCREEN SYMBOL",
	"PROJECTIVE",
	"PROPERTY LINE",
	"PROPORTION",
	"PROPORTIONAL TO",
	"PUBLIC ADDRESS LOUDSPEAKER",
	"PUNCTUATION SPACE",
	"PURPLE HEART",
	"PURSE",
	"PUSHPIN",
	"PUT LITTER IN ITS PLACE SYMBOL",
	"QUADRANT LOWER LEFT",
	"QUADRANT LOWER RIGHT",
	"QUADRANT UPPER LEFT",
	"QUADRANT UPPER LEFT AND LOWER LEFT AND LOWER RIGHT",
	"QUADRANT UPPER LEFT AND LOWER RIGHT",
	"QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER LEFT",
	"QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER RIGHT",
	"QUADRANT UPPER RIGHT",
	"QUADRANT UPPER RIGHT AND LOWER LEFT",
	"QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT",
	"QUADRUPLE INTEGRAL OPERATOR",
	"QUADRUPLE PRIME",
	"QUARTER NOTE",
	"QUATERNION INTEGRAL OPERATOR",
	"QUESTION EXCLAMATION MARK",
	"QUESTION MARK",
	"QUESTIONED EQUAL TO",
	"QUINCUNX",
	"QUOTATION MARK",
	"RABBIT",
	"RABBIT FACE",
	"RADICAL SYMBOL BOTTOM",
	"RADIO",
	"RADIO BUTTON",
	"RADIOACTIVE SIGN",
	"RAILWAY CAR",
	"RAIN",
	"RAINBOW",
	"RAISED COMMA",
	"RAISED DOT",
	"RAISED DOTTED INTERPOLATION MARKER",
	"RAISED FIST",
	"RAISED HAND",
	"RAISED INTERPOLATION MARKER",
	"RAISED MC SIGN",
	"RAISED MD SIGN",
	"RAISED SQUARE",
	"RAM",
	"RAT",
	"RATIO",
	"RECREATIONAL VEHICLE",
	"RECYCLED PAPER SYMBOL",
	"RECYCLING SYMBOL FOR GENERIC MATERIALS",
	"RECYCLING SYMBOL FOR TYPE-1 PLASTICS",
	"RECYCLING SYMBOL FOR TYPE-2 PLASTICS",
	"RECYCLING SYMBOL FOR TYPE-3 PLASTICS",
	"RECYCLING SYMBOL FOR TYPE-4 PLASTICS",
	"RECYCLING SYMBOL FOR TYPE-5 PLASTICS",
	"RECYCLING SYMBOL FOR TYPE-6 PLASTICS",
	"RECYCLING SYMBOL FOR TYPE-7 PLASTICS",
	"RED APPLE",
	"REFERENCE MARK",
	"REGIONAL INDICATOR SYMBOL LETTER A",
	"REGIONAL INDICATOR SYMBOL LETTER B",
	"REGIONAL INDICATOR SYMBOL LETTER C",
	"REGIONAL INDICATOR SYMBOL LETTER D",
	"REGIONAL INDICATOR SYMBOL LETTER E",
	"REGIONAL INDICATOR SYMBOL LETTER F",
	"REGIONAL INDICATOR SYMBOL LETTER G",
	"REGIONAL INDICATOR SYMBOL LETTER H",
	"REGIONAL INDICATOR SYMBOL LETTER I",
	"REGIONAL INDICATOR SYMBOL LETTER J",
	"REGIONAL INDICATOR SYMBOL LETTER K",
	"REGIONAL INDICATOR SYMBOL LETTER L",
	"REGIONAL INDICATOR SYMBOL LETTER M",
	"REGIONAL INDICATOR SYMBOL LETTER N",
	"REGIONAL INDICATOR SYMBOL LETTER O",
	"REGIONAL INDICATOR SYMBOL LETTER P",
	"REGIONAL INDICATOR SYMBOL LETTER Q",
	"REGIONAL INDICATOR SYMBOL LETTER R",
	"REGIONAL INDICATOR SYMBOL LETTER S",
	"REGIONAL INDICATOR SYMBOL LETTER T",
	"REGIONAL INDICATOR SYMBOL LETTER U",
	"REGIONAL INDICATOR SYMBOL LETTER V",
	"REGIONAL INDICATOR SYMBOL LETTER W",
	"REGIONAL INDICATOR SYMBOL LETTER X",
	"REGIONAL INDICATOR SYMBOL LETTER Y",
	"REGIONAL INDICATOR SYMBOL LETTER Z",
	"REGISTERED SIGN",
	"REJANG CONSONANT SIGN H",
	"REJANG CONSONANT SIGN N",
	"REJANG CONSONANT SIGN NG",
	"REJANG CONSONANT SIGN R",
	"REJANG LETTER A",
	"REJANG LETTER BA",
	"REJANG LETTER CA",
	"REJANG LETTER DA",
	"REJANG LETTER GA",
	"REJANG LETTER HA",
	"REJANG LETTER JA",
	"REJANG LETTER KA",
	"REJANG LETTER LA",
	"REJANG LETTER MA",
	"REJANG LETTER MBA",
	"REJANG LETTER NA",
	"REJANG LETTER NDA",
	"REJANG LETTER NGA",
	"REJANG LETTER NGGA",
	"REJANG LETTER NYA",
	"REJANG LETTER NYJA",
	"REJANG LETTER PA",
	"REJANG LETTER RA",
	"REJANG LETTER SA",
	"REJANG LETTER TA",
	"REJANG LETTER WA",
	"REJANG LETTER YA",
	"REJANG SECTION MARK",
	"REJANG VIRAMA",
	"REJANG VOWEL SIGN AI",
	"REJANG VOWEL SIGN AU",
	"REJANG VOWEL SIGN E",
	"REJANG VOWEL SIGN EA",
	"REJANG VOWEL SIGN EU",
	"REJANG VOWEL SIGN I",
	"REJANG VOWEL SIGN O",
	"REJANG VOWEL SIGN U",
	"RELIEVED FACE",
	"REPLACEMENT CHARACTER",
	"RESPONSE",
	"RESTROOM",
	"RETURN SYMBOL",
	"REVERSE SOLIDUS",
	"REVERSE SOLIDUS OPERATOR",
	"REVERSE SOLIDUS PRECEDING SUBSET",
	"REVERSE SOLIDUS WITH HORIZONTAL STROKE",
	"REVERSE TILDE OPERATOR ABOVE LEFTWARDS ARROW",
	"REVERSE TILDE OPERATOR ABOVE RIGHTWARDS ARROW",
	"REVERSED ANGLE",
	"REVERSED ANGLE WITH UNDERBAR",
	"REVERSED DOUBLE PRIME",
	"REVERSED DOUBLE PRIME QUOTATION MARK",
	"REVERSED DOUBLE STROKE NOT SIGN",
	"REVERSED EMPTY SET",
	"REVERSED FORKED PARAGRAPHOS",
	"REVERSED NOT SIGN",
	"REVERSED PILCROW SIGN",
	"REVERSED PRIME",
	"REVERSED QUESTION MARK",
	"REVERSED ROTATED FLORAL HEART BULLET",
	"REVERSED SANS-SERIF CAPITAL L",
	"REVERSED SEMICOLON",
	"REVERSED TILDE",
	"REVERSED TILDE EQUALS",
	"REVERSED TRIPLE PRIME",
	"REVOLVING HEARTS",
	"RIAL SIGN",
	"RIBBON",
	"RICE BALL",
	"RICE CRACKER",
	"RIGHT ANGLE",
	"RIGHT ANGLE BRACKET",
	"RIGHT ANGLE BRACKET WITH DOT",
	"RIGHT ANGLE DOTTED SUBSTITUTION MARKER",
	"RIGHT ANGLE SUBSTITUTION MARKER",
	"RIGHT ANGLE VARIANT WITH SQUARE",
	"RIGHT ANGLE WITH ARC",
	"RIGHT ANGLE WITH DOWNWARDS ZIGZAG ARROW",
	"RIGHT ARC GREATER-THAN BRACKET",
	"RIGHT ARROW WITH CIRCLED PLUS",
	"RIGHT ARROW WITH SMALL CIRCLE",
	"RIGHT BLACK LENTICULAR BRACKET",
	"RIGHT BLACK TORTOISE SHELL BRACKET",
	"RIGHT CEILING",
	"RIGHT CORNER BRACKET",
	"RIGHT CURLY BRACKET",
	"RIGHT CURLY BRACKET LOWER HOOK",
	"RIGHT CURLY BRACKET MIDDLE PIECE",
	"RIGHT CURLY BRACKET UPPER HOOK",
	"RIGHT DOTTED SUBSTITUTION BRACKET",
	"RIGHT DOUBLE ANGLE BRACKET",
	"RIGHT DOUBLE ARROW WITH ROUNDED HEAD",
	"RIGHT DOUBLE PARENTHESIS",
	"RIGHT DOUBLE QUOTATION MARK",
	"RIGHT DOUBLE WIGGLY FENCE",
	"RIGHT FISH TAIL",
	"RIGHT FLOOR",
	"RIGHT HALF BLACK CIRCLE",
	"RIGHT HALF BLOCK",
	"RIGHT LOW PARAPHRASE BRACKET",
	"RIGHT NORMAL FACTOR SEMIDIRECT PRODUCT",
	"RIGHT ONE EIGHTH BLOCK",
	"RIGHT OUTER JOIN",
	"RIGHT PARENTHESIS",
	"RIGHT PARENTHESIS EXTENSION",
	"RIGHT PARENTHESIS LOWER HOOK",
	"RIGHT PARENTHESIS UPPER HOOK",
	"RIGHT RAISED OMISSION BRACKET",
	"RIGHT S-SHAPED BAG DELIMITER",
	"RIGHT SEMIDIRECT PRODUCT",
	"RIGHT SIDEWAYS U BRACKET",
	"RIGHT SINGLE QUOTATION MARK",
	"RIGHT SQUARE BRACKET",
	"RIGHT SQUARE BRACKET EXTENSION",
	"RIGHT SQUARE BRACKET LOWER CORNER",
	"RIGHT SQUARE BRACKET UPPER CORNER",
	"RIGHT SQUARE BRACKET WITH QUILL",
	"RIGHT SQUARE BRACKET WITH TICK IN BOTTOM CORNER",
	"RIGHT SQUARE BRACKET WITH TICK IN TOP CORNER",
	"RIGHT SQUARE BRACKET WITH UNDERBAR",
	"RIGHT SUBSTITUTION BRACKET",
	"RIGHT TACK",
	"RIGHT TORTOISE SHELL BRACKET",
	"RIGHT TRANSPOSITION BRACKET",
	"RIGHT TRIANGLE",
	"RIGHT TRIANGLE ABOVE LEFT TRIANGLE",
	"RIGHT VERTICAL BAR WITH QUILL",
	"RIGHT VERTICAL BOX LINE",
	"RIGHT WHITE CORNER BRACKET",
	"RIGHT WHITE CURLY BRACKET",
	"RIGHT WHITE LENTICULAR BRACKET",
	"RIGHT WHITE PARENTHESIS",
	"RIGHT WHITE SQUARE BRACKET",
	"RIGHT WHITE TORTOISE SHELL BRACKET",
	"RIGHT WIGGLY FENCE",
	"RIGHT-FACING SVASTI SIGN",
	"RIGHT-FACING SVASTI SIGN WITH DOTS",
	"RIGHT-HANDED INTERLACED PENTAGRAM",
	"RIGHT-POINTING ANGLE BRACKET",
	"RIGHT-POINTING CURVED ANGLE BRACKET",
	"RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK",
	"RIGHT-POINTING MAGNIFYING GLASS",
	"RIGHT-SHADED WHITE RIGHTWARDS ARROW",
	"RIGHT-SIDE ARC CLOCKWISE ARROW",
	"RIGHT-TO-LEFT EMBEDDING",
	"RIGHT-TO-LEFT ISOLATE",
	"RIGHT-TO-LEFT MARK",
	"RIGHT-TO-LEFT OVERRIDE",
	"RIGHTHAND INTERIOR PRODUCT",
	"RIGHTWARDS ARROW",
	"RIGHTWARDS ARROW ABOVE ALMOST EQUAL TO",
	"RIGHTWARDS ARROW ABOVE REVERSE ALMOST EQUAL TO",
	"RIGHTWARDS ARROW ABOVE REVERSE TILDE OPERATOR",
	"RIGHTWARDS ARROW ABOVE SHORT LEFTWARDS ARROW",
	"RIGHTWARDS ARROW ABOVE TILDE OPERATOR",
	"RIGHTWARDS ARROW FROM BAR",
	"RIGHTWARDS ARROW FROM BAR TO BLACK DIAMOND",
	"RIGHTWARDS ARROW OVER LEFTWARDS ARROW",
	"RIGHTWARDS ARROW THROUGH GREATER-THAN",
	"RIGHTWARDS ARROW THROUGH SUPERSET",
	"RIGHTWARDS ARROW THROUGH X",
	"RIGHTWARDS ARROW TO BAR",
	"RIGHTWARDS ARROW TO BLACK DIAMOND",
	"RIGHTWARDS ARROW WITH CORNER DOWNWARDS",
	"RIGHTWARDS ARROW WITH DOTTED STEM",
	"RIGHTWARDS ARROW WITH DOUBLE VERTICAL STROKE",
	"RIGHTWARDS ARROW WITH HOOK",
	"RIGHTWARDS ARROW WITH LOOP",
	"RIGHTWARDS ARROW WITH PLUS BELOW",
	"RIGHTWARDS ARROW WITH STROKE",
	"RIGHTWARDS ARROW WITH TAIL",
	"RIGHTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE",
	"RIGHTWARDS ARROW WITH TAIL WITH VERTICAL STROKE",
	"RIGHTWARDS ARROW WITH TIP DOWNWARDS",
	"RIGHTWARDS ARROW WITH TIP UPWARDS",
	"RIGHTWARDS ARROW WITH VERTICAL STROKE",
	"RIGHTWARDS ARROW-TAIL",
	"RIGHTWARDS DASHED ARROW",
	"RIGHTWARDS DOUBLE ARROW",
	"RIGHTWARDS DOUBLE ARROW FROM BAR",
	"RIGHTWARDS DOUBLE ARROW WITH STROKE",
	"RIGHTWARDS DOUBLE ARROW WITH VERTICAL STROKE",
	"RIGHTWARDS DOUBLE ARROW-TAIL",
	"RIGHTWARDS DOUBLE DASH ARROW",
	"RIGHTWARDS HARPOON OVER LEFTWARDS HARPOON",
	"RIGHTWARDS HARPOON WITH BARB DOWN ABOVE LEFTWARDS HARPOON WITH BARB DOWN",
	"RIGHTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH",
	"RIGHTWARDS HARPOON WITH BARB DOWN FROM BAR",
	"RIGHTWARDS HARPOON WITH BARB DOWN TO BAR",
	"RIGHTWARDS HARPOON WITH BARB DOWNWARDS",
	"RIGHTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB UP",
	"RIGHTWARDS HARPOON WITH BARB UP ABOVE LONG DASH",
	"RIGHTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB DOWN",
	"RIGHTWARDS HARPOON WITH BARB UP FROM BAR",
	"RIGHTWARDS HARPOON WITH BARB UP TO BAR",
	"RIGHTWARDS HARPOON WITH BARB UPWARDS",
	"RIGHTWARDS OPEN-HEADED ARROW",
	"RIGHTWARDS PAIRED ARROWS",
	"RIGHTWARDS QUADRUPLE ARROW",
	"RIGHTWARDS SQUIGGLE ARROW",
	"RIGHTWARDS TRIPLE ARROW",
	"RIGHTWARDS TRIPLE DASH ARROW",
	"RIGHTWARDS TWO HEADED ARROW",
	"RIGHTWARDS TWO-HEADED ARROW FROM BAR",
	"RIGHTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE",
	"RIGHTWARDS TWO-HEADED ARROW WITH TAIL",
	"RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE",
	"RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE",
	"RIGHTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE",
	"RIGHTWARDS TWO-HEADED TRIPLE DASH ARROW",
	"RIGHTWARDS WAVE ARROW",
	"RIGHTWARDS WHITE ARROW",
	"RIGHTWARDS WHITE ARROW FROM WALL",
	"RING",
	"RING ABOVE",
	"RING EQUAL TO",
	"RING IN EQUAL TO",
	"RING OPERATOR",
	"RING POINT",
	"RISING DIAGONAL CROSSING FALLING DIAGONAL",
	"RISING DIAGONAL CROSSING SOUTH EAST ARROW",
	"ROASTED SWEET POTATO",
	"ROCKET",
	"ROLLER COASTER",
	"ROMAN AS SIGN",
	"ROMAN CENTURIAL SIGN",
	"ROMAN DENARIUS SIGN",
	"ROMAN DIMIDIA SEXTULA SIGN",
	"ROMAN DUPONDIUS SIGN",
	"ROMAN NUMERAL EIGHT",
	"ROMAN NUMERAL ELEVEN",
	"ROMAN NUMERAL FIFTY",
	"ROMAN NUMERAL FIFTY EARLY FORM",
	"ROMAN NUMERAL FIFTY THOUSAND",
	"ROMAN NUMERAL FIVE",
	"ROMAN NUMERAL FIVE HUNDRED",
	"ROMAN NUMERAL FIVE THOUSAND",
	"ROMAN NUMERAL FOUR",
	"ROMAN NUMERAL NINE",
	"ROMAN NUMERAL ONE",
	"ROMAN NUMERAL ONE HUNDRED",
	"ROMAN NUMERAL ONE HUNDRED THOUSAND",
	"ROMAN NUMERAL ONE THOUSAND",
	"ROMAN NUMERAL ONE THOUSAND C D",
	"ROMAN NUMERAL REVERSED ONE HUNDRED",
	"ROMAN NUMERAL SEVEN",
	"ROMAN NUMERAL SIX",
	"ROMAN NUMERAL SIX LATE FORM",
	"ROMAN NUMERAL TEN",
	"ROMAN NUMERAL TEN THOUSAND",
	"ROMAN NUMERAL THREE",
	"ROMAN NUMERAL TWELVE",
	"ROMAN NUMERAL TWO",
	"ROMAN QUINARIUS SIGN",
	"ROMAN SEMUNCIA SIGN",
	"ROMAN SESTERTIUS SIGN",
	"ROMAN SEXTANS SIGN",
	"ROMAN SEXTULA SIGN",
	"ROMAN SILIQUA SIGN",
	"ROMAN UNCIA SIGN",
	"ROOSTER",
	"ROSE",
	"ROTATED CAPITAL Q",
	"ROTATED FLORAL HEART BULLET",
	"ROTATED HEAVY BLACK HEART BULLET",
	"ROUND PUSHPIN",
	"ROWBOAT",
	"RUGBY FOOTBALL",
	"RULE-DELAYED",
	"RUMI DIGIT EIGHT",
	"RUMI DIGIT FIVE",
	"RUMI DIGIT FOUR",
	"RUMI DIGIT NINE",
	"RUMI DIGIT ONE",
	"RUMI DIGIT SEVEN",
	"RUMI DIGIT SIX",
	"RUMI DIGIT THREE",
	"RUMI DIGIT TWO",
	"RUMI FRACTION ONE HALF",
	"RUMI FRACTION ONE QUARTER",
	"RUMI FRACTION ONE THIRD",
	"RUMI FRACTION TWO THIRDS",
	"RUMI NUMBER EIGHT HUNDRED",
	"RUMI NUMBER EIGHTY",
	"RUMI NUMBER FIFTY",
	"RUMI NUMBER FIVE HUNDRED",
	"RUMI NUMBER FORTY",
	"RUMI NUMBER FOUR HUNDRED",
	"RUMI NUMBER NINE HUNDRED",
	"RUMI NUMBER NINETY",
	"RUMI NUMBER ONE HUNDRED",
	"RUMI NUMBER SEVEN HUNDRED",
	"RUMI NUMBER SEVENTY",
	"RUMI NUMBER SIX HUNDRED",
	"RUMI NUMBER SIXTY",
	"RUMI NUMBER TEN",
	"RUMI NUMBER THIRTY",
	"RUMI NUMBER THREE HUNDRED",
	"RUMI NUMBER TWENTY",
	"RUMI NUMBER TWO HUNDRED",
	"RUNIC ARLAUG SYMBOL",
	"RUNIC BELGTHOR SYMBOL",
	"RUNIC CROSS PUNCTUATION",
	"RUNIC LETTER AC A",
	"RUNIC LETTER AESC",
	"RUNIC LETTER ALGIZ EOLHX",
	"RUNIC LETTER ANSUZ A",
	"RUNIC LETTER BERKANAN BEORC BJARKAN B",
	"RUNIC LETTER C",
	"RUNIC LETTER CALC",
	"RUNIC LETTER CEALC",
	"RUNIC LETTER CEN",
	"RUNIC LETTER CWEORTH",
	"RUNIC LETTER D",
	"RUNIC LETTER DAGAZ DAEG D",
	"RUNIC LETTER DOTTED-L",
	"RUNIC LETTER DOTTED-N",
	"RUNIC LETTER DOTTED-P",
	"RUNIC LETTER E",
	"RUNIC LETTER EAR",
	"RUNIC LETTER EHWAZ EH E",
	"RUNIC LETTER ENG",
	"RUNIC LETTER ETH",
	"RUNIC LETTER FEHU FEOH FE F",
	"RUNIC LETTER G",
	"RUNIC LETTER GAR",
	"RUNIC LETTER GEBO GYFU G",
	"RUNIC LETTER GER",
	"RUNIC LETTER HAEGL H",
	"RUNIC LETTER HAGLAZ H",
	"RUNIC LETTER ICELANDIC-YR",
	"RUNIC LETTER ING",
	"RUNIC LETTER INGWAZ",
	"RUNIC LETTER IOR",
	"RUNIC LETTER ISAZ IS ISS I",
	"RUNIC LETTER IWAZ EOH",
	"RUNIC LETTER JERAN J",
	"RUNIC LETTER KAUN K",
	"RUNIC LETTER KAUNA",
	"RUNIC LETTER LAUKAZ LAGU LOGR L",
	"RUNIC LETTER LONG-BRANCH-AR AE",
	"RUNIC LETTER LONG-BRANCH-HAGALL H",
	"RUNIC LETTER LONG-BRANCH-MADR M",
	"RUNIC LETTER LONG-BRANCH-OSS O",
	"RUNIC LETTER LONG-BRANCH-YR",
	"RUNIC LETTER MANNAZ MAN M",
	"RUNIC LETTER NAUDIZ NYD NAUD N",
	"RUNIC LETTER O",
	"RUNIC LETTER OE",
	"RUNIC LETTER ON",
	"RUNIC LETTER OPEN-P",
	"RUNIC LETTER OS O",
	"RUNIC LETTER OTHALAN ETHEL O",
	"RUNIC LETTER PERTHO PEORTH P",
	"RUNIC LETTER Q",
	"RUNIC LETTER RAIDO RAD REID R",
	"RUNIC LETTER SHORT-TWIG-AR A",
	"RUNIC LETTER SHORT-TWIG-BJARKAN B",
	"RUNIC LETTER SHORT-TWIG-HAGALL H",
	"RUNIC LETTER SHORT-TWIG-MADR M",
	"RUNIC LETTER SHORT-TWIG-NAUD N",
	"RUNIC LETTER SHORT-TWIG-OSS O",
	"RUNIC LETTER SHORT-TWIG-SOL S",
	"RUNIC LETTER SHORT-TWIG-TYR T",
	"RUNIC LETTER SHORT-TWIG-YR",
	"RUNIC LETTER SIGEL LONG-BRANCH-SOL S",
	"RUNIC LETTER SOWILO S",
	"RUNIC LETTER STAN",
	"RUNIC LETTER THURISAZ THURS THORN",
	"RUNIC LETTER TIWAZ TIR TYR T",
	"RUNIC LETTER URUZ UR U",
	"RUNIC LETTER V",
	"RUNIC LETTER W",
	"RUNIC LETTER WUNJO WYNN W",
	"RUNIC LETTER X",
	"RUNIC LETTER Y",
	"RUNIC LETTER YR",
	"RUNIC LETTER Z",
	"RUNIC MULTIPLE PUNCTUATION",
	"RUNIC SINGLE PUNCTUATION",
	"RUNIC TVIMADUR SYMBOL",
	"RUNNER",
	"RUNNING SHIRT WITH SASH",
	"RUPEE SIGN",
	"S IN TRIANGLE",
	"SAGITTARIUS",
	"SAILBOAT",
	"SAKE BOTTLE AND CUP",
	"SALTIRE",
	"SAMARITAN ABBREVIATION MARK",
	"SAMARITAN LETTER ALAF",
	"SAMARITAN LETTER BAA",
	"SAMARITAN LETTER BIT",
	"SAMARITAN LETTER DALAT",
	"SAMARITAN LETTER FI",
	"SAMARITAN LETTER GAMAN",
	"SAMARITAN LETTER IN",
	"SAMARITAN LETTER IT",
	"SAMARITAN LETTER IY",
	"SAMARITAN LETTER KAAF",
	"SAMARITAN LETTER LABAT",
	"SAMARITAN LETTER MIM",
	"SAMARITAN LETTER NUN",
	"SAMARITAN LETTER QUF",
	"SAMARITAN LETTER RISH",
	"SAMARITAN LETTER SHAN",
	"SAMARITAN LETTER SINGAAT",
	"SAMARITAN LETTER TAAF",
	"SAMARITAN LETTER TIT",
	"SAMARITAN LETTER TSAADIY",
	"SAMARITAN LETTER YUT",
	"SAMARITAN LETTER ZEN",
	"SAMARITAN MARK DAGESH",
	"SAMARITAN MARK EPENTHETIC YUT",
	"SAMARITAN MARK IN",
	"SAMARITAN MARK IN-ALAF",
	"SAMARITAN MARK NEQUDAA",
	"SAMARITAN MARK OCCLUSION",
	"SAMARITAN MODIFIER LETTER EPENTHETIC YUT",
	"SAMARITAN MODIFIER LETTER I",
	"SAMARITAN MODIFIER LETTER SHORT A",
	"SAMARITAN PUNCTUATION AFSAAQ",
	"SAMARITAN PUNCTUATION ANGED",
	"SAMARITAN PUNCTUATION ANNAAU",
	"SAMARITAN PUNCTUATION ARKAANU",
	"SAMARITAN PUNCTUATION ATMAAU",
	"SAMARITAN PUNCTUATION BAU",
	"SAMARITAN PUNCTUATION MELODIC QITSA",
	"SAMARITAN PUNCTUATION NEQUDAA",
	"SAMARITAN PUNCTUATION QITSA",
	"SAMARITAN PUNCTUATION SHIYYAALAA",
	"SAMARITAN PUNCTUATION SOF MASHFAAT",
	"SAMARITAN PUNCTUATION TURU",
	"SAMARITAN PUNCTUATION ZAEF",
	"SAMARITAN PUNCTUATION ZIQAA",
	"SAMARITAN VOWEL SIGN A",
	"SAMARITAN VOWEL SIGN AA",
	"SAMARITAN VOWEL SIGN E",
	"SAMARITAN VOWEL SIGN I",
	"SAMARITAN VOWEL SIGN LONG A",
	"SAMARITAN VOWEL SIGN LONG AA",
	"SAMARITAN VOWEL SIGN LONG E",
	"SAMARITAN VOWEL SIGN LONG I",
	"SAMARITAN VOWEL SIGN LONG U",
	"SAMARITAN VOWEL SIGN O",
	"SAMARITAN VOWEL SIGN OVERLONG A",
	"SAMARITAN VOWEL SIGN OVERLONG AA",
	"SAMARITAN VOWEL SIGN SHORT A",
	"SAMARITAN VOWEL SIGN SUKUN",
	"SAMARITAN VOWEL SIGN U",
	"SATELLITE ANTENNA",
	"SATURN",
	"SAURASHTRA CONSONANT SIGN HAARU",
	"SAURASHTRA DANDA",
	"SAURASHTRA DIGIT EIGHT",
	"SAURASHTRA DIGIT FIVE",
	"SAURASHTRA DIGIT FOUR",
	"SAURASHTRA DIGIT NINE",
	"SAURASHTRA DIGIT ONE",
	"SAURASHTRA DIGIT SEVEN",
	"SAURASHTRA DIGIT SIX",
	"SAURASHTRA DIGIT THREE",
	"SAURASHTRA DIGIT TWO",
	"SAURASHTRA DIGIT ZERO",
	"SAURASHTRA DOUBLE DANDA",
	"SAURASHTRA LETTER A",
	"SAURASHTRA LETTER AA",
	"SAURASHTRA LETTER AI",
	"SAURASHTRA LETTER AU",
	"SAURASHTRA LETTER BA",
	"SAURASHTRA LETTER BHA",
	"SAURASHTRA LETTER CA",
	"SAURASHTRA LETTER CHA",
	"SAURASHTRA LETTER DA",
	"SAURASHTRA LETTER DDA",
	"SAURASHTRA LETTER DDHA",
	"SAURASHTRA LETTER DHA",
	"SAURASHTRA LETTER E",
	"SAURASHTRA LETTER EE",
	"SAURASHTRA LETTER GA",
	"SAURASHTRA LETTER GHA",
	"SAURASHTRA LETTER HA",
	"SAURASHTRA LETTER I",
	"SAURASHTRA LETTER II",
	"SAURASHTRA LETTER JA",
	"SAURASHTRA LETTER JHA",
	"SAURASHTRA LETTER KA",
	"SAURASHTRA LETTER KHA",
	"SAURASHTRA LETTER LA",
	"SAURASHTRA LETTER LLA",
	"SAURASHTRA LETTER MA",
	"SAURASHTRA LETTER NA",
	"SAURASHTRA LETTER NGA",
	"SAURASHTRA LETTER NNA",
	"SAURASHTRA LETTER NYA",
	"SAURASHTRA LETTER O",
	"SAURASHTRA LETTER OO",
	"SAURASHTRA LETTER PA",
	"SAURASHTRA LETTER PHA",
	"SAURASHTRA LETTER RA",
	"SAURASHTRA LETTER SA",
	"SAURASHTRA LETTER SHA",
	"SAURASHTRA LETTER SSA",
	"SAURASHTRA LETTER TA",
	"SAURASHTRA LETTER THA",
	"SAURASHTRA LETTER TTA",
	"SAURASHTRA LETTER TTHA",
	"SAURASHTRA LETTER U",
	"SAURASHTRA LETTER UU",
	"SAURASHTRA LETTER VA",
	"SAURASHTRA LETTER VOCALIC L",
	"SAURASHTRA LETTER VOCALIC LL",
	"SAURASHTRA LETTER VOCALIC R",
	"SAURASHTRA LETTER VOCALIC RR",
	"SAURASHTRA LETTER YA",
	"SAURASHTRA SIGN ANUSVARA",
	"SAURASHTRA SIGN VIRAMA",
	"SAURASHTRA SIGN VISARGA",
	"SAURASHTRA VOWEL SIGN AA",
	"SAURASHTRA VOWEL SIGN AI",
	"SAURASHTRA VOWEL SIGN AU",
	"SAURASHTRA VOWEL SIGN E",
	"SAURASHTRA VOWEL SIGN EE",
	"SAURASHTRA VOWEL SIGN I",
	"SAURASHTRA VOWEL SIGN II",
	"SAURASHTRA VOWEL SIGN O",
	"SAURASHTRA VOWEL SIGN OO",
	"SAURASHTRA VOWEL SIGN U",
	"SAURASHTRA VOWEL SIGN UU",
	"SAURASHTRA VOWEL SIGN VOCALIC L",
	"SAURASHTRA VOWEL SIGN VOCALIC LL",
	"SAURASHTRA VOWEL SIGN VOCALIC R",
	"SAURASHTRA VOWEL SIGN VOCALIC RR",
	"SAXOPHONE",
	"SCALES",
	"SCHOOL",
	"SCHOOL SATCHEL",
	"SCORPIUS",
	"SCRIPT CAPITAL B",
	"SCRIPT CAPITAL E",
	"SCRIPT CAPITAL F",
	"SCRIPT CAPITAL H",
	"SCRIPT CAPITAL I",
	"SCRIPT CAPITAL L",
	"SCRIPT CAPITAL M",
	"SCRIPT CAPITAL P",
	"SCRIPT CAPITAL R",
	"SCRIPT SMALL E",
	"SCRIPT SMALL G",
	"SCRIPT SMALL L",
	"SCRIPT SMALL O",
	"SCROLL",
	"SCRUPLE",
	"SEAT",
	"SECTION SIGN",
	"SECTOR",
	"SEE-NO-EVIL MONKEY",
	"SEEDLING",
	"SEGMENT",
	"SEMICOLON",
	"SEMIDIRECT PRODUCT WITH BOTTOM CLOSED",
	"SEMISEXTILE",
	"SERVICE MARK",
	"SESAME DOT",
	"SESQUIQUADRATE",
	"SET MINUS",
	"SEXTILE",
	"SHADOWED WHITE CIRCLE",
	"SHADOWED WHITE LATIN CROSS",
	"SHADOWED WHITE STAR",
	"SHAMROCK",
	"SHARADA ABBREVIATION SIGN",
	"SHARADA DANDA",
	"SHARADA DIGIT EIGHT",
	"SHARADA DIGIT FIVE",
	"SHARADA DIGIT FOUR",
	"SHARADA DIGIT NINE",
	"SHARADA DIGIT ONE",
	"SHARADA DIGIT SEVEN",
	"SHARADA DIGIT SIX",
	"SHARADA DIGIT THREE",
	"SHARADA DIGIT TWO",
	"SHARADA DIGIT ZERO",
	"SHARADA DOUBLE DANDA",
	"SHARADA LETTER A",
	"SHARADA LETTER AA",
	"SHARADA LETTER AI",
	"SHARADA LETTER AU",
	"SHARADA LETTER BA",
	"SHARADA LETTER BHA",
	"SHARADA LETTER CA",
	"SHARADA LETTER CHA",
	"SHARADA LETTER DA",
	"SHARADA LETTER DDA",
	"SHARADA LETTER DDHA",
	"SHARADA LETTER DHA",
	"SHARADA LETTER E",
	"SHARADA LETTER GA",
	"SHARADA LETTER GHA",
	"SHARADA LETTER HA",
	"SHARADA LETTER I",
	"SHARADA LETTER II",
	"SHARADA LETTER JA",
	"SHARADA LETTER JHA",
	"SHARADA LETTER KA",
	"SHARADA LETTER KHA",
	"SHARADA LETTER LA",
	"SHARADA LETTER LLA",
	"SHARADA LETTER MA",
	"SHARADA LETTER NA",
	"SHARADA LETTER NGA",
	"SHARADA LETTER NNA",
	"SHARADA LETTER NYA",
	"SHARADA LETTER O",
	"SHARADA LETTER PA",
	"SHARADA LETTER PHA",
	"SHARADA LETTER RA",
	"SHARADA LETTER SA",
	"SHARADA LETTER SHA",
	"SHARADA LETTER SSA",
	"SHARADA LETTER TA",
	"SHARADA LETTER THA",
	"SHARADA LETTER TTA",
	"SHARADA LETTER TTHA",
	"SHARADA LETTER U",
	"SHARADA LETTER UU",
	"SHARADA LETTER VA",
	"SHARADA LETTER VOCALIC L",
	"SHARADA LETTER VOCALIC LL",
	"SHARADA LETTER VOCALIC R",
	"SHARADA LETTER VOCALIC RR",
	"SHARADA LETTER YA",
	"SHARADA OM",
	"SHARADA SEPARATOR",
	"SHARADA SIGN ANUSVARA",
	"SHARADA SIGN AVAGRAHA",
	"SHARADA SIGN CANDRABINDU",
	"SHARADA SIGN JIHVAMULIYA",
	"SHARADA SIGN UPADHMANIYA",
	"SHARADA SIGN VIRAMA",
	"SHARADA SIGN VISARGA",
	"SHARADA VOWEL SIGN AA",
	"SHARADA VOWEL SIGN AI",
	"SHARADA VOWEL SIGN AU",
	"SHARADA VOWEL SIGN E",
	"SHARADA VOWEL SIGN I",
	"SHARADA VOWEL SIGN II",
	"SHARADA VOWEL SIGN O",
	"SHARADA VOWEL SIGN U",
	"SHARADA VOWEL SIGN UU",
	"SHARADA VOWEL SIGN VOCALIC L",
	"SHARADA VOWEL SIGN VOCALIC LL",
	"SHARADA VOWEL SIGN VOCALIC R",
	"SHARADA VOWEL SIGN VOCALIC RR",
	"SHAVED ICE",
	"SHAVIAN LETTER ADO",
	"SHAVIAN LETTER AGE",
	"SHAVIAN LETTER AH",
	"SHAVIAN LETTER AIR",
	"SHAVIAN LETTER ARE",
	"SHAVIAN LETTER ARRAY",
	"SHAVIAN LETTER ASH",
	"SHAVIAN LETTER AWE",
	"SHAVIAN LETTER BIB",
	"SHAVIAN LETTER CHURCH",
	"SHAVIAN LETTER DEAD",
	"SHAVIAN LETTER EAR",
	"SHAVIAN LETTER EAT",
	"SHAVIAN LETTER EGG",
	"SHAVIAN LETTER ERR",
	"SHAVIAN LETTER FEE",
	"SHAVIAN LETTER GAG",
	"SHAVIAN LETTER HA-HA",
	"SHAVIAN LETTER HUNG",
	"SHAVIAN LETTER IAN",
	"SHAVIAN LETTER ICE",
	"SHAVIAN LETTER IF",
	"SHAVIAN LETTER JUDGE",
	"SHAVIAN LETTER KICK",
	"SHAVIAN LETTER LOLL",
	"SHAVIAN LETTER MEASURE",
	"SHAVIAN LETTER MIME",
	"SHAVIAN LETTER NUN",
	"SHAVIAN LETTER OAK",
	"SHAVIAN LETTER OIL",
	"SHAVIAN LETTER ON",
	"SHAVIAN LETTER OOZE",
	"SHAVIAN LETTER OR",
	"SHAVIAN LETTER OUT",
	"SHAVIAN LETTER PEEP",
	"SHAVIAN LETTER ROAR",
	"SHAVIAN LETTER SO",
	"SHAVIAN LETTER SURE",
	"SHAVIAN LETTER THEY",
	"SHAVIAN LETTER THIGH",
	"SHAVIAN LETTER TOT",
	"SHAVIAN LETTER UP",
	"SHAVIAN LETTER VOW",
	"SHAVIAN LETTER WOE",
	"SHAVIAN LETTER WOOL",
	"SHAVIAN LETTER YEA",
	"SHAVIAN LETTER YEW",
	"SHAVIAN LETTER ZOO",
	"SHEEP",
	"SHINTO SHRINE",
	"SHIP",
	"SHOOTING STAR",
	"SHORT DOWN TACK",
	"SHORT DOWN TACK WITH OVERBAR",
	"SHORT LEFT TACK",
	"SHORT RIGHTWARDS ARROW ABOVE LEFTWARDS ARROW",
	"SHORT UP TACK",
	"SHORT UP TACK ABOVE SHORT DOWN TACK",
	"SHORT UP TACK WITH UNDERBAR",
	"SHORTCAKE",
	"SHOULDERED OPEN BOX",
	"SHOWER",
	"SHUFFLE PRODUCT",
	"SILHOUETTE OF JAPAN",
	"SIMILAR ABOVE GREATER-THAN ABOVE EQUALS SIGN",
	"SIMILAR ABOVE LESS-THAN ABOVE EQUALS SIGN",
	"SIMILAR MINUS SIMILAR",
	"SIMILAR OR GREATER-THAN",
	"SIMILAR OR LESS-THAN",
	"SINE WAVE",
	"SINGLE HIGH-REVERSED-9 QUOTATION MARK",
	"SINGLE LEFT-POINTING ANGLE QUOTATION MARK",
	"SINGLE LOW-9 QUOTATION MARK",
	"SINGLE RIGHT-POINTING ANGLE QUOTATION MARK",
	"SINHALA LETTER AAYANNA",
	"SINHALA LETTER AEEYANNA",
	"SINHALA LETTER AEYANNA",
	"SINHALA LETTER AIYANNA",
	"SINHALA LETTER ALPAPRAANA BAYANNA",
	"SINHALA LETTER ALPAPRAANA CAYANNA",
	"SINHALA LETTER ALPAPRAANA DAYANNA",
	"SINHALA LETTER ALPAPRAANA DDAYANNA",
	"SINHALA LETTER ALPAPRAANA GAYANNA",
	"SINHALA LETTER ALPAPRAANA JAYANNA",
	"SINHALA LETTER ALPAPRAANA KAYANNA",
	"SINHALA LETTER ALPAPRAANA PAYANNA",
	"SINHALA LETTER ALPAPRAANA TAYANNA",
	"SINHALA LETTER ALPAPRAANA TTAYANNA",
	"SINHALA LETTER AMBA BAYANNA",
	"SINHALA LETTER AUYANNA",
	"SINHALA LETTER AYANNA",
	"SINHALA LETTER DANTAJA LAYANNA",
	"SINHALA LETTER DANTAJA NAYANNA",
	"SINHALA LETTER DANTAJA SAYANNA",
	"SINHALA LETTER EEYANNA",
	"SINHALA LETTER EYANNA",
	"SINHALA LETTER FAYANNA",
	"SINHALA LETTER HAYANNA",
	"SINHALA LETTER IIYANNA",
	"SINHALA LETTER ILUUYANNA",
	"SINHALA LETTER ILUYANNA",
	"SINHALA LETTER IRUUYANNA",
	"SINHALA LETTER IRUYANNA",
	"SINHALA LETTER IYANNA",
	"SINHALA LETTER KANTAJA NAASIKYAYA",
	"SINHALA LETTER MAHAAPRAANA BAYANNA",
	"SINHALA LETTER MAHAAPRAANA CAYANNA",
	"SINHALA LETTER MAHAAPRAANA DAYANNA",
	"SINHALA LETTER MAHAAPRAANA DDAYANNA",
	"SINHALA LETTER MAHAAPRAANA GAYANNA",
	"SINHALA LETTER MAHAAPRAANA JAYANNA",
	"SINHALA LETTER MAHAAPRAANA KAYANNA",
	"SINHALA LETTER MAHAAPRAANA PAYANNA",
	"SINHALA LETTER MAHAAPRAANA TAYANNA",
	"SINHALA LETTER MAHAAPRAANA TTAYANNA",
	"SINHALA LETTER MAYANNA",
	"SINHALA LETTER MUURDHAJA LAYANNA",
	"SINHALA LETTER MUURDHAJA NAYANNA",
	"SINHALA LETTER MUURDHAJA SAYANNA",
	"SINHALA LETTER OOYANNA",
	"SINHALA LETTER OYANNA",
	"SINHALA LETTER RAYANNA",
	"SINHALA LETTER SANYAKA DAYANNA",
	"SINHALA LETTER SANYAKA DDAYANNA",
	"SINHALA LETTER SANYAKA GAYANNA",
	"SINHALA LETTER SANYAKA JAYANNA",
	"SINHALA LETTER TAALUJA NAASIKYAYA",
	"SINHALA LETTER TAALUJA SANYOOGA NAAKSIKYAYA",
	"SINHALA LETTER TAALUJA SAYANNA",
	"SINHALA LETTER UUYANNA",
	"SINHALA LETTER UYANNA",
	"SINHALA LETTER VAYANNA",
	"SINHALA LETTER YAYANNA",
	"SINHALA PUNCTUATION KUNDDALIYA",
	"SINHALA SIGN AL-LAKUNA",
	"SINHALA SIGN ANUSVARAYA",
	"SINHALA SIGN VISARGAYA",
	"SINHALA VOWEL SIGN AELA-PILLA",
	"SINHALA VOWEL SIGN DIGA AEDA-PILLA",
	"SINHALA VOWEL SIGN DIGA GAETTA-PILLA",
	"SINHALA VOWEL SIGN DIGA GAYANUKITTA",
	"SINHALA VOWEL SIGN DIGA IS-PILLA",
	"SINHALA VOWEL SIGN DIGA KOMBUVA",
	"SINHALA VOWEL SIGN DIGA PAA-PILLA",
	"SINHALA VOWEL SIGN GAETTA-PILLA",
	"SINHALA VOWEL SIGN GAYANUKITTA",
	"SINHALA VOWEL SIGN KETTI AEDA-PILLA",
	"SINHALA VOWEL SIGN KETTI IS-PILLA",
	"SINHALA VOWEL SIGN KETTI PAA-PILLA",
	"SINHALA VOWEL SIGN KOMBU DEKA",
	"SINHALA VOWEL SIGN KOMBUVA",
	"SINHALA VOWEL SIGN KOMBUVA HAA AELA-PILLA",
	"SINHALA VOWEL SIGN KOMBUVA HAA DIGA AELA-PILLA",
	"SINHALA VOWEL SIGN KOMBUVA HAA GAYANUKITTA",
	"SIX PETALLED BLACK AND WHITE FLORETTE",
	"SIX POINTED BLACK STAR",
	"SIX POINTED STAR WITH MIDDLE DOT",
	"SIX-PER-EM SPACE",
	"SIXTEEN POINTED ASTERISK",
	"SKI AND SKI BOOT",
	"SKIER",
	"SKULL",
	"SKULL AND CROSSBONES",
	"SLANTED EQUAL TO OR GREATER-THAN",
	"SLANTED EQUAL TO OR GREATER-THAN WITH DOT INSIDE",
	"SLANTED EQUAL TO OR LESS-THAN",
	"SLANTED EQUAL TO OR LESS-THAN WITH DOT INSIDE",
	"SLAVONIC ASTERISK",
	"SLEEPING FACE",
	"SLEEPING SYMBOL",
	"SLEEPY FACE",
	"SLICE OF PIZZA",
	"SLOPE",
	"SLOPING LARGE AND",
	"SLOPING LARGE OR",
	"SLOT MACHINE",
	"SMALL AMPERSAND",
	"SMALL ASTERISK",
	"SMALL BLUE DIAMOND",
	"SMALL COLON",
	"SMALL COMMA",
	"SMALL COMMERCIAL AT",
	"SMALL CONTAINS AS MEMBER",
	"SMALL CONTAINS WITH OVERBAR",
	"SMALL CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE",
	"SMALL DOLLAR SIGN",
	"SMALL ELEMENT OF",
	"SMALL ELEMENT OF WITH OVERBAR",
	"SMALL ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE",
	"SMALL EM DASH",
	"SMALL EQUALS SIGN",
	"SMALL EXCLAMATION MARK",
	"SMALL FULL STOP",
	"SMALL GREATER-THAN SIGN",
	"SMALL HYPHEN-MINUS",
	"SMALL IDEOGRAPHIC COMMA",
	"SMALL LEFT CURLY BRACKET",
	"SMALL LEFT PARENTHESIS",
	"SMALL LEFT TORTOISE SHELL BRACKET",
	"SMALL LESS-THAN SIGN",
	"SMALL NUMBER SIGN",
	"SMALL ORANGE DIAMOND",
	"SMALL PERCENT SIGN",
	"SMALL PLUS SIGN",
	"SMALL QUESTION MARK",
	"SMALL REVERSE SOLIDUS",
	"SMALL RIGHT CURLY BRACKET",
	"SMALL RIGHT PARENTHESIS",
	"SMALL RIGHT TORTOISE SHELL BRACKET",
	"SMALL ROMAN NUMERAL EIGHT",
	"SMALL ROMAN NUMERAL ELEVEN",
	"SMALL ROMAN NUMERAL FIFTY",
	"SMALL ROMAN NUMERAL FIVE",
	"SMALL ROMAN NUMERAL FIVE HUNDRED",
	"SMALL ROMAN NUMERAL FOUR",
	"SMALL ROMAN NUMERAL NINE",
	"SMALL ROMAN NUMERAL ONE",
	"SMALL ROMAN NUMERAL ONE HUNDRED",
	"SMALL ROMAN NUMERAL ONE THOUSAND",
	"SMALL ROMAN NUMERAL SEVEN",
	"SMALL ROMAN NUMERAL SIX",
	"SMALL ROMAN NUMERAL TEN",
	"SMALL ROMAN NUMERAL THREE",
	"SMALL ROMAN NUMERAL TWELVE",
	"SMALL ROMAN NUMERAL TWO",
	"SMALL SEMICOLON",
	"SMALL TILDE",
	"SMALL TWO DOTS OVER ONE DOT PUNCTUATION",
	"SMALL VEE WITH UNDERBAR",
	"SMALLER THAN",
	"SMALLER THAN OR EQUAL TO",
	"SMASH PRODUCT",
	"SMILE",
	"SMILING CAT FACE WITH HEART-SHAPED EYES",
	"SMILING CAT FACE WITH OPEN MOUTH",
	"SMILING FACE WITH HALO",
	"SMILING FACE WITH HEART-SHAPED EYES",
	"SMILING FACE WITH HORNS",
	"SMILING FACE WITH OPEN MOUTH",
	"SMILING FACE WITH OPEN MOUTH AND COLD SWEAT",
	"SMILING FACE WITH OPEN MOUTH AND SMILING EYES",
	"SMILING FACE WITH OPEN MOUTH AND TIGHTLY-CLOSED EYES",
	"SMILING FACE WITH SMILING EYES",
	"SMILING FACE WITH SUNGLASSES",
	"SMIRKING FACE",
	"SMOKING SYMBOL",
	"SNAIL",
	"SNAKE",
	"SNOWBOARDER",
	"SNOWFLAKE",
	"SNOWMAN",
	"SNOWMAN WITHOUT SNOW",
	"SOCCER BALL",
	"SOFT HYPHEN",
	"SOFT ICE CREAM",
	"SOFTWARE-FUNCTION SYMBOL",
	"SOLIDUS",
	"SOLIDUS WITH OVERBAR",
	"SOON WITH RIGHTWARDS ARROW ABOVE",
	"SORA SOMPENG DIGIT EIGHT",
	"SORA SOMPENG DIGIT FIVE",
	"SORA SOMPENG DIGIT FOUR",
	"SORA SOMPENG DIGIT NINE",
	"SORA SOMPENG DIGIT ONE",
	"SORA SOMPENG DIGIT SEVEN",
	"SORA SOMPENG DIGIT SIX",
	"SORA SOMPENG DIGIT THREE",
	"SORA SOMPENG DIGIT TWO",
	"SORA SOMPENG DIGIT ZERO",
	"SORA SOMPENG LETTER AH",
	"SORA SOMPENG LETTER BAH",
	"SORA SOMPENG LETTER CAH",
	"SORA SOMPENG LETTER DAH",
	"SORA SOMPENG LETTER EEH",
	"SORA SOMPENG LETTER EH",
	"SORA SOMPENG LETTER GAH",
	"SORA SOMPENG LETTER HAH",
	"SORA SOMPENG LETTER IH",
	"SORA SOMPENG LETTER JAH",
	"SORA SOMPENG LETTER KAH",
	"SORA SOMPENG LETTER LAH",
	"SORA SOMPENG LETTER MAE",
	"SORA SOMPENG LETTER MAH",
	"SORA SOMPENG LETTER NAH",
	"SORA SOMPENG LETTER NGAH",
	"SORA SOMPENG LETTER NYAH",
	"SORA SOMPENG LETTER OH",
	"SORA SOMPENG LETTER PAH",
	"SORA SOMPENG LETTER RAH",
	"SORA SOMPENG LETTER SAH",
	"SORA SOMPENG LETTER TAH",
	"SORA SOMPENG LETTER UH",
	"SORA SOMPENG LETTER VAH",
	"SORA SOMPENG LETTER YAH",
	"SOUND RECORDING COPYRIGHT",
	"SOUTH EAST ARROW",
	"SOUTH EAST ARROW AND SOUTH WEST ARROW",
	"SOUTH EAST ARROW CROSSING NORTH EAST ARROW",
	"SOUTH EAST ARROW TO CORNER",
	"SOUTH EAST ARROW WITH HOOK",
	"SOUTH EAST BLACK ARROW",
	"SOUTH EAST DOUBLE ARROW",
	"SOUTH EAST WHITE ARROW",
	"SOUTH WEST ARROW",
	"SOUTH WEST ARROW AND NORTH WEST ARROW",
	"SOUTH WEST ARROW WITH HOOK",
	"SOUTH WEST BLACK ARROW",
	"SOUTH WEST DOUBLE ARROW",
	"SOUTH WEST WHITE ARROW",
	"SPACE",
	"SPAGHETTI",
	"SPARKLE",
	"SPARKLES",
	"SPARKLING HEART",
	"SPEAK-NO-EVIL MONKEY",
	"SPEAKER",
	"SPEAKER WITH CANCELLATION STROKE",
	"SPEAKER WITH ONE SOUND WAVE",
	"SPEAKER WITH THREE SOUND WAVES",
	"SPEECH BALLOON",
	"SPEEDBOAT",
	"SPESMILO SIGN",
	"SPHERICAL ANGLE",
	"SPHERICAL ANGLE OPENING LEFT",
	"SPHERICAL ANGLE OPENING UP",
	"SPIRAL SHELL",
	"SPLASHING SWEAT SYMBOL",
	"SPOUTING WHALE",
	"SQUARE A OVER M",
	"SQUARE AARU",
	"SQUARE AM",
	"SQUARE ANPEA",
	"SQUARE APAATO",
	"SQUARE ARUHUA",
	"SQUARE AU",
	"SQUARE BAARERU",
	"SQUARE BAR",
	"SQUARE BEETA",
	"SQUARE BIRU",
	"SQUARE BORUTO",
	"SQUARE BQ",
	"SQUARE BUSSYERU",
	"SQUARE C OVER KG",
	"SQUARE CAL",
	"SQUARE CAP",
	"SQUARE CC",
	"SQUARE CD",
	"SQUARE CM",
	"SQUARE CM CUBED",
	"SQUARE CM SQUARED",
	"SQUARE CO",
	"SQUARE CORPORATION",
	"SQUARE CUP",
	"SQUARE DA",
	"SQUARE DAASU",
	"SQUARE DB",
	"SQUARE DESI",
	"SQUARE DJ",
	"SQUARE DL",
	"SQUARE DM",
	"SQUARE DM CUBED",
	"SQUARE DM SQUARED",
	"SQUARE DORU",
	"SQUARE EEKAA",
	"SQUARE ERA NAME HEISEI",
	"SQUARE ERA NAME MEIZI",
	"SQUARE ERA NAME SYOUWA",
	"SQUARE ERA NAME TAISYOU",
	"SQUARE ERG",
	"SQUARE ESUKUUDO",
	"SQUARE EV",
	"SQUARE FM",
	"SQUARE FOOT",
	"SQUARE FOUR CORNERS",
	"SQUARE GAL",
	"SQUARE GANMA",
	"SQUARE GARON",
	"SQUARE GB",
	"SQUARE GHZ",
	"SQUARE GIGA",
	"SQUARE GINII",
	"SQUARE GIRUDAA",
	"SQUARE GPA",
	"SQUARE GURAMU",
	"SQUARE GURAMUTON",
	"SQUARE GY",
	"SQUARE HA",
	"SQUARE HAITU",
	"SQUARE HEKUTAARU",
	"SQUARE HERUTU",
	"SQUARE HG",
	"SQUARE HIRAGANA HOKA",
	"SQUARE HON",
	"SQUARE HOON",
	"SQUARE HOORU",
	"SQUARE HP",
	"SQUARE HPA",
	"SQUARE HUARADDO",
	"SQUARE HUIITO",
	"SQUARE HURAN",
	"SQUARE HZ",
	"SQUARE IMAGE OF",
	"SQUARE IMAGE OF OR EQUAL TO",
	"SQUARE IMAGE OF OR NOT EQUAL TO",
	"SQUARE IN",
	"SQUARE ININGU",
	"SQUARE INTI",
	"SQUARE IU",
	"SQUARE K OHM",
	"SQUARE KA",
	"SQUARE KAIRI",
	"SQUARE KARATTO",
	"SQUARE KARORII",
	"SQUARE KB",
	"SQUARE KCAL",
	"SQUARE KEESU",
	"SQUARE KG",
	"SQUARE KHZ",
	"SQUARE KIRO",
	"SQUARE KIROGURAMU",
	"SQUARE KIROMEETORU",
	"SQUARE KIROWATTO",
	"SQUARE KK",
	"SQUARE KL",
	"SQUARE KM",
	"SQUARE KM CAPITAL",
	"SQUARE KM CUBED",
	"SQUARE KM SQUARED",
	"SQUARE KOOPO",
	"SQUARE KORUNA",
	"SQUARE KPA",
	"SQUARE KT",
	"SQUARE KUROONE",
	"SQUARE KURUZEIRO",
	"SQUARE KV",
	"SQUARE KW",
	"SQUARE KYURII",
	"SQUARE LEFT OPEN BOX OPERATOR",
	"SQUARE LM",
	"SQUARE LN",
	"SQUARE LOG",
	"SQUARE LOZENGE",
	"SQUARE LX",
	"SQUARE M CUBED",
	"SQUARE M OHM",
	"SQUARE M OVER S",
	"SQUARE M OVER S SQUARED",
	"SQUARE M SQUARED",
	"SQUARE MA",
	"SQUARE MAHHA",
	"SQUARE MAIKURO",
	"SQUARE MAIRU",
	"SQUARE MANSYON",
	"SQUARE MARUKU",
	"SQUARE MB",
	"SQUARE MB SMALL",
	"SQUARE MEETORU",
	"SQUARE MEGA",
	"SQUARE MEGATON",
	"SQUARE MG",
	"SQUARE MHZ",
	"SQUARE MIKURON",
	"SQUARE MIL",
	"SQUARE MIRI",
	"SQUARE MIRIBAARU",
	"SQUARE ML",
	"SQUARE MM",
	"SQUARE MM CUBED",
	"SQUARE MM SQUARED",
	"SQUARE MOL",
	"SQUARE MPA",
	"SQUARE MS",
	"SQUARE MU A",
	"SQUARE MU F",
	"SQUARE MU G",
	"SQUARE MU L",
	"SQUARE MU M",
	"SQUARE MU S",
	"SQUARE MU V",
	"SQUARE MU W",
	"SQUARE MV",
	"SQUARE MV MEGA",
	"SQUARE MW",
	"SQUARE MW MEGA",
	"SQUARE NA",
	"SQUARE NANO",
	"SQUARE NF",
	"SQUARE NM",
	"SQUARE NOTTO",
	"SQUARE NS",
	"SQUARE NV",
	"SQUARE NW",
	"SQUARE ONSU",
	"SQUARE OOMU",
	"SQUARE ORIGINAL OF",
	"SQUARE ORIGINAL OF OR EQUAL TO",
	"SQUARE ORIGINAL OF OR NOT EQUAL TO",
	"SQUARE OV",
	"SQUARE PA",
	"SQUARE PA AMPS",
	"SQUARE PAASENTO",
	"SQUARE PAATU",
	"SQUARE PC",
	"SQUARE PEEZI",
	"SQUARE PENIHI",
	"SQUARE PENSU",
	"SQUARE PESO",
	"SQUARE PF",
	"SQUARE PH",
	"SQUARE PIASUTORU",
	"SQUARE PIKO",
	"SQUARE PIKURU",
	"SQUARE PM",
	"SQUARE POINTO",
	"SQUARE PONDO",
	"SQUARE PPM",
	"SQUARE PR",
	"SQUARE PS",
	"SQUARE PV",
	"SQUARE PW",
	"SQUARE RAD",
	"SQUARE RAD OVER S",
	"SQUARE RAD OVER S SQUARED",
	"SQUARE REMU",
	"SQUARE RENTOGEN",
	"SQUARE RIGHT OPEN BOX OPERATOR",
	"SQUARE RIRA",
	"SQUARE RITTORU",
	"SQUARE ROOT",
	"SQUARE RUPII",
	"SQUARE RUUBURU",
	"SQUARE SAIKURU",
	"SQUARE SANTIIMU",
	"SQUARE SENTI",
	"SQUARE SENTO",
	"SQUARE SIRINGU",
	"SQUARE SR",
	"SQUARE SV",
	"SQUARE THZ",
	"SQUARE TON",
	"SQUARE UON",
	"SQUARE V OVER M",
	"SQUARE WATTO",
	"SQUARE WB",
	"SQUARE WITH BOTTOM HALF BLACK",
	"SQUARE WITH CONTOURED OUTLINE",
	"SQUARE WITH DIAGONAL CROSSHATCH FILL",
	"SQUARE WITH HORIZONTAL FILL",
	"SQUARE WITH LEFT HALF BLACK",
	"SQUARE WITH LOWER LEFT DIAGONAL HALF BLACK",
	"SQUARE WITH LOWER RIGHT DIAGONAL HALF BLACK",
	"SQUARE WITH ORTHOGONAL CROSSHATCH FILL",
	"SQUARE WITH RIGHT HALF BLACK",
	"SQUARE WITH TOP HALF BLACK",
	"SQUARE WITH UPPER LEFT DIAGONAL HALF BLACK",
	"SQUARE WITH UPPER LEFT TO LOWER RIGHT FILL",
	"SQUARE WITH UPPER RIGHT DIAGONAL HALF BLACK",
	"SQUARE WITH UPPER RIGHT TO LOWER LEFT FILL",
	"SQUARE WITH VERTICAL FILL",
	"SQUARE YAADO",
	"SQUARE YAARU",
	"SQUARE YUAN",
	"SQUARED ASTERISK",
	"SQUARED CJK UNIFIED IDEOGRAPH-4E2D",
	"SQUARED CJK UNIFIED IDEOGRAPH-4E8C",
	"SQUARED CJK UNIFIED IDEOGRAPH-518D",
	"SQUARED CJK UNIFIED IDEOGRAPH-521D",
	"SQUARED CJK UNIFIED IDEOGRAPH-524D",
	"SQUARED CJK UNIFIED IDEOGRAPH-53CC",
	"SQUARED CJK UNIFIED IDEOGRAPH-591A",
	"SQUARED CJK UNIFIED IDEOGRAPH-5F8C",
	"SQUARED CJK UNIFIED IDEOGRAPH-624B",
	"SQUARED CJK UNIFIED IDEOGRAPH-751F",
	"SQUARED CJK UNIFIED IDEOGRAPH-7A7A",
	"SQUARED CJK UNIFIED IDEOGRAPH-904A",
	"SQUARED CL",
	"SQUARED COOL",
	"SQUARED DOT OPERATOR",
	"SQUARED FALLING DIAGONAL SLASH",
	"SQUARED FOUR DOT PUNCTUATION",
	"SQUARED FREE",
	"SQUARED HV",
	"SQUARED ID",
	"SQUARED KATAKANA DE",
	"SQUARED KATAKANA KOKO",
	"SQUARED KATAKANA SA",
	"SQUARED KEY",
	"SQUARED LATIN CAPITAL LETTER A",
	"SQUARED LATIN CAPITAL LETTER B",
	"SQUARED LATIN CAPITAL LETTER C",
	"SQUARED LATIN CAPITAL LETTER D",
	"SQUARED LATIN CAPITAL LETTER E",
	"SQUARED LATIN CAPITAL LETTER F",
	"SQUARED LATIN CAPITAL LETTER G",
	"SQUARED LATIN CAPITAL LETTER H",
	"SQUARED LATIN CAPITAL LETTER I",
	"SQUARED LATIN CAPITAL LETTER J",
	"SQUARED LATIN CAPITAL LETTER K",
	"SQUARED LATIN CAPITAL LETTER L",
	"SQUARED LATIN CAPITAL LETTER M",
	"SQUARED LATIN CAPITAL LETTER N",
	"SQUARED LATIN CAPITAL LETTER O",
	"SQUARED LATIN CAPITAL LETTER P",
	"SQUARED LATIN CAPITAL LETTER Q",
	"SQUARED LATIN CAPITAL LETTER R",
	"SQUARED LATIN CAPITAL LETTER S",
	"SQUARED LATIN CAPITAL LETTER T",
	"SQUARED LATIN CAPITAL LETTER U",
	"SQUARED LATIN CAPITAL LETTER V",
	"SQUARED LATIN CAPITAL LETTER W",
	"SQUARED LATIN CAPITAL LETTER X",
	"SQUARED LATIN CAPITAL LETTER Y",
	"SQUARED LATIN CAPITAL LETTER Z",
	"SQUARED LOGICAL AND",
	"SQUARED LOGICAL OR",
	"SQUARED MINUS",
	"SQUARED MV",
	"SQUARED NEW",
	"SQUARED NG",
	"SQUARED OK",
	"SQUARED PLUS",
	"SQUARED PPV",
	"SQUARED RISING DIAGONAL SLASH",
	"SQUARED SALTIRE",
	"SQUARED SD",
	"SQUARED SMALL CIRCLE",
	"SQUARED SOS",
	"SQUARED SQUARE",
	"SQUARED SS",
	"SQUARED TIMES",
	"SQUARED UP WITH EXCLAMATION MARK",
	"SQUARED VS",
	"SQUARED WC",
	"SQUAT BLACK RIGHTWARDS ARROW",
	"STAFF OF AESCULAPIUS",
	"STAFF OF HERMES",
	"STAR AND CRESCENT",
	"STAR EQUALS",
	"STAR OF DAVID",
	"STAR OPERATOR",
	"STATION",
	"STATUE OF LIBERTY",
	"STEAM LOCOMOTIVE",
	"STEAMING BOWL",
	"STOPWATCH",
	"STRAIGHT RULER",
	"STRAIGHTNESS",
	"STRAWBERRY",
	"STRESS OUTLINED WHITE STAR",
	"STRICTLY EQUIVALENT TO",
	"SUBSCRIPT EIGHT",
	"SUBSCRIPT EQUALS SIGN",
	"SUBSCRIPT FIVE",
	"SUBSCRIPT FOUR",
	"SUBSCRIPT LEFT PARENTHESIS",
	"SUBSCRIPT MINUS",
	"SUBSCRIPT NINE",
	"SUBSCRIPT ONE",
	"SUBSCRIPT PLUS SIGN",
	"SUBSCRIPT RIGHT PARENTHESIS",
	"SUBSCRIPT SEVEN",
	"SUBSCRIPT SIX",
	"SUBSCRIPT THREE",
	"SUBSCRIPT TWO",
	"SUBSCRIPT ZERO",
	"SUBSET ABOVE RIGHTWARDS ARROW",
	"SUBSET ABOVE SUBSET",
	"SUBSET ABOVE SUPERSET",
	"SUBSET OF",
	"SUBSET OF ABOVE ALMOST EQUAL TO",
	"SUBSET OF ABOVE EQUALS SIGN",
	"SUBSET OF ABOVE NOT EQUAL TO",
	"SUBSET OF ABOVE TILDE OPERATOR",
	"SUBSET OF OR EQUAL TO",
	"SUBSET OF OR EQUAL TO WITH DOT ABOVE",
	"SUBSET OF WITH NOT EQUAL TO",
	"SUBSET WITH DOT",
	"SUBSET WITH MULTIPLICATION SIGN BELOW",
	"SUBSET WITH PLUS SIGN BELOW",
	"SUCCEEDS",
	"SUCCEEDS ABOVE ALMOST EQUAL TO",
	"SUCCEEDS ABOVE EQUALS SIGN",
	"SUCCEEDS ABOVE NOT ALMOST EQUAL TO",
	"SUCCEEDS ABOVE NOT EQUAL TO",
	"SUCCEEDS ABOVE SINGLE-LINE EQUALS SIGN",
	"SUCCEEDS ABOVE SINGLE-LINE NOT EQUAL TO",
	"SUCCEEDS BUT NOT EQUIVALENT TO",
	"SUCCEEDS OR EQUAL TO",
	"SUCCEEDS OR EQUIVALENT TO",
	"SUCCEEDS UNDER RELATION",
	"SUMMATION BOTTOM",
	"SUMMATION TOP",
	"SUMMATION WITH INTEGRAL",
	"SUN",
	"SUN BEHIND CLOUD",
	"SUN WITH FACE",
	"SUNDANESE AVAGRAHA",
	"SUNDANESE CONSONANT SIGN PAMINGKAL",
	"SUNDANESE CONSONANT SIGN PANYAKRA",
	"SUNDANESE CONSONANT SIGN PANYIKU",
	"SUNDANESE CONSONANT SIGN PASANGAN MA",
	"SUNDANESE CONSONANT SIGN PASANGAN WA",
	"SUNDANESE DIGIT EIGHT",
	"SUNDANESE DIGIT FIVE",
	"SUNDANESE DIGIT FOUR",
	"SUNDANESE DIGIT NINE",
	"SUNDANESE DIGIT ONE",
	"SUNDANESE DIGIT SEVEN",
	"SUNDANESE DIGIT SIX",
	"SUNDANESE DIGIT THREE",
	"SUNDANESE DIGIT TWO",
	"SUNDANESE DIGIT ZERO",
	"SUNDANESE LETTER A",
	"SUNDANESE LETTER AE",
	"SUNDANESE LETTER BA",
	"SUNDANESE LETTER BHA",
	"SUNDANESE LETTER CA",
	"SUNDANESE LETTER DA",
	"SUNDANESE LETTER E",
	"SUNDANESE LETTER EU",
	"SUNDANESE LETTER FA",
	"SUNDANESE LETTER FINAL K",
	"SUNDANESE LETTER FINAL M",
	"SUNDANESE LETTER GA",
	"SUNDANESE LETTER HA",
	"SUNDANESE LETTER I",
	"SUNDANESE LETTER JA",
	"SUNDANESE LETTER KA",
	"SUNDANESE LETTER KHA",
	"SUNDANESE LETTER LA",
	"SUNDANESE LETTER LEU",
	"SUNDANESE LETTER MA",
	"SUNDANESE LETTER NA",
	"SUNDANESE LETTER NGA",
	"SUNDANESE LETTER NYA",
	"SUNDANESE LETTER O",
	"SUNDANESE LETTER PA",
	"SUNDANESE LETTER QA",
	"SUNDANESE LETTER RA",
	"SUNDANESE LETTER REU",
	"SUNDANESE LETTER SA",
	"SUNDANESE LETTER SYA",
	"SUNDANESE LETTER TA",
	"SUNDANESE LETTER U",
	"SUNDANESE LETTER VA",
	"SUNDANESE LETTER WA",
	"SUNDANESE LETTER XA",
	"SUNDANESE LETTER YA",
	"SUNDANESE LETTER ZA",
	"SUNDANESE PUNCTUATION BINDU BA SATANGA",
	"SUNDANESE PUNCTUATION BINDU CAKRA",
	"SUNDANESE PUNCTUATION BINDU DA SATANGA",
	"SUNDANESE PUNCTUATION BINDU KA SATANGA",
	"SUNDANESE PUNCTUATION BINDU LEU SATANGA",
	"SUNDANESE PUNCTUATION BINDU PANGLONG",
	"SUNDANESE PUNCTUATION BINDU PURNAMA",
	"SUNDANESE PUNCTUATION BINDU SURYA",
	"SUNDANESE SIGN PAMAAEH",
	"SUNDANESE SIGN PANGLAYAR",
	"SUNDANESE SIGN PANGWISAD",
	"SUNDANESE SIGN PANYECEK",
	"SUNDANESE SIGN VIRAMA",
	"SUNDANESE VOWEL SIGN PAMEPET",
	"SUNDANESE VOWEL SIGN PANAELAENG",
	"SUNDANESE VOWEL SIGN PANEULEUNG",
	"SUNDANESE VOWEL SIGN PANGHULU",
	"SUNDANESE VOWEL SIGN PANOLONG",
	"SUNDANESE VOWEL SIGN PANYUKU",
	"SUNFLOWER",
	"SUNRISE",
	"SUNRISE OVER MOUNTAINS",
	"SUNSET OVER BUILDINGS",
	"SUPERSCRIPT EIGHT",
	"SUPERSCRIPT EQUALS SIGN",
	"SUPERSCRIPT FIVE",
	"SUPERSCRIPT FOUR",
	"SUPERSCRIPT LATIN SMALL LETTER I",
	"SUPERSCRIPT LATIN SMALL LETTER N",
	"SUPERSCRIPT LEFT PARENTHESIS",
	"SUPERSCRIPT MINUS",
	"SUPERSCRIPT NINE",
	"SUPERSCRIPT ONE",
	"SUPERSCRIPT PLUS SIGN",
	"SUPERSCRIPT RIGHT PARENTHESIS",
	"SUPERSCRIPT SEVEN",
	"SUPERSCRIPT SIX",
	"SUPERSCRIPT THREE",
	"SUPERSCRIPT TWO",
	"SUPERSCRIPT ZERO",
	"SUPERSET ABOVE LEFTWARDS ARROW",
	"SUPERSET ABOVE SUBSET",
	"SUPERSET ABOVE SUPERSET",
	"SUPERSET BESIDE AND JOINED BY DASH WITH SUBSET",
	"SUPERSET BESIDE SUBSET",
	"SUPERSET OF",
	"SUPERSET OF ABOVE ALMOST EQUAL TO",
	"SUPERSET OF ABOVE EQUALS SIGN",
	"SUPERSET OF ABOVE NOT EQUAL TO",
	"SUPERSET OF ABOVE TILDE OPERATOR",
	"SUPERSET OF OR EQUAL TO",
	"SUPERSET OF OR EQUAL TO WITH DOT ABOVE",
	"SUPERSET OF WITH NOT EQUAL TO",
	"SUPERSET PRECEDING SOLIDUS",
	"SUPERSET WITH DOT",
	"SUPERSET WITH MULTIPLICATION SIGN BELOW",
	"SUPERSET WITH PLUS SIGN BELOW",
	"SURFACE INTEGRAL",
	"SURFER",
	"SUSHI",
	"SUSPENSION RAILWAY",
	"SWIMMER",
	"SWUNG DASH",
	"SYLOTI NAGRI LETTER A",
	"SYLOTI NAGRI LETTER BHO",
	"SYLOTI NAGRI LETTER BO",
	"SYLOTI NAGRI LETTER CHO",
	"SYLOTI NAGRI LETTER CO",
	"SYLOTI NAGRI LETTER DDHO",
	"SYLOTI NAGRI LETTER DDO",
	"SYLOTI NAGRI LETTER DHO",
	"SYLOTI NAGRI LETTER DO",
	"SYLOTI NAGRI LETTER E",
	"SYLOTI NAGRI LETTER GHO",
	"SYLOTI NAGRI LETTER GO",
	"SYLOTI NAGRI LETTER HO",
	"SYLOTI NAGRI LETTER I",
	"SYLOTI NAGRI LETTER JHO",
	"SYLOTI NAGRI LETTER JO",
	"SYLOTI NAGRI LETTER KHO",
	"SYLOTI NAGRI LETTER KO",
	"SYLOTI NAGRI LETTER LO",
	"SYLOTI NAGRI LETTER MO",
	"SYLOTI NAGRI LETTER NO",
	"SYLOTI NAGRI LETTER O",
	"SYLOTI NAGRI LETTER PHO",
	"SYLOTI NAGRI LETTER PO",
	"SYLOTI NAGRI LETTER RO",
	"SYLOTI NAGRI LETTER RRO",
	"SYLOTI NAGRI LETTER SO",
	"SYLOTI NAGRI LETTER THO",
	"SYLOTI NAGRI LETTER TO",
	"SYLOTI NAGRI LETTER TTHO",
	"SYLOTI NAGRI LETTER TTO",
	"SYLOTI NAGRI LETTER U",
	"SYLOTI NAGRI SIGN ANUSVARA",
	"SYLOTI NAGRI SIGN DVISVARA",
	"SYLOTI NAGRI SIGN HASANTA",
	"SYLOTI NAGRI VOWEL SIGN A",
	"SYLOTI NAGRI VOWEL SIGN E",
	"SYLOTI NAGRI VOWEL SIGN I",
	"SYLOTI NAGRI VOWEL SIGN OO",
	"SYLOTI NAGRI VOWEL SIGN U",
	"SYMBOL FOR ACKNOWLEDGE",
	"SYMBOL FOR BACKSPACE",
	"SYMBOL FOR BELL",
	"SYMBOL FOR CANCEL",
	"SYMBOL FOR CARRIAGE RETURN",
	"SYMBOL FOR DATA LINK ESCAPE",
	"SYMBOL FOR DELETE",
	"SYMBOL FOR DELETE FORM TWO",
	"SYMBOL FOR DEVICE CONTROL FOUR",
	"SYMBOL FOR DEVICE CONTROL ONE",
	"SYMBOL FOR DEVICE CONTROL THREE",
	"SYMBOL FOR DEVICE CONTROL TWO",
	"SYMBOL FOR END OF MEDIUM",
	"SYMBOL FOR END OF TEXT",
	"SYMBOL FOR END OF TRANSMISSION",
	"SYMBOL FOR END OF TRANSMISSION BLOCK",
	"SYMBOL FOR ENQUIRY",
	"SYMBOL FOR ESCAPE",
	"SYMBOL FOR FILE SEPARATOR",
	"SYMBOL FOR FORM FEED",
	"SYMBOL FOR GROUP SEPARATOR",
	"SYMBOL FOR HORIZONTAL TABULATION",
	"SYMBOL FOR LINE FEED",
	"SYMBOL FOR NEGATIVE ACKNOWLEDGE",
	"SYMBOL FOR NEWLINE",
	"SYMBOL FOR NULL",
	"SYMBOL FOR RECORD SEPARATOR",
	"SYMBOL FOR SAMARITAN SOURCE",
	"SYMBOL FOR SHIFT IN",
	"SYMBOL FOR SHIFT OUT",
	"SYMBOL FOR SPACE",
	"SYMBOL FOR START OF HEADING",
	"SYMBOL FOR START OF TEXT",
	"SYMBOL FOR SUBSTITUTE",
	"SYMBOL FOR SUBSTITUTE FORM TWO",
	"SYMBOL FOR SYNCHRONOUS IDLE",
	"SYMBOL FOR UNIT SEPARATOR",
	"SYMBOL FOR VERTICAL TABULATION",
	"SYMMETRY",
	"SYRIAC ABBREVIATION MARK",
	"SYRIAC BARREKH",
	"SYRIAC COLON SKEWED LEFT",
	"SYRIAC COLON SKEWED RIGHT",
	"SYRIAC CONTRACTION",
	"SYRIAC DOTTED ZLAMA ANGULAR",
	"SYRIAC DOTTED ZLAMA HORIZONTAL",
	"SYRIAC END OF PARAGRAPH",
	"SYRIAC ESASA ABOVE",
	"SYRIAC ESASA BELOW",
	"SYRIAC FEMININE DOT",
	"SYRIAC HARKLEAN ASTERISCUS",
	"SYRIAC HARKLEAN METOBELUS",
	"SYRIAC HARKLEAN OBELUS",
	"SYRIAC HBASA ABOVE",
	"SYRIAC HBASA BELOW",
	"SYRIAC HBASA-ESASA DOTTED",
	"SYRIAC HORIZONTAL COLON",
	"SYRIAC LETTER ALAPH",
	"SYRIAC LETTER BETH",
	"SYRIAC LETTER DALATH",
	"SYRIAC LETTER DOTLESS DALATH RISH",
	"SYRIAC LETTER E",
	"SYRIAC LETTER FINAL SEMKATH",
	"SYRIAC LETTER GAMAL",
	"SYRIAC LETTER GAMAL GARSHUNI",
	"SYRIAC LETTER HE",
	"SYRIAC LETTER HETH",
	"SYRIAC LETTER KAPH",
	"SYRIAC LETTER LAMADH",
	"SYRIAC LETTER MIM",
	"SYRIAC LETTER NUN",
	"SYRIAC LETTER PE",
	"SYRIAC LETTER PERSIAN BHETH",
	"SYRIAC LETTER PERSIAN DHALATH",
	"SYRIAC LETTER PERSIAN GHAMAL",
	"SYRIAC LETTER QAPH",
	"SYRIAC LETTER REVERSED PE",
	"SYRIAC LETTER RISH",
	"SYRIAC LETTER SADHE",
	"SYRIAC LETTER SEMKATH",
	"SYRIAC LETTER SHIN",
	"SYRIAC LETTER SOGDIAN FE",
	"SYRIAC LETTER SOGDIAN KHAPH",
	"SYRIAC LETTER SOGDIAN ZHAIN",
	"SYRIAC LETTER SUPERSCRIPT ALAPH",
	"SYRIAC LETTER TAW",
	"SYRIAC LETTER TETH",
	"SYRIAC LETTER TETH GARSHUNI",
	"SYRIAC LETTER WAW",
	"SYRIAC LETTER YUDH",
	"SYRIAC LETTER YUDH HE",
	"SYRIAC LETTER ZAIN",
	"SYRIAC MUSIC",
	"SYRIAC OBLIQUE LINE ABOVE",
	"SYRIAC OBLIQUE LINE BELOW",
	"SYRIAC PTHAHA ABOVE",
	"SYRIAC PTHAHA BELOW",
	"SYRIAC PTHAHA DOTTED",
	"SYRIAC QUSHSHAYA",
	"SYRIAC RBASA ABOVE",
	"SYRIAC RBASA BELOW",
	"SYRIAC RUKKAKHA",
	"SYRIAC RWAHA",
	"SYRIAC SUBLINEAR COLON",
	"SYRIAC SUBLINEAR COLON SKEWED RIGHT",
	"SYRIAC SUBLINEAR FULL STOP",
	"SYRIAC SUPRALINEAR COLON",
	"SYRIAC SUPRALINEAR COLON SKEWED LEFT",
	"SYRIAC SUPRALINEAR FULL STOP",
	"SYRIAC THREE DOTS ABOVE",
	"SYRIAC THREE DOTS BELOW",
	"SYRIAC TWO VERTICAL DOTS ABOVE",
	"SYRIAC TWO VERTICAL DOTS BELOW",
	"SYRIAC ZQAPHA ABOVE",
	"SYRIAC ZQAPHA BELOW",
	"SYRIAC ZQAPHA DOTTED",
	"SYRINGE",
	"T-SHIRT",
	"TAG AMPERSAND",
	"TAG APOSTROPHE",
	"TAG ASTERISK",
	"TAG CIRCUMFLEX ACCENT",
	"TAG COLON",
	"TAG COMMA",
	"TAG COMMERCIAL AT",
	"TAG DIGIT EIGHT",
	"TAG DIGIT FIVE",
	"TAG DIGIT FOUR",
	"TAG DIGIT NINE",
	"TAG DIGIT ONE",
	"TAG DIGIT SEVEN",
	"TAG DIGIT SIX",
	"TAG DIGIT THREE",
	"TAG DIGIT TWO",
	"TAG DIGIT ZERO",
	"TAG DOLLAR SIGN",
	"TAG EQUALS SIGN",
	"TAG EXCLAMATION MARK",
	"TAG FULL STOP",
	"TAG GRAVE ACCENT",
	"TAG GREATER-THAN SIGN",
	"TAG HYPHEN-MINUS",
	"TAG LATIN CAPITAL LETTER A",
	"TAG LATIN CAPITAL LETTER B",
	"TAG LATIN CAPITAL LETTER C",
	"TAG LATIN CAPITAL LETTER D",
	"TAG LATIN CAPITAL LETTER E",
	"TAG LATIN CAPITAL LETTER F",
	"TAG LATIN CAPITAL LETTER G",
	"TAG LATIN CAPITAL LETTER H",
	"TAG LATIN CAPITAL LETTER I",
	"TAG LATIN CAPITAL LETTER J",
	"TAG LATIN CAPITAL LETTER K",
	"TAG LATIN CAPITAL LETTER L",
	"TAG LATIN CAPITAL LETTER M",
	"TAG LATIN CAPITAL LETTER N",
	"TAG LATIN CAPITAL LETTER O",
	"TAG LATIN CAPITAL LETTER P",
	"TAG LATIN CAPITAL LETTER Q",
	"TAG LATIN CAPITAL LETTER R",
	"TAG LATIN CAPITAL LETTER S",
	"TAG LATIN CAPITAL LETTER T",
	"TAG LATIN CAPITAL LETTER U",
	"TAG LATIN CAPITAL LETTER V",
	"TAG LATIN CAPITAL LETTER W",
	"TAG LATIN CAPITAL LETTER X",
	"TAG LATIN CAPITAL LETTER Y",
	"TAG LATIN CAPITAL LETTER Z",
	"TAG LATIN SMALL LETTER A",
	"TAG LATIN SMALL LETTER B",
	"TAG LATIN SMALL LETTER C",
	"TAG LATIN SMALL LETTER D",
	"TAG LATIN SMALL LETTER E",
	"TAG LATIN SMALL LETTER F",
	"TAG LATIN SMALL LETTER G",
	"TAG LATIN SMALL LETTER H",
	"TAG LATIN SMALL LETTER I",
	"TAG LATIN SMALL LETTER J",
	"TAG LATIN SMALL LETTER K",
	"TAG LATIN SMALL LETTER L",
	"TAG LATIN SMALL LETTER M",
	"TAG LATIN SMALL LETTER N",
	"TAG LATIN SMALL LETTER O",
	"TAG LATIN SMALL LETTER P",
	"TAG LATIN SMALL LETTER Q",
	"TAG LATIN SMALL LETTER R",
	"TAG LATIN SMALL LETTER S",
	"TAG LATIN SMALL LETTER T",
	"TAG LATIN SMALL LETTER U",
	"TAG LATIN SMALL LETTER V",
	"TAG LATIN SMALL LETTER W",
	"TAG LATIN SMALL LETTER X",
	"TAG LATIN SMALL LETTER Y",
	"TAG LATIN SMALL LETTER Z",
	"TAG LEFT CURLY BRACKET",
	"TAG LEFT PARENTHESIS",
	"TAG LEFT SQUARE BRACKET",
	"TAG LESS-THAN SIGN",
	"TAG LOW LINE",
	"TAG NUMBER SIGN",
	"TAG PERCENT SIGN",
	"TAG PLUS SIGN",
	"TAG QUESTION MARK",
	"TAG QUOTATION MARK",
	"TAG REVERSE SOLIDUS",
	"TAG RIGHT CURLY BRACKET",
	"TAG RIGHT PARENTHESIS",
	"TAG RIGHT SQUARE BRACKET",
	"TAG SEMICOLON",
	"TAG SOLIDUS",
	"TAG SPACE",
	"TAG TILDE",
	"TAG VERTICAL LINE",
	"TAGALOG LETTER A",
	"TAGALOG LETTER BA",
	"TAGALOG LETTER DA",
	"TAGALOG LETTER GA",
	"TAGALOG LETTER HA",
	"TAGALOG LETTER I",
	"TAGALOG LETTER KA",
	"TAGALOG LETTER LA",
	"TAGALOG LETTER MA",
	"TAGALOG LETTER NA",
	"TAGALOG LETTER NGA",
	"TAGALOG LETTER PA",
	"TAGALOG LETTER SA",
	"TAGALOG LETTER TA",
	"TAGALOG LETTER U",
	"TAGALOG LETTER WA",
	"TAGALOG LETTER YA",
	"TAGALOG SIGN VIRAMA",
	"TAGALOG VOWEL SIGN I",
	"TAGALOG VOWEL SIGN U",
	"TAGBANWA LETTER A",
	"TAGBANWA LETTER BA",
	"TAGBANWA LETTER DA",
	"TAGBANWA LETTER GA",
	"TAGBANWA LETTER I",
	"TAGBANWA LETTER KA",
	"TAGBANWA LETTER LA",
	"TAGBANWA LETTER MA",
	"TAGBANWA LETTER NA",
	"TAGBANWA LETTER NGA",
	"TAGBANWA LETTER PA",
	"TAGBANWA LETTER SA",
	"TAGBANWA LETTER TA",
	"TAGBANWA LETTER U",
	"TAGBANWA LETTER WA",
	"TAGBANWA LETTER YA",
	"TAGBANWA VOWEL SIGN I",
	"TAGBANWA VOWEL SIGN U",
	"TAI LE LETTER A",
	"TAI LE LETTER AI",
	"TAI LE LETTER AUE",
	"TAI LE LETTER E",
	"TAI LE LETTER EE",
	"TAI LE LETTER EH",
	"TAI LE LETTER FA",
	"TAI LE LETTER HA",
	"TAI LE LETTER I",
	"TAI LE LETTER KA",
	"TAI LE LETTER KHA",
	"TAI LE LETTER LA",
	"TAI LE LETTER MA",
	"TAI LE LETTER NA",
	"TAI LE LETTER NGA",
	"TAI LE LETTER O",
	"TAI LE LETTER OO",
	"TAI LE LETTER PA",
	"TAI LE LETTER PHA",
	"TAI LE LETTER QA",
	"TAI LE LETTER SA",
	"TAI LE LETTER TA",
	"TAI LE LETTER THA",
	"TAI LE LETTER TSA",
	"TAI LE LETTER TSHA",
	"TAI LE LETTER U",
	"TAI LE LETTER UE",
	"TAI LE LETTER VA",
	"TAI LE LETTER XA",
	"TAI LE LETTER YA",
	"TAI THAM COMBINING CRYPTOGRAMMIC DOT",
	"TAI THAM CONSONANT SIGN BA",
	"TAI THAM CONSONANT SIGN FINAL NGA",
	"TAI THAM CONSONANT SIGN HIGH RATHA OR LOW PA",
	"TAI THAM CONSONANT SIGN LA TANG LAI",
	"TAI THAM CONSONANT SIGN LOW PA",
	"TAI THAM CONSONANT SIGN MA",
	"TAI THAM CONSONANT SIGN MEDIAL LA",
	"TAI THAM CONSONANT SIGN MEDIAL RA",
	"TAI THAM CONSONANT SIGN SA",
	"TAI THAM HORA DIGIT EIGHT",
	"TAI THAM HORA DIGIT FIVE",
	"TAI THAM HORA DIGIT FOUR",
	"TAI THAM HORA DIGIT NINE",
	"TAI THAM HORA DIGIT ONE",
	"TAI THAM HORA DIGIT SEVEN",
	"TAI THAM HORA DIGIT SIX",
	"TAI THAM HORA DIGIT THREE",
	"TAI THAM HORA DIGIT TWO",
	"TAI THAM HORA DIGIT ZERO",
	"TAI THAM LETTER A",
	"TAI THAM LETTER BA",
	"TAI THAM LETTER DA",
	"TAI THAM LETTER EE",
	"TAI THAM LETTER GREAT SA",
	"TAI THAM LETTER HIGH CA",
	"TAI THAM LETTER HIGH CHA",
	"TAI THAM LETTER HIGH FA",
	"TAI THAM LETTER HIGH HA",
	"TAI THAM LETTER HIGH KA",
	"TAI THAM LETTER HIGH KHA",
	"TAI THAM LETTER HIGH KXA",
	"TAI THAM LETTER HIGH PA",
	"TAI THAM LETTER HIGH PHA",
	"TAI THAM LETTER HIGH RATHA",
	"TAI THAM LETTER HIGH SA",
	"TAI THAM LETTER HIGH SHA",
	"TAI THAM LETTER HIGH SSA",
	"TAI THAM LETTER HIGH TA",
	"TAI THAM LETTER HIGH THA",
	"TAI THAM LETTER HIGH YA",
	"TAI THAM LETTER I",
	"TAI THAM LETTER II",
	"TAI THAM LETTER LA",
	"TAI THAM LETTER LAE",
	"TAI THAM LETTER LLA",
	"TAI THAM LETTER LOW CA",
	"TAI THAM LETTER LOW CHA",
	"TAI THAM LETTER LOW FA",
	"TAI THAM LETTER LOW HA",
	"TAI THAM LETTER LOW KA",
	"TAI THAM LETTER LOW KHA",
	"TAI THAM LETTER LOW KXA",
	"TAI THAM LETTER LOW PA",
	"TAI THAM LETTER LOW PHA",
	"TAI THAM LETTER LOW RATHA",
	"TAI THAM LETTER LOW SA",
	"TAI THAM LETTER LOW TA",
	"TAI THAM LETTER LOW THA",
	"TAI THAM LETTER LOW YA",
	"TAI THAM LETTER LUE",
	"TAI THAM LETTER MA",
	"TAI THAM LETTER NA",
	"TAI THAM LETTER NGA",
	"TAI THAM LETTER NYA",
	"TAI THAM LETTER OO",
	"TAI THAM LETTER RA",
	"TAI THAM LETTER RANA",
	"TAI THAM LETTER RATA",
	"TAI THAM LETTER RUE",
	"TAI THAM LETTER U",
	"TAI THAM LETTER UU",
	"TAI THAM LETTER WA",
	"TAI THAM SIGN CAANG",
	"TAI THAM SIGN DOKMAI",
	"TAI THAM SIGN HANG",
	"TAI THAM SIGN HOY",
	"TAI THAM SIGN KAAN",
	"TAI THAM SIGN KAANKUU",
	"TAI THAM SIGN KEOW",
	"TAI THAM SIGN KHUEN-LUE KARAN",
	"TAI THAM SIGN MAI KANG",
	"TAI THAM SIGN MAI KANG LAI",
	"TAI THAM SIGN MAI SAM",
	"TAI THAM SIGN MAI YAMOK",
	"TAI THAM SIGN RA HAAM",
	"TAI THAM SIGN REVERSED ROTATED RANA",
	"TAI THAM SIGN SAKOT",
	"TAI THAM SIGN SATKAAN",
	"TAI THAM SIGN SATKAANKUU",
	"TAI THAM SIGN SAWAN",
	"TAI THAM SIGN WIANG",
	"TAI THAM SIGN WIANGWAAK",
	"TAI THAM THAM DIGIT EIGHT",
	"TAI THAM THAM DIGIT FIVE",
	"TAI THAM THAM DIGIT FOUR",
	"TAI THAM THAM DIGIT NINE",
	"TAI THAM THAM DIGIT ONE",
	"TAI THAM THAM DIGIT SEVEN",
	"TAI THAM THAM DIGIT SIX",
	"TAI THAM THAM DIGIT THREE",
	"TAI THAM THAM DIGIT TWO",
	"TAI THAM THAM DIGIT ZERO",
	"TAI THAM VOWEL SIGN A",
	"TAI THAM VOWEL SIGN AA",
	"TAI THAM VOWEL SIGN AE",
	"TAI THAM VOWEL SIGN AI",
	"TAI THAM VOWEL SIGN E",
	"TAI THAM VOWEL SIGN I",
	"TAI THAM VOWEL SIGN II",
	"TAI THAM VOWEL SIGN MAI SAT",
	"TAI THAM VOWEL SIGN O",
	"TAI THAM VOWEL SIGN OA ABOVE",
	"TAI THAM VOWEL SIGN OA BELOW",
	"TAI THAM VOWEL SIGN OO",
	"TAI THAM VOWEL SIGN OY",
	"TAI THAM VOWEL SIGN TALL AA",
	"TAI THAM VOWEL SIGN THAM AI",
	"TAI THAM VOWEL SIGN U",
	"TAI THAM VOWEL SIGN UE",
	"TAI THAM VOWEL SIGN UU",
	"TAI THAM VOWEL SIGN UUE",
	"TAI VIET LETTER HIGH BO",
	"TAI VIET LETTER HIGH CHO",
	"TAI VIET LETTER HIGH CO",
	"TAI VIET LETTER HIGH DO",
	"TAI VIET LETTER HIGH FO",
	"TAI VIET LETTER HIGH GO",
	"TAI VIET LETTER HIGH HO",
	"TAI VIET LETTER HIGH KHHO",
	"TAI VIET LETTER HIGH KHO",
	"TAI VIET LETTER HIGH KO",
	"TAI VIET LETTER HIGH LO",
	"TAI VIET LETTER HIGH MO",
	"TAI VIET LETTER HIGH NGO",
	"TAI VIET LETTER HIGH NO",
	"TAI VIET LETTER HIGH NYO",
	"TAI VIET LETTER HIGH O",
	"TAI VIET LETTER HIGH PHO",
	"TAI VIET LETTER HIGH PO",
	"TAI VIET LETTER HIGH RO",
	"TAI VIET LETTER HIGH SO",
	"TAI VIET LETTER HIGH THO",
	"TAI VIET LETTER HIGH TO",
	"TAI VIET LETTER HIGH VO",
	"TAI VIET LETTER HIGH YO",
	"TAI VIET LETTER LOW BO",
	"TAI VIET LETTER LOW CHO",
	"TAI VIET LETTER LOW CO",
	"TAI VIET LETTER LOW DO",
	"TAI VIET LETTER LOW FO",
	"TAI VIET LETTER LOW GO",
	"TAI VIET LETTER LOW HO",
	"TAI VIET LETTER LOW KHHO",
	"TAI VIET LETTER LOW KHO",
	"TAI VIET LETTER LOW KO",
	"TAI VIET LETTER LOW LO",
	"TAI VIET LETTER LOW MO",
	"TAI VIET LETTER LOW NGO",
	"TAI VIET LETTER LOW NO",
	"TAI VIET LETTER LOW NYO",
	"TAI VIET LETTER LOW O",
	"TAI VIET LETTER LOW PHO",
	"TAI VIET LETTER LOW PO",
	"TAI VIET LETTER LOW RO",
	"TAI VIET LETTER LOW SO",
	"TAI VIET LETTER LOW THO",
	"TAI VIET LETTER LOW TO",
	"TAI VIET LETTER LOW VO",
	"TAI VIET LETTER LOW YO",
	"TAI VIET MAI KANG",
	"TAI VIET MAI KHIT",
	"TAI VIET SYMBOL HO HOI",
	"TAI VIET SYMBOL KOI KOI",
	"TAI VIET SYMBOL KON",
	"TAI VIET SYMBOL NUENG",
	"TAI VIET SYMBOL SAM",
	"TAI VIET TONE MAI EK",
	"TAI VIET TONE MAI NUENG",
	"TAI VIET TONE MAI SONG",
	"TAI VIET TONE MAI THO",
	"TAI VIET VOWEL AA",
	"TAI VIET VOWEL AM",
	"TAI VIET VOWEL AN",
	"TAI VIET VOWEL AUE",
	"TAI VIET VOWEL AY",
	"TAI VIET VOWEL E",
	"TAI VIET VOWEL I",
	"TAI VIET VOWEL IA",
	"TAI VIET VOWEL O",
	"TAI VIET VOWEL U",
	"TAI VIET VOWEL UA",
	"TAI VIET VOWEL UE",
	"TAI VIET VOWEL UEA",
	"TAKRI DIGIT EIGHT",
	"TAKRI DIGIT FIVE",
	"TAKRI DIGIT FOUR",
	"TAKRI DIGIT NINE",
	"TAKRI DIGIT ONE",
	"TAKRI DIGIT SEVEN",
	"TAKRI DIGIT SIX",
	"TAKRI DIGIT THREE",
	"TAKRI DIGIT TWO",
	"TAKRI DIGIT ZERO",
	"TAKRI LETTER A",
	"TAKRI LETTER AA",
	"TAKRI LETTER AI",
	"TAKRI LETTER AU",
	"TAKRI LETTER BA",
	"TAKRI LETTER BHA",
	"TAKRI LETTER CA",
	"TAKRI LETTER CHA",
	"TAKRI LETTER DA",
	"TAKRI LETTER DDA",
	"TAKRI LETTER DDHA",
	"TAKRI LETTER DHA",
	"TAKRI LETTER E",
	"TAKRI LETTER GA",
	"TAKRI LETTER GHA",
	"TAKRI LETTER HA",
	"TAKRI LETTER I",
	"TAKRI LETTER II",
	"TAKRI LETTER JA",
	"TAKRI LETTER JHA",
	"TAKRI LETTER KA",
	"TAKRI LETTER KHA",
	"TAKRI LETTER LA",
	"TAKRI LETTER MA",
	"TAKRI LETTER NA",
	"TAKRI LETTER NGA",
	"TAKRI LETTER NNA",
	"TAKRI LETTER NYA",
	"TAKRI LETTER O",
	"TAKRI LETTER PA",
	"TAKRI LETTER PHA",
	"TAKRI LETTER RA",
	"TAKRI LETTER RRA",
	"TAKRI LETTER SA",
	"TAKRI LETTER SHA",
	"TAKRI LETTER TA",
	"TAKRI LETTER THA",
	"TAKRI LETTER TTA",
	"TAKRI LETTER TTHA",
	"TAKRI LETTER U",
	"TAKRI LETTER UU",
	"TAKRI LETTER VA",
	"TAKRI LETTER YA",
	"TAKRI SIGN ANUSVARA",
	"TAKRI SIGN NUKTA",
	"TAKRI SIGN VIRAMA",
	"TAKRI SIGN VISARGA",
	"TAKRI VOWEL SIGN AA",
	"TAKRI VOWEL SIGN AI",
	"TAKRI VOWEL SIGN AU",
	"TAKRI VOWEL SIGN E",
	"TAKRI VOWEL SIGN I",
	"TAKRI VOWEL SIGN II",
	"TAKRI VOWEL SIGN O",
	"TAKRI VOWEL SIGN U",
	"TAKRI VOWEL SIGN UU",
	"TAMIL AS ABOVE SIGN",
	"TAMIL AU LENGTH MARK",
	"TAMIL CREDIT SIGN",
	"TAMIL DAY SIGN",
	"TAMIL DEBIT SIGN",
	"TAMIL DIGIT EIGHT",
	"TAMIL DIGIT FIVE",
	"TAMIL DIGIT FOUR",
	"TAMIL DIGIT NINE",
	"TAMIL DIGIT ONE",
	"TAMIL DIGIT SEVEN",
	"TAMIL DIGIT SIX",
	"TAMIL DIGIT THREE",
	"TAMIL DIGIT TWO",
	"TAMIL DIGIT ZERO",
	"TAMIL LETTER A",
	"TAMIL LETTER AA",
	"TAMIL LETTER AI",
	"TAMIL LETTER AU",
	"TAMIL LETTER CA",
	"TAMIL LETTER E",
	"TAMIL LETTER EE",
	"TAMIL LETTER HA",
	"TAMIL LETTER I",
	"TAMIL LETTER II",
	"TAMIL LETTER JA",
	"TAMIL LETTER KA",
	"TAMIL LETTER LA",
	"TAMIL LETTER LLA",
	"TAMIL LETTER LLLA",
	"TAMIL LETTER MA",
	"TAMIL LETTER NA",
	"TAMIL LETTER NGA",
	"TAMIL LETTER NNA",
	"TAMIL LETTER NNNA",
	"TAMIL LETTER NYA",
	"TAMIL LETTER O",
	"TAMIL LETTER OO",
	"TAMIL LETTER PA",
	"TAMIL LETTER RA",
	"TAMIL LETTER RRA",
	"TAMIL LETTER SA",
	"TAMIL LETTER SHA",
	"TAMIL LETTER SSA",
	"TAMIL LETTER TA",
	"TAMIL LETTER TTA",
	"TAMIL LETTER U",
	"TAMIL LETTER UU",
	"TAMIL LETTER VA",
	"TAMIL LETTER YA",
	"TAMIL MONTH SIGN",
	"TAMIL NUMBER ONE HUNDRED",
	"TAMIL NUMBER ONE THOUSAND",
	"TAMIL NUMBER SIGN",
	"TAMIL NUMBER TEN",
	"TAMIL OM",
	"TAMIL RUPEE SIGN",
	"TAMIL SIGN ANUSVARA",
	"TAMIL SIGN VIRAMA",
	"TAMIL SIGN VISARGA",
	"TAMIL VOWEL SIGN AA",
	"TAMIL VOWEL SIGN AI",
	"TAMIL VOWEL SIGN AU",
	"TAMIL VOWEL SIGN E",
	"TAMIL VOWEL SIGN EE",
	"TAMIL VOWEL SIGN I",
	"TAMIL VOWEL SIGN II",
	"TAMIL VOWEL SIGN O",
	"TAMIL VOWEL SIGN OO",
	"TAMIL VOWEL SIGN U",
	"TAMIL VOWEL SIGN UU",
	"TAMIL YEAR SIGN",
	"TANABATA TREE",
	"TANGERINE",
	"TAPE DRIVE",
	"TAURUS",
	"TAXI",
	"TEACUP WITHOUT HANDLE",
	"TEAR-OFF CALENDAR",
	"TEARDROP-BARBED RIGHTWARDS ARROW",
	"TEARDROP-SPOKED ASTERISK",
	"TELEPHONE LOCATION SIGN",
	"TELEPHONE RECEIVER",
	"TELEPHONE RECORDER",
	"TELEPHONE SIGN",
	"TELESCOPE",
	"TELEVISION",
	"TELUGU AI LENGTH MARK",
	"TELUGU DIGIT EIGHT",
	"TELUGU DIGIT FIVE",
	"TELUGU DIGIT FOUR",
	"TELUGU DIGIT NINE",
	"TELUGU DIGIT ONE",
	"TELUGU DIGIT SEVEN",
	"TELUGU DIGIT SIX",
	"TELUGU DIGIT THREE",
	"TELUGU DIGIT TWO",
	"TELUGU DIGIT ZERO",
	"TELUGU FRACTION DIGIT ONE FOR EVEN POWERS OF FOUR",
	"TELUGU FRACTION DIGIT ONE FOR ODD POWERS OF FOUR",
	"TELUGU FRACTION DIGIT THREE FOR EVEN POWERS OF FOUR",
	"TELUGU FRACTION DIGIT THREE FOR ODD POWERS OF FOUR",
	"TELUGU FRACTION DIGIT TWO FOR EVEN POWERS OF FOUR",
	"TELUGU FRACTION DIGIT TWO FOR ODD POWERS OF FOUR",
	"TELUGU FRACTION DIGIT ZERO FOR ODD POWERS OF FOUR",
	"TELUGU LENGTH MARK",
	"TELUGU LETTER A",
	"TELUGU LETTER AA",
	"TELUGU LETTER AI",
	"TELUGU LETTER AU",
	"TELUGU LETTER BA",
	"TELUGU LETTER BHA",
	"TELUGU LETTER CA",
	"TELUGU LETTER CHA",
	"TELUGU LETTER DA",
	"TELUGU LETTER DDA",
	"TELUGU LETTER DDHA",
	"TELUGU LETTER DHA",
	"TELUGU LETTER DZA",
	"TELUGU LETTER E",
	"TELUGU LETTER EE",
	"TELUGU LETTER GA",
	"TELUGU LETTER GHA",
	"TELUGU LETTER HA",
	"TELUGU LETTER I",
	"TELUGU LETTER II",
	"TELUGU LETTER JA",
	"TELUGU LETTER JHA",
	"TELUGU LETTER KA",
	"TELUGU LETTER KHA",
	"TELUGU LETTER LA",
	"TELUGU LETTER LLA",
	"TELUGU LETTER MA",
	"TELUGU LETTER NA",
	"TELUGU LETTER NGA",
	"TELUGU LETTER NNA",
	"TELUGU LETTER NYA",
	"TELUGU LETTER O",
	"TELUGU LETTER OO",
	"TELUGU LETTER PA",
	"TELUGU LETTER PHA",
	"TELUGU LETTER RA",
	"TELUGU LETTER RRA",
	"TELUGU LETTER SA",
	"TELUGU LETTER SHA",
	"TELUGU LETTER SSA",
	"TELUGU LETTER TA",
	"TELUGU LETTER THA",
	"TELUGU LETTER TSA",
	"TELUGU LETTER TTA",
	"TELUGU LETTER TTHA",
	"TELUGU LETTER U",
	"TELUGU LETTER UU",
	"TELUGU LETTER VA",
	"TELUGU LETTER VOCALIC L",
	"TELUGU LETTER VOCALIC LL",
	"TELUGU LETTER VOCALIC R",
	"TELUGU LETTER VOCALIC RR",
	"TELUGU LETTER YA",
	"TELUGU SIGN ANUSVARA",
	"TELUGU SIGN AVAGRAHA",
	"TELUGU SIGN CANDRABINDU",
	"TELUGU SIGN TUUMU",
	"TELUGU SIGN VIRAMA",
	"TELUGU SIGN VISARGA",
	"TELUGU VOWEL SIGN AA",
	"TELUGU VOWEL SIGN AI",
	"TELUGU VOWEL SIGN AU",
	"TELUGU VOWEL SIGN E",
	"TELUGU VOWEL SIGN EE",
	"TELUGU VOWEL SIGN I",
	"TELUGU VOWEL SIGN II",
	"TELUGU VOWEL SIGN O",
	"TELUGU VOWEL SIGN OO",
	"TELUGU VOWEL SIGN U",
	"TELUGU VOWEL SIGN UU",
	"TELUGU VOWEL SIGN VOCALIC L",
	"TELUGU VOWEL SIGN VOCALIC LL",
	"TELUGU VOWEL SIGN VOCALIC R",
	"TELUGU VOWEL SIGN VOCALIC RR",
	"TENGE SIGN",
	"TENNIS RACQUET AND BALL",
	"TENT",
	"TETRAGRAM FOR ACCUMULATION",
	"TETRAGRAM FOR ADVANCE",
	"TETRAGRAM FOR AGGRAVATION",
	"TETRAGRAM FOR ASCENT",
	"TETRAGRAM FOR BARRIER",
	"TETRAGRAM FOR BOLD RESOLUTION",
	"TETRAGRAM FOR BRANCHING OUT",
	"TETRAGRAM FOR CENTRE",
	"TETRAGRAM FOR CHANGE",
	"TETRAGRAM FOR CLOSED MOUTH",
	"TETRAGRAM FOR CLOSENESS",
	"TETRAGRAM FOR CLOSURE",
	"TETRAGRAM FOR COMPLETION",
	"TETRAGRAM FOR COMPLIANCE",
	"TETRAGRAM FOR CONSTANCY",
	"TETRAGRAM FOR CONTACT",
	"TETRAGRAM FOR CONTENTION",
	"TETRAGRAM FOR CONTRARIETY",
	"TETRAGRAM FOR DARKENING",
	"TETRAGRAM FOR DECISIVENESS",
	"TETRAGRAM FOR DEFECTIVENESS OR DISTORTION",
	"TETRAGRAM FOR DEPARTURE",
	"TETRAGRAM FOR DIFFICULTIES",
	"TETRAGRAM FOR DIMINISHMENT",
	"TETRAGRAM FOR DIMMING",
	"TETRAGRAM FOR DIVERGENCE",
	"TETRAGRAM FOR DOUBT",
	"TETRAGRAM FOR DUTIES",
	"TETRAGRAM FOR EASE",
	"TETRAGRAM FOR EMBELLISHMENT",
	"TETRAGRAM FOR ENCOUNTERS",
	"TETRAGRAM FOR ENDEAVOUR",
	"TETRAGRAM FOR ENLARGEMENT",
	"TETRAGRAM FOR ETERNITY",
	"TETRAGRAM FOR EXHAUSTION",
	"TETRAGRAM FOR FAILURE",
	"TETRAGRAM FOR FLIGHT",
	"TETRAGRAM FOR FOLLOWING",
	"TETRAGRAM FOR FOSTERING",
	"TETRAGRAM FOR FULL CIRCLE",
	"TETRAGRAM FOR FULLNESS",
	"TETRAGRAM FOR GATHERING",
	"TETRAGRAM FOR GATHERING IN",
	"TETRAGRAM FOR GOING TO MEET",
	"TETRAGRAM FOR GREATNESS",
	"TETRAGRAM FOR GUARDEDNESS",
	"TETRAGRAM FOR HARDNESS",
	"TETRAGRAM FOR HOLDING BACK",
	"TETRAGRAM FOR INCREASE",
	"TETRAGRAM FOR INNER",
	"TETRAGRAM FOR JOY",
	"TETRAGRAM FOR KEEPING SMALL",
	"TETRAGRAM FOR KINSHIP",
	"TETRAGRAM FOR LABOURING",
	"TETRAGRAM FOR LAW OR MODEL",
	"TETRAGRAM FOR LEGION",
	"TETRAGRAM FOR MASSING",
	"TETRAGRAM FOR MEASURE",
	"TETRAGRAM FOR MIRED",
	"TETRAGRAM FOR ON THE VERGE",
	"TETRAGRAM FOR OPPOSITION",
	"TETRAGRAM FOR PACKING",
	"TETRAGRAM FOR PATTERN",
	"TETRAGRAM FOR PENETRATION",
	"TETRAGRAM FOR PURITY",
	"TETRAGRAM FOR REACH",
	"TETRAGRAM FOR RELEASE",
	"TETRAGRAM FOR RESIDENCE",
	"TETRAGRAM FOR RESISTANCE",
	"TETRAGRAM FOR RESPONSE",
	"TETRAGRAM FOR RITUAL",
	"TETRAGRAM FOR SEVERANCE",
	"TETRAGRAM FOR SINKING",
	"TETRAGRAM FOR STOPPAGE",
	"TETRAGRAM FOR STOVE",
	"TETRAGRAM FOR STRENGTH",
	"TETRAGRAM FOR UNITY",
	"TETRAGRAM FOR VASTNESS OR WASTING",
	"TETRAGRAM FOR WAITING",
	"TETRAGRAM FOR WATCH",
	"TETRAGRAM FOR YOUTHFULNESS",
	"THAANA AABAAFILI",
	"THAANA ABAFILI",
	"THAANA EBEFILI",
	"THAANA EEBEEFILI",
	"THAANA EYBEYFILI",
	"THAANA IBIFILI",
	"THAANA LETTER AINU",
	"THAANA LETTER ALIFU",
	"THAANA LETTER BAA",
	"THAANA LETTER CHAVIYANI",
	"THAANA LETTER DAADHU",
	"THAANA LETTER DAVIYANI",
	"THAANA LETTER DHAALU",
	"THAANA LETTER FAAFU",
	"THAANA LETTER GAAFU",
	"THAANA LETTER GHAINU",
	"THAANA LETTER GNAVIYANI",
	"THAANA LETTER HAA",
	"THAANA LETTER HHAA",
	"THAANA LETTER JAVIYANI",
	"THAANA LETTER KAAFU",
	"THAANA LETTER KHAA",
	"THAANA LETTER LAAMU",
	"THAANA LETTER LHAVIYANI",
	"THAANA LETTER MEEMU",
	"THAANA LETTER NAA",
	"THAANA LETTER NOONU",
	"THAANA LETTER PAVIYANI",
	"THAANA LETTER QAAFU",
	"THAANA LETTER RAA",
	"THAANA LETTER SAADHU",
	"THAANA LETTER SEENU",
	"THAANA LETTER SHAVIYANI",
	"THAANA LETTER SHEENU",
	"THAANA LETTER TAVIYANI",
	"THAANA LETTER THAA",
	"THAANA LETTER THAALU",
	"THAANA LETTER TO",
	"THAANA LETTER TTAA",
	"THAANA LETTER VAAVU",
	"THAANA LETTER WAAVU",
	"THAANA LETTER YAA",
	"THAANA LETTER ZAA",
	"THAANA LETTER ZAVIYANI",
	"THAANA LETTER ZO",
	"THAANA OABOAFILI",
	"THAANA OBOFILI",
	"THAANA OOBOOFILI",
	"THAANA SUKUN",
	"THAANA UBUFILI",
	"THAI CHARACTER ANGKHANKHU",
	"THAI CHARACTER BO BAIMAI",
	"THAI CHARACTER CHO CHAN",
	"THAI CHARACTER CHO CHANG",
	"THAI CHARACTER CHO CHING",
	"THAI CHARACTER CHO CHOE",
	"THAI CHARACTER DO CHADA",
	"THAI CHARACTER DO DEK",
	"THAI CHARACTER FO FA",
	"THAI CHARACTER FO FAN",
	"THAI CHARACTER FONGMAN",
	"THAI CHARACTER HO HIP",
	"THAI CHARACTER HO NOKHUK",
	"THAI CHARACTER KHO KHAI",
	"THAI CHARACTER KHO KHON",
	"THAI CHARACTER KHO KHUAT",
	"THAI CHARACTER KHO KHWAI",
	"THAI CHARACTER KHO RAKHANG",
	"THAI CHARACTER KHOMUT",
	"THAI CHARACTER KO KAI",
	"THAI CHARACTER LAKKHANGYAO",
	"THAI CHARACTER LO CHULA",
	"THAI CHARACTER LO LING",
	"THAI CHARACTER LU",
	"THAI CHARACTER MAI CHATTAWA",
	"THAI CHARACTER MAI EK",
	"THAI CHARACTER MAI HAN-AKAT",
	"THAI CHARACTER MAI THO",
	"THAI CHARACTER MAI TRI",
	"THAI CHARACTER MAITAIKHU",
	"THAI CHARACTER MAIYAMOK",
	"THAI CHARACTER MO MA",
	"THAI CHARACTER NGO NGU",
	"THAI CHARACTER NIKHAHIT",
	"THAI CHARACTER NO NEN",
	"THAI CHARACTER NO NU",
	"THAI CHARACTER O ANG",
	"THAI CHARACTER PAIYANNOI",
	"THAI CHARACTER PHINTHU",
	"THAI CHARACTER PHO PHAN",
	"THAI CHARACTER PHO PHUNG",
	"THAI CHARACTER PHO SAMPHAO",
	"THAI CHARACTER PO PLA",
	"THAI CHARACTER RO RUA",
	"THAI CHARACTER RU",
	"THAI CHARACTER SARA A",
	"THAI CHARACTER SARA AA",
	"THAI CHARACTER SARA AE",
	"THAI CHARACTER SARA AI MAIMALAI",
	"THAI CHARACTER SARA AI MAIMUAN",
	"THAI CHARACTER SARA AM",
	"THAI CHARACTER SARA E",
	"THAI CHARACTER SARA I",
	"THAI CHARACTER SARA II",
	"THAI CHARACTER SARA O",
	"THAI CHARACTER SARA U",
	"THAI CHARACTER SARA UE",
	"THAI CHARACTER SARA UEE",
	"THAI CHARACTER SARA UU",
	"THAI CHARACTER SO RUSI",
	"THAI CHARACTER SO SALA",
	"THAI CHARACTER SO SO",
	"THAI CHARACTER SO SUA",
	"THAI CHARACTER THANTHAKHAT",
	"THAI CHARACTER THO NANGMONTHO",
	"THAI CHARACTER THO PHUTHAO",
	"THAI CHARACTER THO THAHAN",
	"THAI CHARACTER THO THAN",
	"THAI CHARACTER THO THONG",
	"THAI CHARACTER THO THUNG",
	"THAI CHARACTER TO PATAK",
	"THAI CHARACTER TO TAO",
	"THAI CHARACTER WO WAEN",
	"THAI CHARACTER YAMAKKAN",
	"THAI CHARACTER YO YAK",
	"THAI CHARACTER YO YING",
	"THAI CURRENCY SYMBOL BAHT",
	"THAI DIGIT EIGHT",
	"THAI DIGIT FIVE",
	"THAI DIGIT FOUR",
	"THAI DIGIT NINE",
	"THAI DIGIT ONE",
	"THAI DIGIT SEVEN",
	"THAI DIGIT SIX",
	"THAI DIGIT THREE",
	"THAI DIGIT TWO",
	"THAI DIGIT ZERO",
	"THERE DOES NOT EXIST",
	"THERE EXISTS",
	"THEREFORE",
	"THERMODYNAMIC",
	"THIN SPACE",
	"THOUGHT BALLOON",
	"THREE CONSECUTIVE EQUALS SIGNS",
	"THREE DIMENSIONAL ANGLE",
	"THREE DOT PUNCTUATION",
	"THREE LEFTWARDS ARROWS",
	"THREE LINES CONVERGING LEFT",
	"THREE LINES CONVERGING RIGHT",
	"THREE RIGHTWARDS ARROWS",
	"THREE-D BOTTOM-LIGHTED RIGHTWARDS ARROWHEAD",
	"THREE-D TOP-LIGHTED RIGHTWARDS ARROWHEAD",
	"THREE-EM DASH",
	"THREE-PER-EM SPACE",
	"THUMBS DOWN SIGN",
	"THUMBS UP SIGN",
	"THUNDER CLOUD AND RAIN",
	"THUNDERSTORM",
	"TIBETAN ASTROLOGICAL SIGN -KHYUD PA",
	"TIBETAN ASTROLOGICAL SIGN SDONG TSHUGS",
	"TIBETAN ASTROLOGICAL SIGN SGRA GCAN -CHAR RTAGS",
	"TIBETAN CANTILLATION SIGN CANG TE-U",
	"TIBETAN CANTILLATION SIGN HEAVY BEAT",
	"TIBETAN CANTILLATION SIGN LIGHT BEAT",
	"TIBETAN CANTILLATION SIGN SBUB -CHAL",
	"TIBETAN DIGIT EIGHT",
	"TIBETAN DIGIT FIVE",
	"TIBETAN DIGIT FOUR",
	"TIBETAN DIGIT HALF EIGHT",
	"TIBETAN DIGIT HALF FIVE",
	"TIBETAN DIGIT HALF FOUR",
	"TIBETAN DIGIT HALF NINE",
	"TIBETAN DIGIT HALF ONE",
	"TIBETAN DIGIT HALF SEVEN",
	"TIBETAN DIGIT HALF SIX",
	"TIBETAN DIGIT HALF THREE",
	"TIBETAN DIGIT HALF TWO",
	"TIBETAN DIGIT HALF ZERO",
	"TIBETAN DIGIT NINE",
	"TIBETAN DIGIT ONE",
	"TIBETAN DIGIT SEVEN",
	"TIBETAN DIGIT SIX",
	"TIBETAN DIGIT THREE",
	"TIBETAN DIGIT TWO",
	"TIBETAN DIGIT ZERO",
	"TIBETAN KU RU KHA",
	"TIBETAN KU RU KHA BZHI MIG CAN",
	"TIBETAN LETTER -A",
	"TIBETAN LETTER A",
	"TIBETAN LETTER BA",
	"TIBETAN LETTER BHA",
	"TIBETAN LETTER CA",
	"TIBETAN LETTER CHA",
	"TIBETAN LETTER DA",
	"TIBETAN LETTER DDA",
	"TIBETAN LETTER DDHA",
	"TIBETAN LETTER DHA",
	"TIBETAN LETTER DZA",
	"TIBETAN LETTER DZHA",
	"TIBETAN LETTER FIXED-FORM RA",
	"TIBETAN LETTER GA",
	"TIBETAN LETTER GHA",
	"TIBETAN LETTER HA",
	"TIBETAN LETTER JA",
	"TIBETAN LETTER KA",
	"TIBETAN LETTER KHA",
	"TIBETAN LETTER KKA",
	"TIBETAN LETTER KSSA",
	"TIBETAN LETTER LA",
	"TIBETAN LETTER MA",
	"TIBETAN LETTER NA",
	"TIBETAN LETTER NGA",
	"TIBETAN LETTER NNA",
	"TIBETAN LETTER NYA",
	"TIBETAN LETTER PA",
	"TIBETAN LETTER PHA",
	"TIBETAN LETTER RA",
	"TIBETAN LETTER RRA",
	"TIBETAN LETTER SA",
	"TIBETAN LETTER SHA",
	"TIBETAN LETTER SSA",
	"TIBETAN LETTER TA",
	"TIBETAN LETTER THA",
	"TIBETAN LETTER TSA",
	"TIBETAN LETTER TSHA",
	"TIBETAN LETTER TTA",
	"TIBETAN LETTER TTHA",
	"TIBETAN LETTER WA",
	"TIBETAN LETTER YA",
	"TIBETAN LETTER ZA",
	"TIBETAN LETTER ZHA",
	"TIBETAN LOGOTYPE SIGN CHAD RTAGS",
	"TIBETAN LOGOTYPE SIGN LHAG RTAGS",
	"TIBETAN MARK ANG KHANG GYAS",
	"TIBETAN MARK ANG KHANG GYON",
	"TIBETAN MARK BKA- SHOG YIG MGO",
	"TIBETAN MARK BSDUS RTAGS",
	"TIBETAN MARK BSKA- SHOG GI MGO RGYAN",
	"TIBETAN MARK BSKUR YIG MGO",
	"TIBETAN MARK CARET -DZUD RTAGS BZHI MIG CAN",
	"TIBETAN MARK CARET -DZUD RTAGS ME LONG CAN",
	"TIBETAN MARK CARET YIG MGO PHUR SHAD MA",
	"TIBETAN MARK CHE MGO",
	"TIBETAN MARK CLOSING BRDA RNYING YIG MGO SGAB MA",
	"TIBETAN MARK CLOSING YIG MGO SGAB MA",
	"TIBETAN MARK DELIMITER TSHEG BSTAR",
	"TIBETAN MARK GTER TSHEG",
	"TIBETAN MARK GTER YIG MGO -UM GTER TSHEG MA",
	"TIBETAN MARK GTER YIG MGO -UM RNAM BCAD MA",
	"TIBETAN MARK GTER YIG MGO TRUNCATED A",
	"TIBETAN MARK GUG RTAGS GYAS",
	"TIBETAN MARK GUG RTAGS GYON",
	"TIBETAN MARK HALANTA",
	"TIBETAN MARK INITIAL BRDA RNYING YIG MGO MDUN MA",
	"TIBETAN MARK INITIAL YIG MGO MDUN MA",
	"TIBETAN MARK INTERSYLLABIC TSHEG",
	"TIBETAN MARK LEADING MCHAN RTAGS",
	"TIBETAN MARK MNYAM YIG GI MGO RGYAN",
	"TIBETAN MARK NGAS BZUNG NYI ZLA",
	"TIBETAN MARK NGAS BZUNG SGOR RTAGS",
	"TIBETAN MARK NYIS SHAD",
	"TIBETAN MARK NYIS TSHEG",
	"TIBETAN MARK NYIS TSHEG SHAD",
	"TIBETAN MARK PALUTA",
	"TIBETAN MARK RGYA GRAM SHAD",
	"TIBETAN MARK RIN CHEN SPUNGS SHAD",
	"TIBETAN MARK SBRUL SHAD",
	"TIBETAN MARK SHAD",
	"TIBETAN MARK TRAILING MCHAN RTAGS",
	"TIBETAN MARK TSA -PHRU",
	"TIBETAN MARK TSHEG SHAD",
	"TIBETAN MARK YIG MGO TSHEG SHAD MA",
	"TIBETAN SIGN GRU CAN RGYINGS",
	"TIBETAN SIGN GRU MED RGYINGS",
	"TIBETAN SIGN INVERTED MCHU CAN",
	"TIBETAN SIGN LCE TSA CAN",
	"TIBETAN SIGN LCI RTAGS",
	"TIBETAN SIGN MAR TSHES",
	"TIBETAN SIGN MCHU CAN",
	"TIBETAN SIGN NYI ZLA NAA DA",
	"TIBETAN SIGN RDEL DKAR GCIG",
	"TIBETAN SIGN RDEL DKAR GNYIS",
	"TIBETAN SIGN RDEL DKAR GSUM",
	"TIBETAN SIGN RDEL DKAR RDEL NAG",
	"TIBETAN SIGN RDEL NAG GCIG",
	"TIBETAN SIGN RDEL NAG GNYIS",
	"TIBETAN SIGN RDEL NAG GSUM",
	"TIBETAN SIGN RDEL NAG RDEL DKAR",
	"TIBETAN SIGN RJES SU NGA RO",
	"TIBETAN SIGN RNAM BCAD",
	"TIBETAN SIGN SNA LDAN",
	"TIBETAN SIGN YANG RTAGS",
	"TIBETAN SIGN YAR TSHES",
	"TIBETAN SUBJOINED LETTER -A",
	"TIBETAN SUBJOINED LETTER A",
	"TIBETAN SUBJOINED LETTER BA",
	"TIBETAN SUBJOINED LETTER BHA",
	"TIBETAN SUBJOINED LETTER CA",
	"TIBETAN SUBJOINED LETTER CHA",
	"TIBETAN SUBJOINED LETTER DA",
	"TIBETAN SUBJOINED LETTER DDA",
	"TIBETAN SUBJOINED LETTER DDHA",
	"TIBETAN SUBJOINED LETTER DHA",
	"TIBETAN SUBJOINED LETTER DZA",
	"TIBETAN SUBJOINED LETTER DZHA",
	"TIBETAN SUBJOINED LETTER FIXED-FORM RA",
	"TIBETAN SUBJOINED LETTER FIXED-FORM WA",
	"TIBETAN SUBJOINED LETTER FIXED-FORM YA",
	"TIBETAN SUBJOINED LETTER GA",
	"TIBETAN SUBJOINED LETTER GHA",
	"TIBETAN SUBJOINED LETTER HA",
	"TIBETAN SUBJOINED LETTER JA",
	"TIBETAN SUBJOINED LETTER KA",
	"TIBETAN SUBJOINED LETTER KHA",
	"TIBETAN SUBJOINED LETTER KSSA",
	"TIBETAN SUBJOINED LETTER LA",
	"TIBETAN SUBJOINED LETTER MA",
	"TIBETAN SUBJOINED LETTER NA",
	"TIBETAN SUBJOINED LETTER NGA",
	"TIBETAN SUBJOINED LETTER NNA",
	"TIBETAN SUBJOINED LETTER NYA",
	"TIBETAN SUBJOINED LETTER PA",
	"TIBETAN SUBJOINED LETTER PHA",
	"TIBETAN SUBJOINED LETTER RA",
	"TIBETAN SUBJOINED LETTER SA",
	"TIBETAN SUBJOINED LETTER SHA",
	"TIBETAN SUBJOINED LETTER SSA",
	"TIBETAN SUBJOINED LETTER TA",
	"TIBETAN SUBJOINED LETTER THA",
	"TIBETAN SUBJOINED LETTER TSA",
	"TIBETAN SUBJOINED LETTER TSHA",
	"TIBETAN SUBJOINED LETTER TTA",
	"TIBETAN SUBJOINED LETTER TTHA",
	"TIBETAN SUBJOINED LETTER WA",
	"TIBETAN SUBJOINED LETTER YA",
	"TIBETAN SUBJOINED LETTER ZA",
	"TIBETAN SUBJOINED LETTER ZHA",
	"TIBETAN SUBJOINED SIGN INVERTED MCHU CAN",
	"TIBETAN SUBJOINED SIGN LCE TSA CAN",
	"TIBETAN SUBJOINED SIGN MCHU CAN",
	"TIBETAN SYLLABLE OM",
	"TIBETAN SYMBOL DRIL BU",
	"TIBETAN SYMBOL NOR BU",
	"TIBETAN SYMBOL NOR BU BZHI -KHYIL",
	"TIBETAN SYMBOL NOR BU GSUM -KHYIL",
	"TIBETAN SYMBOL NOR BU NYIS -KHYIL",
	"TIBETAN SYMBOL PADMA GDAN",
	"TIBETAN SYMBOL PHUR PA",
	"TIBETAN SYMBOL RDO RJE",
	"TIBETAN SYMBOL RDO RJE RGYA GRAM",
	"TIBETAN VOWEL SIGN AA",
	"TIBETAN VOWEL SIGN E",
	"TIBETAN VOWEL SIGN EE",
	"TIBETAN VOWEL SIGN I",
	"TIBETAN VOWEL SIGN II",
	"TIBETAN VOWEL SIGN O",
	"TIBETAN VOWEL SIGN OO",
	"TIBETAN VOWEL SIGN REVERSED I",
	"TIBETAN VOWEL SIGN REVERSED II",
	"TIBETAN VOWEL SIGN U",
	"TIBETAN VOWEL SIGN UU",
	"TIBETAN VOWEL SIGN VOCALIC L",
	"TIBETAN VOWEL SIGN VOCALIC LL",
	"TIBETAN VOWEL SIGN VOCALIC R",
	"TIBETAN VOWEL SIGN VOCALIC RR",
	"TICKET",
	"TIE OVER INFINITY",
	"TIFINAGH CONSONANT JOINER",
	"TIFINAGH LETTER AHAGGAR YAZH",
	"TIFINAGH LETTER AYER YAGH",
	"TIFINAGH LETTER BERBER ACADEMY YAH",
	"TIFINAGH LETTER BERBER ACADEMY YAJ",
	"TIFINAGH LETTER TAWELLEMET YAZ",
	"TIFINAGH LETTER TUAREG YAGH",
	"TIFINAGH LETTER TUAREG YAGN",
	"TIFINAGH LETTER TUAREG YAH",
	"TIFINAGH LETTER TUAREG YAK",
	"TIFINAGH LETTER TUAREG YAKH",
	"TIFINAGH LETTER TUAREG YANG",
	"TIFINAGH LETTER TUAREG YAQ",
	"TIFINAGH LETTER TUAREG YAZH",
	"TIFINAGH LETTER YA",
	"TIFINAGH LETTER YAA",
	"TIFINAGH LETTER YAB",
	"TIFINAGH LETTER YABH",
	"TIFINAGH LETTER YACH",
	"TIFINAGH LETTER YAD",
	"TIFINAGH LETTER YADD",
	"TIFINAGH LETTER YADDH",
	"TIFINAGH LETTER YADH",
	"TIFINAGH LETTER YAF",
	"TIFINAGH LETTER YAG",
	"TIFINAGH LETTER YAGH",
	"TIFINAGH LETTER YAGHH",
	"TIFINAGH LETTER YAH",
	"TIFINAGH LETTER YAHH",
	"TIFINAGH LETTER YAJ",
	"TIFINAGH LETTER YAK",
	"TIFINAGH LETTER YAKH",
	"TIFINAGH LETTER YAKHH",
	"TIFINAGH LETTER YAL",
	"TIFINAGH LETTER YAM",
	"TIFINAGH LETTER YAN",
	"TIFINAGH LETTER YAP",
	"TIFINAGH LETTER YAQ",
	"TIFINAGH LETTER YAR",
	"TIFINAGH LETTER YARR",
	"TIFINAGH LETTER YAS",
	"TIFINAGH LETTER YASH",
	"TIFINAGH LETTER YASS",
	"TIFINAGH LETTER YAT",
	"TIFINAGH LETTER YATH",
	"TIFINAGH LETTER YATT",
	"TIFINAGH LETTER YAV",
	"TIFINAGH LETTER YAW",
	"TIFINAGH LETTER YAY",
	"TIFINAGH LETTER YAZ",
	"TIFINAGH LETTER YAZH",
	"TIFINAGH LETTER YAZZ",
	"TIFINAGH LETTER YE",
	"TIFINAGH LETTER YEY",
	"TIFINAGH LETTER YI",
	"TIFINAGH LETTER YO",
	"TIFINAGH LETTER YU",
	"TIFINAGH MODIFIER LETTER LABIALIZATION MARK",
	"TIFINAGH SEPARATOR MARK",
	"TIGER",
	"TIGER FACE",
	"TIGHT TRIFOLIATE SNOWFLAKE",
	"TILDE",
	"TILDE OPERATOR",
	"TILDE OPERATOR ABOVE LEFTWARDS ARROW",
	"TILDE OPERATOR ABOVE RIGHTWARDS ARROW",
	"TILDE OPERATOR WITH DOT ABOVE",
	"TILDE OPERATOR WITH RISING DOTS",
	"TILDE WITH DOT ABOVE",
	"TILDE WITH DOT BELOW",
	"TILDE WITH RING ABOVE",
	"TIMER CLOCK",
	"TIMES WITH LEFT HALF BLACK",
	"TIMES WITH RIGHT HALF BLACK",
	"TINY",
	"TINY TWO DOTS OVER ONE DOT PUNCTUATION",
	"TIRED FACE",
	"TIRONIAN SIGN ET",
	"TOILET",
	"TOKYO TOWER",
	"TOMATO",
	"TONGUE",
	"TOP ARC ANTICLOCKWISE ARROW",
	"TOP ARC ANTICLOCKWISE ARROW WITH PLUS",
	"TOP ARC CLOCKWISE ARROW WITH MINUS",
	"TOP CURLY BRACKET",
	"TOP HALF INTEGRAL",
	"TOP HALF SECTION SIGN",
	"TOP HAT",
	"TOP LEFT CORNER",
	"TOP LEFT CROP",
	"TOP LEFT HALF BRACKET",
	"TOP PARENTHESIS",
	"TOP RIGHT CORNER",
	"TOP RIGHT CROP",
	"TOP RIGHT HALF BRACKET",
	"TOP SQUARE BRACKET",
	"TOP TORTOISE SHELL BRACKET",
	"TOP WITH UPWARDS ARROW ABOVE",
	"TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-4E8C",
	"TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-52DD",
	"TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-672C",
	"TORTOISE SHELL BRACKETED LATIN CAPITAL LETTER S",
	"TOTAL RUNOUT",
	"TRACTOR",
	"TRADE MARK SIGN",
	"TRAIN",
	"TRAM",
	"TRAM CAR",
	"TRANSVERSAL INTERSECTION",
	"TRIANGLE WITH DOT ABOVE",
	"TRIANGLE WITH SERIFS AT BOTTOM",
	"TRIANGLE WITH UNDERBAR",
	"TRIANGLE-HEADED RIGHTWARDS ARROW",
	"TRIANGULAR BULLET",
	"TRIANGULAR FLAG ON POST",
	"TRIANGULAR RULER",
	"TRICOLON",
	"TRIDENT EMBLEM",
	"TRIGRAM FOR EARTH",
	"TRIGRAM FOR FIRE",
	"TRIGRAM FOR HEAVEN",
	"TRIGRAM FOR LAKE",
	"TRIGRAM FOR MOUNTAIN",
	"TRIGRAM FOR THUNDER",
	"TRIGRAM FOR WATER",
	"TRIGRAM FOR WIND",
	"TRIPLE COLON OPERATOR",
	"TRIPLE HORIZONTAL BAR WITH DOUBLE VERTICAL STROKE",
	"TRIPLE HORIZONTAL BAR WITH TRIPLE VERTICAL STROKE",
	"TRIPLE INTEGRAL",
	"TRIPLE NESTED GREATER-THAN",
	"TRIPLE NESTED LESS-THAN",
	"TRIPLE PLUS",
	"TRIPLE PRIME",
	"TRIPLE SOLIDUS BINARY RELATION",
	"TRIPLE TILDE",
	"TRIPLE VERTICAL BAR BINARY RELATION",
	"TRIPLE VERTICAL BAR DELIMITER",
	"TRIPLE VERTICAL BAR RIGHT TURNSTILE",
	"TRIPLE VERTICAL BAR WITH HORIZONTAL STROKE",
	"TROLLEYBUS",
	"TROPHY",
	"TROPICAL DRINK",
	"TROPICAL FISH",
	"TRUE",
	"TRUMPET",
	"TUGRIK SIGN",
	"TULIP",
	"TURKISH LIRA SIGN",
	"TURNED AMPERSAND",
	"TURNED ANGLE",
	"TURNED BLACK SHOGI PIECE",
	"TURNED CAPITAL F",
	"TURNED COMMA",
	"TURNED DAGGER",
	"TURNED GREEK SMALL LETTER IOTA",
	"TURNED NOT SIGN",
	"TURNED SANS-SERIF CAPITAL G",
	"TURNED SANS-SERIF CAPITAL L",
	"TURNED SANS-SERIF CAPITAL Y",
	"TURNED SEMICOLON",
	"TURNED SMALL F",
	"TURNED WHITE SHOGI PIECE",
	"TURTLE",
	"TWELVE POINTED BLACK STAR",
	"TWISTED RIGHTWARDS ARROWS",
	"TWO ASTERISKS ALIGNED VERTICALLY",
	"TWO CONSECUTIVE EQUALS SIGNS",
	"TWO DOT LEADER",
	"TWO DOT PUNCTUATION",
	"TWO DOTS OVER ONE DOT PUNCTUATION",
	"TWO HEARTS",
	"TWO INTERSECTING LOGICAL AND",
	"TWO INTERSECTING LOGICAL OR",
	"TWO JOINED SQUARES",
	"TWO LOGICAL AND OPERATOR",
	"TWO LOGICAL OR OPERATOR",
	"TWO MEN HOLDING HANDS",
	"TWO WOMEN HOLDING HANDS",
	"TWO-EM DASH",
	"UGARITIC LETTER AIN",
	"UGARITIC LETTER ALPA",
	"UGARITIC LETTER BETA",
	"UGARITIC LETTER DELTA",
	"UGARITIC LETTER DHAL",
	"UGARITIC LETTER GAMLA",
	"UGARITIC LETTER GHAIN",
	"UGARITIC LETTER HO",
	"UGARITIC LETTER HOTA",
	"UGARITIC LETTER I",
	"UGARITIC LETTER KAF",
	"UGARITIC LETTER KHA",
	"UGARITIC LETTER LAMDA",
	"UGARITIC LETTER MEM",
	"UGARITIC LETTER NUN",
	"UGARITIC LETTER PU",
	"UGARITIC LETTER QOPA",
	"UGARITIC LETTER RASHA",
	"UGARITIC LETTER SADE",
	"UGARITIC LETTER SAMKA",
	"UGARITIC LETTER SHIN",
	"UGARITIC LETTER SSU",
	"UGARITIC LETTER TET",
	"UGARITIC LETTER THANNA",
	"UGARITIC LETTER TO",
	"UGARITIC LETTER U",
	"UGARITIC LETTER WO",
	"UGARITIC LETTER YOD",
	"UGARITIC LETTER ZETA",
	"UGARITIC LETTER ZU",
	"UGARITIC WORD DIVIDER",
	"UMBRELLA",
	"UMBRELLA ON GROUND",
	"UMBRELLA WITH RAIN DROPS",
	"UNAMUSED FACE",
	"UNDERTIE",
	"UNDO SYMBOL",
	"UNION",
	"UNION ABOVE BAR ABOVE INTERSECTION",
	"UNION ABOVE INTERSECTION",
	"UNION BESIDE AND JOINED WITH UNION",
	"UNION WITH LOGICAL OR",
	"UNION WITH MINUS SIGN",
	"UNION WITH OVERBAR",
	"UNIVERSAL RECYCLING SYMBOL",
	"UNMARRIED PARTNERSHIP SYMBOL",
	"UP ARROW THROUGH CIRCLE",
	"UP ARROWHEAD",
	"UP ARROWHEAD BETWEEN TWO HORIZONTAL BARS",
	"UP BARB LEFT DOWN BARB LEFT HARPOON",
	"UP BARB LEFT DOWN BARB RIGHT HARPOON",
	"UP BARB RIGHT DOWN BARB LEFT HARPOON",
	"UP BARB RIGHT DOWN BARB RIGHT HARPOON",
	"UP DOWN ARROW",
	"UP DOWN ARROW WITH BASE",
	"UP DOWN BLACK ARROW",
	"UP DOWN DOUBLE ARROW",
	"UP DOWN WHITE ARROW",
	"UP FISH TAIL",
	"UP RIGHT DIAGONAL ELLIPSIS",
	"UP TACK",
	"UP TACK WITH CIRCLE ABOVE",
	"UP-POINTING RED TRIANGLE",
	"UP-POINTING SMALL RED TRIANGLE",
	"UP-POINTING TRIANGLE WITH LEFT HALF BLACK",
	"UP-POINTING TRIANGLE WITH RIGHT HALF BLACK",
	"UPPER BLADE SCISSORS",
	"UPPER HALF BLOCK",
	"UPPER HALF CIRCLE",
	"UPPER HALF INVERSE WHITE CIRCLE",
	"UPPER LEFT CORNER WITH DOT",
	"UPPER LEFT OR LOWER RIGHT CURLY BRACKET SECTION",
	"UPPER LEFT QUADRANT CIRCULAR ARC",
	"UPPER LEFT TRIANGLE",
	"UPPER ONE EIGHTH BLOCK",
	"UPPER RIGHT DROP-SHADOWED WHITE SQUARE",
	"UPPER RIGHT OR LOWER LEFT CURLY BRACKET SECTION",
	"UPPER RIGHT PENCIL",
	"UPPER RIGHT QUADRANT CIRCULAR ARC",
	"UPPER RIGHT SHADOWED WHITE SQUARE",
	"UPPER RIGHT TRIANGLE",
	"UPWARDS ANCORA",
	"UPWARDS ARROW",
	"UPWARDS ARROW FROM BAR",
	"UPWARDS ARROW LEFTWARDS OF DOWNWARDS ARROW",
	"UPWARDS ARROW TO BAR",
	"UPWARDS ARROW WITH DOUBLE STROKE",
	"UPWARDS ARROW WITH HORIZONTAL STROKE",
	"UPWARDS ARROW WITH TIP LEFTWARDS",
	"UPWARDS ARROW WITH TIP RIGHTWARDS",
	"UPWARDS BLACK ARROW",
	"UPWARDS DASHED ARROW",
	"UPWARDS DOUBLE ARROW",
	"UPWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT",
	"UPWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT",
	"UPWARDS HARPOON WITH BARB LEFT FROM BAR",
	"UPWARDS HARPOON WITH BARB LEFT TO BAR",
	"UPWARDS HARPOON WITH BARB LEFTWARDS",
	"UPWARDS HARPOON WITH BARB RIGHT FROM BAR",
	"UPWARDS HARPOON WITH BARB RIGHT TO BAR",
	"UPWARDS HARPOON WITH BARB RIGHTWARDS",
	"UPWARDS PAIRED ARROWS",
	"UPWARDS QUADRUPLE ARROW",
	"UPWARDS TRIPLE ARROW",
	"UPWARDS TWO HEADED ARROW",
	"UPWARDS TWO-HEADED ARROW FROM SMALL CIRCLE",
	"UPWARDS WHITE ARROW",
	"UPWARDS WHITE ARROW FROM BAR",
	"UPWARDS WHITE ARROW ON PEDESTAL",
	"UPWARDS WHITE ARROW ON PEDESTAL WITH HORIZONTAL BAR",
	"UPWARDS WHITE ARROW ON PEDESTAL WITH VERTICAL BAR",
	"UPWARDS WHITE DOUBLE ARROW",
	"UPWARDS WHITE DOUBLE ARROW ON PEDESTAL",
	"URANUS",
	"VAI COMMA",
	"VAI DIGIT EIGHT",
	"VAI DIGIT FIVE",
	"VAI DIGIT FOUR",
	"VAI DIGIT NINE",
	"VAI DIGIT ONE",
	"VAI DIGIT SEVEN",
	"VAI DIGIT SIX",
	"VAI DIGIT THREE",
	"VAI DIGIT TWO",
	"VAI DIGIT ZERO",
	"VAI FULL STOP",
	"VAI QUESTION MARK",
	"VAI SYLLABLE A",
	"VAI SYLLABLE AN",
	"VAI SYLLABLE BA",
	"VAI SYLLABLE BE",
	"VAI SYLLABLE BEE",
	"VAI SYLLABLE BHA",
	"VAI SYLLABLE BHE",
	"VAI SYLLABLE BHEE",
	"VAI SYLLABLE BHI",
	"VAI SYLLABLE BHO",
	"VAI SYLLABLE BHOO",
	"VAI SYLLABLE BHU",
	"VAI SYLLABLE BI",
	"VAI SYLLABLE BO",
	"VAI SYLLABLE BOO",
	"VAI SYLLABLE BU",
	"VAI SYLLABLE CA",
	"VAI SYLLABLE CE",
	"VAI SYLLABLE CEE",
	"VAI SYLLABLE CI",
	"VAI SYLLABLE CO",
	"VAI SYLLABLE COO",
	"VAI SYLLABLE CU",
	"VAI SYLLABLE DA",
	"VAI SYLLABLE DE",
	"VAI SYLLABLE DEE",
	"VAI SYLLABLE DHA",
	"VAI SYLLABLE DHE",
	"VAI SYLLABLE DHEE",
	"VAI SYLLABLE DHHA",
	"VAI SYLLABLE DHHE",
	"VAI SYLLABLE DHHEE",
	"VAI SYLLABLE DHHI",
	"VAI SYLLABLE DHHO",
	"VAI SYLLABLE DHHOO",
	"VAI SYLLABLE DHHU",
	"VAI SYLLABLE DHI",
	"VAI SYLLABLE DHO",
	"VAI SYLLABLE DHOO",
	"VAI SYLLABLE DHU",
	"VAI SYLLABLE DI",
	"VAI SYLLABLE DO",
	"VAI SYLLABLE DOO",
	"VAI SYLLABLE DU",
	"VAI SYLLABLE E",
	"VAI SYLLABLE EE",
	"VAI SYLLABLE EEN",
	"VAI SYLLABLE EN",
	"VAI SYLLABLE FA",
	"VAI SYLLABLE FE",
	"VAI SYLLABLE FEE",
	"VAI SYLLABLE FI",
	"VAI SYLLABLE FO",
	"VAI SYLLABLE FOO",
	"VAI SYLLABLE FU",
	"VAI SYLLABLE GA",
	"VAI SYLLABLE GBA",
	"VAI SYLLABLE GBE",
	"VAI SYLLABLE GBEE",
	"VAI SYLLABLE GBEN",
	"VAI SYLLABLE GBI",
	"VAI SYLLABLE GBO",
	"VAI SYLLABLE GBON",
	"VAI SYLLABLE GBOO",
	"VAI SYLLABLE GBU",
	"VAI SYLLABLE GE",
	"VAI SYLLABLE GEE",
	"VAI SYLLABLE GEN",
	"VAI SYLLABLE GI",
	"VAI SYLLABLE GO",
	"VAI SYLLABLE GOO",
	"VAI SYLLABLE GU",
	"VAI SYLLABLE HA",
	"VAI SYLLABLE HAN",
	"VAI SYLLABLE HE",
	"VAI SYLLABLE HEE",
	"VAI SYLLABLE HEN",
	"VAI SYLLABLE HI",
	"VAI SYLLABLE HIN",
	"VAI SYLLABLE HO",
	"VAI SYLLABLE HON",
	"VAI SYLLABLE HOO",
	"VAI SYLLABLE HU",
	"VAI SYLLABLE HUN",
	"VAI SYLLABLE I",
	"VAI SYLLABLE IN",
	"VAI SYLLABLE JA",
	"VAI SYLLABLE JE",
	"VAI SYLLABLE JEE",
	"VAI SYLLABLE JI",
	"VAI SYLLABLE JO",
	"VAI SYLLABLE JOO",
	"VAI SYLLABLE JU",
	"VAI SYLLABLE KA",
	"VAI SYLLABLE KAN",
	"VAI SYLLABLE KE",
	"VAI SYLLABLE KEE",
	"VAI SYLLABLE KI",
	"VAI SYLLABLE KO",
	"VAI SYLLABLE KOO",
	"VAI SYLLABLE KPA",
	"VAI SYLLABLE KPAN",
	"VAI SYLLABLE KPE",
	"VAI SYLLABLE KPEE",
	"VAI SYLLABLE KPEN",
	"VAI SYLLABLE KPI",
	"VAI SYLLABLE KPO",
	"VAI SYLLABLE KPOO",
	"VAI SYLLABLE KPU",
	"VAI SYLLABLE KU",
	"VAI SYLLABLE LA",
	"VAI SYLLABLE LE",
	"VAI SYLLABLE LEE",
	"VAI SYLLABLE LENGTHENER",
	"VAI SYLLABLE LI",
	"VAI SYLLABLE LO",
	"VAI SYLLABLE LOO",
	"VAI SYLLABLE LU",
	"VAI SYLLABLE MA",
	"VAI SYLLABLE MBA",
	"VAI SYLLABLE MBE",
	"VAI SYLLABLE MBEE",
	"VAI SYLLABLE MBI",
	"VAI SYLLABLE MBO",
	"VAI SYLLABLE MBOO",
	"VAI SYLLABLE MBU",
	"VAI SYLLABLE ME",
	"VAI SYLLABLE MEE",
	"VAI SYLLABLE MGBA",
	"VAI SYLLABLE MGBE",
	"VAI SYLLABLE MGBEE",
	"VAI SYLLABLE MGBI",
	"VAI SYLLABLE MGBO",
	"VAI SYLLABLE MGBOO",
	"VAI SYLLABLE MGBU",
	"VAI SYLLABLE MI",
	"VAI SYLLABLE MO",
	"VAI SYLLABLE MOO",
	"VAI SYLLABLE MU",
	"VAI SYLLABLE NA",
	"VAI SYLLABLE NDA",
	"VAI SYLLABLE NDE",
	"VAI SYLLABLE NDEE",
	"VAI SYLLABLE NDI",
	"VAI SYLLABLE NDO",
	"VAI SYLLABLE NDOLE DO",
	"VAI SYLLABLE NDOLE FA",
	"VAI SYLLABLE NDOLE KA",
	"VAI SYLLABLE NDOLE MA",
	"VAI SYLLABLE NDOLE SOO",
	"VAI SYLLABLE NDOO",
	"VAI SYLLABLE NDU",
	"VAI SYLLABLE NE",
	"VAI SYLLABLE NEE",
	"VAI SYLLABLE NG",
	"VAI SYLLABLE NGAN",
	"VAI SYLLABLE NGEN",
	"VAI SYLLABLE NGGA",
	"VAI SYLLABLE NGGE",
	"VAI SYLLABLE NGGEE",
	"VAI SYLLABLE NGGEN",
	"VAI SYLLABLE NGGI",
	"VAI SYLLABLE NGGO",
	"VAI SYLLABLE NGGOO",
	"VAI SYLLABLE NGGU",
	"VAI SYLLABLE NGON",
	"VAI SYLLABLE NI",
	"VAI SYLLABLE NJA",
	"VAI SYLLABLE NJE",
	"VAI SYLLABLE NJEE",
	"VAI SYLLABLE NJI",
	"VAI SYLLABLE NJO",
	"VAI SYLLABLE NJOO",
	"VAI SYLLABLE NJU",
	"VAI SYLLABLE NO",
	"VAI SYLLABLE NOO",
	"VAI SYLLABLE NU",
	"VAI SYLLABLE NYA",
	"VAI SYLLABLE NYE",
	"VAI SYLLABLE NYEE",
	"VAI SYLLABLE NYI",
	"VAI SYLLABLE NYO",
	"VAI SYLLABLE NYOO",
	"VAI SYLLABLE NYU",
	"VAI SYLLABLE O",
	"VAI SYLLABLE ON",
	"VAI SYLLABLE OO",
	"VAI SYLLABLE OON",
	"VAI SYLLABLE PA",
	"VAI SYLLABLE PE",
	"VAI SYLLABLE PEE",
	"VAI SYLLABLE PI",
	"VAI SYLLABLE PO",
	"VAI SYLLABLE POO",
	"VAI SYLLABLE PU",
	"VAI SYLLABLE RA",
	"VAI SYLLABLE RE",
	"VAI SYLLABLE REE",
	"VAI SYLLABLE RI",
	"VAI SYLLABLE RO",
	"VAI SYLLABLE ROO",
	"VAI SYLLABLE RU",
	"VAI SYLLABLE SA",
	"VAI SYLLABLE SE",
	"VAI SYLLABLE SEE",
	"VAI SYLLABLE SHA",
	"VAI SYLLABLE SHE",
	"VAI SYLLABLE SHEE",
	"VAI SYLLABLE SHI",
	"VAI SYLLABLE SHO",
	"VAI SYLLABLE SHOO",
	"VAI SYLLABLE SHU",
	"VAI SYLLABLE SI",
	"VAI SYLLABLE SO",
	"VAI SYLLABLE SOO",
	"VAI SYLLABLE SU",
	"VAI SYLLABLE TA",
	"VAI SYLLABLE TE",
	"VAI SYLLABLE TEE",
	"VAI SYLLABLE THA",
	"VAI SYLLABLE THE",
	"VAI SYLLABLE THEE",
	"VAI SYLLABLE THI",
	"VAI SYLLABLE THO",
	"VAI SYLLABLE THOO",
	"VAI SYLLABLE THU",
	"VAI SYLLABLE TI",
	"VAI SYLLABLE TO",
	"VAI SYLLABLE TOO",
	"VAI SYLLABLE TU",
	"VAI SYLLABLE U",
	"VAI SYLLABLE UN",
	"VAI SYLLABLE VA",
	"VAI SYLLABLE VE",
	"VAI SYLLABLE VEE",
	"VAI SYLLABLE VI",
	"VAI SYLLABLE VO",
	"VAI SYLLABLE VOO",
	"VAI SYLLABLE VU",
	"VAI SYLLABLE WA",
	"VAI SYLLABLE WAN",
	"VAI SYLLABLE WE",
	"VAI SYLLABLE WEE",
	"VAI SYLLABLE WEEN",
	"VAI SYLLABLE WEN",
	"VAI SYLLABLE WI",
	"VAI SYLLABLE WIN",
	"VAI SYLLABLE WO",
	"VAI SYLLABLE WON",
	"VAI SYLLABLE WOO",
	"VAI SYLLABLE WOON",
	"VAI SYLLABLE WU",
	"VAI SYLLABLE WUN",
	"VAI SYLLABLE YA",
	"VAI SYLLABLE YE",
	"VAI SYLLABLE YEE",
	"VAI SYLLABLE YI",
	"VAI SYLLABLE YO",
	"VAI SYLLABLE YOO",
	"VAI SYLLABLE YU",
	"VAI SYLLABLE ZA",
	"VAI SYLLABLE ZE",
	"VAI SYLLABLE ZEE",
	"VAI SYLLABLE ZHA",
	"VAI SYLLABLE ZHE",
	"VAI SYLLABLE ZHEE",
	"VAI SYLLABLE ZHI",
	"VAI SYLLABLE ZHO",
	"VAI SYLLABLE ZHOO",
	"VAI SYLLABLE ZHU",
	"VAI SYLLABLE ZI",
	"VAI SYLLABLE ZO",
	"VAI SYLLABLE ZOO",
	"VAI SYLLABLE ZU",
	"VAI SYMBOL BANG",
	"VAI SYMBOL DANG",
	"VAI SYMBOL DO-O",
	"VAI SYMBOL DOONG",
	"VAI SYMBOL FAA",
	"VAI SYMBOL FEENG",
	"VAI SYMBOL JONG",
	"VAI SYMBOL KEENG",
	"VAI SYMBOL KUNG",
	"VAI SYMBOL NII",
	"VAI SYMBOL TAA",
	"VAI SYMBOL TING",
	"VAI SYMBOL TONG",
	"VECTOR OR CROSS PRODUCT",
	"VEDIC SIGN ANUSVARA ANTARGOMUKHA",
	"VEDIC SIGN ANUSVARA BAHIRGOMUKHA",
	"VEDIC SIGN ANUSVARA UBHAYATO MUKHA",
	"VEDIC SIGN ANUSVARA VAMAGOMUKHA",
	"VEDIC SIGN ANUSVARA VAMAGOMUKHA WITH TAIL",
	"VEDIC SIGN ARDHAVISARGA",
	"VEDIC SIGN HEXIFORM LONG ANUSVARA",
	"VEDIC SIGN JIHVAMULIYA",
	"VEDIC SIGN LONG ANUSVARA",
	"VEDIC SIGN NIHSHVASA",
	"VEDIC SIGN REVERSED VISARGA ANUDATTA",
	"VEDIC SIGN REVERSED VISARGA UDATTA",
	"VEDIC SIGN ROTATED ARDHAVISARGA",
	"VEDIC SIGN RTHANG LONG ANUSVARA",
	"VEDIC SIGN TIRYAK",
	"VEDIC SIGN UPADHMANIYA",
	"VEDIC SIGN VISARGA ANUDATTA",
	"VEDIC SIGN VISARGA ANUDATTA WITH TAIL",
	"VEDIC SIGN VISARGA SVARITA",
	"VEDIC SIGN VISARGA UDATTA",
	"VEDIC SIGN VISARGA UDATTA WITH TAIL",
	"VEDIC SIGN YAJURVEDIC MIDLINE SVARITA",
	"VEDIC TONE ATHARVAVEDIC INDEPENDENT SVARITA",
	"VEDIC TONE CANDRA ABOVE",
	"VEDIC TONE CANDRA BELOW",
	"VEDIC TONE DOT BELOW",
	"VEDIC TONE DOUBLE SVARITA",
	"VEDIC TONE KARSHANA",
	"VEDIC TONE KATHAKA ANUDATTA",
	"VEDIC TONE PRENKHA",
	"VEDIC TONE RIGVEDIC KASHMIRI INDEPENDENT SVARITA",
	"VEDIC TONE SHARA",
	"VEDIC TONE THREE DOTS BELOW",
	"VEDIC TONE TRIPLE SVARITA",
	"VEDIC TONE TWO DOTS BELOW",
	"VEDIC TONE YAJURVEDIC AGGRAVATED INDEPENDENT SVARITA",
	"VEDIC TONE YAJURVEDIC INDEPENDENT SVARITA",
	"VEDIC TONE YAJURVEDIC KATHAKA INDEPENDENT SVARITA",
	"VEDIC TONE YAJURVEDIC KATHAKA INDEPENDENT SVARITA SCHROEDER",
	"VERSICLE",
	"VERTICAL BAR BESIDE RIGHT TRIANGLE",
	"VERTICAL BAR DOUBLE LEFT TURNSTILE",
	"VERTICAL BAR TRIPLE RIGHT TURNSTILE",
	"VERTICAL BAR WITH HORIZONTAL STROKE",
	"VERTICAL ELLIPSIS",
	"VERTICAL FOUR DOTS",
	"VERTICAL IDEOGRAPHIC ITERATION MARK",
	"VERTICAL KANA REPEAT MARK",
	"VERTICAL KANA REPEAT MARK LOWER HALF",
	"VERTICAL KANA REPEAT MARK UPPER HALF",
	"VERTICAL KANA REPEAT WITH VOICED SOUND MARK",
	"VERTICAL KANA REPEAT WITH VOICED SOUND MARK UPPER HALF",
	"VERTICAL LINE",
	"VERTICAL LINE EXTENSION",
	"VERTICAL LINE WITH CIRCLE ABOVE",
	"VERTICAL LINE WITH CIRCLE BELOW",
	"VERTICAL LINE WITH MIDDLE DOT",
	"VERTICAL MALE WITH STROKE SIGN",
	"VERTICAL TILDE",
	"VERTICAL TRAFFIC LIGHT",
	"VERTICAL ZIGZAG LINE",
	"VERY MUCH GREATER-THAN",
	"VERY MUCH LESS-THAN",
	"VESTA",
	"VIBRATION MODE",
	"VICTORY HAND",
	"VIDEO CAMERA",
	"VIDEO GAME",
	"VIDEOCASSETTE",
	"VIEWDATA SQUARE",
	"VIOLIN",
	"VIRGO",
	"VOLCANO",
	"VOLUME INTEGRAL",
	"VULGAR FRACTION FIVE EIGHTHS",
	"VULGAR FRACTION FIVE SIXTHS",
	"VULGAR FRACTION FOUR FIFTHS",
	"VULGAR FRACTION ONE EIGHTH",
	"VULGAR FRACTION ONE FIFTH",
	"VULGAR FRACTION ONE HALF",
	"VULGAR FRACTION ONE NINTH",
	"VULGAR FRACTION ONE QUARTER",
	"VULGAR FRACTION ONE SEVENTH",
	"VULGAR FRACTION ONE SIXTH",
	"VULGAR FRACTION ONE TENTH",
	"VULGAR FRACTION ONE THIRD",
	"VULGAR FRACTION SEVEN EIGHTHS",
	"VULGAR FRACTION THREE EIGHTHS",
	"VULGAR FRACTION THREE FIFTHS",
	"VULGAR FRACTION THREE QUARTERS",
	"VULGAR FRACTION TWO FIFTHS",
	"VULGAR FRACTION TWO THIRDS",
	"VULGAR FRACTION ZERO THIRDS",
	"WANING CRESCENT MOON SYMBOL",
	"WANING GIBBOUS MOON SYMBOL",
	"WARNING SIGN",
	"WATCH",
	"WATER BUFFALO",
	"WATER CLOSET",
	"WATER WAVE",
	"WATERMELON",
	"WAVE ARROW POINTING DIRECTLY LEFT",
	"WAVE ARROW POINTING DIRECTLY RIGHT",
	"WAVE DASH",
	"WAVING HAND SIGN",
	"WAVY DASH",
	"WAVY LINE",
	"WAVY LOW LINE",
	"WAVY OVERLINE",
	"WAXING CRESCENT MOON SYMBOL",
	"WAXING GIBBOUS MOON SYMBOL",
	"WEARY CAT FACE",
	"WEARY FACE",
	"WEDDING",
	"WEDGE-TAILED RIGHTWARDS ARROW",
	"WEST SYRIAC CROSS",
	"WHALE",
	"WHEEL OF DHARMA",
	"WHEELCHAIR SYMBOL",
	"WHITE BULLET",
	"WHITE CHESS BISHOP",
	"WHITE CHESS KING",
	"WHITE CHESS KNIGHT",
	"WHITE CHESS PAWN",
	"WHITE CHESS QUEEN",
	"WHITE CHESS ROOK",
	"WHITE CIRCLE",
	"WHITE CIRCLE WITH DOT RIGHT",
	"WHITE CIRCLE WITH DOWN ARROW",
	"WHITE CIRCLE WITH LOWER LEFT QUADRANT",
	"WHITE CIRCLE WITH LOWER RIGHT QUADRANT",
	"WHITE CIRCLE WITH TWO DOTS",
	"WHITE CIRCLE WITH UPPER LEFT QUADRANT",
	"WHITE CIRCLE WITH UPPER RIGHT QUADRANT",
	"WHITE CLUB SUIT",
	"WHITE CONCAVE-SIDED DIAMOND",
	"WHITE CONCAVE-SIDED DIAMOND WITH LEFTWARDS TICK",
	"WHITE CONCAVE-SIDED DIAMOND WITH RIGHTWARDS TICK",
	"WHITE DIAMOND",
	"WHITE DIAMOND CONTAINING BLACK SMALL DIAMOND",
	"WHITE DIAMOND IN SQUARE",
	"WHITE DIAMOND SUIT",
	"WHITE DIAMOND WITH CENTRED DOT",
	"WHITE DOWN POINTING BACKHAND INDEX",
	"WHITE DOWN POINTING INDEX",
	"WHITE DOWN-POINTING SMALL TRIANGLE",
	"WHITE DOWN-POINTING TRIANGLE",
	"WHITE DRAUGHTS KING",
	"WHITE DRAUGHTS MAN",
	"WHITE EXCLAMATION MARK ORNAMENT",
	"WHITE FLAG",
	"WHITE FLAG WITH HORIZONTAL MIDDLE BLACK STRIPE",
	"WHITE FLORETTE",
	"WHITE FLOWER",
	"WHITE FOUR POINTED STAR",
	"WHITE FROWNING FACE",
	"WHITE HEART SUIT",
	"WHITE HEAVY CHECK MARK",
	"WHITE HEXAGON",
	"WHITE HORIZONTAL ELLIPSE",
	"WHITE HOURGLASS",
	"WHITE LARGE SQUARE",
	"WHITE LEFT LANE MERGE",
	"WHITE LEFT POINTING BACKHAND INDEX",
	"WHITE LEFT POINTING INDEX",
	"WHITE LEFT-POINTING POINTER",
	"WHITE LEFT-POINTING SMALL TRIANGLE",
	"WHITE LEFT-POINTING TRIANGLE",
	"WHITE MEDIUM DIAMOND",
	"WHITE MEDIUM LOZENGE",
	"WHITE MEDIUM SMALL SQUARE",
	"WHITE MEDIUM SQUARE",
	"WHITE MEDIUM STAR",
	"WHITE NIB",
	"WHITE PARALLELOGRAM",
	"WHITE PENTAGON",
	"WHITE QUESTION MARK ORNAMENT",
	"WHITE RECTANGLE",
	"WHITE RIGHT POINTING BACKHAND INDEX",
	"WHITE RIGHT POINTING INDEX",
	"WHITE RIGHT-POINTING PENTAGON",
	"WHITE RIGHT-POINTING POINTER",
	"WHITE RIGHT-POINTING SMALL TRIANGLE",
	"WHITE RIGHT-POINTING TRIANGLE",
	"WHITE SCISSORS",
	"WHITE SESAME DOT",
	"WHITE SHOGI PIECE",
	"WHITE SMALL LOZENGE",
	"WHITE SMALL SQUARE",
	"WHITE SMALL STAR",
	"WHITE SMILING FACE",
	"WHITE SPADE SUIT",
	"WHITE SQUARE",
	"WHITE SQUARE BUTTON",
	"WHITE SQUARE CONTAINING BLACK SMALL SQUARE",
	"WHITE SQUARE WITH CENTRE VERTICAL LINE",
	"WHITE SQUARE WITH LEFTWARDS TICK",
	"WHITE SQUARE WITH LOWER LEFT QUADRANT",
	"WHITE SQUARE WITH LOWER RIGHT QUADRANT",
	"WHITE SQUARE WITH RIGHTWARDS TICK",
	"WHITE SQUARE WITH ROUNDED CORNERS",
	"WHITE SQUARE WITH UPPER LEFT QUADRANT",
	"WHITE SQUARE WITH UPPER RIGHT QUADRANT",
	"WHITE SQUARE WITH VERTICAL BISECTING LINE",
	"WHITE STAR",
	"WHITE SUN WITH RAYS",
	"WHITE TELEPHONE",
	"WHITE TRAPEZIUM",
	"WHITE TRIANGLE CONTAINING SMALL WHITE TRIANGLE",
	"WHITE TWO-WAY LEFT WAY TRAFFIC",
	"WHITE UP POINTING BACKHAND INDEX",
	"WHITE UP POINTING INDEX",
	"WHITE UP-POINTING SMALL TRIANGLE",
	"WHITE UP-POINTING TRIANGLE",
	"WHITE UP-POINTING TRIANGLE WITH DOT",
	"WHITE VERTICAL BAR",
	"WHITE VERTICAL ELLIPSE",
	"WHITE VERTICAL RECTANGLE",
	"WHITE VERY SMALL SQUARE",
	"WHITE-FEATHERED RIGHTWARDS ARROW",
	"WIND CHIME",
	"WINE GLASS",
	"WINKING FACE",
	"WOLF FACE",
	"WOMAN",
	"WOMAN WITH BUNNY EARS",
	"WOMANS BOOTS",
	"WOMANS CLOTHES",
	"WOMANS HAT",
	"WOMANS SANDAL",
	"WOMENS SYMBOL",
	"WON SIGN",
	"WORD JOINER",
	"WORD SEPARATOR MIDDLE DOT",
	"WORRIED FACE",
	"WRAPPED PRESENT",
	"WREATH PRODUCT",
	"WRENCH",
	"WRITING HAND",
	"X IN A RECTANGLE BOX",
	"XOR",
	"YELLOW HEART",
	"YEN SIGN",
	"YI RADICAL BBUT",
	"YI RADICAL BUR",
	"YI RADICAL CHE",
	"YI RADICAL CIP",
	"YI RADICAL CUOP",
	"YI RADICAL CY",
	"YI RADICAL CYP",
	"YI RADICAL CYT",
	"YI RADICAL DDUR",
	"YI RADICAL DU",
	"YI RADICAL GA",
	"YI RADICAL GEP",
	"YI RADICAL GGOP",
	"YI RADICAL GGUO",
	"YI RADICAL GOT",
	"YI RADICAL HMO",
	"YI RADICAL HXIT",
	"YI RADICAL HXOP",
	"YI RADICAL HXUO",
	"YI RADICAL JJIE",
	"YI RADICAL JJUT",
	"YI RADICAL JJY",
	"YI RADICAL JO",
	"YI RADICAL KE",
	"YI RADICAL KIT",
	"YI RADICAL LI",
	"YI RADICAL LIE",
	"YI RADICAL LYR",
	"YI RADICAL MI",
	"YI RADICAL MOP",
	"YI RADICAL NBIE",
	"YI RADICAL NYIP",
	"YI RADICAL NYOP",
	"YI RADICAL NZUP",
	"YI RADICAL OP",
	"YI RADICAL PUT",
	"YI RADICAL PYT",
	"YI RADICAL QOT",
	"YI RADICAL SHAT",
	"YI RADICAL SHOP",
	"YI RADICAL SHUR",
	"YI RADICAL SHY",
	"YI RADICAL SSI",
	"YI RADICAL TAT",
	"YI RADICAL TU",
	"YI RADICAL VEP",
	"YI RADICAL VUR",
	"YI RADICAL WO",
	"YI RADICAL YIT",
	"YI RADICAL YO",
	"YI RADICAL ZA",
	"YI RADICAL ZOT",
	"YI RADICAL ZUP",
	"YI RADICAL ZUR",
	"YI RADICAL ZZIET",
	"YI SYLLABLE A",
	"YI SYLLABLE AP",
	"YI SYLLABLE AT",
	"YI SYLLABLE AX",
	"YI SYLLABLE BA",
	"YI SYLLABLE BAP",
	"YI SYLLABLE BAT",
	"YI SYLLABLE BAX",
	"YI SYLLABLE BBA",
	"YI SYLLABLE BBAP",
	"YI SYLLABLE BBAT",
	"YI SYLLABLE BBAX",
	"YI SYLLABLE BBE",
	"YI SYLLABLE BBEP",
	"YI SYLLABLE BBEX",
	"YI SYLLABLE BBI",
	"YI SYLLABLE BBIE",
	"YI SYLLABLE BBIEP",
	"YI SYLLABLE BBIET",
	"YI SYLLABLE BBIEX",
	"YI SYLLABLE BBIP",
	"YI SYLLABLE BBIT",
	"YI SYLLABLE BBIX",
	"YI SYLLABLE BBO",
	"YI SYLLABLE BBOP",
	"YI SYLLABLE BBOT",
	"YI SYLLABLE BBOX",
	"YI SYLLABLE BBU",
	"YI SYLLABLE BBUO",
	"YI SYLLABLE BBUOP",
	"YI SYLLABLE BBUOX",
	"YI SYLLABLE BBUP",
	"YI SYLLABLE BBUR",
	"YI SYLLABLE BBURX",
	"YI SYLLABLE BBUT",
	"YI SYLLABLE BBUX",
	"YI SYLLABLE BBY",
	"YI SYLLABLE BBYP",
	"YI SYLLABLE BBYT",
	"YI SYLLABLE BBYX",
	"YI SYLLABLE BE",
	"YI SYLLABLE BEP",
	"YI SYLLABLE BEX",
	"YI SYLLABLE BI",
	"YI SYLLABLE BIE",
	"YI SYLLABLE BIEP",
	"YI SYLLABLE BIET",
	"YI SYLLABLE BIEX",
	"YI SYLLABLE BIP",
	"YI SYLLABLE BIT",
	"YI SYLLABLE BIX",
	"YI SYLLABLE BO",
	"YI SYLLABLE BOP",
	"YI SYLLABLE BOT",
	"YI SYLLABLE BOX",
	"YI SYLLABLE BU",
	"YI SYLLABLE BUO",
	"YI SYLLABLE BUOP",
	"YI SYLLABLE BUOX",
	"YI SYLLABLE BUP",
	"YI SYLLABLE BUR",
	"YI SYLLABLE BURX",
	"YI SYLLABLE BUT",
	"YI SYLLABLE BUX",
	"YI SYLLABLE BY",
	"YI SYLLABLE BYP",
	"YI SYLLABLE BYR",
	"YI SYLLABLE BYRX",
	"YI SYLLABLE BYT",
	"YI SYLLABLE BYX",
	"YI SYLLABLE CA",
	"YI SYLLABLE CAP",
	"YI SYLLABLE CAT",
	"YI SYLLABLE CAX",
	"YI SYLLABLE CE",
	"YI SYLLABLE CEP",
	"YI SYLLABLE CEX",
	"YI SYLLABLE CHA",
	"YI SYLLABLE CHAP",
	"YI SYLLABLE CHAT",
	"YI SYLLABLE CHAX",
	"YI SYLLABLE CHE",
	"YI SYLLABLE CHEP",
	"YI SYLLABLE CHET",
	"YI SYLLABLE CHEX",
	"YI SYLLABLE CHO",
	"YI SYLLABLE CHOP",
	"YI SYLLABLE CHOT",
	"YI SYLLABLE CHOX",
	"YI SYLLABLE CHU",
	"YI SYLLABLE CHUO",
	"YI SYLLABLE CHUOP",
	"YI SYLLABLE CHUOT",
	"YI SYLLABLE CHUOX",
	"YI SYLLABLE CHUP",
	"YI SYLLABLE CHUR",
	"YI SYLLABLE CHURX",
	"YI SYLLABLE CHUX",
	"YI SYLLABLE CHY",
	"YI SYLLABLE CHYP",
	"YI SYLLABLE CHYR",
	"YI SYLLABLE CHYRX",
	"YI SYLLABLE CHYT",
	"YI SYLLABLE CHYX",
	"YI SYLLABLE CI",
	"YI SYLLABLE CIE",
	"YI SYLLABLE CIEP",
	"YI SYLLABLE CIET",
	"YI SYLLABLE CIEX",
	"YI SYLLABLE CIP",
	"YI SYLLABLE CIT",
	"YI SYLLABLE CIX",
	"YI SYLLABLE CO",
	"YI SYLLABLE COP",
	"YI SYLLABLE COT",
	"YI SYLLABLE COX",
	"YI SYLLABLE CU",
	"YI SYLLABLE CUO",
	"YI SYLLABLE CUOP",
	"YI SYLLABLE CUOX",
	"YI SYLLABLE CUP",
	"YI SYLLABLE CUR",
	"YI SYLLABLE CURX",
	"YI SYLLABLE CUT",
	"YI SYLLABLE CUX",
	"YI SYLLABLE CY",
	"YI SYLLABLE CYP",
	"YI SYLLABLE CYR",
	"YI SYLLABLE CYRX",
	"YI SYLLABLE CYT",
	"YI SYLLABLE CYX",
	"YI SYLLABLE DA",
	"YI SYLLABLE DAP",
	"YI SYLLABLE DAT",
	"YI SYLLABLE DAX",
	"YI SYLLABLE DDA",
	"YI SYLLABLE DDAP",
	"YI SYLLABLE DDAT",
	"YI SYLLABLE DDAX",
	"YI SYLLABLE DDE",
	"YI SYLLABLE DDEP",
	"YI SYLLABLE DDEX",
	"YI SYLLABLE DDI",
	"YI SYLLABLE DDIE",
	"YI SYLLABLE DDIEP",
	"YI SYLLABLE DDIEX",
	"YI SYLLABLE DDIP",
	"YI SYLLABLE DDIT",
	"YI SYLLABLE DDIX",
	"YI SYLLABLE DDO",
	"YI SYLLABLE DDOP",
	"YI SYLLABLE DDOT",
	"YI SYLLABLE DDOX",
	"YI SYLLABLE DDU",
	"YI SYLLABLE DDUO",
	"YI SYLLABLE DDUOP",
	"YI SYLLABLE DDUOX",
	"YI SYLLABLE DDUP",
	"YI SYLLABLE DDUR",
	"YI SYLLABLE DDURX",
	"YI SYLLABLE DDUT",
	"YI SYLLABLE DDUX",
	"YI SYLLABLE DE",
	"YI SYLLABLE DEP",
	"YI SYLLABLE DEX",
	"YI SYLLABLE DI",
	"YI SYLLABLE DIE",
	"YI SYLLABLE DIEP",
	"YI SYLLABLE DIEX",
	"YI SYLLABLE DIP",
	"YI SYLLABLE DIT",
	"YI SYLLABLE DIX",
	"YI SYLLABLE DO",
	"YI SYLLABLE DOP",
	"YI SYLLABLE DOT",
	"YI SYLLABLE DOX",
	"YI SYLLABLE DU",
	"YI SYLLABLE DUO",
	"YI SYLLABLE DUOX",
	"YI SYLLABLE DUP",
	"YI SYLLABLE DUR",
	"YI SYLLABLE DURX",
	"YI SYLLABLE DUT",
	"YI SYLLABLE DUX",
	"YI SYLLABLE E",
	"YI SYLLABLE EX",
	"YI SYLLABLE FA",
	"YI SYLLABLE FAP",
	"YI SYLLABLE FAT",
	"YI SYLLABLE FAX",
	"YI SYLLABLE FI",
	"YI SYLLABLE FIP",
	"YI SYLLABLE FIT",
	"YI SYLLABLE FIX",
	"YI SYLLABLE FO",
	"YI SYLLABLE FOP",
	"YI SYLLABLE FOX",
	"YI SYLLABLE FU",
	"YI SYLLABLE FUP",
	"YI SYLLABLE FUR",
	"YI SYLLABLE FURX",
	"YI SYLLABLE FUT",
	"YI SYLLABLE FUX",
	"YI SYLLABLE FY",
	"YI SYLLABLE FYP",
	"YI SYLLABLE FYT",
	"YI SYLLABLE FYX",
	"YI SYLLABLE GA",
	"YI SYLLABLE GAP",
	"YI SYLLABLE GAT",
	"YI SYLLABLE GAX",
	"YI SYLLABLE GE",
	"YI SYLLABLE GEP",
	"YI SYLLABLE GET",
	"YI SYLLABLE GEX",
	"YI SYLLABLE GGA",
	"YI SYLLABLE GGAP",
	"YI SYLLABLE GGAT",
	"YI SYLLABLE GGAX",
	"YI SYLLABLE GGE",
	"YI SYLLABLE GGEP",
	"YI SYLLABLE GGET",
	"YI SYLLABLE GGEX",
	"YI SYLLABLE GGI",
	"YI SYLLABLE GGIE",
	"YI SYLLABLE GGIEP",
	"YI SYLLABLE GGIEX",
	"YI SYLLABLE GGIT",
	"YI SYLLABLE GGIX",
	"YI SYLLABLE GGO",
	"YI SYLLABLE GGOP",
	"YI SYLLABLE GGOT",
	"YI SYLLABLE GGOX",
	"YI SYLLABLE GGU",
	"YI SYLLABLE GGUO",
	"YI SYLLABLE GGUOP",
	"YI SYLLABLE GGUOT",
	"YI SYLLABLE GGUOX",
	"YI SYLLABLE GGUP",
	"YI SYLLABLE GGUR",
	"YI SYLLABLE GGURX",
	"YI SYLLABLE GGUT",
	"YI SYLLABLE GGUX",
	"YI SYLLABLE GI",
	"YI SYLLABLE GIE",
	"YI SYLLABLE GIEP",
	"YI SYLLABLE GIET",
	"YI SYLLABLE GIEX",
	"YI SYLLABLE GIP",
	"YI SYLLABLE GIT",
	"YI SYLLABLE GIX",
	"YI SYLLABLE GO",
	"YI SYLLABLE GOP",
	"YI SYLLABLE GOT",
	"YI SYLLABLE GOX",
	"YI SYLLABLE GU",
	"YI SYLLABLE GUO",
	"YI SYLLABLE GUOP",
	"YI SYLLABLE GUOT",
	"YI SYLLABLE GUOX",
	"YI SYLLABLE GUP",
	"YI SYLLABLE GUR",
	"YI SYLLABLE GURX",
	"YI SYLLABLE GUT",
	"YI SYLLABLE GUX",
	"YI SYLLABLE HA",
	"YI SYLLABLE HAP",
	"YI SYLLABLE HAT",
	"YI SYLLABLE HAX",
	"YI SYLLABLE HE",
	"YI SYLLABLE HEP",
	"YI SYLLABLE HEX",
	"YI SYLLABLE HIE",
	"YI SYLLABLE HIEX",
	"YI SYLLABLE HIT",
	"YI SYLLABLE HLA",
	"YI SYLLABLE HLAP",
	"YI SYLLABLE HLAT",
	"YI SYLLABLE HLAX",
	"YI SYLLABLE HLE",
	"YI SYLLABLE HLEP",
	"YI SYLLABLE HLEX",
	"YI SYLLABLE HLI",
	"YI SYLLABLE HLIE",
	"YI SYLLABLE HLIEP",
	"YI SYLLABLE HLIEX",
	"YI SYLLABLE HLIP",
	"YI SYLLABLE HLIT",
	"YI SYLLABLE HLIX",
	"YI SYLLABLE HLO",
	"YI SYLLABLE HLOP",
	"YI SYLLABLE HLOX",
	"YI SYLLABLE HLU",
	"YI SYLLABLE HLUO",
	"YI SYLLABLE HLUOP",
	"YI SYLLABLE HLUOX",
	"YI SYLLABLE HLUP",
	"YI SYLLABLE HLUR",
	"YI SYLLABLE HLURX",
	"YI SYLLABLE HLUT",
	"YI SYLLABLE HLUX",
	"YI SYLLABLE HLY",
	"YI SYLLABLE HLYP",
	"YI SYLLABLE HLYR",
	"YI SYLLABLE HLYRX",
	"YI SYLLABLE HLYT",
	"YI SYLLABLE HLYX",
	"YI SYLLABLE HMA",
	"YI SYLLABLE HMAP",
	"YI SYLLABLE HMAT",
	"YI SYLLABLE HMAX",
	"YI SYLLABLE HMI",
	"YI SYLLABLE HMIE",
	"YI SYLLABLE HMIEP",
	"YI SYLLABLE HMIEX",
	"YI SYLLABLE HMIP",
	"YI SYLLABLE HMIT",
	"YI SYLLABLE HMIX",
	"YI SYLLABLE HMO",
	"YI SYLLABLE HMOP",
	"YI SYLLABLE HMOT",
	"YI SYLLABLE HMOX",
	"YI SYLLABLE HMU",
	"YI SYLLABLE HMUO",
	"YI SYLLABLE HMUOP",
	"YI SYLLABLE HMUOX",
	"YI SYLLABLE HMUP",
	"YI SYLLABLE HMUR",
	"YI SYLLABLE HMURX",
	"YI SYLLABLE HMUT",
	"YI SYLLABLE HMUX",
	"YI SYLLABLE HMY",
	"YI SYLLABLE HMYP",
	"YI SYLLABLE HMYR",
	"YI SYLLABLE HMYRX",
	"YI SYLLABLE HMYX",
	"YI SYLLABLE HNA",
	"YI SYLLABLE HNAP",
	"YI SYLLABLE HNAT",
	"YI SYLLABLE HNAX",
	"YI SYLLABLE HNE",
	"YI SYLLABLE HNEP",
	"YI SYLLABLE HNEX",
	"YI SYLLABLE HNI",
	"YI SYLLABLE HNIE",
	"YI SYLLABLE HNIEP",
	"YI SYLLABLE HNIET",
	"YI SYLLABLE HNIEX",
	"YI SYLLABLE HNIP",
	"YI SYLLABLE HNIT",
	"YI SYLLABLE HNIX",
	"YI SYLLABLE HNOP",
	"YI SYLLABLE HNOT",
	"YI SYLLABLE HNOX",
	"YI SYLLABLE HNUO",
	"YI SYLLABLE HNUOX",
	"YI SYLLABLE HNUT",
	"YI SYLLABLE HO",
	"YI SYLLABLE HOP",
	"YI SYLLABLE HOT",
	"YI SYLLABLE HOX",
	"YI SYLLABLE HUO",
	"YI SYLLABLE HUOP",
	"YI SYLLABLE HUOT",
	"YI SYLLABLE HUOX",
	"YI SYLLABLE HXA",
	"YI SYLLABLE HXAP",
	"YI SYLLABLE HXAT",
	"YI SYLLABLE HXAX",
	"YI SYLLABLE HXE",
	"YI SYLLABLE HXEP",
	"YI SYLLABLE HXEX",
	"YI SYLLABLE HXI",
	"YI SYLLABLE HXIE",
	"YI SYLLABLE HXIEP",
	"YI SYLLABLE HXIET",
	"YI SYLLABLE HXIEX",
	"YI SYLLABLE HXIP",
	"YI SYLLABLE HXIT",
	"YI SYLLABLE HXIX",
	"YI SYLLABLE HXO",
	"YI SYLLABLE HXOP",
	"YI SYLLABLE HXOT",
	"YI SYLLABLE HXOX",
	"YI SYLLABLE HXUO",
	"YI SYLLABLE HXUOP",
	"YI SYLLABLE HXUOT",
	"YI SYLLABLE HXUOX",
	"YI SYLLABLE I",
	"YI SYLLABLE IE",
	"YI SYLLABLE IEP",
	"YI SYLLABLE IET",
	"YI SYLLABLE IEX",
	"YI SYLLABLE IP",
	"YI SYLLABLE IT",
	"YI SYLLABLE IX",
	"YI SYLLABLE JI",
	"YI SYLLABLE JIE",
	"YI SYLLABLE JIEP",
	"YI SYLLABLE JIET",
	"YI SYLLABLE JIEX",
	"YI SYLLABLE JIP",
	"YI SYLLABLE JIT",
	"YI SYLLABLE JIX",
	"YI SYLLABLE JJI",
	"YI SYLLABLE JJIE",
	"YI SYLLABLE JJIEP",
	"YI SYLLABLE JJIET",
	"YI SYLLABLE JJIEX",
	"YI SYLLABLE JJIP",
	"YI SYLLABLE JJIT",
	"YI SYLLABLE JJIX",
	"YI SYLLABLE JJO",
	"YI SYLLABLE JJOP",
	"YI SYLLABLE JJOT",
	"YI SYLLABLE JJOX",
	"YI SYLLABLE JJU",
	"YI SYLLABLE JJUO",
	"YI SYLLABLE JJUOP",
	"YI SYLLABLE JJUOX",
	"YI SYLLABLE JJUP",
	"YI SYLLABLE JJUR",
	"YI SYLLABLE JJURX",
	"YI SYLLABLE JJUT",
	"YI SYLLABLE JJUX",
	"YI SYLLABLE JJY",
	"YI SYLLABLE JJYP",
	"YI SYLLABLE JJYT",
	"YI SYLLABLE JJYX",
	"YI SYLLABLE JO",
	"YI SYLLABLE JOP",
	"YI SYLLABLE JOT",
	"YI SYLLABLE JOX",
	"YI SYLLABLE JU",
	"YI SYLLABLE JUO",
	"YI SYLLABLE JUOP",
	"YI SYLLABLE JUOT",
	"YI SYLLABLE JUOX",
	"YI SYLLABLE JUP",
	"YI SYLLABLE JUR",
	"YI SYLLABLE JURX",
	"YI SYLLABLE JUT",
	"YI SYLLABLE JUX",
	"YI SYLLABLE JY",
	"YI SYLLABLE JYP",
	"YI SYLLABLE JYR",
	"YI SYLLABLE JYRX",
	"YI SYLLABLE JYT",
	"YI SYLLABLE JYX",
	"YI SYLLABLE KA",
	"YI SYLLABLE KAP",
	"YI SYLLABLE KAT",
	"YI SYLLABLE KAX",
	"YI SYLLABLE KE",
	"YI SYLLABLE KEP",
	"YI SYLLABLE KET",
	"YI SYLLABLE KEX",
	"YI SYLLABLE KI",
	"YI SYLLABLE KIE",
	"YI SYLLABLE KIEP",
	"YI SYLLABLE KIEX",
	"YI SYLLABLE KIP",
	"YI SYLLABLE KIT",
	"YI SYLLABLE KIX",
	"YI SYLLABLE KO",
	"YI SYLLABLE KOP",
	"YI SYLLABLE KOT",
	"YI SYLLABLE KOX",
	"YI SYLLABLE KU",
	"YI SYLLABLE KUO",
	"YI SYLLABLE KUOP",
	"YI SYLLABLE KUOX",
	"YI SYLLABLE KUP",
	"YI SYLLABLE KUR",
	"YI SYLLABLE KURX",
	"YI SYLLABLE KUT",
	"YI SYLLABLE KUX",
	"YI SYLLABLE LA",
	"YI SYLLABLE LAP",
	"YI SYLLABLE LAT",
	"YI SYLLABLE LAX",
	"YI SYLLABLE LE",
	"YI SYLLABLE LEP",
	"YI SYLLABLE LEX",
	"YI SYLLABLE LI",
	"YI SYLLABLE LIE",
	"YI SYLLABLE LIEP",
	"YI SYLLABLE LIET",
	"YI SYLLABLE LIEX",
	"YI SYLLABLE LIP",
	"YI SYLLABLE LIT",
	"YI SYLLABLE LIX",
	"YI SYLLABLE LO",
	"YI SYLLABLE LOP",
	"YI SYLLABLE LOT",
	"YI SYLLABLE LOX",
	"YI SYLLABLE LU",
	"YI SYLLABLE LUO",
	"YI SYLLABLE LUOP",
	"YI SYLLABLE LUOT",
	"YI SYLLABLE LUOX",
	"YI SYLLABLE LUP",
	"YI SYLLABLE LUR",
	"YI SYLLABLE LURX",
	"YI SYLLABLE LUT",
	"YI SYLLABLE LUX",
	"YI SYLLABLE LY",
	"YI SYLLABLE LYP",
	"YI SYLLABLE LYR",
	"YI SYLLABLE LYRX",
	"YI SYLLABLE LYT",
	"YI SYLLABLE LYX",
	"YI SYLLABLE MA",
	"YI SYLLABLE MAP",
	"YI SYLLABLE MAT",
	"YI SYLLABLE MAX",
	"YI SYLLABLE ME",
	"YI SYLLABLE MEX",
	"YI SYLLABLE MGA",
	"YI SYLLABLE MGAP",
	"YI SYLLABLE MGAT",
	"YI SYLLABLE MGAX",
	"YI SYLLABLE MGE",
	"YI SYLLABLE MGEP",
	"YI SYLLABLE MGEX",
	"YI SYLLABLE MGIE",
	"YI SYLLABLE MGIEX",
	"YI SYLLABLE MGO",
	"YI SYLLABLE MGOP",
	"YI SYLLABLE MGOT",
	"YI SYLLABLE MGOX",
	"YI SYLLABLE MGU",
	"YI SYLLABLE MGUO",
	"YI SYLLABLE MGUOP",
	"YI SYLLABLE MGUOX",
	"YI SYLLABLE MGUP",
	"YI SYLLABLE MGUR",
	"YI SYLLABLE MGURX",
	"YI SYLLABLE MGUT",
	"YI SYLLABLE MGUX",
	"YI SYLLABLE MI",
	"YI SYLLABLE MIE",
	"YI SYLLABLE MIEP",
	"YI SYLLABLE MIEX",
	"YI SYLLABLE MIP",
	"YI SYLLABLE MIT",
	"YI SYLLABLE MIX",
	"YI SYLLABLE MO",
	"YI SYLLABLE MOP",
	"YI SYLLABLE MOT",
	"YI SYLLABLE MOX",
	"YI SYLLABLE MU",
	"YI SYLLABLE MUO",
	"YI SYLLABLE MUOP",
	"YI SYLLABLE MUOT",
	"YI SYLLABLE MUOX",
	"YI SYLLABLE MUP",
	"YI SYLLABLE MUR",
	"YI SYLLABLE MURX",
	"YI SYLLABLE MUT",
	"YI SYLLABLE MUX",
	"YI SYLLABLE MY",
	"YI SYLLABLE MYP",
	"YI SYLLABLE MYT",
	"YI SYLLABLE MYX",
	"YI SYLLABLE NA",
	"YI SYLLABLE NAP",
	"YI SYLLABLE NAX",
	"YI SYLLABLE NBA",
	"YI SYLLABLE NBAP",
	"YI SYLLABLE NBAT",
	"YI SYLLABLE NBAX",
	"YI SYLLABLE NBI",
	"YI SYLLABLE NBIE",
	"YI SYLLABLE NBIEP",
	"YI SYLLABLE NBIEX",
	"YI SYLLABLE NBIP",
	"YI SYLLABLE NBIT",
	"YI SYLLABLE NBIX",
	"YI SYLLABLE NBO",
	"YI SYLLABLE NBOP",
	"YI SYLLABLE NBOT",
	"YI SYLLABLE NBOX",
	"YI SYLLABLE NBU",
	"YI SYLLABLE NBUP",
	"YI SYLLABLE NBUR",
	"YI SYLLABLE NBURX",
	"YI SYLLABLE NBUT",
	"YI SYLLABLE NBUX",
	"YI SYLLABLE NBY",
	"YI SYLLABLE NBYP",
	"YI SYLLABLE NBYR",
	"YI SYLLABLE NBYRX",
	"YI SYLLABLE NBYT",
	"YI SYLLABLE NBYX",
	"YI SYLLABLE NDA",
	"YI SYLLABLE NDAP",
	"YI SYLLABLE NDAT",
	"YI SYLLABLE NDAX",
	"YI SYLLABLE NDE",
	"YI SYLLABLE NDEP",
	"YI SYLLABLE NDEX",
	"YI SYLLABLE NDI",
	"YI SYLLABLE NDIE",
	"YI SYLLABLE NDIEX",
	"YI SYLLABLE NDIP",
	"YI SYLLABLE NDIT",
	"YI SYLLABLE NDIX",
	"YI SYLLABLE NDO",
	"YI SYLLABLE NDOP",
	"YI SYLLABLE NDOT",
	"YI SYLLABLE NDOX",
	"YI SYLLABLE NDU",
	"YI SYLLABLE NDUP",
	"YI SYLLABLE NDUR",
	"YI SYLLABLE NDURX",
	"YI SYLLABLE NDUT",
	"YI SYLLABLE NDUX",
	"YI SYLLABLE NE",
	"YI SYLLABLE NEP",
	"YI SYLLABLE NEX",
	"YI SYLLABLE NGA",
	"YI SYLLABLE NGAP",
	"YI SYLLABLE NGAT",
	"YI SYLLABLE NGAX",
	"YI SYLLABLE NGE",
	"YI SYLLABLE NGEP",
	"YI SYLLABLE NGEX",
	"YI SYLLABLE NGIE",
	"YI SYLLABLE NGIEP",
	"YI SYLLABLE NGIEX",
	"YI SYLLABLE NGO",
	"YI SYLLABLE NGOP",
	"YI SYLLABLE NGOT",
	"YI SYLLABLE NGOX",
	"YI SYLLABLE NGUO",
	"YI SYLLABLE NGUOT",
	"YI SYLLABLE NGUOX",
	"YI SYLLABLE NI",
	"YI SYLLABLE NIE",
	"YI SYLLABLE NIEP",
	"YI SYLLABLE NIEX",
	"YI SYLLABLE NIP",
	"YI SYLLABLE NIT",
	"YI SYLLABLE NIX",
	"YI SYLLABLE NJI",
	"YI SYLLABLE NJIE",
	"YI SYLLABLE NJIEP",
	"YI SYLLABLE NJIET",
	"YI SYLLABLE NJIEX",
	"YI SYLLABLE NJIP",
	"YI SYLLABLE NJIT",
	"YI SYLLABLE NJIX",
	"YI SYLLABLE NJO",
	"YI SYLLABLE NJOP",
	"YI SYLLABLE NJOT",
	"YI SYLLABLE NJOX",
	"YI SYLLABLE NJU",
	"YI SYLLABLE NJUO",
	"YI SYLLABLE NJUOX",
	"YI SYLLABLE NJUP",
	"YI SYLLABLE NJUR",
	"YI SYLLABLE NJURX",
	"YI SYLLABLE NJUX",
	"YI SYLLABLE NJY",
	"YI SYLLABLE NJYP",
	"YI SYLLABLE NJYR",
	"YI SYLLABLE NJYRX",
	"YI SYLLABLE NJYT",
	"YI SYLLABLE NJYX",
	"YI SYLLABLE NO",
	"YI SYLLABLE NOP",
	"YI SYLLABLE NOT",
	"YI SYLLABLE NOX",
	"YI SYLLABLE NRA",
	"YI SYLLABLE NRAP",
	"YI SYLLABLE NRAT",
	"YI SYLLABLE NRAX",
	"YI SYLLABLE NRE",
	"YI SYLLABLE NREP",
	"YI SYLLABLE NRET",
	"YI SYLLABLE NREX",
	"YI SYLLABLE NRO",
	"YI SYLLABLE NROP",
	"YI SYLLABLE NROX",
	"YI SYLLABLE NRU",
	"YI SYLLABLE NRUP",
	"YI SYLLABLE NRUR",
	"YI SYLLABLE NRURX",
	"YI SYLLABLE NRUT",
	"YI SYLLABLE NRUX",
	"YI SYLLABLE NRY",
	"YI SYLLABLE NRYP",
	"YI SYLLABLE NRYR",
	"YI SYLLABLE NRYRX",
	"YI SYLLABLE NRYT",
	"YI SYLLABLE NRYX",
	"YI SYLLABLE NU",
	"YI SYLLABLE NUO",
	"YI SYLLABLE NUOP",
	"YI SYLLABLE NUOX",
	"YI SYLLABLE NUP",
	"YI SYLLABLE NUR",
	"YI SYLLABLE NURX",
	"YI SYLLABLE NUT",
	"YI SYLLABLE NUX",
	"YI SYLLABLE NYI",
	"YI SYLLABLE NYIE",
	"YI SYLLABLE NYIEP",
	"YI SYLLABLE NYIET",
	"YI SYLLABLE NYIEX",
	"YI SYLLABLE NYIP",
	"YI SYLLABLE NYIT",
	"YI SYLLABLE NYIX",
	"YI SYLLABLE NYO",
	"YI SYLLABLE NYOP",
	"YI SYLLABLE NYOT",
	"YI SYLLABLE NYOX",
	"YI SYLLABLE NYU",
	"YI SYLLABLE NYUO",
	"YI SYLLABLE NYUOP",
	"YI SYLLABLE NYUOX",
	"YI SYLLABLE NYUP",
	"YI SYLLABLE NYUT",
	"YI SYLLABLE NYUX",
	"YI SYLLABLE NZA",
	"YI SYLLABLE NZAP",
	"YI SYLLABLE NZAT",
	"YI SYLLABLE NZAX",
	"YI SYLLABLE NZE",
	"YI SYLLABLE NZEX",
	"YI SYLLABLE NZI",
	"YI SYLLABLE NZIE",
	"YI SYLLABLE NZIEP",
	"YI SYLLABLE NZIEX",
	"YI SYLLABLE NZIP",
	"YI SYLLABLE NZIT",
	"YI SYLLABLE NZIX",
	"YI SYLLABLE NZOP",
	"YI SYLLABLE NZOX",
	"YI SYLLABLE NZU",
	"YI SYLLABLE NZUO",
	"YI SYLLABLE NZUOX",
	"YI SYLLABLE NZUP",
	"YI SYLLABLE NZUR",
	"YI SYLLABLE NZURX",
	"YI SYLLABLE NZUX",
	"YI SYLLABLE NZY",
	"YI SYLLABLE NZYP",
	"YI SYLLABLE NZYR",
	"YI SYLLABLE NZYRX",
	"YI SYLLABLE NZYT",
	"YI SYLLABLE NZYX",
	"YI SYLLABLE O",
	"YI SYLLABLE OP",
	"YI SYLLABLE OT",
	"YI SYLLABLE OX",
	"YI SYLLABLE PA",
	"YI SYLLABLE PAP",
	"YI SYLLABLE PAT",
	"YI SYLLABLE PAX",
	"YI SYLLABLE PI",
	"YI SYLLABLE PIE",
	"YI SYLLABLE PIEP",
	"YI SYLLABLE PIEX",
	"YI SYLLABLE PIP",
	"YI SYLLABLE PIT",
	"YI SYLLABLE PIX",
	"YI SYLLABLE PO",
	"YI SYLLABLE POP",
	"YI SYLLABLE POT",
	"YI SYLLABLE POX",
	"YI SYLLABLE PU",
	"YI SYLLABLE PUO",
	"YI SYLLABLE PUOP",
	"YI SYLLABLE PUOX",
	"YI SYLLABLE PUP",
	"YI SYLLABLE PUR",
	"YI SYLLABLE PURX",
	"YI SYLLABLE PUT",
	"YI SYLLABLE PUX",
	"YI SYLLABLE PY",
	"YI SYLLABLE PYP",
	"YI SYLLABLE PYR",
	"YI SYLLABLE PYRX",
	"YI SYLLABLE PYT",
	"YI SYLLABLE PYX",
	"YI SYLLABLE QI",
	"YI SYLLABLE QIE",
	"YI SYLLABLE QIEP",
	"YI SYLLABLE QIET",
	"YI SYLLABLE QIEX",
	"YI SYLLABLE QIP",
	"YI SYLLABLE QIT",
	"YI SYLLABLE QIX",
	"YI SYLLABLE QO",
	"YI SYLLABLE QOP",
	"YI SYLLABLE QOT",
	"YI SYLLABLE QOX",
	"YI SYLLABLE QU",
	"YI SYLLABLE QUO",
	"YI SYLLABLE QUOP",
	"YI SYLLABLE QUOT",
	"YI SYLLABLE QUOX",
	"YI SYLLABLE QUP",
	"YI SYLLABLE QUR",
	"YI SYLLABLE QURX",
	"YI SYLLABLE QUT",
	"YI SYLLABLE QUX",
	"YI SYLLABLE QY",
	"YI SYLLABLE QYP",
	"YI SYLLABLE QYR",
	"YI SYLLABLE QYRX",
	"YI SYLLABLE QYT",
	"YI SYLLABLE QYX",
	"YI SYLLABLE RA",
	"YI SYLLABLE RAP",
	"YI SYLLABLE RAT",
	"YI SYLLABLE RAX",
	"YI SYLLABLE RE",
	"YI SYLLABLE REP",
	"YI SYLLABLE REX",
	"YI SYLLABLE RO",
	"YI SYLLABLE ROP",
	"YI SYLLABLE ROT",
	"YI SYLLABLE ROX",
	"YI SYLLABLE RRA",
	"YI SYLLABLE RRAX",
	"YI SYLLABLE RRE",
	"YI SYLLABLE RREP",
	"YI SYLLABLE RRET",
	"YI SYLLABLE RREX",
	"YI SYLLABLE RRO",
	"YI SYLLABLE RROP",
	"YI SYLLABLE RROT",
	"YI SYLLABLE RROX",
	"YI SYLLABLE RRU",
	"YI SYLLABLE RRUO",
	"YI SYLLABLE RRUOX",
	"YI SYLLABLE RRUP",
	"YI SYLLABLE RRUR",
	"YI SYLLABLE RRURX",
	"YI SYLLABLE RRUT",
	"YI SYLLABLE RRUX",
	"YI SYLLABLE RRY",
	"YI SYLLABLE RRYP",
	"YI SYLLABLE RRYR",
	"YI SYLLABLE RRYRX",
	"YI SYLLABLE RRYT",
	"YI SYLLABLE RRYX",
	"YI SYLLABLE RU",
	"YI SYLLABLE RUO",
	"YI SYLLABLE RUOP",
	"YI SYLLABLE RUOX",
	"YI SYLLABLE RUP",
	"YI SYLLABLE RUR",
	"YI SYLLABLE RURX",
	"YI SYLLABLE RUT",
	"YI SYLLABLE RUX",
	"YI SYLLABLE RY",
	"YI SYLLABLE RYP",
	"YI SYLLABLE RYR",
	"YI SYLLABLE RYRX",
	"YI SYLLABLE RYT",
	"YI SYLLABLE RYX",
	"YI SYLLABLE SA",
	"YI SYLLABLE SAP",
	"YI SYLLABLE SAT",
	"YI SYLLABLE SAX",
	"YI SYLLABLE SE",
	"YI SYLLABLE SEP",
	"YI SYLLABLE SEX",
	"YI SYLLABLE SHA",
	"YI SYLLABLE SHAP",
	"YI SYLLABLE SHAT",
	"YI SYLLABLE SHAX",
	"YI SYLLABLE SHE",
	"YI SYLLABLE SHEP",
	"YI SYLLABLE SHET",
	"YI SYLLABLE SHEX",
	"YI SYLLABLE SHO",
	"YI SYLLABLE SHOP",
	"YI SYLLABLE SHOT",
	"YI SYLLABLE SHOX",
	"YI SYLLABLE SHU",
	"YI SYLLABLE SHUO",
	"YI SYLLABLE SHUOP",
	"YI SYLLABLE SHUOX",
	"YI SYLLABLE SHUP",
	"YI SYLLABLE SHUR",
	"YI SYLLABLE SHURX",
	"YI SYLLABLE SHUT",
	"YI SYLLABLE SHUX",
	"YI SYLLABLE SHY",
	"YI SYLLABLE SHYP",
	"YI SYLLABLE SHYR",
	"YI SYLLABLE SHYRX",
	"YI SYLLABLE SHYT",
	"YI SYLLABLE SHYX",
	"YI SYLLABLE SI",
	"YI SYLLABLE SIE",
	"YI SYLLABLE SIEP",
	"YI SYLLABLE SIEX",
	"YI SYLLABLE SIP",
	"YI SYLLABLE SIT",
	"YI SYLLABLE SIX",
	"YI SYLLABLE SO",
	"YI SYLLABLE SOP",
	"YI SYLLABLE SOT",
	"YI SYLLABLE SOX",
	"YI SYLLABLE SSA",
	"YI SYLLABLE SSAP",
	"YI SYLLABLE SSAT",
	"YI SYLLABLE SSAX",
	"YI SYLLABLE SSE",
	"YI SYLLABLE SSEP",
	"YI SYLLABLE SSEX",
	"YI SYLLABLE SSI",
	"YI SYLLABLE SSIE",
	"YI SYLLABLE SSIEP",
	"YI SYLLABLE SSIEX",
	"YI SYLLABLE SSIP",
	"YI SYLLABLE SSIT",
	"YI SYLLABLE SSIX",
	"YI SYLLABLE SSO",
	"YI SYLLABLE SSOP",
	"YI SYLLABLE SSOT",
	"YI SYLLABLE SSOX",
	"YI SYLLABLE SSU",
	"YI SYLLABLE SSUP",
	"YI SYLLABLE SSUT",
	"YI SYLLABLE SSUX",
	"YI SYLLABLE SSY",
	"YI SYLLABLE SSYP",
	"YI SYLLABLE SSYR",
	"YI SYLLABLE SSYRX",
	"YI SYLLABLE SSYT",
	"YI SYLLABLE SSYX",
	"YI SYLLABLE SU",
	"YI SYLLABLE SUO",
	"YI SYLLABLE SUOP",
	"YI SYLLABLE SUOX",
	"YI SYLLABLE SUP",
	"YI SYLLABLE SUR",
	"YI SYLLABLE SURX",
	"YI SYLLABLE SUT",
	"YI SYLLABLE SUX",
	"YI SYLLABLE SY",
	"YI SYLLABLE SYP",
	"YI SYLLABLE SYR",
	"YI SYLLABLE SYRX",
	"YI SYLLABLE SYT",
	"YI SYLLABLE SYX",
	"YI SYLLABLE TA",
	"YI SYLLABLE TAP",
	"YI SYLLABLE TAT",
	"YI SYLLABLE TAX",
	"YI SYLLABLE TE",
	"YI SYLLABLE TEP",
	"YI SYLLABLE TEX",
	"YI SYLLABLE TI",
	"YI SYLLABLE TIE",
	"YI SYLLABLE TIEP",
	"YI SYLLABLE TIEX",
	"YI SYLLABLE TIP",
	"YI SYLLABLE TIT",
	"YI SYLLABLE TIX",
	"YI SYLLABLE TO",
	"YI SYLLABLE TOP",
	"YI SYLLABLE TOT",
	"YI SYLLABLE TOX",
	"YI SYLLABLE TU",
	"YI SYLLABLE TUO",
	"YI SYLLABLE TUOP",
	"YI SYLLABLE TUOT",
	"YI SYLLABLE TUOX",
	"YI SYLLABLE TUP",
	"YI SYLLABLE TUR",
	"YI SYLLABLE TURX",
	"YI SYLLABLE TUT",
	"YI SYLLABLE TUX",
	"YI SYLLABLE UO",
	"YI SYLLABLE UOP",
	"YI SYLLABLE UOX",
	"YI SYLLABLE VA",
	"YI SYLLABLE VAP",
	"YI SYLLABLE VAT",
	"YI SYLLABLE VAX",
	"YI SYLLABLE VEP",
	"YI SYLLABLE VEX",
	"YI SYLLABLE VI",
	"YI SYLLABLE VIE",
	"YI SYLLABLE VIEP",
	"YI SYLLABLE VIET",
	"YI SYLLABLE VIEX",
	"YI SYLLABLE VIP",
	"YI SYLLABLE VIT",
	"YI SYLLABLE VIX",
	"YI SYLLABLE VO",
	"YI SYLLABLE VOP",
	"YI SYLLABLE VOT",
	"YI SYLLABLE VOX",
	"YI SYLLABLE VU",
	"YI SYLLABLE VUP",
	"YI SYLLABLE VUR",
	"YI SYLLABLE VURX",
	"YI SYLLABLE VUT",
	"YI SYLLABLE VUX",
	"YI SYLLABLE VY",
	"YI SYLLABLE VYP",
	"YI SYLLABLE VYR",
	"YI SYLLABLE VYRX",
	"YI SYLLABLE VYT",
	"YI SYLLABLE VYX",
	"YI SYLLABLE WA",
	"YI SYLLABLE WAP",
	"YI SYLLABLE WAT",
	"YI SYLLABLE WAX",
	"YI SYLLABLE WE",
	"YI SYLLABLE WEP",
	"YI SYLLABLE WEX",
	"YI SYLLABLE WO",
	"YI SYLLABLE WOP",
	"YI SYLLABLE WOX",
	"YI SYLLABLE WU",
	"YI SYLLABLE WUO",
	"YI SYLLABLE WUOP",
	"YI SYLLABLE WUOX",
	"YI SYLLABLE XI",
	"YI SYLLABLE XIE",
	"YI SYLLABLE XIEP",
	"YI SYLLABLE XIET",
	"YI SYLLABLE XIEX",
	"YI SYLLABLE XIP",
	"YI SYLLABLE XIT",
	"YI SYLLABLE XIX",
	"YI SYLLABLE XO",
	"YI SYLLABLE XOP",
	"YI SYLLABLE XOT",
	"YI SYLLABLE XOX",
	"YI SYLLABLE XUO",
	"YI SYLLABLE XUOX",
	"YI SYLLABLE XY",
	"YI SYLLABLE XYP",
	"YI SYLLABLE XYR",
	"YI SYLLABLE XYRX",
	"YI SYLLABLE XYT",
	"YI SYLLABLE XYX",
	"YI SYLLABLE YI",
	"YI SYLLABLE YIE",
	"YI SYLLABLE YIEP",
	"YI SYLLABLE YIET",
	"YI SYLLABLE YIEX",
	"YI SYLLABLE YIP",
	"YI SYLLABLE YIT",
	"YI SYLLABLE YIX",
	"YI SYLLABLE YO",
	"YI SYLLABLE YOP",
	"YI SYLLABLE YOT",
	"YI SYLLABLE YOX",
	"YI SYLLABLE YU",
	"YI SYLLABLE YUO",
	"YI SYLLABLE YUOP",
	"YI SYLLABLE YUOT",
	"YI SYLLABLE YUOX",
	"YI SYLLABLE YUP",
	"YI SYLLABLE YUR",
	"YI SYLLABLE YURX",
	"YI SYLLABLE YUT",
	"YI SYLLABLE YUX",
	"YI SYLLABLE YY",
	"YI SYLLABLE YYP",
	"YI SYLLABLE YYR",
	"YI SYLLABLE YYRX",
	"YI SYLLABLE YYT",
	"YI SYLLABLE YYX",
	"YI SYLLABLE ZA",
	"YI SYLLABLE ZAP",
	"YI SYLLABLE ZAT",
	"YI SYLLABLE ZAX",
	"YI SYLLABLE ZE",
	"YI SYLLABLE ZEP",
	"YI SYLLABLE ZEX",
	"YI SYLLABLE ZHA",
	"YI SYLLABLE ZHAP",
	"YI SYLLABLE ZHAT",
	"YI SYLLABLE ZHAX",
	"YI SYLLABLE ZHE",
	"YI SYLLABLE ZHEP",
	"YI SYLLABLE ZHET",
	"YI SYLLABLE ZHEX",
	"YI SYLLABLE ZHO",
	"YI SYLLABLE ZHOP",
	"YI SYLLABLE ZHOT",
	"YI SYLLABLE ZHOX",
	"YI SYLLABLE ZHU",
	"YI SYLLABLE ZHUO",
	"YI SYLLABLE ZHUOP",
	"YI SYLLABLE ZHUOX",
	"YI SYLLABLE ZHUP",
	"YI SYLLABLE ZHUR",
	"YI SYLLABLE ZHURX",
	"YI SYLLABLE ZHUT",
	"YI SYLLABLE ZHUX",
	"YI SYLLABLE ZHY",
	"YI SYLLABLE ZHYP",
	"YI SYLLABLE ZHYR",
	"YI SYLLABLE ZHYRX",
	"YI SYLLABLE ZHYT",
	"YI SYLLABLE ZHYX",
	"YI SYLLABLE ZI",
	"YI SYLLABLE ZIE",
	"YI SYLLABLE ZIEP",
	"YI SYLLABLE ZIEX",
	"YI SYLLABLE ZIP",
	"YI SYLLABLE ZIT",
	"YI SYLLABLE ZIX",
	"YI SYLLABLE ZO",
	"YI SYLLABLE ZOP",
	"YI SYLLABLE ZOT",
	"YI SYLLABLE ZOX",
	"YI SYLLABLE ZU",
	"YI SYLLABLE ZUO",
	"YI SYLLABLE ZUOP",
	"YI SYLLABLE ZUOX",
	"YI SYLLABLE ZUP",
	"YI SYLLABLE ZUR",
	"YI SYLLABLE ZURX",
	"YI SYLLABLE ZUT",
	"YI SYLLABLE ZUX",
	"YI SYLLABLE ZY",
	"YI SYLLABLE ZYP",
	"YI SYLLABLE ZYR",
	"YI SYLLABLE ZYRX",
	"YI SYLLABLE ZYT",
	"YI SYLLABLE ZYX",
	"YI SYLLABLE ZZA",
	"YI SYLLABLE ZZAP",
	"YI SYLLABLE ZZAT",
	"YI SYLLABLE ZZAX",
	"YI SYLLABLE ZZE",
	"YI SYLLABLE ZZEP",
	"YI SYLLABLE ZZEX",
	"YI SYLLABLE ZZI",
	"YI SYLLABLE ZZIE",
	"YI SYLLABLE ZZIEP",
	"YI SYLLABLE ZZIET",
	"YI SYLLABLE ZZIEX",
	"YI SYLLABLE ZZIP",
	"YI SYLLABLE ZZIT",
	"YI SYLLABLE ZZIX",
	"YI SYLLABLE ZZO",
	"YI SYLLABLE ZZOP",
	"YI SYLLABLE ZZOX",
	"YI SYLLABLE ZZU",
	"YI SYLLABLE ZZUP",
	"YI SYLLABLE ZZUR",
	"YI SYLLABLE ZZURX",
	"YI SYLLABLE ZZUX",
	"YI SYLLABLE ZZY",
	"YI SYLLABLE ZZYP",
	"YI SYLLABLE ZZYR",
	"YI SYLLABLE ZZYRX",
	"YI SYLLABLE ZZYT",
	"YI SYLLABLE ZZYX",
	"YIN YANG",
	"Z NOTATION BAG MEMBERSHIP",
	"Z NOTATION DOMAIN ANTIRESTRICTION",
	"Z NOTATION LEFT BINDING BRACKET",
	"Z NOTATION LEFT IMAGE BRACKET",
	"Z NOTATION RANGE ANTIRESTRICTION",
	"Z NOTATION RELATIONAL COMPOSITION",
	"Z NOTATION RIGHT BINDING BRACKET",
	"Z NOTATION RIGHT IMAGE BRACKET",
	"Z NOTATION SCHEMA COMPOSITION",
	"Z NOTATION SCHEMA PIPING",
	"Z NOTATION SCHEMA PROJECTION",
	"Z NOTATION SPOT",
	"Z NOTATION TYPE COLON",
	"ZERO WIDTH JOINER",
	"ZERO WIDTH NO-BREAK SPACE",
	"ZERO WIDTH NON-JOINER",
	"ZERO WIDTH SPACE"
};

static const long codepoints[] = {
	0x23E6,
	0x2100,
	0x206D,
	0x206B,
	0x00B4,
	0x299F,
	0x2101,
	0x262C,
	0x10102,
	0x1013C,
	0x1013D,
	0x1013E,
	0x1013F,
	0x1010E,
	0x10120,
	0x10129,
	0x10117,
	0x10132,
	0x10114,
	0x1012F,
	0x1010B,
	0x1011D,
	0x10126,
	0x10113,
	0x1012E,
	0x1010A,
	0x1011C,
	0x10125,
	0x1010F,
	0x10121,
	0x1012A,
	0x10118,
	0x10133,
	0x10107,
	0x10119,
	0x10122,
	0x1010D,
	0x1011F,
	0x10128,
	0x10116,
	0x10131,
	0x1010C,
	0x1011E,
	0x10127,
	0x10115,
	0x10130,
	0x10110,
	0x1012B,
	0x10112,
	0x1012D,
	0x10109,
	0x1011B,
	0x10124,
	0x10111,
	0x1012C,
	0x10108,
	0x1011A,
	0x10123,
	0x10137,
	0x10138,
	0x1013B,
	0x10139,
	0x1013A,
	0x10101,
	0x10100,
	0x1F6A1,
	0x060B,
	0x2708,
	0x214D,
	0x23F0,
	0x1F701,
	0x1F76A,
	0x1F736,
	0x1F745,
	0x1F75B,
	0x1F72B,
	0x1F706,
	0x1F708,
	0x1F705,
	0x1F73A,
	0x1F757,
	0x1F73D,
	0x1F76B,
	0x1F76C,
	0x1F73E,
	0x1F70F,
	0x1F742,
	0x1F759,
	0x1F750,
	0x1F74C,
	0x1F74E,
	0x1F713,
	0x1F725,
	0x1F720,
	0x1F723,
	0x1F71E,
	0x1F765,
	0x1F770,
	0x1F761,
	0x1F760,
	0x1F703,
	0x1F702,
	0x1F71A,
	0x1F749,
	0x1F772,
	0x1F773,
	0x1F756,
	0x1F76E,
	0x1F71C,
	0x1F721,
	0x1F72A,
	0x1F753,
	0x1F738,
	0x1F710,
	0x1F771,
	0x1F76F,
	0x1F715,
	0x1F746,
	0x1F70E,
	0x1F758,
	0x1F74B,
	0x1F75A,
	0x1F75F,
	0x1F763,
	0x1F764,
	0x1F741,
	0x1F700,
	0x1F73B,
	0x1F732,
	0x1F730,
	0x1F71F,
	0x1F76D,
	0x1F718,
	0x1F739,
	0x1F714,
	0x1F72D,
	0x1F726,
	0x1F74F,
	0x1F71B,
	0x1F754,
	0x1F747,
	0x1F752,
	0x1F75C,
	0x1F72C,
	0x1F722,
	0x1F72E,
	0x1F727,
	0x1F75E,
	0x1F70D,
	0x1F73F,
	0x1F729,
	0x1F748,
	0x1F751,
	0x1F74D,
	0x1F755,
	0x1F728,
	0x1F70A,
	0x1F72F,
	0x1F716,
	0x1F704,
	0x1F74A,
	0x2135,
	0x2697,
	0x1F47E,
	0x232E,
	0x224C,
	0x224A,
	0x2248,
	0x2A6F,
	0x26D5,
	0x2387,
	0x2A3F,
	0x1F691,
	0x1F3C8,
	0x0026,
	0x2693,
	0x27D1,
	0x1F4A2,
	0x2220,
	0x299E,
	0x29A4,
	0x1F620,
	0x212B,
	0x1F627,
	0x2625,
	0x1F41C,
	0x1F4F6,
	0x2940,
	0x2233,
	0x1F504,
	0x27F2,
	0x2A11,
	0x21BA,
	0x21B6,
	0x237A,
	0x2376,
	0x2340,
	0x2349,
	0x2365,
	0x233E,
	0x235F,
	0x233D,
	0x235C,
	0x236A,
	0x2362,
	0x2352,
	0x236B,
	0x234B,
	0x2359,
	0x235A,
	0x2371,
	0x2366,
	0x234E,
	0x234A,
	0x2356,
	0x2377,
	0x2369,
	0x2336,
	0x2373,
	0x2378,
	0x2364,
	0x235B,
	0x2367,
	0x2345,
	0x2375,
	0x2379,
	0x2395,
	0x2342,
	0x233C,
	0x2360,
	0x2354,
	0x234D,
	0x233A,
	0x2339,
	0x234C,
	0x2357,
	0x2338,
	0x2344,
	0x233B,
	0x2347,
	0x2343,
	0x236F,
	0x2370,
	0x2348,
	0x2341,
	0x2353,
	0x2350,
	0x235E,
	0x2358,
	0x2374,
	0x2346,
	0x236E,
	0x233F,
	0x2337,
	0x2363,
	0x236D,
	0x2368,
	0x2372,
	0x235D,
	0x2361,
	0x2355,
	0x2351,
	0x234F,
	0x236C,
	0x0027,
	0x2250,
	0x2246,
	0x2A70,
	0x2245,
	0x2252,
	0x2652,
	0x060C,
	0x08E5,
	0x08E8,
	0x08E4,
	0x08E7,
	0x08E6,
	0x08E9,
	0x064F,
	0xFE78,
	0xFE79,
	0x08FE,
	0x064C,
	0xFE72,
	0x060D,
	0x066B,
	0x08FB,
	0x08FC,
	0x06EB,
	0x06EA,
	0x06DD,
	0x064E,
	0xFE76,
	0xFE77,
	0x08F5,
	0x08F4,
	0x065E,
	0x064B,
	0xFE70,
	0x066D,
	0x0602,
	0x06D4,
	0x0654,
	0x0655,
	0x0657,
	0x0650,
	0xFE7A,
	0xFE7B,
	0x08F6,
	0x064D,
	0xFE74,
	0x08F7,
	0x08F9,
	0x06D5,
	0x0639,
	0xFECA,
	0xFECB,
	0xFEC9,
	0xFECC,
	0x06A0,
	0x075E,
	0x075D,
	0x075F,
	0x0627,
	0xFE8E,
	0xFE8D,
	0x0649,
	0xFEF0,
	0xFEEF,
	0x0671,
	0xFB51,
	0xFB50,
	0x0774,
	0x0773,
	0x0623,
	0xFE84,
	0xFE83,
	0x0625,
	0xFE88,
	0xFE87,
	0x0622,
	0xFE82,
	0xFE81,
	0x0672,
	0x0673,
	0x067B,
	0xFB53,
	0xFB54,
	0xFB52,
	0xFB55,
	0x0628,
	0xFE90,
	0xFE91,
	0xFE8F,
	0xFE92,
	0x0751,
	0x0755,
	0x0756,
	0x08A0,
	0x0750,
	0x0752,
	0x0753,
	0x0754,
	0x0680,
	0xFB5B,
	0xFB5C,
	0xFB5A,
	0xFB5D,
	0x0636,
	0xFEBE,
	0xFEBF,
	0xFEBD,
	0xFEC0,
	0x06FB,
	0x068C,
	0xFB85,
	0xFB84,
	0x062F,
	0xFEAA,
	0xFEA9,
	0x068A,
	0x068B,
	0x0690,
	0x075A,
	0x06EE,
	0x0689,
	0x068F,
	0x0759,
	0x068D,
	0xFB83,
	0xFB82,
	0x0688,
	0xFB89,
	0xFB88,
	0x066E,
	0x06A1,
	0x066F,
	0x068E,
	0xFB87,
	0xFB86,
	0x0684,
	0xFB73,
	0xFB74,
	0xFB72,
	0xFB75,
	0x06D0,
	0xFBE5,
	0xFBE6,
	0xFBE4,
	0xFBE7,
	0x06CC,
	0xFBFD,
	0xFBFE,
	0xFBFC,
	0xFBFF,
	0x0777,
	0x0776,
	0x0775,
	0x063D,
	0x063F,
	0x063E,
	0x0641,
	0xFED2,
	0xFED3,
	0xFED1,
	0xFED4,
	0x06A3,
	0x08A4,
	0x06A2,
	0x06A5,
	0x0761,
	0x0760,
	0x06AF,
	0xFB93,
	0xFB94,
	0xFB92,
	0xFB95,
	0x06B0,
	0x06B4,
	0x06B2,
	0x063A,
	0xFECE,
	0xFECF,
	0xFECD,
	0xFED0,
	0x06FC,
	0x06B3,
	0xFB97,
	0xFB98,
	0xFB96,
	0xFB99,
	0x062D,
	0xFEA2,
	0xFEA3,
	0xFEA1,
	0xFEA4,
	0x077C,
	0x0681,
	0x0772,
	0x076F,
	0x076E,
	0x0685,
	0x0758,
	0x0757,
	0x0682,
	0x0621,
	0xFE80,
	0x0647,
	0x06BE,
	0xFBAB,
	0xFBAC,
	0xFBAA,
	0xFBAD,
	0xFEEA,
	0x06C1,
	0xFBA7,
	0xFBA8,
	0xFBA6,
	0xFBA9,
	0x06C2,
	0xFEEB,
	0xFEE9,
	0xFEEC,
	0x06FF,
	0x06C0,
	0xFBA5,
	0xFBA4,
	0x0674,
	0x0675,
	0x0676,
	0x0678,
	0x062C,
	0xFE9E,
	0xFE9F,
	0xFE9D,
	0xFEA0,
	0x08A2,
	0x0698,
	0xFB8B,
	0xFB8A,
	0x0643,
	0xFEDA,
	0xFEDB,
	0xFED9,
	0xFEDC,
	0x06AC,
	0x06AB,
	0x06AE,
	0x077F,
	0x0620,
	0x06A9,
	0xFB8F,
	0xFB90,
	0xFB8E,
	0xFB91,
	0x0762,
	0x0763,
	0x063C,
	0x0764,
	0x063B,
	0x062E,
	0xFEA6,
	0xFEA7,
	0xFEA5,
	0xFEA8,
	0x06C5,
	0xFBE1,
	0xFBE0,
	0x06C9,
	0xFBE3,
	0xFBE2,
	0x0644,
	0xFEDE,
	0xFEDF,
	0xFEDD,
	0xFEE0,
	0x076A,
	0x06B6,
	0x08A6,
	0x06B5,
	0x06B7,
	0x06B8,
	0x061C,
	0x0645,
	0xFEE2,
	0xFEE3,
	0xFEE1,
	0xFEE4,
	0x0765,
	0x0766,
	0x08A7,
	0x06AD,
	0xFBD4,
	0xFBD5,
	0xFBD3,
	0xFBD6,
	0x06B1,
	0xFB9B,
	0xFB9C,
	0xFB9A,
	0xFB9D,
	0x0646,
	0xFEE6,
	0x06BA,
	0xFB9F,
	0xFB9E,
	0xFEE7,
	0xFEE5,
	0xFEE8,
	0x06B9,
	0x06BC,
	0x0768,
	0x0769,
	0x06BD,
	0x0767,
	0x0683,
	0xFB77,
	0xFB78,
	0xFB76,
	0xFB79,
	0x06C6,
	0xFBDA,
	0xFBD9,
	0x067E,
	0xFB57,
	0xFB58,
	0xFB56,
	0xFB59,
	0x06A6,
	0xFB6F,
	0xFB70,
	0xFB6E,
	0xFB71,
	0x0642,
	0xFED6,
	0xFED7,
	0xFED5,
	0xFED8,
	0x06A7,
	0x08A5,
	0x06A8,
	0x0631,
	0xFEAE,
	0xFEAD,
	0x0694,
	0x0696,
	0x0699,
	0x076C,
	0x06EF,
	0x08AA,
	0x0693,
	0x0771,
	0x0692,
	0x0695,
	0x075B,
	0x0697,
	0x076B,
	0x06BB,
	0xFBA1,
	0xFBA2,
	0xFBA0,
	0xFBA3,
	0x08AC,
	0x0691,
	0xFB8D,
	0xFB8C,
	0x0635,
	0xFEBA,
	0xFEBB,
	0xFEB9,
	0xFEBC,
	0x069E,
	0x069D,
	0x0633,
	0xFEB2,
	0xFEB3,
	0xFEB1,
	0xFEB4,
	0x069A,
	0x077D,
	0x075C,
	0x077E,
	0x0770,
	0x069B,
	0x069C,
	0x076D,
	0x0634,
	0xFEB6,
	0xFEB7,
	0xFEB5,
	0xFEB8,
	0x06FA,
	0x0670,
	0x06AA,
	0x0637,
	0xFEC2,
	0xFEC3,
	0xFEC1,
	0xFEC4,
	0x069F,
	0x08A3,
	0x0686,
	0xFB7B,
	0xFB7C,
	0xFB7A,
	0xFB7D,
	0x06BF,
	0x0687,
	0xFB7F,
	0xFB80,
	0xFB7E,
	0xFB81,
	0x062A,
	0xFE96,
	0xFE97,
	0xFE95,
	0x0629,
	0xFE94,
	0x06C3,
	0xFE93,
	0xFE98,
	0x067C,
	0x067D,
	0x067F,
	0xFB63,
	0xFB64,
	0xFB62,
	0xFB65,
	0x0630,
	0xFEAC,
	0xFEAB,
	0x062B,
	0xFE9A,
	0xFE9B,
	0xFE99,
	0xFE9C,
	0x0679,
	0xFB67,
	0xFB68,
	0xFB66,
	0xFB69,
	0x067A,
	0xFB5F,
	0xFB60,
	0xFB5E,
	0xFB61,
	0x06C7,
	0xFBD8,
	0xFBD7,
	0x0677,
	0xFBDD,
	0xFBE8,
	0xFBE9,
	0x06CB,
	0xFBDF,
	0xFBDE,
	0x06A4,
	0xFB6B,
	0xFB6C,
	0xFB6A,
	0xFB6D,
	0x0648,
	0xFEEE,
	0xFEED,
	0x06CF,
	0x08AB,
	0x0779,
	0x0778,
	0x0624,
	0xFE86,
	0xFE85,
	0x06C4,
	0x06CA,
	0x064A,
	0x06D2,
	0xFBAF,
	0xFBAE,
	0x077B,
	0x077A,
	0x06D3,
	0xFBB1,
	0xFBB0,
	0xFEF2,
	0xFEF3,
	0xFEF1,
	0xFEF4,
	0x0626,
	0xFE8A,
	0xFE8B,
	0xFE89,
	0xFE8C,
	0x06CE,
	0x06CD,
	0x06D1,
	0x08A9,
	0x08A8,
	0x06C8,
	0xFBDC,
	0xFBDB,
	0x0638,
	0xFEC6,
	0xFEC7,
	0xFEC5,
	0xFEC8,
	0x0632,
	0xFEB0,
	0xFEAF,
	0xFD13,
	0xFCF7,
	0xFCBA,
	0xFC29,
	0xFD75,
	0xFDC4,
	0xFCBB,
	0xFC2A,
	0xFD78,
	0xFD76,
	0xFD77,
	0xFDB6,
	0xFD14,
	0xFCF8,
	0xFDF3,
	0xFDF7,
	0xFC90,
	0xFC5D,
	0xFD3C,
	0xFD3D,
	0xFDF2,
	0xFC6E,
	0xFC09,
	0xFC9D,
	0xFC06,
	0xFDC2,
	0xFCA0,
	0xFCE2,
	0xFC9C,
	0xFC05,
	0xFC9E,
	0xFC07,
	0xFD9E,
	0xFC6C,
	0xFC9F,
	0xFC08,
	0xFCE1,
	0xFC6D,
	0xFC6A,
	0xFC6F,
	0xFC0A,
	0xFC6B,
	0xFDFD,
	0xFD23,
	0xFD07,
	0xFCB5,
	0xFC23,
	0xFD6E,
	0xFDAB,
	0xFCB4,
	0xFC22,
	0xFCB6,
	0xFC24,
	0xFD6F,
	0xFD70,
	0xFCB7,
	0xFC25,
	0xFD2C,
	0xFD10,
	0xFD24,
	0xFD08,
	0xFC7C,
	0xFC31,
	0xFCBF,
	0xFC2E,
	0xFCBE,
	0xFC2D,
	0xFCC0,
	0xFC2F,
	0xFD7C,
	0xFD7D,
	0xFCC1,
	0xFC30,
	0xFDC1,
	0xFC7D,
	0xFC32,
	0xFD15,
	0xFCF9,
	0xFCBC,
	0xFC2B,
	0xFCBD,
	0xFC2C,
	0xFD7B,
	0xFD79,
	0xFD7A,
	0xFD16,
	0xFCFA,
	0xFD1B,
	0xFCFF,
	0xFCA9,
	0xFC17,
	0xFDBF,
	0xFCAA,
	0xFC18,
	0xFD5B,
	0xFD5A,
	0xFD1C,
	0xFD00,
	0xFC53,
	0xFCD7,
	0xFC51,
	0xFCD8,
	0xFC52,
	0xFD93,
	0xFD94,
	0xFCD9,
	0xFC54,
	0xFDFB,
	0xFD1D,
	0xFD01,
	0xFCA7,
	0xFC15,
	0xFDA6,
	0xFDBE,
	0xFCA8,
	0xFC16,
	0xFDA7,
	0xFD58,
	0xFD59,
	0xFDA5,
	0xFD1E,
	0xFD02,
	0xFC80,
	0xFC37,
	0xFC83,
	0xFC3D,
	0xFCC5,
	0xFC39,
	0xFCC4,
	0xFC38,
	0xFCC6,
	0xFC3A,
	0xFC81,
	0xFCC7,
	0xFC3B,
	0xFCEB,
	0xFC82,
	0xFCC8,
	0xFC3C,
	0xFCEC,
	0xFDBB,
	0xFDC3,
	0xFDB7,
	0xFC84,
	0xFC3E,
	0xFD1F,
	0xFD03,
	0xFC1A,
	0xFCAB,
	0xFC19,
	0xFCAC,
	0xFC1B,
	0xFD20,
	0xFD04,
	0xFEFC,
	0xFEFB,
	0xFC86,
	0xFC43,
	0xFEF8,
	0xFEF7,
	0xFEFA,
	0xFEF9,
	0xFEF6,
	0xFEF5,
	0xFCCA,
	0xFC40,
	0xFD82,
	0xFD80,
	0xFDB5,
	0xFD81,
	0xFCCD,
	0xFCC9,
	0xFC3F,
	0xFD84,
	0xFD83,
	0xFDBC,
	0xFDBA,
	0xFDAC,
	0xFCCB,
	0xFC41,
	0xFD85,
	0xFD86,
	0xFC85,
	0xFCCC,
	0xFC42,
	0xFCED,
	0xFD87,
	0xFD88,
	0xFDAD,
	0xFC87,
	0xFC44,
	0xFC88,
	0xFC49,
	0xFCCF,
	0xFC46,
	0xFD89,
	0xFD8A,
	0xFD8B,
	0xFCCE,
	0xFC45,
	0xFD8C,
	0xFD92,
	0xFD8D,
	0xFDC0,
	0xFCD0,
	0xFC47,
	0xFD8E,
	0xFD8F,
	0xFDB9,
	0xFC89,
	0xFCD1,
	0xFC48,
	0xFDB1,
	0xFC4A,
	0xFDF4,
	0xFC8E,
	0xFC4F,
	0xFCD3,
	0xFC4C,
	0xFD96,
	0xFD95,
	0xFDB3,
	0xFCD6,
	0xFCEF,
	0xFCD2,
	0xFC4B,
	0xFD99,
	0xFDBD,
	0xFDB8,
	0xFD97,
	0xFD98,
	0xFDC7,
	0xFCD4,
	0xFC4D,
	0xFC8C,
	0xFCD5,
	0xFC4E,
	0xFCEE,
	0xFD9B,
	0xFD9A,
	0xFC8D,
	0xFC8A,
	0xFC8F,
	0xFC50,
	0xFC8B,
	0xFC7E,
	0xFC35,
	0xFCC2,
	0xFC33,
	0xFCC3,
	0xFC34,
	0xFD7E,
	0xFDB4,
	0xFD7F,
	0xFDB2,
	0xFC7F,
	0xFC36,
	0xFDF1,
	0xFDF6,
	0xFC5C,
	0xFD21,
	0xFD05,
	0xFCB1,
	0xFC20,
	0xFD64,
	0xFD65,
	0xFDA9,
	0xFCB2,
	0xFCB3,
	0xFC21,
	0xFD66,
	0xFDC5,
	0xFD2B,
	0xFD0F,
	0xFD22,
	0xFD06,
	0xFDF5,
	0xFDF9,
	0xFDF0,
	0xFDFA,
	0xFD17,
	0xFCFB,
	0xFCAE,
	0xFC1D,
	0xFD35,
	0xFD5C,
	0xFD31,
	0xFCE8,
	0xFCAD,
	0xFC1C,
	0xFD34,
	0xFD5E,
	0xFD5D,
	0xFCAF,
	0xFC1E,
	0xFD36,
	0xFDA8,
	0xFDC6,
	0xFCB0,
	0xFC1F,
	0xFCE7,
	0xFD5F,
	0xFD60,
	0xFD61,
	0xFD62,
	0xFD63,
	0xFD2A,
	0xFD0E,
	0xFD18,
	0xFCFC,
	0xFC61,
	0xFCF3,
	0xFC5E,
	0xFC60,
	0xFCF2,
	0xFC62,
	0xFCF4,
	0xFC5F,
	0xFC63,
	0xFD19,
	0xFCFD,
	0xFD26,
	0xFD2E,
	0xFD0A,
	0xFD38,
	0xFD67,
	0xFD68,
	0xFDAA,
	0xFD32,
	0xFCEA,
	0xFD25,
	0xFD2D,
	0xFD09,
	0xFD37,
	0xFD69,
	0xFD27,
	0xFD2F,
	0xFD0B,
	0xFD39,
	0xFD28,
	0xFD30,
	0xFD0C,
	0xFCE9,
	0xFD6A,
	0xFD6B,
	0xFD6C,
	0xFD6D,
	0xFD29,
	0xFD0D,
	0xFD1A,
	0xFCFE,
	0xFD11,
	0xFCF5,
	0xFCB8,
	0xFC26,
	0xFD33,
	0xFC27,
	0xFD3A,
	0xFD71,
	0xFD72,
	0xFD73,
	0xFD74,
	0xFD12,
	0xFCF6,
	0xFC74,
	0xFC0F,
	0xFCA2,
	0xFC0C,
	0xFD51,
	0xFD52,
	0xFD53,
	0xFCA5,
	0xFCE4,
	0xFCA1,
	0xFC0B,
	0xFDA0,
	0xFD50,
	0xFD9F,
	0xFCA3,
	0xFC0D,
	0xFDA2,
	0xFD54,
	0xFDA1,
	0xFC72,
	0xFCA4,
	0xFC0E,
	0xFCE3,
	0xFDA4,
	0xFD56,
	0xFD55,
	0xFD57,
	0xFDA3,
	0xFC73,
	0xFC70,
	0xFC75,
	0xFC10,
	0xFC71,
	0xFC5B,
	0xFC7A,
	0xFC13,
	0xFCE6,
	0xFC11,
	0xFC78,
	0xFCA6,
	0xFC12,
	0xFCE5,
	0xFC79,
	0xFC76,
	0xFC7B,
	0xFC14,
	0xFC77,
	0xFBFA,
	0xFBFB,
	0xFBF9,
	0xFDF8,
	0xFC95,
	0xFC59,
	0xFCDB,
	0xFC56,
	0xFDAE,
	0xFBED,
	0xFBEC,
	0xFBEB,
	0xFBEA,
	0xFC68,
	0xFC03,
	0xFBF7,
	0xFBF8,
	0xFBF6,
	0xFC98,
	0xFC01,
	0xFC9B,
	0xFCE0,
	0xFC97,
	0xFC00,
	0xFC99,
	0xFC66,
	0xFC9A,
	0xFC02,
	0xFCDF,
	0xFC67,
	0xFBF3,
	0xFBF2,
	0xFC64,
	0xFBF1,
	0xFBF0,
	0xFBEF,
	0xFBEE,
	0xFC69,
	0xFC04,
	0xFBF5,
	0xFBF4,
	0xFC65,
	0xFCDE,
	0xFCF1,
	0xFCDA,
	0xFC55,
	0xFDAF,
	0xFCDC,
	0xFC57,
	0xFC93,
	0xFCDD,
	0xFC58,
	0xFCF0,
	0xFD9C,
	0xFD9D,
	0xFDB0,
	0xFC94,
	0xFC91,
	0xFC96,
	0xFC5A,
	0xFC92,
	0xFCB9,
	0xFC28,
	0xFD3B,
	0x0653,
	0x0658,
	0x1EE0F,
	0x1EE00,
	0x1EE01,
	0x1EE19,
	0x1EE03,
	0x1EE1C,
	0x1EE1E,
	0x1EE1D,
	0x1EE1F,
	0x1EEAF,
	0x1EEA1,
	0x1EEB9,
	0x1EEA3,
	0x1EEB0,
	0x1EEBB,
	0x1EEA7,
	0x1EEA2,
	0x1EEB7,
	0x1EEAB,
	0x1EEAC,
	0x1EEAD,
	0x1EEB2,
	0x1EEB3,
	0x1EEB1,
	0x1EEAE,
	0x1EEB4,
	0x1EEA8,
	0x1EEB5,
	0x1EEB8,
	0x1EEB6,
	0x1EEA5,
	0x1EEA9,
	0x1EEBA,
	0x1EEA6,
	0x1EE10,
	0x1EE1B,
	0x1EE07,
	0x1EE2F,
	0x1EE21,
	0x1EE39,
	0x1EE30,
	0x1EE3B,
	0x1EE27,
	0x1EE24,
	0x1EE22,
	0x1EE2A,
	0x1EE37,
	0x1EE2B,
	0x1EE2C,
	0x1EE2D,
	0x1EE32,
	0x1EE31,
	0x1EE2E,
	0x1EE34,
	0x1EE35,
	0x1EE36,
	0x1EE29,
	0x1EE02,
	0x1EE0A,
	0x1EE17,
	0x1EE0B,
	0x1EE8F,
	0x1EE80,
	0x1EE81,
	0x1EE99,
	0x1EE83,
	0x1EE90,
	0x1EE9B,
	0x1EE87,
	0x1EE84,
	0x1EE82,
	0x1EE97,
	0x1EE8B,
	0x1EE8C,
	0x1EE8D,
	0x1EE92,
	0x1EE93,
	0x1EE91,
	0x1EE8E,
	0x1EE94,
	0x1EE88,
	0x1EE95,
	0x1EE98,
	0x1EE96,
	0x1EE85,
	0x1EE89,
	0x1EE9A,
	0x1EE86,
	0x1EE0C,
	0x1EE0D,
	0x1EEF1,
	0x1EEF0,
	0x1EE12,
	0x1EE13,
	0x1EE11,
	0x1EE0E,
	0x1EE14,
	0x1EE6F,
	0x1EE61,
	0x1EE79,
	0x1EE7C,
	0x1EE7E,
	0x1EE70,
	0x1EE7B,
	0x1EE67,
	0x1EE64,
	0x1EE62,
	0x1EE6A,
	0x1EE77,
	0x1EE6C,
	0x1EE6D,
	0x1EE72,
	0x1EE71,
	0x1EE6E,
	0x1EE74,
	0x1EE68,
	0x1EE75,
	0x1EE76,
	0x1EE69,
	0x1EE7A,
	0x1EE08,
	0x1EE4F,
	0x1EE59,
	0x1EE5D,
	0x1EE5F,
	0x1EE5B,
	0x1EE47,
	0x1EE42,
	0x1EE57,
	0x1EE4B,
	0x1EE4D,
	0x1EE52,
	0x1EE51,
	0x1EE4E,
	0x1EE54,
	0x1EE49,
	0x1EE15,
	0x1EE18,
	0x1EE16,
	0x1EE05,
	0x1EE09,
	0x1EE1A,
	0x1EE06,
	0x0600,
	0x08F1,
	0x08F0,
	0x08F2,
	0x066A,
	0x06E9,
	0x060E,
	0x061F,
	0x0608,
	0x065D,
	0x08F8,
	0x08FD,
	0x08FA,
	0x06EC,
	0x061B,
	0x0651,
	0xFE7C,
	0xFE7D,
	0x0611,
	0x060F,
	0x0613,
	0x0612,
	0x0603,
	0x0610,
	0x0604,
	0x0601,
	0x06FD,
	0x06FE,
	0x0614,
	0x0619,
	0x0618,
	0x06E1,
	0x06DA,
	0x06D9,
	0x0616,
	0x06D7,
	0x06D6,
	0x06E4,
	0x06D8,
	0x06E2,
	0x06E8,
	0x06DF,
	0x06DC,
	0x0615,
	0x06DB,
	0x06E0,
	0x08F3,
	0x06E7,
	0x0617,
	0x061A,
	0x06ED,
	0x06E3,
	0x06E5,
	0x06E6,
	0x06DE,
	0x0656,
	0x0652,
	0xFE7E,
	0xFE7F,
	0xFBB2,
	0xFBB3,
	0xFBBC,
	0xFBBA,
	0xFBBB,
	0xFBBF,
	0xFBC0,
	0xFBC1,
	0xFBB6,
	0xFBB7,
	0xFBB8,
	0xFBB9,
	0xFBB4,
	0xFBB5,
	0xFBBD,
	0xFBBE,
	0xFE73,
	0x0640,
	0xFE71,
	0x066C,
	0x08EC,
	0x08EF,
	0x08EA,
	0x08ED,
	0x08EB,
	0x08EE,
	0x061E,
	0x065C,
	0x065B,
	0x065A,
	0x065F,
	0x0659,
	0x0606,
	0x0668,
	0x0665,
	0x0664,
	0x0669,
	0x0661,
	0x0667,
	0x0666,
	0x0663,
	0x0662,
	0x0660,
	0x0607,
	0x0609,
	0x060A,
	0x2312,
	0x2648,
	0x055F,
	0x055A,
	0x0531,
	0x0532,
	0x053E,
	0x0549,
	0x0543,
	0x0551,
	0x0534,
	0x0535,
	0x0537,
	0x0538,
	0x0556,
	0x0542,
	0x0533,
	0x0540,
	0x053B,
	0x0541,
	0x054B,
	0x0554,
	0x053F,
	0x053C,
	0x0544,
	0x0546,
	0x0555,
	0x054A,
	0x0553,
	0x054C,
	0x0550,
	0x054D,
	0x0547,
	0x054F,
	0x0539,
	0x054E,
	0x0548,
	0x053D,
	0x0545,
	0x0552,
	0x0536,
	0x053A,
	0x055D,
	0x058F,
	0x055B,
	0x055C,
	0x0589,
	0x058A,
	0x0559,
	0x055E,
	0x0561,
	0x0562,
	0x056E,
	0x0579,
	0x0573,
	0x0581,
	0x0564,
	0x0565,
	0x0567,
	0x0568,
	0x0586,
	0x0572,
	0x0563,
	0x0570,
	0x056B,
	0x0571,
	0x057B,
	0x0584,
	0x056F,
	0x056C,
	0x0574,
	0x0576,
	0x0585,
	0x057A,
	0x0583,
	0x057C,
	0x0580,
	0x057D,
	0x0577,
	0x057F,
	0x0569,
	0x057E,
	0x0578,
	0x056D,
	0x0575,
	0x0582,
	0x0566,
	0x056A,
	0x0587,
	0xFB14,
	0xFB15,
	0xFB13,
	0xFB17,
	0xFB16,
	0x2936,
	0x2937,
	0x2935,
	0x2934,
	0x1F69B,
	0x1F3A8,
	0x260A,
	0x22A6,
	0x002A,
	0x2217,
	0x2042,
	0x1F632,
	0x26E2,
	0x2243,
	0x1F45F,
	0x269B,
	0x1F346,
	0x20B3,
	0x1F3E7,
	0x1F697,
	0x10B39,
	0x10B00,
	0x10B01,
	0x10B05,
	0x10B03,
	0x10B06,
	0x10B07,
	0x10B04,
	0x10B02,
	0x10B20,
	0x10B21,
	0x10B17,
	0x10B1B,
	0x10B1C,
	0x10B08,
	0x10B09,
	0x10B1F,
	0x10B14,
	0x10B15,
	0x10B16,
	0x10B35,
	0x10B29,
	0x10B0C,
	0x10B0D,
	0x10B18,
	0x10B10,
	0x10B2E,
	0x10B28,
	0x10B25,
	0x10B22,
	0x10B24,
	0x10B23,
	0x10B27,
	0x10B26,
	0x10B0A,
	0x10B0B,
	0x10B1E,
	0x10B2D,
	0x10B2F,
	0x10B31,
	0x10B33,
	0x10B34,
	0x10B19,
	0x10B1A,
	0x10B1D,
	0x10B0E,
	0x10B0F,
	0x10B2C,
	0x10B11,
	0x10B13,
	0x10B12,
	0x10B2B,
	0x10B2A,
	0x10B30,
	0x10B32,
	0x1F476,
	0x1F47C,
	0x1F37C,
	0x1F424,
	0x1F6BC,
	0x1F519,
	0x27AB,
	0x1F42B,
	0x1F6C4,
	0x1B44,
	0x1B5D,
	0x1B5F,
	0x1B5E,
	0x1B58,
	0x1B55,
	0x1B54,
	0x1B59,
	0x1B51,
	0x1B57,
	0x1B56,
	0x1B53,
	0x1B52,
	0x1B50,
	0x1B10,
	0x1B05,
	0x1B06,
	0x1B4B,
	0x1B29,
	0x1B2A,
	0x1B18,
	0x1B19,
	0x1B24,
	0x1B25,
	0x1B1F,
	0x1B20,
	0x1B48,
	0x1B0F,
	0x1B15,
	0x1B16,
	0x1B33,
	0x1B07,
	0x1B08,
	0x1B1A,
	0x1B1B,
	0x1B13,
	0x1B14,
	0x1B45,
	0x1B46,
	0x1B2E,
	0x1B0D,
	0x1B0E,
	0x1B2B,
	0x1B26,
	0x1B21,
	0x1B17,
	0x1B1C,
	0x1B11,
	0x1B12,
	0x1B27,
	0x1B28,
	0x1B2D,
	0x1B0B,
	0x1B0C,
	0x1B32,
	0x1B30,
	0x1B31,
	0x1B22,
	0x1B1D,
	0x1B1E,
	0x1B23,
	0x1B47,
	0x1B09,
	0x1B0A,
	0x1B49,
	0x1B2F,
	0x1B2C,
	0x1B4A,
	0x1B72,
	0x1B6C,
	0x1B73,
	0x1B6F,
	0x1B6E,
	0x1B71,
	0x1B6D,
	0x1B70,
	0x1B6B,
	0x1B67,
	0x1B69,
	0x1B64,
	0x1B6A,
	0x1B65,
	0x1B62,
	0x1B68,
	0x1B66,
	0x1B61,
	0x1B63,
	0x1B7A,
	0x1B7B,
	0x1B78,
	0x1B7C,
	0x1B79,
	0x1B77,
	0x1B76,
	0x1B75,
	0x1B74,
	0x1B5B,
	0x1B60,
	0x1B5A,
	0x1B04,
	0x1B02,
	0x1B34,
	0x1B03,
	0x1B01,
	0x1B00,
	0x1B3C,
	0x1B3D,
	0x1B42,
	0x1B43,
	0x1B3A,
	0x1B3B,
	0x1B38,
	0x1B39,
	0x1B3E,
	0x1B3F,
	0x1B41,
	0x1B40,
	0x1B35,
	0x1B36,
	0x1B37,
	0x1B5C,
	0x1F388,
	0x2749,
	0x2610,
	0x2611,
	0x2612,
	0x2717,
	0xA6F4,
	0xA6F0,
	0xA6F1,
	0xA6F5,
	0xA6F3,
	0xA6A0,
	0xA6A4,
	0xA6ED,
	0xA6CB,
	0xA6D9,
	0xA6D8,
	0xA6A9,
	0xA6A1,
	0xA6D2,
	0xA6BB,
	0xA6C4,
	0xA6E5,
	0xA6DF,
	0xA6EF,
	0xA6EE,
	0xA6E9,
	0xA6A3,
	0xA6BA,
	0xA6AA,
	0xA6AE,
	0xA6DC,
	0xA6DE,
	0xA6CD,
	0xA6B3,
	0xA6E3,
	0xA6E7,
	0xA6E0,
	0xA6AF,
	0xA6E2,
	0xA6CE,
	0xA6E6,
	0xA6B5,
	0xA6DB,
	0xA6B1,
	0xA6D5,
	0xA6D4,
	0xA6D3,
	0xA6CF,
	0xA6B2,
	0xA6C6,
	0xA6BE,
	0xA6C3,
	0xA6C7,
	0xA6EB,
	0xA6BD,
	0xA6BC,
	0xA6A8,
	0xA6A7,
	0xA6AB,
	0xA6CA,
	0xA6C5,
	0x16839,
	0x16801,
	0x16821,
	0x1681C,
	0x16827,
	0x16850,
	0x16833,
	0x16813,
	0x1683B,
	0x16835,
	0x16817,
	0x16818,
	0x16838,
	0x16853,
	0x1682F,
	0x1681A,
	0x1684E,
	0x1680B,
	0x1682B,
	0x1680E,
	0x16832,
	0x16846,
	0x1680F,
	0x1683D,
	0x16848,
	0x16856,
	0x16825,
	0x16824,
	0x1681E,
	0x16836,
	0x16826,
	0x16810,
	0x16804,
	0x16855,
	0x16829,
	0x16834,
	0x16854,
	0x1680D,
	0x16845,
	0x16800,
	0x16816,
	0x1682C,
	0x16847,
	0x16843,
	0x16814,
	0x16851,
	0x1684D,
	0x1683F,
	0x16819,
	0x16822,
	0x16812,
	0x16849,
	0x1684F,
	0x16841,
	0x16807,
	0x1681F,
	0x16828,
	0x1684C,
	0x16842,
	0x1681D,
	0x1681B,
	0x1682A,
	0x16803,
	0x16802,
	0x1680A,
	0x16809,
	0x1682D,
	0x1683A,
	0x16811,
	0x16808,
	0x1683E,
	0x16840,
	0x16805,
	0x16837,
	0x16823,
	0x16830,
	0x1683C,
	0x1684B,
	0x16815,
	0x1684A,
	0x16831,
	0x16806,
	0x1680C,
	0x1682E,
	0x16820,
	0x16844,
	0x16852,
	0x16885,
	0x16883,
	0x1686F,
	0x16866,
	0x16860,
	0x16886,
	0x1686E,
	0x16870,
	0x1685D,
	0x1688D,
	0x16871,
	0x16863,
	0x16889,
	0x1685B,
	0x1688C,
	0x16887,
	0x16888,
	0x1685C,
	0x1685F,
	0x1687E,
	0x1686C,
	0x16884,
	0x16879,
	0x16882,
	0x1687C,
	0x1686B,
	0x1687F,
	0x16865,
	0x1688A,
	0x16875,
	0x1687A,
	0x1687B,
	0x16874,
	0x1688E,
	0x1688B,
	0x16857,
	0x16864,
	0x16880,
	0x1686D,
	0x16872,
	0x16861,
	0x16867,
	0x16881,
	0x16877,
	0x1685A,
	0x16869,
	0x1686A,
	0x16859,
	0x1687D,
	0x16878,
	0x16858,
	0x16868,
	0x16873,
	0x16876,
	0x16862,
	0x1685E,
	0x168C0,
	0x168BC,
	0x16898,
	0x168A0,
	0x16896,
	0x168A9,
	0x168EA,
	0x168E9,
	0x168C9,
	0x168A1,
	0x168E2,
	0x168E0,
	0x1689F,
	0x168A8,
	0x168D5,
	0x168CE,
	0x168C5,
	0x168B6,
	0x168ED,
	0x168CD,
	0x168B3,
	0x168D8,
	0x168DE,
	0x168CB,
	0x1689E,
	0x168E3,
	0x168DF,
	0x16897,
	0x168C2,
	0x1689B,
	0x168E1,
	0x168DD,
	0x168B7,
	0x168A6,
	0x168CC,
	0x168A4,
	0x168B8,
	0x168E6,
	0x168E7,
	0x168B2,
	0x168EC,
	0x168D7,
	0x168DA,
	0x16894,
	0x168BD,
	0x168AB,
	0x1689D,
	0x168EB,
	0x16893,
	0x168CA,
	0x168B0,
	0x168D2,
	0x168BB,
	0x168B5,
	0x16895,
	0x1688F,
	0x168D0,
	0x168C4,
	0x168CF,
	0x168C8,
	0x168E5,
	0x168AD,
	0x168BE,
	0x168A5,
	0x168BF,
	0x168D3,
	0x168D6,
	0x168C7,
	0x168B4,
	0x168D4,
	0x168B9,
	0x1689A,
	0x16899,
	0x16890,
	0x168A3,
	0x168EF,
	0x168EE,
	0x1689C,
	0x168C3,
	0x168DC,
	0x168AA,
	0x168E8,
	0x168DB,
	0x168AF,
	0x168AC,
	0x168F0,
	0x168BA,
	0x168AE,
	0x168C6,
	0x168C1,
	0x168B1,
	0x16892,
	0x168D1,
	0x168D9,
	0x168A7,
	0x168A2,
	0x16891,
	0x168E4,
	0x16965,
	0x16914,
	0x16912,
	0x16948,
	0x16904,
	0x168FF,
	0x16926,
	0x1690F,
	0x1692C,
	0x16949,
	0x1693A,
	0x16906,
	0x1693F,
	0x16921,
	0x16956,
	0x1694F,
	0x16930,
	0x16917,
	0x16944,
	0x168F6,
	0x1695F,
	0x1691E,
	0x16951,
	0x16942,
	0x1690A,
	0x16920,
	0x16963,
	0x168F1,
	0x16950,
	0x1693E,
	0x1690B,
	0x1692A,
	0x16908,
	0x16932,
	0x1691D,
	0x168F4,
	0x1691A,
	0x1691C,
	0x16916,
	0x16919,
	0x16953,
	0x1695E,
	0x16937,
	0x16915,
	0x16909,
	0x16918,
	0x16931,
	0x168F9,
	0x16943,
	0x1693B,
	0x16945,
	0x16933,
	0x168FE,
	0x16929,
	0x16910,
	0x1693C,
	0x168FC,
	0x16913,
	0x1695B,
	0x16902,
	0x1690E,
	0x168F7,
	0x168F3,
	0x168F5,
	0x16947,
	0x168F8,
	0x16946,
	0x1691F,
	0x1692B,
	0x16940,
	0x16959,
	0x16938,
	0x16962,
	0x16957,
	0x168FA,
	0x16922,
	0x1694D,
	0x1692F,
	0x16935,
	0x1695A,
	0x1692E,
	0x1692D,
	0x1695D,
	0x1691B,
	0x16927,
	0x16960,
	0x1694A,
	0x1694E,
	0x16907,
	0x16964,
	0x1690C,
	0x168FD,
	0x16901,
	0x16955,
	0x16954,
	0x1695C,
	0x16958,
	0x16924,
	0x16939,
	0x16903,
	0x16952,
	0x1694B,
	0x16928,
	0x16923,
	0x16941,
	0x16900,
	0x16961,
	0x1694C,
	0x16911,
	0x1693D,
	0x168F2,
	0x168FB,
	0x16905,
	0x1690D,
	0x16934,
	0x16936,
	0x16925,
	0x169D5,
	0x169BB,
	0x16A01,
	0x169EB,
	0x169D3,
	0x169D2,
	0x169C8,
	0x169F5,
	0x169B4,
	0x169C4,
	0x169A9,
	0x169B5,
	0x169A2,
	0x169BA,
	0x169C7,
	0x16995,
	0x16988,
	0x16A02,
	0x169D8,
	0x169B7,
	0x1699A,
	0x169E6,
	0x169FE,
	0x169F9,
	0x16974,
	0x169AB,
	0x1697A,
	0x169CC,
	0x1699F,
	0x16969,
	0x169D9,
	0x169B3,
	0x1697B,
	0x1696B,
	0x1698C,
	0x169F8,
	0x169ED,
	0x169FB,
	0x169B8,
	0x1697E,
	0x1698B,
	0x169FC,
	0x169A6,
	0x16968,
	0x169FA,
	0x169AF,
	0x16987,
	0x169A5,
	0x169EE,
	0x169C3,
	0x169FF,
	0x169C6,
	0x169C9,
	0x169F6,
	0x169C5,
	0x169DD,
	0x16992,
	0x16966,
	0x169B0,
	0x1698E,
	0x16970,
	0x169F2,
	0x169A3,
	0x1698D,
	0x169BF,
	0x16977,
	0x16993,
	0x169D0,
	0x16986,
	0x16973,
	0x169B9,
	0x16989,
	0x1697F,
	0x169CB,
	0x169B6,
	0x1697D,
	0x16980,
	0x169E0,
	0x169F1,
	0x1698A,
	0x169D4,
	0x169E8,
	0x16983,
	0x169A8,
	0x1697C,
	0x16981,
	0x1696F,
	0x169CE,
	0x169BC,
	0x169C0,
	0x169AD,
	0x169A7,
	0x169C1,
	0x169D7,
	0x169D1,
	0x169DA,
	0x1696C,
	0x16978,
	0x16984,
	0x169BD,
	0x169E7,
	0x169F7,
	0x169B1,
	0x169CD,
	0x16998,
	0x169C2,
	0x169A0,
	0x16971,
	0x169CA,
	0x169E9,
	0x16991,
	0x169F0,
	0x1696E,
	0x169EF,
	0x16982,
	0x16985,
	0x16976,
	0x16990,
	0x169A4,
	0x169DE,
	0x169F3,
	0x169F4,
	0x1696D,
	0x1699B,
	0x169DB,
	0x169A1,
	0x1698F,
	0x16972,
	0x169DC,
	0x16A00,
	0x169FD,
	0x1699C,
	0x16979,
	0x16967,
	0x169D6,
	0x16996,
	0x169AA,
	0x16999,
	0x169EC,
	0x1699D,
	0x1696A,
	0x1699E,
	0x169EA,
	0x16975,
	0x169AC,
	0x16997,
	0x169CF,
	0x169BE,
	0x169DF,
	0x16994,
	0x169AE,
	0x169E3,
	0x169E2,
	0x169E1,
	0x169B2,
	0x169E5,
	0x169E4,
	0x16A06,
	0x16A2B,
	0x16A03,
	0x16A26,
	0x16A17,
	0x16A2F,
	0x16A36,
	0x16A05,
	0x16A16,
	0x16A0A,
	0x16A2D,
	0x16A2E,
	0x16A11,
	0x16A32,
	0x16A34,
	0x16A30,
	0x16A0D,
	0x16A33,
	0x16A0F,
	0x16A28,
	0x16A27,
	0x16A24,
	0x16A10,
	0x16A1A,
	0x16A1E,
	0x16A20,
	0x16A19,
	0x16A18,
	0x16A09,
	0x16A22,
	0x16A1F,
	0x16A2A,
	0x16A07,
	0x16A31,
	0x16A25,
	0x16A0C,
	0x16A0B,
	0x16A23,
	0x16A37,
	0x16A15,
	0x16A13,
	0x16A29,
	0x16A1C,
	0x16A14,
	0x16A12,
	0x16A0E,
	0x16A08,
	0x16A35,
	0x16A04,
	0x16A38,
	0x16A2C,
	0x16A21,
	0x16A1D,
	0x16A1B,
	0xA6DD,
	0xA6D7,
	0xA6C8,
	0xA6D1,
	0xA6A5,
	0xA6E1,
	0xA6D0,
	0xA6AD,
	0xA6AC,
	0xA6CC,
	0xA6EC,
	0xA6B9,
	0xA6B8,
	0xA6B6,
	0xA6D6,
	0xA6C0,
	0xA6B7,
	0xA6B4,
	0xA6B0,
	0xA6A6,
	0xA6EA,
	0xA6E8,
	0xA6E4,
	0xA6A2,
	0xA6DA,
	0xA6C9,
	0xA6C2,
	0xA6BF,
	0xA6C1,
	0xA6F2,
	0xA6F7,
	0xA6F6,
	0x1F34C,
	0x1F3E6,
	0x1F4B5,
	0x1F4B6,
	0x1F4B7,
	0x1F4B4,
	0x1F4CA,
	0x1F488,
	0x26BE,
	0x1F3C0,
	0x1BF1,
	0x1BF0,
	0x1BC0,
	0x1BC5,
	0x1BE1,
	0x1BD1,
	0x1BCE,
	0x1BC2,
	0x1BE4,
	0x1BD0,
	0x1BC6,
	0x1BDE,
	0x1BD4,
	0x1BC4,
	0x1BCA,
	0x1BDA,
	0x1BE3,
	0x1BC9,
	0x1BE2,
	0x1BDD,
	0x1BD7,
	0x1BE0,
	0x1BC7,
	0x1BCD,
	0x1BD2,
	0x1BD8,
	0x1BC1,
	0x1BCF,
	0x1BC3,
	0x1BDF,
	0x1BD5,
	0x1BC8,
	0x1BD3,
	0x1BD9,
	0x1BCC,
	0x1BDC,
	0x1BD6,
	0x1BE5,
	0x1BCB,
	0x1BDB,
	0x1BF2,
	0x1BF3,
	0x1BE6,
	0x1BFE,
	0x1BFC,
	0x1BFF,
	0x1BFD,
	0x1BE7,
	0x1BE9,
	0x1BEA,
	0x1BEB,
	0x1BED,
	0x1BEC,
	0x1BE8,
	0x1BEE,
	0x1BEF,
	0x1F6C0,
	0x1F6C1,
	0x1F50B,
	0x266B,
	0x266C,
	0x1F43B,
	0x1F493,
	0x2235,
	0x1F37A,
	0x1F514,
	0x237E,
	0x1F515,
	0x09D7,
	0x09F9,
	0x09F7,
	0x09F4,
	0x09F8,
	0x09F6,
	0x09F5,
	0x09EE,
	0x09EB,
	0x09EA,
	0x09EF,
	0x09E7,
	0x09ED,
	0x09EC,
	0x09E9,
	0x09E8,
	0x09E6,
	0x09FB,
	0x09FA,
	0x0985,
	0x0986,
	0x0990,
	0x0994,
	0x09AC,
	0x09AD,
	0x099A,
	0x099B,
	0x09A6,
	0x09A1,
	0x09A2,
	0x09A7,
	0x098F,
	0x0997,
	0x0998,
	0x09B9,
	0x0987,
	0x0988,
	0x099C,
	0x099D,
	0x0995,
	0x0996,
	0x09CE,
	0x09B2,
	0x09AE,
	0x09A8,
	0x0999,
	0x09A3,
	0x099E,
	0x0993,
	0x09AA,
	0x09AB,
	0x09B0,
	0x09F1,
	0x09F0,
	0x09DD,
	0x09DC,
	0x09B8,
	0x09B6,
	0x09B7,
	0x09A4,
	0x09A5,
	0x099F,
	0x09A0,
	0x0989,
	0x098A,
	0x098C,
	0x09E1,
	0x098B,
	0x09E0,
	0x09AF,
	0x09DF,
	0x09F2,
	0x09F3,
	0x0982,
	0x09BD,
	0x0981,
	0x09BC,
	0x09CD,
	0x0983,
	0x09BE,
	0x09C8,
	0x09CC,
	0x09C7,
	0x09BF,
	0x09C0,
	0x09CB,
	0x09C1,
	0x09C2,
	0x09E2,
	0x09E3,
	0x09C3,
	0x09C4,
	0x1F371,
	0x232C,
	0x23E3,
	0x2136,
	0x226C,
	0x1F6B2,
	0x1F6B4,
	0x29F9,
	0x29F8,
	0x1F459,
	0x1F3B1,
	0x2623,
	0x1F426,
	0x1F382,
	0x29D3,
	0x272C,
	0x265D,
	0x265A,
	0x265E,
	0x265F,
	0x265B,
	0x265C,
	0x25CF,
	0x29ED,
	0x2689,
	0x2688,
	0x2663,
	0x26E8,
	0x25C6,
	0x2756,
	0x2666,
	0x29EA,
	0x23EC,
	0x25BE,
	0x25BC,
	0x26C3,
	0x26C2,
	0x2691,
	0x273F,
	0x2726,
	0x2665,
	0x2B22,
	0x2B2C,
	0x29D7,
	0x2B24,
	0x2B1B,
	0x26D8,
	0x261A,
	0x23EA,
	0x23EE,
	0x25C4,
	0x25C2,
	0x25C0,
	0x204C,
	0x25E3,
	0x25E2,
	0x29EB,
	0x2B25,
	0x2B27,
	0x25FE,
	0x25FC,
	0x26B8,
	0x2712,
	0x25B0,
	0x2B1F,
	0x2753,
	0x25AC,
	0x261B,
	0x23E9,
	0x23ED,
	0x2B53,
	0x25BA,
	0x25B8,
	0x25B6,
	0x23EF,
	0x27A1,
	0x27A4,
	0x204D,
	0x2702,
	0x2617,
	0x2B29,
	0x2B2A,
	0x25AA,
	0x2B51,
	0x263B,
	0x26C7,
	0x2660,
	0x25A0,
	0x1F532,
	0x2605,
	0x2600,
	0x260E,
	0x26DF,
	0x26D6,
	0x267B,
	0x23EB,
	0x25B4,
	0x25B2,
	0x25E4,
	0x25E5,
	0x2B2E,
	0x25AE,
	0x2B1D,
	0x27B6,
	0x27B5,
	0x27B4,
	0x212D,
	0x210C,
	0x2111,
	0x211C,
	0x2128,
	0x2422,
	0x1F33C,
	0x1F421,
	0x1F4D8,
	0x1F499,
	0x1F417,
	0x1F4A3,
	0x1F516,
	0x1F4D1,
	0x1F4DA,
	0x31B7,
	0x31B6,
	0x31B4,
	0x31B5,
	0x311A,
	0x311E,
	0x31AE,
	0x31B0,
	0x3122,
	0x3124,
	0x31A9,
	0x3120,
	0x31AF,
	0x3105,
	0x31A0,
	0x3118,
	0x3114,
	0x3109,
	0x311C,
	0x31A4,
	0x311D,
	0x311F,
	0x3123,
	0x3125,
	0x31A5,
	0x3126,
	0x3108,
	0x310D,
	0x31B8,
	0x312C,
	0x31A3,
	0x310F,
	0x3127,
	0x312D,
	0x31AC,
	0x31AA,
	0x31B3,
	0x31A8,
	0x3129,
	0x3110,
	0x31A2,
	0x310E,
	0x310C,
	0x31B9,
	0x3107,
	0x310B,
	0x312B,
	0x31AD,
	0x311B,
	0x31B1,
	0x31B2,
	0x31A7,
	0x31A6,
	0x3121,
	0x3106,
	0x3111,
	0x3116,
	0x3119,
	0x3115,
	0x310A,
	0x3128,
	0x31AB,
	0x312A,
	0x3112,
	0x3117,
	0x3113,
	0x31A1,
	0x31BA,
	0x293B,
	0x23DF,
	0x2321,
	0x231E,
	0x230D,
	0x2E24,
	0x23DD,
	0x231F,
	0x230C,
	0x2E25,
	0x23B5,
	0x23B6,
	0x23E1,
	0x1F490,
	0x1F3B3,
	0x22C8,
	0x29D1,
	0x29D2,
	0x2566,
	0x2557,
	0x2554,
	0x2550,
	0x2569,
	0x255D,
	0x255A,
	0x2551,
	0x256C,
	0x2563,
	0x2560,
	0x2565,
	0x2556,
	0x2553,
	0x2530,
	0x2512,
	0x2527,
	0x250E,
	0x251F,
	0x2541,
	0x252F,
	0x2511,
	0x2529,
	0x250D,
	0x2521,
	0x2547,
	0x2564,
	0x2555,
	0x2552,
	0x254D,
	0x254F,
	0x257B,
	0x2533,
	0x2513,
	0x250F,
	0x2501,
	0x2578,
	0x257E,
	0x2509,
	0x250B,
	0x257A,
	0x2505,
	0x2507,
	0x2579,
	0x253B,
	0x251B,
	0x257F,
	0x2517,
	0x2503,
	0x254B,
	0x252B,
	0x2523,
	0x2545,
	0x252D,
	0x2535,
	0x253D,
	0x2532,
	0x253A,
	0x254A,
	0x2543,
	0x256E,
	0x256D,
	0x256F,
	0x2570,
	0x2573,
	0x2572,
	0x2571,
	0x254C,
	0x254E,
	0x2577,
	0x252C,
	0x2510,
	0x250C,
	0x2500,
	0x2574,
	0x257C,
	0x2508,
	0x250A,
	0x2576,
	0x2504,
	0x2506,
	0x2575,
	0x257D,
	0x2534,
	0x2518,
	0x2514,
	0x2502,
	0x253C,
	0x2524,
	0x251C,
	0x2546,
	0x252E,
	0x2536,
	0x253E,
	0x2531,
	0x2539,
	0x2549,
	0x2544,
	0x2568,
	0x255C,
	0x2559,
	0x2540,
	0x2538,
	0x2526,
	0x251A,
	0x251E,
	0x2516,
	0x2548,
	0x2537,
	0x252A,
	0x2519,
	0x2522,
	0x2515,
	0x2567,
	0x255B,
	0x2558,
	0x256B,
	0x2562,
	0x255F,
	0x2542,
	0x2528,
	0x2520,
	0x253F,
	0x2525,
	0x251D,
	0x256A,
	0x2561,
	0x255E,
	0x1F466,
	0x11047,
	0x1106E,
	0x1106B,
	0x1106A,
	0x1106F,
	0x11067,
	0x1106D,
	0x1106C,
	0x11069,
	0x11068,
	0x11066,
	0x11048,
	0x11005,
	0x11006,
	0x11010,
	0x11012,
	0x11029,
	0x1102A,
	0x11018,
	0x11019,
	0x11024,
	0x1101F,
	0x11020,
	0x11025,
	0x1100F,
	0x11015,
	0x11016,
	0x11033,
	0x11007,
	0x11008,
	0x1101A,
	0x1101B,
	0x11013,
	0x11014,
	0x1102E,
	0x11034,
	0x1102B,
	0x11026,
	0x11017,
	0x11021,
	0x1101C,
	0x11011,
	0x11035,
	0x11037,
	0x11036,
	0x11027,
	0x11028,
	0x1102D,
	0x11032,
	0x11030,
	0x11031,
	0x11022,
	0x11023,
	0x1101D,
	0x1101E,
	0x11009,
	0x1100A,
	0x1102F,
	0x1100D,
	0x1100E,
	0x1100B,
	0x1100C,
	0x1102C,
	0x11059,
	0x11062,
	0x1105F,
	0x11056,
	0x1105E,
	0x11055,
	0x1105A,
	0x11063,
	0x11052,
	0x11064,
	0x11065,
	0x11058,
	0x11061,
	0x11057,
	0x11060,
	0x1105B,
	0x1105D,
	0x11054,
	0x1105C,
	0x11053,
	0x1104C,
	0x11049,
	0x1104A,
	0x1104B,
	0x1104D,
	0x11001,
	0x11000,
	0x11003,
	0x11004,
	0x11002,
	0x11046,
	0x11038,
	0x11043,
	0x11045,
	0x11039,
	0x11042,
	0x1103A,
	0x1103B,
	0x11044,
	0x1103C,
	0x1103D,
	0x11040,
	0x11041,
	0x1103E,
	0x1103F,
	0x2800,
	0x1F35E,
	0x02D8,
	0x1F470,
	0x1F309,
	0x1F4BC,
	0x00A6,
	0x238B,
	0x1F494,
	0x1F41B,
	0x1A1F,
	0x1A15,
	0x1A05,
	0x1A0C,
	0x1A09,
	0x1A01,
	0x1A16,
	0x1A0D,
	0x1A00,
	0x1A12,
	0x1A06,
	0x1A07,
	0x1A0A,
	0x1A02,
	0x1A03,
	0x1A0B,
	0x1A0E,
	0x1A0F,
	0x1A04,
	0x1A11,
	0x1A14,
	0x1A08,
	0x1A13,
	0x1A10,
	0x1A1E,
	0x1A1B,
	0x1A19,
	0x1A17,
	0x1A1A,
	0x1A18,
	0x1740,
	0x174A,
	0x1747,
	0x1744,
	0x1751,
	0x1741,
	0x1743,
	0x174E,
	0x174B,
	0x1748,
	0x1745,
	0x1749,
	0x174D,
	0x1750,
	0x1746,
	0x1742,
	0x174F,
	0x174C,
	0x1752,
	0x1753,
	0x2022,
	0x2219,
	0x25CE,
	0x1F68C,
	0x1F68F,
	0x1F464,
	0x1F465,
	0x1D09C,
	0x1D09B,
	0x1D09F,
	0x1D0A0,
	0x1D09E,
	0x1D09D,
	0x1D09A,
	0x1D0A1,
	0x1D028,
	0x1D062,
	0x1D05C,
	0x1D00D,
	0x1D033,
	0x1D085,
	0x1D022,
	0x1D084,
	0x1D052,
	0x1D0AD,
	0x1D011,
	0x1D012,
	0x1D051,
	0x1D023,
	0x1D097,
	0x1D073,
	0x1D0EC,
	0x1D0EB,
	0x1D0ED,
	0x1D0EF,
	0x1D0E9,
	0x1D0EA,
	0x1D0EE,
	0x1D056,
	0x1D018,
	0x1D03B,
	0x1D067,
	0x1D0C9,
	0x1D0CA,
	0x1D0C8,
	0x1D001,
	0x1D099,
	0x1D0DB,
	0x1D0DA,
	0x1D0DC,
	0x1D0DD,
	0x1D0D0,
	0x1D0D2,
	0x1D0D1,
	0x1D0CF,
	0x1D0D3,
	0x1D0CE,
	0x1D0E7,
	0x1D092,
	0x1D094,
	0x1D093,
	0x1D095,
	0x1D0E6,
	0x1D086,
	0x1D080,
	0x1D02F,
	0x1D064,
	0x1D055,
	0x1D0B6,
	0x1D07B,
	0x1D068,
	0x1D074,
	0x1D060,
	0x1D00E,
	0x1D0B0,
	0x1D0AF,
	0x1D0AE,
	0x1D0C5,
	0x1D034,
	0x1D0B9,
	0x1D0BD,
	0x1D0BF,
	0x1D0BB,
	0x1D0C2,
	0x1D0C1,
	0x1D0BA,
	0x1D0C0,
	0x1D0CC,
	0x1D0CB,
	0x1D0C3,
	0x1D0C4,
	0x1D0BC,
	0x1D0C7,
	0x1D0C6,
	0x1D0BE,
	0x1D0D8,
	0x1D0D9,
	0x1D016,
	0x1D08F,
	0x1D0F5,
	0x1D090,
	0x1D091,
	0x1D072,
	0x1D0B4,
	0x1D0B5,
	0x1D045,
	0x1D03F,
	0x1D098,
	0x1D0B7,
	0x1D035,
	0x1D0B8,
	0x1D0AC,
	0x1D01A,
	0x1D046,
	0x1D037,
	0x1D07A,
	0x1D007,
	0x1D01B,
	0x1D04F,
	0x1D0F3,
	0x1D0F1,
	0x1D010,
	0x1D01C,
	0x1D04E,
	0x1D0F2,
	0x1D0F0,
	0x1D024,
	0x1D07F,
	0x1D0F4,
	0x1D03A,
	0x1D042,
	0x1D089,
	0x1D04A,
	0x1D082,
	0x1D081,
	0x1D083,
	0x1D032,
	0x1D04C,
	0x1D054,
	0x1D00C,
	0x1D061,
	0x1D08B,
	0x1D08A,
	0x1D08E,
	0x1D08D,
	0x1D08C,
	0x1D02E,
	0x1D05D,
	0x1D0A5,
	0x1D0A3,
	0x1D0A4,
	0x1D0AA,
	0x1D0AB,
	0x1D0B3,
	0x1D0A2,
	0x1D0B2,
	0x1D0A8,
	0x1D0A9,
	0x1D0A7,
	0x1D0A6,
	0x1D0B1,
	0x1D057,
	0x1D040,
	0x1D015,
	0x1D047,
	0x1D05B,
	0x1D004,
	0x1D003,
	0x1D048,
	0x1D020,
	0x1D02C,
	0x1D075,
	0x1D03D,
	0x1D05F,
	0x1D009,
	0x1D03E,
	0x1D05E,
	0x1D01E,
	0x1D038,
	0x1D04D,
	0x1D002,
	0x1D041,
	0x1D049,
	0x1D04B,
	0x1D026,
	0x1D059,
	0x1D06C,
	0x1D039,
	0x1D05A,
	0x1D06F,
	0x1D071,
	0x1D000,
	0x1D017,
	0x1D03C,
	0x1D025,
	0x1D01D,
	0x1D029,
	0x1D069,
	0x1D0E2,
	0x1D0E3,
	0x1D0E5,
	0x1D0E4,
	0x1D0DE,
	0x1D0DF,
	0x1D0E1,
	0x1D0E0,
	0x1D07E,
	0x1D01F,
	0x1D0E8,
	0x1D044,
	0x1D02A,
	0x1D02B,
	0x1D065,
	0x1D013,
	0x1D066,
	0x1D008,
	0x1D00F,
	0x1D031,
	0x1D088,
	0x1D02D,
	0x1D078,
	0x1D076,
	0x1D077,
	0x1D079,
	0x1D014,
	0x1D027,
	0x1D030,
	0x1D096,
	0x1D087,
	0x1D06D,
	0x1D043,
	0x1D036,
	0x1D063,
	0x1D06E,
	0x1D06B,
	0x1D070,
	0x1D006,
	0x1D005,
	0x1D058,
	0x1D021,
	0x1D019,
	0x1D06A,
	0x1D07D,
	0x1D07C,
	0x1D0D4,
	0x1D0D6,
	0x1D0D5,
	0x1D0D7,
	0x1D0CD,
	0x1D00A,
	0x1D00B,
	0x1D053,
	0x1D050,
	0x1F335,
	0x2106,
	0x2624,
	0x1F4C5,
	0x1F4F7,
	0x140A,
	0x140B,
	0x1402,
	0x18B2,
	0x141C,
	0x15AF,
	0x142E,
	0x14BE,
	0x1506,
	0x18B1,
	0x18F3,
	0x18F4,
	0x153F,
	0x15B3,
	0x15B0,
	0x15B1,
	0x15BF,
	0x15BC,
	0x15BD,
	0x15BE,
	0x15BB,
	0x15B8,
	0x15B9,
	0x15BA,
	0x15B2,
	0x1508,
	0x167F,
	0x15B7,
	0x15B4,
	0x15B5,
	0x15B6,
	0x14A1,
	0x1490,
	0x1491,
	0x148A,
	0x1666,
	0x1663,
	0x1664,
	0x1665,
	0x1662,
	0x1661,
	0x1453,
	0x18EE,
	0x18F5,
	0x1454,
	0x162D,
	0x162A,
	0x162B,
	0x162C,
	0x1629,
	0x1628,
	0x164D,
	0x164A,
	0x164B,
	0x164C,
	0x1649,
	0x1648,
	0x1408,
	0x15F4,
	0x18EF,
	0x15F1,
	0x15F2,
	0x15C9,
	0x15C6,
	0x15C7,
	0x15C8,
	0x15C5,
	0x15C4,
	0x15F3,
	0x15F0,
	0x15EF,
	0x18F0,
	0x18ED,
	0x144B,
	0x1436,
	0x1437,
	0x15DB,
	0x15D8,
	0x15D9,
	0x15DA,
	0x15D7,
	0x15D6,
	0x1409,
	0x1647,
	0x161B,
	0x1617,
	0x1618,
	0x1619,
	0x1621,
	0x161E,
	0x161F,
	0x1620,
	0x161D,
	0x161C,
	0x1616,
	0x1614,
	0x18F2,
	0x15FA,
	0x15F7,
	0x15F8,
	0x15F9,
	0x15F6,
	0x15F5,
	0x1601,
	0x1600,
	0x15FD,
	0x15FE,
	0x15FF,
	0x15FC,
	0x15FB,
	0x1627,
	0x1624,
	0x1625,
	0x1633,
	0x1630,
	0x1631,
	0x1632,
	0x162F,
	0x162E,
	0x1626,
	0x1623,
	0x1622,
	0x160D,
	0x160A,
	0x160B,
	0x160C,
	0x1609,
	0x1608,
	0x1607,
	0x1604,
	0x1605,
	0x14D1,
	0x1606,
	0x1603,
	0x1602,
	0x15EE,
	0x15ED,
	0x15EA,
	0x15EB,
	0x15EC,
	0x15E9,
	0x15E8,
	0x15CF,
	0x15CC,
	0x15CD,
	0x15CE,
	0x15CB,
	0x15CA,
	0x1653,
	0x1650,
	0x1651,
	0x165A,
	0x1659,
	0x1656,
	0x1657,
	0x1658,
	0x1655,
	0x1654,
	0x1652,
	0x164F,
	0x164E,
	0x15E1,
	0x15DE,
	0x15DF,
	0x15E0,
	0x15DD,
	0x15DC,
	0x163F,
	0x163C,
	0x163D,
	0x1639,
	0x1636,
	0x1637,
	0x1638,
	0x1635,
	0x1634,
	0x163E,
	0x163B,
	0x163A,
	0x1660,
	0x165D,
	0x165E,
	0x165F,
	0x165C,
	0x165B,
	0x15E7,
	0x15E4,
	0x15E5,
	0x15E6,
	0x15E3,
	0x166C,
	0x1669,
	0x166A,
	0x166B,
	0x1668,
	0x1667,
	0x15E2,
	0x15D5,
	0x15D2,
	0x15D3,
	0x15D4,
	0x15D1,
	0x15D0,
	0x1613,
	0x1610,
	0x1611,
	0x1612,
	0x160F,
	0x160E,
	0x1646,
	0x1645,
	0x1642,
	0x1643,
	0x1644,
	0x1641,
	0x1640,
	0x1489,
	0x166D,
	0x148B,
	0x148C,
	0x148D,
	0x148E,
	0x149C,
	0x149E,
	0x1492,
	0x1494,
	0x1496,
	0x1498,
	0x149A,
	0x1401,
	0x18DC,
	0x142B,
	0x155D,
	0x1559,
	0x155A,
	0x1554,
	0x1553,
	0x1555,
	0x1556,
	0x141F,
	0x1421,
	0x1425,
	0x1426,
	0x142A,
	0x1420,
	0x1427,
	0x1429,
	0x18DF,
	0x1423,
	0x1424,
	0x1428,
	0x18DE,
	0x1422,
	0x1557,
	0x1558,
	0x166E,
	0x155B,
	0x141E,
	0x157D,
	0x1400,
	0x1403,
	0x1404,
	0x142C,
	0x1483,
	0x1472,
	0x1473,
	0x146C,
	0x18B8,
	0x146B,
	0x146D,
	0x146E,
	0x146F,
	0x1470,
	0x1484,
	0x147E,
	0x1480,
	0x18B9,
	0x1474,
	0x1476,
	0x1478,
	0x147A,
	0x147C,
	0x14EA,
	0x14DA,
	0x14DB,
	0x14D4,
	0x18BD,
	0x14D3,
	0x15A6,
	0x15A4,
	0x15A5,
	0x15A0,
	0x15A1,
	0x15A2,
	0x15A3,
	0x14D5,
	0x14D6,
	0x14D7,
	0x14D8,
	0x14E6,
	0x14E8,
	0x14DC,
	0x14DE,
	0x14E0,
	0x14E2,
	0x14E4,
	0x14BB,
	0x14AA,
	0x14AB,
	0x14A4,
	0x18BA,
	0x14A3,
	0x14EC,
	0x1552,
	0x14BD,
	0x14A5,
	0x14A6,
	0x14A7,
	0x14A8,
	0x1509,
	0x14B6,
	0x14B8,
	0x14AC,
	0x14AE,
	0x14B0,
	0x14B2,
	0x14B4,
	0x14D0,
	0x155F,
	0x1561,
	0x1563,
	0x14C7,
	0x14C8,
	0x14C1,
	0x14A0,
	0x1482,
	0x14BA,
	0x14CF,
	0x150B,
	0x150F,
	0x150A,
	0x150E,
	0x150C,
	0x150D,
	0x1504,
	0x1465,
	0x141B,
	0x1416,
	0x153D,
	0x18BC,
	0x14C0,
	0x1595,
	0x1593,
	0x1594,
	0x158E,
	0x1670,
	0x158F,
	0x1590,
	0x1591,
	0x1592,
	0x14D2,
	0x14C2,
	0x14C3,
	0x1596,
	0x1675,
	0x1676,
	0x1671,
	0x1672,
	0x1673,
	0x1674,
	0x14C4,
	0x14C5,
	0x18BB,
	0x157B,
	0x1579,
	0x157A,
	0x1574,
	0x1575,
	0x1576,
	0x1577,
	0x1578,
	0x157C,
	0x14CB,
	0x14CD,
	0x14C9,
	0x18C6,
	0x18C8,
	0x18CA,
	0x18CC,
	0x1405,
	0x18D7,
	0x18D6,
	0x18D8,
	0x18D9,
	0x18C7,
	0x18C9,
	0x18CB,
	0x18CD,
	0x18D4,
	0x18DA,
	0x18DB,
	0x18D5,
	0x142D,
	0x1406,
	0x18B0,
	0x1449,
	0x1438,
	0x1439,
	0x1430,
	0x18B5,
	0x142F,
	0x1431,
	0x1432,
	0x1433,
	0x1434,
	0x18B4,
	0x1444,
	0x1446,
	0x143A,
	0x143C,
	0x143E,
	0x1440,
	0x1442,
	0x18B6,
	0x1585,
	0x1583,
	0x1584,
	0x157E,
	0x166F,
	0x157F,
	0x1580,
	0x1581,
	0x1582,
	0x1550,
	0x1543,
	0x18E0,
	0x154B,
	0x154C,
	0x1545,
	0x18C5,
	0x1542,
	0x1546,
	0x1547,
	0x1548,
	0x1549,
	0x18D3,
	0x154E,
	0x18CE,
	0x18CF,
	0x18D0,
	0x18D1,
	0x18D2,
	0x1505,
	0x14F4,
	0x14F5,
	0x14EE,
	0x18BF,
	0x15C3,
	0x15C0,
	0x15C1,
	0x15C2,
	0x18EC,
	0x161A,
	0x1615,
	0x18F1,
	0x14BF,
	0x159A,
	0x1597,
	0x1598,
	0x1599,
	0x18EB,
	0x18EA,
	0x14A2,
	0x1541,
	0x14ED,
	0x1525,
	0x1515,
	0x1516,
	0x18C1,
	0x1510,
	0x1511,
	0x1512,
	0x1513,
	0x1514,
	0x18C0,
	0x1521,
	0x1523,
	0x1517,
	0x1519,
	0x151B,
	0x151D,
	0x151F,
	0x18C2,
	0x14EF,
	0x14F0,
	0x14F1,
	0x14F2,
	0x1488,
	0x1485,
	0x1486,
	0x1487,
	0x18BE,
	0x1507,
	0x1500,
	0x1502,
	0x14F6,
	0x14F8,
	0x14FA,
	0x14FC,
	0x14FE,
	0x1466,
	0x1455,
	0x1456,
	0x144D,
	0x18B7,
	0x144C,
	0x156A,
	0x15AE,
	0x15AC,
	0x15AD,
	0x15A7,
	0x15A8,
	0x15A9,
	0x15AA,
	0x15AB,
	0x1566,
	0x1567,
	0x155E,
	0x1560,
	0x1562,
	0x1564,
	0x1565,
	0x18E4,
	0x1568,
	0x18E3,
	0x144E,
	0x144F,
	0x1589,
	0x1586,
	0x1587,
	0x1588,
	0x18E9,
	0x18E8,
	0x1450,
	0x1451,
	0x146A,
	0x1467,
	0x156F,
	0x156E,
	0x18E7,
	0x156B,
	0x156C,
	0x156D,
	0x18E6,
	0x18E5,
	0x1468,
	0x1469,
	0x1461,
	0x1463,
	0x1457,
	0x1459,
	0x145B,
	0x145D,
	0x145F,
	0x1573,
	0x1570,
	0x1571,
	0x1572,
	0x1417,
	0x1419,
	0x18B3,
	0x140C,
	0x149D,
	0x149F,
	0x1493,
	0x1495,
	0x1497,
	0x1499,
	0x149B,
	0x155C,
	0x147F,
	0x1481,
	0x1475,
	0x1477,
	0x1479,
	0x147B,
	0x147D,
	0x14EB,
	0x154D,
	0x18E2,
	0x1544,
	0x154A,
	0x18E1,
	0x14E7,
	0x14E9,
	0x14DD,
	0x14DF,
	0x14E1,
	0x14E3,
	0x14E5,
	0x14BC,
	0x14B7,
	0x14B9,
	0x14AD,
	0x14AF,
	0x14B1,
	0x14B3,
	0x14B5,
	0x14CC,
	0x14CE,
	0x14CA,
	0x144A,
	0x1445,
	0x1447,
	0x143B,
	0x143D,
	0x143F,
	0x1441,
	0x1443,
	0x1551,
	0x158D,
	0x158A,
	0x158B,
	0x158C,
	0x154F,
	0x1522,
	0x1524,
	0x1518,
	0x151A,
	0x151C,
	0x151E,
	0x1520,
	0x1501,
	0x1503,
	0x14F7,
	0x14F9,
	0x14FB,
	0x14FD,
	0x14FF,
	0x1569,
	0x1462,
	0x1464,
	0x1458,
	0x145A,
	0x145C,
	0x145E,
	0x1460,
	0x1418,
	0x141A,
	0x140D,
	0x140F,
	0x1411,
	0x1413,
	0x1415,
	0x1540,
	0x153A,
	0x153C,
	0x1530,
	0x1532,
	0x1534,
	0x1536,
	0x1538,
	0x18DD,
	0x140E,
	0x1410,
	0x1412,
	0x1414,
	0x167E,
	0x159F,
	0x159E,
	0x159B,
	0x159C,
	0x159D,
	0x167C,
	0x167D,
	0x1677,
	0x1678,
	0x1679,
	0x167A,
	0x167B,
	0x153E,
	0x148F,
	0x1471,
	0x14D9,
	0x14A9,
	0x14C6,
	0x1407,
	0x1435,
	0x1448,
	0x14F3,
	0x1452,
	0x141D,
	0x152C,
	0x152D,
	0x152E,
	0x1527,
	0x18C4,
	0x1526,
	0x1528,
	0x1529,
	0x152A,
	0x152B,
	0x18C3,
	0x1539,
	0x153B,
	0x152F,
	0x1531,
	0x1533,
	0x1535,
	0x1537,
	0xE007F,
	0x264B,
	0x1F36C,
	0x2651,
	0x26D0,
	0x1F4C7,
	0x2105,
	0x2038,
	0x2041,
	0x102A0,
	0x102A9,
	0x102A2,
	0x102BA,
	0x102C0,
	0x102B9,
	0x102C5,
	0x102BC,
	0x102A3,
	0x102A6,
	0x102AA,
	0x102CA,
	0x102B5,
	0x102BE,
	0x102C4,
	0x102B3,
	0x102AB,
	0x102B7,
	0x102A8,
	0x102A5,
	0x102C9,
	0x102B0,
	0x102AE,
	0x102B8,
	0x102C2,
	0x102AD,
	0x102C7,
	0x102B2,
	0x102BF,
	0x102A4,
	0x102BB,
	0x102B4,
	0x02C7,
	0x1F3A0,
	0x1F38F,
	0x26EB,
	0x1F408,
	0x1F431,
	0x1F639,
	0x1F63C,
	0x2621,
	0x20B5,
	0x00B8,
	0x00A2,
	0x2104,
	0xFE4E,
	0xFE4A,
	0x26B3,
	0x26D3,
	0x11132,
	0x11141,
	0x1113E,
	0x1113B,
	0x1113A,
	0x1113F,
	0x11137,
	0x1113D,
	0x1113C,
	0x11139,
	0x11138,
	0x11136,
	0x11142,
	0x11103,
	0x1111D,
	0x1111E,
	0x1110C,
	0x1110D,
	0x11118,
	0x11113,
	0x11114,
	0x11119,
	0x11106,
	0x11109,
	0x1110A,
	0x11126,
	0x11104,
	0x1110E,
	0x1110F,
	0x11107,
	0x11108,
	0x11123,
	0x1111F,
	0x1111A,
	0x1110B,
	0x11115,
	0x11110,
	0x1111B,
	0x1111C,
	0x11122,
	0x11125,
	0x11116,
	0x11117,
	0x11111,
	0x11112,
	0x11105,
	0x11124,
	0x11121,
	0x11120,
	0x11134,
	0x11131,
	0x11143,
	0x11140,
	0x11101,
	0x11100,
	0x11102,
	0x11133,
	0x11127,
	0x1112D,
	0x1112F,
	0x1112C,
	0x11128,
	0x11129,
	0x1112E,
	0x11130,
	0x1112A,
	0x1112B,
	0xAA4D,
	0xAA4C,
	0xAA43,
	0xAA35,
	0xAA34,
	0xAA36,
	0xAA33,
	0xAA58,
	0xAA55,
	0xAA54,
	0xAA59,
	0xAA51,
	0xAA57,
	0xAA56,
	0xAA53,
	0xAA52,
	0xAA50,
	0xAA00,
	0xAA04,
	0xAA1D,
	0xAA21,
	0xAA1E,
	0xAA0C,
	0xAA0D,
	0xAA15,
	0xAA19,
	0xAA16,
	0xAA03,
	0xAA44,
	0xAA41,
	0xAA40,
	0xAA4A,
	0xAA46,
	0xAA42,
	0xAA47,
	0xAA49,
	0xAA4B,
	0xAA45,
	0xAA48,
	0xAA08,
	0xAA09,
	0xAA28,
	0xAA01,
	0xAA0E,
	0xAA0F,
	0xAA06,
	0xAA07,
	0xAA24,
	0xAA20,
	0xAA1F,
	0xAA18,
	0xAA0B,
	0xAA0A,
	0xAA11,
	0xAA12,
	0xAA10,
	0xAA17,
	0xAA05,
	0xAA1A,
	0xAA1C,
	0xAA1B,
	0xAA23,
	0xAA27,
	0xAA26,
	0xAA13,
	0xAA14,
	0xAA02,
	0xAA25,
	0xAA22,
	0xAA5D,
	0xAA5E,
	0xAA5C,
	0xAA5F,
	0xAA29,
	0xAA30,
	0xAA31,
	0xAA2C,
	0xAA2A,
	0xAA2B,
	0xAA2F,
	0xAA2E,
	0xAA2D,
	0xAA32,
	0x2040,
	0x1F4C9,
	0x1F4C8,
	0x1F4B9,
	0x2713,
	0x1F4E3,
	0x1F3C1,
	0x13A0,
	0x13D3,
	0x13D5,
	0x13D7,
	0x13DC,
	0x13D9,
	0x13DA,
	0x13DB,
	0x13A1,
	0x13A6,
	0x13A8,
	0x13A9,
	0x13AA,
	0x13AB,
	0x13AC,
	0x13AD,
	0x13AE,
	0x13AF,
	0x13BF,
	0x13B0,
	0x13B1,
	0x13B2,
	0x13A2,
	0x13A7,
	0x13B3,
	0x13B4,
	0x13B5,
	0x13B6,
	0x13B7,
	0x13B8,
	0x13B9,
	0x13BA,
	0x13BB,
	0x13BC,
	0x13BD,
	0x13BE,
	0x13C0,
	0x13C1,
	0x13C2,
	0x13C3,
	0x13C4,
	0x13C5,
	0x13A3,
	0x13C6,
	0x13C7,
	0x13C8,
	0x13C9,
	0x13CA,
	0x13CB,
	0x13CD,
	0x13CC,
	0x13CE,
	0x13CF,
	0x13D0,
	0x13D1,
	0x13D2,
	0x13D4,
	0x13D6,
	0x13D8,
	0x13DD,
	0x13DE,
	0x13DF,
	0x13E0,
	0x13E1,
	0x13E2,
	0x13E3,
	0x13E4,
	0x13E5,
	0x13E6,
	0x13E7,
	0x13E8,
	0x13A4,
	0x13A5,
	0x13E9,
	0x13EA,
	0x13EB,
	0x13EC,
	0x13ED,
	0x13EE,
	0x13EF,
	0x13F0,
	0x13F1,
	0x13F2,
	0x13F3,
	0x13F4,
	0x1F352,
	0x1F338,
	0x1F330,
	0x2627,
	0x1F414,
	0x1F6B8,
	0x26B7,
	0x1F36B,
	0x1F384,
	0x26EA,
	0x1F3A6,
	0x29BA,
	0x25D5,
	0x29B5,
	0x25D0,
	0x25D2,
	0x25D1,
	0x29C2,
	0x29BB,
	0x29C3,
	0x25D3,
	0x25D4,
	0x25CD,
	0x29BC,
	0x229B,
	0x29BF,
	0x1F12D,
	0x1F540,
	0x26D2,
	0x229D,
	0x2467,
	0x2464,
	0x2463,
	0x2468,
	0x2460,
	0x2466,
	0x2465,
	0x2462,
	0x2461,
	0x24EA,
	0x2A38,
	0x2298,
	0x2299,
	0x229C,
	0x29C1,
	0x3269,
	0x3277,
	0x3268,
	0x3276,
	0x326D,
	0x327B,
	0x3267,
	0x3275,
	0x327E,
	0x326A,
	0x3278,
	0x3260,
	0x326E,
	0x3264,
	0x3272,
	0x3261,
	0x326F,
	0x326C,
	0x327A,
	0x3265,
	0x3273,
	0x3263,
	0x3271,
	0x3266,
	0x3274,
	0x326B,
	0x3279,
	0x3262,
	0x3270,
	0x27B2,
	0x2389,
	0x1F251,
	0x1F250,
	0x32AF,
	0x329F,
	0x32A5,
	0x3297,
	0x32A2,
	0x32A3,
	0x328F,
	0x3287,
	0x32AD,
	0x329D,
	0x329B,
	0x3296,
	0x328B,
	0x3284,
	0x3283,
	0x3292,
	0x32A4,
	0x32A0,
	0x3245,
	0x3247,
	0x3298,
	0x32A7,
	0x32A6,
	0x329A,
	0x32A9,
	0x328E,
	0x328A,
	0x3294,
	0x32B0,
	0x3288,
	0x3280,
	0x329E,
	0x3244,
	0x32AA,
	0x32AE,
	0x32A1,
	0x32A8,
	0x3246,
	0x3299,
	0x3286,
	0x3285,
	0x3293,
	0x3295,
	0x3291,
	0x32AB,
	0x329C,
	0x3290,
	0x32AC,
	0x3289,
	0x3282,
	0x3281,
	0x328C,
	0x328D,
	0x1F12B,
	0x1F12C,
	0x32D0,
	0x32D3,
	0x32E9,
	0x32EC,
	0x32EA,
	0x32ED,
	0x32EB,
	0x32D1,
	0x32D5,
	0x32D8,
	0x32D6,
	0x32D9,
	0x32D7,
	0x32EE,
	0x32F1,
	0x32EF,
	0x32F2,
	0x32F0,
	0x32E4,
	0x32E7,
	0x32E5,
	0x32E8,
	0x32E6,
	0x32D4,
	0x32F6,
	0x32F9,
	0x32F7,
	0x32FA,
	0x32F8,
	0x32DA,
	0x32DD,
	0x32DB,
	0x32DE,
	0x32DC,
	0x32DF,
	0x32E2,
	0x32E0,
	0x32E3,
	0x32E1,
	0x32D2,
	0x32FB,
	0x32FD,
	0x32FC,
	0x32FE,
	0x32F3,
	0x32F5,
	0x32F4,
	0x327C,
	0x327D,
	0x24B6,
	0x24B7,
	0x24B8,
	0x24B9,
	0x24BA,
	0x24BB,
	0x24BC,
	0x24BD,
	0x24BE,
	0x24BF,
	0x24C0,
	0x24C1,
	0x24C2,
	0x24C3,
	0x24C4,
	0x24C5,
	0x24C6,
	0x24C7,
	0x24C8,
	0x24C9,
	0x24CA,
	0x24CB,
	0x24CC,
	0x24CD,
	0x24CE,
	0x24CF,
	0x24D0,
	0x24D1,
	0x24D2,
	0x24D3,
	0x24D4,
	0x24D5,
	0x24D6,
	0x24D7,
	0x24D8,
	0x24D9,
	0x24DA,
	0x24DB,
	0x24DC,
	0x24DD,
	0x24DE,
	0x24DF,
	0x24E0,
	0x24E1,
	0x24E2,
	0x24E3,
	0x24E4,
	0x24E5,
	0x24E6,
	0x24E7,
	0x24E8,
	0x24E9,
	0x29C0,
	0x2296,
	0x2A36,
	0x2471,
	0x324F,
	0x246A,
	0x246E,
	0x32BF,
	0x324C,
	0x32B5,
	0x32BD,
	0x32BA,
	0x32B9,
	0x32BE,
	0x324B,
	0x32B6,
	0x32BC,
	0x32BB,
	0x32B8,
	0x32B7,
	0x246D,
	0x2472,
	0x2470,
	0x324E,
	0x246F,
	0x324D,
	0x2469,
	0x3248,
	0x246C,
	0x325A,
	0x32B3,
	0x325F,
	0x325E,
	0x32B4,
	0x324A,
	0x325B,
	0x32B2,
	0x32B1,
	0x325D,
	0x325C,
	0x246B,
	0x2473,
	0x3258,
	0x3255,
	0x3254,
	0x3259,
	0x3249,
	0x3251,
	0x3257,
	0x3256,
	0x3253,
	0x3252,
	0x2742,
	0x29B7,
	0x29B9,
	0x2295,
	0x3036,
	0x29B8,
	0x229A,
	0x2297,
	0x238A,
	0x29B6,
	0x29BE,
	0x272A,
	0x1F12E,
	0x2A10,
	0x005E,
	0x1F3AA,
	0x1F306,
	0x2F80A,
	0x2F80B,
	0x2F80C,
	0x2F80D,
	0x2F80E,
	0x2F80F,
	0x2F81A,
	0x2F81B,
	0x2F81C,
	0x2F81D,
	0x2F81E,
	0x2F81F,
	0x2F82A,
	0x2F82B,
	0x2F82C,
	0x2F82D,
	0x2F82E,
	0x2F82F,
	0x2F83A,
	0x2F83B,
	0x2F83C,
	0x2F83D,
	0x2F83E,
	0x2F83F,
	0x2F84A,
	0x2F84B,
	0x2F84C,
	0x2F84D,
	0x2F84E,
	0x2F84F,
	0x2F85A,
	0x2F85B,
	0x2F85C,
	0x2F85D,
	0x2F85E,
	0x2F85F,
	0x2F86A,
	0x2F86B,
	0x2F86C,
	0x2F86D,
	0x2F86E,
	0x2F86F,
	0x2F87A,
	0x2F87B,
	0x2F87C,
	0x2F87D,
	0x2F87E,
	0x2F87F,
	0x2F88A,
	0x2F88B,
	0x2F88C,
	0x2F88D,
	0x2F88E,
	0x2F88F,
	0x2F89A,
	0x2F89B,
	0x2F89C,
	0x2F89D,
	0x2F89E,
	0x2F89F,
	0x2F8AA,
	0x2F8AB,
	0x2F8AC,
	0x2F8AD,
	0x2F8AE,
	0x2F8AF,
	0x2F8BA,
	0x2F8BB,
	0x2F8BC,
	0x2F8BD,
	0x2F8BE,
	0x2F8BF,
	0x2F8CA,
	0x2F8CB,
	0x2F8CC,
	0x2F8CD,
	0x2F8CE,
	0x2F8CF,
	0x2F8DA,
	0x2F8DB,
	0x2F8DC,
	0x2F8DD,
	0x2F8DE,
	0x2F8DF,
	0x2F8EA,
	0x2F8EB,
	0x2F8EC,
	0x2F8ED,
	0x2F8EE,
	0x2F8EF,
	0x2F8FA,
	0x2F8FB,
	0x2F8FC,
	0x2F8FD,
	0x2F8FE,
	0x2F8FF,
	0x2F90A,
	0x2F90B,
	0x2F90C,
	0x2F90D,
	0x2F90E,
	0x2F90F,
	0x2F91A,
	0x2F91B,
	0x2F91C,
	0x2F91D,
	0x2F91E,
	0x2F91F,
	0x2F92A,
	0x2F92B,
	0x2F92C,
	0x2F92D,
	0x2F92E,
	0x2F92F,
	0x2F93A,
	0x2F93B,
	0x2F93C,
	0x2F93D,
	0x2F93E,
	0x2F93F,
	0x2F94A,
	0x2F94B,
	0x2F94C,
	0x2F94D,
	0x2F94E,
	0x2F94F,
	0x2F95A,
	0x2F95B,
	0x2F95C,
	0x2F95D,
	0x2F95E,
	0x2F95F,
	0x2F96A,
	0x2F96B,
	0x2F96C,
	0x2F96D,
	0x2F96E,
	0x2F96F,
	0x2F97A,
	0x2F97B,
	0x2F97C,
	0x2F97D,
	0x2F97E,
	0x2F97F,
	0x2F98A,
	0x2F98B,
	0x2F98C,
	0x2F98D,
	0x2F98E,
	0x2F98F,
	0x2F99A,
	0x2F99B,
	0x2F99C,
	0x2F99D,
	0x2F99E,
	0x2F99F,
	0x2F9AA,
	0x2F9AB,
	0x2F9AC,
	0x2F9AD,
	0x2F9AE,
	0x2F9AF,
	0x2F9BA,
	0x2F9BB,
	0x2F9BC,
	0x2F9BD,
	0x2F9BE,
	0x2F9BF,
	0x2F9CA,
	0x2F9CB,
	0x2F9CC,
	0x2F9CD,
	0x2F9CE,
	0x2F9CF,
	0x2F9DA,
	0x2F9DB,
	0x2F9DC,
	0x2F9DD,
	0x2F9DE,
	0x2F9DF,
	0x2F9EA,
	0x2F9EB,
	0x2F9EC,
	0x2F9ED,
	0x2F9EE,
	0x2F9EF,
	0x2F9FA,
	0x2F9FB,
	0x2F9FC,
	0x2F9FD,
	0x2F9FE,
	0x2F9FF,
	0x2FA0A,
	0x2FA0B,
	0x2FA0C,
	0x2FA0D,
	0x2FA0E,
	0x2FA0F,
	0x2FA1A,
	0x2FA1B,
	0x2FA1C,
	0x2FA1D,
	0xF90A,
	0xF90B,
	0xF90C,
	0xF90D,
	0xF90E,
	0xF90F,
	0xF91A,
	0xF91B,
	0xF91C,
	0xF91D,
	0xF91E,
	0xF91F,
	0xF92A,
	0xF92B,
	0xF92C,
	0xF92D,
	0xF92E,
	0xF92F,
	0xF93A,
	0xF93B,
	0xF93C,
	0xF93D,
	0xF93E,
	0xF93F,
	0xF94A,
	0xF94B,
	0xF94C,
	0xF94D,
	0xF94E,
	0xF94F,
	0xF95A,
	0xF95B,
	0xF95C,
	0xF95D,
	0xF95E,
	0xF95F,
	0xF96A,
	0xF96B,
	0xF96C,
	0xF96D,
	0xF96E,
	0xF96F,
	0xF97A,
	0xF97B,
	0xF97C,
	0xF97D,
	0xF97E,
	0xF97F,
	0xF98A,
	0xF98B,
	0xF98C,
	0xF98D,
	0xF98E,
	0xF98F,
	0xF99A,
	0xF99B,
	0xF99C,
	0xF99D,
	0xF99E,
	0xF99F,
	0xF9AA,
	0xF9AB,
	0xF9AC,
	0xF9AD,
	0xF9AE,
	0xF9AF,
	0xF9BA,
	0xF9BB,
	0xF9BC,
	0xF9BD,
	0xF9BE,
	0xF9BF,
	0xF9CA,
	0xF9CB,
	0xF9CC,
	0xF9CD,
	0xF9CE,
	0xF9CF,
	0xF9DA,
	0xF9DB,
	0xF9DC,
	0xF9DD,
	0xF9DE,
	0xF9DF,
	0xF9EA,
	0xF9EB,
	0xF9EC,
	0xF9ED,
	0xF9EE,
	0xF9EF,
	0xF9FA,
	0xF9FB,
	0xF9FC,
	0xF9FD,
	0xF9FE,
	0xF9FF,
	0xFA0A,
	0xFA0B,
	0xFA0C,
	0xFA0D,
	0xFA0E,
	0xFA0F,
	0xFA1A,
	0xFA1B,
	0xFA1C,
	0xFA1D,
	0xFA1E,
	0xFA1F,
	0xFA2A,
	0xFA2B,
	0xFA2C,
	0xFA2D,
	0xFA2E,
	0xFA2F,
	0xFA3A,
	0xFA3B,
	0xFA3C,
	0xFA3D,
	0xFA3E,
	0xFA3F,
	0xFA4A,
	0xFA4B,
	0xFA4C,
	0xFA4D,
	0xFA4E,
	0xFA4F,
	0xFA5A,
	0xFA5B,
	0xFA5C,
	0xFA5D,
	0xFA5E,
	0xFA5F,
	0xFA6A,
	0xFA6B,
	0xFA6C,
	0xFA6D,
	0xFA7A,
	0xFA7B,
	0xFA7C,
	0xFA7D,
	0xFA7E,
	0xFA7F,
	0xFA8A,
	0xFA8B,
	0xFA8C,
	0xFA8D,
	0xFA8E,
	0xFA8F,
	0xFA9A,
	0xFA9B,
	0xFA9C,
	0xFA9D,
	0xFA9E,
	0xFA9F,
	0xFAAA,
	0xFAAB,
	0xFAAC,
	0xFAAD,
	0xFAAE,
	0xFAAF,
	0xFABA,
	0xFABB,
	0xFABC,
	0xFABD,
	0xFABE,
	0xFABF,
	0xFACA,
	0xFACB,
	0xFACC,
	0xFACD,
	0xFACE,
	0xFACF,
	0x2EAE,
	0x2ED8,
	0x2EAA,
	0x2EE3,
	0x2E86,
	0x2EBA,
	0x2EBB,
	0x2EE6,
	0x2ECB,
	0x2EF0,
	0x2EE0,
	0x2EEC,
	0x2EE5,
	0x2EDC,
	0x2EEA,
	0x2ED4,
	0x2ED0,
	0x2EE2,
	0x2EDA,
	0x2ED3,
	0x2EE7,
	0x2EC5,
	0x2EC9,
	0x2EB0,
	0x2EC8,
	0x2ED9,
	0x2EEE,
	0x2EF3,
	0x2EDB,
	0x2E9B,
	0x2ECF,
	0x2EA0,
	0x2E81,
	0x2EC2,
	0x2EA7,
	0x2E9E,
	0x2E8A,
	0x2EA8,
	0x2EDD,
	0x2EDF,
	0x2EDE,
	0x2EB8,
	0x2EAB,
	0x2EA3,
	0x2ECA,
	0x2EE4,
	0x2EBE,
	0x2EC0,
	0x2EBF,
	0x2E98,
	0x2EE1,
	0x2E96,
	0x2E97,
	0x2EC7,
	0x2EEF,
	0x2EEB,
	0x2EED,
	0x2EF2,
	0x2EA9,
	0x2E88,
	0x2E89,
	0x2E91,
	0x2E8E,
	0x2E90,
	0x2E8F,
	0x2ED1,
	0x2ED2,
	0x2EBC,
	0x2EB5,
	0x2E9D,
	0x2EBD,
	0x2E9F,
	0x2ED5,
	0x2ED6,
	0x2EB4,
	0x2EB1,
	0x2EB3,
	0x2EB2,
	0x2EB9,
	0x2EA4,
	0x2EA5,
	0x2E85,
	0x2ED7,
	0x2EB7,
	0x2E99,
	0x2E80,
	0x2E8B,
	0x2E82,
	0x2E84,
	0x2E83,
	0x2EB6,
	0x2EAF,
	0x2EA6,
	0x2EC6,
	0x2ECC,
	0x2EE8,
	0x2EE9,
	0x2E8C,
	0x2E8D,
	0x2E92,
	0x2E94,
	0x2E95,
	0x2EAC,
	0x2EAD,
	0x2E9C,
	0x2E87,
	0x2E93,
	0x2EC1,
	0x2EF1,
	0x2ECD,
	0x2ECE,
	0x2EA1,
	0x2EA2,
	0x2EC3,
	0x2EC4,
	0x31C3,
	0x31D4,
	0x31D0,
	0x31D6,
	0x31C7,
	0x31CC,
	0x31E0,
	0x31D5,
	0x31C6,
	0x31CA,
	0x31CD,
	0x31C8,
	0x31C5,
	0x31CB,
	0x31CE,
	0x31E1,
	0x31CF,
	0x31D2,
	0x31DB,
	0x31E2,
	0x31DC,
	0x31E3,
	0x31D1,
	0x31DA,
	0x31D3,
	0x31D9,
	0x31C4,
	0x31DF,
	0x31D8,
	0x31D7,
	0x31C9,
	0x31DE,
	0x31C0,
	0x31DD,
	0x31C1,
	0x31C2,
	0x1F3AC,
	0x1F44F,
	0x239A,
	0x1F37B,
	0x1F4CB,
	0x1F557,
	0x1F563,
	0x1F55A,
	0x1F566,
	0x1F554,
	0x1F560,
	0x1F553,
	0x1F55F,
	0x1F558,
	0x1F564,
	0x1F550,
	0x1F55C,
	0x1F556,
	0x1F562,
	0x1F555,
	0x1F561,
	0x1F559,
	0x1F565,
	0x1F552,
	0x1F55E,
	0x1F55B,
	0x1F567,
	0x1F551,
	0x1F55D,
	0x2941,
	0x2232,
	0x1F503,
	0x27F3,
	0x2231,
	0x21BB,
	0x1F501,
	0x1F502,
	0x21B7,
	0x2050,
	0x1F4D5,
	0x2A4D,
	0x1F510,
	0x1F4EA,
	0x1F4EB,
	0x2ACF,
	0x2AD1,
	0x2AD0,
	0x2AD2,
	0x1F302,
	0x2A4C,
	0x2A50,
	0x2601,
	0x1F378,
	0x26B0,
	0x1F4A5,
	0x003A,
	0x2254,
	0x20A1,
	0x0301,
	0x0317,
	0x0341,
	0x1DC9,
	0x1DC7,
	0x034C,
	0x1DFD,
	0x20E7,
	0x20D4,
	0x20DA,
	0x20F0,
	0x0359,
	0x0306,
	0x032E,
	0x1DCB,
	0x0346,
	0x032A,
	0x0310,
	0x030C,
	0x032C,
	0x0327,
	0x0302,
	0x032D,
	0x20D5,
	0x20D9,
	0x0313,
	0x0315,
	0x0326,
	0xFE26,
	0x0485,
	0xA671,
	0x0488,
	0xA67C,
	0x2DF6,
	0x2DE0,
	0x2DFE,
	0x2DF1,
	0x2DE3,
	0x2DF8,
	0x2DE7,
	0x2DE8,
	0x2DE9,
	0x2DEC,
	0x2DED,
	0x2DF5,
	0x2DF4,
	0x2DE2,
	0x2DEF,
	0xA678,
	0xA675,
	0x2DF7,
	0x2DFC,
	0x2DFF,
	0xA69F,
	0x2DE6,
	0x2DFD,
	0x2DF9,
	0x2DEA,
	0xA67B,
	0x2DEB,
	0x2DF2,
	0x2DF3,
	0xA67A,
	0x2DEE,
	0x2DF0,
	0xA677,
	0xA674,
	0x2DE1,
	0x2DFA,
	0xA679,
	0xA676,
	0x2DFB,
	0x2DE5,
	0x2DE4,
	0x0489,
	0x0484,
	0xA67D,
	0x0487,
	0x0486,
	0xA670,
	0xA672,
	0x0483,
	0xA66F,
	0xA8E8,
	0xA8E5,
	0xA8E4,
	0xA8E9,
	0xA8E1,
	0xA8E7,
	0xA8E6,
	0xA8E3,
	0xA8E2,
	0xA8E0,
	0xA8EA,
	0xA8EC,
	0xA8ED,
	0xA8EE,
	0xA8EF,
	0xA8EB,
	0xA8F0,
	0xA8F1,
	0x0308,
	0x0324,
	0x0307,
	0x0358,
	0x0323,
	0x1DC1,
	0x1DC0,
	0x030B,
	0x035D,
	0x035C,
	0x1DCD,
	0x030F,
	0x0361,
	0x1DFC,
	0x0333,
	0x035E,
	0x035F,
	0x033F,
	0x0362,
	0x035A,
	0x0360,
	0xFE22,
	0xFE23,
	0x030E,
	0x0348,
	0x20E6,
	0x031E,
	0x20DD,
	0x20E0,
	0x20DF,
	0x20E3,
	0x20E2,
	0x20DE,
	0x20E4,
	0x0347,
	0x0352,
	0x20DC,
	0x034F,
	0x0300,
	0x0316,
	0x0340,
	0x1DC8,
	0x1DC5,
	0x0344,
	0x0343,
	0x1D244,
	0x1D243,
	0x1D242,
	0x0342,
	0x0345,
	0x034B,
	0x0309,
	0x031B,
	0x0311,
	0x032F,
	0x033A,
	0x032B,
	0x1DD0,
	0x309A,
	0x3099,
	0x1DDB,
	0x1DDE,
	0x1DDF,
	0x1DE1,
	0x1DE2,
	0x0363,
	0x1DD4,
	0x1DD5,
	0x1DD6,
	0x0368,
	0x1DD7,
	0x0369,
	0x0364,
	0x1DD9,
	0x1DD3,
	0x1DDA,
	0x036A,
	0x0365,
	0x1DD8,
	0x1DDC,
	0x1DDD,
	0x1DE5,
	0x036B,
	0x1DE0,
	0x0366,
	0x036C,
	0x1DCA,
	0x1DE3,
	0x1DE4,
	0x036D,
	0x0367,
	0x036E,
	0x036F,
	0x1DE6,
	0x031A,
	0x0349,
	0x20D6,
	0x20EE,
	0x1DFE,
	0x0354,
	0x0351,
	0x031C,
	0x20D0,
	0x20E1,
	0x034D,
	0x0318,
	0x20EA,
	0x20ED,
	0xFE20,
	0xFE21,
	0x20EB,
	0x0338,
	0x0336,
	0x20D2,
	0x0332,
	0x0304,
	0x0331,
	0xFE24,
	0xFE25,
	0x1DC4,
	0x1DCC,
	0x1DC6,
	0x0320,
	0x034A,
	0x0328,
	0x1DCE,
	0x0305,
	0x0321,
	0x031F,
	0x0322,
	0x20E5,
	0x0314,
	0x20D7,
	0x20EF,
	0x0350,
	0x1DFF,
	0x0356,
	0x0355,
	0x0357,
	0x0339,
	0x20D1,
	0x0319,
	0x20EC,
	0x030A,
	0x0325,
	0x20D8,
	0x033C,
	0x0337,
	0x0335,
	0x20D3,
	0x1DC2,
	0x033B,
	0x1DC3,
	0x20DB,
	0x0303,
	0x0330,
	0x0334,
	0x20E8,
	0x0312,
	0x031D,
	0x034E,
	0x1DD1,
	0x1DD2,
	0x030D,
	0x0329,
	0x033E,
	0x20E9,
	0x033D,
	0x0353,
	0x035B,
	0x1DCF,
	0x2604,
	0x002C,
	0x0040,
	0x2052,
	0x2201,
	0x2384,
	0x1F38A,
	0x1F616,
	0x1F615,
	0x2A6D,
	0x2332,
	0x260C,
	0x1F6A7,
	0x1F477,
	0x220B,
	0x22B3,
	0x22B5,
	0x22FA,
	0x22FD,
	0x22FB,
	0x2381,
	0x222E,
	0x1F3EA,
	0x1F35A,
	0x1F36A,
	0x1F373,
	0x2CC8,
	0x2C80,
	0x2CF2,
	0x2CC2,
	0x2CB6,
	0x2CED,
	0x2CBC,
	0x2CEB,
	0x2C86,
	0x03EE,
	0x2CB2,
	0x2CCA,
	0x2CB8,
	0x2CBA,
	0x2C88,
	0x03E4,
	0x2CAA,
	0x2C84,
	0x03EA,
	0x2C8E,
	0x03E8,
	0x2C92,
	0x2C94,
	0x03E6,
	0x2CAC,
	0x2C9C,
	0x2CD0,
	0x2C96,
	0x2C98,
	0x2C9A,
	0x2C9E,
	0x2CB4,
	0x2CD8,
	0x2CC6,
	0x2CD6,
	0x2CCE,
	0x2CD4,
	0x2CD2,
	0x2CCC,
	0x2CBE,
	0x2CC4,
	0x2CDA,
	0x2CDE,
	0x2CE0,
	0x2CDC,
	0x2CE2,
	0x2CB0,
	0x2CA0,
	0x2CAE,
	0x2CA2,
	0x2CC0,
	0x03E2,
	0x03EC,
	0x2CA4,
	0x2C8A,
	0x2CA6,
	0x2C90,
	0x2CA8,
	0x2C82,
	0x2C8C,
	0x2CEF,
	0x2CF0,
	0x2CF1,
	0x2CFD,
	0x2CFE,
	0x2CFF,
	0x2CFA,
	0x2CF9,
	0x2CFB,
	0x2CFC,
	0x2CC9,
	0x2C81,
	0x2CF3,
	0x2CC3,
	0x2CB7,
	0x2CEE,
	0x2CBD,
	0x2CEC,
	0x2C87,
	0x03EF,
	0x2CB3,
	0x2CCB,
	0x2CB9,
	0x2CBB,
	0x2C89,
	0x03E5,
	0x2CAB,
	0x2C85,
	0x03EB,
	0x2C8F,
	0x03E9,
	0x2C93,
	0x2C95,
	0x03E7,
	0x2CAD,
	0x2C9D,
	0x2CD1,
	0x2C97,
	0x2C99,
	0x2C9B,
	0x2C9F,
	0x2CB5,
	0x2CD9,
	0x2CC7,
	0x2CD7,
	0x2CCF,
	0x2CD5,
	0x2CD3,
	0x2CCD,
	0x2CBF,
	0x2CC5,
	0x2CDB,
	0x2CDF,
	0x2CE1,
	0x2CDD,
	0x2CE3,
	0x2CB1,
	0x2CA1,
	0x2CAF,
	0x2CA3,
	0x2CC1,
	0x03E3,
	0x03ED,
	0x2CA5,
	0x2C8B,
	0x2CA7,
	0x2C91,
	0x2CA9,
	0x2C83,
	0x2C8D,
	0x2CE4,
	0x2CE9,
	0x2CE5,
	0x2CE6,
	0x2CEA,
	0x2CE7,
	0x2CE8,
	0x00A9,
	0x2258,
	0x2334,
	0x2335,
	0x1D370,
	0x1D36D,
	0x1D36C,
	0x1D371,
	0x1D369,
	0x1D36F,
	0x1D36E,
	0x1D36B,
	0x1D36A,
	0x1D367,
	0x1D364,
	0x1D363,
	0x1D368,
	0x1D360,
	0x1D366,
	0x1D365,
	0x1D362,
	0x1D361,
	0x1F491,
	0x1F404,
	0x1F42E,
	0x1F4B3,
	0x1F319,
	0x1F40A,
	0x274C,
	0x2629,
	0x2628,
	0x1F542,
	0x1F541,
	0x1F38C,
	0x1F18A,
	0x2694,
	0x26CC,
	0x1F451,
	0x20A2,
	0x1F63F,
	0x1F622,
	0x1F52E,
	0x221B,
	0x12406,
	0x1240D,
	0x12413,
	0x12444,
	0x12403,
	0x1244D,
	0x12455,
	0x12439,
	0x1240A,
	0x12422,
	0x12431,
	0x1245C,
	0x12410,
	0x12402,
	0x1244C,
	0x12453,
	0x12438,
	0x12409,
	0x12421,
	0x12430,
	0x1240F,
	0x1243C,
	0x1243E,
	0x1243F,
	0x12457,
	0x12456,
	0x12407,
	0x1240E,
	0x12414,
	0x12446,
	0x12449,
	0x12462,
	0x12461,
	0x12434,
	0x1245F,
	0x1241E,
	0x12460,
	0x1242C,
	0x1245A,
	0x1245D,
	0x12405,
	0x1240C,
	0x12412,
	0x12442,
	0x12443,
	0x12432,
	0x12433,
	0x12404,
	0x1244E,
	0x1240B,
	0x12411,
	0x12401,
	0x1244B,
	0x12436,
	0x12437,
	0x12408,
	0x12420,
	0x12425,
	0x1242E,
	0x1242F,
	0x12400,
	0x1244A,
	0x12435,
	0x1241F,
	0x1242D,
	0x1245B,
	0x1245E,
	0x12472,
	0x12473,
	0x12470,
	0x12471,
	0x12000,
	0x12001,
	0x12002,
	0x12003,
	0x12004,
	0x12005,
	0x12006,
	0x12007,
	0x12008,
	0x1200A,
	0x12015,
	0x1200C,
	0x1200D,
	0x1200E,
	0x1200F,
	0x12010,
	0x12011,
	0x12012,
	0x12013,
	0x12014,
	0x12017,
	0x12018,
	0x12019,
	0x1201C,
	0x1201D,
	0x1201F,
	0x12020,
	0x12021,
	0x12023,
	0x12024,
	0x12026,
	0x12027,
	0x12028,
	0x12029,
	0x1202A,
	0x1202B,
	0x1202C,
	0x1202D,
	0x1202E,
	0x12030,
	0x12031,
	0x1202F,
	0x12032,
	0x12033,
	0x12034,
	0x12035,
	0x12036,
	0x12038,
	0x1203A,
	0x1203C,
	0x1203D,
	0x1203B,
	0x12039,
	0x1203F,
	0x12040,
	0x12041,
	0x12044,
	0x12045,
	0x12046,
	0x12047,
	0x12049,
	0x1204A,
	0x1204B,
	0x1204C,
	0x1204D,
	0x12050,
	0x1204E,
	0x1204F,
	0x12051,
	0x12052,
	0x12053,
	0x12055,
	0x12056,
	0x12057,
	0x12058,
	0x12059,
	0x1205A,
	0x1205B,
	0x1205C,
	0x1205D,
	0x1205F,
	0x12060,
	0x12061,
	0x12062,
	0x12063,
	0x12064,
	0x12065,
	0x12067,
	0x12068,
	0x12069,
	0x1206A,
	0x1206D,
	0x1206E,
	0x1206F,
	0x12072,
	0x12073,
	0x12074,
	0x12075,
	0x12077,
	0x12078,
	0x12079,
	0x1207A,
	0x1207C,
	0x1207B,
	0x1207D,
	0x1207E,
	0x12081,
	0x12082,
	0x12083,
	0x12084,
	0x12086,
	0x12087,
	0x1208A,
	0x1208C,
	0x1208B,
	0x1208E,
	0x1208F,
	0x12090,
	0x12091,
	0x12092,
	0x12093,
	0x12094,
	0x12095,
	0x12096,
	0x12097,
	0x1209B,
	0x1209C,
	0x1209D,
	0x12099,
	0x1209A,
	0x1209E,
	0x120A1,
	0x120A2,
	0x120A3,
	0x120A4,
	0x120A5,
	0x120A6,
	0x120A7,
	0x120A8,
	0x120A9,
	0x120AA,
	0x120AB,
	0x120AC,
	0x120AD,
	0x120AF,
	0x120B0,
	0x120B1,
	0x120B2,
	0x120B4,
	0x120B5,
	0x120B6,
	0x120B8,
	0x120B9,
	0x120BA,
	0x120BB,
	0x120BC,
	0x120BD,
	0x120BE,
	0x120BF,
	0x120C0,
	0x120C1,
	0x120C2,
	0x120C3,
	0x120C4,
	0x120C5,
	0x120C6,
	0x120C7,
	0x120C8,
	0x120C9,
	0x120CA,
	0x120CB,
	0x120CC,
	0x120CD,
	0x120CF,
	0x120D0,
	0x120D2,
	0x120D3,
	0x120D4,
	0x120D6,
	0x120D7,
	0x120D8,
	0x120D9,
	0x120DA,
	0x120DB,
	0x120DC,
	0x120DD,
	0x120DE,
	0x120DF,
	0x120E0,
	0x120E1,
	0x120E2,
	0x120E3,
	0x120E4,
	0x120E5,
	0x120E6,
	0x120E7,
	0x120E8,
	0x120EA,
	0x120EB,
	0x120EC,
	0x120EE,
	0x120EF,
	0x120F0,
	0x120F1,
	0x120F2,
	0x120F3,
	0x120F4,
	0x120F5,
	0x120F6,
	0x120F8,
	0x120FB,
	0x120FD,
	0x120FE,
	0x120FF,
	0x12100,
	0x12103,
	0x12101,
	0x12102,
	0x12107,
	0x12109,
	0x1210B,
	0x1210C,
	0x1210D,
	0x1210E,
	0x1210F,
	0x12110,
	0x12111,
	0x12112,
	0x12115,
	0x12113,
	0x12116,
	0x12117,
	0x1211D,
	0x12119,
	0x1211A,
	0x1211B,
	0x1211E,
	0x12121,
	0x1211F,
	0x12120,
	0x12122,
	0x12123,
	0x12124,
	0x12125,
	0x12127,
	0x12128,
	0x12129,
	0x1212B,
	0x1212A,
	0x1212C,
	0x1212D,
	0x1212E,
	0x12130,
	0x12131,
	0x12132,
	0x12133,
	0x12134,
	0x12135,
	0x12136,
	0x12137,
	0x12139,
	0x1213A,
	0x1213B,
	0x1213C,
	0x1213D,
	0x1213F,
	0x12140,
	0x12141,
	0x12142,
	0x12143,
	0x12144,
	0x12145,
	0x12146,
	0x12147,
	0x1214A,
	0x12149,
	0x12148,
	0x1214B,
	0x1214C,
	0x1214E,
	0x12150,
	0x12151,
	0x12152,
	0x12153,
	0x12154,
	0x12155,
	0x12156,
	0x12157,
	0x12158,
	0x12159,
	0x1215C,
	0x1215D,
	0x1215E,
	0x1215F,
	0x12162,
	0x12163,
	0x12164,
	0x12165,
	0x12166,
	0x12167,
	0x1216A,
	0x12169,
	0x1216B,
	0x1216D,
	0x1216E,
	0x1216F,
	0x12170,
	0x12171,
	0x12172,
	0x12173,
	0x12174,
	0x12175,
	0x12176,
	0x12177,
	0x12178,
	0x12179,
	0x1217A,
	0x1217B,
	0x1217C,
	0x1217D,
	0x1217E,
	0x1217F,
	0x12180,
	0x12181,
	0x12182,
	0x12183,
	0x12184,
	0x12185,
	0x12186,
	0x12187,
	0x12189,
	0x1218A,
	0x1218B,
	0x1218C,
	0x1218F,
	0x12195,
	0x12196,
	0x12197,
	0x12199,
	0x12198,
	0x1219C,
	0x1219D,
	0x1219E,
	0x121A0,
	0x121A1,
	0x121A2,
	0x121A3,
	0x121A4,
	0x121A5,
	0x121A6,
	0x121A7,
	0x121AA,
	0x121AE,
	0x121B0,
	0x121B1,
	0x121B2,
	0x121B3,
	0x121B4,
	0x121B7,
	0x121B8,
	0x121EB,
	0x121B9,
	0x121BA,
	0x121BB,
	0x121BC,
	0x121BD,
	0x121BE,
	0x121BF,
	0x121C0,
	0x121C1,
	0x121C2,
	0x121C3,
	0x121C4,
	0x121C5,
	0x121C6,
	0x121C7,
	0x121C8,
	0x121C9,
	0x121CA,
	0x121CB,
	0x121CC,
	0x121CD,
	0x121CE,
	0x121CF,
	0x121D0,
	0x121D2,
	0x121D3,
	0x121D4,
	0x121D5,
	0x121D6,
	0x121D7,
	0x121D8,
	0x121D9,
	0x121DA,
	0x121DB,
	0x121DC,
	0x121DE,
	0x121E1,
	0x121E2,
	0x121E4,
	0x121E5,
	0x121E6,
	0x121E7,
	0x121E8,
	0x121E9,
	0x121EA,
	0x121EC,
	0x121EF,
	0x121F0,
	0x121ED,
	0x121EE,
	0x121F1,
	0x121F2,
	0x121F3,
	0x121F4,
	0x121F5,
	0x121F6,
	0x121F7,
	0x121F8,
	0x121FA,
	0x121FB,
	0x121FC,
	0x12215,
	0x12214,
	0x12211,
	0x121FE,
	0x121FF,
	0x12201,
	0x12202,
	0x12203,
	0x12204,
	0x12207,
	0x12208,
	0x12209,
	0x1220A,
	0x1220B,
	0x1220C,
	0x1220D,
	0x1220E,
	0x1220F,
	0x12217,
	0x12219,
	0x12218,
	0x1221A,
	0x1221B,
	0x1221C,
	0x1221D,
	0x1221E,
	0x1221F,
	0x12220,
	0x12222,
	0x12224,
	0x12225,
	0x12226,
	0x12228,
	0x12229,
	0x1222A,
	0x1222B,
	0x1222C,
	0x1222D,
	0x1222E,
	0x1222F,
	0x12230,
	0x12232,
	0x12238,
	0x12236,
	0x12237,
	0x12233,
	0x12234,
	0x12235,
	0x1223D,
	0x1223A,
	0x1223B,
	0x1223C,
	0x1223E,
	0x12240,
	0x12241,
	0x12243,
	0x12242,
	0x12244,
	0x12246,
	0x12245,
	0x12248,
	0x1224B,
	0x12249,
	0x1224A,
	0x1224C,
	0x1224D,
	0x1224F,
	0x12250,
	0x12251,
	0x12253,
	0x12254,
	0x12255,
	0x12256,
	0x12257,
	0x12258,
	0x12259,
	0x1225A,
	0x1225B,
	0x1225C,
	0x1225D,
	0x1225E,
	0x1225F,
	0x12260,
	0x12261,
	0x12263,
	0x1226B,
	0x1226C,
	0x12264,
	0x12265,
	0x12266,
	0x12267,
	0x12268,
	0x1226A,
	0x12269,
	0x1226D,
	0x1226E,
	0x1226F,
	0x12270,
	0x12271,
	0x12272,
	0x12274,
	0x12275,
	0x12278,
	0x12279,
	0x1227A,
	0x1227B,
	0x1227C,
	0x1227D,
	0x1227F,
	0x12289,
	0x12280,
	0x12281,
	0x12282,
	0x12283,
	0x12284,
	0x12285,
	0x12286,
	0x12287,
	0x1228A,
	0x1228E,
	0x1228B,
	0x1228C,
	0x1228D,
	0x1228F,
	0x12290,
	0x12291,
	0x12292,
	0x12293,
	0x12295,
	0x122A8,
	0x12294,
	0x122A7,
	0x12296,
	0x12297,
	0x12298,
	0x12299,
	0x1229A,
	0x1229B,
	0x1229C,
	0x1229D,
	0x1229E,
	0x1229F,
	0x122A0,
	0x122A1,
	0x122A3,
	0x122A4,
	0x122A5,
	0x122A6,
	0x122A9,
	0x122AC,
	0x122AD,
	0x122AF,
	0x122B0,
	0x122B1,
	0x122B2,
	0x122B4,
	0x122B5,
	0x122B6,
	0x122BA,
	0x122BB,
	0x122BC,
	0x122BD,
	0x122BF,
	0x122C0,
	0x122C2,
	0x122C3,
	0x122C4,
	0x122C5,
	0x122C6,
	0x122C7,
	0x122C8,
	0x122C9,
	0x122CA,
	0x122CB,
	0x122CC,
	0x122CD,
	0x122CF,
	0x122D0,
	0x122D1,
	0x122D2,
	0x122D3,
	0x122D5,
	0x122D4,
	0x122D6,
	0x122D7,
	0x122D8,
	0x122DA,
	0x122DB,
	0x122DC,
	0x122DD,
	0x122E2,
	0x122E3,
	0x122E4,
	0x122E6,
	0x122E7,
	0x122E8,
	0x122E9,
	0x122EB,
	0x122EC,
	0x122EF,
	0x122ED,
	0x122EE,
	0x122F0,
	0x122F1,
	0x122F2,
	0x122F3,
	0x122F4,
	0x122F5,
	0x122F6,
	0x122F7,
	0x122F9,
	0x122FB,
	0x122FC,
	0x122FD,
	0x122FE,
	0x122FF,
	0x12300,
	0x12301,
	0x12303,
	0x12304,
	0x12305,
	0x12307,
	0x12308,
	0x12309,
	0x1230A,
	0x1230B,
	0x1230C,
	0x1230E,
	0x1230F,
	0x12310,
	0x1230D,
	0x12312,
	0x12313,
	0x12319,
	0x1231A,
	0x1231B,
	0x12315,
	0x12316,
	0x12317,
	0x12318,
	0x1231C,
	0x1231D,
	0x1231E,
	0x1231F,
	0x12321,
	0x12322,
	0x12323,
	0x12324,
	0x12325,
	0x12326,
	0x12327,
	0x12328,
	0x12329,
	0x1232A,
	0x1232C,
	0x1232D,
	0x1232E,
	0x1232F,
	0x12330,
	0x12332,
	0x12333,
	0x12335,
	0x12337,
	0x12338,
	0x12339,
	0x1233A,
	0x1233B,
	0x1233C,
	0x1233D,
	0x1233E,
	0x1233F,
	0x12340,
	0x12341,
	0x12342,
	0x12343,
	0x12344,
	0x12345,
	0x12346,
	0x12347,
	0x12348,
	0x12349,
	0x1234B,
	0x1234C,
	0x1234D,
	0x1234E,
	0x1234F,
	0x12350,
	0x12351,
	0x12352,
	0x12353,
	0x12354,
	0x12358,
	0x12356,
	0x12359,
	0x1235B,
	0x1235C,
	0x1235D,
	0x1235F,
	0x1235E,
	0x12360,
	0x12361,
	0x12363,
	0x12364,
	0x12366,
	0x12367,
	0x12368,
	0x1236A,
	0x1236C,
	0x1236D,
	0x1236E,
	0x26FE,
	0x23AA,
	0x22CF,
	0x22CE,
	0x27B0,
	0x1F4B1,
	0x00A4,
	0x1F35B,
	0x2761,
	0x1F36E,
	0x1F6C3,
	0x1F300,
	0x232D,
	0x10800,
	0x10801,
	0x10802,
	0x10805,
	0x10808,
	0x1080A,
	0x1080B,
	0x1080C,
	0x1080D,
	0x1080E,
	0x1080F,
	0x10810,
	0x10811,
	0x10812,
	0x10813,
	0x10814,
	0x10815,
	0x10816,
	0x10817,
	0x10818,
	0x10819,
	0x1081A,
	0x1081B,
	0x1081C,
	0x1081D,
	0x10803,
	0x1081E,
	0x1081F,
	0x10820,
	0x10821,
	0x10822,
	0x10823,
	0x10824,
	0x10825,
	0x10826,
	0x10827,
	0x10828,
	0x10829,
	0x1082A,
	0x1082B,
	0x1082C,
	0x1082D,
	0x1082E,
	0x1082F,
	0x10830,
	0x10831,
	0x10804,
	0x10832,
	0x10833,
	0x10834,
	0x10835,
	0x10837,
	0x10838,
	0x1083C,
	0x1083F,
	0x0410,
	0x04D0,
	0x04D2,
	0x04BC,
	0x04BE,
	0x04E0,
	0x04A8,
	0x051E,
	0x04E8,
	0x04EA,
	0x04A0,
	0x0411,
	0x046A,
	0xA66A,
	0xA65A,
	0xA64C,
	0x0406,
	0xA686,
	0x0427,
	0x04B6,
	0x04F4,
	0x04B8,
	0xA658,
	0x0414,
	0x0402,
	0xA648,
	0xA66C,
	0xA680,
	0x0405,
	0xA642,
	0x040F,
	0xA682,
	0xA688,
	0x042D,
	0x04EC,
	0x0424,
	0x041B,
	0x0512,
	0x0520,
	0x04C5,
	0x041C,
	0x04CD,
	0x041D,
	0x04A2,
	0x04C7,
	0x0522,
	0x04C9,
	0x0420,
	0x048E,
	0x0421,
	0x04AA,
	0x0472,
	0x0413,
	0x04F6,
	0x0494,
	0x0492,
	0x04FA,
	0x0490,
	0x0403,
	0x0425,
	0x04B2,
	0x04FC,
	0x04FE,
	0x042A,
	0xA694,
	0x0418,
	0x04E4,
	0x040D,
	0x04E2,
	0x0415,
	0x04D6,
	0x0400,
	0x0401,
	0xA646,
	0xA656,
	0x046C,
	0xA65C,
	0x0464,
	0x0468,
	0xA652,
	0x0474,
	0x0476,
	0x0408,
	0x041A,
	0x049A,
	0x04C3,
	0x049E,
	0x049C,
	0x04CB,
	0x040C,
	0x0500,
	0x0502,
	0x0506,
	0x0508,
	0x050A,
	0x050C,
	0x050E,
	0x0504,
	0x0480,
	0x046E,
	0x0514,
	0x0466,
	0x0409,
	0xA668,
	0xA64A,
	0xA64E,
	0x040A,
	0x041E,
	0x04E6,
	0x0460,
	0x047C,
	0x047E,
	0x041F,
	0x0524,
	0x04A6,
	0x0470,
	0x051A,
	0xA644,
	0xA660,
	0xA654,
	0x0510,
	0x0516,
	0x047A,
	0x04D8,
	0x04DA,
	0x048C,
	0x0428,
	0x0429,
	0x04BA,
	0x0526,
	0x0419,
	0x048A,
	0x040E,
	0xA696,
	0xA662,
	0xA664,
	0xA666,
	0x042C,
	0x04AE,
	0x04B0,
	0xA692,
	0x0422,
	0x04AC,
	0xA68A,
	0x0426,
	0x040B,
	0xA690,
	0xA68E,
	0xA68C,
	0x0423,
	0x04F0,
	0x04F2,
	0x04EE,
	0x0478,
	0x0404,
	0x0412,
	0x051C,
	0x042F,
	0x0518,
	0x0462,
	0x042B,
	0xA650,
	0x04F8,
	0x0407,
	0xA65E,
	0x042E,
	0x0417,
	0x0498,
	0x04DE,
	0xA640,
	0x0416,
	0x04C1,
	0x0496,
	0x04DC,
	0xA684,
	0x04D4,
	0x04A4,
	0x04B4,
	0xA67E,
	0xA66E,
	0x04C0,
	0x1D2B,
	0xA67F,
	0x0430,
	0x04D1,
	0x04D3,
	0x04BD,
	0x04BF,
	0x04E1,
	0x04A9,
	0x051F,
	0x04E9,
	0x04EB,
	0x04A1,
	0x0431,
	0x046B,
	0xA66B,
	0xA65B,
	0xA64D,
	0x0456,
	0xA687,
	0x0447,
	0x04B7,
	0x04F5,
	0x04B9,
	0xA659,
	0x0434,
	0x0452,
	0xA649,
	0xA66D,
	0xA681,
	0x0455,
	0xA643,
	0x045F,
	0xA683,
	0xA689,
	0x044D,
	0x04ED,
	0x0444,
	0x043B,
	0x0513,
	0x0521,
	0x04C6,
	0x043C,
	0x04CE,
	0x043D,
	0x04A3,
	0x04C8,
	0x0523,
	0x04CA,
	0x0440,
	0x048F,
	0x0441,
	0x04AB,
	0x0473,
	0x0433,
	0x04F7,
	0x0495,
	0x0493,
	0x04FB,
	0x0491,
	0x0453,
	0x0445,
	0x04B3,
	0x04FD,
	0x04FF,
	0x044A,
	0xA695,
	0x0438,
	0x04E5,
	0x045D,
	0x04E3,
	0x0435,
	0x04D7,
	0x0450,
	0x0451,
	0xA647,
	0xA657,
	0x046D,
	0xA65D,
	0x0465,
	0x0469,
	0xA653,
	0x0475,
	0x0477,
	0x0458,
	0x043A,
	0x049B,
	0x04C4,
	0x049F,
	0x049D,
	0x04CC,
	0x045C,
	0x0501,
	0x0503,
	0x0507,
	0x0509,
	0x050B,
	0x050D,
	0x050F,
	0x0505,
	0x0481,
	0x046F,
	0x0515,
	0x0467,
	0x0459,
	0xA669,
	0xA64B,
	0xA64F,
	0x045A,
	0x043E,
	0x04E7,
	0x0461,
	0x047D,
	0x047F,
	0x04CF,
	0x043F,
	0x0525,
	0x04A7,
	0x0471,
	0x051B,
	0xA645,
	0xA661,
	0xA655,
	0x0511,
	0x0517,
	0x047B,
	0x04D9,
	0x04DB,
	0x048D,
	0x0448,
	0x0449,
	0x04BB,
	0x0527,
	0x0439,
	0x048B,
	0x045E,
	0xA697,
	0xA663,
	0xA665,
	0xA667,
	0x044C,
	0x04AF,
	0x04B1,
	0xA693,
	0x0442,
	0x04AD,
	0xA68B,
	0x0446,
	0x045B,
	0xA691,
	0xA68F,
	0xA68D,
	0x0443,
	0x04F1,
	0x04F3,
	0x04EF,
	0x0479,
	0x0454,
	0x0432,
	0x051D,
	0x044F,
	0x0519,
	0x0463,
	0x044B,
	0xA651,
	0x04F9,
	0x0457,
	0xA65F,
	0x044E,
	0x0437,
	0x0499,
	0x04DF,
	0xA641,
	0x0436,
	0x04C2,
	0x0497,
	0x04DD,
	0xA685,
	0x04D5,
	0x04A5,
	0x04B5,
	0x0482,
	0x2020,
	0x2E36,
	0x2E37,
	0x2138,
	0x1F483,
	0x1F361,
	0x2593,
	0x1F4A8,
	0xFE4D,
	0xFE49,
	0x279F,
	0x1F333,
	0x23E8,
	0x2396,
	0x2103,
	0x2109,
	0x00B0,
	0x1F69A,
	0x225C,
	0x23C9,
	0x23C1,
	0x23C4,
	0x23C7,
	0x23CA,
	0x23C2,
	0x23C5,
	0x23C8,
	0x23CC,
	0x23BF,
	0x23CB,
	0x23BE,
	0x23C6,
	0x23C0,
	0x23C3,
	0x1F3EC,
	0x260B,
	0x1040C,
	0x10412,
	0x10415,
	0x10414,
	0x10419,
	0x10422,
	0x10423,
	0x10424,
	0x10425,
	0x10421,
	0x1041D,
	0x1041F,
	0x1041B,
	0x10427,
	0x10418,
	0x10410,
	0x10416,
	0x10417,
	0x10402,
	0x10403,
	0x10401,
	0x10400,
	0x10404,
	0x10405,
	0x10426,
	0x1040D,
	0x10411,
	0x10408,
	0x10409,
	0x10407,
	0x10406,
	0x1040A,
	0x1040B,
	0x10413,
	0x1041C,
	0x1041A,
	0x1040E,
	0x1040F,
	0x1041E,
	0x10420,
	0x10434,
	0x1043A,
	0x1043D,
	0x1043C,
	0x10441,
	0x1044A,
	0x1044B,
	0x1044C,
	0x1044D,
	0x10449,
	0x10445,
	0x10447,
	0x10443,
	0x1044F,
	0x10440,
	0x10438,
	0x1043E,
	0x1043F,
	0x1042A,
	0x1042B,
	0x10429,
	0x10428,
	0x1042C,
	0x1042D,
	0x1044E,
	0x10435,
	0x10439,
	0x10430,
	0x10431,
	0x1042F,
	0x1042E,
	0x10432,
	0x10433,
	0x1043B,
	0x10444,
	0x10442,
	0x10436,
	0x10437,
	0x10446,
	0x10448,
	0x0970,
	0x0954,
	0xA8FA,
	0x0964,
	0x096E,
	0x096B,
	0x096A,
	0x096F,
	0x0967,
	0x096D,
	0x096C,
	0x0969,
	0x0968,
	0x0966,
	0x0965,
	0xA8F9,
	0x0953,
	0xA8FB,
	0x0905,
	0x0906,
	0x0910,
	0x0914,
	0x0975,
	0x092C,
	0x097F,
	0x092D,
	0x091A,
	0x0972,
	0x090D,
	0x0911,
	0x091B,
	0x0926,
	0x0921,
	0x097E,
	0x095C,
	0x0922,
	0x0927,
	0x090F,
	0x095E,
	0x0917,
	0x097B,
	0x0918,
	0x095A,
	0x097D,
	0x0939,
	0x097A,
	0x0907,
	0x0908,
	0x091C,
	0x091D,
	0x097C,
	0x0915,
	0x0916,
	0x0959,
	0x0932,
	0x0933,
	0x0934,
	0x092E,
	0x0928,
	0x0919,
	0x0923,
	0x0929,
	0x091E,
	0x0913,
	0x0973,
	0x0974,
	0x092A,
	0x092B,
	0x0958,
	0x0930,
	0x095D,
	0x0931,
	0x0938,
	0x0936,
	0x0904,
	0x090E,
	0x0912,
	0x0937,
	0x0924,
	0x0925,
	0x091F,
	0x0920,
	0x0909,
	0x0976,
	0x090A,
	0x0977,
	0x0935,
	0x090C,
	0x0961,
	0x090B,
	0x0960,
	0x092F,
	0x095F,
	0x095B,
	0x0979,
	0x0950,
	0x0902,
	0x093D,
	0x0901,
	0xA8F7,
	0xA8F6,
	0xA8F5,
	0xA8F3,
	0xA8F4,
	0x0971,
	0x0900,
	0x093C,
	0xA8F8,
	0xA8F2,
	0x094D,
	0x0903,
	0x0952,
	0x0951,
	0x093E,
	0x0948,
	0x094C,
	0x094F,
	0x0945,
	0x0955,
	0x0949,
	0x0947,
	0x093F,
	0x0940,
	0x094B,
	0x093A,
	0x093B,
	0x094E,
	0x0946,
	0x094A,
	0x0941,
	0x0956,
	0x0942,
	0x0957,
	0x0962,
	0x0963,
	0x0943,
	0x0944,
	0x00A8,
	0x2300,
	0x22C4,
	0x1F4A0,
	0x2B19,
	0x2B16,
	0x2B17,
	0x2B18,
	0x224F,
	0x0038,
	0x1F109,
	0x248F,
	0x0035,
	0x1F106,
	0x248C,
	0x0034,
	0x1F105,
	0x248B,
	0x0039,
	0x1F10A,
	0x2490,
	0x0031,
	0x1F102,
	0x2488,
	0x0037,
	0x1F108,
	0x248E,
	0x0036,
	0x1F107,
	0x248D,
	0x0033,
	0x1F104,
	0x248A,
	0x0032,
	0x1F103,
	0x2489,
	0x0030,
	0x1F101,
	0x1F100,
	0x1D305,
	0x1D303,
	0x1D304,
	0x268C,
	0x268F,
	0x1D301,
	0x1D302,
	0x268E,
	0x268D,
	0x2331,
	0x2787,
	0x2784,
	0x2783,
	0x2788,
	0x2780,
	0x2786,
	0x2785,
	0x2782,
	0x2781,
	0x2789,
	0x277D,
	0x277A,
	0x2779,
	0x277E,
	0x2776,
	0x277C,
	0x277B,
	0x2778,
	0x2777,
	0x277F,
	0x2791,
	0x278E,
	0x278D,
	0x2792,
	0x278A,
	0x2790,
	0x278F,
	0x278C,
	0x278B,
	0x2793,
	0x2393,
	0x1F3AF,
	0x26CD,
	0x1F625,
	0x1F61E,
	0x2382,
	0x3003,
	0x2223,
	0x00F7,
	0x2215,
	0x22C7,
	0x26AE,
	0x1F635,
	0x1F4AB,
	0x1F6AF,
	0x220C,
	0x22EB,
	0x22ED,
	0x2224,
	0x2AEE,
	0x22AE,
	0x2280,
	0x22E0,
	0x22AC,
	0x2281,
	0x22E1,
	0x1F415,
	0x1F436,
	0x0024,
	0x1F42C,
	0x1F030,
	0x1F062,
	0x20AB,
	0x1F6AA,
	0x02D9,
	0x2238,
	0x22C5,
	0x2214,
	0x25CC,
	0x205C,
	0x2999,
	0x2E13,
	0x2E16,
	0x2B1A,
	0x2E08,
	0x02DD,
	0x24FC,
	0x24F9,
	0x24F8,
	0x24FD,
	0x24F5,
	0x24FB,
	0x24FA,
	0x24F7,
	0x24F6,
	0x24FE,
	0x2A74,
	0x27BF,
	0x2021,
	0x2AEA,
	0x203C,
	0x201F,
	0x222C,
	0x22D2,
	0x2995,
	0x2A53,
	0x2A54,
	0x2017,
	0x201E,
	0x2AA2,
	0x2AA1,
	0x2AA3,
	0x2E17,
	0x29FA,
	0x2ABB,
	0x2033,
	0x301E,
	0x2047,
	0x2996,
	0x2AFD,
	0x2A4E,
	0x2A4F,
	0x2AEC,
	0x22D0,
	0x2ABC,
	0x22D1,
	0x22D3,
	0x2AEB,
	0x2AE5,
	0x22AB,
	0x2AE3,
	0x2016,
	0xFE4C,
	0x29DF,
	0x2A9A,
	0x2A99,
	0x2A9C,
	0x2A9B,
	0x2AFA,
	0x2AF9,
	0x2102,
	0x213E,
	0x210D,
	0x2115,
	0x2119,
	0x213F,
	0x211A,
	0x211D,
	0x2124,
	0x2145,
	0x2146,
	0x2147,
	0x2148,
	0x2149,
	0x2140,
	0x213D,
	0x213C,
	0x26A2,
	0x26A3,
	0x1F369,
	0x2304,
	0x297F,
	0x22F1,
	0x22A4,
	0x2AF1,
	0x1F53B,
	0x1F53D,
	0x29E8,
	0x29E9,
	0x2E14,
	0x2193,
	0x21A7,
	0x21F5,
	0x2913,
	0x21B5,
	0x21DF,
	0x2908,
	0x21B2,
	0x21B3,
	0x2B07,
	0x21E3,
	0x21D3,
	0x2965,
	0x296F,
	0x2961,
	0x2959,
	0x21C3,
	0x295D,
	0x2955,
	0x21C2,
	0x21CA,
	0x27F1,
	0x290B,
	0x21A1,
	0x21E9,
	0x21AF,
	0x20AF,
	0x279B,
	0x1F409,
	0x1F432,
	0x1F457,
	0x26DA,
	0x1F42A,
	0x1F4A7,
	0x1F4C0,
	0x1F4E7,
	0x1F442,
	0x1F33D,
	0x1F33E,
	0x2641,
	0x1F30E,
	0x1F30F,
	0x1F30D,
	0x23DA,
	0x2671,
	0x2E0E,
	0x13005,
	0x13007,
	0x13008,
	0x13011,
	0x13015,
	0x13025,
	0x1302E,
	0x13031,
	0x13033,
	0x13036,
	0x13414,
	0x13415,
	0x13055,
	0x1305C,
	0x1305D,
	0x1305E,
	0x13067,
	0x1307E,
	0x13092,
	0x13097,
	0x1309B,
	0x130A8,
	0x130AB,
	0x130AE,
	0x130AF,
	0x130B0,
	0x130B1,
	0x130B2,
	0x130B3,
	0x130B4,
	0x130B5,
	0x130B6,
	0x130B9,
	0x130BC,
	0x130CA,
	0x130CB,
	0x130CC,
	0x130CD,
	0x130CE,
	0x130CF,
	0x130D0,
	0x130D1,
	0x130DA,
	0x130DC,
	0x130E4,
	0x130E6,
	0x130EA,
	0x130F3,
	0x130FA,
	0x130FF,
	0x1310C,
	0x13115,
	0x13120,
	0x13127,
	0x13129,
	0x13131,
	0x13133,
	0x13135,
	0x1313A,
	0x1313B,
	0x1313C,
	0x13145,
	0x13147,
	0x13148,
	0x1314D,
	0x13157,
	0x1315E,
	0x13169,
	0x1316B,
	0x13172,
	0x13175,
	0x13185,
	0x1318D,
	0x13192,
	0x13194,
	0x13196,
	0x131A5,
	0x131AA,
	0x131AE,
	0x131AF,
	0x131B2,
	0x131BA,
	0x131BD,
	0x131BE,
	0x131BF,
	0x131C0,
	0x131C1,
	0x131C2,
	0x131C3,
	0x131C4,
	0x131C8,
	0x131CA,
	0x131CC,
	0x131D2,
	0x131D5,
	0x131DA,
	0x131DE,
	0x131E1,
	0x131E2,
	0x131EA,
	0x13201,
	0x13202,
	0x1320A,
	0x13213,
	0x13215,
	0x13217,
	0x1321A,
	0x13225,
	0x13232,
	0x13240,
	0x13242,
	0x1324A,
	0x1324F,
	0x13251,
	0x13256,
	0x13258,
	0x13259,
	0x1325A,
	0x1325B,
	0x1325C,
	0x1325D,
	0x13262,
	0x13263,
	0x13264,
	0x1326E,
	0x13270,
	0x13275,
	0x13277,
	0x1327C,
	0x1327E,
	0x13282,
	0x13286,
	0x13287,
	0x13288,
	0x13289,
	0x13298,
	0x13299,
	0x1329C,
	0x1329F,
	0x132B1,
	0x132B3,
	0x132B4,
	0x132BC,
	0x132C3,
	0x132D3,
	0x132D8,
	0x132E1,
	0x132E2,
	0x132E6,
	0x132F0,
	0x132F1,
	0x132FB,
	0x1330A,
	0x1330F,
	0x13311,
	0x13313,
	0x13316,
	0x1331C,
	0x1332D,
	0x1332F,
	0x13339,
	0x1333A,
	0x1334C,
	0x13353,
	0x13357,
	0x13363,
	0x13364,
	0x13365,
	0x13366,
	0x13367,
	0x13368,
	0x13369,
	0x1336A,
	0x1336B,
	0x1336D,
	0x13373,
	0x13374,
	0x13379,
	0x1337A,
	0x1337B,
	0x1337D,
	0x1337E,
	0x13387,
	0x13388,
	0x13389,
	0x1338A,
	0x1338B,
	0x1338C,
	0x1338D,
	0x1338E,
	0x1338F,
	0x13390,
	0x13391,
	0x13392,
	0x13396,
	0x1339C,
	0x1339E,
	0x133A0,
	0x133A2,
	0x133A5,
	0x133AA,
	0x133AE,
	0x133B2,
	0x133B9,
	0x133BB,
	0x133C0,
	0x133C4,
	0x133C6,
	0x133CD,
	0x133D3,
	0x133D4,
	0x133D7,
	0x133DA,
	0x133DC,
	0x133E6,
	0x133E7,
	0x133E8,
	0x133E9,
	0x133EB,
	0x133EC,
	0x133EE,
	0x133F0,
	0x133FB,
	0x133FC,
	0x133FD,
	0x133FE,
	0x133FF,
	0x13400,
	0x13401,
	0x13402,
	0x13403,
	0x13405,
	0x13406,
	0x13407,
	0x13408,
	0x13409,
	0x1340A,
	0x1340B,
	0x1340C,
	0x2741,
	0x2734,
	0x2735,
	0x2737,
	0x2733,
	0x274A,
	0x266A,
	0x23CF,
	0x2301,
	0x1F4A1,
	0x1F50C,
	0x1F526,
	0x23E7,
	0x2208,
	0x2AD9,
	0x27D2,
	0x22F5,
	0x22F2,
	0x22F6,
	0x22F9,
	0x22F8,
	0x22F3,
	0x1F418,
	0x2014,
	0x2001,
	0x2003,
	0x2383,
	0x2205,
	0x29B4,
	0x29B1,
	0x29B3,
	0x29B2,
	0x2013,
	0x2000,
	0x2002,
	0x220E,
	0x1F51A,
	0x2386,
	0x2709,
	0x1F4E9,
	0x22D5,
	0x225D,
	0x22DD,
	0x22DC,
	0x22DE,
	0x22DF,
	0x2255,
	0x003D,
	0x2B40,
	0x2A71,
	0x2971,
	0x2A73,
	0x29E3,
	0x29E4,
	0x2AAE,
	0x2A66,
	0x2A77,
	0x2A6E,
	0x225A,
	0x224D,
	0x2A78,
	0x232B,
	0x2326,
	0x29F3,
	0x29F1,
	0x29EF,
	0x29F2,
	0x29F0,
	0x29EE,
	0x212E,
	0x2259,
	0x1365,
	0x135D,
	0x135F,
	0x135E,
	0x1363,
	0x1370,
	0x136D,
	0x136C,
	0x1371,
	0x1369,
	0x136F,
	0x136E,
	0x136B,
	0x136A,
	0x1362,
	0x1379,
	0x1376,
	0x1375,
	0x137B,
	0x137A,
	0x1378,
	0x1377,
	0x1372,
	0x137C,
	0x1374,
	0x1373,
	0x1368,
	0x1366,
	0x1367,
	0x1360,
	0x1364,
	0x1260,
	0x1263,
	0xAB28,
	0xAB2B,
	0xAB2D,
	0xAB2C,
	0xAB2A,
	0xAB2E,
	0xAB29,
	0x1265,
	0x1264,
	0x1262,
	0x1266,
	0x2D85,
	0x1261,
	0x1267,
	0x1387,
	0x1386,
	0x1385,
	0x1278,
	0x127B,
	0x2DA8,
	0x2DAB,
	0x2DAD,
	0x2DAC,
	0x2DB8,
	0x2DBB,
	0x2DBD,
	0x2DBC,
	0xAB20,
	0xAB23,
	0xAB25,
	0xAB24,
	0xAB22,
	0xAB26,
	0xAB21,
	0x2DBA,
	0x2DBE,
	0x2DB9,
	0x2DAA,
	0x2DAE,
	0x2DA9,
	0x127D,
	0x127C,
	0x1328,
	0x132B,
	0x132D,
	0x132C,
	0x132A,
	0x132E,
	0x2D90,
	0x1329,
	0x132F,
	0x127A,
	0x127E,
	0x2D87,
	0x1279,
	0x127F,
	0x12F0,
	0x12F3,
	0x12F8,
	0x12FB,
	0x12FD,
	0x12FC,
	0xAB0B,
	0xAB0D,
	0xAB0C,
	0xAB0A,
	0xAB0E,
	0xAB09,
	0x12FA,
	0x12FE,
	0x2D8D,
	0x12F9,
	0x12FF,
	0x12F5,
	0x12F4,
	0x12F2,
	0x12F6,
	0x2D8C,
	0x12F1,
	0x12F7,
	0xAB13,
	0xAB15,
	0xAB14,
	0xAB12,
	0xAB16,
	0xAB11,
	0x1348,
	0x134B,
	0x134D,
	0x134C,
	0x134A,
	0x134E,
	0x1349,
	0x134F,
	0x138B,
	0x138A,
	0x1389,
	0x135A,
	0x1308,
	0x130B,
	0x130D,
	0x130C,
	0x1318,
	0x131B,
	0x131D,
	0x131C,
	0x131A,
	0x131E,
	0x1319,
	0x2D93,
	0x131F,
	0x2D96,
	0x2D95,
	0x2D94,
	0x130A,
	0x12A0,
	0x12A3,
	0x12A5,
	0x12A4,
	0x12A2,
	0x12A6,
	0x2D8A,
	0x12A1,
	0x12A7,
	0x130E,
	0x130F,
	0x1309,
	0x1310,
	0x1313,
	0x1315,
	0x1314,
	0x1312,
	0x2DD8,
	0x2DDB,
	0x2DDD,
	0x2DDC,
	0x2DDA,
	0x2DDE,
	0x2DD9,
	0x1200,
	0x1203,
	0x1205,
	0x1204,
	0x1210,
	0x1213,
	0x1215,
	0x1214,
	0x1212,
	0x1216,
	0x1211,
	0x1217,
	0x1202,
	0x1206,
	0x1207,
	0x1201,
	0x1300,
	0x1303,
	0x1305,
	0x1304,
	0x1302,
	0x1306,
	0x2D8E,
	0x1301,
	0x1307,
	0x12A8,
	0x12AB,
	0x12AD,
	0x12AC,
	0x12AA,
	0x12AE,
	0x12AF,
	0x12A9,
	0x12B0,
	0x12B3,
	0x12B5,
	0x12B4,
	0x12B2,
	0x12B8,
	0x12BB,
	0x12BD,
	0x12BC,
	0x12BA,
	0x12BE,
	0x12B9,
	0x12C0,
	0x12C3,
	0x12C5,
	0x12C4,
	0x12C2,
	0x2DC8,
	0x2DCB,
	0x2DCD,
	0x2DCC,
	0x2DCA,
	0x2DCE,
	0x2DC9,
	0x1208,
	0x120B,
	0x120D,
	0x120C,
	0x120A,
	0x120E,
	0x2D80,
	0x1209,
	0x120F,
	0x1218,
	0x121B,
	0x121D,
	0x121C,
	0x121A,
	0x121E,
	0x2D81,
	0x1219,
	0x121F,
	0x1383,
	0x1382,
	0x1381,
	0x1359,
	0x1290,
	0x1293,
	0x1295,
	0x1294,
	0x1292,
	0x1296,
	0x2D88,
	0x1291,
	0x1297,
	0x1298,
	0x129B,
	0x129D,
	0x129C,
	0x129A,
	0x129E,
	0x2D89,
	0x1299,
	0x129F,
	0x1350,
	0x1353,
	0x1355,
	0x1354,
	0x1330,
	0x1333,
	0x12D0,
	0x12D3,
	0x12D5,
	0x12D4,
	0x12D2,
	0x12D6,
	0x12D1,
	0x1335,
	0x1334,
	0x1332,
	0x1336,
	0x2D91,
	0x1331,
	0x1337,
	0x1352,
	0x1356,
	0x2D92,
	0x1351,
	0x1357,
	0x138F,
	0x138E,
	0x138D,
	0x1240,
	0x1243,
	0x1245,
	0x1244,
	0x1250,
	0x1253,
	0x1255,
	0x1254,
	0x1252,
	0x1256,
	0x1251,
	0x1258,
	0x125B,
	0x125D,
	0x125C,
	0x125A,
	0x1242,
	0x1246,
	0x1247,
	0x1241,
	0x1248,
	0x124B,
	0x124D,
	0x124C,
	0x124A,
	0x2DC0,
	0x2DC3,
	0x2DC5,
	0x2DC4,
	0x2DC2,
	0x2DC6,
	0x2DC1,
	0x1228,
	0x122B,
	0x122D,
	0x122C,
	0x122A,
	0x122E,
	0x2D82,
	0x1229,
	0x122F,
	0x1358,
	0x1230,
	0x1233,
	0x1235,
	0x1384,
	0x1388,
	0x1380,
	0x138C,
	0x1234,
	0x1238,
	0x123B,
	0x123D,
	0x123C,
	0x123A,
	0x123E,
	0x2D84,
	0x1239,
	0x123F,
	0x1232,
	0x1236,
	0x2D83,
	0x2DA0,
	0x2DA3,
	0x2DA5,
	0x2DA4,
	0x2DA2,
	0x2DA6,
	0x2DA1,
	0x1231,
	0x1237,
	0x1220,
	0x1223,
	0x1225,
	0x1224,
	0x1222,
	0x1226,
	0x1221,
	0x1227,
	0x1270,
	0x1273,
	0x1275,
	0x1274,
	0x1320,
	0x1323,
	0x1325,
	0x1324,
	0x1322,
	0x1326,
	0x2D8F,
	0x1321,
	0x1327,
	0x1272,
	0x1276,
	0x2D86,
	0x1338,
	0x133B,
	0x133D,
	0x133C,
	0x133A,
	0x133E,
	0x1339,
	0x133F,
	0xAB03,
	0xAB05,
	0xAB04,
	0xAB02,
	0xAB06,
	0xAB01,
	0x1271,
	0x1277,
	0x1340,
	0x1343,
	0x1345,
	0x1344,
	0x1342,
	0x1346,
	0x1347,
	0x1341,
	0x1268,
	0x126B,
	0x126D,
	0x126C,
	0x126A,
	0x126E,
	0x1269,
	0x126F,
	0x12C8,
	0x12CB,
	0x12CD,
	0x12CC,
	0x12CA,
	0x12CE,
	0x12CF,
	0x12C9,
	0x1280,
	0x1283,
	0x1285,
	0x1284,
	0x1282,
	0x1286,
	0x1287,
	0x1281,
	0x1288,
	0x128B,
	0x128D,
	0x128C,
	0x128A,
	0x2DD0,
	0x2DD3,
	0x2DD5,
	0x2DD4,
	0x2DD2,
	0x2DD6,
	0x2DD1,
	0x12E8,
	0x12EB,
	0x12ED,
	0x12EC,
	0x12EA,
	0x12EE,
	0x12EF,
	0x12E9,
	0x12D8,
	0x12DB,
	0x12DD,
	0x12DC,
	0x12E0,
	0x12E3,
	0x12E5,
	0x12E4,
	0x12E2,
	0x12E6,
	0x12E1,
	0x12E7,
	0x12DA,
	0x12DE,
	0x2D8B,
	0x12D9,
	0x12DF,
	0x2DB0,
	0x2DB3,
	0x2DB5,
	0x2DB4,
	0x2DB2,
	0x2DB6,
	0x2DB1,
	0x1396,
	0x1391,
	0x1398,
	0x1394,
	0x1397,
	0x1395,
	0x1399,
	0x1392,
	0x1393,
	0x1390,
	0x1361,
	0x2107,
	0x20AC,
	0x20A0,
	0x1F3F0,
	0x1F3E4,
	0x1F332,
	0x2239,
	0x0021,
	0x2049,
	0x1F611,
	0x06F8,
	0x06F5,
	0x06F4,
	0x06F9,
	0x06F1,
	0x06F7,
	0x06F6,
	0x06F3,
	0x06F2,
	0x06F0,
	0x1F47D,
	0x1F453,
	0x1F440,
	0x1F486,
	0x1F60B,
	0x1F631,
	0x1F618,
	0x1F613,
	0x1F624,
	0x1F637,
	0x1F645,
	0x1F646,
	0x1F62E,
	0x1F630,
	0x1F61B,
	0x1F61D,
	0x1F61C,
	0x1F602,
	0x1F636,
	0x213B,
	0x1F3ED,
	0x1F342,
	0x292F,
	0x292C,
	0x26DE,
	0x1F46A,
	0x262B,
	0x1F385,
	0x1F4E0,
	0x1F628,
	0x2640,
	0x00AA,
	0x1F3A1,
	0x26F4,
	0x2012,
	0x2007,
	0x1F4C1,
	0x2A0D,
	0x1F525,
	0x1F692,
	0x1F387,
	0x1F386,
	0x263D,
	0x1F313,
	0x1F31B,
	0x2068,
	0x1F41F,
	0x1F365,
	0x25C9,
	0x1F3A3,
	0x1F44A,
	0x2E2D,
	0x2059,
	0x26F3,
	0x23E5,
	0x269C,
	0x1F4AA,
	0x1F4BE,
	0x2766,
	0x2698,
	0x1F3B4,
	0x2055,
	0x1F633,
	0x1F301,
	0x1F463,
	0x2200,
	0x22A9,
	0x1F374,
	0x2E10,
	0x2ADC,
	0x26F2,
	0x2723,
	0x2725,
	0x205B,
	0x2058,
	0x1F340,
	0x2722,
	0x2005,
	0x221C,
	0x215F,
	0x2044,
	0x20A3,
	0x1F35F,
	0x1F364,
	0x1F438,
	0x1F425,
	0x27AC,
	0x2322,
	0x1F626,
	0x26FD,
	0x2588,
	0x1F315,
	0x1F31D,
	0x27D7,
	0x002E,
	0xFF06,
	0xFF07,
	0xFF0A,
	0xFFE4,
	0xFFE0,
	0xFF3E,
	0xFF1A,
	0xFF0C,
	0xFF20,
	0xFF18,
	0xFF15,
	0xFF14,
	0xFF19,
	0xFF11,
	0xFF17,
	0xFF16,
	0xFF13,
	0xFF12,
	0xFF10,
	0xFF04,
	0xFF1D,
	0xFF01,
	0xFF0E,
	0xFF40,
	0xFF1E,
	0xFF0D,
	0xFF21,
	0xFF22,
	0xFF23,
	0xFF24,
	0xFF25,
	0xFF26,
	0xFF27,
	0xFF28,
	0xFF29,
	0xFF2A,
	0xFF2B,
	0xFF2C,
	0xFF2D,
	0xFF2E,
	0xFF2F,
	0xFF30,
	0xFF31,
	0xFF32,
	0xFF33,
	0xFF34,
	0xFF35,
	0xFF36,
	0xFF37,
	0xFF38,
	0xFF39,
	0xFF3A,
	0xFF41,
	0xFF42,
	0xFF43,
	0xFF44,
	0xFF45,
	0xFF46,
	0xFF47,
	0xFF48,
	0xFF49,
	0xFF4A,
	0xFF4B,
	0xFF4C,
	0xFF4D,
	0xFF4E,
	0xFF4F,
	0xFF50,
	0xFF51,
	0xFF52,
	0xFF53,
	0xFF54,
	0xFF55,
	0xFF56,
	0xFF57,
	0xFF58,
	0xFF59,
	0xFF5A,
	0xFF5B,
	0xFF08,
	0xFF3B,
	0xFF5F,
	0xFF1C,
	0xFF3F,
	0xFFE3,
	0xFFE2,
	0xFF03,
	0xFF05,
	0xFF0B,
	0xFFE1,
	0xFF1F,
	0xFF02,
	0xFF3C,
	0xFF5D,
	0xFF09,
	0xFF3D,
	0xFF60,
	0xFF1B,
	0xFF0F,
	0xFF5E,
	0xFF5C,
	0xFFE6,
	0xFFE5,
	0x2061,
	0x26B1,
	0x23DB,
	0x1F3B2,
	0x2699,
	0x26EE,
	0x26ED,
	0x1F48E,
	0x264A,
	0x223A,
	0x2251,
	0x224E,
	0x10CD,
	0x10A0,
	0x10A1,
	0x10BA,
	0x10BD,
	0x10B9,
	0x10BC,
	0x10A3,
	0x10A4,
	0x10A2,
	0x10B6,
	0x10C0,
	0x10C4,
	0x10C1,
	0x10C2,
	0x10C5,
	0x10A8,
	0x10BF,
	0x10BB,
	0x10A9,
	0x10B5,
	0x10AA,
	0x10AB,
	0x10AC,
	0x10AD,
	0x10AE,
	0x10B4,
	0x10B7,
	0x10B0,
	0x10B1,
	0x10B8,
	0x10A7,
	0x10B2,
	0x10B3,
	0x10A5,
	0x10C3,
	0x10BE,
	0x10C7,
	0x10A6,
	0x10AF,
	0x10FD,
	0x10FA,
	0x10D0,
	0x10D1,
	0x10EA,
	0x10ED,
	0x10E9,
	0x10EC,
	0x10D3,
	0x10F8,
	0x10D4,
	0x10F6,
	0x10D2,
	0x10E6,
	0x10F0,
	0x10F4,
	0x10FE,
	0x10F1,
	0x10F2,
	0x10F5,
	0x10D8,
	0x10EF,
	0x10EB,
	0x10D9,
	0x10E5,
	0x10FF,
	0x10DA,
	0x10DB,
	0x10DC,
	0x10DD,
	0x10DE,
	0x10E4,
	0x10E7,
	0x10E0,
	0x10E1,
	0x10E8,
	0x10D7,
	0x10E2,
	0x10F9,
	0x10E3,
	0x10D5,
	0x10F3,
	0x10EE,
	0x10F7,
	0x10D6,
	0x10DF,
	0x10FB,
	0x2D2D,
	0x2D00,
	0x2D01,
	0x2D1A,
	0x2D1D,
	0x2D19,
	0x2D1C,
	0x2D03,
	0x2D04,
	0x2D02,
	0x2D16,
	0x2D20,
	0x2D24,
	0x2D21,
	0x2D22,
	0x2D25,
	0x2D08,
	0x2D1F,
	0x2D1B,
	0x2D09,
	0x2D15,
	0x2D0A,
	0x2D0B,
	0x2D0C,
	0x2D0D,
	0x2D0E,
	0x2D14,
	0x2D17,
	0x2D10,
	0x2D11,
	0x2D18,
	0x2D07,
	0x2D12,
	0x2D13,
	0x2D05,
	0x2D23,
	0x2D1E,
	0x2D27,
	0x2D06,
	0x2D0F,
	0x20B0,
	0x3013,
	0x1F47B,
	0x2137,
	0x1F467,
	0x2C00,
	0x2C28,
	0x2C01,
	0x2C1D,
	0x2C0C,
	0x2C04,
	0x2C07,
	0x2C2A,
	0x2C17,
	0x2C03,
	0x2C18,
	0x2C0B,
	0x2C0A,
	0x2C29,
	0x2C27,
	0x2C09,
	0x2C2B,
	0x2C0D,
	0x2C2E,
	0x2C0E,
	0x2C0F,
	0x2C10,
	0x2C11,
	0x2C19,
	0x2C1A,
	0x2C12,
	0x2C13,
	0x2C1E,
	0x2C1B,
	0x2C2C,
	0x2C14,
	0x2C24,
	0x2C25,
	0x2C22,
	0x2C2D,
	0x2C1C,
	0x2C15,
	0x2C16,
	0x2C02,
	0x2C21,
	0x2C20,
	0x2C1F,
	0x2C05,
	0x2C26,
	0x2C23,
	0x2C08,
	0x2C06,
	0x2C30,
	0x2C58,
	0x2C31,
	0x2C4D,
	0x2C3C,
	0x2C34,
	0x2C37,
	0x2C5A,
	0x2C47,
	0x2C33,
	0x2C48,
	0x2C3B,
	0x2C3A,
	0x2C59,
	0x2C57,
	0x2C39,
	0x2C5B,
	0x2C3D,
	0x2C5E,
	0x2C3E,
	0x2C3F,
	0x2C40,
	0x2C41,
	0x2C49,
	0x2C4A,
	0x2C42,
	0x2C43,
	0x2C4E,
	0x2C4B,
	0x2C5C,
	0x2C44,
	0x2C54,
	0x2C55,
	0x2C52,
	0x2C5D,
	0x2C4C,
	0x2C45,
	0x2C46,
	0x2C32,
	0x2C51,
	0x2C50,
	0x2C4F,
	0x2C35,
	0x2C56,
	0x2C53,
	0x2C38,
	0x2C36,
	0x29E6,
	0x1F310,
	0x1F31F,
	0x1F410,
	0x10330,
	0x10334,
	0x10331,
	0x10333,
	0x10339,
	0x10346,
	0x10332,
	0x10337,
	0x10348,
	0x10347,
	0x10336,
	0x1033E,
	0x1033A,
	0x1033B,
	0x1033C,
	0x1033D,
	0x1034A,
	0x10341,
	0x10349,
	0x10340,
	0x10335,
	0x10342,
	0x10343,
	0x10344,
	0x10338,
	0x1033F,
	0x10345,
	0x1F393,
	0x1F347,
	0x0060,
	0x2A8C,
	0x2A92,
	0x2978,
	0x2A90,
	0x2A8E,
	0x2A94,
	0x2A8A,
	0x2A88,
	0x2AA5,
	0x2269,
	0x22E7,
	0x2AA7,
	0x2AA9,
	0x22DB,
	0x2A86,
	0x2265,
	0x2273,
	0x2277,
	0x2A7E,
	0x2A82,
	0x2A84,
	0x2A80,
	0x2267,
	0x2AA4,
	0x003E,
	0x2A7A,
	0x22D7,
	0x2A7C,
	0x10144,
	0x10151,
	0x1014A,
	0x10147,
	0x10156,
	0x10143,
	0x10145,
	0x10153,
	0x1014C,
	0x1014F,
	0x10148,
	0x10146,
	0x1014E,
	0x10142,
	0x10141,
	0x10152,
	0x1014B,
	0x10140,
	0x10154,
	0x1014D,
	0x10157,
	0x10150,
	0x10149,
	0x10155,
	0x1016F,
	0x1015D,
	0x10173,
	0x1016C,
	0x1015B,
	0x1015E,
	0x10158,
	0x10168,
	0x1015A,
	0x10162,
	0x10163,
	0x10170,
	0x10174,
	0x10169,
	0x1016E,
	0x10172,
	0x10159,
	0x1016A,
	0x10171,
	0x10164,
	0x10165,
	0x1016B,
	0x1015C,
	0x10166,
	0x10167,
	0x1015F,
	0x1016D,
	0x10160,
	0x10161,
	0x0387,
	0x10187,
	0x10186,
	0x03D0,
	0x03FE,
	0x03CF,
	0x0391,
	0x1F09,
	0x1F0D,
	0x1F8D,
	0x1F0F,
	0x1F8F,
	0x1F89,
	0x1F0B,
	0x1F8B,
	0x1FB9,
	0x1FBB,
	0x1FBC,
	0x1F08,
	0x1F0C,
	0x1F8C,
	0x1F0E,
	0x1F8E,
	0x1F88,
	0x1F0A,
	0x1F8A,
	0x0386,
	0x1FBA,
	0x1FB8,
	0x0372,
	0x0392,
	0x03A7,
	0x0394,
	0x0395,
	0x1F19,
	0x1F1D,
	0x1F1B,
	0x1FC9,
	0x1F18,
	0x1F1C,
	0x1F1A,
	0x0388,
	0x1FC8,
	0x0397,
	0x1F29,
	0x1F2D,
	0x1F9D,
	0x1F2F,
	0x1F9F,
	0x1F99,
	0x1F2B,
	0x1F9B,
	0x1FCB,
	0x1FCC,
	0x1F28,
	0x1F2C,
	0x1F9C,
	0x1F2E,
	0x1F9E,
	0x1F98,
	0x1F2A,
	0x1F9A,
	0x0389,
	0x1FCA,
	0x0393,
	0x0370,
	0x0399,
	0x1F39,
	0x1F3D,
	0x1F3F,
	0x1F3B,
	0x03AA,
	0x1FD9,
	0x1FDB,
	0x1F38,
	0x1F3C,
	0x1F3E,
	0x1F3A,
	0x038A,
	0x1FDA,
	0x1FD8,
	0x039A,
	0x039B,
	0x039C,
	0x039D,
	0x03A9,
	0x1F69,
	0x1F6D,
	0x1FAD,
	0x1F6F,
	0x1FAF,
	0x1FA9,
	0x1F6B,
	0x1FAB,
	0x1FFB,
	0x1FFC,
	0x1F68,
	0x1F6C,
	0x1FAC,
	0x1F6E,
	0x1FAE,
	0x1FA8,
	0x1F6A,
	0x1FAA,
	0x038F,
	0x1FFA,
	0x039F,
	0x1F49,
	0x1F4D,
	0x1F4B,
	0x1FF9,
	0x1F48,
	0x1F4C,
	0x1F4A,
	0x038C,
	0x1FF8,
	0x0376,
	0x03A6,
	0x03A0,
	0x03A8,
	0x03A1,
	0x1FEC,
	0x03FA,
	0x03F7,
	0x03A3,
	0x03A4,
	0x0398,
	0x03A5,
	0x1F59,
	0x1F5D,
	0x1F5F,
	0x1F5B,
	0x03AB,
	0x1FE9,
	0x1FEB,
	0x038E,
	0x1FEA,
	0x1FE8,
	0x039E,
	0x0396,
	0x03F9,
	0x03FF,
	0x03FD,
	0x03F4,
	0x1FFE,
	0x1FDE,
	0x1FDF,
	0x1FDD,
	0x1FEE,
	0x1FC1,
	0x1FED,
	0x0385,
	0x1017B,
	0x10180,
	0x1017F,
	0x10188,
	0x03D7,
	0x03F0,
	0x1FBD,
	0x10182,
	0x03D8,
	0x03DC,
	0x03DE,
	0x03E0,
	0x1D26,
	0x1D27,
	0x1D28,
	0x1D2A,
	0x1D29,
	0x03DA,
	0x03F3,
	0x10183,
	0x0375,
	0x03F5,
	0x03F2,
	0x10181,
	0x1D245,
	0x0374,
	0x1017C,
	0x10175,
	0x10176,
	0x10184,
	0x1FFD,
	0x1FC0,
	0x03D5,
	0x03D6,
	0x1FBE,
	0x1FBF,
	0x1FCE,
	0x1FCF,
	0x1FCD,
	0x037E,
	0x03F6,
	0x03F1,
	0x03FC,
	0x037C,
	0x03B1,
	0x1F01,
	0x1F05,
	0x1F85,
	0x1F07,
	0x1F87,
	0x1F03,
	0x1F83,
	0x1F81,
	0x1FB1,
	0x1F71,
	0x1FB4,
	0x1FB6,
	0x1FB7,
	0x1F00,
	0x1F04,
	0x1F84,
	0x1F06,
	0x1F86,
	0x1F02,
	0x1F82,
	0x1F80,
	0x03AC,
	0x1F70,
	0x1FB2,
	0x1FB0,
	0x1FB3,
	0x03D9,
	0x0373,
	0x03B2,
	0x03C7,
	0x03B4,
	0x03DD,
	0x03B5,
	0x1F11,
	0x1F15,
	0x1F13,
	0x1F73,
	0x1F10,
	0x1F14,
	0x1F12,
	0x03AD,
	0x1F72,
	0x03B7,
	0x1F21,
	0x1F25,
	0x1F95,
	0x1F27,
	0x1F97,
	0x1F23,
	0x1F93,
	0x1F91,
	0x1F75,
	0x1FC4,
	0x1FC6,
	0x1FC7,
	0x1F20,
	0x1F24,
	0x1F94,
	0x1F26,
	0x1F96,
	0x1F22,
	0x1F92,
	0x1F90,
	0x03AE,
	0x1F74,
	0x1FC2,
	0x1FC3,
	0x03C2,
	0x03B3,
	0x0371,
	0x03B9,
	0x1F31,
	0x1F35,
	0x1F37,
	0x1F33,
	0x03CA,
	0x1FD3,
	0x1FD7,
	0x0390,
	0x1FD2,
	0x1FD1,
	0x1F77,
	0x1FD6,
	0x1F30,
	0x1F34,
	0x1F36,
	0x1F32,
	0x03AF,
	0x1F76,
	0x1FD0,
	0x03BA,
	0x03DF,
	0x03BB,
	0x03BC,
	0x03BD,
	0x03C9,
	0x1F61,
	0x1F65,
	0x1FA5,
	0x1F67,
	0x1FA7,
	0x1F63,
	0x1FA3,
	0x1FA1,
	0x1F7D,
	0x1FF4,
	0x1FF6,
	0x1FF7,
	0x1F60,
	0x1F64,
	0x1FA4,
	0x1F66,
	0x1FA6,
	0x1F62,
	0x1FA2,
	0x1FA0,
	0x03CE,
	0x1F7C,
	0x1FF2,
	0x1FF3,
	0x03BF,
	0x1F41,
	0x1F45,
	0x1F43,
	0x1F79,
	0x1F40,
	0x1F44,
	0x1F42,
	0x03CC,
	0x1F78,
	0x0377,
	0x03C6,
	0x03C0,
	0x03C8,
	0x03C1,
	0x1FE5,
	0x1FE4,
	0x03E1,
	0x03FB,
	0x03F8,
	0x03C3,
	0x03DB,
	0x03C4,
	0x03B8,
	0x03C5,
	0x1F51,
	0x1F55,
	0x1F57,
	0x1F53,
	0x03CB,
	0x1FE3,
	0x1FE7,
	0x03B0,
	0x1FE2,
	0x1FE1,
	0x1F7B,
	0x1FE6,
	0x1F50,
	0x1F54,
	0x1F56,
	0x1F52,
	0x03CD,
	0x1F7A,
	0x1FE0,
	0x03BE,
	0x03B6,
	0x037D,
	0x037B,
	0x1D66,
	0x1D6A,
	0x1D67,
	0x1D69,
	0x1D68,
	0x1017A,
	0x03D1,
	0x1017E,
	0x10178,
	0x0384,
	0x10189,
	0x1017D,
	0x10177,
	0x03D3,
	0x03D4,
	0x03D2,
	0x1FEF,
	0x10185,
	0x10179,
	0x037A,
	0x1018A,
	0x1F34F,
	0x1F4D7,
	0x1F49A,
	0x1F62C,
	0x1F638,
	0x1F600,
	0x1F601,
	0x1F497,
	0x20B2,
	0x1F482,
	0x1F3B8,
	0x0AF0,
	0x0AEE,
	0x0AEB,
	0x0AEA,
	0x0AEF,
	0x0AE7,
	0x0AED,
	0x0AEC,
	0x0AE9,
	0x0AE8,
	0x0AE6,
	0x0A85,
	0x0A86,
	0x0A90,
	0x0A94,
	0x0AAC,
	0x0AAD,
	0x0A9A,
	0x0A9B,
	0x0AA6,
	0x0AA1,
	0x0AA2,
	0x0AA7,
	0x0A8F,
	0x0A97,
	0x0A98,
	0x0AB9,
	0x0A87,
	0x0A88,
	0x0A9C,
	0x0A9D,
	0x0A95,
	0x0A96,
	0x0AB2,
	0x0AB3,
	0x0AAE,
	0x0AA8,
	0x0A99,
	0x0AA3,
	0x0A9E,
	0x0A93,
	0x0AAA,
	0x0AAB,
	0x0AB0,
	0x0AB8,
	0x0AB6,
	0x0AB7,
	0x0AA4,
	0x0AA5,
	0x0A9F,
	0x0AA0,
	0x0A89,
	0x0A8A,
	0x0AB5,
	0x0A8C,
	0x0AE1,
	0x0A8B,
	0x0AE0,
	0x0AAF,
	0x0AD0,
	0x0AF1,
	0x0A82,
	0x0ABD,
	0x0A81,
	0x0ABC,
	0x0ACD,
	0x0A83,
	0x0A8D,
	0x0A91,
	0x0ABE,
	0x0AC8,
	0x0ACC,
	0x0AC5,
	0x0AC9,
	0x0AC7,
	0x0ABF,
	0x0AC0,
	0x0ACB,
	0x0AC1,
	0x0AC2,
	0x0AE2,
	0x0AE3,
	0x0AC3,
	0x0AC4,
	0x0A71,
	0x0A6E,
	0x0A6B,
	0x0A6A,
	0x0A6F,
	0x0A67,
	0x0A6D,
	0x0A6C,
	0x0A69,
	0x0A68,
	0x0A66,
	0x0A74,
	0x0A72,
	0x0A05,
	0x0A06,
	0x0A10,
	0x0A14,
	0x0A2C,
	0x0A2D,
	0x0A1A,
	0x0A1B,
	0x0A26,
	0x0A21,
	0x0A22,
	0x0A27,
	0x0A0F,
	0x0A5E,
	0x0A17,
	0x0A18,
	0x0A5A,
	0x0A39,
	0x0A07,
	0x0A08,
	0x0A1C,
	0x0A1D,
	0x0A15,
	0x0A16,
	0x0A59,
	0x0A32,
	0x0A33,
	0x0A2E,
	0x0A28,
	0x0A19,
	0x0A23,
	0x0A1E,
	0x0A13,
	0x0A2A,
	0x0A2B,
	0x0A30,
	0x0A5C,
	0x0A38,
	0x0A36,
	0x0A24,
	0x0A25,
	0x0A1F,
	0x0A20,
	0x0A09,
	0x0A0A,
	0x0A35,
	0x0A2F,
	0x0A5B,
	0x0A01,
	0x0A02,
	0x0A3C,
	0x0A51,
	0x0A4D,
	0x0A03,
	0x0A75,
	0x0A70,
	0x0A73,
	0x0A3E,
	0x0A48,
	0x0A4C,
	0x0A47,
	0x0A3F,
	0x0A40,
	0x0A4B,
	0x0A41,
	0x0A42,
	0x200A,
	0x1F487,
	0xFFED,
	0xFFEC,
	0xFFE8,
	0xFFA0,
	0xFFC2,
	0xFFC3,
	0xFFBA,
	0xFFB8,
	0xFFC7,
	0xFFC6,
	0xFFDA,
	0xFFBE,
	0xFFDC,
	0xFFB7,
	0xFFBB,
	0xFFA1,
	0xFFA3,
	0xFFB1,
	0xFFA4,
	0xFFA5,
	0xFFA6,
	0xFFCC,
	0xFFCF,
	0xFFBD,
	0xFFB2,
	0xFFB4,
	0xFFA9,
	0xFFB0,
	0xFFAA,
	0xFFAB,
	0xFFAF,
	0xFFAC,
	0xFFAD,
	0xFFAE,
	0xFFB5,
	0xFFB9,
	0xFFA2,
	0xFFB3,
	0xFFB6,
	0xFFA8,
	0xFFBC,
	0xFFA7,
	0xFFD3,
	0xFFCD,
	0xFFCE,
	0xFFD5,
	0xFFD4,
	0xFFD6,
	0xFFC4,
	0xFFC5,
	0xFFCB,
	0xFFCA,
	0xFFDB,
	0xFFD2,
	0xFFD7,
	0xFF64,
	0xFF61,
	0xFF71,
	0xFF74,
	0xFF8A,
	0xFF8D,
	0xFF8B,
	0xFF8E,
	0xFF8C,
	0xFF72,
	0xFF76,
	0xFF79,
	0xFF77,
	0xFF7A,
	0xFF78,
	0xFF8F,
	0xFF92,
	0xFF90,
	0xFF93,
	0xFF91,
	0xFF9D,
	0xFF85,
	0xFF88,
	0xFF86,
	0xFF89,
	0xFF87,
	0xFF75,
	0xFF97,
	0xFF9A,
	0xFF98,
	0xFF9B,
	0xFF99,
	0xFF7B,
	0xFF7E,
	0xFF7C,
	0xFF67,
	0xFF6A,
	0xFF68,
	0xFF6B,
	0xFF6F,
	0xFF69,
	0xFF6C,
	0xFF6E,
	0xFF6D,
	0xFF7F,
	0xFF7D,
	0xFF80,
	0xFF83,
	0xFF81,
	0xFF84,
	0xFF82,
	0xFF73,
	0xFF9C,
	0xFF66,
	0xFF94,
	0xFF96,
	0xFF95,
	0xFF65,
	0xFF9F,
	0xFF9E,
	0xFF70,
	0xFF62,
	0xFFE9,
	0xFF63,
	0xFFEB,
	0xFFEA,
	0xFFEE,
	0x1F354,
	0x1F528,
	0x2692,
	0x262D,
	0x1F439,
	0x1F45C,
	0x1155,
	0x1150,
	0x113E,
	0x1151,
	0x113F,
	0x110E,
	0x1153,
	0x1152,
	0x1154,
	0x114E,
	0x113C,
	0x114F,
	0x113D,
	0x110C,
	0x114D,
	0x115F,
	0x1112,
	0xA97B,
	0x110B,
	0x1149,
	0x1148,
	0xA977,
	0x1141,
	0x1143,
	0x1146,
	0x114B,
	0x1144,
	0xA976,
	0x1145,
	0x114A,
	0x1142,
	0x111D,
	0x1157,
	0x112B,
	0x111B,
	0x112C,
	0x110F,
	0x1100,
	0x115A,
	0x1106,
	0xA96F,
	0x111C,
	0xA971,
	0xA970,
	0x1102,
	0x115C,
	0x115D,
	0x1113,
	0x1116,
	0x115B,
	0x1115,
	0x1140,
	0x1111,
	0xA97A,
	0x1156,
	0x1107,
	0x1128,
	0x1127,
	0xA974,
	0xA973,
	0x111E,
	0x111F,
	0x112A,
	0x1121,
	0x1126,
	0x1122,
	0x1124,
	0xA972,
	0x1123,
	0x1125,
	0x1129,
	0x1120,
	0x1105,
	0xA96D,
	0x111A,
	0xA96B,
	0xA96E,
	0xA964,
	0xA968,
	0x1118,
	0xA969,
	0xA96C,
	0xA965,
	0xA96A,
	0xA967,
	0xA966,
	0x1109,
	0x1137,
	0x1136,
	0x113B,
	0x1135,
	0x1138,
	0x112D,
	0x1131,
	0x112E,
	0x113A,
	0x1132,
	0x1133,
	0x1130,
	0x1134,
	0x1139,
	0x112F,
	0x110D,
	0xA978,
	0x1158,
	0x1147,
	0x1101,
	0x1114,
	0x1108,
	0x1119,
	0x110A,
	0xA975,
	0xA979,
	0x1104,
	0xA97C,
	0x1110,
	0x1103,
	0xA963,
	0x1117,
	0xA960,
	0xA961,
	0x115E,
	0xA962,
	0x1159,
	0x114C,
	0x302F,
	0x3164,
	0x11BE,
	0x11BD,
	0xD7F7,
	0xD7F8,
	0x11C2,
	0x11F7,
	0x11F5,
	0x11F8,
	0x11F6,
	0x11BC,
	0x11EF,
	0x11EC,
	0x11ED,
	0x11E2,
	0x11F4,
	0x11E6,
	0xD7DD,
	0x11BF,
	0x11A8,
	0x11FC,
	0x11FE,
	0x11FD,
	0x11FA,
	0x11FB,
	0x11C3,
	0x11AA,
	0x11C4,
	0x11B7,
	0x11E0,
	0xD7E2,
	0x11E1,
	0x11DA,
	0xD7DE,
	0x11DF,
	0x11DC,
	0xD7E1,
	0x11DB,
	0x11DD,
	0xD7DF,
	0x11DE,
	0x11AB,
	0xD7CC,
	0x11AC,
	0x11AD,
	0x11C5,
	0x11C8,
	0xD7CB,
	0x11C7,
	0x11C9,
	0x11C6,
	0x11EB,
	0xD7F4,
	0xD7F3,
	0x11C1,
	0x11F3,
	0xD7FA,
	0xD7FB,
	0x11B8,
	0xD7E9,
	0xD7E8,
	0x11E5,
	0xD7E5,
	0x11E4,
	0x11E3,
	0xD7E4,
	0x11B9,
	0xD7E7,
	0xD7E3,
	0x11AF,
	0x11B6,
	0x11D5,
	0x11D8,
	0x11B0,
	0xD7D6,
	0x11CC,
	0x11B1,
	0xD7D8,
	0x11D1,
	0x11D2,
	0x11CD,
	0x11D7,
	0x11B5,
	0x11B2,
	0x11D4,
	0xD7DA,
	0x11D3,
	0xD7D9,
	0x11B3,
	0xD7D5,
	0x11D6,
	0x11B4,
	0x11CE,
	0x11CF,
	0x11D9,
	0xD7DC,
	0xD7DB,
	0x11BA,
	0xD7F0,
	0xD7EF,
	0xD7F2,
	0xD7EB,
	0x11E7,
	0xD7EA,
	0xD7EE,
	0x11EA,
	0x11E9,
	0xD7F1,
	0x11E8,
	0xD7F9,
	0x11EE,
	0x11A9,
	0xD7E0,
	0x11FF,
	0xD7E6,
	0x11D0,
	0xD7D7,
	0x11BB,
	0xD7EC,
	0xD7ED,
	0xD7CD,
	0xD7CE,
	0x11C0,
	0x11AE,
	0xD7D3,
	0xD7D2,
	0x11CA,
	0xD7CF,
	0x11CB,
	0xD7D0,
	0xD7D1,
	0xD7D4,
	0x11F9,
	0x11F0,
	0xD7F6,
	0xD7F5,
	0x11F2,
	0x11F1,
	0x1161,
	0x11A3,
	0x1176,
	0x1177,
	0x1162,
	0x119E,
	0xD7C5,
	0xD7C6,
	0x119F,
	0x11A1,
	0x11A0,
	0x1166,
	0x1165,
	0x117C,
	0x117A,
	0x117B,
	0x1173,
	0xD7B9,
	0xD7BB,
	0xD7BA,
	0x1196,
	0xD7BC,
	0x1195,
	0x1160,
	0x1175,
	0x1198,
	0x119D,
	0x119C,
	0xD7C4,
	0x119A,
	0xD7C1,
	0x119B,
	0x1199,
	0xD7BD,
	0xD7BE,
	0xD7C0,
	0xD7BF,
	0xD7C2,
	0xD7C3,
	0x1169,
	0x1180,
	0x117F,
	0x1182,
	0xD7B1,
	0x1183,
	0x11A6,
	0x11A7,
	0x1181,
	0xD7B0,
	0x116C,
	0x11A2,
	0x116E,
	0x1189,
	0x118A,
	0x118B,
	0xD7B6,
	0x118D,
	0x118C,
	0xD7B5,
	0x116A,
	0x116B,
	0x1170,
	0x116F,
	0x1171,
	0x1163,
	0x1178,
	0x11A4,
	0x1179,
	0x1164,
	0x1168,
	0x1167,
	0x117D,
	0x117E,
	0x11A5,
	0x1174,
	0x1197,
	0x116D,
	0xD7B2,
	0xD7B3,
	0xD7B4,
	0x1188,
	0x1187,
	0x1184,
	0x1185,
	0x1186,
	0x1172,
	0x118E,
	0xD7B7,
	0x1190,
	0x118F,
	0x1194,
	0xD7B8,
	0x1193,
	0x1192,
	0x1191,
	0x314F,
	0x3150,
	0x318D,
	0x318E,
	0x314A,
	0x3148,
	0x3154,
	0x3153,
	0x3161,
	0x314E,
	0x3163,
	0x3147,
	0x3171,
	0x3184,
	0x3178,
	0x3179,
	0x314B,
	0x3131,
	0x3133,
	0x3141,
	0x3170,
	0x316E,
	0x316F,
	0x3134,
	0x3135,
	0x3136,
	0x3168,
	0x3167,
	0x3166,
	0x3157,
	0x315A,
	0x317F,
	0x314D,
	0x3142,
	0x3176,
	0x3172,
	0x3144,
	0x3174,
	0x3175,
	0x3177,
	0x3173,
	0x3139,
	0x3140,
	0x313A,
	0x3169,
	0x313B,
	0x316C,
	0x313F,
	0x313C,
	0x316B,
	0x313D,
	0x313E,
	0x316A,
	0x316D,
	0x3145,
	0x317E,
	0x317A,
	0x317B,
	0x317D,
	0x317C,
	0x3149,
	0x3185,
	0x3180,
	0x3132,
	0x3165,
	0x3143,
	0x3146,
	0x3138,
	0x314C,
	0x3137,
	0x315C,
	0x3158,
	0x3159,
	0x315E,
	0x315D,
	0x315F,
	0x3151,
	0x3152,
	0x3156,
	0x3155,
	0x3186,
	0x3181,
	0x3183,
	0x3182,
	0x3162,
	0x315B,
	0x3189,
	0x3187,
	0x3188,
	0x3160,
	0x318C,
	0x318B,
	0x318A,
	0x302E,
	0x3028,
	0x3025,
	0x3024,
	0x3029,
	0x3021,
	0x3027,
	0x3026,
	0x3038,
	0x303A,
	0x3023,
	0x3039,
	0x3022,
	0x1720,
	0x172A,
	0x1727,
	0x1724,
	0x1731,
	0x1721,
	0x1723,
	0x172E,
	0x172B,
	0x1728,
	0x1725,
	0x1729,
	0x172D,
	0x1730,
	0x1726,
	0x1722,
	0x172F,
	0x172C,
	0x1734,
	0x1732,
	0x1733,
	0x1F64B,
	0x1F423,
	0x1F3A7,
	0x26FC,
	0x1F649,
	0x1F49F,
	0x1F498,
	0x1F49D,
	0x2731,
	0x2718,
	0x27A5,
	0x27A6,
	0x2764,
	0x27B9,
	0x27B8,
	0x27B7,
	0x2714,
	0x2746,
	0x2B58,
	0x2B57,
	0x26E3,
	0x2B59,
	0x27A8,
	0x27A0,
	0x2797,
	0x1F4B2,
	0x275E,
	0x275D,
	0x2738,
	0x274B,
	0x2762,
	0x2757,
	0x2724,
	0x271A,
	0x2763,
	0x2B55,
	0x2770,
	0x276E,
	0x2760,
	0x275F,
	0x27AD,
	0x2796,
	0x2716,
	0x279A,
	0x271C,
	0x272E,
	0x2B56,
	0x2795,
	0x2771,
	0x276F,
	0x2799,
	0x279C,
	0x275C,
	0x275B,
	0x2798,
	0x2748,
	0x27BB,
	0x273D,
	0x2743,
	0x279E,
	0x27AE,
	0x275A,
	0x27BD,
	0x26DB,
	0x2794,
	0x05A2,
	0x05A7,
	0x05AD,
	0x0591,
	0x059C,
	0x059D,
	0x059E,
	0x05AC,
	0x05A4,
	0x05A5,
	0x05A6,
	0x05A3,
	0x05AB,
	0x0599,
	0x05A1,
	0x05A8,
	0x059F,
	0x0597,
	0x0592,
	0x0593,
	0x05A0,
	0x05A9,
	0x059B,
	0x0596,
	0x05AA,
	0x059A,
	0x0595,
	0x0594,
	0x0598,
	0x05AE,
	0x05D0,
	0xFB30,
	0xFB2E,
	0xFB2F,
	0xFB20,
	0xFB29,
	0x05E2,
	0x05D1,
	0xFB31,
	0xFB4C,
	0x05D3,
	0xFB33,
	0x05DA,
	0xFB3A,
	0x05DD,
	0x05DF,
	0x05E3,
	0xFB43,
	0x05E5,
	0x05D2,
	0xFB32,
	0x05D4,
	0xFB34,
	0x05D7,
	0x05DB,
	0xFB3B,
	0xFB4D,
	0x05DC,
	0xFB3C,
	0x05DE,
	0xFB3E,
	0x05E0,
	0xFB40,
	0x05E4,
	0xFB44,
	0xFB4E,
	0x05E7,
	0xFB47,
	0x05E8,
	0xFB48,
	0x05E1,
	0xFB41,
	0x05E9,
	0xFB49,
	0xFB2C,
	0xFB2D,
	0xFB2A,
	0xFB2B,
	0x05EA,
	0xFB4A,
	0x05D8,
	0xFB38,
	0x05E6,
	0xFB46,
	0x05D5,
	0xFB35,
	0xFB4B,
	0xFB21,
	0xFB22,
	0xFB26,
	0xFB23,
	0xFB24,
	0xFB25,
	0xFB27,
	0xFB28,
	0x05D9,
	0xFB39,
	0xFB1D,
	0x05D6,
	0xFB36,
	0xFB4F,
	0x05F0,
	0x05F2,
	0x05F1,
	0xFB1F,
	0x05C5,
	0x05AF,
	0x05C4,
	0x05BC,
	0x05B2,
	0x05B3,
	0x05B1,
	0x05B4,
	0x05B9,
	0x05BA,
	0xFB1E,
	0x05BD,
	0x05B7,
	0x05B8,
	0x05C7,
	0x05BB,
	0x05BF,
	0x05B6,
	0x05B0,
	0x05C1,
	0x05C2,
	0x05B5,
	0x05F3,
	0x05F4,
	0x05BE,
	0x05C6,
	0x05C0,
	0x05C3,
	0x1F681,
	0x2388,
	0x26D1,
	0x1F33F,
	0x22B9,
	0x4DF6,
	0x4DFE,
	0x4DD2,
	0x4DFF,
	0x4DD4,
	0x4DEA,
	0x4DEB,
	0x4DC5,
	0x4DD3,
	0x4DE3,
	0x4DE8,
	0x4DE7,
	0x4DF4,
	0x4DC2,
	0x4DFA,
	0x4DDF,
	0x4DCF,
	0x4DCC,
	0x4DD0,
	0x4DEC,
	0x4DD5,
	0x4DCD,
	0x4DE1,
	0x4DDB,
	0x4DD9,
	0x4DC7,
	0x4DE9,
	0x4DDE,
	0x4DFC,
	0x4DD8,
	0x4DFB,
	0x4DCE,
	0x4DDA,
	0x4DE6,
	0x4DE5,
	0x4DEE,
	0x4DCA,
	0x4DE2,
	0x4DED,
	0x4DE0,
	0x4DD7,
	0x4DF0,
	0x4DFD,
	0x4DC8,
	0x4DD6,
	0x4DCB,
	0x4DDC,
	0x4DC6,
	0x4DF2,
	0x4DF1,
	0x4DDD,
	0x4DC0,
	0x4DE4,
	0x4DF8,
	0x4DF9,
	0x4DF3,
	0x4DF5,
	0x4DC1,
	0x4DF7,
	0x4DEF,
	0x4DC9,
	0x4DC4,
	0x4DD1,
	0x4DC3,
	0x1F33A,
	0x1F506,
	0x26A1,
	0x1F460,
	0x1F684,
	0x1F685,
	0x309F,
	0x309D,
	0x3042,
	0x1B001,
	0x3070,
	0x3079,
	0x3073,
	0x307C,
	0x3076,
	0x3060,
	0x3067,
	0x3062,
	0x3069,
	0x3065,
	0x3048,
	0x304C,
	0x3052,
	0x304E,
	0x3054,
	0x3050,
	0x306F,
	0x3078,
	0x3072,
	0x307B,
	0x3075,
	0x3044,
	0x304B,
	0x3051,
	0x304D,
	0x3053,
	0x304F,
	0x307E,
	0x3081,
	0x307F,
	0x3082,
	0x3080,
	0x3093,
	0x306A,
	0x306D,
	0x306B,
	0x306E,
	0x306C,
	0x304A,
	0x3071,
	0x307A,
	0x3074,
	0x307D,
	0x3077,
	0x3089,
	0x308C,
	0x308A,
	0x308D,
	0x308B,
	0x3055,
	0x305B,
	0x3057,
	0x3041,
	0x3047,
	0x3043,
	0x3095,
	0x3096,
	0x3049,
	0x3063,
	0x3045,
	0x308E,
	0x3083,
	0x3087,
	0x3085,
	0x305D,
	0x3059,
	0x305F,
	0x3066,
	0x3061,
	0x3068,
	0x3064,
	0x3046,
	0x3094,
	0x308F,
	0x3091,
	0x3090,
	0x3092,
	0x3084,
	0x3088,
	0x3086,
	0x3056,
	0x305C,
	0x3058,
	0x305E,
	0x305A,
	0x309E,
	0x26EC,
	0x1F52A,
	0x223B,
	0x1F36F,
	0x1F41D,
	0x2015,
	0x2B23,
	0x2026,
	0x23AF,
	0x26A9,
	0x1F6A5,
	0x1F40E,
	0x1F434,
	0x1F3C7,
	0x1F3E5,
	0x2615,
	0x2668,
	0x1F3E8,
	0x231B,
	0x23F3,
	0x2302,
	0x1F3E0,
	0x1F3E1,
	0x20B4,
	0x1F4AF,
	0x1F62F,
	0x2010,
	0x2043,
	0x2E1A,
	0x002D,
	0x2027,
	0x2E12,
	0x238E,
	0x1F368,
	0x26F8,
	0x2261,
	0x29E5,
	0x2A67,
	0x3198,
	0x319E,
	0x3199,
	0x3195,
	0x319C,
	0x319D,
	0x3190,
	0x319F,
	0x3197,
	0x3192,
	0x3191,
	0x319A,
	0x319B,
	0x3194,
	0x3196,
	0x3193,
	0x3006,
	0x3001,
	0x302C,
	0x2FF1,
	0x2FF3,
	0x2FF4,
	0x2FF2,
	0x2FF0,
	0x2FFB,
	0x2FF5,
	0x2FF6,
	0x2FF7,
	0x2FFA,
	0x2FF8,
	0x2FF9,
	0x302D,
	0x3002,
	0x303F,
	0x3005,
	0x302A,
	0x3007,
	0x302B,
	0x3000,
	0x3037,
	0x32C3,
	0x32C7,
	0x33E7,
	0x33F1,
	0x33EA,
	0x33EE,
	0x33E4,
	0x33E3,
	0x33ED,
	0x33E8,
	0x33F2,
	0x33E0,
	0x33E6,
	0x33F0,
	0x33E5,
	0x33EF,
	0x33E9,
	0x33EC,
	0x33FD,
	0x33FE,
	0x33E2,
	0x33EB,
	0x33F3,
	0x33FB,
	0x33F8,
	0x33F7,
	0x33FC,
	0x33F4,
	0x33FA,
	0x33F9,
	0x33F6,
	0x33F5,
	0x33E1,
	0x32CB,
	0x32C1,
	0x3360,
	0x336A,
	0x3363,
	0x3367,
	0x335D,
	0x335C,
	0x3366,
	0x3361,
	0x336B,
	0x3359,
	0x335F,
	0x3369,
	0x335E,
	0x3368,
	0x3362,
	0x3365,
	0x335B,
	0x3364,
	0x336C,
	0x3370,
	0x336D,
	0x336F,
	0x336E,
	0x335A,
	0x3358,
	0x32C0,
	0x32C6,
	0x32C5,
	0x32C2,
	0x32C4,
	0x32CA,
	0x32C9,
	0x32C8,
	0x303E,
	0x22B7,
	0x2253,
	0x1F47F,
	0x10840,
	0x1084F,
	0x10841,
	0x10843,
	0x10842,
	0x10844,
	0x10847,
	0x1084A,
	0x1084B,
	0x1084C,
	0x1084D,
	0x10850,
	0x10852,
	0x10853,
	0x10851,
	0x1084E,
	0x10854,
	0x10855,
	0x10848,
	0x10845,
	0x10849,
	0x10846,
	0x10858,
	0x1085D,
	0x1085E,
	0x1085B,
	0x1085F,
	0x1085A,
	0x1085C,
	0x10859,
	0x10857,
	0x1F4E5,
	0x1F4E8,
	0x29DC,
	0x29E1,
	0x2206,
	0x20B9,
	0x221E,
	0x29DE,
	0x1F481,
	0x2139,
	0x206C,
	0x206A,
	0x1F520,
	0x1F524,
	0x1F521,
	0x1F522,
	0x1F523,
	0x10B60,
	0x10B61,
	0x10B63,
	0x10B62,
	0x10B64,
	0x10B67,
	0x10B6A,
	0x10B6B,
	0x10B6C,
	0x10B6D,
	0x10B6F,
	0x10B70,
	0x10B6E,
	0x10B71,
	0x10B72,
	0x10B68,
	0x10B65,
	0x10B69,
	0x10B66,
	0x10B7B,
	0x10B78,
	0x10B7E,
	0x10B7F,
	0x10B7C,
	0x10B7A,
	0x10B7D,
	0x10B79,
	0x10B40,
	0x10B4F,
	0x10B41,
	0x10B43,
	0x10B42,
	0x10B44,
	0x10B47,
	0x10B4A,
	0x10B4B,
	0x10B4C,
	0x10B4D,
	0x10B50,
	0x10B52,
	0x10B53,
	0x10B51,
	0x10B4E,
	0x10B54,
	0x10B55,
	0x10B48,
	0x10B45,
	0x10B49,
	0x10B46,
	0x10B5B,
	0x10B58,
	0x10B5E,
	0x10B5F,
	0x10B5C,
	0x10B5A,
	0x10B5D,
	0x10B59,
	0x2380,
	0x222B,
	0x2A15,
	0x2A0F,
	0x23AE,
	0x2A0E,
	0x2A19,
	0x2A17,
	0x2A1B,
	0x2A18,
	0x2A1C,
	0x2A1A,
	0x22BA,
	0x2A3C,
	0xFFF9,
	0xFFFA,
	0xFFFB,
	0x26A4,
	0x203D,
	0x2229,
	0x2A49,
	0x2A47,
	0x2A4B,
	0x2A40,
	0x2A44,
	0x2A43,
	0x25D8,
	0x25D9,
	0x00A1,
	0x2E18,
	0x223E,
	0x2127,
	0x26E7,
	0x00BF,
	0x2054,
	0x2064,
	0x2063,
	0x2062,
	0x1F3EE,
	0x1F383,
	0x26FB,
	0x1F3EF,
	0x1F38E,
	0x1F47A,
	0x3004,
	0x1F479,
	0x1F3E3,
	0x1F530,
	0xA9BF,
	0xA9BD,
	0xA9BE,
	0xA9D8,
	0xA9D5,
	0xA9D4,
	0xA9D9,
	0xA9D1,
	0xA9D7,
	0xA9D6,
	0xA9D3,
	0xA9D2,
	0xA9D0,
	0xA9C1,
	0xA984,
	0xA98D,
	0xA9A7,
	0xA9A8,
	0xA995,
	0xA996,
	0xA9A2,
	0xA9A3,
	0xA99D,
	0xA99E,
	0xA98C,
	0xA992,
	0xA993,
	0xA9B2,
	0xA986,
	0xA985,
	0xA987,
	0xA997,
	0xA999,
	0xA98F,
	0xA991,
	0xA990,
	0xA9AD,
	0xA9A9,
	0xA9A4,
	0xA99F,
	0xA994,
	0xA98A,
	0xA98B,
	0xA99A,
	0xA998,
	0xA98E,
	0xA9A5,
	0xA989,
	0xA9A6,
	0xA9AB,
	0xA9AC,
	0xA9B1,
	0xA9B0,
	0xA9AF,
	0xA9A0,
	0xA9A1,
	0xA99B,
	0xA99C,
	0xA988,
	0xA9AE,
	0xA9AA,
	0xA9CA,
	0xA9CB,
	0xA9C3,
	0xA9DF,
	0xA9C8,
	0xA9C5,
	0xA9C9,
	0xA9C4,
	0xA9C7,
	0xA9CC,
	0xA9DE,
	0xA9C6,
	0xA9C0,
	0xA9CF,
	0xA9C2,
	0xA981,
	0xA9B3,
	0xA982,
	0xA980,
	0xA983,
	0xA9CD,
	0xA9BB,
	0xA9BC,
	0xA9B8,
	0xA9B9,
	0xA9BA,
	0xA9B4,
	0xA9B5,
	0xA9B6,
	0xA9B7,
	0x1F456,
	0x2A1D,
	0x26B5,
	0x2643,
	0x110BB,
	0x110C0,
	0x110C1,
	0x110BF,
	0x110BC,
	0x11083,
	0x11084,
	0x1108A,
	0x1108C,
	0x110A5,
	0x110A6,
	0x11092,
	0x11093,
	0x110A0,
	0x11099,
	0x1109A,
	0x1109B,
	0x110A1,
	0x11089,
	0x1108F,
	0x11090,
	0x110AF,
	0x11085,
	0x11086,
	0x11094,
	0x11095,
	0x1108D,
	0x1108E,
	0x110AA,
	0x110A7,
	0x110A2,
	0x11091,
	0x1109D,
	0x11096,
	0x1108B,
	0x110A3,
	0x110A4,
	0x110A9,
	0x1109C,
	0x110AE,
	0x110AC,
	0x110AD,
	0x1109E,
	0x1109F,
	0x11097,
	0x11098,
	0x11087,
	0x11088,
	0x110AB,
	0x110A8,
	0x110BD,
	0x110BE,
	0x11081,
	0x11080,
	0x110BA,
	0x110B9,
	0x11082,
	0x110B0,
	0x110B6,
	0x110B8,
	0x110B5,
	0x110B1,
	0x110B2,
	0x110B7,
	0x110B3,
	0x110B4,
	0x2F1C,
	0x2F7D,
	0x2F84,
	0x2F6E,
	0x2F44,
	0x2F98,
	0x2F75,
	0x2F96,
	0x2F24,
	0x2FC3,
	0x2F9F,
	0x2FCA,
	0x2F8E,
	0x2FAD,
	0x2F88,
	0x2F9D,
	0x2F66,
	0x2FBB,
	0x2F38,
	0x2F40,
	0x2F3A,
	0x2F80,
	0x2F9E,
	0x2FC0,
	0x2F73,
	0x2F26,
	0x2FA2,
	0x2F52,
	0x2F56,
	0x2F1A,
	0x2F90,
	0x2F8A,
	0x2F50,
	0x2F2B,
	0x2F0D,
	0x2F5C,
	0x2F4D,
	0x2FC5,
	0x2F43,
	0x2F6B,
	0x2FA4,
	0x2F18,
	0x2F4F,
	0x2F5D,
	0x2F3E,
	0x2F02,
	0x2F34,
	0x2F68,
	0x2F58,
	0x2F0C,
	0x2FD3,
	0x2FCE,
	0x2F32,
	0x2F7F,
	0x2F1F,
	0x2FB7,
	0x2F0B,
	0x2FCB,
	0x2F1E,
	0x2F0A,
	0x2FD1,
	0x2F23,
	0x2F6C,
	0x2FAF,
	0x2F5B,
	0x2F57,
	0x2F7B,
	0x2F65,
	0x2FBE,
	0x2F55,
	0x2FC2,
	0x2FD5,
	0x2FB6,
	0x2F9C,
	0x2FB9,
	0x2FCC,
	0x2F51,
	0x2FA8,
	0x2FC1,
	0x2F21,
	0x2F22,
	0x2FA6,
	0x2F72,
	0x2F8B,
	0x2FBD,
	0x2F3D,
	0x2F59,
	0x2F3F,
	0x2FB8,
	0x2F3C,
	0x2FC7,
	0x2F16,
	0x2F05,
	0x2F93,
	0x2FBA,
	0x2F0E,
	0x2F28,
	0x2F8D,
	0x2F5F,
	0x2F78,
	0x2F11,
	0x2F4B,
	0x2F2A,
	0x2FB4,
	0x2FB0,
	0x2FB2,
	0x2F09,
	0x2F07,
	0x2F63,
	0x2F01,
	0x2FA7,
	0x2F35,
	0x2F08,
	0x2F81,
	0x2F60,
	0x2FC9,
	0x2F82,
	0x2F49,
	0x2FA0,
	0x2F85,
	0x2FA9,
	0x2F2D,
	0x2F1D,
	0x2F79,
	0x2FD0,
	0x2F46,
	0x2F7C,
	0x2F00,
	0x2F30,
	0x2F10,
	0x2F87,
	0x2F97,
	0x2F7E,
	0x2F12,
	0x2F1B,
	0x2F5E,
	0x2FAC,
	0x2F41,
	0x2FCF,
	0x2F9A,
	0x2F76,
	0x2F15,
	0x2F2E,
	0x2F27,
	0x2F9B,
	0x2FBF,
	0x2FC4,
	0x2F48,
	0x2F20,
	0x2F42,
	0x2F19,
	0x2F04,
	0x2F92,
	0x2F83,
	0x2F7A,
	0x2F99,
	0x2F37,
	0x2FAB,
	0x2F33,
	0x2F67,
	0x2F77,
	0x2F6A,
	0x2F03,
	0x2FAA,
	0x2F5A,
	0x2F29,
	0x2F39,
	0x2FB3,
	0x2F6D,
	0x2F94,
	0x2F70,
	0x2F14,
	0x2F2C,
	0x2F45,
	0x2F74,
	0x2F53,
	0x2F3B,
	0x2F6F,
	0x2F4C,
	0x2F89,
	0x2F47,
	0x2F62,
	0x2F0F,
	0x2FBC,
	0x2FB1,
	0x2F17,
	0x2F8C,
	0x2F61,
	0x2F86,
	0x2FD2,
	0x2F71,
	0x2F4A,
	0x2FCD,
	0x2F31,
	0x2FD4,
	0x2F06,
	0x2F36,
	0x2F64,
	0x2F95,
	0x2FA5,
	0x2FA1,
	0x2F8F,
	0x2F54,
	0x2F4E,
	0x2F91,
	0x2FC6,
	0x2F69,
	0x2FB5,
	0x2FA3,
	0x2F25,
	0x2F2F,
	0x2F13,
	0x2FAE,
	0x2FC8,
	0x0CD6,
	0x0CEE,
	0x0CEB,
	0x0CEA,
	0x0CEF,
	0x0CE7,
	0x0CED,
	0x0CEC,
	0x0CE9,
	0x0CE8,
	0x0CE6,
	0x0CD5,
	0x0C85,
	0x0C86,
	0x0C90,
	0x0C94,
	0x0CAC,
	0x0CAD,
	0x0C9A,
	0x0C9B,
	0x0CA6,
	0x0CA1,
	0x0CA2,
	0x0CA7,
	0x0C8E,
	0x0C8F,
	0x0CDE,
	0x0C97,
	0x0C98,
	0x0CB9,
	0x0C87,
	0x0C88,
	0x0C9C,
	0x0C9D,
	0x0C95,
	0x0C96,
	0x0CB2,
	0x0CB3,
	0x0CAE,
	0x0CA8,
	0x0C99,
	0x0CA3,
	0x0C9E,
	0x0C92,
	0x0C93,
	0x0CAA,
	0x0CAB,
	0x0CB0,
	0x0CB1,
	0x0CB8,
	0x0CB6,
	0x0CB7,
	0x0CA4,
	0x0CA5,
	0x0C9F,
	0x0CA0,
	0x0C89,
	0x0C8A,
	0x0CB5,
	0x0C8C,
	0x0CE1,
	0x0C8B,
	0x0CE0,
	0x0CAF,
	0x0C82,
	0x0CBD,
	0x0CF1,
	0x0CBC,
	0x0CF2,
	0x0CCD,
	0x0C83,
	0x0CBE,
	0x0CC8,
	0x0CCC,
	0x0CC6,
	0x0CC7,
	0x0CBF,
	0x0CC0,
	0x0CCA,
	0x0CCB,
	0x0CC1,
	0x0CC2,
	0x0CE2,
	0x0CE3,
	0x0CC3,
	0x0CC4,
	0x30FF,
	0x30FD,
	0x30A2,
	0x1B000,
	0x30D0,
	0x30D9,
	0x30D3,
	0x30DC,
	0x30D6,
	0x30C0,
	0x30C7,
	0x30C2,
	0x30C9,
	0x30C5,
	0x30A8,
	0x30AC,
	0x30B2,
	0x30AE,
	0x30B4,
	0x30B0,
	0x30CF,
	0x30D8,
	0x30D2,
	0x30DB,
	0x30D5,
	0x30A4,
	0x30AB,
	0x30B1,
	0x30AD,
	0x30B3,
	0x30AF,
	0x30DE,
	0x30E1,
	0x30DF,
	0x30E2,
	0x30E0,
	0x30F3,
	0x30CA,
	0x30CD,
	0x30CB,
	0x30CE,
	0x30CC,
	0x30AA,
	0x30D1,
	0x30DA,
	0x30D4,
	0x30DD,
	0x30D7,
	0x30E9,
	0x30EC,
	0x30EA,
	0x30ED,
	0x30EB,
	0x30B5,
	0x30BB,
	0x30B7,
	0x30A1,
	0x30A7,
	0x31F5,
	0x31F8,
	0x31F6,
	0x31F9,
	0x31F7,
	0x30A3,
	0x30F5,
	0x30F6,
	0x31F0,
	0x31FA,
	0x31F4,
	0x30A9,
	0x31FB,
	0x31FE,
	0x31FC,
	0x31FF,
	0x31FD,
	0x31F1,
	0x31F2,
	0x31F3,
	0x30C3,
	0x30A5,
	0x30EE,
	0x30E3,
	0x30E7,
	0x30E5,
	0x30BD,
	0x30B9,
	0x30BF,
	0x30C6,
	0x30C1,
	0x30C8,
	0x30C4,
	0x30A6,
	0x30F7,
	0x30F9,
	0x30F8,
	0x30FA,
	0x30F4,
	0x30EF,
	0x30F1,
	0x30F0,
	0x30F2,
	0x30E4,
	0x30E8,
	0x30E6,
	0x30B6,
	0x30BC,
	0x30B8,
	0x30BE,
	0x30BA,
	0x30FB,
	0x30FE,
	0x30A0,
	0x30FC,
	0x309C,
	0x309B,
	0xA908,
	0xA905,
	0xA904,
	0xA909,
	0xA901,
	0xA907,
	0xA906,
	0xA903,
	0xA902,
	0xA900,
	0xA922,
	0xA919,
	0xA921,
	0xA918,
	0xA90C,
	0xA91F,
	0xA913,
	0xA924,
	0xA90A,
	0xA90B,
	0xA91C,
	0xA917,
	0xA914,
	0xA90D,
	0xA911,
	0xA923,
	0xA925,
	0xA915,
	0xA916,
	0xA91A,
	0xA90E,
	0xA90F,
	0xA912,
	0xA91E,
	0xA920,
	0xA91D,
	0xA91B,
	0xA910,
	0xA92E,
	0xA92F,
	0xA92C,
	0xA92D,
	0xA92B,
	0xA927,
	0xA929,
	0xA92A,
	0xA928,
	0xA926,
	0x212A,
	0x1F511,
	0x2328,
	0x1F51F,
	0x10A43,
	0x10A40,
	0x10A42,
	0x10A41,
	0x10A00,
	0x10A26,
	0x10A27,
	0x10A15,
	0x10A16,
	0x10A21,
	0x10A1C,
	0x10A1D,
	0x10A22,
	0x10A12,
	0x10A13,
	0x10A31,
	0x10A17,
	0x10A10,
	0x10A11,
	0x10A32,
	0x10A2B,
	0x10A28,
	0x10A23,
	0x10A1E,
	0x10A19,
	0x10A24,
	0x10A25,
	0x10A2A,
	0x10A2F,
	0x10A2D,
	0x10A2E,
	0x10A1F,
	0x10A20,
	0x10A1A,
	0x10A1B,
	0x10A33,
	0x10A2C,
	0x10A29,
	0x10A30,
	0x10A46,
	0x10A47,
	0x10A44,
	0x10A45,
	0x10A52,
	0x10A53,
	0x10A56,
	0x10A50,
	0x10A57,
	0x10A58,
	0x10A55,
	0x10A54,
	0x10A51,
	0x10A0E,
	0x10A38,
	0x10A39,
	0x10A3A,
	0x10A0D,
	0x10A0F,
	0x10A3F,
	0x10A0C,
	0x10A05,
	0x10A01,
	0x10A06,
	0x10A02,
	0x10A03,
	0x17DB,
	0x17E8,
	0x17E5,
	0x17E4,
	0x17E9,
	0x17E1,
	0x17E7,
	0x17E6,
	0x17E3,
	0x17E2,
	0x17E0,
	0x17AD,
	0x17AE,
	0x17A4,
	0x17B0,
	0x17A3,
	0x17B3,
	0x17AF,
	0x17A5,
	0x17A6,
	0x17B1,
	0x17B2,
	0x17A7,
	0x17A8,
	0x17A9,
	0x17AA,
	0x17AB,
	0x17AC,
	0x1794,
	0x1785,
	0x1786,
	0x1788,
	0x1787,
	0x178A,
	0x178C,
	0x17A0,
	0x1780,
	0x1781,
	0x1783,
	0x1782,
	0x17A1,
	0x179B,
	0x1798,
	0x1784,
	0x178E,
	0x1793,
	0x1789,
	0x1795,
	0x1797,
	0x1796,
	0x17A2,
	0x179A,
	0x179F,
	0x179D,
	0x179E,
	0x178F,
	0x1790,
	0x1792,
	0x1791,
	0x178B,
	0x178D,
	0x179C,
	0x1799,
	0x17CF,
	0x17DD,
	0x17DC,
	0x17CB,
	0x17D5,
	0x17D3,
	0x17D8,
	0x17D6,
	0x17D2,
	0x17CE,
	0x17D4,
	0x17DA,
	0x17D7,
	0x17C9,
	0x17C6,
	0x17D9,
	0x17C7,
	0x17CC,
	0x17D0,
	0x17CD,
	0x17CA,
	0x17D1,
	0x17C8,
	0x19E3,
	0x19F3,
	0x19E4,
	0x19F4,
	0x19EA,
	0x19FA,
	0x19ED,
	0x19FD,
	0x19EE,
	0x19FE,
	0x19EB,
	0x19FB,
	0x19EC,
	0x19FC,
	0x19EF,
	0x19FF,
	0x17F3,
	0x17F4,
	0x17F1,
	0x17F2,
	0x17F5,
	0x17F8,
	0x17F9,
	0x17F6,
	0x17F7,
	0x17F0,
	0x19E1,
	0x19F1,
	0x19E0,
	0x19E2,
	0x19F2,
	0x19E5,
	0x19F5,
	0x19E8,
	0x19F8,
	0x19E9,
	0x19F9,
	0x19E6,
	0x19F6,
	0x19E7,
	0x19F7,
	0x19F0,
	0x17B5,
	0x17B4,
	0x17B6,
	0x17C2,
	0x17C3,
	0x17C5,
	0x17C1,
	0x17B7,
	0x17C0,
	0x17B8,
	0x17BE,
	0x17C4,
	0x17BB,
	0x17BD,
	0x17BC,
	0x17B9,
	0x17BF,
	0x17BA,
	0x1F458,
	0x20AD,
	0x1F48F,
	0x1F48B,
	0x1F63D,
	0x1F617,
	0x1F61A,
	0x1F619,
	0x1F428,
	0x327F,
	0x2114,
	0x1F41E,
	0xE0001,
	0x0ECC,
	0x0ED8,
	0x0ED5,
	0x0ED4,
	0x0ED9,
	0x0ED1,
	0x0ED7,
	0x0ED6,
	0x0ED3,
	0x0ED2,
	0x0ED0,
	0x0EAF,
	0x0EDD,
	0x0EDC,
	0x0EC6,
	0x0E9A,
	0x0E88,
	0x0E94,
	0x0E9F,
	0x0E9D,
	0x0EAB,
	0x0EAE,
	0x0EDE,
	0x0EDF,
	0x0E82,
	0x0E84,
	0x0E81,
	0x0EA3,
	0x0EA5,
	0x0EA1,
	0x0E87,
	0x0E99,
	0x0E8D,
	0x0EAD,
	0x0E9C,
	0x0E9E,
	0x0E9B,
	0x0EAA,
	0x0E8A,
	0x0E96,
	0x0E97,
	0x0E95,
	0x0EA7,
	0x0EA2,
	0x0ECD,
	0x0EBC,
	0x0EBD,
	0x0ECB,
	0x0EC8,
	0x0EC9,
	0x0ECA,
	0x0EB0,
	0x0EB2,
	0x0EC4,
	0x0EB3,
	0x0EC3,
	0x0EC0,
	0x0EC1,
	0x0EB4,
	0x0EB5,
	0x0EB1,
	0x0EBB,
	0x0EC2,
	0x0EB8,
	0x0EB9,
	0x0EB6,
	0x0EB7,
	0x1F535,
	0x1F537,
	0x25EF,
	0x27D9,
	0x2A1E,
	0x10B3D,
	0x10B3F,
	0x1F536,
	0x1F534,
	0x2AFC,
	0x10B3C,
	0x10B3E,
	0x27D8,
	0x2AAB,
	0x2AAD,
	0x263E,
	0x1F317,
	0x1F31C,
	0x0041,
	0x00C1,
	0x0102,
	0x1EAE,
	0x1EB6,
	0x1EB0,
	0x1EB2,
	0x1EB4,
	0x01CD,
	0x00C2,
	0x1EA4,
	0x1EAC,
	0x1EA6,
	0x1EA8,
	0x1EAA,
	0x00C4,
	0x01DE,
	0x0226,
	0x01E0,
	0x1EA0,
	0x0200,
	0x00C0,
	0x1EA2,
	0x0202,
	0x0100,
	0x0104,
	0x00C5,
	0x01FA,
	0x1E00,
	0x023A,
	0x00C3,
	0xA732,
	0x00C6,
	0x01FC,
	0x01E2,
	0x0189,
	0x2C6D,
	0xA734,
	0xA736,
	0xA738,
	0xA73A,
	0xA73C,
	0x0042,
	0x1E02,
	0x1E04,
	0x0181,
	0x1E06,
	0x0243,
	0x0182,
	0xA746,
	0x0043,
	0x0106,
	0xA792,
	0x010C,
	0x00C7,
	0x1E08,
	0x0108,
	0x010A,
	0x0187,
	0x023B,
	0xA76E,
	0xA72C,
	0xA72E,
	0x0044,
	0x010E,
	0x1E10,
	0x1E12,
	0x1E0A,
	0x1E0C,
	0x018A,
	0x1E0E,
	0x01F2,
	0x01C5,
	0x0110,
	0x018B,
	0x01F1,
	0x01C4,
	0x0045,
	0x00C9,
	0x0114,
	0x011A,
	0x0228,
	0x1E1C,
	0x00CA,
	0x1EBE,
	0x1EC6,
	0x1EC0,
	0x1EC2,
	0x1EC4,
	0x1E18,
	0x00CB,
	0x0116,
	0x1EB8,
	0x0204,
	0x00C8,
	0x1EBA,
	0x0206,
	0x0112,
	0x1E16,
	0x1E14,
	0x0118,
	0x0246,
	0x1EBC,
	0x1E1A,
	0xA724,
	0xA722,
	0x014A,
	0x01A9,
	0xA76A,
	0x00D0,
	0x01B7,
	0x01B8,
	0x01EE,
	0x0046,
	0x1E1E,
	0x0191,
	0x0047,
	0x01F4,
	0x011E,
	0x01E6,
	0x0122,
	0x011C,
	0x0120,
	0x0193,
	0x1E20,
	0xA7A0,
	0x01E4,
	0x0194,
	0x0241,
	0x0048,
	0x1E2A,
	0x021E,
	0x1E28,
	0x0124,
	0x2C67,
	0x1E26,
	0x1E22,
	0x1E24,
	0xA7AA,
	0x0126,
	0x2C75,
	0xA726,
	0x01F6,
	0x0049,
	0x00CD,
	0x012C,
	0x01CF,
	0x00CE,
	0x00CF,
	0x1E2E,
	0x0130,
	0x1ECA,
	0x0208,
	0x00CC,
	0x1EC8,
	0x020A,
	0x012A,
	0x012E,
	0x0197,
	0x0128,
	0x1E2C,
	0xA779,
	0xA77B,
	0xA77D,
	0xA782,
	0xA784,
	0xA786,
	0x0196,
	0xA76C,
	0x004A,
	0x0134,
	0x0248,
	0x004B,
	0x1E30,
	0x01E8,
	0x0136,
	0x2C69,
	0xA742,
	0x1E32,
	0x0198,
	0x1E34,
	0xA7A2,
	0xA740,
	0xA744,
	0x004C,
	0x0139,
	0x023D,
	0x013D,
	0x013B,
	0x1E3C,
	0x1E36,
	0x1E38,
	0x2C60,
	0xA748,
	0x1E3A,
	0x013F,
	0x2C62,
	0x01C8,
	0x0141,
	0x01C7,
	0x004D,
	0x1E3E,
	0x1E40,
	0x1E42,
	0x2C6E,
	0x1EFA,
	0x1EFC,
	0x004E,
	0x0143,
	0x0147,
	0x0145,
	0x1E4A,
	0xA790,
	0x1E44,
	0x1E46,
	0x01F8,
	0x019D,
	0x1E48,
	0x0220,
	0xA7A4,
	0x01CB,
	0x00D1,
	0x01CA,
	0x004F,
	0x00D3,
	0x014E,
	0x01D1,
	0x00D4,
	0x1ED0,
	0x1ED8,
	0x1ED2,
	0x1ED4,
	0x1ED6,
	0x00D6,
	0x022A,
	0x022E,
	0x0230,
	0x1ECC,
	0x0150,
	0x020C,
	0x00D2,
	0x1ECE,
	0x01A0,
	0x1EDA,
	0x1EE2,
	0x1EDC,
	0x1EDE,
	0x1EE0,
	0x020E,
	0xA74A,
	0xA74C,
	0x014C,
	0x1E52,
	0x1E50,
	0x019F,
	0x01EA,
	0x01EC,
	0x00D8,
	0x01FE,
	0x00D5,
	0x1E4C,
	0x1E4E,
	0x022C,
	0x01A2,
	0xA74E,
	0x0190,
	0x0186,
	0x0222,
	0x0050,
	0x1E54,
	0x1E56,
	0xA752,
	0x01A4,
	0xA754,
	0x2C63,
	0xA750,
	0x0051,
	0xA758,
	0xA756,
	0x0052,
	0xA75A,
	0x0154,
	0x0158,
	0x0156,
	0x1E58,
	0x1E5A,
	0x1E5C,
	0x0210,
	0x0212,
	0x1E5E,
	0xA7A6,
	0x024C,
	0x2C64,
	0xA73E,
	0x018E,
	0xA75C,
	0x0053,
	0x015A,
	0x1E64,
	0x0160,
	0x1E66,
	0x015E,
	0x015C,
	0x0218,
	0x1E60,
	0x1E62,
	0x1E68,
	0xA7A8,
	0x2C7E,
	0xA78B,
	0x018F,
	0x1E9E,
	0x024A,
	0x0054,
	0x0164,
	0x0162,
	0x1E70,
	0x021A,
	0x023E,
	0x1E6A,
	0x1E6C,
	0x01AC,
	0x1E6E,
	0x01AE,
	0x0166,
	0x00DE,
	0xA764,
	0xA766,
	0x01BC,
	0x0184,
	0x01A7,
	0xA72A,
	0x2C6F,
	0x2C70,
	0xA78D,
	0xA77E,
	0xA780,
	0x019C,
	0x0245,
	0xA728,
	0x0055,
	0x0244,
	0x00DA,
	0x016C,
	0x01D3,
	0x00DB,
	0x1E76,
	0x00DC,
	0x01D7,
	0x01D9,
	0x01DB,
	0x01D5,
	0x1E72,
	0x1EE4,
	0x0170,
	0x0214,
	0x00D9,
	0x1EE6,
	0x01AF,
	0x1EE8,
	0x1EF0,
	0x1EEA,
	0x1EEC,
	0x1EEE,
	0x0216,
	0x016A,
	0x1E7A,
	0x0172,
	0x016E,
	0x0168,
	0x1E78,
	0x1E74,
	0x01B1,
	0x0056,
	0xA75E,
	0x1E7E,
	0x01B2,
	0x1E7C,
	0xA768,
	0xA762,
	0xA760,
	0x0057,
	0x1E82,
	0x0174,
	0x1E84,
	0x1E86,
	0x1E88,
	0x1E80,
	0x2C72,
	0x01F7,
	0x0058,
	0x1E8C,
	0x1E8A,
	0x0059,
	0x00DD,
	0x0176,
	0x0178,
	0x1E8E,
	0x1EF4,
	0x1EF2,
	0x01B3,
	0x1EF6,
	0x1EFE,
	0x0232,
	0x024E,
	0x1EF8,
	0x021C,
	0x005A,
	0x0179,
	0x017D,
	0x1E90,
	0x2C6B,
	0x017B,
	0x1E92,
	0x0224,
	0x1E94,
	0x01B5,
	0x2C7F,
	0x0132,
	0x0152,
	0x271D,
	0xA7FF,
	0xA7FE,
	0xA7FD,
	0xA7FB,
	0xA7FC,
	0x1D25,
	0x01C2,
	0x02AD,
	0x0298,
	0x02AC,
	0x01C0,
	0x0294,
	0x02A1,
	0x0296,
	0x01BE,
	0x01C1,
	0x0295,
	0x01C3,
	0x01AA,
	0x02A2,
	0x1D00,
	0x1D01,
	0x0299,
	0x1D03,
	0x1D04,
	0x1D05,
	0x1D07,
	0x1D06,
	0x1D23,
	0xA730,
	0x0262,
	0x029B,
	0x029C,
	0x026A,
	0x0281,
	0x1D0A,
	0x1D0B,
	0x029F,
	0x1D0C,
	0x1D0D,
	0x0274,
	0x1D0F,
	0x0276,
	0x1D10,
	0x1D15,
	0x1D18,
	0x0280,
	0x1D0E,
	0x1D19,
	0xA776,
	0xA731,
	0x1D1B,
	0x2C7B,
	0xA7FA,
	0x1D1A,
	0x1D1C,
	0x1D20,
	0x1D21,
	0x028F,
	0x1D22,
	0x0297,
	0x01BB,
	0x1D24,
	0x01BF,
	0x01A6,
	0x1D7B,
	0x1D7E,
	0x0061,
	0x00E1,
	0x0103,
	0x1EAF,
	0x1EB7,
	0x1EB1,
	0x1EB3,
	0x1EB5,
	0x01CE,
	0x00E2,
	0x1EA5,
	0x1EAD,
	0x1EA7,
	0x1EA9,
	0x1EAB,
	0x00E4,
	0x01DF,
	0x0227,
	0x01E1,
	0x1EA1,
	0x0201,
	0x00E0,
	0x1EA3,
	0x0203,
	0x0101,
	0x0105,
	0x1D8F,
	0x1E9A,
	0x00E5,
	0x01FB,
	0x1E01,
	0x2C65,
	0x00E3,
	0xA733,
	0x00E6,
	0x01FD,
	0x01E3,
	0x0251,
	0x1D90,
	0xA735,
	0xA737,
	0xA739,
	0xA73B,
	0xA73D,
	0x0062,
	0x1E03,
	0x1E05,
	0x0253,
	0x1E07,
	0x1D6C,
	0x1D80,
	0x0180,
	0x0183,
	0x0275,
	0x1D17,
	0xA747,
	0x0063,
	0x0107,
	0xA793,
	0x010D,
	0x00E7,
	0x1E09,
	0x0109,
	0x0255,
	0x010B,
	0x0188,
	0x023C,
	0x0277,
	0x029A,
	0x025E,
	0xA76F,
	0xA72D,
	0xA72F,
	0x0064,
	0x010F,
	0x1E11,
	0x1E13,
	0x0221,
	0x1E0B,
	0x1E0D,
	0x0257,
	0x1D91,
	0x1E0F,
	0x1D6D,
	0x1D81,
	0x0111,
	0x0256,
	0x018C,
	0x0238,
	0x1E9F,
	0x02A4,
	0x0131,
	0x0237,
	0x025F,
	0x0284,
	0xA771,
	0x01F3,
	0x02A3,
	0x02A5,
	0x01C6,
	0x0065,
	0x00E9,
	0x0115,
	0x011B,
	0x0229,
	0x1E1D,
	0x00EA,
	0x1EBF,
	0x1EC7,
	0x1EC1,
	0x1EC3,
	0x1EC5,
	0x1E19,
	0x00EB,
	0x0117,
	0x1EB9,
	0x0205,
	0x00E8,
	0x1EBB,
	0x0207,
	0x0113,
	0x1E17,
	0x1E15,
	0x2C78,
	0x0119,
	0x1D92,
	0x0247,
	0x1EBD,
	0x1E1B,
	0xA725,
	0xA723,
	0x014B,
	0x0283,
	0x0286,
	0x1D8B,
	0x1D98,
	0xA76B,
	0x00F0,
	0x0292,
	0x01B9,
	0x01EF,
	0x0293,
	0x1D9A,
	0x01BA,
	0x0066,
	0x1E1F,
	0x0192,
	0x1D6E,
	0x1D82,
	0x02A9,
	0x0067,
	0x01F5,
	0x011F,
	0x01E7,
	0x0123,
	0x011D,
	0x0121,
	0x0260,
	0x1E21,
	0xA7A1,
	0x1D83,
	0x01E5,
	0x0263,
	0x0242,
	0x0068,
	0x1E2B,
	0x021F,
	0x1E29,
	0x0125,
	0x2C68,
	0x1E27,
	0x1E23,
	0x1E25,
	0x0266,
	0x1E96,
	0x0127,
	0x2C76,
	0xA727,
	0x0267,
	0x0195,
	0x0069,
	0x00ED,
	0x012D,
	0x01D0,
	0x00EE,
	0x00EF,
	0x1E2F,
	0x1ECB,
	0x0209,
	0x00EC,
	0x1EC9,
	0x020B,
	0x012B,
	0x012F,
	0x1D96,
	0x0268,
	0x0129,
	0x1E2D,
	0xA77A,
	0xA77C,
	0x1D79,
	0xA783,
	0xA785,
	0xA787,
	0x0269,
	0x1D7C,
	0xA76D,
	0x006A,
	0x01F0,
	0x0135,
	0x029D,
	0x0249,
	0x006B,
	0x1E31,
	0x01E9,
	0x0137,
	0x2C6A,
	0xA743,
	0x1E33,
	0x0199,
	0x1E35,
	0xA7A3,
	0x1D84,
	0xA741,
	0xA745,
	0x0138,
	0x006C,
	0x013A,
	0x019A,
	0x026C,
	0x013E,
	0x013C,
	0x1E3D,
	0x0234,
	0x1E37,
	0x1E39,
	0x2C61,
	0xA749,
	0x1E3B,
	0x0140,
	0x026B,
	0x1D85,
	0x026D,
	0xA78E,
	0x0142,
	0x019B,
	0x026E,
	0x01C9,
	0x017F,
	0x1E9C,
	0x1E9B,
	0x1E9D,
	0x02AA,
	0xA772,
	0x02AB,
	0x006D,
	0x1E3F,
	0x1E41,
	0x1E43,
	0x0271,
	0x1D6F,
	0x1D86,
	0x1EFB,
	0x1EFD,
	0xA773,
	0x006E,
	0x0149,
	0x0144,
	0x0148,
	0x0146,
	0x1E4B,
	0x0235,
	0xA791,
	0x1E45,
	0x1E47,
	0x01F9,
	0x0272,
	0x1E49,
	0x019E,
	0x1D70,
	0xA7A5,
	0x1D87,
	0x0273,
	0x00F1,
	0x01CC,
	0xA774,
	0x006F,
	0x00F3,
	0x014F,
	0x01D2,
	0x00F4,
	0x1ED1,
	0x1ED9,
	0x1ED3,
	0x1ED5,
	0x1ED7,
	0x00F6,
	0x022B,
	0x022F,
	0x0231,
	0x1ECD,
	0x0151,
	0x020D,
	0x00F2,
	0x1ECF,
	0x01A1,
	0x1EDB,
	0x1EE3,
	0x1EDD,
	0x1EDF,
	0x1EE1,
	0x020F,
	0xA74B,
	0xA74D,
	0x2C7A,
	0x014D,
	0x1E53,
	0x1E51,
	0x01EB,
	0x01ED,
	0x00F8,
	0x01FF,
	0x00F5,
	0x1E4D,
	0x1E4F,
	0x022D,
	0x01A3,
	0xA74F,
	0x025B,
	0x1D93,
	0x0254,
	0x1D97,
	0x0223,
	0x0070,
	0x1E55,
	0x1E57,
	0xA753,
	0x01A5,
	0x1D71,
	0x1D88,
	0xA755,
	0x1D7D,
	0xA751,
	0x0278,
	0x0071,
	0xA759,
	0x02A0,
	0x024B,
	0xA757,
	0x0239,
	0x0072,
	0xA75B,
	0x0155,
	0x0159,
	0x0157,
	0x1E59,
	0x1E5B,
	0x1E5D,
	0x0211,
	0x027E,
	0x1D73,
	0x0213,
	0x1E5F,
	0x027C,
	0x1D72,
	0xA7A7,
	0x1D89,
	0x024D,
	0x027D,
	0x0264,
	0x2184,
	0xA73F,
	0x0258,
	0x025C,
	0x025D,
	0x1D94,
	0x027F,
	0xA775,
	0xA75D,
	0x0073,
	0x015B,
	0x1E65,
	0x0161,
	0x1E67,
	0x015F,
	0x015D,
	0x0219,
	0x1E61,
	0x1E63,
	0x1E69,
	0x0282,
	0x1D74,
	0xA7A9,
	0x1D8A,
	0x023F,
	0xA78C,
	0x0259,
	0x025A,
	0x1D95,
	0x0261,
	0x00DF,
	0x1D1E,
	0x1D11,
	0x1D13,
	0x1D12,
	0x1D1F,
	0x1D1D,
	0x0285,
	0x0074,
	0x0165,
	0x0163,
	0x1E71,
	0x021B,
	0x0236,
	0x1E97,
	0x2C66,
	0x1E6B,
	0x1E6D,
	0x01AD,
	0x1E6F,
	0x1D75,
	0x01AB,
	0x0288,
	0x0167,
	0x2C77,
	0x02A8,
	0x02A7,
	0x1D7A,
	0x00FE,
	0xA765,
	0xA767,
	0x01BD,
	0x0185,
	0x01A8,
	0x1D16,
	0xA72B,
	0x02A6,
	0xA777,
	0x0250,
	0x1D02,
	0x0252,
	0x018D,
	0x01DD,
	0x1D77,
	0x0265,
	0x02AE,
	0x02AF,
	0x1D09,
	0xA77F,
	0x029E,
	0xA781,
	0x026F,
	0x0270,
	0x1D14,
	0x1D08,
	0x0279,
	0x027B,
	0x027A,
	0x2C79,
	0x0287,
	0x028C,
	0x028D,
	0x028E,
	0xA729,
	0x0075,
	0x0289,
	0x00FA,
	0x016D,
	0x01D4,
	0x00FB,
	0x1E77,
	0x00FC,
	0x01D8,
	0x01DA,
	0x01DC,
	0x01D6,
	0x1E73,
	0x1EE5,
	0x0171,
	0x0215,
	0x00F9,
	0x1EE7,
	0x01B0,
	0x1EE9,
	0x1EF1,
	0x1EEB,
	0x1EED,
	0x1EEF,
	0x0217,
	0x016B,
	0x1E7B,
	0x0173,
	0x1D99,
	0x016F,
	0x0169,
	0x1E79,
	0x1E75,
	0x1D6B,
	0xA778,
	0x028A,
	0x1D7F,
	0x0076,
	0x2C74,
	0xA75F,
	0x1E7F,
	0x028B,
	0x1D8C,
	0x2C71,
	0x1E7D,
	0xA769,
	0xA763,
	0xA761,
	0x0077,
	0x1E83,
	0x0175,
	0x1E85,
	0x1E87,
	0x1E89,
	0x1E81,
	0x2C73,
	0x1E98,
	0x0078,
	0x1E8D,
	0x1E8B,
	0x1D8D,
	0x0079,
	0x00FD,
	0x0177,
	0x00FF,
	0x1E8F,
	0x1EF5,
	0x1EF3,
	0x01B4,
	0x1EF7,
	0x1EFF,
	0x0233,
	0x1E99,
	0x024F,
	0x1EF9,
	0x021D,
	0x007A,
	0x017A,
	0x017E,
	0x1E91,
	0x0291,
	0x2C6C,
	0x017C,
	0x1E93,
	0x0225,
	0x1E95,
	0x1D76,
	0x1D8E,
	0x0290,
	0x01B6,
	0x0240,
	0xFB00,
	0xFB03,
	0xFB04,
	0xFB01,
	0xFB02,
	0x0133,
	0xFB05,
	0x0153,
	0xFB06,
	0x2090,
	0x2091,
	0x2095,
	0x1D62,
	0x2C7C,
	0x2096,
	0x2097,
	0x2098,
	0x2099,
	0x2092,
	0x209A,
	0x1D63,
	0x209B,
	0x2094,
	0x209C,
	0x1D64,
	0x1D65,
	0x2093,
	0x1F343,
	0x1F4D2,
	0x27DA,
	0x27DB,
	0x3008,
	0x2991,
	0x2993,
	0x2B32,
	0x2B30,
	0x2950,
	0x294B,
	0x294A,
	0x294E,
	0x3010,
	0x2997,
	0x2308,
	0x26DC,
	0x300C,
	0x007B,
	0x23A9,
	0x23A8,
	0x23A7,
	0x2E04,
	0x300A,
	0x2E28,
	0x201C,
	0x29DA,
	0x297C,
	0x258B,
	0x230A,
	0x25D6,
	0x258C,
	0x2E1C,
	0x1F6C5,
	0x27DC,
	0x22C9,
	0x258F,
	0x258E,
	0x27D5,
	0x0028,
	0x239C,
	0x239D,
	0x239B,
	0x2E0C,
	0x2194,
	0x2948,
	0x21FC,
	0x21AE,
	0x21F9,
	0x2B0C,
	0x21D4,
	0x21CE,
	0x2904,
	0x21FF,
	0x21AD,
	0x2B04,
	0x27C5,
	0x22CB,
	0x2589,
	0x2E26,
	0x2018,
	0x005B,
	0x23A2,
	0x23A3,
	0x23A1,
	0x2045,
	0x298F,
	0x298D,
	0x298B,
	0x2E02,
	0x22A3,
	0x258D,
	0x258A,
	0x3014,
	0x2E09,
	0x29CF,
	0x2E20,
	0x23B8,
	0x300E,
	0x2983,
	0x3016,
	0x2985,
	0x301A,
	0x3018,
	0x29D8,
	0x0FD6,
	0x0FD8,
	0x26E6,
	0x2329,
	0x29FC,
	0x00AB,
	0x1F50D,
	0x27AA,
	0x2939,
	0x202A,
	0x2066,
	0x200E,
	0x202D,
	0x2190,
	0x2B4A,
	0x2B42,
	0x2B4B,
	0x2943,
	0x2973,
	0x21A4,
	0x291F,
	0x21C6,
	0x2977,
	0x297A,
	0x2B3E,
	0x21E4,
	0x21B9,
	0x291D,
	0x2B38,
	0x21FA,
	0x21A9,
	0x21AB,
	0x2946,
	0x219A,
	0x21A2,
	0x2B3A,
	0x2B39,
	0x2B10,
	0x2B11,
	0x21F7,
	0x2919,
	0x2B05,
	0x21E0,
	0x21D0,
	0x2906,
	0x21CD,
	0x2902,
	0x291B,
	0x290C,
	0x21CB,
	0x2967,
	0x296B,
	0x295E,
	0x2956,
	0x21BD,
	0x2962,
	0x296A,
	0x2966,
	0x295A,
	0x2952,
	0x21BC,
	0x21FD,
	0x21C7,
	0x2B45,
	0x21DC,
	0x21DA,
	0x290E,
	0x219E,
	0x2B36,
	0x2B35,
	0x2B3B,
	0x2B3D,
	0x2B3C,
	0x2B34,
	0x2B37,
	0x219C,
	0x21E6,
	0x1F34B,
	0x264C,
	0x1F406,
	0x1C2D,
	0x1C35,
	0x1C2F,
	0x1C2E,
	0x1C30,
	0x1C34,
	0x1C31,
	0x1C32,
	0x1C33,
	0x1C48,
	0x1C45,
	0x1C44,
	0x1C49,
	0x1C41,
	0x1C47,
	0x1C46,
	0x1C43,
	0x1C42,
	0x1C40,
	0x1C23,
	0x1C13,
	0x1C14,
	0x1C06,
	0x1C07,
	0x1C0C,
	0x1C4F,
	0x1C19,
	0x1C11,
	0x1C12,
	0x1C03,
	0x1C04,
	0x1C1D,
	0x1C1E,
	0x1C08,
	0x1C00,
	0x1C02,
	0x1C01,
	0x1C1C,
	0x1C15,
	0x1C16,
	0x1C0D,
	0x1C05,
	0x1C09,
	0x1C0E,
	0x1C10,
	0x1C0F,
	0x1C1B,
	0x1C20,
	0x1C21,
	0x1C0A,
	0x1C0B,
	0x1C17,
	0x1C18,
	0x1C4D,
	0x1C4E,
	0x1C1F,
	0x1C22,
	0x1C1A,
	0x1C3D,
	0x1C3C,
	0x1C3B,
	0x1C3F,
	0x1C3E,
	0x1C37,
	0x1C36,
	0x1C25,
	0x1C24,
	0x1C26,
	0x1C2C,
	0x1C27,
	0x1C28,
	0x1C29,
	0x1C2A,
	0x1C2B,
	0x2A8B,
	0x2A91,
	0x2976,
	0x2A8F,
	0x2A8D,
	0x2A93,
	0x2A89,
	0x2A87,
	0x2268,
	0x22E6,
	0x2AA6,
	0x2AA8,
	0x22DA,
	0x2A85,
	0x2264,
	0x2272,
	0x2276,
	0x2A7D,
	0x2A81,
	0x2A83,
	0x2A7F,
	0x2266,
	0x003C,
	0x2A79,
	0x22D6,
	0x2A7B,
	0x264E,
	0x2772,
	0x1F688,
	0x2773,
	0x2591,
	0x2758,
	0x2607,
	0x194E,
	0x194B,
	0x194A,
	0x194F,
	0x1947,
	0x194D,
	0x194C,
	0x1949,
	0x1948,
	0x1946,
	0x1944,
	0x1912,
	0x1913,
	0x1906,
	0x1907,
	0x190D,
	0x190E,
	0x1903,
	0x1904,
	0x191C,
	0x1908,
	0x1909,
	0x1901,
	0x1902,
	0x1917,
	0x1914,
	0x190F,
	0x1905,
	0x1910,
	0x1911,
	0x1916,
	0x191B,
	0x1919,
	0x191A,
	0x190B,
	0x190C,
	0x1918,
	0x1915,
	0x190A,
	0x1945,
	0x193A,
	0x1940,
	0x1939,
	0x193B,
	0x1932,
	0x1930,
	0x1938,
	0x1936,
	0x1934,
	0x1931,
	0x1935,
	0x1937,
	0x1933,
	0x192A,
	0x192B,
	0x1929,
	0x1920,
	0x1924,
	0x1926,
	0x1927,
	0x1923,
	0x1921,
	0x1928,
	0x1925,
	0x1922,
	0x1900,
	0x32CF,
	0x2A14,
	0x2A12,
	0x2A13,
	0x2028,
	0x10080,
	0x10081,
	0x10082,
	0x10083,
	0x10084,
	0x10085,
	0x10086,
	0x10087,
	0x10088,
	0x10089,
	0x1008A,
	0x1008B,
	0x1008C,
	0x1008D,
	0x1008E,
	0x1008F,
	0x10090,
	0x10091,
	0x10092,
	0x10095,
	0x10096,
	0x1009A,
	0x1009B,
	0x1009D,
	0x100A0,
	0x100A7,
	0x100AA,
	0x100AB,
	0x100B5,
	0x100B7,
	0x100C3,
	0x100C4,
	0x100C5,
	0x100C6,
	0x100C7,
	0x100C9,
	0x100CC,
	0x100CD,
	0x100CE,
	0x100CF,
	0x100D8,
	0x10093,
	0x10094,
	0x10098,
	0x10099,
	0x100D2,
	0x10005,
	0x1002B,
	0x1001E,
	0x10033,
	0x10035,
	0x10019,
	0x10007,
	0x10000,
	0x1002E,
	0x10004,
	0x10021,
	0x10030,
	0x10015,
	0x10008,
	0x10017,
	0x10023,
	0x1003C,
	0x1003F,
	0x10025,
	0x10018,
	0x1001A,
	0x1002C,
	0x10029,
	0x10002,
	0x1001B,
	0x1002D,
	0x10026,
	0x1000D,
	0x10034,
	0x10001,
	0x10020,
	0x10039,
	0x1002F,
	0x1003A,
	0x10010,
	0x10006,
	0x1000B,
	0x10045,
	0x10022,
	0x10009,
	0x1001C,
	0x1002A,
	0x10037,
	0x1001D,
	0x1000A,
	0x10031,
	0x10032,
	0x10028,
	0x10003,
	0x10047,
	0x1000E,
	0x10011,
	0x10036,
	0x10012,
	0x10043,
	0x1001F,
	0x10016,
	0x1003D,
	0x10038,
	0x1000F,
	0x10024,
	0x10014,
	0x10013,
	0x10042,
	0x1004C,
	0x10044,
	0x1004D,
	0x1F517,
	0x1F484,
	0x20A4,
	0xA4EE,
	0xA4EF,
	0xA4D0,
	0xA4DA,
	0xA4DB,
	0xA4D3,
	0xA4DC,
	0xA4F0,
	0xA4F1,
	0xA4E9,
	0xA4D6,
	0xA4ED,
	0xA4E6,
	0xA4E8,
	0xA4F2,
	0xA4D9,
	0xA4D7,
	0xA4D8,
	0xA4E1,
	0xA4DF,
	0xA4E0,
	0xA4E5,
	0xA4F3,
	0xA4F7,
	0xA4D1,
	0xA4D2,
	0xA4E2,
	0xA4EB,
	0xA4D4,
	0xA4D5,
	0xA4FB,
	0xA4FA,
	0xA4FD,
	0xA4FC,
	0xA4F8,
	0xA4F9,
	0xA4DD,
	0xA4DE,
	0xA4F4,
	0xA4F5,
	0xA4F6,
	0xA4EA,
	0xA4E7,
	0xA4EC,
	0xA4E4,
	0xA4E3,
	0xA4FE,
	0xA4FF,
	0x20B6,
	0x1F512,
	0x1F50F,
	0x2227,
	0x2A51,
	0x2A5E,
	0x2A60,
	0x2A5C,
	0x2A5A,
	0x2A5F,
	0x2228,
	0x2A59,
	0x2A52,
	0x2A62,
	0x2A63,
	0x2A5D,
	0x2A5B,
	0x1F36D,
	0x2AE6,
	0x27CC,
	0x27F7,
	0x27FA,
	0x27DE,
	0x27F5,
	0x27FB,
	0x27F8,
	0x27FD,
	0x2B33,
	0x27DD,
	0x27F6,
	0x27FC,
	0x27F9,
	0x27FE,
	0x27FF,
	0x1F62D,
	0x1F3E9,
	0x1F48C,
	0x204E,
	0x1F505,
	0x301F,
	0x005F,
	0x2703,
	0x2585,
	0x2584,
	0x25E1,
	0x25DB,
	0x25DF,
	0x293F,
	0x25FA,
	0x2581,
	0x2582,
	0x27D3,
	0x274F,
	0x270E,
	0x25DE,
	0x293E,
	0x2751,
	0x25FF,
	0x2587,
	0x2583,
	0x2586,
	0x25CA,
	0x27E0,
	0x10280,
	0x10299,
	0x10282,
	0x10283,
	0x10285,
	0x10281,
	0x1029A,
	0x10284,
	0x1029B,
	0x10286,
	0x1028A,
	0x1028B,
	0x10294,
	0x1028D,
	0x1028E,
	0x10290,
	0x1028F,
	0x10291,
	0x10293,
	0x1028C,
	0x10295,
	0x10296,
	0x10297,
	0x10289,
	0x10298,
	0x10292,
	0x10287,
	0x1029C,
	0x10288,
	0x10920,
	0x10935,
	0x10921,
	0x10939,
	0x10923,
	0x10924,
	0x10936,
	0x10931,
	0x10922,
	0x10926,
	0x10928,
	0x10929,
	0x10937,
	0x1092A,
	0x1092B,
	0x10938,
	0x1092C,
	0x10932,
	0x1092D,
	0x10933,
	0x1092E,
	0x1092F,
	0x10934,
	0x10930,
	0x10925,
	0x10927,
	0x1093F,
	0x00AF,
	0x1F028,
	0x1F02B,
	0x1F024,
	0x1F025,
	0x1F000,
	0x1F017,
	0x1F00E,
	0x1F020,
	0x1F014,
	0x1F00B,
	0x1F01D,
	0x1F013,
	0x1F00A,
	0x1F01C,
	0x1F005,
	0x1F02A,
	0x1F018,
	0x1F00F,
	0x1F021,
	0x1F003,
	0x1F010,
	0x1F007,
	0x1F019,
	0x1F023,
	0x1F022,
	0x1F004,
	0x1F016,
	0x1F00D,
	0x1F01F,
	0x1F015,
	0x1F00C,
	0x1F01E,
	0x1F001,
	0x1F026,
	0x1F027,
	0x1F012,
	0x1F009,
	0x1F01B,
	0x1F011,
	0x1F008,
	0x1F01A,
	0x1F002,
	0x1F006,
	0x1F029,
	0x0D57,
	0x0D79,
	0x0D6E,
	0x0D6B,
	0x0D6A,
	0x0D6F,
	0x0D67,
	0x0D6D,
	0x0D6C,
	0x0D69,
	0x0D68,
	0x0D66,
	0x0D74,
	0x0D73,
	0x0D75,
	0x0D05,
	0x0D06,
	0x0D10,
	0x0D14,
	0x0D2C,
	0x0D2D,
	0x0D1A,
	0x0D1B,
	0x0D7F,
	0x0D7D,
	0x0D7E,
	0x0D7B,
	0x0D7A,
	0x0D7C,
	0x0D26,
	0x0D21,
	0x0D22,
	0x0D27,
	0x0D4E,
	0x0D0E,
	0x0D0F,
	0x0D17,
	0x0D18,
	0x0D39,
	0x0D07,
	0x0D08,
	0x0D1C,
	0x0D1D,
	0x0D15,
	0x0D16,
	0x0D32,
	0x0D33,
	0x0D34,
	0x0D2E,
	0x0D28,
	0x0D19,
	0x0D23,
	0x0D29,
	0x0D1E,
	0x0D12,
	0x0D13,
	0x0D2A,
	0x0D2B,
	0x0D30,
	0x0D31,
	0x0D38,
	0x0D36,
	0x0D37,
	0x0D24,
	0x0D25,
	0x0D1F,
	0x0D20,
	0x0D3A,
	0x0D09,
	0x0D0A,
	0x0D35,
	0x0D0C,
	0x0D61,
	0x0D0B,
	0x0D60,
	0x0D2F,
	0x0D71,
	0x0D72,
	0x0D70,
	0x0D02,
	0x0D3D,
	0x0D4D,
	0x0D03,
	0x0D3E,
	0x0D48,
	0x0D4C,
	0x0D46,
	0x0D47,
	0x0D3F,
	0x0D40,
	0x0D4A,
	0x0D4B,
	0x0D41,
	0x0D42,
	0x0D62,
	0x0D63,
	0x0D43,
	0x0D44,
	0x26A5,
	0x2642,
	0x26A7,
	0x26A6,
	0x2720,
	0x1F468,
	0x1F46B,
	0x1F472,
	0x1F473,
	0x0859,
	0x085B,
	0x0841,
	0x0843,
	0x0842,
	0x0844,
	0x0858,
	0x084A,
	0x0849,
	0x084B,
	0x084C,
	0x084D,
	0x0850,
	0x0852,
	0x0853,
	0x084E,
	0x0854,
	0x0851,
	0x0855,
	0x0848,
	0x0846,
	0x0856,
	0x0840,
	0x084F,
	0x0847,
	0x0857,
	0x0845,
	0x085E,
	0x085A,
	0x1F45E,
	0x26EF,
	0x1F341,
	0x26AD,
	0x00BA,
	0x303C,
	0x1D400,
	0x1D6A8,
	0x1D401,
	0x1D6A9,
	0x1D402,
	0x1D6BE,
	0x1D403,
	0x1D6AB,
	0x1D7CA,
	0x1D404,
	0x1D6AC,
	0x1D6AE,
	0x1D405,
	0x1D406,
	0x1D6AA,
	0x1D407,
	0x1D408,
	0x1D6B0,
	0x1D409,
	0x1D40A,
	0x1D6B1,
	0x1D40B,
	0x1D6B2,
	0x1D40C,
	0x1D6B3,
	0x1D40D,
	0x1D6B4,
	0x1D40E,
	0x1D6C0,
	0x1D6B6,
	0x1D40F,
	0x1D6BD,
	0x1D6B7,
	0x1D6BF,
	0x1D410,
	0x1D411,
	0x1D6B8,
	0x1D412,
	0x1D6BA,
	0x1D413,
	0x1D6BB,
	0x1D6AF,
	0x1D6B9,
	0x1D414,
	0x1D6BC,
	0x1D415,
	0x1D416,
	0x1D417,
	0x1D6B5,
	0x1D418,
	0x1D419,
	0x1D6AD,
	0x1D7D6,
	0x1D7D3,
	0x1D7D2,
	0x1D7D7,
	0x1D7CF,
	0x1D7D5,
	0x1D7D4,
	0x1D7D1,
	0x1D7D0,
	0x1D7CE,
	0x1D6DC,
	0x1D56C,
	0x1D56D,
	0x1D56E,
	0x1D56F,
	0x1D570,
	0x1D571,
	0x1D572,
	0x1D573,
	0x1D574,
	0x1D575,
	0x1D576,
	0x1D577,
	0x1D578,
	0x1D579,
	0x1D57A,
	0x1D57B,
	0x1D57C,
	0x1D57D,
	0x1D57E,
	0x1D57F,
	0x1D580,
	0x1D581,
	0x1D582,
	0x1D583,
	0x1D584,
	0x1D585,
	0x1D586,
	0x1D587,
	0x1D588,
	0x1D589,
	0x1D58A,
	0x1D58B,
	0x1D58C,
	0x1D58D,
	0x1D58E,
	0x1D58F,
	0x1D590,
	0x1D591,
	0x1D592,
	0x1D593,
	0x1D594,
	0x1D595,
	0x1D596,
	0x1D597,
	0x1D598,
	0x1D599,
	0x1D59A,
	0x1D59B,
	0x1D59C,
	0x1D59D,
	0x1D59E,
	0x1D59F,
	0x1D468,
	0x1D71C,
	0x1D469,
	0x1D71D,
	0x1D46A,
	0x1D732,
	0x1D46B,
	0x1D71F,
	0x1D46C,
	0x1D720,
	0x1D722,
	0x1D46D,
	0x1D46E,
	0x1D71E,
	0x1D46F,
	0x1D470,
	0x1D724,
	0x1D471,
	0x1D472,
	0x1D725,
	0x1D473,
	0x1D726,
	0x1D474,
	0x1D727,
	0x1D475,
	0x1D728,
	0x1D476,
	0x1D734,
	0x1D72A,
	0x1D477,
	0x1D731,
	0x1D72B,
	0x1D733,
	0x1D478,
	0x1D479,
	0x1D72C,
	0x1D47A,
	0x1D72E,
	0x1D47B,
	0x1D72F,
	0x1D723,
	0x1D72D,
	0x1D47C,
	0x1D730,
	0x1D47D,
	0x1D47E,
	0x1D47F,
	0x1D729,
	0x1D480,
	0x1D481,
	0x1D721,
	0x1D750,
	0x1D752,
	0x1D735,
	0x1D74F,
	0x1D753,
	0x1D755,
	0x1D754,
	0x1D482,
	0x1D736,
	0x1D483,
	0x1D737,
	0x1D484,
	0x1D74C,
	0x1D485,
	0x1D739,
	0x1D486,
	0x1D73A,
	0x1D73C,
	0x1D487,
	0x1D747,
	0x1D488,
	0x1D738,
	0x1D489,
	0x1D48A,
	0x1D73E,
	0x1D48B,
	0x1D48C,
	0x1D73F,
	0x1D48D,
	0x1D740,
	0x1D48E,
	0x1D741,
	0x1D48F,
	0x1D742,
	0x1D490,
	0x1D74E,
	0x1D744,
	0x1D491,
	0x1D74B,
	0x1D745,
	0x1D74D,
	0x1D492,
	0x1D493,
	0x1D746,
	0x1D494,
	0x1D748,
	0x1D495,
	0x1D749,
	0x1D73D,
	0x1D496,
	0x1D74A,
	0x1D497,
	0x1D498,
	0x1D499,
	0x1D743,
	0x1D49A,
	0x1D49B,
	0x1D73B,
	0x1D751,
	0x1D6DE,
	0x1D6C1,
	0x1D6DB,
	0x1D6DF,
	0x1D6E1,
	0x1D6E0,
	0x1D4D0,
	0x1D4D1,
	0x1D4D2,
	0x1D4D3,
	0x1D4D4,
	0x1D4D5,
	0x1D4D6,
	0x1D4D7,
	0x1D4D8,
	0x1D4D9,
	0x1D4DA,
	0x1D4DB,
	0x1D4DC,
	0x1D4DD,
	0x1D4DE,
	0x1D4DF,
	0x1D4E0,
	0x1D4E1,
	0x1D4E2,
	0x1D4E3,
	0x1D4E4,
	0x1D4E5,
	0x1D4E6,
	0x1D4E7,
	0x1D4E8,
	0x1D4E9,
	0x1D4EA,
	0x1D4EB,
	0x1D4EC,
	0x1D4ED,
	0x1D4EE,
	0x1D4EF,
	0x1D4F0,
	0x1D4F1,
	0x1D4F2,
	0x1D4F3,
	0x1D4F4,
	0x1D4F5,
	0x1D4F6,
	0x1D4F7,
	0x1D4F8,
	0x1D4F9,
	0x1D4FA,
	0x1D4FB,
	0x1D4FC,
	0x1D4FD,
	0x1D4FE,
	0x1D4FF,
	0x1D500,
	0x1D501,
	0x1D502,
	0x1D503,
	0x1D41A,
	0x1D6C2,
	0x1D41B,
	0x1D6C3,
	0x1D41C,
	0x1D6D8,
	0x1D41D,
	0x1D6C5,
	0x1D7CB,
	0x1D41E,
	0x1D6C6,
	0x1D6C8,
	0x1D41F,
	0x1D6D3,
	0x1D420,
	0x1D6C4,
	0x1D421,
	0x1D422,
	0x1D6CA,
	0x1D423,
	0x1D424,
	0x1D6CB,
	0x1D425,
	0x1D6CC,
	0x1D426,
	0x1D6CD,
	0x1D427,
	0x1D6CE,
	0x1D428,
	0x1D6DA,
	0x1D6D0,
	0x1D429,
	0x1D6D7,
	0x1D6D1,
	0x1D6D9,
	0x1D42A,
	0x1D42B,
	0x1D6D2,
	0x1D42C,
	0x1D6D4,
	0x1D42D,
	0x1D6D5,
	0x1D6C9,
	0x1D42E,
	0x1D6D6,
	0x1D42F,
	0x1D430,
	0x1D431,
	0x1D6CF,
	0x1D432,
	0x1D433,
	0x1D6C7,
	0x1D6DD,
	0x1D538,
	0x1D539,
	0x1D53B,
	0x1D53C,
	0x1D53D,
	0x1D53E,
	0x1D540,
	0x1D541,
	0x1D542,
	0x1D543,
	0x1D544,
	0x1D546,
	0x1D54A,
	0x1D54B,
	0x1D54C,
	0x1D54D,
	0x1D54E,
	0x1D54F,
	0x1D550,
	0x1D7E0,
	0x1D7DD,
	0x1D7DC,
	0x1D7E1,
	0x1D7D9,
	0x1D7DF,
	0x1D7DE,
	0x1D7DB,
	0x1D7DA,
	0x1D7D8,
	0x1D552,
	0x1D553,
	0x1D554,
	0x1D555,
	0x1D556,
	0x1D557,
	0x1D558,
	0x1D559,
	0x1D55A,
	0x1D55B,
	0x1D55C,
	0x1D55D,
	0x1D55E,
	0x1D55F,
	0x1D560,
	0x1D561,
	0x1D562,
	0x1D563,
	0x1D564,
	0x1D565,
	0x1D566,
	0x1D567,
	0x1D568,
	0x1D569,
	0x1D56A,
	0x1D56B,
	0x27CD,
	0x1D504,
	0x1D505,
	0x1D507,
	0x1D508,
	0x1D509,
	0x1D50A,
	0x1D50D,
	0x1D50E,
	0x1D50F,
	0x1D510,
	0x1D511,
	0x1D512,
	0x1D513,
	0x1D514,
	0x1D516,
	0x1D517,
	0x1D518,
	0x1D519,
	0x1D51A,
	0x1D51B,
	0x1D51C,
	0x1D51E,
	0x1D51F,
	0x1D520,
	0x1D521,
	0x1D522,
	0x1D523,
	0x1D524,
	0x1D525,
	0x1D526,
	0x1D527,
	0x1D528,
	0x1D529,
	0x1D52A,
	0x1D52B,
	0x1D52C,
	0x1D52D,
	0x1D52E,
	0x1D52F,
	0x1D530,
	0x1D531,
	0x1D532,
	0x1D533,
	0x1D534,
	0x1D535,
	0x1D536,
	0x1D537,
	0x1D434,
	0x1D6E2,
	0x1D435,
	0x1D6E3,
	0x1D436,
	0x1D6F8,
	0x1D437,
	0x1D6E5,
	0x1D438,
	0x1D6E6,
	0x1D6E8,
	0x1D439,
	0x1D43A,
	0x1D6E4,
	0x1D43B,
	0x1D43C,
	0x1D6EA,
	0x1D43D,
	0x1D43E,
	0x1D6EB,
	0x1D43F,
	0x1D6EC,
	0x1D440,
	0x1D6ED,
	0x1D441,
	0x1D6EE,
	0x1D442,
	0x1D6FA,
	0x1D6F0,
	0x1D443,
	0x1D6F7,
	0x1D6F1,
	0x1D6F9,
	0x1D444,
	0x1D445,
	0x1D6F2,
	0x1D446,
	0x1D6F4,
	0x1D447,
	0x1D6F5,
	0x1D6E9,
	0x1D6F3,
	0x1D448,
	0x1D6F6,
	0x1D449,
	0x1D44A,
	0x1D44B,
	0x1D6EF,
	0x1D44C,
	0x1D44D,
	0x1D6E7,
	0x1D716,
	0x1D718,
	0x1D6FB,
	0x1D715,
	0x1D719,
	0x1D71B,
	0x1D71A,
	0x1D44E,
	0x1D6FC,
	0x1D44F,
	0x1D6FD,
	0x1D450,
	0x1D712,
	0x1D451,
	0x1D6FF,
	0x1D6A4,
	0x1D6A5,
	0x1D452,
	0x1D700,
	0x1D702,
	0x1D453,
	0x1D70D,
	0x1D454,
	0x1D6FE,
	0x1D456,
	0x1D704,
	0x1D457,
	0x1D458,
	0x1D705,
	0x1D459,
	0x1D706,
	0x1D45A,
	0x1D707,
	0x1D45B,
	0x1D708,
	0x1D45C,
	0x1D714,
	0x1D70A,
	0x1D45D,
	0x1D711,
	0x1D70B,
	0x1D713,
	0x1D45E,
	0x1D45F,
	0x1D70C,
	0x1D460,
	0x1D70E,
	0x1D461,
	0x1D70F,
	0x1D703,
	0x1D462,
	0x1D710,
	0x1D463,
	0x1D464,
	0x1D465,
	0x1D709,
	0x1D466,
	0x1D467,
	0x1D701,
	0x1D717,
	0x27E8,
	0x27EA,
	0x27EE,
	0x27E6,
	0x27EC,
	0x1D670,
	0x1D671,
	0x1D672,
	0x1D673,
	0x1D674,
	0x1D675,
	0x1D676,
	0x1D677,
	0x1D678,
	0x1D679,
	0x1D67A,
	0x1D67B,
	0x1D67C,
	0x1D67D,
	0x1D67E,
	0x1D67F,
	0x1D680,
	0x1D681,
	0x1D682,
	0x1D683,
	0x1D684,
	0x1D685,
	0x1D686,
	0x1D687,
	0x1D688,
	0x1D689,
	0x1D7FE,
	0x1D7FB,
	0x1D7FA,
	0x1D7FF,
	0x1D7F7,
	0x1D7FD,
	0x1D7FC,
	0x1D7F9,
	0x1D7F8,
	0x1D7F6,
	0x1D68A,
	0x1D68B,
	0x1D68C,
	0x1D68D,
	0x1D68E,
	0x1D68F,
	0x1D690,
	0x1D691,
	0x1D692,
	0x1D693,
	0x1D694,
	0x1D695,
	0x1D696,
	0x1D697,
	0x1D698,
	0x1D699,
	0x1D69A,
	0x1D69B,
	0x1D69C,
	0x1D69D,
	0x1D69E,
	0x1D69F,
	0x1D6A0,
	0x1D6A1,
	0x1D6A2,
	0x1D6A3,
	0x27E9,
	0x27EB,
	0x27EF,
	0x27E7,
	0x27ED,
	0x27CB,
	0x1D5D4,
	0x1D756,
	0x1D5D5,
	0x1D757,
	0x1D5D6,
	0x1D76C,
	0x1D5D7,
	0x1D759,
	0x1D5D8,
	0x1D75A,
	0x1D75C,
	0x1D5D9,
	0x1D5DA,
	0x1D758,
	0x1D5DB,
	0x1D5DC,
	0x1D75E,
	0x1D5DD,
	0x1D5DE,
	0x1D75F,
	0x1D5DF,
	0x1D760,
	0x1D5E0,
	0x1D761,
	0x1D5E1,
	0x1D762,
	0x1D5E2,
	0x1D76E,
	0x1D764,
	0x1D5E3,
	0x1D76B,
	0x1D765,
	0x1D76D,
	0x1D5E4,
	0x1D5E5,
	0x1D766,
	0x1D5E6,
	0x1D768,
	0x1D5E7,
	0x1D769,
	0x1D75D,
	0x1D767,
	0x1D5E8,
	0x1D76A,
	0x1D5E9,
	0x1D5EA,
	0x1D5EB,
	0x1D763,
	0x1D5EC,
	0x1D5ED,
	0x1D75B,
	0x1D7F4,
	0x1D7F1,
	0x1D7F0,
	0x1D7F5,
	0x1D7ED,
	0x1D7F3,
	0x1D7F2,
	0x1D7EF,
	0x1D7EE,
	0x1D7EC,
	0x1D78A,
	0x1D63C,
	0x1D790,
	0x1D63D,
	0x1D791,
	0x1D63E,
	0x1D7A6,
	0x1D63F,
	0x1D793,
	0x1D640,
	0x1D794,
	0x1D796,
	0x1D641,
	0x1D642,
	0x1D792,
	0x1D643,
	0x1D644,
	0x1D798,
	0x1D645,
	0x1D646,
	0x1D799,
	0x1D647,
	0x1D79A,
	0x1D648,
	0x1D79B,
	0x1D649,
	0x1D79C,
	0x1D64A,
	0x1D7A8,
	0x1D79E,
	0x1D64B,
	0x1D7A5,
	0x1D79F,
	0x1D7A7,
	0x1D64C,
	0x1D64D,
	0x1D7A0,
	0x1D64E,
	0x1D7A2,
	0x1D64F,
	0x1D7A3,
	0x1D797,
	0x1D7A1,
	0x1D650,
	0x1D7A4,
	0x1D651,
	0x1D652,
	0x1D653,
	0x1D79D,
	0x1D654,
	0x1D655,
	0x1D795,
	0x1D7C4,
	0x1D7C6,
	0x1D7A9,
	0x1D7C3,
	0x1D7C7,
	0x1D7C9,
	0x1D7C8,
	0x1D656,
	0x1D7AA,
	0x1D657,
	0x1D7AB,
	0x1D658,
	0x1D7C0,
	0x1D659,
	0x1D7AD,
	0x1D65A,
	0x1D7AE,
	0x1D7B0,
	0x1D65B,
	0x1D7BB,
	0x1D65C,
	0x1D7AC,
	0x1D65D,
	0x1D65E,
	0x1D7B2,
	0x1D65F,
	0x1D660,
	0x1D7B3,
	0x1D661,
	0x1D7B4,
	0x1D662,
	0x1D7B5,
	0x1D663,
	0x1D7B6,
	0x1D664,
	0x1D7C2,
	0x1D7B8,
	0x1D665,
	0x1D7BF,
	0x1D7B9,
	0x1D7C1,
	0x1D666,
	0x1D667,
	0x1D7BA,
	0x1D668,
	0x1D7BC,
	0x1D669,
	0x1D7BD,
	0x1D7B1,
	0x1D66A,
	0x1D7BE,
	0x1D66B,
	0x1D66C,
	0x1D66D,
	0x1D7B7,
	0x1D66E,
	0x1D66F,
	0x1D7AF,
	0x1D7C5,
	0x1D78C,
	0x1D76F,
	0x1D789,
	0x1D78D,
	0x1D78F,
	0x1D78E,
	0x1D5EE,
	0x1D770,
	0x1D5EF,
	0x1D771,
	0x1D5F0,
	0x1D786,
	0x1D5F1,
	0x1D773,
	0x1D5F2,
	0x1D774,
	0x1D776,
	0x1D5F3,
	0x1D781,
	0x1D5F4,
	0x1D772,
	0x1D5F5,
	0x1D5F6,
	0x1D778,
	0x1D5F7,
	0x1D5F8,
	0x1D779,
	0x1D5F9,
	0x1D77A,
	0x1D5FA,
	0x1D77B,
	0x1D5FB,
	0x1D77C,
	0x1D5FC,
	0x1D788,
	0x1D77E,
	0x1D5FD,
	0x1D785,
	0x1D77F,
	0x1D787,
	0x1D5FE,
	0x1D5FF,
	0x1D780,
	0x1D600,
	0x1D782,
	0x1D601,
	0x1D783,
	0x1D777,
	0x1D602,
	0x1D784,
	0x1D603,
	0x1D604,
	0x1D605,
	0x1D77D,
	0x1D606,
	0x1D607,
	0x1D775,
	0x1D78B,
	0x1D5A0,
	0x1D5A1,
	0x1D5A2,
	0x1D5A3,
	0x1D5A4,
	0x1D5A5,
	0x1D5A6,
	0x1D5A7,
	0x1D5A8,
	0x1D5A9,
	0x1D5AA,
	0x1D5AB,
	0x1D5AC,
	0x1D5AD,
	0x1D5AE,
	0x1D5AF,
	0x1D5B0,
	0x1D5B1,
	0x1D5B2,
	0x1D5B3,
	0x1D5B4,
	0x1D5B5,
	0x1D5B6,
	0x1D5B7,
	0x1D5B8,
	0x1D5B9,
	0x1D7EA,
	0x1D7E7,
	0x1D7E6,
	0x1D7EB,
	0x1D7E3,
	0x1D7E9,
	0x1D7E8,
	0x1D7E5,
	0x1D7E4,
	0x1D7E2,
	0x1D608,
	0x1D609,
	0x1D60A,
	0x1D60B,
	0x1D60C,
	0x1D60D,
	0x1D60E,
	0x1D60F,
	0x1D610,
	0x1D611,
	0x1D612,
	0x1D613,
	0x1D614,
	0x1D615,
	0x1D616,
	0x1D617,
	0x1D618,
	0x1D619,
	0x1D61A,
	0x1D61B,
	0x1D61C,
	0x1D61D,
	0x1D61E,
	0x1D61F,
	0x1D620,
	0x1D621,
	0x1D622,
	0x1D623,
	0x1D624,
	0x1D625,
	0x1D626,
	0x1D627,
	0x1D628,
	0x1D629,
	0x1D62A,
	0x1D62B,
	0x1D62C,
	0x1D62D,
	0x1D62E,
	0x1D62F,
	0x1D630,
	0x1D631,
	0x1D632,
	0x1D633,
	0x1D634,
	0x1D635,
	0x1D636,
	0x1D637,
	0x1D638,
	0x1D639,
	0x1D63A,
	0x1D63B,
	0x1D5BA,
	0x1D5BB,
	0x1D5BC,
	0x1D5BD,
	0x1D5BE,
	0x1D5BF,
	0x1D5C0,
	0x1D5C1,
	0x1D5C2,
	0x1D5C3,
	0x1D5C4,
	0x1D5C5,
	0x1D5C6,
	0x1D5C7,
	0x1D5C8,
	0x1D5C9,
	0x1D5CA,
	0x1D5CB,
	0x1D5CC,
	0x1D5CD,
	0x1D5CE,
	0x1D5CF,
	0x1D5D0,
	0x1D5D1,
	0x1D5D2,
	0x1D5D3,
	0x1D49C,
	0x1D49E,
	0x1D49F,
	0x1D4A2,
	0x1D4A5,
	0x1D4A6,
	0x1D4A9,
	0x1D4AA,
	0x1D4AB,
	0x1D4AC,
	0x1D4AE,
	0x1D4AF,
	0x1D4B0,
	0x1D4B1,
	0x1D4B2,
	0x1D4B3,
	0x1D4B4,
	0x1D4B5,
	0x1D4B6,
	0x1D4B7,
	0x1D4B8,
	0x1D4B9,
	0x1D4BB,
	0x1D4BD,
	0x1D4BE,
	0x1D4BF,
	0x1D4C0,
	0x1D4C1,
	0x1D4C2,
	0x1D4C3,
	0x1D4C5,
	0x1D4C6,
	0x1D4C7,
	0x1D4C8,
	0x1D4C9,
	0x1D4CA,
	0x1D4CB,
	0x1D4CC,
	0x1D4CD,
	0x1D4CE,
	0x1D4CF,
	0x2221,
	0x299B,
	0x29AB,
	0x29AA,
	0x29AF,
	0x29AD,
	0x29AE,
	0x29AC,
	0x29A9,
	0x29A8,
	0x225E,
	0x299D,
	0x1F356,
	0x26AB,
	0x276A,
	0x276B,
	0x2774,
	0x2768,
	0x276C,
	0x205F,
	0x2775,
	0x2769,
	0x276D,
	0x2592,
	0x26AC,
	0x2759,
	0x26AA,
	0xAAF1,
	0xAAF2,
	0xABED,
	0xAAF0,
	0xABEB,
	0xABF8,
	0xABF5,
	0xABF4,
	0xABF9,
	0xABF1,
	0xABF7,
	0xABF6,
	0xABF3,
	0xABF2,
	0xABF0,
	0xABD1,
	0xABD5,
	0xABDA,
	0xAAE2,
	0xABC6,
	0xAAE6,
	0xAAE7,
	0xABD9,
	0xABD7,
	0xAAE0,
	0xABD8,
	0xABD2,
	0xABCD,
	0xABCF,
	0xABE2,
	0xABD3,
	0xABD6,
	0xABC8,
	0xABC0,
	0xABDB,
	0xABC2,
	0xABDC,
	0xABC3,
	0xABDD,
	0xABC5,
	0xABDF,
	0xABC9,
	0xABE1,
	0xAAE8,
	0xAAE3,
	0xAAE1,
	0xABC4,
	0xABDE,
	0xABD0,
	0xABD4,
	0xABC1,
	0xAAE9,
	0xAAEA,
	0xABCA,
	0xABC7,
	0xABE0,
	0xAAE4,
	0xAAE5,
	0xABCE,
	0xABCB,
	0xABCC,
	0xABEC,
	0xAAF3,
	0xAAF6,
	0xAAED,
	0xAAEF,
	0xABE5,
	0xAAEE,
	0xABE9,
	0xAAEB,
	0xABE4,
	0xABEA,
	0xABE3,
	0xABE7,
	0xABE8,
	0xAAEC,
	0xAAF5,
	0xABE6,
	0xAAF4,
	0x1F348,
	0x1F4DD,
	0x1F6B9,
	0x263F,
	0x109A0,
	0x109B0,
	0x109A6,
	0x109B7,
	0x109A1,
	0x109AE,
	0x109A2,
	0x109B2,
	0x109AD,
	0x109AC,
	0x109A8,
	0x109A9,
	0x109AA,
	0x109A3,
	0x109A7,
	0x109B3,
	0x109AB,
	0x109AF,
	0x109B1,
	0x109B4,
	0x109B5,
	0x109B6,
	0x109A5,
	0x109A4,
	0x109BF,
	0x109BE,
	0x10980,
	0x10986,
	0x1099D,
	0x10981,
	0x10992,
	0x10982,
	0x10996,
	0x10991,
	0x10990,
	0x10989,
	0x1098A,
	0x1098C,
	0x10983,
	0x10988,
	0x10997,
	0x1098E,
	0x10993,
	0x10995,
	0x10998,
	0x1099A,
	0x1099C,
	0x10985,
	0x10984,
	0x1099E,
	0x23D1,
	0x23D2,
	0x23D4,
	0x23D9,
	0x23D3,
	0x23D8,
	0x23D7,
	0x23D6,
	0x23D5,
	0x1F687,
	0x16F43,
	0x16F06,
	0x16F13,
	0x16F25,
	0x16F3F,
	0x16F01,
	0x16F0B,
	0x16F0F,
	0x16F1B,
	0x16F1D,
	0x16F38,
	0x16F2F,
	0x16F2B,
	0x16F07,
	0x16F1F,
	0x16F28,
	0x16F29,
	0x16F26,
	0x16F44,
	0x16F1E,
	0x16F16,
	0x16F18,
	0x16F19,
	0x16F17,
	0x16F04,
	0x16F05,
	0x16F10,
	0x16F50,
	0x16F23,
	0x16F24,
	0x16F11,
	0x16F14,
	0x16F15,
	0x16F2C,
	0x16F2D,
	0x16F00,
	0x16F03,
	0x16F21,
	0x16F22,
	0x16F32,
	0x16F3A,
	0x16F33,
	0x16F34,
	0x16F0A,
	0x16F1A,
	0x16F1C,
	0x16F37,
	0x16F2E,
	0x16F2A,
	0x16F0E,
	0x16F08,
	0x16F09,
	0x16F42,
	0x16F27,
	0x16F31,
	0x16F20,
	0x16F12,
	0x16F02,
	0x16F0D,
	0x16F39,
	0x16F30,
	0x16F0C,
	0x16F3B,
	0x16F35,
	0x16F3C,
	0x16F36,
	0x16F3D,
	0x16F3E,
	0x16F41,
	0x16F40,
	0x16F51,
	0x16F53,
	0x16F52,
	0x16F91,
	0x16F92,
	0x16F8F,
	0x16F90,
	0x16F54,
	0x16F55,
	0x16F73,
	0x16F74,
	0x16F56,
	0x16F79,
	0x16F57,
	0x16F58,
	0x16F7B,
	0x16F5D,
	0x16F7A,
	0x16F5E,
	0x16F5F,
	0x16F77,
	0x16F75,
	0x16F61,
	0x16F62,
	0x16F63,
	0x16F64,
	0x16F66,
	0x16F67,
	0x16F69,
	0x16F65,
	0x16F68,
	0x16F7D,
	0x16F7E,
	0x16F59,
	0x16F60,
	0x16F5A,
	0x16F7C,
	0x16F78,
	0x16F76,
	0x16F6A,
	0x16F6B,
	0x16F6C,
	0x16F6D,
	0x16F6F,
	0x16F70,
	0x16F6E,
	0x16F5C,
	0x16F5B,
	0x16F71,
	0x16F72,
	0x00B5,
	0x1F3A4,
	0x1F52C,
	0x00B7,
	0x22EF,
	0x1F30C,
	0x20A5,
	0x1F690,
	0x1F4BD,
	0x2212,
	0x2A3A,
	0x2A29,
	0x2A2A,
	0x2A2B,
	0x2A2C,
	0x2242,
	0x2213,
	0x29FF,
	0x1F4F1,
	0x1F4F4,
	0x1F4F2,
	0x22A7,
	0x02CA,
	0x02BC,
	0x02F9,
	0x02FB,
	0x1D2C,
	0x1D2D,
	0x1D2E,
	0x1D2F,
	0x1D30,
	0x1D31,
	0x1D33,
	0x1D34,
	0xA7F8,
	0x1D35,
	0x1D36,
	0x1D37,
	0x1D38,
	0x1D39,
	0x1D3A,
	0x1D3C,
	0x1D3D,
	0x1D3E,
	0x1D3F,
	0x1D32,
	0x1D3B,
	0x1D40,
	0x1D41,
	0x2C7D,
	0x1D42,
	0x02D3,
	0x02D2,
	0xA701,
	0xA705,
	0xA707,
	0xA703,
	0xA700,
	0xA704,
	0xA706,
	0xA702,
	0x02C6,
	0xA789,
	0x02DF,
	0x1D78,
	0xA719,
	0xA718,
	0xA717,
	0x02EE,
	0x02BA,
	0x02C5,
	0x02D5,
	0x02FA,
	0x02FC,
	0xA70D,
	0xA708,
	0xA712,
	0x02E5,
	0xA711,
	0xA70C,
	0xA716,
	0x02E9,
	0x10FC,
	0x02C0,
	0x02CB,
	0x02D1,
	0xA70E,
	0xA709,
	0xA713,
	0x02E6,
	0x02C2,
	0x02BF,
	0x02CF,
	0xA788,
	0xA710,
	0xA70B,
	0x02EF,
	0x02CE,
	0xA71F,
	0x02FF,
	0x02F1,
	0xA715,
	0x02CD,
	0x02F2,
	0x02F3,
	0x02F7,
	0x02E8,
	0x02F0,
	0x02CC,
	0xA71A,
	0x02C9,
	0xA70F,
	0xA70A,
	0xA714,
	0x02E7,
	0x02F6,
	0x02F5,
	0x02F4,
	0x02D7,
	0x02FE,
	0x02D6,
	0x02B9,
	0x02F8,
	0xA71C,
	0xA71D,
	0xA71E,
	0xA71B,
	0x02BD,
	0x02C1,
	0x02DE,
	0x02C3,
	0x02BE,
	0x02FD,
	0xA78A,
	0x1D43,
	0x1D5C,
	0x1D45,
	0x1D47,
	0x1DB1,
	0x1D5D,
	0x1D55,
	0x1D9C,
	0x1D9D,
	0x1DA6,
	0x1DA7,
	0x02B6,
	0x1DAB,
	0x1DB0,
	0x1DB8,
	0x1D61,
	0x1D48,
	0x1D5F,
	0x1DA1,
	0x1D49,
	0x1D51,
	0x1DB4,
	0x1D9E,
	0x1DBE,
	0x1DA0,
	0x1D4D,
	0x02E0,
	0x1D5E,
	0x1D60,
	0x02B0,
	0x02B1,
	0x1DA4,
	0x1DA5,
	0x02B2,
	0x1DA8,
	0x1D4F,
	0x02E1,
	0x1DAA,
	0x1DA9,
	0xA7F9,
	0x1D50,
	0x1DAC,
	0x1DAE,
	0x1DAF,
	0x1D52,
	0x1D4B,
	0x1D53,
	0x1D56,
	0x1DB2,
	0x02B3,
	0x02E4,
	0x1D9F,
	0x02E2,
	0x1DB3,
	0x1D4A,
	0x1DA2,
	0x1D59,
	0x1D57,
	0x1DB5,
	0x1DBF,
	0x1D54,
	0x1D44,
	0x1D46,
	0x1D9B,
	0x1DA3,
	0x1D4E,
	0x1D5A,
	0x1DAD,
	0x1D4C,
	0x02B4,
	0x02B5,
	0x1DBA,
	0x1D58,
	0x1DB6,
	0x1DB7,
	0x1D5B,
	0x1DB9,
	0x02B7,
	0x02E3,
	0x02B8,
	0x1DBB,
	0x1DBD,
	0x1DBC,
	0xA720,
	0xA721,
	0x02D0,
	0x02BB,
	0x02ED,
	0x02C4,
	0x02D4,
	0xA770,
	0x02C8,
	0x02EC,
	0x02EB,
	0x02EA,
	0x2A0A,
	0x1F4B0,
	0x1F4B8,
	0x1800,
	0x1804,
	0x1802,
	0x1818,
	0x1815,
	0x1814,
	0x1819,
	0x1811,
	0x1817,
	0x1816,
	0x1813,
	0x1812,
	0x1810,
	0x1801,
	0x1805,
	0x180B,
	0x180D,
	0x180C,
	0x1803,
	0x1820,
	0x1887,
	0x1897,
	0x1880,
	0x1885,
	0x188B,
	0x1891,
	0x18A9,
	0x1882,
	0x188E,
	0x18A6,
	0x18A7,
	0x1888,
	0x1884,
	0x1889,
	0x188A,
	0x188F,
	0x1892,
	0x1893,
	0x1894,
	0x1890,
	0x1886,
	0x188C,
	0x188D,
	0x1883,
	0x1881,
	0x1896,
	0x1895,
	0x1829,
	0x182A,
	0x1834,
	0x1842,
	0x1833,
	0x1821,
	0x1827,
	0x1839,
	0x182D,
	0x183E,
	0x1822,
	0x1835,
	0x183A,
	0x183B,
	0x182F,
	0x1840,
	0x182E,
	0x18A8,
	0x189C,
	0x18A3,
	0x189F,
	0x18A1,
	0x189A,
	0x189D,
	0x18AA,
	0x189B,
	0x18A2,
	0x18A0,
	0x189E,
	0x18A5,
	0x18A4,
	0x1876,
	0x1873,
	0x1874,
	0x1875,
	0x1877,
	0x1828,
	0x1823,
	0x1825,
	0x182B,
	0x182C,
	0x1837,
	0x1830,
	0x1831,
	0x1862,
	0x1871,
	0x1869,
	0x185D,
	0x186B,
	0x1864,
	0x186C,
	0x1865,
	0x186D,
	0x185E,
	0x185F,
	0x186A,
	0x1863,
	0x1866,
	0x1870,
	0x1867,
	0x1868,
	0x186E,
	0x1861,
	0x1860,
	0x186F,
	0x1872,
	0x1832,
	0x1898,
	0x1899,
	0x184A,
	0x184B,
	0x1852,
	0x1851,
	0x185C,
	0x1844,
	0x184E,
	0x1858,
	0x1859,
	0x1845,
	0x1853,
	0x185A,
	0x1857,
	0x1843,
	0x184F,
	0x185B,
	0x1846,
	0x1848,
	0x184C,
	0x184D,
	0x1850,
	0x1854,
	0x1847,
	0x1849,
	0x1856,
	0x1855,
	0x183C,
	0x1824,
	0x1826,
	0x1838,
	0x1836,
	0x183D,
	0x1841,
	0x183F,
	0x1808,
	0x1809,
	0x180A,
	0x1807,
	0x1806,
	0x180E,
	0x1F412,
	0x1F435,
	0x1D300,
	0x268A,
	0x268B,
	0x1F69D,
	0x238D,
	0x1F391,
	0x1F5FB,
	0x26F0,
	0x1F6B5,
	0x1F6A0,
	0x1F69E,
	0x1F401,
	0x1F42D,
	0x1F444,
	0x1F3A5,
	0x1F5FF,
	0x226B,
	0x226A,
	0x22B8,
	0x1F3B6,
	0x00D7,
	0x2A37,
	0x2A34,
	0x2A35,
	0x2A3B,
	0x2A30,
	0x2A31,
	0x2715,
	0x228C,
	0x228D,
	0x228E,
	0x1F344,
	0x266D,
	0x266E,
	0x266F,
	0x1F3B9,
	0x1F3B5,
	0x1F3BC,
	0x1D184,
	0x1D183,
	0x1D173,
	0x1D179,
	0x1D177,
	0x1D175,
	0x1D114,
	0x1D115,
	0x1D112,
	0x1D15C,
	0x1D1B8,
	0x1D1C3,
	0x1D121,
	0x1D113,
	0x1D145,
	0x1D1D7,
	0x1D1D5,
	0x1D15B,
	0x1D15A,
	0x1D10C,
	0x1D17B,
	0x1D181,
	0x1D16D,
	0x1D189,
	0x1D185,
	0x1D18A,
	0x1D1AA,
	0x1D187,
	0x1D1AC,
	0x1D182,
	0x1D17F,
	0x1D180,
	0x1D186,
	0x1D188,
	0x1D1AD,
	0x1D166,
	0x1D17E,
	0x1D17C,
	0x1D165,
	0x1D17D,
	0x1D18B,
	0x1D1AB,
	0x1D134,
	0x1D192,
	0x1D1CF,
	0x1D135,
	0x1D10A,
	0x1D109,
	0x1D1B4,
	0x1D1B5,
	0x1D104,
	0x1D193,
	0x1D1A9,
	0x1D101,
	0x1D12B,
	0x1D12A,
	0x1D160,
	0x1D13E,
	0x1D174,
	0x1D1A8,
	0x1D17A,
	0x1D178,
	0x1D176,
	0x1D122,
	0x1D123,
	0x1D124,
	0x1D110,
	0x1D111,
	0x1D102,
	0x1D11A,
	0x1D12D,
	0x1D12C,
	0x1D191,
	0x1D119,
	0x1D11D,
	0x1D1C0,
	0x1D1BF,
	0x1D11E,
	0x1D11F,
	0x1D120,
	0x1D1B2,
	0x1D1B1,
	0x1D195,
	0x1D194,
	0x1D1D0,
	0x1D1D1,
	0x1D15E,
	0x1D1B0,
	0x1D13C,
	0x1D1A6,
	0x1D198,
	0x1D106,
	0x1D1B7,
	0x1D1C2,
	0x1D1C1,
	0x1D1B6,
	0x1D190,
	0x1D1BB,
	0x1D1BC,
	0x1D1C5,
	0x1D153,
	0x1D152,
	0x1D13A,
	0x1D129,
	0x1D12F,
	0x1D12E,
	0x1D1A7,
	0x1D158,
	0x1D159,
	0x1D164,
	0x1D142,
	0x1D116,
	0x1D136,
	0x1D137,
	0x1D156,
	0x1D1AE,
	0x1D1AF,
	0x1D1DD,
	0x1D18F,
	0x1D144,
	0x1D1D4,
	0x1D1D9,
	0x1D1DA,
	0x1D15F,
	0x1D13D,
	0x1D133,
	0x1D132,
	0x1D138,
	0x1D139,
	0x1D108,
	0x1D103,
	0x1D107,
	0x1D18C,
	0x1D1D6,
	0x1D1DB,
	0x1D10B,
	0x1D1BA,
	0x1D1C4,
	0x1D1B9,
	0x1D1BE,
	0x1D1C6,
	0x1D1BD,
	0x1D131,
	0x1D130,
	0x1D105,
	0x1D100,
	0x1D11B,
	0x1D11C,
	0x1D161,
	0x1D13F,
	0x1D163,
	0x1D141,
	0x1D1D2,
	0x1D147,
	0x1D146,
	0x1D18D,
	0x1D1CB,
	0x1D1CA,
	0x1D1C8,
	0x1D1C7,
	0x1D162,
	0x1D140,
	0x1D118,
	0x1D1D8,
	0x1D1DC,
	0x1D196,
	0x1D14F,
	0x1D14E,
	0x1D14B,
	0x1D14A,
	0x1D14D,
	0x1D14C,
	0x1D149,
	0x1D151,
	0x1D150,
	0x1D148,
	0x1D155,
	0x1D154,
	0x1D197,
	0x1D199,
	0x1D19A,
	0x1D117,
	0x1D1D3,
	0x1D157,
	0x1D15D,
	0x1D13B,
	0x1D1B3,
	0x1D143,
	0x1D18E,
	0x103E,
	0x103C,
	0x103D,
	0x103B,
	0x1060,
	0x105F,
	0x105E,
	0x1082,
	0x1048,
	0x1045,
	0x1044,
	0x1049,
	0x1041,
	0x1047,
	0x1046,
	0x1043,
	0x1042,
	0x1040,
	0x1021,
	0xAA7A,
	0x102A,
	0x1017,
	0x1018,
	0x1005,
	0x1006,
	0x1012,
	0x100D,
	0x100E,
	0x1013,
	0x1027,
	0x1070,
	0x106E,
	0x106F,
	0x1002,
	0x1003,
	0x103F,
	0x101F,
	0x1023,
	0x1024,
	0x1007,
	0x1008,
	0x1000,
	0x1001,
	0xAA61,
	0xAA62,
	0xAA68,
	0xAA69,
	0xAA6A,
	0xAA6F,
	0xAA60,
	0xAA6D,
	0xAA6E,
	0xAA63,
	0xAA64,
	0xAA6B,
	0xAA65,
	0xAA73,
	0xAA6C,
	0xAA66,
	0xAA67,
	0xAA71,
	0xAA72,
	0x101C,
	0x1020,
	0x1019,
	0x105C,
	0x105D,
	0x1028,
	0x105B,
	0x105A,
	0x1014,
	0x1004,
	0x100F,
	0x100A,
	0x1009,
	0x1029,
	0x1015,
	0x1016,
	0x101B,
	0x108E,
	0x101E,
	0x1061,
	0x1050,
	0x1022,
	0x107F,
	0x1078,
	0x107B,
	0x107E,
	0x1077,
	0x1081,
	0x1075,
	0x1076,
	0x107C,
	0x107A,
	0x107D,
	0x1080,
	0x1079,
	0x1051,
	0x1010,
	0x1011,
	0x100B,
	0x100C,
	0x1025,
	0x1026,
	0x1054,
	0x1055,
	0x1052,
	0x1053,
	0x101D,
	0x1066,
	0x1065,
	0x101A,
	0xAA76,
	0xAA74,
	0xAA75,
	0xAA70,
	0x1098,
	0x1095,
	0x1094,
	0x1099,
	0x1091,
	0x1097,
	0x1096,
	0x1093,
	0x1092,
	0x1090,
	0x1036,
	0x103A,
	0x1037,
	0x104A,
	0xAA7B,
	0x104B,
	0x108D,
	0x1039,
	0x1038,
	0x104E,
	0xAA77,
	0xAA78,
	0xAA79,
	0x104D,
	0x104F,
	0x104C,
	0x109F,
	0x109E,
	0x1063,
	0x1064,
	0x102C,
	0x1032,
	0x109C,
	0x109D,
	0x1031,
	0x1035,
	0x1071,
	0x102D,
	0x102E,
	0x1074,
	0x1072,
	0x1073,
	0x1033,
	0x1034,
	0x1062,
	0x1083,
	0x1084,
	0x1085,
	0x1086,
	0x102B,
	0x102F,
	0x1030,
	0x1058,
	0x1059,
	0x1056,
	0x1057,
	0x1067,
	0x1068,
	0x2A00,
	0x2A01,
	0x2A02,
	0x2210,
	0x22C2,
	0x22C0,
	0x22C1,
	0x220F,
	0x2A05,
	0x2A06,
	0x2211,
	0x2A09,
	0x22C3,
	0x2A03,
	0x2A04,
	0x2AFF,
	0x2207,
	0x1F485,
	0x20A6,
	0x1F4DB,
	0x22BC,
	0x202F,
	0x206E,
	0x1F454,
	0x22AF,
	0x24FF,
	0x1F150,
	0x1F151,
	0x1F152,
	0x1F153,
	0x1F154,
	0x1F155,
	0x1F156,
	0x1F157,
	0x1F158,
	0x1F159,
	0x1F15A,
	0x1F15B,
	0x1F15C,
	0x1F15D,
	0x1F15E,
	0x1F15F,
	0x1F160,
	0x1F161,
	0x1F162,
	0x1F163,
	0x1F164,
	0x1F165,
	0x1F166,
	0x1F167,
	0x1F168,
	0x1F169,
	0x24F2,
	0x24EB,
	0x24EF,
	0x24EE,
	0x24F3,
	0x24F1,
	0x24F0,
	0x24ED,
	0x24EC,
	0x24F4,
	0x1F18E,
	0x274E,
	0x1F18B,
	0x1F170,
	0x1F171,
	0x1F172,
	0x1F173,
	0x1F174,
	0x1F175,
	0x1F176,
	0x1F177,
	0x1F178,
	0x1F179,
	0x1F17A,
	0x1F17B,
	0x1F17C,
	0x1F17D,
	0x1F17E,
	0x1F17F,
	0x1F180,
	0x1F181,
	0x1F182,
	0x1F183,
	0x1F184,
	0x1F185,
	0x1F186,
	0x1F187,
	0x1F188,
	0x1F189,
	0x1F18C,
	0x1F18D,
	0x1F18F,
	0x2288,
	0x2289,
	0x2247,
	0x2271,
	0x2275,
	0x2279,
	0x2270,
	0x2274,
	0x2278,
	0x2646,
	0x26B2,
	0x1F610,
	0x1F311,
	0x1F31A,
	0x20AA,
	0x19D8,
	0x19D5,
	0x19D4,
	0x19D9,
	0x19D1,
	0x19D7,
	0x19D6,
	0x19D3,
	0x19D2,
	0x19D0,
	0x19C7,
	0x19C6,
	0x19C5,
	0x19C4,
	0x19C3,
	0x19C2,
	0x19C1,
	0x19A2,
	0x19A1,
	0x199A,
	0x19A0,
	0x1982,
	0x19A6,
	0x199C,
	0x1996,
	0x1990,
	0x1984,
	0x1994,
	0x1995,
	0x1980,
	0x1989,
	0x19AA,
	0x198E,
	0x198F,
	0x1988,
	0x199B,
	0x1983,
	0x19A7,
	0x198A,
	0x19A5,
	0x19A4,
	0x199D,
	0x19A3,
	0x1985,
	0x19A8,
	0x199F,
	0x1999,
	0x1993,
	0x1987,
	0x1997,
	0x1998,
	0x1981,
	0x198C,
	0x19AB,
	0x1991,
	0x1992,
	0x198B,
	0x199E,
	0x1986,
	0x19A9,
	0x198D,
	0x19DE,
	0x19DF,
	0x19DA,
	0x19B1,
	0x19BB,
	0x19B6,
	0x19BA,
	0x19B5,
	0x19B2,
	0x19C0,
	0x19B7,
	0x19B8,
	0x19BE,
	0x19BD,
	0x19B3,
	0x19B9,
	0x19BF,
	0x19B4,
	0x19BC,
	0x19B0,
	0x1F4F0,
	0x2398,
	0x1F303,
	0x07F3,
	0x07EE,
	0x07EF,
	0x07F0,
	0x07F1,
	0x07F2,
	0x07EB,
	0x07EC,
	0x07ED,
	0x07F8,
	0x07C8,
	0x07C5,
	0x07C4,
	0x07C9,
	0x07C1,
	0x07C7,
	0x07C6,
	0x07C3,
	0x07C2,
	0x07C0,
	0x07F9,
	0x07F4,
	0x07FA,
	0x07CA,
	0x07D3,
	0x07D7,
	0x07D8,
	0x07D1,
	0x07CD,
	0x07CB,
	0x07DD,
	0x07DC,
	0x07E4,
	0x07CC,
	0x07D6,
	0x07E9,
	0x07E8,
	0x07EA,
	0x07DE,
	0x07DF,
	0x07E1,
	0x07D2,
	0x07E3,
	0x07E0,
	0x07E2,
	0x07E7,
	0x07D0,
	0x07CF,
	0x07D4,
	0x07D9,
	0x07DA,
	0x07DB,
	0x07D5,
	0x07CE,
	0x07E5,
	0x07E6,
	0x07F5,
	0x07F7,
	0x07F6,
	0x1F6B3,
	0x26D4,
	0x1F6AB,
	0x1F4F5,
	0x1F51E,
	0x1F6B7,
	0x1F6AD,
	0x00A0,
	0x206F,
	0x2011,
	0x1F6B1,
	0x2ADD,
	0x22BD,
	0x22B2,
	0x22B4,
	0x2922,
	0x2197,
	0x2928,
	0x2931,
	0x292E,
	0x2924,
	0x2B08,
	0x21D7,
	0x2B00,
	0xA834,
	0xA831,
	0xA830,
	0xA833,
	0xA832,
	0xA835,
	0xA837,
	0xA839,
	0xA836,
	0xA838,
	0x2921,
	0x2196,
	0x2927,
	0x2932,
	0x21F1,
	0x21B8,
	0x2923,
	0x2B09,
	0x21D6,
	0x2B01,
	0x1F443,
	0x2284,
	0x2285,
	0x2249,
	0x2209,
	0x2244,
	0x237B,
	0x2260,
	0x226D,
	0x226F,
	0x2262,
	0x226E,
	0x22EA,
	0x22EC,
	0x2226,
	0x00AC,
	0x22E2,
	0x22E3,
	0x2241,
	0x22AD,
	0x1F543,
	0x27AF,
	0x27B1,
	0x1F4D3,
	0x1F4D4,
	0x2499,
	0x2492,
	0x2496,
	0x2495,
	0x249A,
	0x2498,
	0x0023,
	0x2497,
	0x2491,
	0x2494,
	0x2493,
	0x249B,
	0x2116,
	0x1F529,
	0xFFFC,
	0x29A7,
	0x29A6,
	0x2447,
	0x2444,
	0x2445,
	0x2446,
	0x2441,
	0x2449,
	0x2448,
	0x244A,
	0x2442,
	0x2440,
	0x2443,
	0x1F419,
	0x1F362,
	0x1F3E2,
	0x169B,
	0x1690,
	0x1681,
	0x168A,
	0x1689,
	0x1687,
	0x1695,
	0x1693,
	0x1699,
	0x1683,
	0x168C,
	0x1698,
	0x1694,
	0x1682,
	0x168B,
	0x168D,
	0x1685,
	0x1691,
	0x1696,
	0x169A,
	0x168F,
	0x1684,
	0x168E,
	0x1688,
	0x1686,
	0x1697,
	0x1692,
	0x169C,
	0x1680,
	0x02DB,
	0x2126,
	0x1F44C,
	0x1C7D,
	0x1C58,
	0x1C55,
	0x1C54,
	0x1C59,
	0x1C51,
	0x1C57,
	0x1C56,
	0x1C53,
	0x1C52,
	0x1C50,
	0x1C79,
	0x1C61,
	0x1C60,
	0x1C62,
	0x1C63,
	0x1C5C,
	0x1C5E,
	0x1C5D,
	0x1C5B,
	0x1C70,
	0x1C71,
	0x1C6F,
	0x1C72,
	0x1C66,
	0x1C67,
	0x1C68,
	0x1C65,
	0x1C5A,
	0x1C5F,
	0x1C6E,
	0x1C64,
	0x1C73,
	0x1C69,
	0x1C75,
	0x1C77,
	0x1C74,
	0x1C76,
	0x1C6A,
	0x1C6B,
	0x1C6C,
	0x1C6D,
	0x1C78,
	0x1C7A,
	0x1C7C,
	0x1C7F,
	0x1C7E,
	0x1C7B,
	0x10300,
	0x10301,
	0x1031C,
	0x10303,
	0x10304,
	0x1031A,
	0x10317,
	0x1030B,
	0x1030C,
	0x1030D,
	0x10313,
	0x1031B,
	0x10314,
	0x1030E,
	0x10307,
	0x10309,
	0x1031D,
	0x1030A,
	0x10302,
	0x10319,
	0x10312,
	0x1030F,
	0x10310,
	0x10318,
	0x10311,
	0x10315,
	0x10308,
	0x10316,
	0x1031E,
	0x10305,
	0x10306,
	0x10323,
	0x10321,
	0x10320,
	0x10322,
	0x103D5,
	0x103D1,
	0x103D3,
	0x103D4,
	0x103D2,
	0x103A0,
	0x103C8,
	0x103CA,
	0x103B2,
	0x103CE,
	0x103CF,
	0x103A8,
	0x103AD,
	0x103CC,
	0x103AE,
	0x103AF,
	0x103B3,
	0x103A5,
	0x103A6,
	0x103C3,
	0x103A1,
	0x103A9,
	0x103AA,
	0x103A3,
	0x103A4,
	0x103BE,
	0x103B6,
	0x103B7,
	0x103B8,
	0x103B4,
	0x103B5,
	0x103B1,
	0x103BC,
	0x103BD,
	0x103BF,
	0x103C1,
	0x103C2,
	0x103AB,
	0x103B0,
	0x103AC,
	0x103A2,
	0x103BA,
	0x103BB,
	0x103A7,
	0x103CB,
	0x103B9,
	0x103C0,
	0x103D0,
	0x10A71,
	0x10A72,
	0x10A68,
	0x10A75,
	0x10A73,
	0x10A79,
	0x10A70,
	0x10A76,
	0x10A74,
	0x10A60,
	0x10A62,
	0x10A6B,
	0x10A6D,
	0x10A61,
	0x10A63,
	0x10A6C,
	0x10A64,
	0x10A67,
	0x10A6E,
	0x10A6F,
	0x10A6A,
	0x10A66,
	0x10A69,
	0x10A77,
	0x10A7B,
	0x10A7C,
	0x10A65,
	0x10A7A,
	0x10A78,
	0x10A7E,
	0x10A7D,
	0x10A7F,
	0x10C00,
	0x10C09,
	0x10C11,
	0x10C0B,
	0x10C13,
	0x10C0F,
	0x10C1A,
	0x10C20,
	0x10C24,
	0x10C3C,
	0x10C3E,
	0x10C45,
	0x10C18,
	0x10C0D,
	0x10C1E,
	0x10C23,
	0x10C34,
	0x10C3A,
	0x10C3D,
	0x10C3F,
	0x10C43,
	0x10C16,
	0x10C48,
	0x10C32,
	0x10C21,
	0x10C22,
	0x10C28,
	0x10C2D,
	0x10C26,
	0x10C2A,
	0x10C2F,
	0x10C41,
	0x10C14,
	0x10C03,
	0x10C31,
	0x10C36,
	0x10C06,
	0x10C07,
	0x10C1C,
	0x10C30,
	0x10C38,
	0x10C47,
	0x10C01,
	0x10C0A,
	0x10C12,
	0x10C02,
	0x10C0C,
	0x10C10,
	0x10C1B,
	0x10C25,
	0x10C2E,
	0x10C46,
	0x10C19,
	0x10C0E,
	0x10C1F,
	0x10C2C,
	0x10C35,
	0x10C3B,
	0x10C40,
	0x10C44,
	0x10C17,
	0x10C05,
	0x10C33,
	0x10C29,
	0x10C27,
	0x10C2B,
	0x10C42,
	0x10C15,
	0x10C04,
	0x10C37,
	0x10C08,
	0x10C1D,
	0x10C39,
	0x1F474,
	0x1F475,
	0x1F51B,
	0x1F698,
	0x1F68D,
	0x1F694,
	0x1F696,
	0x2024,
	0x2E2B,
	0x1F4D6,
	0x2423,
	0x2732,
	0x272B,
	0x271B,
	0x273C,
	0x1F4C2,
	0x1F450,
	0x1F513,
	0x1F4ED,
	0x1F4EC,
	0x27C3,
	0x27C4,
	0x238F,
	0x2390,
	0x27BE,
	0x26CE,
	0x260D,
	0x1F4BF,
	0x2325,
	0x27C7,
	0x1F4D9,
	0x22B6,
	0x0B56,
	0x0B57,
	0x0B6E,
	0x0B6B,
	0x0B6A,
	0x0B6F,
	0x0B67,
	0x0B6D,
	0x0B6C,
	0x0B69,
	0x0B68,
	0x0B66,
	0x0B76,
	0x0B73,
	0x0B72,
	0x0B75,
	0x0B74,
	0x0B77,
	0x0B70,
	0x0B05,
	0x0B06,
	0x0B10,
	0x0B14,
	0x0B2C,
	0x0B2D,
	0x0B1A,
	0x0B1B,
	0x0B26,
	0x0B21,
	0x0B22,
	0x0B27,
	0x0B0F,
	0x0B17,
	0x0B18,
	0x0B39,
	0x0B07,
	0x0B08,
	0x0B1C,
	0x0B1D,
	0x0B15,
	0x0B16,
	0x0B32,
	0x0B33,
	0x0B2E,
	0x0B28,
	0x0B19,
	0x0B23,
	0x0B1E,
	0x0B13,
	0x0B2A,
	0x0B2B,
	0x0B30,
	0x0B5D,
	0x0B5C,
	0x0B38,
	0x0B36,
	0x0B37,
	0x0B24,
	0x0B25,
	0x0B1F,
	0x0B20,
	0x0B09,
	0x0B0A,
	0x0B35,
	0x0B0C,
	0x0B61,
	0x0B0B,
	0x0B60,
	0x0B71,
	0x0B2F,
	0x0B5F,
	0x0B02,
	0x0B3D,
	0x0B01,
	0x0B3C,
	0x0B4D,
	0x0B03,
	0x0B3E,
	0x0B48,
	0x0B4C,
	0x0B47,
	0x0B3F,
	0x0B40,
	0x0B4B,
	0x0B41,
	0x0B42,
	0x0B62,
	0x0B63,
	0x0B43,
	0x0B44,
	0xFD3E,
	0xFD3F,
	0x2626,
	0x104A8,
	0x104A5,
	0x104A4,
	0x104A9,
	0x104A1,
	0x104A7,
	0x104A6,
	0x104A3,
	0x104A2,
	0x104A0,
	0x10496,
	0x1049B,
	0x10480,
	0x10481,
	0x1048B,
	0x10486,
	0x1048A,
	0x10497,
	0x1049C,
	0x1048D,
	0x1048C,
	0x10494,
	0x10498,
	0x10483,
	0x1048F,
	0x10485,
	0x10490,
	0x10491,
	0x10492,
	0x10499,
	0x1049D,
	0x1048E,
	0x10487,
	0x10488,
	0x10489,
	0x10482,
	0x1049A,
	0x10493,
	0x10484,
	0x10495,
	0x2125,
	0x1F4E4,
	0x272D,
	0x2719,
	0x271F,
	0x269D,
	0x203E,
	0x1F402,
	0x1F4E6,
	0x1F4C4,
	0x1F4C3,
	0x1F4DF,
	0x26B4,
	0x2E19,
	0x1F334,
	0x1F43C,
	0x1F4CE,
	0x2029,
	0x2E0F,
	0x2225,
	0x2AF2,
	0x2AF3,
	0x247B,
	0x2478,
	0x2477,
	0x247C,
	0x2474,
	0x247A,
	0x2479,
	0x2476,
	0x2475,
	0x3209,
	0x3217,
	0x3208,
	0x3216,
	0x321C,
	0x320D,
	0x321B,
	0x3207,
	0x3215,
	0x320A,
	0x3218,
	0x3200,
	0x320E,
	0x3204,
	0x3212,
	0x3201,
	0x320F,
	0x320C,
	0x321A,
	0x3205,
	0x3213,
	0x3203,
	0x3211,
	0x3206,
	0x3214,
	0x320B,
	0x3219,
	0x3202,
	0x3210,
	0x323F,
	0x323A,
	0x3237,
	0x322F,
	0x3227,
	0x323D,
	0x3240,
	0x3236,
	0x322B,
	0x3224,
	0x3223,
	0x3232,
	0x3238,
	0x322E,
	0x322A,
	0x3234,
	0x3228,
	0x3220,
	0x3243,
	0x3239,
	0x323E,
	0x3241,
	0x3242,
	0x3226,
	0x3225,
	0x3233,
	0x3235,
	0x3231,
	0x323B,
	0x3230,
	0x323C,
	0x3229,
	0x3222,
	0x3221,
	0x322C,
	0x322D,
	0x321E,
	0x321D,
	0x1F110,
	0x1F111,
	0x1F112,
	0x1F113,
	0x1F114,
	0x1F115,
	0x1F116,
	0x1F117,
	0x1F118,
	0x1F119,
	0x1F11A,
	0x1F11B,
	0x1F11C,
	0x1F11D,
	0x1F11E,
	0x1F11F,
	0x1F120,
	0x1F121,
	0x1F122,
	0x1F123,
	0x1F124,
	0x1F125,
	0x1F126,
	0x1F127,
	0x1F128,
	0x1F129,
	0x249C,
	0x249D,
	0x249E,
	0x249F,
	0x24A0,
	0x24A1,
	0x24A2,
	0x24A3,
	0x24A4,
	0x24A5,
	0x24A6,
	0x24A7,
	0x24A8,
	0x24A9,
	0x24AA,
	0x24AB,
	0x24AC,
	0x24AD,
	0x24AE,
	0x24AF,
	0x24B0,
	0x24B1,
	0x24B2,
	0x24B3,
	0x24B4,
	0x24B5,
	0x2485,
	0x247E,
	0x2482,
	0x2481,
	0x2486,
	0x2484,
	0x2483,
	0x247D,
	0x2480,
	0x247F,
	0x2487,
	0x303D,
	0x2202,
	0x267D,
	0x3250,
	0x1F389,
	0x2391,
	0x2392,
	0x1F6C2,
	0x1F43E,
	0x262E,
	0x1F351,
	0x1F350,
	0x1F6B6,
	0x270F,
	0x1F427,
	0x1F614,
	0x26E4,
	0x2030,
	0x214C,
	0x2031,
	0x0025,
	0x1F3AD,
	0x267E,
	0x27C2,
	0x2AE1,
	0x1F623,
	0x1F647,
	0x1F64D,
	0x1F64C,
	0x26F9,
	0x1F471,
	0x1F64F,
	0x1F64E,
	0x1F4BB,
	0x2306,
	0x20A7,
	0x20B1,
	0xA875,
	0xA85D,
	0xA86D,
	0xA870,
	0xA84E,
	0xA844,
	0xA873,
	0xA845,
	0xA84A,
	0xA86B,
	0xA852,
	0xA860,
	0xA866,
	0xA864,
	0xA842,
	0xA865,
	0xA85C,
	0xA85E,
	0xA846,
	0xA840,
	0xA841,
	0xA859,
	0xA84F,
	0xA84B,
	0xA843,
	0xA86C,
	0xA847,
	0xA861,
	0xA84C,
	0xA84D,
	0xA862,
	0xA858,
	0xA85B,
	0xA85A,
	0xA856,
	0xA848,
	0xA849,
	0xA850,
	0xA851,
	0xA869,
	0xA86A,
	0xA85F,
	0xA86F,
	0xA86E,
	0xA853,
	0xA863,
	0xA857,
	0xA855,
	0xA854,
	0xA877,
	0xA876,
	0xA874,
	0xA871,
	0xA867,
	0xA868,
	0xA872,
	0x101D9,
	0x101F1,
	0x101E7,
	0x101E1,
	0x101DA,
	0x101EB,
	0x101D3,
	0x101E2,
	0x101EC,
	0x101D4,
	0x101DC,
	0x101E6,
	0x101E4,
	0x101FD,
	0x101E3,
	0x101EF,
	0x101EE,
	0x101F8,
	0x101D7,
	0x101F9,
	0x101D6,
	0x101EA,
	0x101E9,
	0x101E0,
	0x101F6,
	0x101DD,
	0x101DE,
	0x101F7,
	0x101F4,
	0x101D0,
	0x101F2,
	0x101D1,
	0x101ED,
	0x101F5,
	0x101DF,
	0x101DB,
	0x101E8,
	0x101E5,
	0x101FB,
	0x101FA,
	0x101D2,
	0x101D8,
	0x101F0,
	0x101F3,
	0x101FC,
	0x101D5,
	0x1736,
	0x1735,
	0x1090F,
	0x10900,
	0x10901,
	0x10903,
	0x10902,
	0x10904,
	0x10907,
	0x1090A,
	0x1090B,
	0x1090C,
	0x1090D,
	0x10910,
	0x10912,
	0x10913,
	0x10911,
	0x1090E,
	0x10914,
	0x10915,
	0x10908,
	0x10905,
	0x10909,
	0x10906,
	0x10916,
	0x10919,
	0x10917,
	0x1091B,
	0x10918,
	0x1091A,
	0x1091F,
	0x26CF,
	0x1F416,
	0x1F437,
	0x1F43D,
	0x00B6,
	0x1F4A9,
	0x1F48A,
	0x1F38D,
	0x1F34D,
	0x272F,
	0x2653,
	0x1F52B,
	0x22D4,
	0x2ADA,
	0x2318,
	0x210E,
	0x210F,
	0x1F0D1,
	0x1F0C1,
	0x1F0B1,
	0x1F0A1,
	0x1F0A0,
	0x1F0CF,
	0x1F0D8,
	0x1F0C8,
	0x1F0B8,
	0x1F0A8,
	0x1F0D5,
	0x1F0C5,
	0x1F0B5,
	0x1F0A5,
	0x1F0D4,
	0x1F0C4,
	0x1F0B4,
	0x1F0A4,
	0x1F0DB,
	0x1F0CB,
	0x1F0BB,
	0x1F0AB,
	0x1F0DE,
	0x1F0CE,
	0x1F0BE,
	0x1F0AE,
	0x1F0DC,
	0x1F0CC,
	0x1F0BC,
	0x1F0AC,
	0x1F0D9,
	0x1F0C9,
	0x1F0B9,
	0x1F0A9,
	0x1F0DD,
	0x1F0CD,
	0x1F0BD,
	0x1F0AD,
	0x1F0D7,
	0x1F0C7,
	0x1F0B7,
	0x1F0A7,
	0x1F0D6,
	0x1F0C6,
	0x1F0B6,
	0x1F0A6,
	0x1F0DA,
	0x1F0CA,
	0x1F0BA,
	0x1F0AA,
	0x1F0D3,
	0x1F0C3,
	0x1F0B3,
	0x1F0A3,
	0x1F0D2,
	0x1F0C2,
	0x1F0B2,
	0x1F0A2,
	0x1F0DF,
	0x002B,
	0x2A72,
	0x2A2D,
	0x2A2E,
	0x2A39,
	0x2A28,
	0x2A23,
	0x2A25,
	0x2A22,
	0x2A27,
	0x2A24,
	0x2A26,
	0x00B1,
	0x2647,
	0x1F693,
	0x1F6A8,
	0x1F46E,
	0x1F429,
	0x202C,
	0x2069,
	0x2316,
	0x1F4EF,
	0x3012,
	0x3020,
	0x1F4EE,
	0x1F372,
	0x1F6B0,
	0x1F45D,
	0x1F357,
	0x00A3,
	0x1F63E,
	0x1F621,
	0x227A,
	0x2AB7,
	0x2AB3,
	0x2AB9,
	0x2AB5,
	0x2AAF,
	0x2AB1,
	0x22E8,
	0x227C,
	0x227E,
	0x22B0,
	0x211E,
	0xFE13,
	0xFE10,
	0xFE31,
	0xFE32,
	0xFE15,
	0xFE19,
	0xFE11,
	0xFE12,
	0xFE3F,
	0xFE3B,
	0xFE41,
	0xFE37,
	0xFE3D,
	0xFE35,
	0xFE47,
	0xFE39,
	0xFE43,
	0xFE17,
	0xFE33,
	0xFE16,
	0xFE40,
	0xFE3C,
	0xFE42,
	0xFE38,
	0xFE3E,
	0xFE36,
	0xFE48,
	0xFE3A,
	0xFE44,
	0xFE18,
	0xFE14,
	0xFE30,
	0xFE34,
	0x2397,
	0x2032,
	0x1F478,
	0x2399,
	0x2305,
	0x214A,
	0x2237,
	0x221D,
	0x1F4E2,
	0x2008,
	0x1F49C,
	0x1F45B,
	0x1F4CC,
	0x1F6AE,
	0x2596,
	0x2597,
	0x2598,
	0x2599,
	0x259A,
	0x259B,
	0x259C,
	0x259D,
	0x259E,
	0x259F,
	0x2A0C,
	0x2057,
	0x2669,
	0x2A16,
	0x2048,
	0x003F,
	0x225F,
	0x26BB,
	0x0022,
	0x1F407,
	0x1F430,
	0x23B7,
	0x1F4FB,
	0x1F518,
	0x2622,
	0x1F683,
	0x26C6,
	0x1F308,
	0x2E34,
	0x2E33,
	0x2E07,
	0x270A,
	0x270B,
	0x2E06,
	0x1F16A,
	0x1F16B,
	0x2E0B,
	0x1F40F,
	0x1F400,
	0x2236,
	0x1F699,
	0x267C,
	0x267A,
	0x2673,
	0x2674,
	0x2675,
	0x2676,
	0x2677,
	0x2678,
	0x2679,
	0x1F34E,
	0x203B,
	0x1F1E6,
	0x1F1E7,
	0x1F1E8,
	0x1F1E9,
	0x1F1EA,
	0x1F1EB,
	0x1F1EC,
	0x1F1ED,
	0x1F1EE,
	0x1F1EF,
	0x1F1F0,
	0x1F1F1,
	0x1F1F2,
	0x1F1F3,
	0x1F1F4,
	0x1F1F5,
	0x1F1F6,
	0x1F1F7,
	0x1F1F8,
	0x1F1F9,
	0x1F1FA,
	0x1F1FB,
	0x1F1FC,
	0x1F1FD,
	0x1F1FE,
	0x1F1FF,
	0x00AE,
	0xA952,
	0xA950,
	0xA94F,
	0xA951,
	0xA946,
	0xA937,
	0xA939,
	0xA934,
	0xA931,
	0xA941,
	0xA93A,
	0xA930,
	0xA93E,
	0xA938,
	0xA942,
	0xA935,
	0xA944,
	0xA932,
	0xA943,
	0xA93B,
	0xA945,
	0xA936,
	0xA93D,
	0xA93C,
	0xA933,
	0xA940,
	0xA93F,
	0xA95F,
	0xA953,
	0xA94A,
	0xA94C,
	0xA949,
	0xA94E,
	0xA94D,
	0xA947,
	0xA94B,
	0xA948,
	0x1F60C,
	0xFFFD,
	0x211F,
	0x1F6BB,
	0x23CE,
	0x005C,
	0x29F5,
	0x27C8,
	0x29F7,
	0x2B41,
	0x2B47,
	0x29A3,
	0x29A5,
	0x2036,
	0x301D,
	0x2AED,
	0x29B0,
	0x2E11,
	0x2310,
	0x204B,
	0x2035,
	0x2E2E,
	0x2619,
	0x2143,
	0x204F,
	0x223D,
	0x22CD,
	0x2037,
	0x1F49E,
	0xFDFC,
	0x1F380,
	0x1F359,
	0x1F358,
	0x221F,
	0x3009,
	0x2992,
	0x2E01,
	0x2E00,
	0x299C,
	0x22BE,
	0x237C,
	0x2994,
	0x27F4,
	0x21F4,
	0x3011,
	0x2998,
	0x2309,
	0x300D,
	0x007D,
	0x23AD,
	0x23AC,
	0x23AB,
	0x2E05,
	0x300B,
	0x2970,
	0x2E29,
	0x201D,
	0x29DB,
	0x297D,
	0x230B,
	0x25D7,
	0x2590,
	0x2E1D,
	0x22CA,
	0x2595,
	0x27D6,
	0x0029,
	0x239F,
	0x23A0,
	0x239E,
	0x2E0D,
	0x27C6,
	0x22CC,
	0x2E27,
	0x2019,
	0x005D,
	0x23A5,
	0x23A6,
	0x23A4,
	0x2046,
	0x298E,
	0x2990,
	0x298C,
	0x2E03,
	0x22A2,
	0x3015,
	0x2E0A,
	0x22BF,
	0x29CE,
	0x2E21,
	0x23B9,
	0x300F,
	0x2984,
	0x3017,
	0x2986,
	0x301B,
	0x3019,
	0x29D9,
	0x0FD5,
	0x0FD7,
	0x26E5,
	0x232A,
	0x29FD,
	0x00BB,
	0x1F50E,
	0x27A9,
	0x2938,
	0x202B,
	0x2067,
	0x200F,
	0x202E,
	0x2A3D,
	0x2192,
	0x2975,
	0x2B48,
	0x2B4C,
	0x2942,
	0x2974,
	0x21A6,
	0x2920,
	0x21C4,
	0x2B43,
	0x2B44,
	0x2947,
	0x21E5,
	0x291E,
	0x21B4,
	0x2911,
	0x21FB,
	0x21AA,
	0x21AC,
	0x2945,
	0x219B,
	0x21A3,
	0x2915,
	0x2914,
	0x2B0E,
	0x2B0F,
	0x21F8,
	0x291A,
	0x21E2,
	0x21D2,
	0x2907,
	0x21CF,
	0x2903,
	0x291C,
	0x290D,
	0x21CC,
	0x2969,
	0x296D,
	0x295F,
	0x2957,
	0x21C1,
	0x2968,
	0x296C,
	0x2964,
	0x295B,
	0x2953,
	0x21C0,
	0x21FE,
	0x21C9,
	0x2B46,
	0x21DD,
	0x21DB,
	0x290F,
	0x21A0,
	0x2905,
	0x2901,
	0x2916,
	0x2918,
	0x2917,
	0x2900,
	0x2910,
	0x219D,
	0x21E8,
	0x21F0,
	0x1F48D,
	0x02DA,
	0x2257,
	0x2256,
	0x2218,
	0x2E30,
	0x292B,
	0x2930,
	0x1F360,
	0x1F680,
	0x1F3A2,
	0x1019A,
	0x1019B,
	0x10196,
	0x10194,
	0x10199,
	0x2167,
	0x216A,
	0x216C,
	0x2186,
	0x2187,
	0x2164,
	0x216E,
	0x2181,
	0x2163,
	0x2168,
	0x2160,
	0x216D,
	0x2188,
	0x216F,
	0x2180,
	0x2183,
	0x2166,
	0x2165,
	0x2185,
	0x2169,
	0x2182,
	0x2162,
	0x216B,
	0x2161,
	0x10197,
	0x10192,
	0x10198,
	0x10190,
	0x10193,
	0x10195,
	0x10191,
	0x1F413,
	0x1F339,
	0x213A,
	0x2767,
	0x2765,
	0x1F4CD,
	0x1F6A3,
	0x1F3C9,
	0x29F4,
	0x10E67,
	0x10E64,
	0x10E63,
	0x10E68,
	0x10E60,
	0x10E66,
	0x10E65,
	0x10E62,
	0x10E61,
	0x10E7B,
	0x10E7C,
	0x10E7D,
	0x10E7E,
	0x10E79,
	0x10E70,
	0x10E6D,
	0x10E76,
	0x10E6C,
	0x10E75,
	0x10E7A,
	0x10E71,
	0x10E72,
	0x10E78,
	0x10E6F,
	0x10E77,
	0x10E6E,
	0x10E69,
	0x10E6B,
	0x10E74,
	0x10E6A,
	0x10E73,
	0x16EE,
	0x16F0,
	0x16ED,
	0x16AA,
	0x16AB,
	0x16C9,
	0x16A8,
	0x16D2,
	0x16CD,
	0x16E3,
	0x16E4,
	0x16B3,
	0x16E2,
	0x16D1,
	0x16DE,
	0x16DB,
	0x16C0,
	0x16D4,
	0x16C2,
	0x16E0,
	0x16D6,
	0x16B6,
	0x16A7,
	0x16A0,
	0x16B5,
	0x16B8,
	0x16B7,
	0x16C4,
	0x16BB,
	0x16BA,
	0x16E8,
	0x16DD,
	0x16DC,
	0x16E1,
	0x16C1,
	0x16C7,
	0x16C3,
	0x16B4,
	0x16B2,
	0x16DA,
	0x16C5,
	0x16BC,
	0x16D8,
	0x16AC,
	0x16E6,
	0x16D7,
	0x16BE,
	0x16AE,
	0x16AF,
	0x16B0,
	0x16D5,
	0x16A9,
	0x16DF,
	0x16C8,
	0x16E9,
	0x16B1,
	0x16C6,
	0x16D3,
	0x16BD,
	0x16D9,
	0x16BF,
	0x16AD,
	0x16CC,
	0x16D0,
	0x16E7,
	0x16CB,
	0x16CA,
	0x16E5,
	0x16A6,
	0x16CF,
	0x16A2,
	0x16A1,
	0x16A5,
	0x16B9,
	0x16EA,
	0x16A4,
	0x16A3,
	0x16CE,
	0x16EC,
	0x16EB,
	0x16EF,
	0x1F3C3,
	0x1F3BD,
	0x20A8,
	0x29CC,
	0x2650,
	0x26F5,
	0x1F376,
	0x2613,
	0x0836,
	0x0800,
	0x0805,
	0x0801,
	0x0803,
	0x0810,
	0x0802,
	0x080F,
	0x0807,
	0x0804,
	0x080A,
	0x080B,
	0x080C,
	0x080D,
	0x0812,
	0x0813,
	0x0814,
	0x080E,
	0x0815,
	0x0808,
	0x0811,
	0x0809,
	0x0806,
	0x0819,
	0x081B,
	0x0816,
	0x0817,
	0x082D,
	0x0818,
	0x081A,
	0x0828,
	0x0824,
	0x0831,
	0x0832,
	0x083E,
	0x083C,
	0x0834,
	0x0833,
	0x0837,
	0x0830,
	0x0839,
	0x0835,
	0x083D,
	0x083B,
	0x083A,
	0x0838,
	0x0823,
	0x0820,
	0x081D,
	0x082A,
	0x0822,
	0x081F,
	0x081C,
	0x0829,
	0x0826,
	0x082B,
	0x0821,
	0x081E,
	0x0825,
	0x082C,
	0x0827,
	0x1F4E1,
	0x2644,
	0xA8B4,
	0xA8CE,
	0xA8D8,
	0xA8D5,
	0xA8D4,
	0xA8D9,
	0xA8D1,
	0xA8D7,
	0xA8D6,
	0xA8D3,
	0xA8D2,
	0xA8D0,
	0xA8CF,
	0xA882,
	0xA883,
	0xA88E,
	0xA891,
	0xA8A8,
	0xA8A9,
	0xA897,
	0xA898,
	0xA8A3,
	0xA89E,
	0xA89F,
	0xA8A4,
	0xA88C,
	0xA88D,
	0xA894,
	0xA895,
	0xA8B2,
	0xA884,
	0xA885,
	0xA899,
	0xA89A,
	0xA892,
	0xA893,
	0xA8AD,
	0xA8B3,
	0xA8AA,
	0xA8A5,
	0xA896,
	0xA8A0,
	0xA89B,
	0xA88F,
	0xA890,
	0xA8A6,
	0xA8A7,
	0xA8AC,
	0xA8B1,
	0xA8AF,
	0xA8B0,
	0xA8A1,
	0xA8A2,
	0xA89C,
	0xA89D,
	0xA886,
	0xA887,
	0xA8AE,
	0xA88A,
	0xA88B,
	0xA888,
	0xA889,
	0xA8AB,
	0xA880,
	0xA8C4,
	0xA881,
	0xA8B5,
	0xA8C0,
	0xA8C3,
	0xA8BE,
	0xA8BF,
	0xA8B6,
	0xA8B7,
	0xA8C1,
	0xA8C2,
	0xA8B8,
	0xA8B9,
	0xA8BC,
	0xA8BD,
	0xA8BA,
	0xA8BB,
	0x1F3B7,
	0x2696,
	0x1F3EB,
	0x1F392,
	0x264F,
	0x212C,
	0x2130,
	0x2131,
	0x210B,
	0x2110,
	0x2112,
	0x2133,
	0x2118,
	0x211B,
	0x212F,
	0x210A,
	0x2113,
	0x2134,
	0x1F4DC,
	0x2108,
	0x1F4BA,
	0x00A7,
	0x2314,
	0x1F648,
	0x1F331,
	0x2313,
	0x003B,
	0x2A32,
	0x26BA,
	0x2120,
	0xFE45,
	0x26BC,
	0x2216,
	0x26B9,
	0x274D,
	0x271E,
	0x2730,
	0x2618,
	0x111C7,
	0x111C5,
	0x111D8,
	0x111D5,
	0x111D4,
	0x111D9,
	0x111D1,
	0x111D7,
	0x111D6,
	0x111D3,
	0x111D2,
	0x111D0,
	0x111C6,
	0x11183,
	0x11184,
	0x1118E,
	0x11190,
	0x111A7,
	0x111A8,
	0x11196,
	0x11197,
	0x111A2,
	0x1119D,
	0x1119E,
	0x111A3,
	0x1118D,
	0x11193,
	0x11194,
	0x111B2,
	0x11185,
	0x11186,
	0x11198,
	0x11199,
	0x11191,
	0x11192,
	0x111AC,
	0x111AD,
	0x111A9,
	0x111A4,
	0x11195,
	0x1119F,
	0x1119A,
	0x1118F,
	0x111A5,
	0x111A6,
	0x111AB,
	0x111B1,
	0x111AF,
	0x111B0,
	0x111A0,
	0x111A1,
	0x1119B,
	0x1119C,
	0x11187,
	0x11188,
	0x111AE,
	0x1118B,
	0x1118C,
	0x11189,
	0x1118A,
	0x111AA,
	0x111C4,
	0x111C8,
	0x11181,
	0x111C1,
	0x11180,
	0x111C2,
	0x111C3,
	0x111C0,
	0x11182,
	0x111B3,
	0x111BD,
	0x111BF,
	0x111BC,
	0x111B4,
	0x111B5,
	0x111BE,
	0x111B6,
	0x111B7,
	0x111BA,
	0x111BB,
	0x111B8,
	0x111B9,
	0x1F367,
	0x10469,
	0x10471,
	0x1046D,
	0x1047A,
	0x10478,
	0x1047C,
	0x10468,
	0x10477,
	0x1045A,
	0x10457,
	0x1045B,
	0x1047D,
	0x10470,
	0x10467,
	0x1047B,
	0x10453,
	0x1045C,
	0x10463,
	0x10459,
	0x1047E,
	0x10472,
	0x10466,
	0x10461,
	0x10452,
	0x10464,
	0x10460,
	0x10465,
	0x1046F,
	0x10474,
	0x10476,
	0x1046A,
	0x10475,
	0x10479,
	0x1046C,
	0x10450,
	0x1046E,
	0x10455,
	0x10456,
	0x1045E,
	0x10454,
	0x10451,
	0x10473,
	0x1045D,
	0x10462,
	0x1046B,
	0x10458,
	0x1047F,
	0x1045F,
	0x1F411,
	0x26E9,
	0x1F6A2,
	0x1F320,
	0x2ADF,
	0x2AE7,
	0x2ADE,
	0x2944,
	0x2AE0,
	0x2AE9,
	0x2AE8,
	0x1F370,
	0x237D,
	0x1F6BF,
	0x29E2,
	0x1F5FE,
	0x2AA0,
	0x2A9F,
	0x2A6C,
	0x2A9E,
	0x2A9D,
	0x223F,
	0x201B,
	0x2039,
	0x201A,
	0x203A,
	0x0D86,
	0x0D88,
	0x0D87,
	0x0D93,
	0x0DB6,
	0x0DA0,
	0x0DAF,
	0x0DA9,
	0x0D9C,
	0x0DA2,
	0x0D9A,
	0x0DB4,
	0x0DAD,
	0x0DA7,
	0x0DB9,
	0x0D96,
	0x0D85,
	0x0DBD,
	0x0DB1,
	0x0DC3,
	0x0D92,
	0x0D91,
	0x0DC6,
	0x0DC4,
	0x0D8A,
	0x0D90,
	0x0D8F,
	0x0D8E,
	0x0D8D,
	0x0D89,
	0x0D9E,
	0x0DB7,
	0x0DA1,
	0x0DB0,
	0x0DAA,
	0x0D9D,
	0x0DA3,
	0x0D9B,
	0x0DB5,
	0x0DAE,
	0x0DA8,
	0x0DB8,
	0x0DC5,
	0x0DAB,
	0x0DC2,
	0x0D95,
	0x0D94,
	0x0DBB,
	0x0DB3,
	0x0DAC,
	0x0D9F,
	0x0DA6,
	0x0DA4,
	0x0DA5,
	0x0DC1,
	0x0D8C,
	0x0D8B,
	0x0DC0,
	0x0DBA,
	0x0DF4,
	0x0DCA,
	0x0D82,
	0x0D83,
	0x0DCF,
	0x0DD1,
	0x0DF2,
	0x0DF3,
	0x0DD3,
	0x0DDA,
	0x0DD6,
	0x0DD8,
	0x0DDF,
	0x0DD0,
	0x0DD2,
	0x0DD4,
	0x0DDB,
	0x0DD9,
	0x0DDC,
	0x0DDD,
	0x0DDE,
	0x273E,
	0x2736,
	0x1F52F,
	0x2006,
	0x273A,
	0x1F3BF,
	0x26F7,
	0x1F480,
	0x2620,
	0x2A96,
	0x2A98,
	0x2A95,
	0x2A97,
	0xA673,
	0x1F634,
	0x1F4A4,
	0x1F62A,
	0x1F355,
	0x2333,
	0x2A58,
	0x2A57,
	0x1F3B0,
	0xFE60,
	0xFE61,
	0x1F539,
	0xFE55,
	0xFE50,
	0xFE6B,
	0x220D,
	0x22FE,
	0x22FC,
	0xFE69,
	0x220A,
	0x22F7,
	0x22F4,
	0xFE58,
	0xFE66,
	0xFE57,
	0xFE52,
	0xFE65,
	0xFE63,
	0xFE51,
	0xFE5B,
	0xFE59,
	0xFE5D,
	0xFE64,
	0xFE5F,
	0x1F538,
	0xFE6A,
	0xFE62,
	0xFE56,
	0xFE68,
	0xFE5C,
	0xFE5A,
	0xFE5E,
	0x2177,
	0x217A,
	0x217C,
	0x2174,
	0x217E,
	0x2173,
	0x2178,
	0x2170,
	0x217D,
	0x217F,
	0x2176,
	0x2175,
	0x2179,
	0x2172,
	0x217B,
	0x2171,
	0xFE54,
	0x02DC,
	0x10B3B,
	0x2A61,
	0x2AAA,
	0x2AAC,
	0x2A33,
	0x2323,
	0x1F63B,
	0x1F63A,
	0x1F607,
	0x1F60D,
	0x1F608,
	0x1F603,
	0x1F605,
	0x1F604,
	0x1F606,
	0x1F60A,
	0x1F60E,
	0x1F60F,
	0x1F6AC,
	0x1F40C,
	0x1F40D,
	0x1F3C2,
	0x2744,
	0x2603,
	0x26C4,
	0x26BD,
	0x00AD,
	0x1F366,
	0x2394,
	0x002F,
	0x29F6,
	0x1F51C,
	0x110F8,
	0x110F5,
	0x110F4,
	0x110F9,
	0x110F1,
	0x110F7,
	0x110F6,
	0x110F3,
	0x110F2,
	0x110F0,
	0x110E2,
	0x110D2,
	0x110D3,
	0x110D4,
	0x110E3,
	0x110E7,
	0x110D5,
	0x110DE,
	0x110E4,
	0x110E0,
	0x110DF,
	0x110D8,
	0x110E8,
	0x110D6,
	0x110D9,
	0x110D7,
	0x110E1,
	0x110E6,
	0x110DB,
	0x110DD,
	0x110D0,
	0x110D1,
	0x110E5,
	0x110DA,
	0x110DC,
	0x2117,
	0x2198,
	0x2929,
	0x292D,
	0x21F2,
	0x2925,
	0x2B0A,
	0x21D8,
	0x2B02,
	0x2199,
	0x292A,
	0x2926,
	0x2B0B,
	0x21D9,
	0x2B03,
	0x0020,
	0x1F35D,
	0x2747,
	0x2728,
	0x1F496,
	0x1F64A,
	0x1F508,
	0x1F507,
	0x1F509,
	0x1F50A,
	0x1F4AC,
	0x1F6A4,
	0x20B7,
	0x2222,
	0x29A0,
	0x29A1,
	0x1F41A,
	0x1F4A6,
	0x1F433,
	0x33DF,
	0x3303,
	0x33C2,
	0x3302,
	0x3300,
	0x3301,
	0x3373,
	0x332D,
	0x3374,
	0x333C,
	0x3331,
	0x333E,
	0x33C3,
	0x3334,
	0x33C6,
	0x3388,
	0x2293,
	0x33C4,
	0x33C5,
	0x339D,
	0x33A4,
	0x33A0,
	0x33C7,
	0x337F,
	0x2294,
	0x3372,
	0x3324,
	0x33C8,
	0x3325,
	0x1F190,
	0x3397,
	0x3377,
	0x3379,
	0x3378,
	0x3326,
	0x3308,
	0x337B,
	0x337E,
	0x337C,
	0x337D,
	0x32CD,
	0x3307,
	0x32CE,
	0x3399,
	0x23CD,
	0x26F6,
	0x33FF,
	0x330F,
	0x330E,
	0x3387,
	0x3393,
	0x3310,
	0x3311,
	0x3313,
	0x33AC,
	0x3318,
	0x3319,
	0x33C9,
	0x33CA,
	0x332A,
	0x3336,
	0x3339,
	0x32CC,
	0x1F200,
	0x333F,
	0x3342,
	0x3341,
	0x33CB,
	0x3371,
	0x3332,
	0x3333,
	0x3335,
	0x3390,
	0x228F,
	0x2291,
	0x22E4,
	0x33CC,
	0x3304,
	0x3305,
	0x337A,
	0x33C0,
	0x3384,
	0x330B,
	0x330C,
	0x330D,
	0x3385,
	0x3389,
	0x331C,
	0x338F,
	0x3391,
	0x3314,
	0x3315,
	0x3316,
	0x3317,
	0x33CD,
	0x3398,
	0x339E,
	0x33CE,
	0x33A6,
	0x33A2,
	0x331E,
	0x331D,
	0x33AA,
	0x33CF,
	0x331B,
	0x331A,
	0x33B8,
	0x33BE,
	0x3312,
	0x2ACD,
	0x33D0,
	0x33D1,
	0x33D2,
	0x2311,
	0x33D3,
	0x33A5,
	0x33C1,
	0x33A7,
	0x33A8,
	0x33A1,
	0x3383,
	0x3345,
	0x3343,
	0x3344,
	0x3347,
	0x3346,
	0x3386,
	0x33D4,
	0x334D,
	0x334B,
	0x334C,
	0x338E,
	0x3392,
	0x3348,
	0x33D5,
	0x3349,
	0x334A,
	0x3396,
	0x339C,
	0x33A3,
	0x339F,
	0x33D6,
	0x33AB,
	0x33B3,
	0x3382,
	0x338C,
	0x338D,
	0x3395,
	0x339B,
	0x33B2,
	0x33B6,
	0x33BC,
	0x33B7,
	0x33B9,
	0x33BD,
	0x33BF,
	0x3381,
	0x3328,
	0x338B,
	0x339A,
	0x3329,
	0x33B1,
	0x33B5,
	0x33BB,
	0x3309,
	0x330A,
	0x2290,
	0x2292,
	0x22E5,
	0x3375,
	0x33A9,
	0x3380,
	0x332B,
	0x332C,
	0x3376,
	0x333B,
	0x3338,
	0x333A,
	0x3337,
	0x338A,
	0x33D7,
	0x332E,
	0x3330,
	0x332F,
	0x33D8,
	0x333D,
	0x3340,
	0x33D9,
	0x33DA,
	0x33B0,
	0x33B4,
	0x33BA,
	0x33AD,
	0x33AE,
	0x33AF,
	0x3355,
	0x3356,
	0x2ACE,
	0x3352,
	0x3351,
	0x221A,
	0x3353,
	0x3354,
	0x331F,
	0x3320,
	0x3322,
	0x3323,
	0x3321,
	0x33DB,
	0x33DC,
	0x3394,
	0x3327,
	0x3306,
	0x33DE,
	0x3357,
	0x33DD,
	0x2B13,
	0x29E0,
	0x25A9,
	0x25A4,
	0x25E7,
	0x2B15,
	0x25EA,
	0x25A6,
	0x25E8,
	0x2B12,
	0x25E9,
	0x25A7,
	0x2B14,
	0x25A8,
	0x25A5,
	0x334E,
	0x334F,
	0x3350,
	0x29C6,
	0x1F22D,
	0x1F214,
	0x1F21E,
	0x1F220,
	0x1F21C,
	0x1F212,
	0x1F215,
	0x1F21D,
	0x1F210,
	0x1F222,
	0x1F233,
	0x1F22B,
	0x1F191,
	0x1F192,
	0x22A1,
	0x29C5,
	0x2E2C,
	0x1F193,
	0x1F14A,
	0x1F194,
	0x1F213,
	0x1F201,
	0x1F202,
	0x26BF,
	0x1F130,
	0x1F131,
	0x1F132,
	0x1F133,
	0x1F134,
	0x1F135,
	0x1F136,
	0x1F137,
	0x1F138,
	0x1F139,
	0x1F13A,
	0x1F13B,
	0x1F13C,
	0x1F13D,
	0x1F13E,
	0x1F13F,
	0x1F140,
	0x1F141,
	0x1F142,
	0x1F143,
	0x1F144,
	0x1F145,
	0x1F146,
	0x1F147,
	0x1F148,
	0x1F149,
	0x27CE,
	0x27CF,
	0x229F,
	0x1F14B,
	0x1F195,
	0x1F196,
	0x1F197,
	0x229E,
	0x1F14E,
	0x29C4,
	0x26DD,
	0x1F14C,
	0x29C7,
	0x1F198,
	0x29C8,
	0x1F14D,
	0x22A0,
	0x1F199,
	0x1F19A,
	0x1F14F,
	0x27A7,
	0x2695,
	0x269A,
	0x262A,
	0x225B,
	0x2721,
	0x22C6,
	0x1F689,
	0x1F5FD,
	0x1F682,
	0x1F35C,
	0x23F1,
	0x1F4CF,
	0x23E4,
	0x1F353,
	0x2729,
	0x2263,
	0x2088,
	0x208C,
	0x2085,
	0x2084,
	0x208D,
	0x208B,
	0x2089,
	0x2081,
	0x208A,
	0x208E,
	0x2087,
	0x2086,
	0x2083,
	0x2082,
	0x2080,
	0x2979,
	0x2AD5,
	0x2AD3,
	0x2282,
	0x2AC9,
	0x2AC5,
	0x2ACB,
	0x2AC7,
	0x2286,
	0x2AC3,
	0x228A,
	0x2ABD,
	0x2AC1,
	0x2ABF,
	0x227B,
	0x2AB8,
	0x2AB4,
	0x2ABA,
	0x2AB6,
	0x2AB0,
	0x2AB2,
	0x22E9,
	0x227D,
	0x227F,
	0x22B1,
	0x23B3,
	0x23B2,
	0x2A0B,
	0x2609,
	0x26C5,
	0x1F31E,
	0x1BBA,
	0x1BA1,
	0x1BA2,
	0x1BA3,
	0x1BAC,
	0x1BAD,
	0x1BB8,
	0x1BB5,
	0x1BB4,
	0x1BB9,
	0x1BB1,
	0x1BB7,
	0x1BB6,
	0x1BB3,
	0x1BB2,
	0x1BB0,
	0x1B83,
	0x1B86,
	0x1B98,
	0x1BBD,
	0x1B8E,
	0x1B93,
	0x1B88,
	0x1B89,
	0x1B96,
	0x1BBE,
	0x1BBF,
	0x1B8C,
	0x1BA0,
	0x1B84,
	0x1B8F,
	0x1B8A,
	0x1BAE,
	0x1B9C,
	0x1BBC,
	0x1B99,
	0x1B94,
	0x1B8D,
	0x1B91,
	0x1B87,
	0x1B95,
	0x1B8B,
	0x1B9B,
	0x1BBB,
	0x1B9E,
	0x1BAF,
	0x1B92,
	0x1B85,
	0x1B97,
	0x1B9D,
	0x1B9F,
	0x1B9A,
	0x1B90,
	0x1CC7,
	0x1CC3,
	0x1CC6,
	0x1CC5,
	0x1CC4,
	0x1CC1,
	0x1CC2,
	0x1CC0,
	0x1BAA,
	0x1B81,
	0x1B82,
	0x1B80,
	0x1BAB,
	0x1BA8,
	0x1BA6,
	0x1BA9,
	0x1BA4,
	0x1BA7,
	0x1BA5,
	0x1F33B,
	0x1F305,
	0x1F304,
	0x1F307,
	0x2078,
	0x207C,
	0x2075,
	0x2074,
	0x2071,
	0x207F,
	0x207D,
	0x207B,
	0x2079,
	0x00B9,
	0x207A,
	0x207E,
	0x2077,
	0x2076,
	0x00B3,
	0x00B2,
	0x2070,
	0x297B,
	0x2AD4,
	0x2AD6,
	0x2AD8,
	0x2AD7,
	0x2283,
	0x2ACA,
	0x2AC6,
	0x2ACC,
	0x2AC8,
	0x2287,
	0x2AC4,
	0x228B,
	0x27C9,
	0x2ABE,
	0x2AC2,
	0x2AC0,
	0x222F,
	0x1F3C4,
	0x1F363,
	0x1F69F,
	0x1F3CA,
	0x2053,
	0xA800,
	0xA81C,
	0xA81B,
	0xA80D,
	0xA80C,
	0xA813,
	0xA812,
	0xA817,
	0xA816,
	0xA804,
	0xA80A,
	0xA809,
	0xA822,
	0xA801,
	0xA80F,
	0xA80E,
	0xA808,
	0xA807,
	0xA81F,
	0xA81D,
	0xA818,
	0xA805,
	0xA81A,
	0xA819,
	0xA81E,
	0xA820,
	0xA821,
	0xA815,
	0xA814,
	0xA811,
	0xA810,
	0xA803,
	0xA80B,
	0xA802,
	0xA806,
	0xA823,
	0xA826,
	0xA824,
	0xA827,
	0xA825,
	0x2406,
	0x2408,
	0x2407,
	0x2418,
	0x240D,
	0x2410,
	0x2421,
	0x2425,
	0x2414,
	0x2411,
	0x2413,
	0x2412,
	0x2419,
	0x2403,
	0x2404,
	0x2417,
	0x2405,
	0x241B,
	0x241C,
	0x240C,
	0x241D,
	0x2409,
	0x240A,
	0x2415,
	0x2424,
	0x2400,
	0x241E,
	0x214F,
	0x240F,
	0x240E,
	0x2420,
	0x2401,
	0x2402,
	0x241A,
	0x2426,
	0x2416,
	0x241F,
	0x240B,
	0x232F,
	0x070F,
	0x074A,
	0x0706,
	0x0707,
	0x070A,
	0x0739,
	0x0738,
	0x0700,
	0x073D,
	0x073E,
	0x0740,
	0x070D,
	0x070C,
	0x070B,
	0x073A,
	0x073B,
	0x073C,
	0x0705,
	0x0710,
	0x0712,
	0x0715,
	0x0716,
	0x0725,
	0x0724,
	0x0713,
	0x0714,
	0x0717,
	0x071A,
	0x071F,
	0x0720,
	0x0721,
	0x0722,
	0x0726,
	0x072D,
	0x072F,
	0x072E,
	0x0729,
	0x0727,
	0x072A,
	0x0728,
	0x0723,
	0x072B,
	0x074F,
	0x074E,
	0x074D,
	0x0711,
	0x072C,
	0x071B,
	0x071C,
	0x0718,
	0x071D,
	0x071E,
	0x0719,
	0x0749,
	0x0747,
	0x0748,
	0x0730,
	0x0731,
	0x0732,
	0x0741,
	0x0736,
	0x0737,
	0x0742,
	0x073F,
	0x0704,
	0x0709,
	0x0702,
	0x0703,
	0x0708,
	0x0701,
	0x0745,
	0x0746,
	0x0743,
	0x0744,
	0x0733,
	0x0734,
	0x0735,
	0x1F489,
	0x1F455,
	0xE0026,
	0xE0027,
	0xE002A,
	0xE005E,
	0xE003A,
	0xE002C,
	0xE0040,
	0xE0038,
	0xE0035,
	0xE0034,
	0xE0039,
	0xE0031,
	0xE0037,
	0xE0036,
	0xE0033,
	0xE0032,
	0xE0030,
	0xE0024,
	0xE003D,
	0xE0021,
	0xE002E,
	0xE0060,
	0xE003E,
	0xE002D,
	0xE0041,
	0xE0042,
	0xE0043,
	0xE0044,
	0xE0045,
	0xE0046,
	0xE0047,
	0xE0048,
	0xE0049,
	0xE004A,
	0xE004B,
	0xE004C,
	0xE004D,
	0xE004E,
	0xE004F,
	0xE0050,
	0xE0051,
	0xE0052,
	0xE0053,
	0xE0054,
	0xE0055,
	0xE0056,
	0xE0057,
	0xE0058,
	0xE0059,
	0xE005A,
	0xE0061,
	0xE0062,
	0xE0063,
	0xE0064,
	0xE0065,
	0xE0066,
	0xE0067,
	0xE0068,
	0xE0069,
	0xE006A,
	0xE006B,
	0xE006C,
	0xE006D,
	0xE006E,
	0xE006F,
	0xE0070,
	0xE0071,
	0xE0072,
	0xE0073,
	0xE0074,
	0xE0075,
	0xE0076,
	0xE0077,
	0xE0078,
	0xE0079,
	0xE007A,
	0xE007B,
	0xE0028,
	0xE005B,
	0xE003C,
	0xE005F,
	0xE0023,
	0xE0025,
	0xE002B,
	0xE003F,
	0xE0022,
	0xE005C,
	0xE007D,
	0xE0029,
	0xE005D,
	0xE003B,
	0xE002F,
	0xE0020,
	0xE007E,
	0xE007C,
	0x1700,
	0x170A,
	0x1707,
	0x1704,
	0x1711,
	0x1701,
	0x1703,
	0x170E,
	0x170B,
	0x1708,
	0x1705,
	0x1709,
	0x1710,
	0x1706,
	0x1702,
	0x170F,
	0x170C,
	0x1714,
	0x1712,
	0x1713,
	0x1760,
	0x176A,
	0x1767,
	0x1764,
	0x1761,
	0x1763,
	0x176E,
	0x176B,
	0x1768,
	0x1765,
	0x1769,
	0x1770,
	0x1766,
	0x1762,
	0x176F,
	0x176C,
	0x1772,
	0x1773,
	0x1963,
	0x196D,
	0x196C,
	0x196B,
	0x1965,
	0x1966,
	0x195C,
	0x195E,
	0x1964,
	0x1950,
	0x1960,
	0x1958,
	0x195B,
	0x1962,
	0x1952,
	0x1969,
	0x1968,
	0x1959,
	0x195A,
	0x195F,
	0x1954,
	0x1956,
	0x1957,
	0x1953,
	0x1961,
	0x1967,
	0x196A,
	0x195D,
	0x1951,
	0x1955,
	0x1A7F,
	0x1A5D,
	0x1A59,
	0x1A5B,
	0x1A57,
	0x1A5A,
	0x1A5C,
	0x1A56,
	0x1A55,
	0x1A5E,
	0x1A88,
	0x1A85,
	0x1A84,
	0x1A89,
	0x1A81,
	0x1A87,
	0x1A86,
	0x1A83,
	0x1A82,
	0x1A80,
	0x1A4B,
	0x1A37,
	0x1A2F,
	0x1A51,
	0x1A54,
	0x1A27,
	0x1A28,
	0x1A3A,
	0x1A49,
	0x1A20,
	0x1A21,
	0x1A22,
	0x1A38,
	0x1A39,
	0x1A2E,
	0x1A48,
	0x1A46,
	0x1A47,
	0x1A32,
	0x1A33,
	0x1A40,
	0x1A4D,
	0x1A4E,
	0x1A43,
	0x1A53,
	0x1A4A,
	0x1A29,
	0x1A2B,
	0x1A3C,
	0x1A4C,
	0x1A23,
	0x1A25,
	0x1A24,
	0x1A3B,
	0x1A3D,
	0x1A30,
	0x1A2A,
	0x1A34,
	0x1A35,
	0x1A3F,
	0x1A44,
	0x1A3E,
	0x1A36,
	0x1A26,
	0x1A2C,
	0x1A52,
	0x1A41,
	0x1A31,
	0x1A2D,
	0x1A42,
	0x1A4F,
	0x1A50,
	0x1A45,
	0x1AAD,
	0x1AA5,
	0x1AAC,
	0x1AA4,
	0x1AA8,
	0x1AA9,
	0x1AA3,
	0x1A7C,
	0x1A74,
	0x1A58,
	0x1A7B,
	0x1AA7,
	0x1A7A,
	0x1AA6,
	0x1A60,
	0x1AAA,
	0x1AAB,
	0x1AA2,
	0x1AA0,
	0x1AA1,
	0x1A98,
	0x1A95,
	0x1A94,
	0x1A99,
	0x1A91,
	0x1A97,
	0x1A96,
	0x1A93,
	0x1A92,
	0x1A90,
	0x1A61,
	0x1A63,
	0x1A6F,
	0x1A71,
	0x1A6E,
	0x1A65,
	0x1A66,
	0x1A62,
	0x1A6B,
	0x1A73,
	0x1A6C,
	0x1A70,
	0x1A6D,
	0x1A64,
	0x1A72,
	0x1A69,
	0x1A67,
	0x1A6A,
	0x1A68,
	0xAA9B,
	0xAA8D,
	0xAA8B,
	0xAA93,
	0xAAA1,
	0xAA87,
	0xAAAD,
	0xAA85,
	0xAA83,
	0xAA81,
	0xAAA9,
	0xAAA3,
	0xAA89,
	0xAA99,
	0xAA91,
	0xAAAF,
	0xAA9F,
	0xAA9D,
	0xAAA7,
	0xAA8F,
	0xAA97,
	0xAA95,
	0xAAAB,
	0xAAA5,
	0xAA9A,
	0xAA8C,
	0xAA8A,
	0xAA92,
	0xAAA0,
	0xAA86,
	0xAAAC,
	0xAA84,
	0xAA82,
	0xAA80,
	0xAAA8,
	0xAAA2,
	0xAA88,
	0xAA98,
	0xAA90,
	0xAAAE,
	0xAA9E,
	0xAA9C,
	0xAAA6,
	0xAA8E,
	0xAA96,
	0xAA94,
	0xAAAA,
	0xAAA4,
	0xAAB0,
	0xAAB7,
	0xAADE,
	0xAADF,
	0xAADB,
	0xAADC,
	0xAADD,
	0xAABF,
	0xAAC0,
	0xAAC2,
	0xAAC1,
	0xAAB1,
	0xAABE,
	0xAABD,
	0xAABB,
	0xAABC,
	0xAAB5,
	0xAAB2,
	0xAAB8,
	0xAAB6,
	0xAAB4,
	0xAABA,
	0xAAB3,
	0xAAB9,
	0x116C8,
	0x116C5,
	0x116C4,
	0x116C9,
	0x116C1,
	0x116C7,
	0x116C6,
	0x116C3,
	0x116C2,
	0x116C0,
	0x11680,
	0x11681,
	0x11687,
	0x11689,
	0x116A0,
	0x116A1,
	0x1168F,
	0x11690,
	0x1169B,
	0x11696,
	0x11697,
	0x1169C,
	0x11686,
	0x1168C,
	0x1168D,
	0x116A9,
	0x11682,
	0x11683,
	0x11691,
	0x11692,
	0x1168A,
	0x1168B,
	0x116A5,
	0x116A2,
	0x1169D,
	0x1168E,
	0x11698,
	0x11693,
	0x11688,
	0x1169E,
	0x1169F,
	0x116A4,
	0x116AA,
	0x116A8,
	0x116A7,
	0x11699,
	0x1169A,
	0x11694,
	0x11695,
	0x11684,
	0x11685,
	0x116A6,
	0x116A3,
	0x116AB,
	0x116B7,
	0x116B6,
	0x116AC,
	0x116AD,
	0x116B3,
	0x116B5,
	0x116B2,
	0x116AE,
	0x116AF,
	0x116B4,
	0x116B0,
	0x116B1,
	0x0BF8,
	0x0BD7,
	0x0BF7,
	0x0BF3,
	0x0BF6,
	0x0BEE,
	0x0BEB,
	0x0BEA,
	0x0BEF,
	0x0BE7,
	0x0BED,
	0x0BEC,
	0x0BE9,
	0x0BE8,
	0x0BE6,
	0x0B85,
	0x0B86,
	0x0B90,
	0x0B94,
	0x0B9A,
	0x0B8E,
	0x0B8F,
	0x0BB9,
	0x0B87,
	0x0B88,
	0x0B9C,
	0x0B95,
	0x0BB2,
	0x0BB3,
	0x0BB4,
	0x0BAE,
	0x0BA8,
	0x0B99,
	0x0BA3,
	0x0BA9,
	0x0B9E,
	0x0B92,
	0x0B93,
	0x0BAA,
	0x0BB0,
	0x0BB1,
	0x0BB8,
	0x0BB6,
	0x0BB7,
	0x0BA4,
	0x0B9F,
	0x0B89,
	0x0B8A,
	0x0BB5,
	0x0BAF,
	0x0BF4,
	0x0BF1,
	0x0BF2,
	0x0BFA,
	0x0BF0,
	0x0BD0,
	0x0BF9,
	0x0B82,
	0x0BCD,
	0x0B83,
	0x0BBE,
	0x0BC8,
	0x0BCC,
	0x0BC6,
	0x0BC7,
	0x0BBF,
	0x0BC0,
	0x0BCA,
	0x0BCB,
	0x0BC1,
	0x0BC2,
	0x0BF5,
	0x1F38B,
	0x1F34A,
	0x2707,
	0x2649,
	0x1F695,
	0x1F375,
	0x1F4C6,
	0x27BA,
	0x273B,
	0x2706,
	0x1F4DE,
	0x2315,
	0x2121,
	0x1F52D,
	0x1F4FA,
	0x0C56,
	0x0C6E,
	0x0C6B,
	0x0C6A,
	0x0C6F,
	0x0C67,
	0x0C6D,
	0x0C6C,
	0x0C69,
	0x0C68,
	0x0C66,
	0x0C7C,
	0x0C79,
	0x0C7E,
	0x0C7B,
	0x0C7D,
	0x0C7A,
	0x0C78,
	0x0C55,
	0x0C05,
	0x0C06,
	0x0C10,
	0x0C14,
	0x0C2C,
	0x0C2D,
	0x0C1A,
	0x0C1B,
	0x0C26,
	0x0C21,
	0x0C22,
	0x0C27,
	0x0C59,
	0x0C0E,
	0x0C0F,
	0x0C17,
	0x0C18,
	0x0C39,
	0x0C07,
	0x0C08,
	0x0C1C,
	0x0C1D,
	0x0C15,
	0x0C16,
	0x0C32,
	0x0C33,
	0x0C2E,
	0x0C28,
	0x0C19,
	0x0C23,
	0x0C1E,
	0x0C12,
	0x0C13,
	0x0C2A,
	0x0C2B,
	0x0C30,
	0x0C31,
	0x0C38,
	0x0C36,
	0x0C37,
	0x0C24,
	0x0C25,
	0x0C58,
	0x0C1F,
	0x0C20,
	0x0C09,
	0x0C0A,
	0x0C35,
	0x0C0C,
	0x0C61,
	0x0C0B,
	0x0C60,
	0x0C2F,
	0x0C02,
	0x0C3D,
	0x0C01,
	0x0C7F,
	0x0C4D,
	0x0C03,
	0x0C3E,
	0x0C48,
	0x0C4C,
	0x0C46,
	0x0C47,
	0x0C3F,
	0x0C40,
	0x0C4A,
	0x0C4B,
	0x0C41,
	0x0C42,
	0x0C62,
	0x0C63,
	0x0C43,
	0x0C44,
	0x20B8,
	0x1F3BE,
	0x26FA,
	0x1D341,
	0x1D319,
	0x1D351,
	0x1D30C,
	0x1D309,
	0x1D323,
	0x1D30E,
	0x1D306,
	0x1D321,
	0x1D33D,
	0x1D326,
	0x1D34F,
	0x1D34E,
	0x1D352,
	0x1D338,
	0x1D315,
	0x1D31E,
	0x1D30B,
	0x1D348,
	0x1D322,
	0x1D30F,
	0x1D347,
	0x1D354,
	0x1D33C,
	0x1D349,
	0x1D310,
	0x1D343,
	0x1D320,
	0x1D31C,
	0x1D342,
	0x1D330,
	0x1D31F,
	0x1D333,
	0x1D33A,
	0x1D34A,
	0x1D350,
	0x1D336,
	0x1D318,
	0x1D356,
	0x1D307,
	0x1D32B,
	0x1D328,
	0x1D33F,
	0x1D32F,
	0x1D332,
	0x1D33E,
	0x1D34D,
	0x1D316,
	0x1D312,
	0x1D346,
	0x1D31D,
	0x1D30A,
	0x1D327,
	0x1D355,
	0x1D32D,
	0x1D325,
	0x1D340,
	0x1D339,
	0x1D308,
	0x1D353,
	0x1D30D,
	0x1D324,
	0x1D334,
	0x1D313,
	0x1D32A,
	0x1D314,
	0x1D31A,
	0x1D32C,
	0x1D31B,
	0x1D32E,
	0x1D335,
	0x1D34B,
	0x1D345,
	0x1D34C,
	0x1D331,
	0x1D329,
	0x1D33B,
	0x1D337,
	0x1D317,
	0x1D344,
	0x1D311,
	0x07A7,
	0x07A6,
	0x07AC,
	0x07A9,
	0x07AD,
	0x07A8,
	0x07A2,
	0x0787,
	0x0784,
	0x0797,
	0x079F,
	0x0791,
	0x078B,
	0x078A,
	0x078E,
	0x07A3,
	0x078F,
	0x0780,
	0x0799,
	0x0796,
	0x0786,
	0x079A,
	0x078D,
	0x0785,
	0x0789,
	0x07B1,
	0x0782,
	0x0795,
	0x07A4,
	0x0783,
	0x079E,
	0x0790,
	0x0781,
	0x079D,
	0x0793,
	0x078C,
	0x079B,
	0x07A0,
	0x0798,
	0x0788,
	0x07A5,
	0x0794,
	0x079C,
	0x0792,
	0x07A1,
	0x07AF,
	0x07AE,
	0x07AB,
	0x07B0,
	0x07AA,
	0x0E5A,
	0x0E1A,
	0x0E08,
	0x0E0A,
	0x0E09,
	0x0E0C,
	0x0E0E,
	0x0E14,
	0x0E1D,
	0x0E1F,
	0x0E4F,
	0x0E2B,
	0x0E2E,
	0x0E02,
	0x0E05,
	0x0E03,
	0x0E04,
	0x0E06,
	0x0E5B,
	0x0E01,
	0x0E45,
	0x0E2C,
	0x0E25,
	0x0E26,
	0x0E4B,
	0x0E48,
	0x0E31,
	0x0E49,
	0x0E4A,
	0x0E47,
	0x0E46,
	0x0E21,
	0x0E07,
	0x0E4D,
	0x0E13,
	0x0E19,
	0x0E2D,
	0x0E2F,
	0x0E3A,
	0x0E1E,
	0x0E1C,
	0x0E20,
	0x0E1B,
	0x0E23,
	0x0E24,
	0x0E30,
	0x0E32,
	0x0E41,
	0x0E44,
	0x0E43,
	0x0E33,
	0x0E40,
	0x0E34,
	0x0E35,
	0x0E42,
	0x0E38,
	0x0E36,
	0x0E37,
	0x0E39,
	0x0E29,
	0x0E28,
	0x0E0B,
	0x0E2A,
	0x0E4C,
	0x0E11,
	0x0E12,
	0x0E17,
	0x0E10,
	0x0E18,
	0x0E16,
	0x0E0F,
	0x0E15,
	0x0E27,
	0x0E4E,
	0x0E22,
	0x0E0D,
	0x0E3F,
	0x0E58,
	0x0E55,
	0x0E54,
	0x0E59,
	0x0E51,
	0x0E57,
	0x0E56,
	0x0E53,
	0x0E52,
	0x0E50,
	0x2204,
	0x2203,
	0x2234,
	0x29E7,
	0x2009,
	0x1F4AD,
	0x2A76,
	0x27C0,
	0x2056,
	0x2B31,
	0x269F,
	0x269E,
	0x21F6,
	0x27A3,
	0x27A2,
	0x2E3B,
	0x2004,
	0x1F44E,
	0x1F44D,
	0x26C8,
	0x2608,
	0x0F18,
	0x0F19,
	0x0F17,
	0x0FC2,
	0x0FC0,
	0x0FC1,
	0x0FC3,
	0x0F28,
	0x0F25,
	0x0F24,
	0x0F31,
	0x0F2E,
	0x0F2D,
	0x0F32,
	0x0F2A,
	0x0F30,
	0x0F2F,
	0x0F2C,
	0x0F2B,
	0x0F33,
	0x0F29,
	0x0F21,
	0x0F27,
	0x0F26,
	0x0F23,
	0x0F22,
	0x0F20,
	0x0FBE,
	0x0FBF,
	0x0F60,
	0x0F68,
	0x0F56,
	0x0F57,
	0x0F45,
	0x0F46,
	0x0F51,
	0x0F4C,
	0x0F4D,
	0x0F52,
	0x0F5B,
	0x0F5C,
	0x0F6A,
	0x0F42,
	0x0F43,
	0x0F67,
	0x0F47,
	0x0F40,
	0x0F41,
	0x0F6B,
	0x0F69,
	0x0F63,
	0x0F58,
	0x0F53,
	0x0F44,
	0x0F4E,
	0x0F49,
	0x0F54,
	0x0F55,
	0x0F62,
	0x0F6C,
	0x0F66,
	0x0F64,
	0x0F65,
	0x0F4F,
	0x0F50,
	0x0F59,
	0x0F5A,
	0x0F4A,
	0x0F4B,
	0x0F5D,
	0x0F61,
	0x0F5F,
	0x0F5E,
	0x0F15,
	0x0F16,
	0x0F3D,
	0x0F3C,
	0x0F0A,
	0x0F34,
	0x0FD0,
	0x0F09,
	0x0F36,
	0x0F13,
	0x0F06,
	0x0F38,
	0x0FD4,
	0x0F05,
	0x0F0C,
	0x0F14,
	0x0F03,
	0x0F02,
	0x0F01,
	0x0F3B,
	0x0F3A,
	0x0F84,
	0x0FD3,
	0x0F04,
	0x0F0B,
	0x0FD9,
	0x0FD1,
	0x0F35,
	0x0F37,
	0x0F0E,
	0x0FD2,
	0x0F10,
	0x0F85,
	0x0F12,
	0x0F11,
	0x0F08,
	0x0F0D,
	0x0FDA,
	0x0F39,
	0x0F0F,
	0x0F07,
	0x0F8A,
	0x0F8B,
	0x0F8C,
	0x0F88,
	0x0F86,
	0x0F3F,
	0x0F89,
	0x0F82,
	0x0F1A,
	0x0F1B,
	0x0F1C,
	0x0F1F,
	0x0F1D,
	0x0F1E,
	0x0FCF,
	0x0FCE,
	0x0F7E,
	0x0F7F,
	0x0F83,
	0x0F87,
	0x0F3E,
	0x0FB0,
	0x0FB8,
	0x0FA6,
	0x0FA7,
	0x0F95,
	0x0F96,
	0x0FA1,
	0x0F9C,
	0x0F9D,
	0x0FA2,
	0x0FAB,
	0x0FAC,
	0x0FBC,
	0x0FBA,
	0x0FBB,
	0x0F92,
	0x0F93,
	0x0FB7,
	0x0F97,
	0x0F90,
	0x0F91,
	0x0FB9,
	0x0FB3,
	0x0FA8,
	0x0FA3,
	0x0F94,
	0x0F9E,
	0x0F99,
	0x0FA4,
	0x0FA5,
	0x0FB2,
	0x0FB6,
	0x0FB4,
	0x0FB5,
	0x0F9F,
	0x0FA0,
	0x0FA9,
	0x0FAA,
	0x0F9A,
	0x0F9B,
	0x0FAD,
	0x0FB1,
	0x0FAF,
	0x0FAE,
	0x0F8F,
	0x0F8D,
	0x0F8E,
	0x0F00,
	0x0FC4,
	0x0FC9,
	0x0FCC,
	0x0FCB,
	0x0FCA,
	0x0FC6,
	0x0FC8,
	0x0FC5,
	0x0FC7,
	0x0F71,
	0x0F7A,
	0x0F7B,
	0x0F72,
	0x0F73,
	0x0F7C,
	0x0F7D,
	0x0F80,
	0x0F81,
	0x0F74,
	0x0F75,
	0x0F78,
	0x0F79,
	0x0F76,
	0x0F77,
	0x1F3AB,
	0x29DD,
	0x2D7F,
	0x2D4B,
	0x2D58,
	0x2D41,
	0x2D35,
	0x2D64,
	0x2D57,
	0x2D50,
	0x2D42,
	0x2D3E,
	0x2D46,
	0x2D51,
	0x2D48,
	0x2D4C,
	0x2D30,
	0x2D44,
	0x2D31,
	0x2D32,
	0x2D5E,
	0x2D37,
	0x2D39,
	0x2D3A,
	0x2D38,
	0x2D3C,
	0x2D33,
	0x2D56,
	0x2D34,
	0x2D40,
	0x2D43,
	0x2D36,
	0x2D3D,
	0x2D45,
	0x2D3F,
	0x2D4D,
	0x2D4E,
	0x2D4F,
	0x2D52,
	0x2D47,
	0x2D54,
	0x2D55,
	0x2D59,
	0x2D5B,
	0x2D5A,
	0x2D5C,
	0x2D5D,
	0x2D5F,
	0x2D60,
	0x2D61,
	0x2D62,
	0x2D63,
	0x2D4A,
	0x2D65,
	0x2D66,
	0x2D3B,
	0x2D49,
	0x2D67,
	0x2D53,
	0x2D6F,
	0x2D70,
	0x1F405,
	0x1F42F,
	0x2745,
	0x007E,
	0x223C,
	0x2B49,
	0x2972,
	0x2A6A,
	0x2A6B,
	0x2E1E,
	0x2E1F,
	0x2E1B,
	0x23F2,
	0x29D4,
	0x29D5,
	0x29FE,
	0x10B3A,
	0x1F62B,
	0x204A,
	0x1F6BD,
	0x1F5FC,
	0x1F345,
	0x1F445,
	0x293A,
	0x293D,
	0x293C,
	0x23DE,
	0x2320,
	0x2E39,
	0x1F3A9,
	0x231C,
	0x230F,
	0x2E22,
	0x23DC,
	0x231D,
	0x230E,
	0x2E23,
	0x23B4,
	0x23E0,
	0x1F51D,
	0x1F242,
	0x1F247,
	0x1F240,
	0x1F12A,
	0x2330,
	0x1F69C,
	0x2122,
	0x1F686,
	0x1F68A,
	0x1F68B,
	0x2ADB,
	0x29CA,
	0x29CD,
	0x29CB,
	0x279D,
	0x2023,
	0x1F6A9,
	0x1F4D0,
	0x205D,
	0x1F531,
	0x2637,
	0x2632,
	0x2630,
	0x2631,
	0x2636,
	0x2633,
	0x2635,
	0x2634,
	0x2AF6,
	0x2A68,
	0x2A69,
	0x222D,
	0x2AF8,
	0x2AF7,
	0x29FB,
	0x2034,
	0x2AFB,
	0x224B,
	0x2AF4,
	0x2980,
	0x22AA,
	0x2AF5,
	0x1F68E,
	0x1F3C6,
	0x1F379,
	0x1F420,
	0x22A8,
	0x1F3BA,
	0x20AE,
	0x1F337,
	0x20BA,
	0x214B,
	0x29A2,
	0x26CA,
	0x2132,
	0x2E32,
	0x2E38,
	0x2129,
	0x2319,
	0x2141,
	0x2142,
	0x2144,
	0x2E35,
	0x214E,
	0x26C9,
	0x1F422,
	0x2739,
	0x1F500,
	0x2051,
	0x2A75,
	0x2025,
	0x205A,
	0x2E2A,
	0x1F495,
	0x2A55,
	0x2A56,
	0x29C9,
	0x2A07,
	0x2A08,
	0x1F46C,
	0x1F46D,
	0x2E3A,
	0x10393,
	0x10380,
	0x10381,
	0x10384,
	0x1038F,
	0x10382,
	0x10399,
	0x10385,
	0x10388,
	0x1039B,
	0x1038B,
	0x10383,
	0x1038D,
	0x1038E,
	0x10390,
	0x10394,
	0x10396,
	0x10397,
	0x10395,
	0x10392,
	0x1038C,
	0x1039D,
	0x10389,
	0x10398,
	0x1039A,
	0x1039C,
	0x10386,
	0x1038A,
	0x10387,
	0x10391,
	0x1039F,
	0x2602,
	0x26F1,
	0x2614,
	0x1F612,
	0x203F,
	0x238C,
	0x222A,
	0x2A48,
	0x2A46,
	0x2A4A,
	0x2A45,
	0x2A41,
	0x2A42,
	0x2672,
	0x26AF,
	0x29BD,
	0x2303,
	0x2324,
	0x2951,
	0x294D,
	0x294C,
	0x294F,
	0x2195,
	0x21A8,
	0x2B0D,
	0x21D5,
	0x21F3,
	0x297E,
	0x22F0,
	0x22A5,
	0x27DF,
	0x1F53A,
	0x1F53C,
	0x25ED,
	0x25EE,
	0x2701,
	0x2580,
	0x25E0,
	0x25DA,
	0x27D4,
	0x23B0,
	0x25DC,
	0x25F8,
	0x2594,
	0x2750,
	0x23B1,
	0x2710,
	0x25DD,
	0x2752,
	0x25F9,
	0x2E15,
	0x2191,
	0x21A5,
	0x21C5,
	0x2912,
	0x21DE,
	0x2909,
	0x21B0,
	0x21B1,
	0x2B06,
	0x21E1,
	0x21D1,
	0x296E,
	0x2963,
	0x2960,
	0x2958,
	0x21BF,
	0x295C,
	0x2954,
	0x21BE,
	0x21C8,
	0x27F0,
	0x290A,
	0x219F,
	0x2949,
	0x21E7,
	0x21EA,
	0x21EB,
	0x21EC,
	0x21ED,
	0x21EE,
	0x21EF,
	0x2645,
	0xA60D,
	0xA628,
	0xA625,
	0xA624,
	0xA629,
	0xA621,
	0xA627,
	0xA626,
	0xA623,
	0xA622,
	0xA620,
	0xA60E,
	0xA60F,
	0xA549,
	0xA54A,
	0xA552,
	0xA5EA,
	0xA507,
	0xA551,
	0xA5E9,
	0xA506,
	0xA52B,
	0xA5C2,
	0xA577,
	0xA59C,
	0xA52C,
	0xA5C3,
	0xA578,
	0xA59D,
	0xA566,
	0xA5FF,
	0xA51A,
	0xA53F,
	0xA5D7,
	0xA58B,
	0xA5B0,
	0xA560,
	0xA5F9,
	0xA514,
	0xA55C,
	0xA5F5,
	0xA510,
	0xA55D,
	0xA5F6,
	0xA511,
	0xA536,
	0xA5CE,
	0xA582,
	0xA5A7,
	0xA535,
	0xA5CD,
	0xA581,
	0xA5A6,
	0xA539,
	0xA5D1,
	0xA585,
	0xA5AA,
	0xA5E1,
	0xA500,
	0xA501,
	0xA5E2,
	0xA558,
	0xA5F1,
	0xA50C,
	0xA531,
	0xA5C9,
	0xA57D,
	0xA5A2,
	0xA56D,
	0xA557,
	0xA5EF,
	0xA50B,
	0xA5F0,
	0xA530,
	0xA5C7,
	0xA5C8,
	0xA57C,
	0xA5A1,
	0xA606,
	0xA520,
	0xA607,
	0xA545,
	0xA5DD,
	0xA591,
	0xA5B6,
	0xA54C,
	0xA54D,
	0xA5E4,
	0xA502,
	0xA5E5,
	0xA526,
	0xA527,
	0xA5BD,
	0xA5BE,
	0xA573,
	0xA597,
	0xA598,
	0xA524,
	0xA525,
	0xA567,
	0xA600,
	0xA51B,
	0xA540,
	0xA5D8,
	0xA58C,
	0xA5B1,
	0xA56A,
	0xA56B,
	0xA603,
	0xA51E,
	0xA543,
	0xA5DB,
	0xA58F,
	0xA554,
	0xA555,
	0xA5EC,
	0xA509,
	0xA5ED,
	0xA52E,
	0xA5C5,
	0xA57A,
	0xA59F,
	0xA5B4,
	0xA55E,
	0xA5F7,
	0xA512,
	0xA60C,
	0xA537,
	0xA5CF,
	0xA583,
	0xA5A8,
	0xA56E,
	0xA553,
	0xA5EB,
	0xA508,
	0xA52D,
	0xA5C4,
	0xA579,
	0xA59E,
	0xA608,
	0xA521,
	0xA556,
	0xA5EE,
	0xA50A,
	0xA52F,
	0xA5C6,
	0xA57B,
	0xA5A0,
	0xA546,
	0xA5DE,
	0xA592,
	0xA5B7,
	0xA56F,
	0xA561,
	0xA5FA,
	0xA515,
	0xA53A,
	0xA5D2,
	0xA62B,
	0xA610,
	0xA611,
	0xA62A,
	0xA612,
	0xA586,
	0xA5AB,
	0xA609,
	0xA522,
	0xA60B,
	0xA54B,
	0xA5E3,
	0xA56C,
	0xA604,
	0xA51F,
	0xA605,
	0xA544,
	0xA5DC,
	0xA590,
	0xA5B5,
	0xA5BC,
	0xA547,
	0xA568,
	0xA601,
	0xA51C,
	0xA541,
	0xA5D9,
	0xA58D,
	0xA5B2,
	0xA5DF,
	0xA593,
	0xA5B8,
	0xA570,
	0xA60A,
	0xA523,
	0xA548,
	0xA5E0,
	0xA594,
	0xA5B9,
	0xA5BA,
	0xA5BB,
	0xA571,
	0xA572,
	0xA550,
	0xA5E8,
	0xA505,
	0xA52A,
	0xA5C1,
	0xA576,
	0xA59B,
	0xA55F,
	0xA5F8,
	0xA513,
	0xA538,
	0xA5D0,
	0xA584,
	0xA5A9,
	0xA562,
	0xA5FB,
	0xA516,
	0xA563,
	0xA5FC,
	0xA517,
	0xA53C,
	0xA5D4,
	0xA588,
	0xA5AD,
	0xA53B,
	0xA5D3,
	0xA587,
	0xA5AC,
	0xA55A,
	0xA5F3,
	0xA50E,
	0xA55B,
	0xA5F4,
	0xA50F,
	0xA534,
	0xA5CC,
	0xA580,
	0xA5A5,
	0xA533,
	0xA5CB,
	0xA57F,
	0xA5A4,
	0xA595,
	0xA596,
	0xA559,
	0xA5F2,
	0xA50D,
	0xA532,
	0xA5CA,
	0xA57E,
	0xA5A3,
	0xA54E,
	0xA54F,
	0xA5E6,
	0xA503,
	0xA504,
	0xA5E7,
	0xA528,
	0xA529,
	0xA5BF,
	0xA5C0,
	0xA574,
	0xA575,
	0xA599,
	0xA59A,
	0xA569,
	0xA602,
	0xA51D,
	0xA542,
	0xA5DA,
	0xA58E,
	0xA5B3,
	0xA564,
	0xA5FD,
	0xA518,
	0xA565,
	0xA5FE,
	0xA519,
	0xA53E,
	0xA5D6,
	0xA58A,
	0xA5AF,
	0xA53D,
	0xA5D5,
	0xA589,
	0xA5AE,
	0xA617,
	0xA61A,
	0xA61E,
	0xA61B,
	0xA618,
	0xA613,
	0xA61F,
	0xA614,
	0xA61C,
	0xA616,
	0xA619,
	0xA615,
	0xA61D,
	0x2A2F,
	0x1CE9,
	0x1CEA,
	0x1CF1,
	0x1CEB,
	0x1CEC,
	0x1CF2,
	0x1CEE,
	0x1CF5,
	0x1CEF,
	0x1CD3,
	0x1CE6,
	0x1CE4,
	0x1CF3,
	0x1CF0,
	0x1CED,
	0x1CF6,
	0x1CE5,
	0x1CE8,
	0x1CE2,
	0x1CE3,
	0x1CE7,
	0x1CD4,
	0x1CE1,
	0x1CF4,
	0x1CD8,
	0x1CDD,
	0x1CDA,
	0x1CD0,
	0x1CDC,
	0x1CD2,
	0x1CE0,
	0x1CD1,
	0x1CDF,
	0x1CDB,
	0x1CDE,
	0x1CD5,
	0x1CD6,
	0x1CD7,
	0x1CD9,
	0x2123,
	0x29D0,
	0x2AE4,
	0x2AE2,
	0x27CA,
	0x22EE,
	0x205E,
	0x303B,
	0x3031,
	0x3035,
	0x3033,
	0x3032,
	0x3034,
	0x007C,
	0x23D0,
	0x2AEF,
	0x2AF0,
	0x237F,
	0x26A8,
	0x2E2F,
	0x1F6A6,
	0x299A,
	0x22D9,
	0x22D8,
	0x26B6,
	0x1F4F3,
	0x270C,
	0x1F4F9,
	0x1F3AE,
	0x1F4FC,
	0x2317,
	0x1F3BB,
	0x264D,
	0x1F30B,
	0x2230,
	0x215D,
	0x215A,
	0x2158,
	0x215B,
	0x2155,
	0x00BD,
	0x2151,
	0x00BC,
	0x2150,
	0x2159,
	0x2152,
	0x2153,
	0x215E,
	0x215C,
	0x2157,
	0x00BE,
	0x2156,
	0x2154,
	0x2189,
	0x1F318,
	0x1F316,
	0x26A0,
	0x231A,
	0x1F403,
	0x1F6BE,
	0x1F30A,
	0x1F349,
	0x2B3F,
	0x2933,
	0x301C,
	0x1F44B,
	0x3030,
	0x2307,
	0xFE4F,
	0xFE4B,
	0x1F312,
	0x1F314,
	0x1F640,
	0x1F629,
	0x1F492,
	0x27BC,
	0x2670,
	0x1F40B,
	0x2638,
	0x267F,
	0x25E6,
	0x2657,
	0x2654,
	0x2658,
	0x2659,
	0x2655,
	0x2656,
	0x25CB,
	0x2686,
	0x29EC,
	0x25F5,
	0x25F6,
	0x2687,
	0x25F4,
	0x25F7,
	0x2667,
	0x27E1,
	0x27E2,
	0x27E3,
	0x25C7,
	0x25C8,
	0x26CB,
	0x2662,
	0x27D0,
	0x1F447,
	0x261F,
	0x25BF,
	0x25BD,
	0x26C1,
	0x26C0,
	0x2755,
	0x2690,
	0x26FF,
	0x2740,
	0x1F4AE,
	0x2727,
	0x2639,
	0x2661,
	0x2705,
	0x2B21,
	0x2B2D,
	0x29D6,
	0x2B1C,
	0x26D9,
	0x1F448,
	0x261C,
	0x25C5,
	0x25C3,
	0x25C1,
	0x2B26,
	0x2B28,
	0x25FD,
	0x25FB,
	0x2B50,
	0x2711,
	0x25B1,
	0x2B20,
	0x2754,
	0x25AD,
	0x1F449,
	0x261E,
	0x2B54,
	0x25BB,
	0x25B9,
	0x25B7,
	0x2704,
	0xFE46,
	0x2616,
	0x2B2B,
	0x25AB,
	0x2B52,
	0x263A,
	0x2664,
	0x25A1,
	0x1F533,
	0x25A3,
	0x2385,
	0x27E4,
	0x25F1,
	0x25F2,
	0x27E5,
	0x25A2,
	0x25F0,
	0x25F3,
	0x25EB,
	0x2606,
	0x263C,
	0x260F,
	0x23E2,
	0x27C1,
	0x26D7,
	0x1F446,
	0x261D,
	0x25B5,
	0x25B3,
	0x25EC,
	0x2AFE,
	0x2B2F,
	0x25AF,
	0x2B1E,
	0x27B3,
	0x1F390,
	0x1F377,
	0x1F609,
	0x1F43A,
	0x1F469,
	0x1F46F,
	0x1F462,
	0x1F45A,
	0x1F452,
	0x1F461,
	0x1F6BA,
	0x20A9,
	0x2060,
	0x2E31,
	0x1F61F,
	0x1F381,
	0x2240,
	0x1F527,
	0x270D,
	0x2327,
	0x22BB,
	0x1F49B,
	0x00A5,
	0xA49B,
	0xA4A5,
	0xA4C3,
	0xA4BE,
	0xA4BD,
	0xA4BC,
	0xA494,
	0xA4A3,
	0xA4A4,
	0xA4B9,
	0xA4A1,
	0xA497,
	0xA496,
	0xA4A6,
	0xA4B6,
	0xA4AD,
	0xA499,
	0xA4BF,
	0xA49F,
	0xA4B7,
	0xA4AA,
	0xA4B5,
	0xA4B3,
	0xA4C6,
	0xA492,
	0xA491,
	0xA4BB,
	0xA49A,
	0xA498,
	0xA49C,
	0xA4C5,
	0xA493,
	0xA4A7,
	0xA4B4,
	0xA4A9,
	0xA49E,
	0xA4AC,
	0xA490,
	0xA4C0,
	0xA4C2,
	0xA4BA,
	0xA4B0,
	0xA495,
	0xA4A0,
	0xA4A8,
	0xA4B1,
	0xA4AF,
	0xA4B8,
	0xA4AE,
	0xA49D,
	0xA4B2,
	0xA4AB,
	0xA4A2,
	0xA4C1,
	0xA4C4,
	0xA00A,
	0xA00B,
	0xA008,
	0xA009,
	0xA020,
	0xA021,
	0xA01E,
	0xA01F,
	0xA060,
	0xA061,
	0xA05E,
	0xA05F,
	0xA06A,
	0xA06B,
	0xA069,
	0xA058,
	0xA05C,
	0xA05D,
	0xA05A,
	0xA05B,
	0xA059,
	0xA056,
	0xA057,
	0xA067,
	0xA068,
	0xA065,
	0xA066,
	0xA06E,
	0xA063,
	0xA064,
	0xA062,
	0xA06F,
	0xA071,
	0xA070,
	0xA06C,
	0xA06D,
	0xA074,
	0xA075,
	0xA072,
	0xA073,
	0xA02A,
	0xA02B,
	0xA029,
	0xA018,
	0xA01C,
	0xA01D,
	0xA01A,
	0xA01B,
	0xA019,
	0xA016,
	0xA017,
	0xA027,
	0xA028,
	0xA025,
	0xA026,
	0xA02E,
	0xA023,
	0xA024,
	0xA022,
	0xA02F,
	0xA031,
	0xA030,
	0xA02C,
	0xA02D,
	0xA034,
	0xA035,
	0xA037,
	0xA036,
	0xA032,
	0xA033,
	0xA2B8,
	0xA2B9,
	0xA2B6,
	0xA2B7,
	0xA2C2,
	0xA2C3,
	0xA2C1,
	0xA363,
	0xA364,
	0xA361,
	0xA362,
	0xA36F,
	0xA370,
	0xA36D,
	0xA36E,
	0xA36B,
	0xA36C,
	0xA369,
	0xA36A,
	0xA372,
	0xA367,
	0xA368,
	0xA365,
	0xA366,
	0xA373,
	0xA375,
	0xA374,
	0xA371,
	0xA378,
	0xA379,
	0xA37B,
	0xA37A,
	0xA376,
	0xA377,
	0xA2B0,
	0xA2B4,
	0xA2B5,
	0xA2B2,
	0xA2B3,
	0xA2B1,
	0xA2AE,
	0xA2AF,
	0xA2BF,
	0xA2C0,
	0xA2BD,
	0xA2BE,
	0xA2C6,
	0xA2BB,
	0xA2BC,
	0xA2BA,
	0xA2C7,
	0xA2C9,
	0xA2C8,
	0xA2C4,
	0xA2C5,
	0xA2CC,
	0xA2CD,
	0xA2CF,
	0xA2CE,
	0xA2CA,
	0xA2CB,
	0xA109,
	0xA10A,
	0xA107,
	0xA108,
	0xA13F,
	0xA140,
	0xA13D,
	0xA13E,
	0xA149,
	0xA14A,
	0xA148,
	0xA138,
	0xA13B,
	0xA13C,
	0xA13A,
	0xA139,
	0xA136,
	0xA137,
	0xA146,
	0xA147,
	0xA144,
	0xA145,
	0xA14D,
	0xA142,
	0xA143,
	0xA141,
	0xA14E,
	0xA150,
	0xA14F,
	0xA14B,
	0xA14C,
	0xA112,
	0xA113,
	0xA111,
	0xA102,
	0xA105,
	0xA106,
	0xA104,
	0xA103,
	0xA100,
	0xA101,
	0xA10F,
	0xA110,
	0xA10D,
	0xA10E,
	0xA116,
	0xA10C,
	0xA10B,
	0xA117,
	0xA119,
	0xA118,
	0xA114,
	0xA115,
	0xA014,
	0xA013,
	0xA0D3,
	0xA0D4,
	0xA0D1,
	0xA0D2,
	0xA0CF,
	0xA0D0,
	0xA0CD,
	0xA0CE,
	0xA0D6,
	0xA0D7,
	0xA0D5,
	0xA0DA,
	0xA0DB,
	0xA0DD,
	0xA0DC,
	0xA0D8,
	0xA0D9,
	0xA0E0,
	0xA0E1,
	0xA0DE,
	0xA0DF,
	0xA1E4,
	0xA1E5,
	0xA1E2,
	0xA1E3,
	0xA1F0,
	0xA1F1,
	0xA1EE,
	0xA1EF,
	0xA21C,
	0xA21D,
	0xA21A,
	0xA21B,
	0xA228,
	0xA229,
	0xA226,
	0xA227,
	0xA216,
	0xA218,
	0xA219,
	0xA217,
	0xA214,
	0xA215,
	0xA224,
	0xA225,
	0xA222,
	0xA223,
	0xA22C,
	0xA220,
	0xA221,
	0xA21E,
	0xA21F,
	0xA22D,
	0xA22F,
	0xA22E,
	0xA22A,
	0xA22B,
	0xA1DC,
	0xA1E0,
	0xA1E1,
	0xA1DE,
	0xA1DF,
	0xA1DD,
	0xA1DA,
	0xA1DB,
	0xA1EC,
	0xA1ED,
	0xA1EA,
	0xA1EB,
	0xA1F4,
	0xA1E8,
	0xA1E9,
	0xA1E6,
	0xA1E7,
	0xA1F5,
	0xA1F7,
	0xA1F6,
	0xA1F2,
	0xA1F3,
	0xA273,
	0xA274,
	0xA271,
	0xA272,
	0xA27E,
	0xA27F,
	0xA27D,
	0xA270,
	0xA26F,
	0xA26E,
	0xA1A0,
	0xA1A1,
	0xA19E,
	0xA19F,
	0xA1A9,
	0xA1AA,
	0xA1A8,
	0xA199,
	0xA19C,
	0xA19D,
	0xA19B,
	0xA19A,
	0xA197,
	0xA198,
	0xA1A6,
	0xA1A7,
	0xA1A5,
	0xA1AD,
	0xA1A3,
	0xA1A4,
	0xA1A2,
	0xA1AE,
	0xA1B0,
	0xA1AF,
	0xA1AB,
	0xA1AC,
	0xA1B3,
	0xA1B4,
	0xA1B6,
	0xA1B5,
	0xA1B1,
	0xA1B2,
	0xA09A,
	0xA09B,
	0xA098,
	0xA099,
	0xA093,
	0xA096,
	0xA097,
	0xA095,
	0xA094,
	0xA091,
	0xA092,
	0xA0A1,
	0xA0A2,
	0xA09F,
	0xA0A0,
	0xA0A5,
	0xA09D,
	0xA09E,
	0xA09C,
	0xA0A6,
	0xA0A8,
	0xA0A7,
	0xA0A3,
	0xA0A4,
	0xA0AA,
	0xA0AB,
	0xA0AD,
	0xA0AC,
	0xA0A9,
	0xA172,
	0xA173,
	0xA170,
	0xA171,
	0xA17A,
	0xA17B,
	0xA179,
	0xA16A,
	0xA16E,
	0xA16F,
	0xA16C,
	0xA16D,
	0xA16B,
	0xA168,
	0xA169,
	0xA178,
	0xA176,
	0xA177,
	0xA175,
	0xA174,
	0xA17C,
	0xA27B,
	0xA27C,
	0xA279,
	0xA27A,
	0xA277,
	0xA278,
	0xA275,
	0xA276,
	0xA250,
	0xA251,
	0xA24E,
	0xA24F,
	0xA25B,
	0xA25C,
	0xA25A,
	0xA248,
	0xA24C,
	0xA24D,
	0xA24A,
	0xA24B,
	0xA249,
	0xA246,
	0xA247,
	0xA258,
	0xA259,
	0xA256,
	0xA257,
	0xA254,
	0xA255,
	0xA252,
	0xA253,
	0xA002,
	0xA006,
	0xA007,
	0xA004,
	0xA005,
	0xA003,
	0xA000,
	0xA001,
	0xA3E2,
	0xA3E6,
	0xA3E7,
	0xA3E4,
	0xA3E5,
	0xA3E3,
	0xA3E0,
	0xA3E1,
	0xA41A,
	0xA41E,
	0xA41F,
	0xA41C,
	0xA41D,
	0xA41B,
	0xA418,
	0xA419,
	0xA425,
	0xA426,
	0xA423,
	0xA424,
	0xA429,
	0xA421,
	0xA422,
	0xA420,
	0xA42A,
	0xA42C,
	0xA42B,
	0xA427,
	0xA428,
	0xA42F,
	0xA430,
	0xA42D,
	0xA42E,
	0xA3EE,
	0xA3EF,
	0xA3EC,
	0xA3ED,
	0xA3F2,
	0xA3EA,
	0xA3EB,
	0xA3E8,
	0xA3E9,
	0xA3F3,
	0xA3F5,
	0xA3F4,
	0xA3F0,
	0xA3F1,
	0xA3F8,
	0xA3F9,
	0xA3FB,
	0xA3FA,
	0xA3F6,
	0xA3F7,
	0xA201,
	0xA202,
	0xA1FF,
	0xA200,
	0xA20C,
	0xA20D,
	0xA20A,
	0xA20B,
	0xA1FA,
	0xA1FD,
	0xA1FE,
	0xA1FC,
	0xA1FB,
	0xA1F8,
	0xA1F9,
	0xA208,
	0xA209,
	0xA206,
	0xA207,
	0xA210,
	0xA204,
	0xA205,
	0xA203,
	0xA211,
	0xA213,
	0xA212,
	0xA20E,
	0xA20F,
	0xA1C1,
	0xA1C2,
	0xA1BF,
	0xA1C0,
	0xA1CC,
	0xA1CD,
	0xA1CB,
	0xA1B9,
	0xA1BD,
	0xA1BE,
	0xA1BB,
	0xA1BC,
	0xA1BA,
	0xA1B7,
	0xA1B8,
	0xA1C9,
	0xA1CA,
	0xA1C7,
	0xA1C8,
	0xA1D0,
	0xA1C5,
	0xA1C6,
	0xA1C3,
	0xA1C4,
	0xA1D1,
	0xA1D3,
	0xA1D2,
	0xA1CE,
	0xA1CF,
	0xA1D6,
	0xA1D7,
	0xA1D9,
	0xA1D8,
	0xA1D4,
	0xA1D5,
	0xA0B7,
	0xA0B8,
	0xA0B5,
	0xA0B6,
	0xA0C2,
	0xA0C1,
	0xA234,
	0xA235,
	0xA232,
	0xA233,
	0xA23E,
	0xA23F,
	0xA23D,
	0xA231,
	0xA230,
	0xA23B,
	0xA23C,
	0xA239,
	0xA23A,
	0xA242,
	0xA237,
	0xA238,
	0xA236,
	0xA243,
	0xA245,
	0xA244,
	0xA240,
	0xA241,
	0xA0B0,
	0xA0B3,
	0xA0B4,
	0xA0B2,
	0xA0B1,
	0xA0AE,
	0xA0AF,
	0xA0BF,
	0xA0C0,
	0xA0BD,
	0xA0BE,
	0xA0C5,
	0xA0BB,
	0xA0BC,
	0xA0B9,
	0xA0BA,
	0xA0C6,
	0xA0C8,
	0xA0C7,
	0xA0C3,
	0xA0C4,
	0xA0CB,
	0xA0CC,
	0xA0C9,
	0xA0CA,
	0xA185,
	0xA186,
	0xA184,
	0xA07F,
	0xA080,
	0xA07D,
	0xA07E,
	0xA078,
	0xA07B,
	0xA07C,
	0xA07A,
	0xA079,
	0xA076,
	0xA077,
	0xA083,
	0xA084,
	0xA081,
	0xA082,
	0xA087,
	0xA088,
	0xA08A,
	0xA089,
	0xA085,
	0xA086,
	0xA08D,
	0xA08E,
	0xA090,
	0xA08F,
	0xA08B,
	0xA08C,
	0xA159,
	0xA15A,
	0xA157,
	0xA158,
	0xA160,
	0xA161,
	0xA15F,
	0xA153,
	0xA156,
	0xA155,
	0xA154,
	0xA151,
	0xA152,
	0xA15D,
	0xA15E,
	0xA15B,
	0xA15C,
	0xA164,
	0xA165,
	0xA167,
	0xA166,
	0xA162,
	0xA163,
	0xA18F,
	0xA190,
	0xA18E,
	0xA262,
	0xA263,
	0xA260,
	0xA261,
	0xA26C,
	0xA26D,
	0xA26B,
	0xA25E,
	0xA25F,
	0xA25D,
	0xA269,
	0xA26A,
	0xA267,
	0xA268,
	0xA266,
	0xA264,
	0xA265,
	0xA17F,
	0xA182,
	0xA183,
	0xA181,
	0xA180,
	0xA17D,
	0xA17E,
	0xA433,
	0xA437,
	0xA438,
	0xA435,
	0xA436,
	0xA434,
	0xA431,
	0xA432,
	0xA43D,
	0xA43E,
	0xA43B,
	0xA43C,
	0xA440,
	0xA43A,
	0xA439,
	0xA441,
	0xA443,
	0xA442,
	0xA43F,
	0xA446,
	0xA447,
	0xA449,
	0xA448,
	0xA444,
	0xA445,
	0xA18C,
	0xA18D,
	0xA18A,
	0xA18B,
	0xA396,
	0xA397,
	0xA394,
	0xA395,
	0xA39D,
	0xA39E,
	0xA39B,
	0xA39C,
	0xA399,
	0xA39A,
	0xA398,
	0xA3A1,
	0xA3A2,
	0xA3A4,
	0xA3A3,
	0xA39F,
	0xA3A0,
	0xA3A7,
	0xA3A8,
	0xA3AA,
	0xA3A9,
	0xA3A5,
	0xA3A6,
	0xA193,
	0xA188,
	0xA189,
	0xA187,
	0xA194,
	0xA196,
	0xA195,
	0xA191,
	0xA192,
	0xA44C,
	0xA450,
	0xA451,
	0xA44E,
	0xA44F,
	0xA44D,
	0xA44A,
	0xA44B,
	0xA457,
	0xA458,
	0xA455,
	0xA456,
	0xA45B,
	0xA453,
	0xA454,
	0xA452,
	0xA45C,
	0xA459,
	0xA45A,
	0xA2F6,
	0xA2F7,
	0xA2F4,
	0xA2F5,
	0xA2FD,
	0xA2FC,
	0xA2EF,
	0xA2F2,
	0xA2F3,
	0xA2F1,
	0xA2F0,
	0xA2ED,
	0xA2EE,
	0xA2FB,
	0xA2FA,
	0xA2FF,
	0xA2F9,
	0xA2F8,
	0xA300,
	0xA302,
	0xA301,
	0xA2FE,
	0xA305,
	0xA306,
	0xA308,
	0xA307,
	0xA303,
	0xA304,
	0xA011,
	0xA012,
	0xA00F,
	0xA010,
	0xA041,
	0xA042,
	0xA03F,
	0xA040,
	0xA03A,
	0xA03D,
	0xA03E,
	0xA03C,
	0xA03B,
	0xA038,
	0xA039,
	0xA048,
	0xA049,
	0xA046,
	0xA047,
	0xA04C,
	0xA044,
	0xA045,
	0xA043,
	0xA04D,
	0xA04F,
	0xA04E,
	0xA04A,
	0xA04B,
	0xA052,
	0xA053,
	0xA055,
	0xA054,
	0xA050,
	0xA051,
	0xA3FE,
	0xA402,
	0xA403,
	0xA400,
	0xA401,
	0xA3FF,
	0xA3FC,
	0xA3FD,
	0xA40A,
	0xA40B,
	0xA408,
	0xA409,
	0xA40E,
	0xA406,
	0xA407,
	0xA404,
	0xA405,
	0xA40F,
	0xA411,
	0xA410,
	0xA40C,
	0xA40D,
	0xA414,
	0xA415,
	0xA417,
	0xA416,
	0xA412,
	0xA413,
	0xA3C8,
	0xA3C9,
	0xA3C6,
	0xA3C7,
	0xA3D2,
	0xA3D3,
	0xA3D1,
	0xA3CF,
	0xA3D0,
	0xA3CD,
	0xA3CE,
	0xA37D,
	0xA37C,
	0xA386,
	0xA387,
	0xA384,
	0xA385,
	0xA382,
	0xA383,
	0xA380,
	0xA381,
	0xA38A,
	0xA37F,
	0xA37E,
	0xA38B,
	0xA38D,
	0xA38C,
	0xA388,
	0xA389,
	0xA390,
	0xA391,
	0xA393,
	0xA392,
	0xA38E,
	0xA38F,
	0xA3D6,
	0xA3CB,
	0xA3CC,
	0xA3CA,
	0xA3D7,
	0xA3D9,
	0xA3D8,
	0xA3D4,
	0xA3D5,
	0xA3DC,
	0xA3DD,
	0xA3DF,
	0xA3DE,
	0xA3DA,
	0xA3DB,
	0xA312,
	0xA313,
	0xA310,
	0xA311,
	0xA31C,
	0xA31D,
	0xA31B,
	0xA3AD,
	0xA3AE,
	0xA3AB,
	0xA3AC,
	0xA3B8,
	0xA3B9,
	0xA3B6,
	0xA3B7,
	0xA3B4,
	0xA3B5,
	0xA3B2,
	0xA3B3,
	0xA3BC,
	0xA3B0,
	0xA3B1,
	0xA3AF,
	0xA3BD,
	0xA3BF,
	0xA3BE,
	0xA3BA,
	0xA3BB,
	0xA3C2,
	0xA3C3,
	0xA3C5,
	0xA3C4,
	0xA3C0,
	0xA3C1,
	0xA30B,
	0xA30E,
	0xA30F,
	0xA30D,
	0xA30C,
	0xA309,
	0xA30A,
	0xA319,
	0xA31A,
	0xA317,
	0xA318,
	0xA333,
	0xA334,
	0xA331,
	0xA332,
	0xA33A,
	0xA33B,
	0xA339,
	0xA32C,
	0xA32F,
	0xA330,
	0xA32E,
	0xA32D,
	0xA32A,
	0xA32B,
	0xA337,
	0xA338,
	0xA335,
	0xA336,
	0xA33E,
	0xA33F,
	0xA33C,
	0xA33D,
	0xA342,
	0xA343,
	0xA345,
	0xA344,
	0xA340,
	0xA341,
	0xA320,
	0xA315,
	0xA316,
	0xA314,
	0xA321,
	0xA323,
	0xA322,
	0xA31E,
	0xA31F,
	0xA326,
	0xA327,
	0xA329,
	0xA328,
	0xA324,
	0xA325,
	0xA123,
	0xA124,
	0xA121,
	0xA122,
	0xA12E,
	0xA12F,
	0xA12D,
	0xA11C,
	0xA11F,
	0xA120,
	0xA11E,
	0xA11D,
	0xA11A,
	0xA11B,
	0xA12B,
	0xA12C,
	0xA129,
	0xA12A,
	0xA132,
	0xA127,
	0xA128,
	0xA125,
	0xA126,
	0xA133,
	0xA135,
	0xA134,
	0xA130,
	0xA131,
	0xA00D,
	0xA00E,
	0xA00C,
	0xA0EC,
	0xA0ED,
	0xA0EA,
	0xA0EB,
	0xA0F3,
	0xA0F2,
	0xA0E4,
	0xA0E8,
	0xA0E9,
	0xA0E6,
	0xA0E7,
	0xA0E5,
	0xA0E2,
	0xA0E3,
	0xA0F0,
	0xA0F1,
	0xA0EE,
	0xA0EF,
	0xA0F6,
	0xA0F7,
	0xA0F9,
	0xA0F8,
	0xA0F4,
	0xA0F5,
	0xA0FC,
	0xA0FD,
	0xA0FF,
	0xA0FE,
	0xA0FA,
	0xA0FB,
	0xA282,
	0xA283,
	0xA280,
	0xA281,
	0xA28B,
	0xA28C,
	0xA28A,
	0xA288,
	0xA289,
	0xA287,
	0xA015,
	0xA285,
	0xA286,
	0xA284,
	0xA45F,
	0xA463,
	0xA464,
	0xA461,
	0xA462,
	0xA460,
	0xA45D,
	0xA45E,
	0xA469,
	0xA46A,
	0xA467,
	0xA468,
	0xA466,
	0xA465,
	0xA46D,
	0xA46E,
	0xA470,
	0xA46F,
	0xA46B,
	0xA46C,
	0xA473,
	0xA477,
	0xA478,
	0xA475,
	0xA476,
	0xA474,
	0xA471,
	0xA472,
	0xA47F,
	0xA480,
	0xA47D,
	0xA47E,
	0xA483,
	0xA47B,
	0xA47C,
	0xA479,
	0xA47A,
	0xA484,
	0xA486,
	0xA485,
	0xA481,
	0xA482,
	0xA489,
	0xA48A,
	0xA48C,
	0xA48B,
	0xA487,
	0xA488,
	0xA296,
	0xA297,
	0xA294,
	0xA295,
	0xA2A0,
	0xA2A1,
	0xA29F,
	0xA348,
	0xA349,
	0xA346,
	0xA347,
	0xA353,
	0xA354,
	0xA351,
	0xA352,
	0xA34F,
	0xA350,
	0xA34D,
	0xA34E,
	0xA357,
	0xA34B,
	0xA34C,
	0xA34A,
	0xA358,
	0xA35A,
	0xA359,
	0xA355,
	0xA356,
	0xA35D,
	0xA35E,
	0xA360,
	0xA35F,
	0xA35B,
	0xA35C,
	0xA28F,
	0xA292,
	0xA293,
	0xA291,
	0xA290,
	0xA28D,
	0xA28E,
	0xA29D,
	0xA29E,
	0xA29B,
	0xA29C,
	0xA2A4,
	0xA299,
	0xA29A,
	0xA298,
	0xA2A5,
	0xA2A7,
	0xA2A6,
	0xA2A2,
	0xA2A3,
	0xA2AA,
	0xA2AB,
	0xA2AD,
	0xA2AC,
	0xA2A8,
	0xA2A9,
	0xA2DA,
	0xA2DB,
	0xA2D8,
	0xA2D9,
	0xA2E0,
	0xA2E1,
	0xA2DF,
	0xA2D2,
	0xA2D6,
	0xA2D7,
	0xA2D4,
	0xA2D5,
	0xA2D3,
	0xA2D0,
	0xA2D1,
	0xA2DD,
	0xA2DE,
	0xA2DC,
	0xA2E3,
	0xA2E4,
	0xA2E6,
	0xA2E5,
	0xA2E2,
	0xA2E9,
	0xA2EA,
	0xA2EC,
	0xA2EB,
	0xA2E7,
	0xA2E8,
	0x262F,
	0x22FF,
	0x2A64,
	0x2989,
	0x2987,
	0x2A65,
	0x2A3E,
	0x298A,
	0x2988,
	0x2A1F,
	0x2A20,
	0x2A21,
	0x2981,
	0x2982,
	0x200D,
	0xFEFF,
	0x200C,
	0x200B
};

#define NUM_UNICODE 21747

/**
 * Performs a binary search on an array of strings.
 *
 * \param [in] strings The array of string to search.
 * \param [in] start The index to start searching at.
 * \param [in] end The index to end searching at.
 * \param [in] find The string to search for.
 *
 * \return The index of the matching string, if found.
 *
 * \retval -1 The string was not found in the array.
 */
int binarySearch(const char **strings,
                 int start,
                 int end,
                 const char *find)
{
	int midpoint;
	int cmp;
	if (end < start) return -1;
	midpoint = ((end - start) / 2) + start;
	cmp = strcmp(strings[midpoint], find);
	if (cmp == 0)
		return midpoint;
	else if (cmp > 0)
		return binarySearch(strings, start, midpoint - 1, find);
	else if (cmp < 0)
		return binarySearch(strings, midpoint + 1, end, find);
	return -1;
}

/**
 * Converts a Unicode normative name to a Unicode code point.
 *
 * \param [in] name The Unicode normative name to convert.
 *
 * \return The Unicode code point corresponding to \a name.
 *
 * \retval -1 An invalid Unicode normative name was supplied.
 */
long convertNormativeNameToCodePoint(const char *name)
{
	int index = binarySearch(names, 0, NUM_UNICODE - 1, name);
	if (index < 0) {
		fprintf(stderr, "Invalid Unicode normative name.\n");
		return -1;
	}
	else
		return codepoints[index];
}

/**
 * Converts a Unicode code point to a UTF-8 character.
 *
 * \param [in] codepoint The Unicode code point to convert to UTF-8.
 * \param [out] out A pointer to the location to store the UTF-8 character.
 *
 * \return The length of the converted multi-byte UTF-8 character.
 *
 * \retval 0 An invalid Unicode code point was supplied.
 */
size_t convertCodePointToUTF8(unsigned long codepoint,
                              char *out)
{
	/* Out of range */
	if (codepoint > 0x10FFFF) {
		fprintf(stderr, "Invalid Unicode code point.\n");
		return 0;
	}
	/* U+010000 to U+10FFFF  */
	else if (codepoint >= 0x010000) {
		char x1 = (char)(codepoint & 0x003F);
		char x2 = (char)((codepoint & 0x00C0) >> 6);
		char y1 = (char)((codepoint & 0x0F00) >> 8);
		char y2 = (char)((codepoint & 0xF000) >> 12);
		char z1 = (char)((codepoint & 0x30000) >> 16);
		char z2 = (char)((codepoint & 0x1C0000) >> 18);
		out[0] = (char)(0xF0 | z2);
		out[1] = (char)(0x80 | (z1 << 4) | y2);
		out[2] = (char)(0x80 | (y1 << 2) | x2);
		out[3] = (char)(0x80 | x1);
		return 4;
	}
	/* U+0800 to U+FFFF  */
	else if (codepoint >= 0x0800) {
		char x1 = (char)(codepoint & 0x003F);
		char x2 = (char)((codepoint & 0x00C0) >> 6);
		char y1 = (char)((codepoint & 0x0F00) >> 8);
		char y2 = (char)((codepoint & 0xF000) >> 12);
		out[0] = (char)(0xE0 | y2);
		out[1] = (char)(0x80 | (y1 << 2) | x2);
		out[2] = (char)(0x80 | x1);
		return 3;
	}
	/* U+0080 to U+07FF  */
	else if (codepoint & 0x0080) {
		char x1 = (char)(codepoint & 0x3F);
		char x2 = (char)((codepoint & 0x00C0) >> 6);
		char y = (char)((codepoint & 0x0700) >> 8);
		out[0] = (char)(0xC0 | (y << 2) | x2);
		out[1] =  (char)(0x80 | x1);
		return 2;
	}
	/* U+0080 to U+07FF  */
	else {
		out[0] = (char)codepoint;
		return 1;
	}
}
